/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/platform/log/common/log","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/node/pfs","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/base/common/map","fs","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/extensions/common/extensions","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/json","path","net","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/amd","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","vs/base/node/id","vs/editor/common/core/position","vs/base/common/htmlContent","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostTestItem","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","yauzl","yazl","http","vs/server/node/server.main"],we=function(le){for(var e=[],D=0,O=le.length;D<O;D++)e[D]=be[le[D]];return e};define(be[93],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class D{static get(){const r=new Map,P=new Map,A=new Map,I=new Map;function w(d,g){d.has(g.detail)||d.set(g.detail,-g.timestamp)}function $(d,g){const m=d.get(g.detail);m&&(m>=0||d.set(g.detail,m+g.timestamp))}let C=[];typeof le=="function"&&typeof le.getStats=="function"&&(C=le.getStats().slice(0).sort((d,g)=>d.timestamp-g.timestamp));for(const d of C)switch(d.type){case 10:w(r,d);break;case 11:case 12:$(r,d);break;case 21:w(P,d);break;case 22:$(P,d);break;case 33:w(A,d);break;case 34:$(A,d);break;case 31:w(I,d);break;case 32:$(I,d);break}let S=0;A.forEach(d=>S+=d);function v(d){const g=[];return d.forEach((m,l)=>g.push([l,m])),g}return{amdLoad:v(r),amdInvoke:v(P),nodeRequire:v(A),nodeEval:v(I),nodeRequireTotal:S}}static toMarkdownTable(r,P){let A="";const I=[];return r.forEach((w,$)=>{I[$]=w.length}),P.forEach(w=>{w.forEach(($,C)=>{typeof $>"u"&&($=w[C]="-");const S=$.toString().length;I[C]=Math.max(S,I[C])})}),r.forEach((w,$)=>{A+=`| ${w+" ".repeat(I[$]-w.toString().length)} `}),A+=`|
`,r.forEach((w,$)=>{A+=`| ${"-".repeat(I[$])} `}),A+=`|
`,P.forEach(w=>{w.forEach(($,C)=>{typeof $<"u"&&(A+=`| ${$+" ".repeat(I[C]-$.toString().length)} `)}),A+=`|
`}),A}}e.$S=D}),define(be[141],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function D(m,l,f){const u=O(m,l);if(u!==-1)return m[u]}e.$db=D;function O(m,l,f=m.length-1){for(let u=f;u>=0;u--){const c=m[u];if(l(c))return u}return-1}e.$eb=O;function r(m,l){const f=P(m,l);return f===-1?void 0:m[f]}e.$fb=r;function P(m,l,f=0,u=m.length){let c=f,y=u;for(;c<y;){const h=Math.floor((c+y)/2);l(m[h])?c=h+1:y=h}return c-1}e.$gb=P;function A(m,l){const f=I(m,l);return f===m.length?void 0:m[f]}e.$hb=A;function I(m,l,f=0,u=m.length){let c=f,y=u;for(;c<y;){const h=Math.floor((c+y)/2);l(m[h])?y=h:c=h+1}return c}e.$ib=I;function w(m,l,f=0,u=m.length){const c=I(m,l,f,u);return c===m.length?-1:c}e.$jb=w;class ${static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if($.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!l(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const f=P(this.e,l,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$kb=$;function C(m,l){if(m.length===0)return;let f=m[0];for(let u=1;u<m.length;u++){const c=m[u];l(c,f)>0&&(f=c)}return f}e.$lb=C;function S(m,l){if(m.length===0)return;let f=m[0];for(let u=1;u<m.length;u++){const c=m[u];l(c,f)>=0&&(f=c)}return f}e.$mb=S;function v(m,l){return C(m,(f,u)=>-l(f,u))}e.$nb=v;function d(m,l){if(m.length===0)return-1;let f=0;for(let u=1;u<m.length;u++){const c=m[u];l(c,m[f])>0&&(f=u)}return f}e.$ob=d;function g(m,l){for(const f of m){const u=l(f);if(u!==void 0)return u}}e.$pb=g}),define(be[142],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function D(A,I){const w=Object.create(null);for(const $ of A){const C=I($);let S=w[C];S||(S=w[C]=[]),S.push($)}return w}e.$I=D;function O(A,I){const w=[],$=[];for(const C of A)I.has(C)||w.push(C);for(const C of I)A.has(C)||$.push(C);return{removed:w,added:$}}e.$J=O;function r(A,I){const w=[],$=[];for(const[C,S]of A)I.has(C)||w.push(S);for(const[C,S]of I)A.has(C)||$.push(S);return{removed:w,added:$}}e.$K=r;function P(A,I){const w=new Set;for(const $ of I)A.has($)&&w.add($);return w}e.$L=P}),define(be[73],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fh=e.$eh=e.$dh=void 0;function D(A){return(I,w,$)=>{let C=null,S=null;if(typeof $.value=="function"?(C="value",S=$.value):typeof $.get=="function"&&(C="get",S=$.get),!S)throw new Error("not supported");$[C]=A(S,w)}}function O(A,I,w){let $=null,C=null;if(typeof w.value=="function"?($="value",C=w.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&($="get",C=w.get),!C)throw new Error("not supported");const S=`$memoize$${I}`;w[$]=function(...v){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,v)}),this[S]}}e.$dh=O;function r(A,I,w){return D(($,C)=>{const S=`$debounce$${C}`,v=`$debounce$result$${C}`;return function(...d){this[v]||(this[v]=w?w():void 0),clearTimeout(this[S]),I&&(this[v]=I(this[v],...d),d=[this[v]]),this[S]=setTimeout(()=>{$.apply(this,d),this[v]=w?w():void 0},A)}})}e.$eh=r;function P(A,I,w){return D(($,C)=>{const S=`$throttle$timer$${C}`,v=`$throttle$result$${C}`,d=`$throttle$lastRun$${C}`,g=`$throttle$pending$${C}`;return function(...m){if(this[v]||(this[v]=w?w():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[v]=I(this[v],...m)),this[g])return;const l=this[d]+A;l<=Date.now()?(this[d]=Date.now(),$.apply(this,[this[v]]),this[v]=w?w():void 0):(this[g]=!0,this[S]=setTimeout(()=>{this[g]=!1,this[d]=Date.now(),$.apply(this,[this[v]]),this[v]=w?w():void 0},l-Date.now()))}})}e.$fh=P}),define(be[11],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?c.isErrorNoTelemetry(t)?new c(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=D,e.$V=new D;function O(h){e.$V.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=O;function r(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=r;function P(h){$(h)||e.$V.onUnexpectedError(h)}e.$Y=P;function A(h){$(h)||e.$V.onUnexpectedExternalError(h)}e.$Z=A;function I(h){if(h instanceof Error){const{name:t,message:s}=h,o=h.stacktrace||h.stack;return{$isError:!0,name:t,message:s,stack:o,noTelemetry:c.isErrorNoTelemetry(h)}}return h}e.$1=I;const w="Canceled";function $(h){return h instanceof C?!0:h instanceof Error&&h.name===w&&h.message===w}e.$2=$;class C extends Error{constructor(){super(w),this.name=this.message}}e.$3=C;function S(){const h=new Error(w);return h.name=h.message,h}e.$4=S;function v(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.$5=v;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.$6=d;class g extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=g;function m(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.$8=m;class l extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=l;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=f;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=u;class c extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof c)return t;const s=new c;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=c;class y extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,y.prototype)}}e.$ab=y}),define(be[18],we([1,0,11,141]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function r(T,q=0){return T[T.length-(1+q)]}e.$qb=r;function P(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$rb=P;function A(T,q,z=(ie,B)=>ie===B){if(T===q)return!0;if(!T||!q||T.length!==q.length)return!1;for(let ie=0,B=T.length;ie<B;ie++)if(!z(T[ie],q[ie]))return!1;return!0}e.$sb=A;function I(T,q){const z=T.length-1;q<z&&(T[q]=T[z]),T.pop()}e.$tb=I;function w(T,q,z){return $(T.length,ie=>z(T[ie],q))}e.$ub=w;function $(T,q){let z=0,ie=T-1;for(;z<=ie;){const B=(z+ie)/2|0,X=q(B);if(X<0)z=B+1;else if(X>0)ie=B-1;else return B}return-(z+1)}e.$vb=$;function C(T,q,z){if(T=T|0,T>=q.length)throw new TypeError("invalid index");const ie=q[Math.floor(q.length*Math.random())],B=[],X=[],H=[];for(const Q of q){const re=z(Q,ie);re<0?B.push(Q):re>0?X.push(Q):H.push(Q)}return T<B.length?C(T,B,z):T<B.length+H.length?H[0]:C(T-(B.length+H.length),X,z)}e.$wb=C;function S(T,q){const z=[];let ie;for(const B of T.slice(0).sort(q))!ie||q(ie[0],B)!==0?(ie=[B],z.push(ie)):ie.push(B);return z}e.$xb=S;function*v(T,q){let z,ie;for(const B of T)ie!==void 0&&q(ie,B)?z.push(B):(z&&(yield z),z=[B]),ie=B;z&&(yield z)}e.$yb=v;function d(T,q){for(let z=0;z<=T.length;z++)q(z===0?void 0:T[z-1],z===T.length?void 0:T[z])}e.$zb=d;function g(T,q){for(let z=0;z<T.length;z++)q(z===0?void 0:T[z-1],T[z],z+1===T.length?void 0:T[z+1])}e.$Ab=g;function m(T,q,z){const ie=[];function B(Q,re,de){if(re===0&&de.length===0)return;const Ee=ie[ie.length-1];Ee&&Ee.start+Ee.deleteCount===Q?(Ee.deleteCount+=re,Ee.toInsert.push(...de)):ie.push({start:Q,deleteCount:re,toInsert:de})}let X=0,H=0;for(;;){if(X===T.length){B(X,0,q.slice(H));break}if(H===q.length){B(X,T.length-X,[]);break}const Q=T[X],re=q[H],de=z(Q,re);de===0?(X+=1,H+=1):de<0?(B(X,1,[]),X+=1):de>0&&(B(X,0,[re]),H+=1)}return ie}e.$Bb=m;function l(T,q,z){const ie=m(T,q,z),B=[],X=[];for(const H of ie)B.push(...T.slice(H.start,H.start+H.deleteCount)),X.push(...H.toInsert);return{removed:B,added:X}}e.$Cb=l;function f(T,q,z){if(z===0)return[];const ie=T.slice(0,z).sort(q);return c(T,q,ie,z,T.length),ie}e.top=f;function u(T,q,z,ie,B){return z===0?Promise.resolve([]):new Promise((X,H)=>{(async()=>{const Q=T.length,re=T.slice(0,z).sort(q);for(let de=z,Ee=Math.min(z+ie,Q);de<Q;de=Ee,Ee=Math.min(Ee+ie,Q)){if(de>z&&await new Promise(Ce=>setTimeout(Ce)),B&&B.isCancellationRequested)throw new D.$3;c(T,q,re,de,Ee)}return re})().then(X,H)})}e.$Eb=u;function c(T,q,z,ie,B){for(const X=z.length;ie<B;ie++){const H=T[ie];if(q(H,z[X-1])<0){z.pop();const Q=(0,O.$ib)(z,re=>q(H,re)<0);z.splice(Q,0,H)}}}function y(T){return T.filter(q=>!!q)}e.$Fb=y;function h(T){let q=0;for(let z=0;z<T.length;z++)T[z]&&(T[q]=T[z],q+=1);T.length=q}e.$Gb=h;function t(T,q,z){T.splice(z,0,T.splice(q,1)[0])}e.$Hb=t;function s(T){return!Array.isArray(T)||T.length===0}e.$Ib=s;function o(T){return Array.isArray(T)&&T.length>0}e.$Jb=o;function i(T,q=z=>z){const z=new Set;return T.filter(ie=>{const B=q(ie);return z.has(B)?!1:(z.add(B),!0)})}e.$Kb=i;function n(T){const q=new Set;return z=>{const ie=T(z);return q.has(ie)?!1:(q.add(ie),!0)}}e.$Lb=n;function a(T,q){return T.length>0?T[0]:q}e.$Mb=a;function b(T,q){return T.length>0?T[T.length-1]:q}e.$Nb=b;function p(T,q,z=(ie,B)=>ie===B){let ie=0;for(let B=0,X=Math.min(T.length,q.length);B<X&&z(T[B],q[B]);B++)ie++;return ie}e.$Ob=p;function E(T){return[].concat(...T)}e.$Pb=E;function k(T,q){let z=typeof q=="number"?T:0;typeof q=="number"?z=T:(z=0,q=T);const ie=[];if(z<=q)for(let B=z;B<q;B++)ie.push(B);else for(let B=z;B>q;B--)ie.push(B);return ie}e.$Qb=k;function L(T,q,z){return T.reduce((ie,B)=>(ie[q(B)]=z?z(B):B,ie),Object.create(null))}e.$Rb=L;function j(T,q){return T.push(q),()=>Y(T,q)}e.$Sb=j;function Y(T,q){const z=T.indexOf(q);if(z>-1)return T.splice(z,1),q}e.$Tb=Y;function ce(T,q,z){const ie=T.slice(0,q),B=T.slice(q);return ie.concat(z,B)}e.$Ub=ce;function x(T,q){let z;if(typeof q=="number"){let ie=q;z=()=>{const B=Math.sin(ie++)*179426549;return B-Math.floor(B)}}else z=Math.random;for(let ie=T.length-1;ie>0;ie-=1){const B=Math.floor(z()*(ie+1)),X=T[ie];T[ie]=T[B],T[B]=X}}e.$Vb=x;function ne(T,q){const z=T.indexOf(q);z>-1&&(T.splice(z,1),T.unshift(q))}e.$Wb=ne;function ue(T,q){const z=T.indexOf(q);z>-1&&(T.splice(z,1),T.push(q))}e.$Xb=ue;function _(T,q){for(const z of q)T.push(z)}e.$Yb=_;function he(T,q){return Array.isArray(T)?T.map(q):q(T)}e.$Zb=he;function ee(T){return Array.isArray(T)?T:[T]}e.$1b=ee;function te(T){return T[Math.floor(Math.random()*T.length)]}e.$2b=te;function W(T,q,z){const ie=V(T,q),B=T.length,X=z.length;T.length=B+X;for(let H=B-1;H>=ie;H--)T[H+X]=T[H];for(let H=0;H<X;H++)T[H+ie]=z[H]}e.$3b=W;function K(T,q,z,ie){const B=V(T,q);let X=T.splice(B,z);return X===void 0&&(X=[]),W(T,B,ie),X}e.$4b=K;function V(T,q){return q<0?Math.max(q+T.length,0):Math.min(q,T.length)}var oe;(function(T){function q(X){return X<0}T.isLessThan=q;function z(X){return X<=0}T.isLessThanOrEqual=z;function ie(X){return X>0}T.isGreaterThan=ie;function B(X){return X===0}T.isNeitherLessOrGreaterThan=B,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function me(T,q){return(z,ie)=>q(T(z),T(ie))}e.$5b=me;function se(...T){return(q,z)=>{for(const ie of T){const B=ie(q,z);if(!oe.isNeitherLessOrGreaterThan(B))return B}return oe.neitherLessOrGreaterThan}}e.$6b=se;const U=(T,q)=>T-q;e.$7b=U;const Z=(T,q)=>(0,e.$7b)(T?1:0,q?1:0);e.$8b=Z;function R(T){return(q,z)=>-T(q,z)}e.$9b=R;class F{constructor(q){this.g=q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(q){let z=this.c;for(;z<this.g.length&&q(this.g[z]);)z++;const ie=z===this.c?null:this.g.slice(this.c,z);return this.c=z,ie}takeFromEndWhile(q){let z=this.d;for(;z>=0&&q(this.g[z]);)z--;const ie=z===this.d?null:this.g.slice(z+1,this.d+1);return this.d=z,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const q=this.g[this.c];return this.c++,q}removeLast(){const q=this.g[this.d];return this.d--,q}takeCount(q){const z=this.g.slice(this.c,this.c+q);return this.c+=q,z}}e.$0b=F;class G{static{this.empty=new G(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(z=>(q(z),!0))}toArray(){const q=[];return this.iterate(z=>(q.push(z),!0)),q}filter(q){return new G(z=>this.iterate(ie=>q(ie)?z(ie):!0))}map(q){return new G(z=>this.iterate(ie=>z(q(ie))))}some(q){let z=!1;return this.iterate(ie=>(z=q(ie),!z)),z}findFirst(q){let z;return this.iterate(ie=>q(ie)?(z=ie,!1):!0),z}findLast(q){let z;return this.iterate(ie=>(q(ie)&&(z=ie),!0)),z}findLastMaxBy(q){let z,ie=!0;return this.iterate(B=>((ie||oe.isGreaterThan(q(B,z)))&&(ie=!1,z=B),!0)),z}}e.$$b=G}),define(be[94],we([1,0,11]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$4c=e.$3c=e.$2c=e.ok=void 0;function O(w,$){if(!w)throw new Error($?`Assertion failed (${$})`:"Assertion Failed")}e.ok=O;function r(w,$="Unreachable"){throw new Error($)}e.$2c=r;function P(w){if(!w)throw new D.$ab("Assertion Failed")}e.$3c=P;function A(w){if(!w()){debugger;w(),(0,D.$Y)(new D.$ab("Assertion Failed"))}}e.$4c=A;function I(w,$){let C=0;for(;C<w.length-1;){const S=w[C],v=w[C+1];if(!$(S,v))return!1;C++}return!0}e.$5c=I}),define(be[74],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function D(O){const r=this;let P=!1,A;return function(){return P||(P=!0,A=O.apply(r,arguments)),A}}e.$bb=D}),define(be[47],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(O){function r(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}O.is=r;const P=Object.freeze([]);function A(){return P}O.empty=A;function*I(h){yield h}O.single=I;function w(h){return r(h)?h:I(h)}O.wrap=w;function $(h){return h||P}O.from=$;function*C(h){for(let t=h.length-1;t>=0;t--)yield h[t]}O.reverse=C;function S(h){return!h||h[Symbol.iterator]().next().done===!0}O.isEmpty=S;function v(h){return h[Symbol.iterator]().next().value}O.first=v;function d(h,t){for(const s of h)if(t(s))return!0;return!1}O.some=d;function g(h,t){for(const s of h)if(t(s))return s}O.find=g;function*m(h,t){for(const s of h)t(s)&&(yield s)}O.filter=m;function*l(h,t){let s=0;for(const o of h)yield t(o,s++)}O.map=l;function*f(...h){for(const t of h)for(const s of t)yield s}O.concat=f;function u(h,t,s){let o=s;for(const i of h)o=t(o,i);return o}O.reduce=u;function*c(h,t,s=h.length){for(t<0&&(t+=h.length),s<0?s+=h.length:s>h.length&&(s=h.length);t<s;t++)yield h[t]}O.slice=c;function y(h,t=Number.POSITIVE_INFINITY){const s=[];if(t===0)return[s,h];const o=h[Symbol.iterator]();for(let i=0;i<t;i++){const n=o.next();if(n.done)return[s,O.empty()];s.push(n.value)}return[s,{[Symbol.iterator](){return o}}]}O.consume=y})(D||(e.Iterable=D={}))}),define(be[75],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function A(t,s=!1){let o=0;const i=t.length;let n="",a=0,b=16,p=0;function E(ne){let ue=0,_=0;for(;ue<ne;){const he=t.charCodeAt(o);if(he>=48&&he<=57)_=_*16+he-48;else if(he>=65&&he<=70)_=_*16+he-65+10;else if(he>=97&&he<=102)_=_*16+he-97+10;else break;o++,ue++}return ue<ne&&(_=-1),_}function k(ne){o=ne,n="",a=0,b=16,p=0}function L(){const ne=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&$(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&$(t.charCodeAt(o)))for(o++;o<t.length&&$(t.charCodeAt(o));)o++;else return p=3,t.substring(ne,o);let ue=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&$(t.charCodeAt(o))){for(o++;o<t.length&&$(t.charCodeAt(o));)o++;ue=o}else p=3;return t.substring(ne,ue)}function j(){let ne="",ue=o;for(;;){if(o>=i){ne+=t.substring(ue,o),p=2;break}const _=t.charCodeAt(o);if(_===34){ne+=t.substring(ue,o),o++;break}if(_===92){if(ne+=t.substring(ue,o),o++,o>=i){p=2;break}switch(t.charCodeAt(o++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const ee=E(4);ee>=0?ne+=String.fromCharCode(ee):p=4;break}default:p=5}ue=o;continue}if(_>=0&&_<=31)if(w(_)){ne+=t.substring(ue,o),p=2;break}else p=6;o++}return ne}function Y(){if(n="",p=0,a=o,o>=i)return a=i,b=17;let ne=t.charCodeAt(o);if(I(ne)){do o++,n+=String.fromCharCode(ne),ne=t.charCodeAt(o);while(I(ne));return b=15}if(w(ne))return o++,n+=String.fromCharCode(ne),ne===13&&t.charCodeAt(o)===10&&(o++,n+=`
`),b=14;switch(ne){case 123:return o++,b=1;case 125:return o++,b=2;case 91:return o++,b=3;case 93:return o++,b=4;case 58:return o++,b=6;case 44:return o++,b=5;case 34:return o++,n=j(),b=10;case 47:{const ue=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!w(t.charCodeAt(o));)o++;return n=t.substring(ue,o),b=12}if(t.charCodeAt(o+1)===42){o+=2;const _=i-1;let he=!1;for(;o<_;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,he=!0;break}o++}return he||(o++,p=1),n=t.substring(ue,o),b=13}return n+=String.fromCharCode(ne),o++,b=16}case 45:if(n+=String.fromCharCode(ne),o++,o===i||!$(t.charCodeAt(o)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=L(),b=11;default:for(;o<i&&ce(ne);)o++,ne=t.charCodeAt(o);if(a!==o){switch(n=t.substring(a,o),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(ne),o++,b=16}}function ce(ne){if(I(ne)||w(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function x(){let ne;do ne=Y();while(ne>=12&&ne<=15);return ne}return{setPosition:k,getPosition:()=>o,scan:s?x:Y,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>p}}e.$Km=A;function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function $(t){return t>=48&&t<=57}var C;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(C||(C={}));function S(t,s){const o=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function p(E,k,L,j){a.value=E,a.offset=k,a.length=L,a.type=j,a.colonOffset=void 0,n=a}try{c(t,{onObjectBegin:(E,k)=>{if(s<=E)throw i;n=void 0,b=s>E,o.push("")},onObjectProperty:(E,k,L)=>{if(s<k||(p(E,k,L,"property"),o[o.length-1]=E,s<=k+L))throw i},onObjectEnd:(E,k)=>{if(s<=E)throw i;n=void 0,o.pop()},onArrayBegin:(E,k)=>{if(s<=E)throw i;n=void 0,o.push(0)},onArrayEnd:(E,k)=>{if(s<=E)throw i;n=void 0,o.pop()},onLiteralValue:(E,k,L)=>{if(s<k||(p(E,k,L,h(E)),s<=k+L))throw i},onSeparator:(E,k,L)=>{if(s<=k)throw i;if(E===":"&&n&&n.type==="property")n.colonOffset=k,b=!1,n=void 0;else if(E===","){const j=o[o.length-1];typeof j=="number"?o[o.length-1]=j+1:(b=!0,o[o.length-1]=""),n=void 0}}})}catch(E){if(E!==i)throw E}return{path:o,previousNode:n,isAtPropertyKey:b,matches:E=>{let k=0;for(let L=0;k<E.length&&L<o.length;L++)if(E[k]===o[L]||E[k]==="*")k++;else if(E[k]!=="**")return!1;return k===E.length}}}e.$Lm=S;function v(t,s=[],o=P.DEFAULT){let i=null,n=[];const a=[];function b(E){Array.isArray(n)?n.push(E):i!==null&&(n[i]=E)}return c(t,{onObjectBegin:()=>{const E={};b(E),a.push(n),n=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const E=[];b(E),a.push(n),n=E,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:b,onError:(E,k,L)=>{s.push({error:E,offset:k,length:L})}},o),n[0]}e.$Mm=v;function d(t,s=[],o=P.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(E){i.type==="property"&&(i.length=E-i.offset,i=i.parent)}function a(E){return i.children.push(E),E}c(t,{onObjectBegin:E=>{i=a({type:"object",offset:E,length:-1,parent:i,children:[]})},onObjectProperty:(E,k,L)=>{i=a({type:"property",offset:k,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:E,offset:k,length:L,parent:i})},onObjectEnd:(E,k)=>{i.length=E+k-i.offset,i=i.parent,n(E+k)},onArrayBegin:(E,k)=>{i=a({type:"array",offset:E,length:-1,parent:i,children:[]})},onArrayEnd:(E,k)=>{i.length=E+k-i.offset,i=i.parent,n(E+k)},onLiteralValue:(E,k,L)=>{a({type:h(E),offset:k,length:L,parent:i,value:E}),n(k+L)},onSeparator:(E,k,L)=>{i.type==="property"&&(E===":"?i.colonOffset=k:E===","&&n(k))},onError:(E,k,L)=>{s.push({error:E,offset:k,length:L})}},o);const p=i.children[0];return p&&delete p.parent,p}e.$Nm=d;function g(t,s){if(!t)return;let o=t;for(const i of s)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===i){o=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Om=g;function m(t){if(!t.parent||!t.parent.children)return[];const s=m(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;s.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&s.push(o)}return s}e.$Pm=m;function l(t){switch(t.type){case"array":return t.children.map(l);case"object":{const s=Object.create(null);for(const o of t.children){const i=o.children[1];i&&(s[o.children[0].value]=l(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Qm=l;function f(t,s,o=!1){return s>=t.offset&&s<t.offset+t.length||o&&s===t.offset+t.length}e.$Rm=f;function u(t,s,o=!1){if(f(t,s,o)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const a=u(i[n],s,o);if(a)return a}return t}}e.$Sm=u;function c(t,s,o=P.DEFAULT){const i=A(t,!1);function n(me){return me?()=>me(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(me){return me?se=>me(se,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=n(s.onObjectBegin),p=a(s.onObjectProperty),E=n(s.onObjectEnd),k=n(s.onArrayBegin),L=n(s.onArrayEnd),j=a(s.onLiteralValue),Y=a(s.onSeparator),ce=n(s.onComment),x=a(s.onError),ne=o&&o.disallowComments,ue=o&&o.allowTrailingComma;function _(){for(;;){const me=i.scan();switch(i.getTokenError()){case 4:he(14);break;case 5:he(15);break;case 3:he(13);break;case 1:ne||he(11);break;case 2:he(12);break;case 6:he(16);break}switch(me){case 12:case 13:ne?he(10):ce();break;case 16:he(1);break;case 15:case 14:break;default:return me}}}function he(me,se=[],U=[]){if(x(me),se.length+U.length>0){let Z=i.getToken();for(;Z!==17;){if(se.indexOf(Z)!==-1){_();break}else if(U.indexOf(Z)!==-1)break;Z=_()}}}function ee(me){const se=i.getTokenValue();return me?j(se):p(se),_(),!0}function te(){switch(i.getToken()){case 11:{let me=0;try{me=JSON.parse(i.getTokenValue()),typeof me!="number"&&(he(2),me=0)}catch{he(2)}j(me);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return _(),!0}function W(){return i.getToken()!==10?(he(3,[],[2,5]),!1):(ee(!1),i.getToken()===6?(Y(":"),_(),oe()||he(4,[],[2,5])):he(5,[],[2,5]),!0)}function K(){b(),_();let me=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(me||he(4,[],[]),Y(","),_(),i.getToken()===2&&ue)break}else me&&he(6,[],[]);W()||he(4,[],[2,5]),me=!0}return E(),i.getToken()!==2?he(7,[2],[]):_(),!0}function V(){k(),_();let me=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(me||he(4,[],[]),Y(","),_(),i.getToken()===4&&ue)break}else me&&he(6,[],[]);oe()||he(4,[],[4,5]),me=!0}return L(),i.getToken()!==4?he(8,[4],[]):_(),!0}function oe(){switch(i.getToken()){case 3:return V();case 1:return K();case 10:return ee(!0);default:return te()}}return _(),i.getToken()===17?o.allowEmptyContent?!0:(he(4,[],[]),!1):oe()?(i.getToken()!==17&&he(9,[],[]),!0):(he(4,[],[]),!1)}e.$Tm=c;function y(t,s){const o=A(t),i=[];let n,a=0,b;do switch(b=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:a!==b&&i.push(t.substring(a,b)),s!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,s)),a=o.getPosition();break}while(n!==17);return i.join("")}e.$Um=y;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Vm=h}),define(be[95],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class D{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=D}),define(be[96],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zc=void 0;class D{static{this.Undefined=new D(void 0)}constructor(P){this.element=P,this.next=D.Undefined,this.prev=D.Undefined}}class O{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let P=this.a;for(;P!==D.Undefined;){const A=P.next;P.prev=D.Undefined,P.next=D.Undefined,P=A}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,A){const I=new D(P);if(this.a===D.Undefined)this.a=I,this.b=I;else if(A){const $=this.b;this.b=I,I.prev=$,$.next=I}else{const $=this.a;this.a=I,I.next=$,$.prev=I}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(I))}}shift(){if(this.a!==D.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==D.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==D.Undefined&&P.next!==D.Undefined){const A=P.prev;A.next=P.next,P.next.prev=A}else P.prev===D.Undefined&&P.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):P.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):P.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==D.Undefined;)yield P.element,P=P.next}}e.$Zc=O}),define(be[26],we([1,0]),function(le,e){"use strict";var D,O,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.Touch=e.$zc=e.$yc=e.$xc=e.$wc=e.$vc=void 0;function P(u,c,y){let h=u.get(c);return h===void 0&&(h=y,u.set(c,h)),h}e.$vc=P;function A(u){const c=[];return u.forEach((y,h)=>{c.push(`${h} => ${y}`)}),`Map(${u.size}) {${c.join(", ")}}`}e.$wc=A;function I(u){const c=[];return u.forEach(y=>{c.push(y)}),`Set(${u.size}) {${c.join(", ")}}`}e.$xc=I;class w{constructor(c,y){this.uri=c,this.value=y}}function $(u){return Array.isArray(u)}class C{static{this.a=c=>c.toString()}constructor(c,y){if(this[D]="ResourceMap",c instanceof C)this.b=new Map(c.b),this.c=y??C.a;else if($(c)){this.b=new Map,this.c=y??C.a;for(const[h,t]of c)this.set(h,t)}else this.b=new Map,this.c=c??C.a}set(c,y){return this.b.set(this.c(c),new w(c,y)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,y){typeof y<"u"&&(c=c.bind(y));for(const[h,t]of this.b)c(t.value,t.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$yc=C;class S{constructor(c,y){this[O]="ResourceSet",!c||typeof c=="function"?this.a=new C(c):(this.a=new C(y),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,y){this.a.forEach((h,t)=>c.call(y,t,t,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$zc=S;var v;(function(u){u[u.None=0]="None",u[u.AsOld=1]="AsOld",u[u.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class d{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,y=0){const h=this.a.get(c);if(h)return y!==0&&this.j(h,y),h.value}set(c,y,h=0){let t=this.a.get(c);if(t)t.value=y,h!==0&&this.j(t,h);else{switch(t={key:c,value:y,next:void 0,previous:void 0},h){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(c,t),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const y=this.a.get(c);if(y)return this.a.delete(c),this.i(y),this.d--,y.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,y){const h=this.e;let t=this.b;for(;t;){if(y?c.bind(y)(t.value,t.key,this):c(t.value,t.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const c=this,y=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==y)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:h.key,done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}values(){const c=this,y=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==y)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:h.value,done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}entries(){const c=this,y=this.e;let h=this.b;const t={[Symbol.iterator](){return t},next(){if(c.e!==y)throw new Error("LinkedMap got modified during iteration.");if(h){const s={value:[h.key,h.value],done:!1};return h=h.next,s}else return{value:void 0,done:!0}}};return t}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let y=this.b,h=this.size;for(;y&&h>c;)this.a.delete(y.key),y=y.next,h--;this.b=y,this.d=h,y&&(y.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const y=c.next,h=c.previous;if(!y||!h)throw new Error("Invalid list");y.previous=h,h.next=y}c.next=void 0,c.previous=void 0,this.e++}j(c,y){if(!this.b||!this.c)throw new Error("Invalid list");if(!(y!==1&&y!==2)){if(y===1){if(c===this.b)return;const h=c.next,t=c.previous;c===this.c?(t.next=void 0,this.c=t):(h.previous=t,t.next=h),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(y===2){if(c===this.c)return;const h=c.next,t=c.previous;c===this.b?(h.previous=void 0,this.b=h):(h.previous=t,t.next=h),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((y,h)=>{c.push([h,y])}),c}fromJSON(c){this.clear();for(const[y,h]of c)this.set(y,h)}}e.$Ac=d;class g extends d{constructor(c,y=1){super(),this.k=c,this.l=Math.min(Math.max(0,y),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,y=2){return super.get(c,y)}peek(c){return super.get(c,0)}set(c,y){return super.set(c,y,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Bc=g;class m{constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let y=this.a.get(c)||0;return y===0?!1:(y--,y===0?this.a.delete(c):this.a.set(c,y),!0)}has(c){return this.a.has(c)}}e.$Cc=m;class l{constructor(c){if(this.a=new Map,this.b=new Map,c)for(const[y,h]of c)this.set(y,h)}clear(){this.a.clear(),this.b.clear()}set(c,y){this.a.set(c,y),this.b.set(y,c)}get(c){return this.a.get(c)}getKey(c){return this.b.get(c)}delete(c){const y=this.a.get(c);return y===void 0?!1:(this.a.delete(c),this.b.delete(y),!0)}forEach(c,y){this.a.forEach((h,t)=>{c.call(y,h,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Dc=l;class f{constructor(){this.a=new Map}add(c,y){let h=this.a.get(c);h||(h=new Set,this.a.set(c,h)),h.add(y)}delete(c,y){const h=this.a.get(c);h&&(h.delete(y),h.size===0&&this.a.delete(c))}forEach(c,y){const h=this.a.get(c);h&&h.forEach(y)}get(c){const y=this.a.get(c);return y||new Set}}e.$Ec=f}),define(be[2],we([1,0,18,142,26,74,47]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=void 0;const I=!1;let w=null;class ${constructor(){this.b=new Map}static{this.a=0}c(L){let j=this.b.get(L);return j||(j={parent:null,source:null,isSingleton:!1,value:L,idx:$.a++},this.b.set(L,j)),j}trackDisposable(L){const j=this.c(L);j.source||(j.source=new Error().stack)}setParent(L,j){const Y=this.c(L);Y.parent=j}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,j){const Y=j.get(L);if(Y)return Y;const ce=L.parent?this.f(this.c(L.parent),j):L;return j.set(L,ce),ce}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,Y])=>Y.source!==null&&!this.f(Y,L).isSingleton).map(([Y])=>Y).flat()}computeLeakingDisposables(L=10,j){let Y;if(j)Y=j;else{const _=new Map,he=[...this.b.values()].filter(te=>te.source!==null&&!this.f(te,_).isSingleton);if(he.length===0)return;const ee=new Set(he.map(te=>te.value));if(Y=he.filter(te=>!(te.parent&&ee.has(te.parent))),Y.length===0)throw new Error("There are cyclic diposable chains!")}if(!Y)return;function ce(_){function he(te,W){for(;te.length>0&&W.some(K=>typeof K=="string"?K===te[0]:te[0].match(K));)te.shift()}const ee=_.source.split(`
`).map(te=>te.trim().replace("at ","")).filter(te=>te!=="");return he(ee,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ee.reverse()}const x=new r.$Ec;for(const _ of Y){const he=ce(_);for(let ee=0;ee<=he.length;ee++)x.add(he.slice(0,ee).join(`
`),_)}Y.sort((0,D.$5b)(_=>_.idx,D.$7b));let ne="",ue=0;for(const _ of Y.slice(0,L)){ue++;const he=ce(_),ee=[];for(let te=0;te<he.length;te++){let W=he[te];W=`(shared with ${x.get(he.slice(0,te+1).join(`
`)).size}/${Y.length} leaks) at ${W}`;const V=x.get(he.slice(0,te).join(`
`)),oe=(0,O.$I)([...V].map(me=>ce(me)[te]),me=>me);delete oe[he[te]];for(const[me,se]of Object.entries(oe))ee.unshift(`    - stacktraces of ${se.length} other leaks continue with ${me}`);ee.unshift(W)}ne+=`


==================== Leaking disposable ${ue}/${Y.length}: ${_.value.constructor.name} ====================
${ee.join(`
`)}
============================================================

`}return Y.length>L&&(ne+=`


... and ${Y.length-L} more leaking disposables

`),{leaks:Y,details:ne}}}e.$Fc=$;function C(k){w=k}if(e.$Gc=C,I){const k="__is_disposable_tracked__";C(new class{trackDisposable(L){const j=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[k]||console.log(j)},3e3)}setParent(L,j){if(L&&L!==t.None)try{L[k]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[k]=!0}catch{}}markAsSingleton(L){}})}function S(k){return w?.trackDisposable(k),k}e.$Hc=S;function v(k){w?.markAsDisposed(k)}e.$Ic=v;function d(k,L){w?.setParent(k,L)}function g(k,L){if(w)for(const j of k)w.setParent(j,L)}function m(k){return w?.markAsSingleton(k),k}e.$Jc=m;function l(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Kc=l;function f(k){if(A.Iterable.is(k)){const L=[];for(const j of k)if(j)try{j.dispose()}catch(Y){L.push(Y)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Lc=f;function u(k){for(const L of k)l(L)&&L.dispose();return[]}e.$Mc=u;function c(...k){const L=y(()=>f(k));return g(k,L),L}e.$Nc=c;function y(k){const L=S({dispose:(0,P.$bb)(()=>{v(L),k()})});return L}e.$Oc=y;class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return d(L,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),d(L,null))}}e.$Pc=h;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,S(this),d(this.q,this)}dispose(){v(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Qc=t;class s{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&d(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&d(L,null),L}}e.$Rc=s;class o{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Sc=o;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(L){let j=L;return this.unset=()=>j=void 0,this.isset=()=>j!==void 0,this.dispose=()=>{j&&(j(),j=void 0,v(this))},this}}e.$Tc=i;class n{constructor(){this.a=new Map}acquire(L,...j){let Y=this.a.get(L);Y||(Y={counter:0,object:this.b(L,...j)},this.a.set(L,Y));const{object:ce}=Y,x=(0,P.$bb)(()=>{--Y.counter===0&&(this.c(L,Y.object),this.a.delete(L))});return Y.counter++,{object:ce,dispose:x}}}e.$Uc=n;class a{constructor(L){this.a=L}async acquire(L,...j){const Y=this.a.acquire(L,...j);try{return{object:await Y.object,dispose:()=>Y.dispose()}}catch(ce){throw Y.dispose(),ce}}}e.$Vc=a;class b{constructor(L){this.object=L}dispose(){}}e.$Wc=b;function p(k){const L=new h;try{k(L)}finally{L.dispose()}}e.$Xc=p;class E{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,j,Y=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Y||this.a.get(L)?.dispose(),this.a.set(L,j)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$Yc=E}),function(le,e){typeof define=="function"&&define.amd?define(be[143],we([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(q,z){for(var ie=0;ie<z.length;ie++){var B=z[ie];B.enumerable=B.enumerable||!1,B.configurable=!0,"value"in B&&(B.writable=!0),Object.defineProperty(q,B.key,B)}}function D(q,z,ie){return z&&e(q.prototype,z),ie&&e(q,ie),Object.defineProperty(q,"prototype",{writable:!1}),q}function O(q,z){if(q){if(typeof q=="string")return r(q,z);var ie=Object.prototype.toString.call(q).slice(8,-1);if(ie==="Object"&&q.constructor&&(ie=q.constructor.name),ie==="Map"||ie==="Set")return Array.from(q);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return r(q,z)}}function r(q,z){(z==null||z>q.length)&&(z=q.length);for(var ie=0,B=new Array(z);ie<z;ie++)B[ie]=q[ie];return B}function P(q,z){var ie=typeof Symbol<"u"&&q[Symbol.iterator]||q["@@iterator"];if(ie)return(ie=ie.call(q)).next.bind(ie);if(Array.isArray(q)||(ie=O(q))||z&&q&&typeof q.length=="number"){ie&&(q=ie);var B=0;return function(){return B>=q.length?{done:!0}:{done:!1,value:q[B++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=A();function I(q){le.defaults=q}var w=/[&<>"']/,$=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(z){return v[z]};function g(q,z){if(z){if(w.test(q))return q.replace($,d)}else if(C.test(q))return q.replace(S,d);return q}var m=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(q){return q.replace(m,function(z,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var f=/(^|[^\[])\^/g;function u(q,z){q=typeof q=="string"?q:q.source,z=z||"";var ie={replace:function(X,H){return H=H.source||H,H=H.replace(f,"$1"),q=q.replace(X,H),ie},getRegex:function(){return new RegExp(q,z)}};return ie}var c=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(q,z,ie){if(q){var B;try{B=decodeURIComponent(l(ie)).replace(c,"").toLowerCase()}catch{return null}if(B.indexOf("javascript:")===0||B.indexOf("vbscript:")===0||B.indexOf("data:")===0)return null}z&&!y.test(ie)&&(ie=n(z,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},s=/^[^:]+:\/*[^/]*$/,o=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(q,z){t[" "+q]||(s.test(q)?t[" "+q]=q+"/":t[" "+q]=E(q,"/",!0)),q=t[" "+q];var ie=q.indexOf(":")===-1;return z.substring(0,2)==="//"?ie?z:q.replace(o,"$1")+z:z.charAt(0)==="/"?ie?z:q.replace(i,"$1")+z:q+z}var a={exec:function(){}};function b(q){for(var z=1,ie,B;z<arguments.length;z++){ie=arguments[z];for(B in ie)Object.prototype.hasOwnProperty.call(ie,B)&&(q[B]=ie[B])}return q}function p(q,z){var ie=q.replace(/\|/g,function(H,Q,re){for(var de=!1,Ee=Q;--Ee>=0&&re[Ee]==="\\";)de=!de;return de?"|":" |"}),B=ie.split(/ \|/),X=0;if(B[0].trim()||B.shift(),B.length>0&&!B[B.length-1].trim()&&B.pop(),B.length>z)B.splice(z);else for(;B.length<z;)B.push("");for(;X<B.length;X++)B[X]=B[X].trim().replace(/\\\|/g,"|");return B}function E(q,z,ie){var B=q.length;if(B===0)return"";for(var X=0;X<B;){var H=q.charAt(B-X-1);if(H===z&&!ie)X++;else if(H!==z&&ie)X++;else break}return q.slice(0,B-X)}function k(q,z){if(q.indexOf(z[1])===-1)return-1;for(var ie=q.length,B=0,X=0;X<ie;X++)if(q[X]==="\\")X++;else if(q[X]===z[0])B++;else if(q[X]===z[1]&&(B--,B<0))return X;return-1}function L(q){q&&q.sanitize&&!q.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(q,z){if(z<1)return"";for(var ie="";z>1;)z&1&&(ie+=q),z>>=1,q+=q;return ie+q}function Y(q,z,ie,B){var X=z.href,H=z.title?g(z.title):null,Q=q[1].replace(/\\([\[\]])/g,"$1");if(q[0].charAt(0)!=="!"){B.state.inLink=!0;var re={type:"link",raw:ie,href:X,title:H,text:Q,tokens:B.inlineTokens(Q)};return B.state.inLink=!1,re}return{type:"image",raw:ie,href:X,title:H,text:g(Q)}}function ce(q,z){var ie=q.match(/^(\s+)(?:```)/);if(ie===null)return z;var B=ie[1];return z.split(`
`).map(function(X){var H=X.match(/^\s+/);if(H===null)return X;var Q=H[0];return Q.length>=B.length?X.slice(B.length):X}).join(`
`)}var x=function(){function q(ie){this.options=ie||le.defaults}var z=q.prototype;return z.space=function(B){var X=this.rules.block.newline.exec(B);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},z.code=function(B){var X=this.rules.block.code.exec(B);if(X){var H=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?H:E(H,`
`)}}},z.fences=function(B){var X=this.rules.block.fences.exec(B);if(X){var H=X[0],Q=ce(H,X[3]||"");return{type:"code",raw:H,lang:X[2]?X[2].trim():X[2],text:Q}}},z.heading=function(B){var X=this.rules.block.heading.exec(B);if(X){var H=X[2].trim();if(/#$/.test(H)){var Q=E(H,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(H=Q.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:H,tokens:this.lexer.inline(H)}}},z.hr=function(B){var X=this.rules.block.hr.exec(B);if(X)return{type:"hr",raw:X[0]}},z.blockquote=function(B){var X=this.rules.block.blockquote.exec(B);if(X){var H=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(H,[]),text:H}}},z.list=function(B){var X=this.rules.block.list.exec(B);if(X){var H,Q,re,de,Ee,Ce,Le,Ne,$e,ke,ye,Te,Ue=X[1].trim(),Xe=Ue.length>1,He={type:"list",raw:"",ordered:Xe,start:Xe?+Ue.slice(0,-1):"",loose:!1,items:[]};Ue=Xe?"\\d{1,9}\\"+Ue.slice(-1):"\\"+Ue,this.options.pedantic&&(Ue=Xe?Ue:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Ue+")((?:[	 ][^\\n]*)?(?:\\n|$))");B&&(Te=!1,!(!(X=Ze.exec(B))||this.rules.block.hr.test(B)));){if(H=X[0],B=B.substring(H.length),Ne=X[2].split(`
`,1)[0],$e=B.split(`
`,1)[0],this.options.pedantic?(de=2,ye=Ne.trimLeft()):(de=X[2].search(/[^ ]/),de=de>4?1:de,ye=Ne.slice(de),de+=X[1].length),Ce=!1,!Ne&&/^ *$/.test($e)&&(H+=$e+`
`,B=B.substring($e.length+1),Te=!0),!Te)for(var Je=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ge=new RegExp("^ {0,"+Math.min(3,de-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Se=new RegExp("^ {0,"+Math.min(3,de-1)+"}(?:```|~~~)"),Ie=new RegExp("^ {0,"+Math.min(3,de-1)+"}#");B&&(ke=B.split(`
`,1)[0],Ne=ke,this.options.pedantic&&(Ne=Ne.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Se.test(Ne)||Ie.test(Ne)||Je.test(Ne)||ge.test(B)));){if(Ne.search(/[^ ]/)>=de||!Ne.trim())ye+=`
`+Ne.slice(de);else if(!Ce)ye+=`
`+Ne;else break;!Ce&&!Ne.trim()&&(Ce=!0),H+=ke+`
`,B=B.substring(ke.length+1)}He.loose||(Le?He.loose=!0:/\n *\n *$/.test(H)&&(Le=!0)),this.options.gfm&&(Q=/^\[[ xX]\] /.exec(ye),Q&&(re=Q[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:H,task:!!Q,checked:re,loose:!1,text:ye}),He.raw+=H}He.items[He.items.length-1].raw=H.trimRight(),He.items[He.items.length-1].text=ye.trimRight(),He.raw=He.raw.trimRight();var Fe=He.items.length;for(Ee=0;Ee<Fe;Ee++){this.lexer.state.top=!1,He.items[Ee].tokens=this.lexer.blockTokens(He.items[Ee].text,[]);var je=He.items[Ee].tokens.filter(function(Be){return Be.type==="space"}),Ke=je.every(function(Be){for(var qe=Be.raw.split(""),Qe=0,We=P(qe),Ye;!(Ye=We()).done;){var it=Ye.value;if(it===`
`&&(Qe+=1),Qe>1)return!0}return!1});!He.loose&&je.length&&Ke&&(He.loose=!0,He.items[Ee].loose=!0)}return He}},z.html=function(B){var X=this.rules.block.html.exec(B);if(X){var H={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var Q=this.options.sanitizer?this.options.sanitizer(X[0]):g(X[0]);H.type="paragraph",H.text=Q,H.tokens=this.lexer.inline(Q)}return H}},z.def=function(B){var X=this.rules.block.def.exec(B);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var H=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:H,raw:X[0],href:X[2],title:X[3]}}},z.table=function(B){var X=this.rules.block.table.exec(B);if(X){var H={type:"table",header:p(X[1]).map(function(Le){return{text:Le}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=X[0];var Q=H.align.length,re,de,Ee,Ce;for(re=0;re<Q;re++)/^ *-+: *$/.test(H.align[re])?H.align[re]="right":/^ *:-+: *$/.test(H.align[re])?H.align[re]="center":/^ *:-+ *$/.test(H.align[re])?H.align[re]="left":H.align[re]=null;for(Q=H.rows.length,re=0;re<Q;re++)H.rows[re]=p(H.rows[re],H.header.length).map(function(Le){return{text:Le}});for(Q=H.header.length,de=0;de<Q;de++)H.header[de].tokens=this.lexer.inline(H.header[de].text);for(Q=H.rows.length,de=0;de<Q;de++)for(Ce=H.rows[de],Ee=0;Ee<Ce.length;Ee++)Ce[Ee].tokens=this.lexer.inline(Ce[Ee].text);return H}}},z.lheading=function(B){var X=this.rules.block.lheading.exec(B);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},z.paragraph=function(B){var X=this.rules.block.paragraph.exec(B);if(X){var H=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:H,tokens:this.lexer.inline(H)}}},z.text=function(B){var X=this.rules.block.text.exec(B);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},z.escape=function(B){var X=this.rules.inline.escape.exec(B);if(X)return{type:"escape",raw:X[0],text:g(X[1])}},z.tag=function(B){var X=this.rules.inline.tag.exec(B);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):g(X[0]):X[0]}},z.link=function(B){var X=this.rules.inline.link.exec(B);if(X){var H=X[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var Q=E(H.slice(0,-1),"\\");if((H.length-Q.length)%2===0)return}else{var re=k(X[2],"()");if(re>-1){var de=X[0].indexOf("!")===0?5:4,Ee=de+X[1].length+re;X[2]=X[2].substring(0,re),X[0]=X[0].substring(0,Ee).trim(),X[3]=""}}var Ce=X[2],Le="";if(this.options.pedantic){var Ne=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);Ne&&(Ce=Ne[1],Le=Ne[3])}else Le=X[3]?X[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(H)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),Y(X,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:Le&&Le.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},z.reflink=function(B,X){var H;if((H=this.rules.inline.reflink.exec(B))||(H=this.rules.inline.nolink.exec(B))){var Q=(H[2]||H[1]).replace(/\s+/g," ");if(Q=X[Q.toLowerCase()],!Q||!Q.href){var re=H[0].charAt(0);return{type:"text",raw:re,text:re}}return Y(H,Q,H[0],this.lexer)}},z.emStrong=function(B,X,H){H===void 0&&(H="");var Q=this.rules.inline.emStrong.lDelim.exec(B);if(Q&&!(Q[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var re=Q[1]||Q[2]||"";if(!re||re&&(H===""||this.rules.inline.punctuation.exec(H))){var de=Q[0].length-1,Ee,Ce,Le=de,Ne=0,$e=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for($e.lastIndex=0,X=X.slice(-1*B.length+de);(Q=$e.exec(X))!=null;)if(Ee=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ee){if(Ce=Ee.length,Q[3]||Q[4]){Le+=Ce;continue}else if((Q[5]||Q[6])&&de%3&&!((de+Ce)%3)){Ne+=Ce;continue}if(Le-=Ce,!(Le>0)){if(Ce=Math.min(Ce,Ce+Le+Ne),Math.min(de,Ce)%2){var ke=B.slice(1,de+Q.index+Ce);return{type:"em",raw:B.slice(0,de+Q.index+Ce+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}var ye=B.slice(2,de+Q.index+Ce-1);return{type:"strong",raw:B.slice(0,de+Q.index+Ce+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},z.codespan=function(B){var X=this.rules.inline.code.exec(B);if(X){var H=X[2].replace(/\n/g," "),Q=/[^ ]/.test(H),re=/^ /.test(H)&&/ $/.test(H);return Q&&re&&(H=H.substring(1,H.length-1)),H=g(H,!0),{type:"codespan",raw:X[0],text:H}}},z.br=function(B){var X=this.rules.inline.br.exec(B);if(X)return{type:"br",raw:X[0]}},z.del=function(B){var X=this.rules.inline.del.exec(B);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},z.autolink=function(B,X){var H=this.rules.inline.autolink.exec(B);if(H){var Q,re;return H[2]==="@"?(Q=g(this.options.mangle?X(H[1]):H[1]),re="mailto:"+Q):(Q=g(H[1]),re=Q),{type:"link",raw:H[0],text:Q,href:re,tokens:[{type:"text",raw:Q,text:Q}]}}},z.url=function(B,X){var H;if(H=this.rules.inline.url.exec(B)){var Q,re;if(H[2]==="@")Q=g(this.options.mangle?X(H[0]):H[0]),re="mailto:"+Q;else{var de;do de=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(de!==H[0]);Q=g(H[0]),H[1]==="www."?re="http://"+Q:re=Q}return{type:"link",raw:H[0],text:Q,href:re,tokens:[{type:"text",raw:Q,text:Q}]}}},z.inlineText=function(B,X){var H=this.rules.inline.text.exec(B);if(H){var Q;return this.lexer.state.inRawBlock?Q=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):g(H[0]):H[0]:Q=g(this.options.smartypants?X(H[0]):H[0]),{type:"text",raw:H[0],text:Q}}},q}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=u(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=u(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=u(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=u(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=u(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=u(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=b({},ne),ne.gfm=b({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=u(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=u(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=b({},ne.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:u(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ue={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ue._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ue.punctuation=u(ue.punctuation).replace(/punctuation/g,ue._punctuation).getRegex(),ue.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ue.escapedEmSt=/\\\*|\\_/g,ue._comment=u(ne._comment).replace("(?:-->|$)","-->").getRegex(),ue.emStrong.lDelim=u(ue.emStrong.lDelim).replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimAst=u(ue.emStrong.rDelimAst,"g").replace(/punct/g,ue._punctuation).getRegex(),ue.emStrong.rDelimUnd=u(ue.emStrong.rDelimUnd,"g").replace(/punct/g,ue._punctuation).getRegex(),ue._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ue._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ue._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ue.autolink=u(ue.autolink).replace("scheme",ue._scheme).replace("email",ue._email).getRegex(),ue._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ue.tag=u(ue.tag).replace("comment",ue._comment).replace("attribute",ue._attribute).getRegex(),ue._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ue._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ue._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ue.link=u(ue.link).replace("label",ue._label).replace("href",ue._href).replace("title",ue._title).getRegex(),ue.reflink=u(ue.reflink).replace("label",ue._label).replace("ref",ne._label).getRegex(),ue.nolink=u(ue.nolink).replace("ref",ne._label).getRegex(),ue.reflinkSearch=u(ue.reflinkSearch,"g").replace("reflink",ue.reflink).replace("nolink",ue.nolink).getRegex(),ue.normal=b({},ue),ue.pedantic=b({},ue.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ue._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ue._label).getRegex()}),ue.gfm=b({},ue.normal,{escape:u(ue.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ue.gfm.url=u(ue.gfm.url,"i").replace("email",ue.gfm._extended_email).getRegex(),ue.breaks=b({},ue.gfm,{br:u(ue.br).replace("{2,}","*").getRegex(),text:u(ue.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(q){return q.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function he(q){var z="",ie,B,X=q.length;for(ie=0;ie<X;ie++)B=q.charCodeAt(ie),Math.random()>.5&&(B="x"+B.toString(16)),z+="&#"+B+";";return z}var ee=function(){function q(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||le.defaults,this.options.tokenizer=this.options.tokenizer||new x,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var B={block:ne.normal,inline:ue.normal};this.options.pedantic?(B.block=ne.pedantic,B.inline=ue.pedantic):this.options.gfm&&(B.block=ne.gfm,this.options.breaks?B.inline=ue.breaks:B.inline=ue.gfm),this.tokenizer.rules=B}q.lex=function(B,X){var H=new q(X);return H.lex(B)},q.lexInline=function(B,X){var H=new q(X);return H.inlineTokens(B)};var z=q.prototype;return z.lex=function(B){B=B.replace(/\r\n|\r/g,`
`),this.blockTokens(B,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},z.blockTokens=function(B,X){var H=this;X===void 0&&(X=[]),this.options.pedantic?B=B.replace(/\t/g,"    ").replace(/^ +$/gm,""):B=B.replace(/^( *)(\t+)/gm,function(Le,Ne,$e){return Ne+"    ".repeat($e.length)});for(var Q,re,de,Ee;B;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Le){return(Q=Le.call({lexer:H},B,X))?(B=B.substring(Q.raw.length),X.push(Q),!0):!1}))){if(Q=this.tokenizer.space(B)){B=B.substring(Q.raw.length),Q.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(Q);continue}if(Q=this.tokenizer.code(B)){B=B.substring(Q.raw.length),re=X[X.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.text,this.inlineQueue[this.inlineQueue.length-1].src=re.text):X.push(Q);continue}if(Q=this.tokenizer.fences(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.heading(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.hr(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.blockquote(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.list(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.html(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.def(B)){B=B.substring(Q.raw.length),re=X[X.length-1],re&&(re.type==="paragraph"||re.type==="text")?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.raw,this.inlineQueue[this.inlineQueue.length-1].src=re.text):this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.lheading(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(de=B,this.options.extensions&&this.options.extensions.startBlock&&function(){var Le=1/0,Ne=B.slice(1),$e=void 0;H.options.extensions.startBlock.forEach(function(ke){$e=ke.call({lexer:this},Ne),typeof $e=="number"&&$e>=0&&(Le=Math.min(Le,$e))}),Le<1/0&&Le>=0&&(de=B.substring(0,Le+1))}(),this.state.top&&(Q=this.tokenizer.paragraph(de))){re=X[X.length-1],Ee&&re.type==="paragraph"?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):X.push(Q),Ee=de.length!==B.length,B=B.substring(Q.raw.length);continue}if(Q=this.tokenizer.text(B)){B=B.substring(Q.raw.length),re=X[X.length-1],re&&re.type==="text"?(re.raw+=`
`+Q.raw,re.text+=`
`+Q.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=re.text):X.push(Q);continue}if(B){var Ce="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return this.state.top=!0,X},z.inline=function(B,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:B,tokens:X}),X},z.inlineTokens=function(B,X){var H=this;X===void 0&&(X=[]);var Q,re,de,Ee=B,Ce,Le,Ne;if(this.tokens.links){var $e=Object.keys(this.tokens.links);if($e.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)$e.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Ce.index)+"["+j("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"["+j("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;B;)if(Le||(Ne=""),Le=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Q=ye.call({lexer:H},B,X))?(B=B.substring(Q.raw.length),X.push(Q),!0):!1}))){if(Q=this.tokenizer.escape(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.tag(B)){B=B.substring(Q.raw.length),re=X[X.length-1],re&&Q.type==="text"&&re.type==="text"?(re.raw+=Q.raw,re.text+=Q.text):X.push(Q);continue}if(Q=this.tokenizer.link(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.reflink(B,this.tokens.links)){B=B.substring(Q.raw.length),re=X[X.length-1],re&&Q.type==="text"&&re.type==="text"?(re.raw+=Q.raw,re.text+=Q.text):X.push(Q);continue}if(Q=this.tokenizer.emStrong(B,Ee,Ne)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.codespan(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.br(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.del(B)){B=B.substring(Q.raw.length),X.push(Q);continue}if(Q=this.tokenizer.autolink(B,he)){B=B.substring(Q.raw.length),X.push(Q);continue}if(!this.state.inLink&&(Q=this.tokenizer.url(B,he))){B=B.substring(Q.raw.length),X.push(Q);continue}if(de=B,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Te=B.slice(1),Ue=void 0;H.options.extensions.startInline.forEach(function(Xe){Ue=Xe.call({lexer:this},Te),typeof Ue=="number"&&Ue>=0&&(ye=Math.min(ye,Ue))}),ye<1/0&&ye>=0&&(de=B.substring(0,ye+1))}(),Q=this.tokenizer.inlineText(de,_)){B=B.substring(Q.raw.length),Q.raw.slice(-1)!=="_"&&(Ne=Q.raw.slice(-1)),Le=!0,re=X[X.length-1],re&&re.type==="text"?(re.raw+=Q.raw,re.text+=Q.text):X.push(Q);continue}if(B){var ke="Infinite loop on byte: "+B.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return X},D(q,null,[{key:"rules",get:function(){return{block:ne,inline:ue}}}]),q}(),te=function(){function q(ie){this.options=ie||le.defaults}var z=q.prototype;return z.code=function(B,X,H){var Q=(X||"").match(/\S*/)[0];if(this.options.highlight){var re=this.options.highlight(B,Q);re!=null&&re!==B&&(H=!0,B=re)}return B=B.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+g(Q,!0)+'">'+(H?B:g(B,!0))+`</code></pre>
`:"<pre><code>"+(H?B:g(B,!0))+`</code></pre>
`},z.blockquote=function(B){return`<blockquote>
`+B+`</blockquote>
`},z.html=function(B){return B},z.heading=function(B,X,H,Q){if(this.options.headerIds){var re=this.options.headerPrefix+Q.slug(H);return"<h"+X+' id="'+re+'">'+B+"</h"+X+`>
`}return"<h"+X+">"+B+"</h"+X+`>
`},z.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},z.list=function(B,X,H){var Q=X?"ol":"ul",re=X&&H!==1?' start="'+H+'"':"";return"<"+Q+re+`>
`+B+"</"+Q+`>
`},z.listitem=function(B){return"<li>"+B+`</li>
`},z.checkbox=function(B){return"<input "+(B?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},z.paragraph=function(B){return"<p>"+B+`</p>
`},z.table=function(B,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+B+`</thead>
`+X+`</table>
`},z.tablerow=function(B){return`<tr>
`+B+`</tr>
`},z.tablecell=function(B,X){var H=X.header?"th":"td",Q=X.align?"<"+H+' align="'+X.align+'">':"<"+H+">";return Q+B+("</"+H+`>
`)},z.strong=function(B){return"<strong>"+B+"</strong>"},z.em=function(B){return"<em>"+B+"</em>"},z.codespan=function(B){return"<code>"+B+"</code>"},z.br=function(){return this.options.xhtml?"<br/>":"<br>"},z.del=function(B){return"<del>"+B+"</del>"},z.link=function(B,X,H){if(B=h(this.options.sanitize,this.options.baseUrl,B),B===null)return H;var Q='<a href="'+g(B)+'"';return X&&(Q+=' title="'+X+'"'),Q+=">"+H+"</a>",Q},z.image=function(B,X,H){if(B=h(this.options.sanitize,this.options.baseUrl,B),B===null)return H;var Q='<img src="'+B+'" alt="'+H+'"';return X&&(Q+=' title="'+X+'"'),Q+=this.options.xhtml?"/>":">",Q},z.text=function(B){return B},q}(),W=function(){function q(){}var z=q.prototype;return z.strong=function(B){return B},z.em=function(B){return B},z.codespan=function(B){return B},z.del=function(B){return B},z.html=function(B){return B},z.text=function(B){return B},z.link=function(B,X,H){return""+H},z.image=function(B,X,H){return""+H},z.br=function(){return""},q}(),K=function(){function q(){this.seen={}}var z=q.prototype;return z.serialize=function(B){return B.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},z.getNextSafeSlug=function(B,X){var H=B,Q=0;if(this.seen.hasOwnProperty(H)){Q=this.seen[B];do Q++,H=B+"-"+Q;while(this.seen.hasOwnProperty(H))}return X||(this.seen[B]=Q,this.seen[H]=0),H},z.slug=function(B,X){X===void 0&&(X={});var H=this.serialize(B);return this.getNextSafeSlug(H,X.dryrun)},q}(),V=function(){function q(ie){this.options=ie||le.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new W,this.slugger=new K}q.parse=function(B,X){var H=new q(X);return H.parse(B)},q.parseInline=function(B,X){var H=new q(X);return H.parseInline(B)};var z=q.prototype;return z.parse=function(B,X){X===void 0&&(X=!0);var H="",Q,re,de,Ee,Ce,Le,Ne,$e,ke,ye,Te,Ue,Xe,He,Ze,Je,ge,Se,Ie,Fe=B.length;for(Q=0;Q<Fe;Q++){if(ye=B[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ie=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ie!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){H+=Ie||"";continue}switch(ye.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,l(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for($e="",Ne="",Ee=ye.header.length,re=0;re<Ee;re++)Ne+=this.renderer.tablecell(this.parseInline(ye.header[re].tokens),{header:!0,align:ye.align[re]});for($e+=this.renderer.tablerow(Ne),ke="",Ee=ye.rows.length,re=0;re<Ee;re++){for(Le=ye.rows[re],Ne="",Ce=Le.length,de=0;de<Ce;de++)Ne+=this.renderer.tablecell(this.parseInline(Le[de].tokens),{header:!1,align:ye.align[de]});ke+=this.renderer.tablerow(Ne)}H+=this.renderer.table($e,ke);continue}case"blockquote":{ke=this.parse(ye.tokens),H+=this.renderer.blockquote(ke);continue}case"list":{for(Te=ye.ordered,Ue=ye.start,Xe=ye.loose,Ee=ye.items.length,ke="",re=0;re<Ee;re++)Ze=ye.items[re],Je=Ze.checked,ge=Ze.task,He="",Ze.task&&(Se=this.renderer.checkbox(Je),Xe?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=Se+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=Se+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:Se}):He+=Se),He+=this.parse(Ze.tokens,Xe),ke+=this.renderer.listitem(He,ge,Je);H+=this.renderer.list(ke,Te,Ue);continue}case"html":{H+=this.renderer.html(ye.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(ke=ye.tokens?this.parseInline(ye.tokens):ye.text;Q+1<Fe&&B[Q+1].type==="text";)ye=B[++Q],ke+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);H+=X?this.renderer.paragraph(ke):ke;continue}default:{var je='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return H},z.parseInline=function(B,X){X=X||this.renderer;var H="",Q,re,de,Ee=B.length;for(Q=0;Q<Ee;Q++){if(re=B[Q],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[re.type]&&(de=this.options.extensions.renderers[re.type].call({parser:this},re),de!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(re.type))){H+=de||"";continue}switch(re.type){case"escape":{H+=X.text(re.text);break}case"html":{H+=X.html(re.text);break}case"link":{H+=X.link(re.href,re.title,this.parseInline(re.tokens,X));break}case"image":{H+=X.image(re.href,re.title,re.text);break}case"strong":{H+=X.strong(this.parseInline(re.tokens,X));break}case"em":{H+=X.em(this.parseInline(re.tokens,X));break}case"codespan":{H+=X.codespan(re.text);break}case"br":{H+=X.br();break}case"del":{H+=X.del(this.parseInline(re.tokens,X));break}case"text":{H+=X.text(re.text);break}default:{var Ce='Token with "'+re.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return H},q}();function oe(q,z,ie){if(typeof q>"u"||q===null)throw new Error("marked(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");if(typeof z=="function"&&(ie=z,z=null),z=b({},oe.defaults,z||{}),L(z),ie){var B=z.highlight,X;try{X=ee.lex(q,z)}catch(Ee){return ie(Ee)}var H=function(Ce){var Le;if(!Ce)try{z.walkTokens&&oe.walkTokens(X,z.walkTokens),Le=V.parse(X,z)}catch(Ne){Ce=Ne}return z.highlight=B,Ce?ie(Ce):ie(null,Le)};if(!B||B.length<3||(delete z.highlight,!X.length))return H();var Q=0;oe.walkTokens(X,function(Ee){Ee.type==="code"&&(Q++,setTimeout(function(){B(Ee.text,Ee.lang,function(Ce,Le){if(Ce)return H(Ce);Le!=null&&Le!==Ee.text&&(Ee.text=Le,Ee.escaped=!0),Q--,Q===0&&H()})},0))}),Q===0&&H();return}function re(Ee){if(Ee.message+=`
Please report this to https://github.com/markedjs/marked.`,z.silent)return"<p>An error occurred:</p><pre>"+g(Ee.message+"",!0)+"</pre>";throw Ee}try{var de=ee.lex(q,z);if(z.walkTokens){if(z.async)return Promise.all(oe.walkTokens(de,z.walkTokens)).then(function(){return V.parse(de,z)}).catch(re);oe.walkTokens(de,z.walkTokens)}return V.parse(de,z)}catch(Ee){re(Ee)}}oe.options=oe.setOptions=function(q){return b(oe.defaults,q),I(oe.defaults),oe},oe.getDefaults=A,oe.defaults=le.defaults,oe.use=function(){for(var q=arguments.length,z=new Array(q),ie=0;ie<q;ie++)z[ie]=arguments[ie];var B=b.apply(void 0,[{}].concat(z)),X=oe.defaults.extensions||{renderers:{},childTokens:{}},H;z.forEach(function(Q){if(Q.extensions&&(H=!0,Q.extensions.forEach(function(de){if(!de.name)throw new Error("extension name required");if(de.renderer){var Ee=X.renderers?X.renderers[de.name]:null;Ee?X.renderers[de.name]=function(){for(var Ce=arguments.length,Le=new Array(Ce),Ne=0;Ne<Ce;Ne++)Le[Ne]=arguments[Ne];var $e=de.renderer.apply(this,Le);return $e===!1&&($e=Ee.apply(this,Le)),$e}:X.renderers[de.name]=de.renderer}if(de.tokenizer){if(!de.level||de.level!=="block"&&de.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[de.level]?X[de.level].unshift(de.tokenizer):X[de.level]=[de.tokenizer],de.start&&(de.level==="block"?X.startBlock?X.startBlock.push(de.start):X.startBlock=[de.start]:de.level==="inline"&&(X.startInline?X.startInline.push(de.start):X.startInline=[de.start]))}de.childTokens&&(X.childTokens[de.name]=de.childTokens)})),Q.renderer&&function(){var de=oe.defaults.renderer||new te,Ee=function(Ne){var $e=de[Ne];de[Ne]=function(){for(var ke=arguments.length,ye=new Array(ke),Te=0;Te<ke;Te++)ye[Te]=arguments[Te];var Ue=Q.renderer[Ne].apply(de,ye);return Ue===!1&&(Ue=$e.apply(de,ye)),Ue}};for(var Ce in Q.renderer)Ee(Ce);B.renderer=de}(),Q.tokenizer&&function(){var de=oe.defaults.tokenizer||new x,Ee=function(Ne){var $e=de[Ne];de[Ne]=function(){for(var ke=arguments.length,ye=new Array(ke),Te=0;Te<ke;Te++)ye[Te]=arguments[Te];var Ue=Q.tokenizer[Ne].apply(de,ye);return Ue===!1&&(Ue=$e.apply(de,ye)),Ue}};for(var Ce in Q.tokenizer)Ee(Ce);B.tokenizer=de}(),Q.walkTokens){var re=oe.defaults.walkTokens;B.walkTokens=function(de){var Ee=[];return Ee.push(Q.walkTokens.call(this,de)),re&&(Ee=Ee.concat(re.call(this,de))),Ee}}H&&(B.extensions=X),oe.setOptions(B)})},oe.walkTokens=function(q,z){for(var ie=[],B=function(){var re=H.value;switch(ie=ie.concat(z.call(oe,re)),re.type){case"table":{for(var de=P(re.header),Ee;!(Ee=de()).done;){var Ce=Ee.value;ie=ie.concat(oe.walkTokens(Ce.tokens,z))}for(var Le=P(re.rows),Ne;!(Ne=Le()).done;)for(var $e=Ne.value,ke=P($e),ye;!(ye=ke()).done;){var Te=ye.value;ie=ie.concat(oe.walkTokens(Te.tokens,z))}break}case"list":{ie=ie.concat(oe.walkTokens(re.items,z));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[re.type]?oe.defaults.extensions.childTokens[re.type].forEach(function(Ue){ie=ie.concat(oe.walkTokens(re[Ue],z))}):re.tokens&&(ie=ie.concat(oe.walkTokens(re.tokens,z)))}},X=P(q),H;!(H=X()).done;)B();return ie},oe.parseInline=function(q,z){if(typeof q>"u"||q===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof q!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(q)+", string expected");z=b({},oe.defaults,z||{}),L(z);try{var ie=ee.lexInline(q,z);return z.walkTokens&&oe.walkTokens(ie,z.walkTokens),V.parseInline(ie,z)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,z.silent)return"<p>An error occurred:</p><pre>"+g(B.message+"",!0)+"</pre>";throw B}},oe.Parser=V,oe.parser=V.parse,oe.Renderer=te,oe.TextRenderer=W,oe.Lexer=ee,oe.lexer=ee.lex,oe.Tokenizer=x,oe.Slugger=K,oe.parse=oe;var me=oe.options,se=oe.setOptions,U=oe.use,Z=oe.walkTokens,R=oe.parseInline,F=oe,G=V.parse,T=ee.lex;le.Lexer=ee,le.Parser=V,le.Renderer=te,le.Slugger=K,le.TextRenderer=W,le.Tokenizer=x,le.getDefaults=A,le.lexer=T,le.marked=oe,le.options=me,le.parse=F,le.parseInline=R,le.parser=G,le.setOptions=se,le.use=U,le.walkTokens=Z,Object.defineProperty(le,"__esModule",{value:!0})}),define(be[97],we([1,0,26]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=void 0;const O=new D.$Bc(1e4);function r($){return w($,"NFC",O)}e.$il=r;const P=new D.$Bc(1e4);function A($){return w($,"NFD",P)}e.$jl=A;const I=/[^\u0000-\u0080]/;function w($,C,S){if(!$)return $;const v=S.get($);if(v)return v;let d;return I.test($)?d=$.normalize(C):d=$,S.set($,d),d}e.$kl=function(){const $=/[\u0300-\u036f]/g;return function(C){return A(C).replace($,"")}}()}),define(be[144],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.rot=e.$Il=void 0;function D(I,w,$){return Math.min(Math.max(I,w),$)}e.$Il=D;function O(I,w){return(w+I%w)%w}e.rot=O;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$Kl=r;class P{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Ll=P;class A{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const $=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ml=A}),function(){function le(r){const P=[];typeof r=="number"&&P.push("code/timeOrigin",r);function A(w){P.push(w,Date.now())}function I(){const w=[];for(let $=0;$<P.length;$+=2)w.push({name:P[$],startTime:P[$+1]});return w}return{mark:A,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const A of performance.getEntriesByType("mark"))P.push({name:A.name,startTime:Math.round(r+A.startTime)});return P}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function D(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=D(O))}(),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var O in D)(typeof exports=="object"?exports:le)[O]=D[O]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function D(O){if(e[O])return e[O].exports;var r=e[O]={i:O,l:!1,exports:{}};return le[O].call(r.exports,r,r.exports,D),r.l=!0,r.exports}return D.m=le,D.c=e,D.d=function(O,r,P){D.o(O,r)||Object.defineProperty(O,r,{enumerable:!0,get:P})},D.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},D.t=function(O,r){if(1&r&&(O=D(O)),8&r||4&r&&typeof O=="object"&&O&&O.__esModule)return O;var P=Object.create(null);if(D.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:O}),2&r&&typeof O!="string")for(var A in O)D.d(P,A,function(I){return O[I]}.bind(null,A));return P},D.n=function(O){var r=O&&O.__esModule?function(){return O.default}:function(){return O};return D.d(r,"a",r),r},D.o=function(O,r){return Object.prototype.hasOwnProperty.call(O,r)},D.p="",D(D.s=0)}([function(le,e,D){(function(O){var r;e=le.exports=U,r=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var $e=Array.prototype.slice.call(arguments,0);$e.unshift("SEMVER"),console.log.apply(console,$e)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],w=e.src=[],$=0,C=$++;w[C]="0|[1-9]\\d*";var S=$++;w[S]="[0-9]+";var v=$++;w[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=$++;w[d]="("+w[C]+")\\.("+w[C]+")\\.("+w[C]+")";var g=$++;w[g]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var m=$++;w[m]="(?:"+w[C]+"|"+w[v]+")";var l=$++;w[l]="(?:"+w[S]+"|"+w[v]+")";var f=$++;w[f]="(?:-("+w[m]+"(?:\\."+w[m]+")*))";var u=$++;w[u]="(?:-?("+w[l]+"(?:\\."+w[l]+")*))";var c=$++;w[c]="[0-9A-Za-z-]+";var y=$++;w[y]="(?:\\+("+w[c]+"(?:\\."+w[c]+")*))";var h=$++,t="v?"+w[d]+w[f]+"?"+w[y]+"?";w[h]="^"+t+"$";var s="[v=\\s]*"+w[g]+w[u]+"?"+w[y]+"?",o=$++;w[o]="^"+s+"$";var i=$++;w[i]="((?:<|>)?=?)";var n=$++;w[n]=w[S]+"|x|X|\\*";var a=$++;w[a]=w[C]+"|x|X|\\*";var b=$++;w[b]="[v=\\s]*("+w[a]+")(?:\\.("+w[a]+")(?:\\.("+w[a]+")(?:"+w[f]+")?"+w[y]+"?)?)?";var p=$++;w[p]="[v=\\s]*("+w[n]+")(?:\\.("+w[n]+")(?:\\.("+w[n]+")(?:"+w[u]+")?"+w[y]+"?)?)?";var E=$++;w[E]="^"+w[i]+"\\s*"+w[b]+"$";var k=$++;w[k]="^"+w[i]+"\\s*"+w[p]+"$";var L=$++;w[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=$++;w[j]="(?:~>?)";var Y=$++;w[Y]="(\\s*)"+w[j]+"\\s+",I[Y]=new RegExp(w[Y],"g");var ce=$++;w[ce]="^"+w[j]+w[b]+"$";var x=$++;w[x]="^"+w[j]+w[p]+"$";var ne=$++;w[ne]="(?:\\^)";var ue=$++;w[ue]="(\\s*)"+w[ne]+"\\s+",I[ue]=new RegExp(w[ue],"g");var _=$++;w[_]="^"+w[ne]+w[b]+"$";var he=$++;w[he]="^"+w[ne]+w[p]+"$";var ee=$++;w[ee]="^"+w[i]+"\\s*("+s+")$|^$";var te=$++;w[te]="^"+w[i]+"\\s*("+t+")$|^$";var W=$++;w[W]="(\\s*)"+w[i]+"\\s*("+s+"|"+w[b]+")",I[W]=new RegExp(w[W],"g");var K=$++;w[K]="^\\s*("+w[b]+")\\s+-\\s+("+w[b]+")\\s*$";var V=$++;w[V]="^\\s*("+w[p]+")\\s+-\\s+("+w[p]+")\\s*$";var oe=$++;w[oe]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)r(me,w[me]),I[me]||(I[me]=new RegExp(w[me]));function se($e,ke){if($e instanceof U)return $e;if(typeof $e!="string"||$e.length>P||!(ke?I[o]:I[h]).test($e))return null;try{return new U($e,ke)}catch{return null}}function U($e,ke){if($e instanceof U){if($e.loose===ke)return $e;$e=$e.version}else if(typeof $e!="string")throw new TypeError("Invalid Version: "+$e);if($e.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof U))return new U($e,ke);r("SemVer",$e,ke),this.loose=ke;var ye=$e.trim().match(ke?I[o]:I[h]);if(!ye)throw new TypeError("Invalid Version: "+$e);if(this.raw=$e,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Te){if(/^[0-9]+$/.test(Te)){var Ue=+Te;if(Ue>=0&&Ue<A)return Ue}return Te}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=se,e.valid=function($e,ke){var ye=se($e,ke);return ye?ye.version:null},e.clean=function($e,ke){var ye=se($e.trim().replace(/^[=v]+/,""),ke);return ye?ye.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function($e){return r("SemVer.compare",this.version,this.loose,$e),$e instanceof U||($e=new U($e,this.loose)),this.compareMain($e)||this.comparePre($e)},U.prototype.compareMain=function($e){return $e instanceof U||($e=new U($e,this.loose)),R(this.major,$e.major)||R(this.minor,$e.minor)||R(this.patch,$e.patch)},U.prototype.comparePre=function($e){if($e instanceof U||($e=new U($e,this.loose)),this.prerelease.length&&!$e.prerelease.length)return-1;if(!this.prerelease.length&&$e.prerelease.length)return 1;if(!this.prerelease.length&&!$e.prerelease.length)return 0;var ke=0;do{var ye=this.prerelease[ke],Te=$e.prerelease[ke];if(r("prerelease compare",ke,ye,Te),ye===void 0&&Te===void 0)return 0;if(Te===void 0)return 1;if(ye===void 0)return-1;if(ye!==Te)return R(ye,Te)}while(++ke)},U.prototype.inc=function($e,ke){switch($e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ke);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ke);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ke),this.inc("pre",ke);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ke),this.inc("pre",ke);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}ke&&(this.prerelease[0]===ke?isNaN(this.prerelease[1])&&(this.prerelease=[ke,0]):this.prerelease=[ke,0]);break;default:throw new Error("invalid increment argument: "+$e)}return this.format(),this.raw=this.version,this},e.inc=function($e,ke,ye,Te){typeof ye=="string"&&(Te=ye,ye=void 0);try{return new U($e,ye).inc(ke,Te).version}catch{return null}},e.diff=function($e,ke){if(q($e,ke))return null;var ye=se($e),Te=se(ke);if(ye.prerelease.length||Te.prerelease.length){for(var Ue in ye)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ye[Ue]!==Te[Ue])return"pre"+Ue;return"prerelease"}for(var Ue in ye)if((Ue==="major"||Ue==="minor"||Ue==="patch")&&ye[Ue]!==Te[Ue])return Ue},e.compareIdentifiers=R;var Z=/^[0-9]+$/;function R($e,ke){var ye=Z.test($e),Te=Z.test(ke);return ye&&Te&&($e=+$e,ke=+ke),ye&&!Te?-1:Te&&!ye?1:$e<ke?-1:$e>ke?1:0}function F($e,ke,ye){return new U($e,ye).compare(new U(ke,ye))}function G($e,ke,ye){return F($e,ke,ye)>0}function T($e,ke,ye){return F($e,ke,ye)<0}function q($e,ke,ye){return F($e,ke,ye)===0}function z($e,ke,ye){return F($e,ke,ye)!==0}function ie($e,ke,ye){return F($e,ke,ye)>=0}function B($e,ke,ye){return F($e,ke,ye)<=0}function X($e,ke,ye,Te){var Ue;switch(ke){case"===":typeof $e=="object"&&($e=$e.version),typeof ye=="object"&&(ye=ye.version),Ue=$e===ye;break;case"!==":typeof $e=="object"&&($e=$e.version),typeof ye=="object"&&(ye=ye.version),Ue=$e!==ye;break;case"":case"=":case"==":Ue=q($e,ye,Te);break;case"!=":Ue=z($e,ye,Te);break;case">":Ue=G($e,ye,Te);break;case">=":Ue=ie($e,ye,Te);break;case"<":Ue=T($e,ye,Te);break;case"<=":Ue=B($e,ye,Te);break;default:throw new TypeError("Invalid operator: "+ke)}return Ue}function H($e,ke){if($e instanceof H){if($e.loose===ke)return $e;$e=$e.value}if(!(this instanceof H))return new H($e,ke);r("comparator",$e,ke),this.loose=ke,this.parse($e),this.semver===Q?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function($e,ke){return R(ke,$e)},e.major=function($e,ke){return new U($e,ke).major},e.minor=function($e,ke){return new U($e,ke).minor},e.patch=function($e,ke){return new U($e,ke).patch},e.compare=F,e.compareLoose=function($e,ke){return F($e,ke,!0)},e.rcompare=function($e,ke,ye){return F(ke,$e,ye)},e.sort=function($e,ke){return $e.sort(function(ye,Te){return e.compare(ye,Te,ke)})},e.rsort=function($e,ke){return $e.sort(function(ye,Te){return e.rcompare(ye,Te,ke)})},e.gt=G,e.lt=T,e.eq=q,e.neq=z,e.gte=ie,e.lte=B,e.cmp=X,e.Comparator=H;var Q={};function re($e,ke){if($e instanceof re)return $e.loose===ke?$e:new re($e.raw,ke);if($e instanceof H)return new re($e.value,ke);if(!(this instanceof re))return new re($e,ke);if(this.loose=ke,this.raw=$e,this.set=$e.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+$e);this.format()}function de($e){return!$e||$e.toLowerCase()==="x"||$e==="*"}function Ee($e,ke,ye,Te,Ue,Xe,He,Ze,Je,ge,Se,Ie,Fe){return((ke=de(ye)?"":de(Te)?">="+ye+".0.0":de(Ue)?">="+ye+"."+Te+".0":">="+ke)+" "+(Ze=de(Je)?"":de(ge)?"<"+(+Je+1)+".0.0":de(Se)?"<"+Je+"."+(+ge+1)+".0":Ie?"<="+Je+"."+ge+"."+Se+"-"+Ie:"<="+Ze)).trim()}function Ce($e,ke){for(var ye=0;ye<$e.length;ye++)if(!$e[ye].test(ke))return!1;if(ke.prerelease.length){for(ye=0;ye<$e.length;ye++)if(r($e[ye].semver),$e[ye].semver!==Q&&$e[ye].semver.prerelease.length>0){var Te=$e[ye].semver;if(Te.major===ke.major&&Te.minor===ke.minor&&Te.patch===ke.patch)return!0}return!1}return!0}function Le($e,ke,ye){try{ke=new re(ke,ye)}catch{return!1}return ke.test($e)}function Ne($e,ke,ye,Te){var Ue,Xe,He,Ze,Je;switch($e=new U($e,Te),ke=new re(ke,Te),ye){case">":Ue=G,Xe=B,He=T,Ze=">",Je=">=";break;case"<":Ue=T,Xe=ie,He=G,Ze="<",Je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Le($e,ke,Te))return!1;for(var ge=0;ge<ke.set.length;++ge){var Se=ke.set[ge],Ie=null,Fe=null;if(Se.forEach(function(je){je.semver===Q&&(je=new H(">=0.0.0")),Ie=Ie||je,Fe=Fe||je,Ue(je.semver,Ie.semver,Te)?Ie=je:He(je.semver,Fe.semver,Te)&&(Fe=je)}),Ie.operator===Ze||Ie.operator===Je||(!Fe.operator||Fe.operator===Ze)&&Xe($e,Fe.semver)||Fe.operator===Je&&He($e,Fe.semver))return!1}return!0}H.prototype.parse=function($e){var ke=this.loose?I[ee]:I[te],ye=$e.match(ke);if(!ye)throw new TypeError("Invalid comparator: "+$e);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new U(ye[2],this.loose):this.semver=Q},H.prototype.toString=function(){return this.value},H.prototype.test=function($e){return r("Comparator.test",$e,this.loose),this.semver===Q||(typeof $e=="string"&&($e=new U($e,this.loose)),X($e,this.operator,this.semver,this.loose))},H.prototype.intersects=function($e,ke){if(!($e instanceof H))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new re($e.value,ke),Le(this.value,ye,ke);if($e.operator==="")return ye=new re(this.value,ke),Le($e.semver,ye,ke);var Te=!(this.operator!==">="&&this.operator!==">"||$e.operator!==">="&&$e.operator!==">"),Ue=!(this.operator!=="<="&&this.operator!=="<"||$e.operator!=="<="&&$e.operator!=="<"),Xe=this.semver.version===$e.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||$e.operator!==">="&&$e.operator!=="<="),Ze=X(this.semver,"<",$e.semver,ke)&&(this.operator===">="||this.operator===">")&&($e.operator==="<="||$e.operator==="<"),Je=X(this.semver,">",$e.semver,ke)&&(this.operator==="<="||this.operator==="<")&&($e.operator===">="||$e.operator===">");return Te||Ue||Xe&&He||Ze||Je},e.Range=re,re.prototype.format=function(){return this.range=this.set.map(function($e){return $e.join(" ").trim()}).join("||").trim(),this.range},re.prototype.toString=function(){return this.range},re.prototype.parseRange=function($e){var ke=this.loose;$e=$e.trim(),r("range",$e,ke);var ye=ke?I[V]:I[K];$e=$e.replace(ye,Ee),r("hyphen replace",$e),$e=$e.replace(I[W],"$1$2$3"),r("comparator trim",$e,I[W]),$e=($e=($e=$e.replace(I[Y],"$1~")).replace(I[ue],"$1^")).split(/\s+/).join(" ");var Te=ke?I[ee]:I[te],Ue=$e.split(" ").map(function(Xe){return function(He,Ze){return r("comp",He),He=function(Je,ge){return Je.trim().split(/\s+/).map(function(Se){return function(Ie,Fe){r("caret",Ie,Fe);var je=Fe?I[he]:I[_];return Ie.replace(je,function(Ke,Be,qe,Qe,We){var Ye;return r("caret",Ie,Ke,Be,qe,Qe,We),de(Be)?Ye="":de(qe)?Ye=">="+Be+".0.0 <"+(+Be+1)+".0.0":de(Qe)?Ye=Be==="0"?">="+Be+"."+qe+".0 <"+Be+"."+(+qe+1)+".0":">="+Be+"."+qe+".0 <"+(+Be+1)+".0.0":We?(r("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ye=Be==="0"?qe==="0"?">="+Be+"."+qe+"."+Qe+We+" <"+Be+"."+qe+"."+(+Qe+1):">="+Be+"."+qe+"."+Qe+We+" <"+Be+"."+(+qe+1)+".0":">="+Be+"."+qe+"."+Qe+We+" <"+(+Be+1)+".0.0"):(r("no pr"),Ye=Be==="0"?qe==="0"?">="+Be+"."+qe+"."+Qe+" <"+Be+"."+qe+"."+(+Qe+1):">="+Be+"."+qe+"."+Qe+" <"+Be+"."+(+qe+1)+".0":">="+Be+"."+qe+"."+Qe+" <"+(+Be+1)+".0.0"),r("caret return",Ye),Ye})}(Se,ge)}).join(" ")}(He,Ze),r("caret",He),He=function(Je,ge){return Je.trim().split(/\s+/).map(function(Se){return function(Ie,Fe){var je=Fe?I[x]:I[ce];return Ie.replace(je,function(Ke,Be,qe,Qe,We){var Ye;return r("tilde",Ie,Ke,Be,qe,Qe,We),de(Be)?Ye="":de(qe)?Ye=">="+Be+".0.0 <"+(+Be+1)+".0.0":de(Qe)?Ye=">="+Be+"."+qe+".0 <"+Be+"."+(+qe+1)+".0":We?(r("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),Ye=">="+Be+"."+qe+"."+Qe+We+" <"+Be+"."+(+qe+1)+".0"):Ye=">="+Be+"."+qe+"."+Qe+" <"+Be+"."+(+qe+1)+".0",r("tilde return",Ye),Ye})}(Se,ge)}).join(" ")}(He,Ze),r("tildes",He),He=function(Je,ge){return r("replaceXRanges",Je,ge),Je.split(/\s+/).map(function(Se){return function(Ie,Fe){Ie=Ie.trim();var je=Fe?I[k]:I[E];return Ie.replace(je,function(Ke,Be,qe,Qe,We,Ye){r("xRange",Ie,Ke,Be,qe,Qe,We,Ye);var it=de(qe),_e=it||de(Qe),st=_e||de(We);return Be==="="&&st&&(Be=""),it?Ke=Be===">"||Be==="<"?"<0.0.0":"*":Be&&st?(_e&&(Qe=0),st&&(We=0),Be===">"?(Be=">=",_e?(qe=+qe+1,Qe=0,We=0):st&&(Qe=+Qe+1,We=0)):Be==="<="&&(Be="<",_e?qe=+qe+1:Qe=+Qe+1),Ke=Be+qe+"."+Qe+"."+We):_e?Ke=">="+qe+".0.0 <"+(+qe+1)+".0.0":st&&(Ke=">="+qe+"."+Qe+".0 <"+qe+"."+(+Qe+1)+".0"),r("xRange return",Ke),Ke})}(Se,ge)}).join(" ")}(He,Ze),r("xrange",He),He=function(Je,ge){return r("replaceStars",Je,ge),Je.trim().replace(I[oe],"")}(He,Ze),r("stars",He),He}(Xe,ke)}).join(" ").split(/\s+/);return this.loose&&(Ue=Ue.filter(function(Xe){return!!Xe.match(Te)})),Ue=Ue.map(function(Xe){return new H(Xe,ke)})},re.prototype.intersects=function($e,ke){if(!($e instanceof re))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Te){return $e.set.some(function(Ue){return Ue.every(function(Xe){return Te.intersects(Xe,ke)})})})})},e.toComparators=function($e,ke){return new re($e,ke).set.map(function(ye){return ye.map(function(Te){return Te.value}).join(" ").trim().split(" ")})},re.prototype.test=function($e){if(!$e)return!1;typeof $e=="string"&&($e=new U($e,this.loose));for(var ke=0;ke<this.set.length;ke++)if(Ce(this.set[ke],$e))return!0;return!1},e.satisfies=Le,e.maxSatisfying=function($e,ke,ye){var Te=null,Ue=null;try{var Xe=new re(ke,ye)}catch{return null}return $e.forEach(function(He){Xe.test(He)&&(Te&&Ue.compare(He)!==-1||(Ue=new U(Te=He,ye)))}),Te},e.minSatisfying=function($e,ke,ye){var Te=null,Ue=null;try{var Xe=new re(ke,ye)}catch{return null}return $e.forEach(function(He){Xe.test(He)&&(Te&&Ue.compare(He)!==1||(Ue=new U(Te=He,ye)))}),Te},e.validRange=function($e,ke){try{return new re($e,ke).range||"*"}catch{return null}},e.ltr=function($e,ke,ye){return Ne($e,ke,"<",ye)},e.gtr=function($e,ke,ye){return Ne($e,ke,">",ye)},e.outside=Ne,e.prerelease=function($e,ke){var ye=se($e,ke);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function($e,ke,ye){return $e=new re($e,ye),ke=new re(ke,ye),$e.intersects(ke)},e.coerce=function($e){if($e instanceof U)return $e;if(typeof $e!="string")return null;var ke=$e.match(I[L]);return ke==null?null:se((ke[1]||"0")+"."+(ke[2]||"0")+"."+(ke[3]||"0"))}}).call(this,D(1))},function(le,e){var D,O,r=le.exports={};function P(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function I(l){if(D===setTimeout)return setTimeout(l,0);if((D===P||!D)&&setTimeout)return D=setTimeout,setTimeout(l,0);try{return D(l,0)}catch{try{return D.call(null,l,0)}catch{return D.call(this,l,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:P}catch{D=P}try{O=typeof clearTimeout=="function"?clearTimeout:A}catch{O=A}})();var w,$=[],C=!1,S=-1;function v(){C&&w&&(C=!1,w.length?$=w.concat($):S=-1,$.length&&d())}function d(){if(!C){var l=I(v);C=!0;for(var f=$.length;f;){for(w=$,$=[];++S<f;)w&&w[S].run();S=-1,f=$.length}w=null,C=!1,function(u){if(O===clearTimeout)return clearTimeout(u);if((O===A||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(u);try{O(u)}catch{try{return O.call(null,u)}catch{return O.call(this,u)}}}(l)}}function g(l,f){this.fun=l,this.array=f}function m(){}r.nextTick=function(l){var f=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)f[u-1]=arguments[u];$.push(new g(l,f)),$.length!==1||C||I(d)},g.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=m,r.addListener=m,r.once=m,r.off=m,r.removeListener=m,r.removeAllListeners=m,r.emit=m,r.prependListener=m,r.prependOnceListener=m,r.listeners=function(l){return[]},r.binding=function(l){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(l){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(be[145],we([1,0]),function(le,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class O{constructor(I,w,$){this.level=I,this.key=w,this.value=$,this.forward=[]}}const r=void 0;class P{constructor(I,w=2**16){this.comparator=I,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new O(this.c,r,r)}get size(){return this.f}clear(){this.e=new O(this.c,r,r)}has(I){return!!P.g(this,I,this.comparator)}get(I){return P.g(this,I,this.comparator)?.value}set(I,w){return P.h(this,I,w,this.comparator)&&(this.f+=1),this}delete(I){const w=P.k(this,I,this.comparator);return w&&(this.f-=1),w}forEach(I,w){let $=this.e.forward[0];for(;$;)I.call(w,$.value,$.key,this),$=$.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",w=this.e.forward[0];for(;w;)I+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return I}static g(I,w,$){let C=I.e;for(let S=I.d-1;S>=0;S--)for(;C.forward[S]&&$(C.forward[S].key,w)<0;)C=C.forward[S];if(C=C.forward[0],C&&$(C.key,w)===0)return C}static h(I,w,$,C){const S=[];let v=I.e;for(let d=I.d-1;d>=0;d--){for(;v.forward[d]&&C(v.forward[d].key,w)<0;)v=v.forward[d];S[d]=v}if(v=v.forward[0],v&&C(v.key,w)===0)return v.value=$,!1;{const d=P.j(I);if(d>I.d){for(let g=I.d;g<d;g++)S[g]=I.e;I.d=d}v=new O(d,w,$);for(let g=0;g<d;g++)v.forward[g]=S[g].forward[g],S[g].forward[g]=v;return!0}}static j(I,w=.5){let $=1;for(;Math.random()<w&&$<I.c;)$+=1;return $}static k(I,w,$){const C=[];let S=I.e;for(let v=I.d-1;v>=0;v--){for(;S.forward[v]&&$(S.forward[v].key,w)<0;)S=S.forward[v];C[v]=S}if(S=S.forward[0],!S||$(S.key,w)!==0)return!1;for(let v=0;v<I.d&&C[v].forward[v]===S;v++)C[v].forward[v]=S.forward[v];for(;I.d>0&&I.e.forward[I.d-1]===r;)I.d-=1;return!0}}e.$pr=P}),define(be[58],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(P){return new O(P)}constructor(P){this.c=D&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Hd=O}),define(be[5],we([1,0,11,74,2,96,58]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.Event=void 0;const I=!1,w=!1;var $;(function(E){E.None=()=>r.$Qc.None;function k(X){if(w){const{onDidAddListener:H}=X,Q=g.create();let re=0;X.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),H?.()}}}function L(X,H){return te(X,()=>{},0,void 0,!0,void 0,H)}E.defer=L;function j(X){return(H,Q=null,re)=>{let de=!1,Ee;return Ee=X(Ce=>{if(!de)return Ee?Ee.dispose():de=!0,H.call(Q,Ce)},null,re),de&&Ee.dispose(),Ee}}E.once=j;function Y(X,H,Q){return he((re,de=null,Ee)=>X(Ce=>re.call(de,H(Ce)),null,Ee),Q)}E.map=Y;function ce(X,H,Q){return he((re,de=null,Ee)=>X(Ce=>{H(Ce),re.call(de,Ce)},null,Ee),Q)}E.forEach=ce;function x(X,H,Q){return he((re,de=null,Ee)=>X(Ce=>H(Ce)&&re.call(de,Ce),null,Ee),Q)}E.filter=x;function ne(X){return X}E.signal=ne;function ue(...X){return(H,Q=null,re)=>{const de=(0,r.$Nc)(...X.map(Ee=>Ee(Ce=>H.call(Q,Ce))));return ee(de,re)}}E.any=ue;function _(X,H,Q,re){let de=Q;return Y(X,Ee=>(de=H(de,Ee),de),re)}E.reduce=_;function he(X,H){let Q;const re={onWillAddFirstListener(){Q=X(de.fire,de)},onDidRemoveLastListener(){Q?.dispose()}};H||k(re);const de=new c(re);return H?.add(de),de.event}function ee(X,H){return H instanceof Array?H.push(X):H&&H.add(X),X}function te(X,H,Q=100,re=!1,de=!1,Ee,Ce){let Le,Ne,$e,ke=0,ye;const Te={leakWarningThreshold:Ee,onWillAddFirstListener(){Le=X(Xe=>{ke++,Ne=H(Ne,Xe),re&&!$e&&(Ue.fire(Ne),Ne=void 0),ye=()=>{const He=Ne;Ne=void 0,$e=void 0,(!re||ke>1)&&Ue.fire(He),ke=0},typeof Q=="number"?(clearTimeout($e),$e=setTimeout(ye,Q)):$e===void 0&&($e=0,queueMicrotask(ye))})},onWillRemoveListener(){de&&ke>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,Le.dispose()}};Ce||k(Te);const Ue=new c(Te);return Ce?.add(Ue),Ue.event}E.debounce=te;function W(X,H=0,Q){return E.debounce(X,(re,de)=>re?(re.push(de),re):[de],H,void 0,!0,void 0,Q)}E.accumulate=W;function K(X,H=(re,de)=>re===de,Q){let re=!0,de;return x(X,Ee=>{const Ce=re||!H(Ee,de);return re=!1,de=Ee,Ce},Q)}E.latch=K;function V(X,H,Q){return[E.filter(X,H,Q),E.filter(X,re=>!H(re),Q)]}E.split=V;function oe(X,H=!1,Q=[],re){let de=Q.slice(),Ee=X(Ne=>{de?de.push(Ne):Le.fire(Ne)});re&&re.add(Ee);const Ce=()=>{de?.forEach(Ne=>Le.fire(Ne)),de=null},Le=new c({onWillAddFirstListener(){Ee||(Ee=X(Ne=>Le.fire(Ne)),re&&re.add(Ee))},onDidAddFirstListener(){de&&(H?setTimeout(Ce):Ce())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return re&&re.add(Le),Le.event}E.buffer=oe;function me(X,H){return(re,de,Ee)=>{const Ce=H(new U);return X(function(Le){const Ne=Ce.evaluate(Le);Ne!==se&&re.call(de,Ne)},void 0,Ee)}}E.chain=me;const se=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(H){return this.f.push(H),this}forEach(H){return this.f.push(Q=>(H(Q),Q)),this}filter(H){return this.f.push(Q=>H(Q)?Q:se),this}reduce(H,Q){let re=Q;return this.f.push(de=>(re=H(re,de),re)),this}latch(H=(Q,re)=>Q===re){let Q=!0,re;return this.f.push(de=>{const Ee=Q||!H(de,re);return Q=!1,re=de,Ee?de:se}),this}evaluate(H){for(const Q of this.f)if(H=Q(H),H===se)break;return H}}function Z(X,H,Q=re=>re){const re=(...Le)=>Ce.fire(Q(...Le)),de=()=>X.on(H,re),Ee=()=>X.removeListener(H,re),Ce=new c({onWillAddFirstListener:de,onDidRemoveLastListener:Ee});return Ce.event}E.fromNodeEventEmitter=Z;function R(X,H,Q=re=>re){const re=(...Le)=>Ce.fire(Q(...Le)),de=()=>X.addEventListener(H,re),Ee=()=>X.removeEventListener(H,re),Ce=new c({onWillAddFirstListener:de,onDidRemoveLastListener:Ee});return Ce.event}E.fromDOMEventEmitter=R;function F(X){return new Promise(H=>j(X)(H))}E.toPromise=F;function G(X){const H=new c;return X.then(Q=>{H.fire(Q)},()=>{H.fire(void 0)}).finally(()=>{H.dispose()}),H.event}E.fromPromise=G;function T(X,H){return H(void 0),X(Q=>H(Q))}E.runAndSubscribe=T;function q(X,H){let Q=null;function re(Ee){Q?.dispose(),Q=new r.$Pc,H(Ee,Q)}re(void 0);const de=X(Ee=>re(Ee));return(0,r.$Oc)(()=>{de.dispose(),Q?.dispose()})}E.runAndSubscribeWithStore=q;class z{constructor(H,Q){this._observable=H,this.f=0,this.g=!1;const re={onWillAddFirstListener:()=>{H.addObserver(this)},onDidRemoveLastListener:()=>{H.removeObserver(this)}};Q||k(re),this.emitter=new c(re),Q&&Q.add(this.emitter)}beginUpdate(H){this.f++}handlePossibleChange(H){}handleChange(H,Q){this.g=!0}endUpdate(H){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(X,H){return new z(X,H).emitter.event}E.fromObservable=ie;function B(X){return H=>{let Q=0,re=!1;const de={beginUpdate(){Q++},endUpdate(){Q--,Q===0&&(X.reportChanges(),re&&(re=!1,H()))},handlePossibleChange(){},handleChange(){re=!0}};return X.addObserver(de),X.reportChanges(),{dispose(){X.removeObserver(de)}}}}E.fromObservableLight=B})($||(e.Event=$={}));class C{static{this.all=new Set}static{this.f=0}constructor(k){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${k}_${C.f++}`,C.all.add(this)}start(k){this.g=new A.$Hd,this.listenerCount=k}stop(){if(this.g){const k=this.g.elapsed();this.durations.push(k),this.elapsedOverall+=k,this.invocationCount+=1,this.g=void 0}}}e.$Jd=C;let S=-1;function v(E){const k=S;return S=E,{dispose(){S=k}}}e.$Kd=v;class d{constructor(k,L=Math.random().toString(18).slice(2,5)){this.threshold=k,this.name=L,this.g=0}dispose(){this.f?.clear()}check(k,L){const j=this.threshold;if(j<=0||L<j)return;this.f||(this.f=new Map);const Y=this.f.get(k.value)||0;if(this.f.set(k.value,Y+1),this.g-=1,this.g<=0){this.g=j*.5;let ce,x=0;for(const[ne,ue]of this.f)(!ce||x<ue)&&(ce=ne,x=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${x}):`),console.warn(ce)}return()=>{const ce=this.f.get(k.value)||0;this.f.set(k.value,ce-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor(k){this.value=k}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class l{constructor(k){this.value=k,this.id=m++}}const f=2,u=(E,k)=>{if(E instanceof l)k(E);else for(let L=0;L<E.length;L++){const j=E[L];j&&k(j)}};class c{constructor(k){this.x=0,this.f=k,this.g=S>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(I){const k=this.t;queueMicrotask(()=>{u(k,L=>L.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(k,L,j)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$Qc.None;if(this.m)return r.$Qc.None;L&&(k=k.bind(L));const Y=new l(k);let ce,x;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(Y.stack=g.create(),ce=this.g.check(Y.stack,this.x+1)),I&&(Y.stack=x??g.create()),this.t?this.t instanceof l?(this.u??=new h,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.x++;const ne=(0,r.$Oc)(()=>{ce?.(),this.y(Y)});return j instanceof r.$Pc?j.add(ne):Array.isArray(j)&&j.push(ne),ne},this.q}y(k){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const L=this.t,j=L.indexOf(k);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,L[j]=void 0;const Y=this.u.current===this;if(this.x*f<=L.length){let ce=0;for(let x=0;x<L.length;x++)L[x]?L[ce++]=L[x]:Y&&(this.u.end--,ce<this.u.i&&this.u.i--);L.length=ce}}z(k,L){if(!k)return;const j=this.f?.onListenerError||D.$Y;if(!j){k.value(L);return}try{k.value(L)}catch(Y){j(Y)}}A(k){const L=k.current.t;for(;k.i<k.end;)this.z(L[k.i++],k.value);k.reset()}fire(k){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof l)this.z(this.t,k);else{const L=this.u;L.enqueue(this,k,this.t.length),this.A(L)}this.j?.stop()}hasListeners(){return this.x>0}}e.$Ld=c;const y=()=>new h;e.$Md=y;class h{constructor(){this.i=-1,this.end=0}enqueue(k,L,j){this.i=0,this.end=j,this.current=k,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends c{async fireAsync(k,L,j){if(this.t)for(this.h||(this.h=new P.$Zc),u(this.t,Y=>this.h.push([Y.value,k]));this.h.size>0&&!L.isCancellationRequested;){const[Y,ce]=this.h.shift(),x=[],ne={...ce,token:L,waitUntil:ue=>{if(Object.isFrozen(x))throw new Error("waitUntil can NOT be called asynchronous");j&&(ue=j(ue,Y)),x.push(ue)}};try{Y(ne)}catch(ue){(0,D.$Y)(ue);continue}Object.freeze(x),await Promise.allSettled(x).then(ue=>{for(const _ of ue)_.status==="rejected"&&(0,D.$Y)(_.reason)})}}}e.$Nd=t;class s extends c{get isPaused(){return this.h!==0}constructor(k){super(k),this.h=0,this.s=new P.$Zc,this.w=k?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const k=Array.from(this.s);this.s.clear(),super.fire(this.w(k))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(k){this.x&&(this.h!==0?this.s.push(k):super.fire(k))}}e.$Od=s;class o extends s{constructor(k){super(k),this.k=k.delay??100}fire(k){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(k)}}e.$Pd=o;class i extends c{constructor(k){super(k),this.h=[],this.k=k?.merge}fire(k){this.hasListeners()&&(this.h.push(k),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$Qd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(k){const L={event:k,listener:null};this.h.push(L),this.g&&this.m(L);const j=()=>{this.g&&this.o(L);const Y=this.h.indexOf(L);this.h.splice(Y,1)};return(0,r.$Oc)((0,O.$bb)(j))}j(){this.g=!0,this.h.forEach(k=>this.m(k))}k(){this.g=!1,this.h.forEach(k=>this.o(k))}m(k){k.listener=k.event(L=>this.f.fire(L))}o(k){k.listener&&k.listener.dispose(),k.listener=null}dispose(){this.f.dispose()}}e.$Rd=n;class a{constructor(k,L,j,Y){this.f=new r.$Pc;const ce=this.f.add(new n),x=this.f.add(new r.$Yc);function ne(ue){x.set(ue,ce.add(Y(ue)))}for(const ue of k)ne(ue);this.f.add(L(ue=>{ne(ue)})),this.f.add(j(ue=>{x.deleteAndDispose(ue)})),this.event=ce.event}dispose(){this.f.dispose()}}e.$Sd=a;class b{constructor(){this.f=[]}wrapEvent(k){return(L,j,Y)=>k(ce=>{const x=this.f[this.f.length-1];x?x.push(()=>L.call(j,ce)):L.call(j,ce)},void 0,Y)}bufferEvents(k){const L=[];this.f.push(L);const j=k();return this.f.pop(),L.forEach(Y=>Y()),j}}e.$Td=b;class p{constructor(){this.f=!1,this.g=$.None,this.h=r.$Qc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(k){this.g=k,this.f&&(this.h.dispose(),this.h=k(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$Ud=p}),define(be[20],we([1,0,5]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vd=e.CancellationToken=void 0;const O=Object.freeze(function(I,w){const $=setTimeout(I.bind(w),0);return{dispose(){clearTimeout($)}}});var r;(function(I){function w($){return $===I.None||$===I.Cancelled||$ instanceof P?!0:!$||typeof $!="object"?!1:typeof $.isCancellationRequested=="boolean"&&typeof $.onCancellationRequested=="function"}I.isCancellationToken=w,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(r||(e.CancellationToken=r={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new D.$Ld),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(w){this.f=void 0,this.g=void 0,this.g=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=r.Cancelled}dispose(w=!1){w&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=r.None}}e.$Vd=A}),define(be[146],we([1,0,20]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.$ve=e.$ue=void 0;class O{constructor(I){this.b=I,this.a=null}get(){if(this.a)return this.a;const I=new D.$Vd,w=this.b(I.token);return this.a={promise:w,dispose:()=>{this.a=null,I.cancel(),I.dispose()}},this.a}}e.$ue=O;class r{constructor(I){this.c=I,this.a=void 0,this.b=void 0}get(I){const w=JSON.stringify(I);return this.b!==w&&(this.b=w,this.a=this.c(I)),this.a}}e.$ve=r;class P{get cachedValues(){return this.a}constructor(I){this.b=I,this.a=new Map}get(I){if(this.a.has(I))return this.a.get(I);const w=this.b(I);return this.a.set(I,w),w}}e.$we=P}),define(be[48],we([1,0,11,2]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=void 0;function r(y){const h=y;return h?typeof h.read=="function":!1}e.$Wd=r;function P(y){const h=y;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}e.$Xd=P;function A(y){const h=y;return h?P(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$Yd=A;function I(y,h){return new w(y,h)}e.$Zd=I;class w{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,D.$Y)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const o=s.indexOf(t);o>=0&&s.splice(o,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(y,h){const t=[];let s;for(;(s=y.read())!==null;)t.push(s);return h(t)}e.$1d=$;function C(y,h,t){const s=[];let o;for(;(o=y.read())!==null&&s.length<t;)s.push(o);return o===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return y.read()}}}e.$2d=C;function S(y,h){return new Promise((t,s)=>{const o=[];v(y,{onData:i=>{h&&o.push(i)},onError:i=>{h?s(i):t(void 0)},onEnd:()=>{t(h?h(o):void 0)}})})}e.$3d=S;function v(y,h,t){y.on("error",s=>{t?.isCancellationRequested||h.onError(s)}),y.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),y.on("data",s=>{t?.isCancellationRequested||h.onData(s)})}e.$4d=v;function d(y,h){return new Promise((t,s)=>{const o=new O.$Pc,i=[],n=p=>{if(i.push(p),i.length>h)return o.dispose(),y.pause(),t({stream:y,buffer:i,ended:!1})},a=p=>(o.dispose(),s(p)),b=()=>(o.dispose(),t({stream:y,buffer:i,ended:!0}));o.add((0,O.$Oc)(()=>y.removeListener("error",a))),y.on("error",a),o.add((0,O.$Oc)(()=>y.removeListener("end",b))),y.on("end",b),o.add((0,O.$Oc)(()=>y.removeListener("data",n))),y.on("data",n)})}e.$5d=d;function g(y,h){const t=I(h);return t.end(y),t}e.$6d=g;function m(){const y=I(()=>{throw new Error("not supported")});return y.end(),y}e.$7d=m;function l(y){let h=!1;return{read:()=>h?null:(h=!0,y)}}e.$8d=l;function f(y,h,t){const s=I(t);return v(y,{onData:o=>s.write(h.data(o)),onError:o=>s.error(h.error?h.error(o):o),onEnd:()=>s.end()}),s}e.$9d=f;function u(y,h,t){let s=!1;return{read:()=>{const o=h.read();return s?o:(s=!0,o!==null?t([y,o]):y)}}}e.$0d=u;function c(y,h,t){let s=!1;const o=I(t);return v(h,{onData:i=>s?o.write(i):(s=!0,o.write(t([y,i]))),onError:i=>o.error(i),onEnd:()=>{s||(s=!0,o.write(y)),o.end()}}),o}e.$$d=c}),define(be[15],we([1,0,95,48]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=void 0;const r=typeof Buffer<"u",P=new D.$T(()=>new Uint8Array(256));let A,I;class w{static alloc(L){return r?new w(Buffer.allocUnsafe(L)):new w(new Uint8Array(L))}static wrap(L){return r&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new w(L)}static fromString(L,j){return!(j?.dontUseNodeBuffer||!1)&&r?new w(Buffer.from(L)):(A||(A=new TextEncoder),new w(A.encode(L)))}static fromByteArray(L){const j=w.alloc(L.length);for(let Y=0,ce=L.length;Y<ce;Y++)j.buffer[Y]=L[Y];return j}static concat(L,j){if(typeof j>"u"){j=0;for(let x=0,ne=L.length;x<ne;x++)j+=L[x].byteLength}const Y=w.alloc(j);let ce=0;for(let x=0,ne=L.length;x<ne;x++){const ue=L[x];Y.set(ue,ce),ce+=ue.byteLength}return Y}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=w.alloc(this.byteLength);return L.set(this),L}toString(){return r?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(L,j){return new w(this.buffer.subarray(L,j))}set(L,j){if(L instanceof w)this.buffer.set(L.buffer,j);else if(L instanceof Uint8Array)this.buffer.set(L,j);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),j);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return v(this.buffer,L)}writeUInt32BE(L,j){d(this.buffer,L,j)}readUInt32LE(L){return g(this.buffer,L)}writeUInt32LE(L,j){m(this.buffer,L,j)}readUInt8(L){return l(this.buffer,L)}writeUInt8(L,j){f(this.buffer,L,j)}indexOf(L,j=0){return $(this.buffer,L instanceof w?L.buffer:L,j)}}e.$_d=w;function $(k,L,j=0){const Y=L.byteLength,ce=k.byteLength;if(Y===0)return 0;if(Y===1)return k.indexOf(L[0]);if(Y>ce-j)return-1;const x=P.value;x.fill(L.length);for(let he=0;he<L.length;he++)x[L[he]]=L.length-he-1;let ne=j+L.length-1,ue=ne,_=-1;for(;ne<ce;)if(k[ne]===L[ue]){if(ue===0){_=ne;break}ne--,ue--}else ne+=Math.max(L.length-ue,x[k[ne]]),ue=L.length-1;return _}e.$ae=$;function C(k,L){return k[L+0]<<0>>>0|k[L+1]<<8>>>0}e.$be=C;function S(k,L,j){k[j+0]=L&255,L=L>>>8,k[j+1]=L&255}e.$ce=S;function v(k,L){return k[L]*2**24+k[L+1]*2**16+k[L+2]*2**8+k[L+3]}e.$de=v;function d(k,L,j){k[j+3]=L,L=L>>>8,k[j+2]=L,L=L>>>8,k[j+1]=L,L=L>>>8,k[j]=L}e.$ee=d;function g(k,L){return k[L+0]<<0>>>0|k[L+1]<<8>>>0|k[L+2]<<16>>>0|k[L+3]<<24>>>0}e.$fe=g;function m(k,L,j){k[j+0]=L&255,L=L>>>8,k[j+1]=L&255,L=L>>>8,k[j+2]=L&255,L=L>>>8,k[j+3]=L&255}e.$ge=m;function l(k,L){return k[L]}e.$he=l;function f(k,L,j){k[j]=L}e.$ie=f;function u(k){return O.$1d(k,L=>w.concat(L))}e.$je=u;function c(k){return O.$8d(k)}e.$ke=c;function y(k){return O.$3d(k,L=>w.concat(L))}e.$le=y;async function h(k){return k.ended?w.concat(k.buffer):w.concat([...k.buffer,await y(k.stream)])}e.$me=h;function t(k){return O.$6d(k,L=>w.concat(L))}e.$ne=t;function s(k){return O.$9d(k,{data:L=>typeof L=="string"?w.fromString(L):w.wrap(L)},L=>w.concat(L))}e.$oe=s;function o(k){return O.$Zd(L=>w.concat(L),k)}e.$pe=o;function i(k,L){return O.$0d(k,L,j=>w.concat(j))}e.$qe=i;function n(k,L){return O.$$d(k,L,j=>w.concat(j))}e.$re=n;function a(k){let L=0,j=0,Y=0;const ce=new Uint8Array(Math.floor(k.length/4*3)),x=ue=>{switch(j){case 3:ce[Y++]=L|ue,j=0;break;case 2:ce[Y++]=L|ue>>>2,L=ue<<6,j=3;break;case 1:ce[Y++]=L|ue>>>4,L=ue<<4,j=2;break;default:L=ue<<2,j=1}};for(let ue=0;ue<k.length;ue++){const _=k.charCodeAt(ue);if(_>=65&&_<=90)x(_-65);else if(_>=97&&_<=122)x(_-97+26);else if(_>=48&&_<=57)x(_-48+52);else if(_===43||_===45)x(62);else if(_===47||_===95)x(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ue]}`)}}const ne=Y;for(;j>0;)x(0);return w.wrap(ce).slice(0,ne)}e.$se=a;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:k},L=!0,j=!1){const Y=j?p:b;let ce="";const x=k.byteLength%3;let ne=0;for(;ne<k.byteLength-x;ne+=3){const ue=k[ne+0],_=k[ne+1],he=k[ne+2];ce+=Y[ue>>>2],ce+=Y[(ue<<4|_>>>4)&63],ce+=Y[(_<<2|he>>>6)&63],ce+=Y[he&63]}if(x===1){const ue=k[ne+0];ce+=Y[ue>>>2],ce+=Y[ue<<4&63],L&&(ce+="==")}else if(x===2){const ue=k[ne+0],_=k[ne+1];ce+=Y[ue>>>2],ce+=Y[(ue<<4|_>>>4)&63],ce+=Y[_<<2&63],L&&(ce+="=")}return ce}e.$te=E}),define(be[17],we([1,0,146,95]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vf=e.$uf=e.$tf=e.$sf=e.GraphemeBreakType=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=void 0;function r(ge){return!ge||typeof ge!="string"?!0:ge.trim().length===0}e.$ze=r;const P=/{(\d+)}/g;function A(ge,...Se){return Se.length===0?ge:ge.replace(P,function(Ie,Fe){const je=parseInt(Fe,10);return isNaN(je)||je<0||je>=Se.length?Ie:Se[je]})}e.$Ae=A;const I=/{([^}]+)}/g;function w(ge,Se){return ge.replace(I,(Ie,Fe)=>Se[Fe]??Ie)}e.$Be=w;function $(ge){return ge.replace(/[<>&]/g,function(Se){switch(Se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Se}})}e.$Ce=$;function C(ge){return ge.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$De=C;function S(ge,Se){let Ie=0;const Fe=Se.charCodeAt(0);for(let je=ge.length-1;je>=0;je--)ge.charCodeAt(je)===Fe&&Ie++;return Ie}e.$Ee=S;function v(ge,Se,Ie="\u2026"){return ge.length<=Se?ge:`${ge.substr(0,Se)}${Ie}`}e.$Fe=v;function d(ge,Se=" "){const Ie=g(ge,Se);return m(Ie,Se)}e.$Ge=d;function g(ge,Se){if(!ge||!Se)return ge;const Ie=Se.length;if(Ie===0||ge.length===0)return ge;let Fe=0;for(;ge.indexOf(Se,Fe)===Fe;)Fe=Fe+Ie;return ge.substring(Fe)}e.$He=g;function m(ge,Se){if(!ge||!Se)return ge;const Ie=Se.length,Fe=ge.length;if(Ie===0||Fe===0)return ge;let je=Fe,Ke=-1;for(;Ke=ge.lastIndexOf(Se,je-1),!(Ke===-1||Ke+Ie!==je);){if(Ke===0)return"";je=Ke}return ge.substring(0,je)}e.$Ie=m;function l(ge){return ge.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Je=l;function f(ge){return ge.replace(/\*/g,"")}e.$Ke=f;function u(ge,Se,Ie={}){if(!ge)throw new Error("Cannot create regex from empty string");Se||(ge=C(ge)),Ie.wholeWord&&(/\B/.test(ge.charAt(0))||(ge="\\b"+ge),/\B/.test(ge.charAt(ge.length-1))||(ge=ge+"\\b"));let Fe="";return Ie.global&&(Fe+="g"),Ie.matchCase||(Fe+="i"),Ie.multiline&&(Fe+="m"),Ie.unicode&&(Fe+="u"),new RegExp(ge,Fe)}e.$Le=u;function c(ge){return ge.source==="^"||ge.source==="^$"||ge.source==="$"||ge.source==="^\\s*$"?!1:!!(ge.exec("")&&ge.lastIndex===0)}e.$Me=c;function y(ge){return ge.split(/\r\n|\r|\n/)}e.$Ne=y;function h(ge){for(let Se=0,Ie=ge.length;Se<Ie;Se++){const Fe=ge.charCodeAt(Se);if(Fe!==32&&Fe!==9)return Se}return-1}e.$Oe=h;function t(ge,Se=0,Ie=ge.length){for(let Fe=Se;Fe<Ie;Fe++){const je=ge.charCodeAt(Fe);if(je!==32&&je!==9)return ge.substring(Se,Fe)}return ge.substring(Se,Ie)}e.$Pe=t;function s(ge,Se=ge.length-1){for(let Ie=Se;Ie>=0;Ie--){const Fe=ge.charCodeAt(Ie);if(Fe!==32&&Fe!==9)return Ie}return-1}e.$Qe=s;function o(ge,Se,Ie){const Fe=[];let je=0;for(const Ke of ge.matchAll(Se)){if(Fe.push(ge.slice(je,Ke.index)),Ke.index===void 0)throw new Error("match.index should be defined");je=Ke.index+Ke[0].length,Fe.push(Ie(Ke[0],...Ke.slice(1),Ke.index,ge,Ke.groups))}return Fe.push(ge.slice(je)),Promise.all(Fe).then(Ke=>Ke.join(""))}e.$Re=o;function i(ge,Se){return ge<Se?-1:ge>Se?1:0}e.$Se=i;function n(ge,Se,Ie=0,Fe=ge.length,je=0,Ke=Se.length){for(;Ie<Fe&&je<Ke;Ie++,je++){const Qe=ge.charCodeAt(Ie),We=Se.charCodeAt(je);if(Qe<We)return-1;if(Qe>We)return 1}const Be=Fe-Ie,qe=Ke-je;return Be<qe?-1:Be>qe?1:0}e.$Te=n;function a(ge,Se){return b(ge,Se,0,ge.length,0,Se.length)}e.$Ue=a;function b(ge,Se,Ie=0,Fe=ge.length,je=0,Ke=Se.length){for(;Ie<Fe&&je<Ke;Ie++,je++){let Qe=ge.charCodeAt(Ie),We=Se.charCodeAt(je);if(Qe===We)continue;if(Qe>=128||We>=128)return n(ge.toLowerCase(),Se.toLowerCase(),Ie,Fe,je,Ke);E(Qe)&&(Qe-=32),E(We)&&(We-=32);const Ye=Qe-We;if(Ye!==0)return Ye}const Be=Fe-Ie,qe=Ke-je;return Be<qe?-1:Be>qe?1:0}e.$Ve=b;function p(ge){return ge>=48&&ge<=57}e.$We=p;function E(ge){return ge>=97&&ge<=122}e.$Xe=E;function k(ge){return ge>=65&&ge<=90}e.$Ye=k;function L(ge,Se){return ge.length===Se.length&&b(ge,Se)===0}e.$Ze=L;function j(ge,Se){const Ie=Se.length;return Se.length>ge.length?!1:b(ge,Se,0,Ie)===0}e.$1e=j;function Y(ge,Se){const Ie=Math.min(ge.length,Se.length);let Fe;for(Fe=0;Fe<Ie;Fe++)if(ge.charCodeAt(Fe)!==Se.charCodeAt(Fe))return Fe;return Ie}e.$2e=Y;function ce(ge,Se){const Ie=Math.min(ge.length,Se.length);let Fe;const je=ge.length-1,Ke=Se.length-1;for(Fe=0;Fe<Ie;Fe++)if(ge.charCodeAt(je-Fe)!==Se.charCodeAt(Ke-Fe))return Fe;return Ie}e.$3e=ce;function x(ge){return 55296<=ge&&ge<=56319}e.$4e=x;function ne(ge){return 56320<=ge&&ge<=57343}e.$5e=ne;function ue(ge,Se){return(ge-55296<<10)+(Se-56320)+65536}e.$6e=ue;function _(ge,Se,Ie){const Fe=ge.charCodeAt(Ie);if(x(Fe)&&Ie+1<Se){const je=ge.charCodeAt(Ie+1);if(ne(je))return ue(Fe,je)}return Fe}e.$7e=_;function he(ge,Se){const Ie=ge.charCodeAt(Se-1);if(ne(Ie)&&Se>1){const Fe=ge.charCodeAt(Se-2);if(x(Fe))return ue(Fe,Ie)}return Ie}class ee{get offset(){return this.e}constructor(Se,Ie=0){this.c=Se,this.d=Se.length,this.e=Ie}setOffset(Se){this.e=Se}prevCodePoint(){const Se=he(this.c,this.e);return this.e-=Se>=65536?2:1,Se}nextCodePoint(){const Se=_(this.c,this.d,this.e);return this.e+=Se>=65536?2:1,Se}eol(){return this.e>=this.d}}e.$8e=ee;class te{get offset(){return this.c.offset}constructor(Se,Ie=0){this.c=new ee(Se,Ie)}nextGraphemeLength(){const Se=ke.getInstance(),Ie=this.c,Fe=Ie.offset;let je=Se.getGraphemeBreakType(Ie.nextCodePoint());for(;!Ie.eol();){const Ke=Ie.offset,Be=Se.getGraphemeBreakType(Ie.nextCodePoint());if(Ne(je,Be)){Ie.setOffset(Ke);break}je=Be}return Ie.offset-Fe}prevGraphemeLength(){const Se=ke.getInstance(),Ie=this.c,Fe=Ie.offset;let je=Se.getGraphemeBreakType(Ie.prevCodePoint());for(;Ie.offset>0;){const Ke=Ie.offset,Be=Se.getGraphemeBreakType(Ie.prevCodePoint());if(Ne(Be,je)){Ie.setOffset(Ke);break}je=Be}return Fe-Ie.offset}eol(){return this.c.eol()}}e.$9e=te;function W(ge,Se){return new te(ge,Se).nextGraphemeLength()}e.$0e=W;function K(ge,Se){return new te(ge,Se).prevGraphemeLength()}e.$$e=K;function V(ge,Se){Se>0&&ne(ge.charCodeAt(Se))&&Se--;const Ie=Se+W(ge,Se);return[Ie-K(ge,Ie),Ie]}e.$_e=V;function oe(ge){const Se=new te(ge);let Ie=0;for(;!Se.eol();)Ie++,Se.nextGraphemeLength();return Ie}e.$af=oe;let me;function se(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(ge){return me||(me=se()),me.test(ge)}e.$bf=U;const Z=/^[\t\n\r\x20-\x7E]*$/;function R(ge){return Z.test(ge)}e.$cf=R,e.$df=/[\u2028\u2029]/;function F(ge){return e.$df.test(ge)}e.$ef=F;function G(ge){return ge>=11904&&ge<=55215||ge>=63744&&ge<=64255||ge>=65281&&ge<=65374}e.$ff=G;function T(ge){return ge>=127462&&ge<=127487||ge===8986||ge===8987||ge===9200||ge===9203||ge>=9728&&ge<=10175||ge===11088||ge===11093||ge>=127744&&ge<=128591||ge>=128640&&ge<=128764||ge>=128992&&ge<=129008||ge>=129280&&ge<=129535||ge>=129648&&ge<=129782}e.$gf=T;function q(ge,Se){if(ge.length<Se)return ge;const Ie=/\b/g;let Fe=0;for(;Ie.test(ge)&&!(ge.length-Ie.lastIndex<Se);)Fe=Ie.lastIndex,Ie.lastIndex+=1;return ge.substring(Fe).replace(/^\s/,"")}e.$hf=q;const z=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function B(ge){return ge&&(ge=ge.replace(z,"").replace(ie,"")),ge}e.$if=B,e.$jf=String.fromCharCode(65279);function X(ge){return!!(ge&&ge.length>0&&ge.charCodeAt(0)===65279)}e.$kf=X;function H(ge){return X(ge)?ge.substr(1):ge}e.$lf=H;function Q(ge,Se){if(!ge||!Se||ge.length<Se.length)return!1;const Ie=Se.length,Fe=ge.toLowerCase();let je=0,Ke=-1;for(;je<Ie;){const Be=Fe.indexOf(Se[je],Ke+1);if(Be<0)return!1;Ke=Be,je++}return!0}e.$mf=Q;function re(ge,Se=!1){return ge?(Se&&(ge=ge.replace(/\\./g,"")),ge.toLowerCase()!==ge):!1}e.$nf=re;function de(ge){return ge.charAt(0).toUpperCase()+ge.slice(1)}e.$of=de;function Ee(ge,Se=1){if(Se===0)return"";let Ie=-1;do Ie=ge.indexOf(`
`,Ie+1),Se--;while(Se>0&&Ie>=0);return Ie===-1?ge:(ge[Ie-1]==="\r"&&Ie--,ge.substr(0,Ie))}e.$pf=Ee;function Ce(ge){return ge=ge%(2*26),ge<26?String.fromCharCode(97+ge):String.fromCharCode(65+ge-26)}e.$qf=Ce;function Le(ge){return ke.getInstance().getGraphemeBreakType(ge)}e.$rf=Le;function Ne(ge,Se){return ge===0?Se!==5&&Se!==7:ge===2&&Se===3?!1:ge===4||ge===2||ge===3||Se===4||Se===2||Se===3?!0:!(ge===8&&(Se===8||Se===9||Se===11||Se===12)||(ge===11||ge===9)&&(Se===9||Se===10)||(ge===12||ge===10)&&Se===10||Se===5||Se===13||Se===7||ge===1||ge===13&&Se===14||ge===6&&Se===6)}var $e;(function(ge){ge[ge.Other=0]="Other",ge[ge.Prepend=1]="Prepend",ge[ge.CR=2]="CR",ge[ge.LF=3]="LF",ge[ge.Control=4]="Control",ge[ge.Extend=5]="Extend",ge[ge.Regional_Indicator=6]="Regional_Indicator",ge[ge.SpacingMark=7]="SpacingMark",ge[ge.L=8]="L",ge[ge.V=9]="V",ge[ge.T=10]="T",ge[ge.LV=11]="LV",ge[ge.LVT=12]="LVT",ge[ge.ZWJ=13]="ZWJ",ge[ge.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=ye()}getGraphemeBreakType(Se){if(Se<32)return Se===10?3:Se===13?2:4;if(Se<127)return 0;const Ie=this.d,Fe=Ie.length/3;let je=1;for(;je<=Fe;)if(Se<Ie[3*je])je=2*je;else if(Se>Ie[3*je+1])je=2*je+1;else return Ie[3*je+2];return 0}}function ye(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(ge,Se){if(ge===0)return 0;const Ie=Ue(ge,Se);if(Ie!==void 0)return Ie;const Fe=new ee(Se,ge);return Fe.prevCodePoint(),Fe.offset}e.$sf=Te;function Ue(ge,Se){const Ie=new ee(Se,ge);let Fe=Ie.prevCodePoint();for(;Xe(Fe)||Fe===65039||Fe===8419;){if(Ie.offset===0)return;Fe=Ie.prevCodePoint()}if(!T(Fe))return;let je=Ie.offset;return je>0&&Ie.prevCodePoint()===8205&&(je=Ie.offset),je}function Xe(ge){return 127995<=ge&&ge<=127999}var He;(function(ge){ge[ge.zwj=8205]="zwj",ge[ge.emojiVariantSelector=65039]="emojiVariantSelector",ge[ge.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),e.$tf="\xA0";class Ze{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$ve(Se=>{function Ie(Ye){const it=new Map;for(let _e=0;_e<Ye.length;_e+=2)it.set(Ye[_e],Ye[_e+1]);return it}function Fe(Ye,it){const _e=new Map(Ye);for(const[st,ot]of it)_e.set(st,ot);return _e}function je(Ye,it){if(!Ye)return it;const _e=new Map;for(const[st,ot]of Ye)it.has(st)&&_e.set(st,ot);return _e}const Ke=this.c.value;let Be=Se.filter(Ye=>!Ye.startsWith("_")&&Ye in Ke);Be.length===0&&(Be=["_default"]);let qe;for(const Ye of Be){const it=Ie(Ke[Ye]);qe=je(qe,it)}const Qe=Ie(Ke._common),We=Fe(Qe,qe);return new Ze(We)})}static getInstance(Se){return Ze.d.get(Array.from(Se))}static{this.e=new O.$T(()=>Object.keys(Ze.c.value).filter(Se=>!Se.startsWith("_")))}static getLocales(){return Ze.e.value}constructor(Se){this.f=Se}isAmbiguous(Se){return this.f.has(Se)}getPrimaryConfusable(Se){return this.f.get(Se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$uf=Ze;class Je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Je.c())),this.d}static isInvisibleCharacter(Se){return Je.e().has(Se)}static get codePoints(){return Je.e()}}e.$vf=Je}),define(be[147],we([1,0,26,17]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.FuzzyScore=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.or=void 0;function r(...H){return function(Q,re){for(let de=0,Ee=H.length;de<Ee;de++){const Ce=H[de](Q,re);if(Ce)return Ce}return null}}e.or=r,e.$yj=P.bind(void 0,!1),e.$zj=P.bind(void 0,!0);function P(H,Q,re){if(!re||re.length<Q.length)return null;let de;return H?de=O.$1e(re,Q):de=re.indexOf(Q)===0,de?Q.length>0?[{start:0,end:Q.length}]:[]:null}function A(H,Q){const re=Q.toLowerCase().indexOf(H.toLowerCase());return re===-1?null:[{start:re,end:re+H.length}]}e.$Aj=A;function I(H,Q){return w(H.toLowerCase(),Q.toLowerCase(),0,0)}e.$Bj=I;function w(H,Q,re,de){if(re===H.length)return[];if(de===Q.length)return null;if(H[re]===Q[de]){let Ee=null;return(Ee=w(H,Q,re+1,de+1))?f({start:de,end:de+1},Ee):null}return w(H,Q,re,de+1)}function $(H){return 97<=H&&H<=122}function C(H){return 65<=H&&H<=90}e.$Cj=C;function S(H){return 48<=H&&H<=57}function v(H){return H===32||H===9||H===10||H===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(H=>d.add(H.charCodeAt(0)));function g(H){return v(H)||d.has(H)}function m(H,Q){return H===Q||g(H)&&g(Q)}function l(H){return $(H)||C(H)||S(H)}function f(H,Q){return Q.length===0?Q=[H]:H.end===Q[0].start?Q[0].start=H.start:Q.unshift(H),Q}function u(H,Q){for(let re=Q;re<H.length;re++){const de=H.charCodeAt(re);if(C(de)||S(de)||re>0&&!l(H.charCodeAt(re-1)))return re}return H.length}function c(H,Q,re,de){if(re===H.length)return[];if(de===Q.length)return null;if(H[re]!==Q[de].toLowerCase())return null;{let Ee=null,Ce=de+1;for(Ee=c(H,Q,re+1,de+1);!Ee&&(Ce=u(Q,Ce))<Q.length;)Ee=c(H,Q,re+1,Ce),Ce++;return Ee===null?null:f({start:de,end:de+1},Ee)}}function y(H){let Q=0,re=0,de=0,Ee=0,Ce=0;for(let ye=0;ye<H.length;ye++)Ce=H.charCodeAt(ye),C(Ce)&&Q++,$(Ce)&&re++,l(Ce)&&de++,S(Ce)&&Ee++;const Le=Q/H.length,Ne=re/H.length,$e=de/H.length,ke=Ee/H.length;return{upperPercent:Le,lowerPercent:Ne,alphaPercent:$e,numericPercent:ke}}function h(H){const{upperPercent:Q,lowerPercent:re}=H;return re===0&&Q>.6}function t(H){const{upperPercent:Q,lowerPercent:re,alphaPercent:de,numericPercent:Ee}=H;return re>.2&&Q<.8&&de>.6&&Ee<.2}function s(H){let Q=0,re=0,de=0,Ee=0;for(let Ce=0;Ce<H.length;Ce++)de=H.charCodeAt(Ce),C(de)&&Q++,$(de)&&re++,v(de)&&Ee++;return(Q===0||re===0)&&Ee===0?H.length<=30:Q<=5}function o(H,Q){if(!Q||(Q=Q.trim(),Q.length===0)||!s(H)||Q.length>60)return null;const re=y(Q);if(!t(re)){if(!h(re))return null;Q=Q.toLowerCase()}let de=null,Ee=0;for(H=H.toLowerCase();Ee<Q.length&&(de=c(H,Q,0,Ee))===null;)Ee=u(Q,Ee+1);return de}e.$Dj=o;function i(H,Q,re=!1){if(!Q||Q.length===0)return null;let de=null,Ee=0;for(H=H.toLowerCase(),Q=Q.toLowerCase();Ee<Q.length&&(de=n(H,Q,0,Ee,re))===null;)Ee=a(Q,Ee+1);return de}e.$Ej=i;function n(H,Q,re,de,Ee){if(re===H.length)return[];if(de===Q.length)return null;if(m(H.charCodeAt(re),Q.charCodeAt(de))){let Ce=null,Le=de+1;if(Ce=n(H,Q,re+1,de+1,Ee),!Ee)for(;!Ce&&(Le=a(Q,Le))<Q.length;)Ce=n(H,Q,re+1,Le,Ee),Le++;return Ce?H.charCodeAt(re)!==Q.charCodeAt(de)?Ce:f({start:de,end:de+1},Ce):null}else return null}function a(H,Q){for(let re=Q;re<H.length;re++)if(g(H.charCodeAt(re))||re>0&&g(H.charCodeAt(re-1)))return re;return H.length}const b=r(e.$zj,o,A),p=r(e.$zj,o,I),E=new D.$Bc(1e4);function k(H,Q,re=!1){if(typeof H!="string"||typeof Q!="string")return null;let de=E.get(H);de||(de=new RegExp(O.$Je(H),"i"),E.set(H,de));const Ee=de.exec(Q);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:re?p(H,Q):b(H,Q)}e.$Fj=k;function L(H,Q){const re=G(H,H.toLowerCase(),0,Q,Q.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return re?Y(re):null}e.$Gj=L;function j(H,Q,re,de,Ee,Ce){const Le=Math.min(13,H.length);for(;re<Le;re++){const Ne=G(H,Q,re,de,Ee,Ce,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Ne)return Ne}return[0,Ce]}e.$Hj=j;function Y(H){if(typeof H>"u")return[];const Q=[],re=H[1];for(let de=H.length-1;de>1;de--){const Ee=H[de]+re,Ce=Q[Q.length-1];Ce&&Ce.end===Ee?Ce.end=Ee+1:Q.push({start:Ee,end:Ee+1})}return Q}e.$Ij=Y;const ce=128;function x(){const H=[],Q=[];for(let re=0;re<=ce;re++)Q[re]=0;for(let re=0;re<=ce;re++)H.push(Q.slice(0));return H}function ne(H){const Q=[];for(let re=0;re<=H;re++)Q[re]=0;return Q}const ue=ne(2*ce),_=ne(2*ce),he=x(),ee=x(),te=x(),W=!1;function K(H,Q,re,de,Ee){function Ce(Ne,$e,ke=" "){for(;Ne.length<$e;)Ne=ke+Ne;return Ne}let Le=` |   |${de.split("").map(Ne=>Ce(Ne,3)).join("|")}
`;for(let Ne=0;Ne<=re;Ne++)Ne===0?Le+=" |":Le+=`${Q[Ne-1]}|`,Le+=H[Ne].slice(0,Ee+1).map($e=>Ce($e.toString(),3)).join("|")+`
`;return Le}function V(H,Q,re,de){H=H.substr(Q),re=re.substr(de),console.log(K(ee,H,H.length,re,re.length)),console.log(K(te,H,H.length,re,re.length)),console.log(K(he,H,H.length,re,re.length))}function oe(H,Q){if(Q<0||Q>=H.length)return!1;const re=H.codePointAt(Q);switch(re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!O.$gf(re)}}function me(H,Q){if(Q<0||Q>=H.length)return!1;switch(H.charCodeAt(Q)){case 32:case 9:return!0;default:return!1}}function se(H,Q,re){return Q[H]!==re[H]}function U(H,Q,re,de,Ee,Ce,Le=!1){for(;Q<re&&Ee<Ce;)H[Q]===de[Ee]&&(Le&&(ue[Q]=Ee),Q+=1),Ee+=1;return Q===re}e.$Jj=U;var Z;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(Z||(Z={}));var R;(function(H){H.Default=[-100,0];function Q(re){return!re||re.length===2&&re[0]===-100&&re[1]===0}H.isDefault=Q})(R||(e.FuzzyScore=R={}));class F{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Q,re){this.firstMatchCanBeWeak=Q,this.boostFullMatch=re}}e.$Kj=F;function G(H,Q,re,de,Ee,Ce,Le=F.default){const Ne=H.length>ce?ce:H.length,$e=de.length>ce?ce:de.length;if(re>=Ne||Ce>=$e||Ne-re>$e-Ce||!U(Q,re,Ne,Ee,Ce,$e,!0))return;T(Ne,$e,re,Ce,Q,Ee);let ke=1,ye=1,Te=re,Ue=Ce;const Xe=[!1];for(ke=1,Te=re;Te<Ne;ke++,Te++){const Se=ue[Te],Ie=_[Te],Fe=Te+1<Ne?_[Te+1]:$e;for(ye=Se-Ce+1,Ue=Se;Ue<Fe;ye++,Ue++){let je=Number.MIN_SAFE_INTEGER,Ke=!1;Ue<=Ie&&(je=q(H,Q,Te,re,de,Ee,Ue,$e,Ce,he[ke-1][ye-1]===0,Xe));let Be=0;je!==Number.MAX_SAFE_INTEGER&&(Ke=!0,Be=je+ee[ke-1][ye-1]);const qe=Ue>Se,Qe=qe?ee[ke][ye-1]+(he[ke][ye-1]>0?-5:0):0,We=Ue>Se+1&&he[ke][ye-1]>0,Ye=We?ee[ke][ye-2]+(he[ke][ye-2]>0?-5:0):0;if(We&&(!qe||Ye>=Qe)&&(!Ke||Ye>=Be))ee[ke][ye]=Ye,te[ke][ye]=3,he[ke][ye]=0;else if(qe&&(!Ke||Qe>=Be))ee[ke][ye]=Qe,te[ke][ye]=2,he[ke][ye]=0;else if(Ke)ee[ke][ye]=Be,te[ke][ye]=1,he[ke][ye]=he[ke-1][ye-1]+1;else throw new Error("not possible")}}if(W&&V(H,re,de,Ce),!Xe[0]&&!Le.firstMatchCanBeWeak)return;ke--,ye--;const He=[ee[ke][ye],Ce];let Ze=0,Je=0;for(;ke>=1;){let Se=ye;do{const Ie=te[ke][Se];if(Ie===3)Se=Se-2;else if(Ie===2)Se=Se-1;else break}while(Se>=1);Ze>1&&Q[re+ke-1]===Ee[Ce+ye-1]&&!se(Se+Ce-1,de,Ee)&&Ze+1>he[ke][Se]&&(Se=ye),Se===ye?Ze++:Ze=1,Je||(Je=Se),ke--,ye=Se-1,He.push(ye)}$e===Ne&&Le.boostFullMatch&&(He[0]+=2);const ge=Je-Ne;return He[0]-=ge,He}e.$Lj=G;function T(H,Q,re,de,Ee,Ce){let Le=H-1,Ne=Q-1;for(;Le>=re&&Ne>=de;)Ee[Le]===Ce[Ne]&&(_[Le]=Ne,Le--),Ne--}function q(H,Q,re,de,Ee,Ce,Le,Ne,$e,ke,ye){if(Q[re]!==Ce[Le])return Number.MIN_SAFE_INTEGER;let Te=1,Ue=!1;return Le===re-de?Te=H[re]===Ee[Le]?7:5:se(Le,Ee,Ce)&&(Le===0||!se(Le-1,Ee,Ce))?(Te=H[re]===Ee[Le]?7:5,Ue=!0):oe(Ce,Le)&&(Le===0||!oe(Ce,Le-1))?Te=5:(oe(Ce,Le-1)||me(Ce,Le-1))&&(Te=5,Ue=!0),Te>1&&re===de&&(ye[0]=!0),Ue||(Ue=se(Le,Ee,Ce)||oe(Ce,Le-1)||me(Ce,Le-1)),re===de?Le>$e&&(Te-=Ue?3:5):ke?Te+=Ue?2:0:Te+=Ue?0:1,Le+1===Ne&&(Te-=Ue?3:5),Te}function z(H,Q,re,de,Ee,Ce,Le){return B(H,Q,re,de,Ee,Ce,!0,Le)}e.$Mj=z;function ie(H,Q,re,de,Ee,Ce,Le){return B(H,Q,re,de,Ee,Ce,!1,Le)}e.$Nj=ie;function B(H,Q,re,de,Ee,Ce,Le,Ne){let $e=G(H,Q,re,de,Ee,Ce,Ne);if($e&&!Le)return $e;if(H.length>=3){const ke=Math.min(7,H.length-1);for(let ye=re+1;ye<ke;ye++){const Te=X(H,ye);if(Te){const Ue=G(Te,Te.toLowerCase(),re,de,Ee,Ce,Ne);Ue&&(Ue[0]-=3,(!$e||Ue[0]>$e[0])&&($e=Ue))}}}return $e}function X(H,Q){if(Q+1>=H.length)return;const re=H[Q],de=H[Q+1];if(re!==de)return H.slice(0,Q)+de+re+H.slice(Q+2)}}),define(be[59],we([1,0,17]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=void 0;function O(f){return r(f,0)}e.$zi=O;function r(f,u){switch(typeof f){case"object":return f===null?P(349,u):Array.isArray(f)?w(f,u):$(f,u);case"string":return I(f,u);case"boolean":return A(f,u);case"number":return P(f,u);case"undefined":return P(937,u);default:return P(617,u)}}e.$Ai=r;function P(f,u){return(u<<5)-u+f|0}e.$Bi=P;function A(f,u){return P(f?433:863,u)}function I(f,u){u=P(149417,u);for(let c=0,y=f.length;c<y;c++)u=P(f.charCodeAt(c),u);return u}e.$Ci=I;function w(f,u){return u=P(104579,u),f.reduce((c,y)=>r(y,c),u)}function $(f,u){return u=P(181387,u),Object.keys(f).sort().reduce((c,y)=>(c=I(y,c),r(f[y],c)),u)}class C{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=r(u,this.g),this.g}}e.$Di=C;var S;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function v(f,u,c=32){const y=c-u,h=~((1<<y)-1);return(f<<u|(h&f)>>>y)>>>0}function d(f,u=0,c=f.byteLength,y=0){for(let h=0;h<c;h++)f[u+h]=y}function g(f,u,c="0"){for(;f.length<u;)f=c+f;return f}function m(f,u=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(c=>c.toString(16).padStart(2,"0")).join(""):g((f>>>0).toString(16),u/4)}e.$Ei=m;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const c=u.length;if(c===0)return;const y=this.p;let h=this.r,t=this.u,s,o;for(t!==0?(s=t,o=-1,t=0):(s=u.charCodeAt(0),o=0);;){let i=s;if(D.$4e(s))if(o+1<c){const n=u.charCodeAt(o+1);D.$5e(n)?(o++,i=D.$6e(s,n)):i=65533}else{t=s;break}else D.$5e(s)&&(i=65533);if(h=this.w(y,h,i),o++,o<c)s=u.charCodeAt(o);else break}this.r=h,this.u=t}w(u,c,y){return y<128?u[c++]=y:y<2048?(u[c++]=192|(y&1984)>>>6,u[c++]=128|(y&63)>>>0):y<65536?(u[c++]=224|(y&61440)>>>12,u[c++]=128|(y&4032)>>>6,u[c++]=128|(y&63)>>>0):(u[c++]=240|(y&1835008)>>>18,u[c++]=128|(y&258048)>>>12,u[c++]=128|(y&4032)>>>6,u[c++]=128|(y&63)>>>0),c>=64&&(this.y(),c-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),c}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=l.g,c=this.q;for(let b=0;b<64;b+=4)u.setUint32(b,c.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)u.setUint32(b,v(u.getUint32(b-12,!1)^u.getUint32(b-32,!1)^u.getUint32(b-56,!1)^u.getUint32(b-64,!1),1),!1);let y=this.h,h=this.l,t=this.m,s=this.n,o=this.o,i,n,a;for(let b=0;b<80;b++)b<20?(i=h&t|~h&s,n=1518500249):b<40?(i=h^t^s,n=1859775393):b<60?(i=h&t|h&s|t&s,n=2400959708):(i=h^t^s,n=3395469782),a=v(y,5)+i+o+n+u.getUint32(b*4,!1)&4294967295,o=s,s=t,t=v(h,30),h=y,y=a;this.h=this.h+y&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}e.$Fi=l}),define(be[60],we([1,0,17]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(O||(O={})),function(r){const P="error",A="warning",I="warn",w="info",$="ignore";function C(v){return v?D.$Ze(P,v)?r.Error:D.$Ze(A,v)||D.$Ze(I,v)?r.Warning:D.$Ze(w,v)?r.Info:r.Ignore:r.Ignore}r.fromValue=C;function S(v){switch(v){case r.Error:return P;case r.Warning:return A;case r.Info:return w;default:return $}}r.toString=S}(O||(O={})),e.default=O}),define(be[148],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Id=void 0,e.$Id=Symbol("MicrotaskDelay")}),define(be[61],we([1,0,18,17]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=void 0;class r{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const g=d.charCodeAt(0),m=this.b.charCodeAt(this.c);return g-m}value(){return this.b[this.c]}}e.$Nh=r;class P{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,O.$Te)(d,this.b,0,d.length,this.c,this.d):(0,O.$Ve)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Oh=P;class A{constructor(d=!0,g=!0){this.f=d,this.g=g}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let g=d.length-1;g>=0;g--,this.c--){const m=this.b.charCodeAt(g);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const g=this.b.charCodeAt(this.e);if(g===47||this.f&&g===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,O.$Te)(d,this.b,0,d.length,this.d,this.e):(0,O.$Ve)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ph=A;var I;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(I||(I={}));class w{constructor(d,g){this.f=d,this.g=g,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,O.$Ue)(d,this.c.scheme);if(this.d[this.e]===2)return(0,O.$Ue)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,O.$Se)(d,this.c.query);if(this.d[this.e]===5)return(0,O.$Se)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Qh=w;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(C||(C={}));class S{static forUris(d=()=>!1,g=()=>!1){return new S(new w(d,g))}static forPaths(d=!1){return new S(new A(void 0,!d))}static forStrings(){return new S(new r)}static forConfigKeys(){return new S(new P)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,g){if(g){const m=g.slice(0);(0,D.$Vb)(m);for(const l of m)this.set(l,d)}else{const m=d.slice(0);(0,D.$Vb)(m);for(const l of m)this.set(l[0],l[1])}}set(d,g){const m=this.b.reset(d);let l;this.c||(this.c=new $,this.c.segment=m.value());const f=[];for(l=this.c;;){const c=m.cmp(l.segment);if(c>0)l.left||(l.left=new $,l.left.segment=m.value()),f.push([-1,l]),l=l.left;else if(c<0)l.right||(l.right=new $,l.right.segment=m.value()),f.push([1,l]),l=l.right;else if(m.hasNext())m.next(),l.mid||(l.mid=new $,l.mid.segment=m.value()),f.push([0,l]),l=l.mid;else break}const u=l.value;l.value=g,l.key=d;for(let c=f.length-1;c>=0;c--){const y=f[c][1];y.updateHeight();const h=y.balanceFactor();if(h<-1||h>1){const t=f[c][0],s=f[c+1][0];if(t===1&&s===1)f[c][1]=y.rotateLeft();else if(t===-1&&s===-1)f[c][1]=y.rotateRight();else if(t===1&&s===-1)y.right=f[c+1][1]=f[c+1][1].rotateRight(),f[c][1]=y.rotateLeft();else if(t===-1&&s===1)y.left=f[c+1][1]=f[c+1][1].rotateLeft(),f[c][1]=y.rotateRight();else throw new Error;if(c>0)switch(f[c-1][0]){case-1:f[c-1][1].left=f[c][1];break;case 1:f[c-1][1].right=f[c][1];break;case 0:f[c-1][1].mid=f[c][1];break}else this.c=f[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const g=this.b.reset(d);let m=this.c;for(;m;){const l=g.cmp(m.segment);if(l>0)m=m.left;else if(l<0)m=m.right;else if(g.hasNext())g.next(),m=m.mid;else break}return m}has(d){const g=this.d(d);return!(g?.value===void 0&&g?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,g){const m=this.b.reset(d),l=[];let f=this.c;for(;f;){const u=m.cmp(f.segment);if(u>0)l.push([-1,f]),f=f.left;else if(u<0)l.push([1,f]),f=f.right;else if(m.hasNext())m.next(),l.push([0,f]),f=f.mid;else break}if(f){if(g?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this.f(f.right);if(u.key){const{key:c,value:y,segment:h}=u;this.e(u.key,!1),f.key=c,f.value=y,f.segment=h}}else{const u=f.left??f.right;if(l.length>0){const[c,y]=l[l.length-1];switch(c){case-1:y.left=u;break;case 0:y.mid=u;break;case 1:y.right=u;break}}else this.c=u}for(let u=l.length-1;u>=0;u--){const c=l[u][1];c.updateHeight();const y=c.balanceFactor();if(y>1?(c.right.balanceFactor()>=0||(c.right=c.right.rotateRight()),l[u][1]=c.rotateLeft()):y<-1&&(c.left.balanceFactor()<=0||(c.left=c.left.rotateLeft()),l[u][1]=c.rotateRight()),u>0)switch(l[u-1][0]){case-1:l[u-1][1].left=l[u][1];break;case 1:l[u-1][1].right=l[u][1];break;case 0:l[u-1][1].mid=l[u][1];break}else this.c=l[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const g=this.b.reset(d);let m=this.c,l;for(;m;){const f=g.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(g.hasNext())g.next(),l=m.value||l,m=m.mid;else break}return m&&m.value||l}findSuperstr(d){return this.g(d,!1)}g(d,g){const m=this.b.reset(d);let l=this.c;for(;l;){const f=m.cmp(l.segment);if(f>0)l=l.left;else if(f<0)l=l.right;else if(m.hasNext())m.next(),l=l.mid;else return l.mid?this.h(l.mid):g?l.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[g,m]of this)d(m,g)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const g=[];return this.j(d,g),g[Symbol.iterator]()}j(d,g){d&&(d.left&&this.j(d.left,g),d.value&&g.push([d.key,d.value]),d.mid&&this.j(d.mid,g),d.right&&this.j(d.right,g))}_isBalanced(){const d=g=>{if(!g)return!0;const m=g.balanceFactor();return m<-1||m>1?!1:d(g.left)&&d(g.right)};return d(this.c)}}e.$Rh=S}),define(be[10],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=void 0;function D(h){return typeof h=="string"}e.$wf=D;function O(h){return Array.isArray(h)&&h.every(t=>D(t))}e.$xf=O;function r(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}e.$yf=r;function P(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}e.$zf=P;function A(h){return typeof h=="number"&&!isNaN(h)}e.$Af=A;function I(h){return!!h&&typeof h[Symbol.iterator]=="function"}e.$Bf=I;function w(h){return h===!0||h===!1}e.$Cf=w;function $(h){return typeof h>"u"}e.$Df=$;function C(h){return!S(h)}e.$Ef=C;function S(h){return $(h)||h===null}e.$Ff=S;function v(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Gf=v;function d(h){if(S(h))throw new Error("Assertion Failed: argument is undefined or null");return h}e.$Hf=d;function g(...h){const t=[];for(let s=0;s<h.length;s++){const o=h[s];if(S(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(o)}return t}e.$If=g;const m=Object.prototype.hasOwnProperty;function l(h){if(!r(h))return!1;for(const t in h)if(m.call(h,t))return!1;return!0}e.$Jf=l;function f(h){return typeof h=="function"}e.$Kf=f;function u(...h){return h.length>0&&h.every(f)}e.$Lf=u;function c(h,t){const s=Math.min(h.length,t.length);for(let o=0;o<s;o++)y(h[o],t[o])}e.$Mf=c;function y(h,t){if(D(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if(h instanceof t)return}catch{}if(!S(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Nf=y}),define(be[49],we([1,0,10]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=void 0;const O=Object.create(null);function r(I,w){if((0,D.$wf)(w)){const $=O[w];if($===void 0)throw new Error(`${I} references an unknown codicon: ${w}`);w=$}return O[I]=w,{id:I}}function P(){return O}e.$Oj=P;function A(){return Object.values(e.$Qj)}e.$Pj=A,e.$Qj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),gitPullRequestLabel:r("git-pull-request-label",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),gitPullRequestMilestone:r("git-pull-request-milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),gitPullRequestReviewer:r("git-pull-request-reviewer",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),gitPullRequestAssignee:r("git-pull-request-assignee",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),mic:r("mic",60434),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(be[22],we([1,0,10]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=void 0;function O(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const u=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([c,y])=>{u[c]=y&&typeof y=="object"?O(y):y}),u}e.$Wm=O;function r(f){if(!f||typeof f!="object")return f;const u=[f];for(;u.length>0;){const c=u.shift();Object.freeze(c);for(const y in c)if(P.call(c,y)){const h=c[y];typeof h=="object"&&!Object.isFrozen(h)&&!(0,D.$zf)(h)&&u.push(h)}}return f}e.$Xm=r;const P=Object.prototype.hasOwnProperty;function A(f,u){return I(f,u,new Set)}e.$Ym=A;function I(f,u,c){if((0,D.$Ff)(f))return f;const y=u(f);if(typeof y<"u")return y;if(Array.isArray(f)){const h=[];for(const t of f)h.push(I(t,u,c));return h}if((0,D.$yf)(f)){if(c.has(f))throw new Error("Cannot clone recursive data-structure");c.add(f);const h={};for(const t in f)P.call(f,t)&&(h[t]=I(f[t],u,c));return c.delete(f),h}return f}function w(f,u,c=!0){return(0,D.$yf)(f)?((0,D.$yf)(u)&&Object.keys(u).forEach(y=>{y in f?c&&((0,D.$yf)(f[y])&&(0,D.$yf)(u[y])?w(f[y],u[y],c):f[y]=u[y]):f[y]=u[y]}),f):u}e.$Zm=w;function $(f,u){if(f===u)return!0;if(f==null||u===null||u===void 0||typeof f!=typeof u||typeof f!="object"||Array.isArray(f)!==Array.isArray(u))return!1;let c,y;if(Array.isArray(f)){if(f.length!==u.length)return!1;for(c=0;c<f.length;c++)if(!$(f[c],u[c]))return!1}else{const h=[];for(y in f)h.push(y);h.sort();const t=[];for(y in u)t.push(y);if(t.sort(),!$(h,t))return!1;for(c=0;c<h.length;c++)if(!$(f[h[c]],u[h[c]]))return!1}return!0}e.$1m=$;function C(f){const u=new Set;return JSON.stringify(f,(c,y)=>{if((0,D.$yf)(y)||Array.isArray(y)){if(u.has(y))return"[Circular]";u.add(y)}return y})}e.$2m=C;function S(f,u){const c=Object.create(null);return!f||!u||Object.keys(u).forEach(h=>{const t=f[h],s=u[h];$(t,s)||(c[h]=s)}),c}e.$3m=S;function v(f,u){const c=u.toLowerCase(),y=Object.keys(f).find(h=>h.toLowerCase()===c);return y?f[y]:f[u]}e.$4m=v;function d(f,u){const c=Object.create(null);for(const[y,h]of Object.entries(f))u(y,h)&&(c[y]=h);return c}e.$5m=d;function g(f){let u=[];for(;Object.prototype!==f;)u=u.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return u}e.$6m=g;function m(f){const u=[];for(const c of g(f))typeof f[c]=="function"&&u.push(c);return u}e.$7m=m;function l(f,u){const c=h=>function(){const t=Array.prototype.slice.call(arguments,0);return u(h,t)},y={};for(const h of f)y[h]=c(h);return y}e.$8m=l}),define(be[98],we([1,0,49]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Rj=e.ThemeColor=void 0;var O;(function(A){function I(w){return w&&typeof w=="object"&&typeof w.id=="string"}A.isThemeColor=I})(O||(e.ThemeColor=O={}));function r(A){return{id:A}}e.$Rj=r;var P;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function w(u){const c=I.exec(u.id);if(!c)return w(D.$Qj.error);const[,y,h]=c,t=["codicon","codicon-"+y];return h&&t.push("codicon-modifier-"+h.substring(1)),t}A.asClassNameArray=w;function $(u){return w(u).join(" ")}A.asClassName=$;function C(u){return"."+w(u).join(".")}A.asCSSSelector=C;function S(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||O.isThemeColor(u.color))}A.isThemeIcon=S;const v=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function d(u){const c=v.exec(u);if(!c)return;const[,y]=c;return{id:y}}A.fromString=d;function g(u){return{id:u}}A.fromId=g;function m(u,c){let y=u.id;const h=y.lastIndexOf("~");return h!==-1&&(y=y.substring(0,h)),c&&(y=`${y}~${c}`),{id:y}}A.modify=m;function l(u){const c=u.id.lastIndexOf("~");if(c!==-1)return u.id.substring(c+1)}A.getModifier=l;function f(u,c){return u.id===c.id&&u.color?.id===c.color?.id}A.isEqual=f})(P||(e.ThemeIcon=P={}))}),define(be[149],we([1,0,147,17,98]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=void 0;const P="$(",A=new RegExp(`\\$\\(${r.ThemeIcon.iconNameExpression}(?:${r.ThemeIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${A.source}`,"g");function w(f){return f.replace(I,(u,c)=>c?u:`\\${u}`)}e.$Sj=w;const $=new RegExp(`\\\\${A.source}`,"g");function C(f){return f.replace($,u=>`\\${u}`)}e.$Tj=C;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function v(f){return f.indexOf(P)===-1?f:f.replace(S,(u,c,y,h)=>y?u:c||h||"")}e.$Uj=v;function d(f){return f?f.replace(/\$\((.*?)\)/g,(u,c)=>` ${c} `).trim():""}e.$Vj=d;const g=new RegExp(`\\$\\(${r.ThemeIcon.iconNameCharacter}+\\)`,"g");function m(f){g.lastIndex=0;let u="";const c=[];let y=0;for(;;){const h=g.lastIndex,t=g.exec(f),s=f.substring(h,t?.index);if(s.length>0){u+=s;for(let o=0;o<s.length;o++)c.push(y)}if(!t)break;y+=t[0].length}return{text:u,iconOffsets:c}}e.$Wj=m;function l(f,u,c=!1){const{text:y,iconOffsets:h}=u;if(!h||h.length===0)return(0,D.$Fj)(f,y,c);const t=(0,O.$He)(y," "),s=y.length-t.length,o=(0,D.$Fj)(f,t,c);if(o)for(const i of o){const n=h[i.start+s]+s;i.start+=n,i.end+=n}return o}e.$Xj=l}),define(be[23],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(r){return D.test(r)}e.$ag=O,e.$bg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(I){for(let w=0;w<I.length;w++)I[w]=Math.floor(Math.random()*256);return I};const P=new Uint8Array(16),A=[];for(let I=0;I<256;I++)A.push(I.toString(16).padStart(2,"0"));return function(){r(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let w=0,$="";return $+=A[P[w++]],$+=A[P[w++]],$+=A[P[w++]],$+=A[P[w++]],$+="-",$+=A[P[w++]],$+=A[P[w++]],$+="-",$+=A[P[w++]],$+=A[P[w++]],$+="-",$+=A[P[w++]],$+=A[P[w++]],$+="-",$+=A[P[w++]],$+=A[P[w++]],$+=A[P[w++]],$+=A[P[w++]],$+=A[P[w++]],$+=A[P[w++]],$}}()}),define(be[150],we([1,0,18,47,23]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=e.$Ts=e.$Ss=e.$Rs=e.$Qs=void 0;function P(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$Qs=P;function A(S,v,d){const g={id:(0,r.$bg)(),name:S,uri:v,data:d};return{asString:async()=>"",asFile:()=>g,value:void 0}}e.$Rs=A;class I{constructor(){this.a=new Map}get size(){let v=0;for(const d of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const d=[...this.a.keys()];return O.Iterable.some(this,([g,m])=>m.asFile())&&d.push("files"),C(w(v),d)}get(v){return this.a.get(this.b(v))?.[0]}append(v,d){const g=this.a.get(v);g?g.push(d):this.a.set(this.b(v),[d])}replace(v,d){this.a.set(this.b(v),[d])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,d]of this.a)for(const g of d)yield[v,g]}b(v){return w(v)}}e.$Ss=I;function w(S){return S.toLowerCase()}function $(S,v){return C(w(S),v.map(w))}e.$Ts=$;function C(S,v){if(S==="*/*")return v.length>0;if(v.includes(S))return!0;const d=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!d)return!1;const[g,m,l]=d;return l==="*"?v.some(f=>f.startsWith(m+"/")):!1}e.$Us=Object.freeze({create:S=>(0,D.$Kb)(S.map(v=>v.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$Us.split(S).filter(v=>!v.startsWith("#"))})}),function(){"use strict";function le(e,D,O){function r(d){return new Promise(g=>D.exists(d,g))}function P(d){return new Promise((g,m)=>{const l=new Date;D.utimes(d,l,l,f=>f?m(f):g())})}function A(d){return new Promise((g,m)=>D.mkdir(d,{recursive:!0},l=>l&&l.code!=="EEXIST"?m(l):g(d)))}function I(d){return new Promise((g,m)=>D.rm(d,{recursive:!0,force:!0,maxRetries:3},l=>l?m(l):g()))}function w(d){return new Promise((g,m)=>D.readFile(d,"utf8",(l,f)=>l?m(l):g(f)))}function $(d,g){return new Promise((m,l)=>D.writeFile(d,g,"utf8",f=>f?l(f):m()))}async function C(d){const g=e.join(d,"languagepacks.json");try{return JSON.parse(await w(g))}catch{}}function S(d,g){try{for(;g;){if(d[g])return g;{const m=g.lastIndexOf("-");if(m>0)g=g.substring(0,m);else return}}}catch(m){console.error("Resolving language pack configuration failed.",m)}}function v(d,g,m,l,f){const u=function(y){return O.mark("code/didGenerateNls"),Promise.resolve({locale:y,osLocale:f,availableLanguages:{}})};if(O.mark("code/willGenerateNls"),l==="pseudo")return Promise.resolve({locale:l,osLocale:f,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:l,osLocale:f,availableLanguages:{}});if(l&&(l==="en"||l==="en-us"))return Promise.resolve({locale:l,osLocale:f,availableLanguages:{}});const c=l;try{return d?C(g).then(y=>{if(!y)return u(c);const h=S(y,l);if(!h)return u(c);l=h;const t=y[l];let s;return!t||typeof t.hash!="string"||!t.translations||typeof(s=t.translations.vscode)!="string"?u(c):r(s).then(o=>{if(!o)return u(c);const i=t.hash+"."+l,n=e.join(g,"clp",i),a=e.join(n,d),b=e.join(n,"tcf.json"),p=e.join(n,"corrupted.info"),E={locale:c,osLocale:f,availableLanguages:{"*":l},_languagePackId:i,_translationsConfigFile:b,_cacheRoot:n,_resolvedLanguagePackCoreLocation:a,_corruptedFile:p};return r(p).then(k=>{let L;return k?L=I(n):L=Promise.resolve(void 0),L.then(()=>r(a).then(j=>j?(P(a).catch(()=>{}),O.mark("code/didGenerateNls"),E):A(a).then(()=>Promise.all([w(m),w(s)])).then(Y=>{const ce=JSON.parse(Y[0]),x=JSON.parse(Y[1]).contents,ne=Object.keys(ce.bundles),ue=[];for(const _ of ne){const he=ce.bundles[_],ee=Object.create(null);for(const te of he){const W=ce.keys[te],K=ce.messages[te],V=x[te];let oe;if(V){oe=[];for(let me=0;me<W.length;me++){const se=W[me],U=typeof se=="string"?se:se.key;let Z=V[U];Z===void 0&&(Z=K[me]),oe.push(Z)}}else oe=K;ee[te]=oe}ue.push($(e.join(a,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(ee)))}return ue.push($(b,JSON.stringify(t.translations))),Promise.all(ue)}).then(()=>(O.mark("code/didGenerateNls"),E)).catch(Y=>(console.error("Generating translation files failed.",Y),u(l)))))})})}):u(c)}catch(y){return console.error("Generating translation files failed.",y),u(l)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(be[151],we([76,27,41]),function(e,D,O){return le(e,D,O)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("fs"),O=require("../common/performance");module.exports=le(e,D,O)}else throw new Error("Unknown context")}(),define(be[152],we([1,0,28]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(A){const I=A.replace(/\-/g,":").toLowerCase();return!O.has(I)}function P(){const A=(0,D.networkInterfaces)();for(const I in A){const w=A[I];if(w){for(const{mac:$}of w)if(r($))return $}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Hm=P}),define(be[99],we([1,0,28,61,23,152]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=e.$Im=void 0,e.$Im=new class{c($){return this.a||(this.a=O.$Rh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr($)}value(){if(this.b===void 0){let $=0,C=0;const S=(0,D.networkInterfaces)();for(const v in S){const d=S[v];if(d)for(const{mac:g,internal:m}of d)m||(C+=1,this.c(g.toUpperCase())&&($+=1))}this.b=C>0?$/C:0}return this.b}};let A;async function I($){return A||(A=(async()=>await w($)||r.$bg())()),A}e.$Jm=I;async function w($){try{const C=await new Promise((v,d)=>{le(["crypto"],v,d)}),S=(0,P.$Hm)();return C.createHash("sha256").update(S,"utf8").digest("hex")}catch(C){$(C);return}}}),define(be[153],we([1,0,77]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.$eg=e.$dg=void 0;function O(I,w,$,C=1){let S=!1;return new Promise(v=>{const d=setTimeout(()=>{if(!S)return S=!0,v(0)},$);r(I,w,C,g=>{if(!S)return S=!0,clearTimeout(d),v(g)})})}e.$dg=O;function r(I,w,$,C){if(w===0)return C(0);const S=new D.Socket;S.once("connect",()=>(A(S),r(I+$,w-1,$,C))),S.once("data",()=>{}),S.once("error",v=>(A(S),v.code!=="ECONNREFUSED"?r(I+$,w-1,$,C):C(I))),S.connect(I,"127.0.0.1")}e.$eg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(I,w,$,C="127.0.0.1"){let S=!1,v,d=1;const g=D.createServer({pauseOnConnect:!0});function m(l,f){S||(S=!0,g.removeAllListeners(),g.close(),v&&clearTimeout(v),f(l))}return new Promise(l=>{v=setTimeout(()=>{m(0,l)},$),g.on("listening",()=>{m(I,l)}),g.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&d<w?(I++,d++,g.listen(I,C)):m(0,l)}),g.on("close",()=>{m(0,l)}),g.listen(I,C)})}e.$fg=P;function A(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(w){console.error(w)}}}),function(){function le(){function e(){return process.uncHostAllowlist}function D(w){const $=new Set;if(Array.isArray(w))for(const C of w)typeof C=="string"&&$.add(C);return Array.from($)}function O(){const w=e();return w?Array.from(w):[]}function r(w){if(process.platform!=="win32")return;const $=e();if($)if(typeof w=="string")$.add(w.toLowerCase());else for(const C of D(w))r(C)}function P(w){if(typeof w!="string")return;const $=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let C;for(const S of $){if(w.indexOf(S)!==0)continue;const d=w.indexOf("\\",S.length);if(d===-1)continue;const g=w.substring(S.length,d);if(g){C=g;break}}return C}function A(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function I(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:r,getUNCHost:P,disableUNCAccessRestrictions:A,isUNCAccessRestrictionsDisabled:I}}typeof define=="function"?define("vs/base/node/unc",[],function(){return le()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=le():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(be[100],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=void 0;class D{constructor(r,P){this.lineNumber=r,this.column=P}with(r=this.lineNumber,P=this.column){return r===this.lineNumber&&P===this.column?this:new D(r,P)}delta(r=0,P=0){return this.with(this.lineNumber+r,this.column+P)}equals(r){return D.equals(this,r)}static equals(r,P){return!r&&!P?!0:!!r&&!!P&&r.lineNumber===P.lineNumber&&r.column===P.column}isBefore(r){return D.isBefore(this,r)}static isBefore(r,P){return r.lineNumber<P.lineNumber?!0:P.lineNumber<r.lineNumber?!1:r.column<P.column}isBeforeOrEqual(r){return D.isBeforeOrEqual(this,r)}static isBeforeOrEqual(r,P){return r.lineNumber<P.lineNumber?!0:P.lineNumber<r.lineNumber?!1:r.column<=P.column}static compare(r,P){const A=r.lineNumber|0,I=P.lineNumber|0;if(A===I){const w=r.column|0,$=P.column|0;return w-$}return A-I}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(r){return new D(r.lineNumber,r.column)}static isIPosition(r){return r&&typeof r.lineNumber=="number"&&typeof r.column=="number"}}e.$ks=D}),define(be[42],we([1,0,100]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;class O{constructor(P,A,I,w){P>I||P===I&&A>w?(this.startLineNumber=I,this.startColumn=w,this.endLineNumber=P,this.endColumn=A):(this.startLineNumber=P,this.startColumn=A,this.endLineNumber=I,this.endColumn=w)}isEmpty(){return O.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return O.containsPosition(this,P)}static containsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<P.startColumn||A.lineNumber===P.endLineNumber&&A.column>P.endColumn)}static strictContainsPosition(P,A){return!(A.lineNumber<P.startLineNumber||A.lineNumber>P.endLineNumber||A.lineNumber===P.startLineNumber&&A.column<=P.startColumn||A.lineNumber===P.endLineNumber&&A.column>=P.endColumn)}containsRange(P){return O.containsRange(this,P)}static containsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>P.endColumn)}strictContainsRange(P){return O.strictContainsRange(this,P)}static strictContainsRange(P,A){return!(A.startLineNumber<P.startLineNumber||A.endLineNumber<P.startLineNumber||A.startLineNumber>P.endLineNumber||A.endLineNumber>P.endLineNumber||A.startLineNumber===P.startLineNumber&&A.startColumn<=P.startColumn||A.endLineNumber===P.endLineNumber&&A.endColumn>=P.endColumn)}plusRange(P){return O.plusRange(this,P)}static plusRange(P,A){let I,w,$,C;return A.startLineNumber<P.startLineNumber?(I=A.startLineNumber,w=A.startColumn):A.startLineNumber===P.startLineNumber?(I=A.startLineNumber,w=Math.min(A.startColumn,P.startColumn)):(I=P.startLineNumber,w=P.startColumn),A.endLineNumber>P.endLineNumber?($=A.endLineNumber,C=A.endColumn):A.endLineNumber===P.endLineNumber?($=A.endLineNumber,C=Math.max(A.endColumn,P.endColumn)):($=P.endLineNumber,C=P.endColumn),new O(I,w,$,C)}intersectRanges(P){return O.intersectRanges(this,P)}static intersectRanges(P,A){let I=P.startLineNumber,w=P.startColumn,$=P.endLineNumber,C=P.endColumn;const S=A.startLineNumber,v=A.startColumn,d=A.endLineNumber,g=A.endColumn;return I<S?(I=S,w=v):I===S&&(w=Math.max(w,v)),$>d?($=d,C=g):$===d&&(C=Math.min(C,g)),I>$||I===$&&w>C?null:new O(I,w,$,C)}equalsRange(P){return O.equalsRange(this,P)}static equalsRange(P,A){return!P&&!A?!0:!!P&&!!A&&P.startLineNumber===A.startLineNumber&&P.startColumn===A.startColumn&&P.endLineNumber===A.endLineNumber&&P.endColumn===A.endColumn}getEndPosition(){return O.getEndPosition(this)}static getEndPosition(P){return new D.$ks(P.endLineNumber,P.endColumn)}getStartPosition(){return O.getStartPosition(this)}static getStartPosition(P){return new D.$ks(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,A){return new O(this.startLineNumber,this.startColumn,P,A)}setStartPosition(P,A){return new O(P,A,this.endLineNumber,this.endColumn)}collapseToStart(){return O.collapseToStart(this)}static collapseToStart(P){return new O(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return O.collapseToEnd(this)}static collapseToEnd(P){return new O(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new O(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,A=P){return new O(P.lineNumber,P.column,A.lineNumber,A.column)}static lift(P){return P?new O(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<P.startColumn)}static areIntersecting(P,A){return!(P.endLineNumber<A.startLineNumber||P.endLineNumber===A.startLineNumber&&P.endColumn<=A.startColumn||A.endLineNumber<P.startLineNumber||A.endLineNumber===P.startLineNumber&&A.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,A){if(P&&A){const $=P.startLineNumber|0,C=A.startLineNumber|0;if($===C){const S=P.startColumn|0,v=A.startColumn|0;if(S===v){const d=P.endLineNumber|0,g=A.endLineNumber|0;if(d===g){const m=P.endColumn|0,l=A.endColumn|0;return m-l}return d-g}return S-v}return $-C}return(P?1:0)-(A?1:0)}static compareRangesUsingEnds(P,A){return P.endLineNumber===A.endLineNumber?P.endColumn===A.endColumn?P.startLineNumber===A.startLineNumber?P.startColumn-A.startColumn:P.startLineNumber-A.startLineNumber:P.endColumn-A.endColumn:P.endLineNumber-A.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$ls=O}),define(be[154],we([1,0,42]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=void 0;class O{static insert(P,A){return{range:new D.$ls(P.lineNumber,P.column,P.lineNumber,P.column),text:A,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,A){return{range:P,text:A}}static replaceMove(P,A){return{range:P,text:A,forceMoveMarkers:!0}}}e.$ms=O}),define(be[155],we([1,0,5,2]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=void 0;class r{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Ld,this.onDidChange=this.c.event,this.d=null}handleChange(I){this.c.fire({changedLanguages:I,changedColorMap:!1})}register(I,w){return this.a.set(I,w),this.handleChange([I]),(0,O.$Oc)(()=>{this.a.get(I)===w&&(this.a.delete(I),this.handleChange([I]))})}get(I){return this.a.get(I)||null}registerFactory(I,w){this.b.get(I)?.dispose();const $=new P(this,I,w);return this.b.set(I,$),(0,O.$Oc)(()=>{const C=this.b.get(I);!C||C!==$||(this.b.delete(I),C.dispose())})}async getOrCreate(I){const w=this.get(I);if(w)return w;const $=this.b.get(I);return!$||$.isResolved?null:(await $.resolve(),this.get(I))}isResolved(I){if(this.get(I))return!0;const $=this.b.get(I);return!!(!$||$.isResolved)}setColorMap(I){this.d=I,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Ws=r;class P extends O.$Qc{get isResolved(){return this.c}constructor(I,w,$){super(),this.f=I,this.g=w,this.h=$,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const I=await this.h.tokenizationSupport;this.c=!0,I&&!this.a&&this.B(this.f.register(this.g,I))}}}),define(be[156],we([8,9]),function(le,e){return le.create("vs/base/common/actions",e)}),define(be[157],we([1,0,5,2,156]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=void 0;class P extends O.$Qc{constructor(v,d="",g="",m=!0,l){super(),this.h=this.B(new D.$Ld),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=d,this.u=g,this.w=m,this.C=l}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,d){this.C&&await this.C(v)}}e.$qi=P;class A extends O.$Qc{constructor(){super(...arguments),this.f=this.B(new D.$Ld),this.onWillRun=this.f.event,this.m=this.B(new D.$Ld),this.onDidRun=this.m.event}async run(v,d){if(!v.enabled)return;this.f.fire({action:v});let g;try{await this.u(v,d)}catch(m){g=m}this.m.fire({action:v,error:g})}async u(v,d){await v.run(d)}}e.$ri=A;class I{constructor(){this.id=I.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let d=[];for(const g of v)g.length&&(d.length?d=[...d,new I,...g]:d=g);return d}static{this.ID="vs.actions.separator"}async run(){}}e.$si=I;class w{get actions(){return this.a}constructor(v,d,g,m){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=d,this.class=m,this.a=g}async run(){}}e.$ti=w;class $ extends P{static{this.ID="vs.actions.empty"}constructor(){super($.ID,r.localize(0,null),void 0,!1)}}e.$ui=$;function C(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...v)=>S.run(...v),tooltip:S.label}}e.$vi=C}),define(be[158],we([8,9]),function(le,e){return le.create("vs/base/common/date",e)}),define(be[159],we([1,0,158]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8l=e.$7l=void 0;const O=60,r=O*60,P=r*24,A=P*7,I=P*30,w=P*365;function $(S,v,d,g){typeof S!="number"&&(S=S.getTime());const m=Math.round((new Date().getTime()-S)/1e3);if(m<-30)return(0,D.localize)(0,null,$(new Date().getTime()+m*1e3,!1));if(!g&&m<30)return(0,D.localize)(1,null);let l;return m<O?(l=m,v?l===1?d?(0,D.localize)(2,null,l):(0,D.localize)(3,null,l):d?(0,D.localize)(4,null,l):(0,D.localize)(5,null,l):l===1?d?(0,D.localize)(6,null,l):(0,D.localize)(7,null,l):d?(0,D.localize)(8,null,l):(0,D.localize)(9,null,l)):m<r?(l=Math.floor(m/O),v?l===1?d?(0,D.localize)(10,null,l):(0,D.localize)(11,null,l):d?(0,D.localize)(12,null,l):(0,D.localize)(13,null,l):l===1?d?(0,D.localize)(14,null,l):(0,D.localize)(15,null,l):d?(0,D.localize)(16,null,l):(0,D.localize)(17,null,l)):m<P?(l=Math.floor(m/r),v?l===1?d?(0,D.localize)(18,null,l):(0,D.localize)(19,null,l):d?(0,D.localize)(20,null,l):(0,D.localize)(21,null,l):l===1?d?(0,D.localize)(22,null,l):(0,D.localize)(23,null,l):d?(0,D.localize)(24,null,l):(0,D.localize)(25,null,l)):m<A?(l=Math.floor(m/P),v?l===1?(0,D.localize)(26,null,l):(0,D.localize)(27,null,l):l===1?(0,D.localize)(28,null,l):(0,D.localize)(29,null,l)):m<I?(l=Math.floor(m/A),v?l===1?d?(0,D.localize)(30,null,l):(0,D.localize)(31,null,l):d?(0,D.localize)(32,null,l):(0,D.localize)(33,null,l):l===1?d?(0,D.localize)(34,null,l):(0,D.localize)(35,null,l):d?(0,D.localize)(36,null,l):(0,D.localize)(37,null,l)):m<w?(l=Math.floor(m/I),v?l===1?d?(0,D.localize)(38,null,l):(0,D.localize)(39,null,l):d?(0,D.localize)(40,null,l):(0,D.localize)(41,null,l):l===1?d?(0,D.localize)(42,null,l):(0,D.localize)(43,null,l):d?(0,D.localize)(44,null,l):(0,D.localize)(45,null,l)):(l=Math.floor(m/w),v?l===1?d?(0,D.localize)(46,null,l):(0,D.localize)(47,null,l):d?(0,D.localize)(48,null,l):(0,D.localize)(49,null,l):l===1?d?(0,D.localize)(50,null,l):(0,D.localize)(51,null,l):d?(0,D.localize)(52,null,l):(0,D.localize)(53,null,l))}e.$7l=$;function C(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$8l=C}),define(be[160],we([8,9]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(be[38],we([1,0,18,10,160]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=void 0;function P(S,v){return v&&(S.stack||S.stacktrace)?r.localize(0,null,I(S),A(S.stack)||A(S.stacktrace)):I(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function I(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?r.localize(1,null,S.message):S.message||r.localize(2,null)}function w(S=null,v=!1){if(!S)return r.localize(3,null);if(Array.isArray(S)){const d=D.$Fb(S),g=w(d[0],v);return d.length>1?r.localize(4,null,g,d.length):g}if(O.$wf(S))return S;if(S.detail){const d=S.detail;if(d.error)return P(d.error,v);if(d.exception)return P(d.exception,v)}return S.stack?P(S,v):S.message?S.message:r.localize(5,null)}e.$wi=w;function $(S){const v=S;return v instanceof Error&&Array.isArray(v.actions)}e.$xi=$;function C(S,v){let d;return typeof S=="string"?d=new Error(S):d=S,d.actions=v,d}e.$yi=C}),define(be[161],we([8,9]),function(le,e){return le.create("vs/base/common/jsonErrorMessages",e)}),define(be[162],we([1,0,161]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function O(r){switch(r){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$np=O}),define(be[163],we([8,9]),function(le,e){return le.create("vs/base/common/platform",e)}),define(be[3],we([1,0,163]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,r=!1,P=!1,A=!1,I=!1,w=!1,$=!1,C=!1,S=!1,v=!1,d,g=e.$f,m=e.$f,l,f;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?u=e.$g.vscode.process:typeof process<"u"&&(u=process);const c=typeof u?.versions?.electron=="string",y=c&&u?.type==="renderer";if(typeof navigator=="object"&&!y)f=navigator.userAgent,O=f.indexOf("Windows")>=0,r=f.indexOf("Macintosh")>=0,C=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=f.indexOf("Linux")>=0,v=f?.indexOf("Mobi")>=0,w=!0,d=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$f,g=d,m=navigator.language;else if(typeof u=="object"){O=u.platform==="win32",r=u.platform==="darwin",P=u.platform==="linux",A=P&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,$=c,S=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$f,g=e.$f;const p=u.env.VSCODE_NLS_CONFIG;if(p)try{const E=JSON.parse(p),k=E.availableLanguages["*"];d=E.locale,m=E.osLocale,g=k||e.$f,l=E._translationsConfigFile}catch{}I=!0}else console.error("Unable to resolve platform.");var h;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(h||(e.Platform=h={}));function t(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let s=0;r?s=1:O?s=3:P&&(s=2),e.$i=O,e.$j=r,e.$k=P,e.$l=A,e.$m=I,e.$n=$,e.$o=w,e.$p=w&&typeof e.$g.importScripts=="function",e.$q=C,e.$r=v,e.$s=S,e.$t=s,e.$u=f,e.$v=g;var o;(function(p){function E(){return e.$v}p.value=E;function k(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}p.isDefaultVariant=k;function L(){return e.$v==="en"}p.isDefault=L})(o||(e.Language=o={})),e.$w=d,e.$x=m,e.$y=l,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const p=[];e.$g.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let L=0,j=p.length;L<j;L++){const Y=p[L];if(Y.id===k.data.vscodeScheduleAsyncWork){p.splice(L,1),Y.callback();return}}});let E=0;return k=>{const L=++E;p.push({id:L,callback:k}),e.$g.postMessage({vscodeScheduleAsyncWork:L},"*")}}return p=>setTimeout(p)})();var i;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||C?2:O?1:3;let n=!0,a=!1;function b(){if(!a){a=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,n=new Uint16Array(p.buffer)[0]===(2<<8)+1}return n}e.$C=b,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(be[29],we([1,0,3]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cc=e.$bc=e.env=e.cwd=void 0;let O;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.process<"u"){const r=D.$g.vscode.process;O={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$bc=O.platform,e.$cc=O.arch}),define(be[7],we([1,0,29]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rc=e.sep=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=void 0;const O=65,r=97,P=90,A=122,I=46,w=47,$=92,C=58,S=63;class v extends Error{constructor(s,o,i){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const a=s.indexOf(".")!==-1?"property":"argument";let b=`The "${s}" ${a} ${n} of type ${o}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,s){if(t===null||typeof t!="object")throw new v(s,"Object",t)}function g(t,s){if(typeof t!="string")throw new v(s,"string",t)}const m=D.$bc==="win32";function l(t){return t===w||t===$}function f(t){return t===w}function u(t){return t>=O&&t<=P||t>=r&&t<=A}function c(t,s,o,i){let n="",a=0,b=-1,p=0,E=0;for(let k=0;k<=t.length;++k){if(k<t.length)E=t.charCodeAt(k);else{if(i(E))break;E=w}if(i(E)){if(!(b===k-1||p===1))if(p===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==I||n.charCodeAt(n.length-2)!==I){if(n.length>2){const L=n.lastIndexOf(o);L===-1?(n="",a=0):(n=n.slice(0,L),a=n.length-1-n.lastIndexOf(o)),b=k,p=0;continue}else if(n.length!==0){n="",a=0,b=k,p=0;continue}}s&&(n+=n.length>0?`${o}..`:"..",a=2)}else n.length>0?n+=`${o}${t.slice(b+1,k)}`:n=t.slice(b+1,k),a=k-b-1;b=k,p=0}else E===I&&p!==-1?++p:p=-1}return n}function y(t,s){d(s,"pathObject");const o=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${i}`:`${o}${t}${i}`:i}e.$dc={resolve(...t){let s="",o="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],g(a,"path"),a.length===0)continue}else s.length===0?a=D.cwd():(a=D.env[`=${s}`]||D.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==s.toLowerCase()&&a.charCodeAt(2)===$)&&(a=`${s}\\`));const b=a.length;let p=0,E="",k=!1;const L=a.charCodeAt(0);if(b===1)l(L)&&(p=1,k=!0);else if(l(L))if(k=!0,l(a.charCodeAt(1))){let j=2,Y=j;for(;j<b&&!l(a.charCodeAt(j));)j++;if(j<b&&j!==Y){const ce=a.slice(Y,j);for(Y=j;j<b&&l(a.charCodeAt(j));)j++;if(j<b&&j!==Y){for(Y=j;j<b&&!l(a.charCodeAt(j));)j++;(j===b||j!==Y)&&(E=`\\\\${ce}\\${a.slice(Y,j)}`,p=j)}}}else p=1;else u(L)&&a.charCodeAt(1)===C&&(E=a.slice(0,2),p=2,b>2&&l(a.charCodeAt(2))&&(k=!0,p=3));if(E.length>0)if(s.length>0){if(E.toLowerCase()!==s.toLowerCase())continue}else s=E;if(i){if(s.length>0)break}else if(o=`${a.slice(p)}\\${o}`,i=k,k&&s.length>0)break}return o=c(o,!i,"\\",l),i?`${s}\\${o}`:`${s}${o}`||"."},normalize(t){g(t,"path");const s=t.length;if(s===0)return".";let o=0,i,n=!1;const a=t.charCodeAt(0);if(s===1)return f(a)?"\\":t;if(l(a))if(n=!0,l(t.charCodeAt(1))){let p=2,E=p;for(;p<s&&!l(t.charCodeAt(p));)p++;if(p<s&&p!==E){const k=t.slice(E,p);for(E=p;p<s&&l(t.charCodeAt(p));)p++;if(p<s&&p!==E){for(E=p;p<s&&!l(t.charCodeAt(p));)p++;if(p===s)return`\\\\${k}\\${t.slice(E)}\\`;p!==E&&(i=`\\\\${k}\\${t.slice(E,p)}`,o=p)}}}else o=1;else u(a)&&t.charCodeAt(1)===C&&(i=t.slice(0,2),o=2,s>2&&l(t.charCodeAt(2))&&(n=!0,o=3));let b=o<s?c(t.slice(o),!n,"\\",l):"";return b.length===0&&!n&&(b="."),b.length>0&&l(t.charCodeAt(s-1))&&(b+="\\"),i===void 0?n?`\\${b}`:b:n?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){g(t,"path");const s=t.length;if(s===0)return!1;const o=t.charCodeAt(0);return l(o)||s>2&&u(o)&&t.charCodeAt(1)===C&&l(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,o;for(let a=0;a<t.length;++a){const b=t[a];g(b,"path"),b.length>0&&(s===void 0?s=o=b:s+=`\\${b}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof o=="string"&&l(o.charCodeAt(0))){++n;const a=o.length;a>1&&l(o.charCodeAt(1))&&(++n,a>2&&(l(o.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&l(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$dc.normalize(s)},relative(t,s){if(g(t,"from"),g(s,"to"),t===s)return"";const o=e.$dc.resolve(t),i=e.$dc.resolve(s);if(o===i||(t=o.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===$;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===$;)a--;const b=a-n;let p=0;for(;p<s.length&&s.charCodeAt(p)===$;)p++;let E=s.length;for(;E-1>p&&s.charCodeAt(E-1)===$;)E--;const k=E-p,L=b<k?b:k;let j=-1,Y=0;for(;Y<L;Y++){const x=t.charCodeAt(n+Y);if(x!==s.charCodeAt(p+Y))break;x===$&&(j=Y)}if(Y!==L){if(j===-1)return i}else{if(k>L){if(s.charCodeAt(p+Y)===$)return i.slice(p+Y+1);if(Y===2)return i.slice(p+Y)}b>L&&(t.charCodeAt(n+Y)===$?j=Y:Y===2&&(j=3)),j===-1&&(j=0)}let ce="";for(Y=n+j+1;Y<=a;++Y)(Y===a||t.charCodeAt(Y)===$)&&(ce+=ce.length===0?"..":"\\..");return p+=j,ce.length>0?`${ce}${i.slice(p,E)}`:(i.charCodeAt(p)===$&&++p,i.slice(p,E))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$dc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===$){if(s.charCodeAt(1)===$){const o=s.charCodeAt(2);if(o!==S&&o!==I)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(u(s.charCodeAt(0))&&s.charCodeAt(1)===C&&s.charCodeAt(2)===$)return`\\\\?\\${s}`;return t},dirname(t){g(t,"path");const s=t.length;if(s===0)return".";let o=-1,i=0;const n=t.charCodeAt(0);if(s===1)return l(n)?t:".";if(l(n)){if(o=i=1,l(t.charCodeAt(1))){let p=2,E=p;for(;p<s&&!l(t.charCodeAt(p));)p++;if(p<s&&p!==E){for(E=p;p<s&&l(t.charCodeAt(p));)p++;if(p<s&&p!==E){for(E=p;p<s&&!l(t.charCodeAt(p));)p++;if(p===s)return t;p!==E&&(o=i=p+1)}}}}else u(n)&&t.charCodeAt(1)===C&&(o=s>2&&l(t.charCodeAt(2))?3:2,i=o);let a=-1,b=!0;for(let p=s-1;p>=i;--p)if(l(t.charCodeAt(p))){if(!b){a=p;break}}else b=!1;if(a===-1){if(o===-1)return".";a=o}return t.slice(0,a)},basename(t,s){s!==void 0&&g(s,"ext"),g(t,"path");let o=0,i=-1,n=!0,a;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===C&&(o=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let b=s.length-1,p=-1;for(a=t.length-1;a>=o;--a){const E=t.charCodeAt(a);if(l(E)){if(!n){o=a+1;break}}else p===-1&&(n=!1,p=a+1),b>=0&&(E===s.charCodeAt(b)?--b===-1&&(i=a):(b=-1,i=p))}return o===i?i=p:i===-1&&(i=t.length),t.slice(o,i)}for(a=t.length-1;a>=o;--a)if(l(t.charCodeAt(a))){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(o,i)},extname(t){g(t,"path");let s=0,o=-1,i=0,n=-1,a=!0,b=0;t.length>=2&&t.charCodeAt(1)===C&&u(t.charCodeAt(0))&&(s=i=2);for(let p=t.length-1;p>=s;--p){const E=t.charCodeAt(p);if(l(E)){if(!a){i=p+1;break}continue}n===-1&&(a=!1,n=p+1),E===I?o===-1?o=p:b!==1&&(b=1):o!==-1&&(b=-1)}return o===-1||n===-1||b===0||b===1&&o===n-1&&o===i+1?"":t.slice(o,n)},format:y.bind(null,"\\"),parse(t){g(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.length;let i=0,n=t.charCodeAt(0);if(o===1)return l(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(l(n)){if(i=1,l(t.charCodeAt(1))){let j=2,Y=j;for(;j<o&&!l(t.charCodeAt(j));)j++;if(j<o&&j!==Y){for(Y=j;j<o&&l(t.charCodeAt(j));)j++;if(j<o&&j!==Y){for(Y=j;j<o&&!l(t.charCodeAt(j));)j++;j===o?i=j:j!==Y&&(i=j+1)}}}}else if(u(n)&&t.charCodeAt(1)===C){if(o<=2)return s.root=s.dir=t,s;if(i=2,l(t.charCodeAt(2))){if(o===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let a=-1,b=i,p=-1,E=!0,k=t.length-1,L=0;for(;k>=i;--k){if(n=t.charCodeAt(k),l(n)){if(!E){b=k+1;break}continue}p===-1&&(E=!1,p=k+1),n===I?a===-1?a=k:L!==1&&(L=1):a!==-1&&(L=-1)}return p!==-1&&(a===-1||L===0||L===1&&a===p-1&&a===b+1?s.base=s.name=t.slice(b,p):(s.name=t.slice(b,a),s.base=t.slice(b,p),s.ext=t.slice(a,p))),b>0&&b!==i?s.dir=t.slice(0,b-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(m){const t=/\\/g;return()=>{const s=D.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>D.cwd()})();e.$ec={resolve(...t){let s="",o=!1;for(let i=t.length-1;i>=-1&&!o;i--){const n=i>=0?t[i]:h();g(n,"path"),n.length!==0&&(s=`${n}/${s}`,o=n.charCodeAt(0)===w)}return s=c(s,!o,"/",f),o?`/${s}`:s.length>0?s:"."},normalize(t){if(g(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===w,o=t.charCodeAt(t.length-1)===w;return t=c(t,!s,"/",f),t.length===0?s?"/":o?"./":".":(o&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return g(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let s;for(let o=0;o<t.length;++o){const i=t[o];g(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$ec.normalize(s)},relative(t,s){if(g(t,"from"),g(s,"to"),t===s||(t=e.$ec.resolve(t),s=e.$ec.resolve(s),t===s))return"";const o=1,i=t.length,n=i-o,a=1,b=s.length-a,p=n<b?n:b;let E=-1,k=0;for(;k<p;k++){const j=t.charCodeAt(o+k);if(j!==s.charCodeAt(a+k))break;j===w&&(E=k)}if(k===p)if(b>p){if(s.charCodeAt(a+k)===w)return s.slice(a+k+1);if(k===0)return s.slice(a+k)}else n>p&&(t.charCodeAt(o+k)===w?E=k:k===0&&(E=0));let L="";for(k=o+E+1;k<=i;++k)(k===i||t.charCodeAt(k)===w)&&(L+=L.length===0?"..":"/..");return`${L}${s.slice(a+E)}`},toNamespacedPath(t){return t},dirname(t){if(g(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===w;let o=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===w){if(!i){o=n;break}}else i=!1;return o===-1?s?"/":".":s&&o===1?"//":t.slice(0,o)},basename(t,s){s!==void 0&&g(s,"ext"),g(t,"path");let o=0,i=-1,n=!0,a;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let b=s.length-1,p=-1;for(a=t.length-1;a>=0;--a){const E=t.charCodeAt(a);if(E===w){if(!n){o=a+1;break}}else p===-1&&(n=!1,p=a+1),b>=0&&(E===s.charCodeAt(b)?--b===-1&&(i=a):(b=-1,i=p))}return o===i?i=p:i===-1&&(i=t.length),t.slice(o,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===w){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(o,i)},extname(t){g(t,"path");let s=-1,o=0,i=-1,n=!0,a=0;for(let b=t.length-1;b>=0;--b){const p=t.charCodeAt(b);if(p===w){if(!n){o=b+1;break}continue}i===-1&&(n=!1,i=b+1),p===I?s===-1?s=b:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||i===-1||a===0||a===1&&s===i-1&&s===o+1?"":t.slice(s,i)},format:y.bind(null,"/"),parse(t){g(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const o=t.charCodeAt(0)===w;let i;o?(s.root="/",i=1):i=0;let n=-1,a=0,b=-1,p=!0,E=t.length-1,k=0;for(;E>=i;--E){const L=t.charCodeAt(E);if(L===w){if(!p){a=E+1;break}continue}b===-1&&(p=!1,b=E+1),L===I?n===-1?n=E:k!==1&&(k=1):n!==-1&&(k=-1)}if(b!==-1){const L=a===0&&o?1:a;n===-1||k===0||k===1&&n===b-1&&n===a+1?s.base=s.name=t.slice(L,b):(s.name=t.slice(L,n),s.base=t.slice(L,b),s.ext=t.slice(n,b))}return a>0?s.dir=t.slice(0,a-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$ec.win32=e.$dc.win32=e.$dc,e.$ec.posix=e.$dc.posix=e.$ec,e.$fc=m?e.$dc.normalize:e.$ec.normalize,e.$gc=m?e.$dc.isAbsolute:e.$ec.isAbsolute,e.$hc=m?e.$dc.join:e.$ec.join,e.$ic=m?e.$dc.resolve:e.$ec.resolve,e.$jc=m?e.$dc.relative:e.$ec.relative,e.$kc=m?e.$dc.dirname:e.$ec.dirname,e.$lc=m?e.$dc.basename:e.$ec.basename,e.$mc=m?e.$dc.extname:e.$ec.extname,e.$nc=m?e.$dc.format:e.$ec.format,e.$oc=m?e.$dc.parse:e.$ec.parse,e.$pc=m?e.$dc.toNamespacedPath:e.$ec.toNamespacedPath,e.sep=m?e.$dc.sep:e.$ec.sep,e.$rc=m?e.$dc.delimiter:e.$ec.delimiter}),define(be[39],we([1,0,7,3,17,10]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=void 0;function A(a){return a===47||a===92}e.$Of=A;function I(a){return a.replace(/[\\/]/g,D.$ec.sep)}e.$Pf=I;function w(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Qf=w;function $(a,b=D.$ec.sep){if(!a)return"";const p=a.length,E=a.charCodeAt(0);if(A(E)){if(A(a.charCodeAt(1))&&!A(a.charCodeAt(2))){let L=3;const j=L;for(;L<p&&!A(a.charCodeAt(L));L++);if(j!==L&&!A(a.charCodeAt(L+1))){for(L+=1;L<p;L++)if(A(a.charCodeAt(L)))return a.slice(0,L+1).replace(/[\\/]/g,b)}}return b}else if(f(E)&&a.charCodeAt(1)===58)return A(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<p;k++)if(A(a.charCodeAt(k)))return a.slice(0,k+1)}return""}e.$Rf=$;function C(a){if(!O.$i||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let p=2;const E=p;for(;p<a.length&&(b=a.charCodeAt(p),b!==92);p++);return!(E===p||(b=a.charCodeAt(p+1),isNaN(b)||b===92))}e.$Sf=C;const S=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function g(a,b=O.$i){const p=b?S:v;return!(!a||a.length===0||/^\s+$/.test(a)||(p.lastIndex=0,p.test(a))||b&&d.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}e.$Tf=g;function m(a,b,p){const E=a===b;return!p||E?E:!a||!b?!1:(0,r.$Ze)(a,b)}e.$Uf=m;function l(a,b,p,E=D.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(p){if(!(0,r.$1e)(a,b))return!1;if(b.length===a.length)return!0;let L=b.length;return b.charAt(b.length-1)===E&&L--,a.charAt(L)===E}return b.charAt(b.length-1)!==E&&(b+=E),a.indexOf(b)===0}e.$Vf=l;function f(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Wf=f;function u(a,b){return O.$i&&a.endsWith(":")&&(a+=D.sep),(0,D.$gc)(a)||(a=(0,D.$hc)(b,a)),a=(0,D.$fc)(a),O.$i?(a=(0,r.$Ie)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,r.$Ie)(a,D.sep),a||(a=D.sep)),a}e.$Xf=u;function c(a){const b=(0,D.$fc)(a);return O.$i?a.length>3?!1:y(b)&&(a.length===2||b.charCodeAt(2)===92):b===D.$ec.sep}e.$Yf=c;function y(a,b=O.$i){return b?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Zf=y;function h(a,b=O.$i){return y(a,b)?a[0]:void 0}e.$1f=h;function t(a,b,p){return b.length>a.length?-1:a===b?0:(p&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}e.$2f=t;function s(a){const b=a.split(":");let p,E,k;for(const L of b){const j=Number(L);(0,P.$Af)(j)?E===void 0?E=j:k===void 0&&(k=j):p=p?[p,L].join(":"):L}if(!p)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:p,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}e.$3f=s;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,b,p=8){let E="";for(let L=0;L<p;L++){let j;L===0&&O.$i&&!b&&(p===3||p===4)?j=i:j=o,E+=j.charAt(Math.floor(Math.random()*j.length))}let k;return b?k=`${b}-${E}`:k=E,a?(0,D.$hc)(a,k):k}e.$4f=n}),define(be[62],we([1,0,7]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=e.$Lr=e.$Kr=e.$Jr=e.$Ir=void 0,e.$Ir=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const O={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},r={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(C){const S=(0,D.$mc)(C),v=O[S.toLowerCase()];return v!==void 0?v:A(C)}e.$Jr=P;function A(C){const S=(0,D.$mc)(C);return r[S.toLowerCase()]}e.$Kr=A;function I(C){for(const S in r)if(r[S]===C)return S}e.$Lr=I;const w=/^(.+)\/(.+?)(;.+)?$/;function $(C,S){const v=w.exec(C);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:S?void 0:C}e.$Mr=$}),define(be[63],we([1,0,3]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ul=e.$tl=e.TerminateResponseCode=e.Source=void 0;var O;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(O||(e.Source=O={}));var r;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function P(I,...w){const $=w.reduce((v,d)=>(v[d]=!0,v),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(v=>!$[v]).forEach(v=>{for(let d=0;d<C.length;d++)if(v.search(C[d])!==-1){delete I[v];break}})}e.$tl=P;function A(I){I&&(delete I.DEBUG,D.$j&&delete I.DYLD_LIBRARY_PATH,D.$k&&delete I.LD_PRELOAD)}e.$ul=A}),define(be[4],we([1,0,7,3]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.$tc=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,P=/^\//,A=/^\/\//;function I(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!r.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!P.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(i,n){return!i&&!n?"file":i}function $(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==S&&(n=S+n):n=S;break}return n}const C="",S="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,b,p,E,k=!1){typeof n=="object"?(this.scheme=n.scheme||C,this.authority=n.authority||C,this.path=n.path||C,this.query=n.query||C,this.fragment=n.fragment||C):(this.scheme=w(n,k),this.authority=a||C,this.path=$(this.scheme,b||C),this.query=p||C,this.fragment=E||C,I(this,k))}get fsPath(){return y(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:b,path:p,query:E,fragment:k}=n;return a===void 0?a=this.scheme:a===null&&(a=C),b===void 0?b=this.authority:b===null&&(b=C),p===void 0?p=this.path:p===null&&(p=C),E===void 0?E=this.query:E===null&&(E=C),k===void 0?k=this.fragment:k===null&&(k=C),a===this.scheme&&b===this.authority&&p===this.path&&E===this.query&&k===this.fragment?this:new l(a,b,p,E,k)}static parse(n,a=!1){const b=v.exec(n);return b?new l(b[2]||C,o(b[4]||C),o(b[5]||C),o(b[7]||C),o(b[9]||C),a):new l(C,C,C,C,C)}static file(n){let a=C;if(O.$i&&(n=n.replace(/\\/g,S)),n[0]===S&&n[1]===S){const b=n.indexOf(S,2);b===-1?(a=n.substring(2),n=S):(a=n.substring(2,b),n=n.substring(b)||S)}return new l("file",a,n,C,C)}static from(n,a){return new l(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return O.$i&&n.scheme==="file"?b=d.file(D.$dc.join(y(n,!0),...a)).path:b=D.$ec.join(n.path,...a),n.with({path:b})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const a=new l(n);return a._formatted=n.external??null,a._fsPath=n._sep===m?n.fsPath??null:null,a}}else return n}}e.URI=d;function g(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$tc=g;const m=O.$i?1:void 0;class l extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const f={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(i,n,a){let b,p=-1;for(let E=0;E<i.length;E++){const k=i.charCodeAt(E);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||n&&k===47||a&&k===91||a&&k===93||a&&k===58)p!==-1&&(b+=encodeURIComponent(i.substring(p,E)),p=-1),b!==void 0&&(b+=i.charAt(E));else{b===void 0&&(b=i.substr(0,E));const L=f[k];L!==void 0?(p!==-1&&(b+=encodeURIComponent(i.substring(p,E)),p=-1),b+=L):p===-1&&(p=E)}}return p!==-1&&(b+=encodeURIComponent(i.substring(p))),b!==void 0?b:i}function c(i){let n;for(let a=0;a<i.length;a++){const b=i.charCodeAt(a);b===35||b===63?(n===void 0&&(n=i.substr(0,a)),n+=f[b]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function y(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,O.$i&&(a=a.replace(/\//g,"\\")),a}e.$uc=y;function h(i,n){const a=n?c:u;let b="",{scheme:p,authority:E,path:k,query:L,fragment:j}=i;if(p&&(b+=p,b+=":"),(E||p==="file")&&(b+=S,b+=S),E){let Y=E.indexOf("@");if(Y!==-1){const ce=E.substr(0,Y);E=E.substr(Y+1),Y=ce.lastIndexOf(":"),Y===-1?b+=a(ce,!1,!1):(b+=a(ce.substr(0,Y),!1,!1),b+=":",b+=a(ce.substr(Y+1),!1,!0)),b+="@"}E=E.toLowerCase(),Y=E.lastIndexOf(":"),Y===-1?b+=a(E,!1,!0):(b+=a(E.substr(0,Y),!1,!0),b+=E.substr(Y))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const Y=k.charCodeAt(1);Y>=65&&Y<=90&&(k=`/${String.fromCharCode(Y+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const Y=k.charCodeAt(0);Y>=65&&Y<=90&&(k=`${String.fromCharCode(Y+32)}:${k.substr(2)}`)}b+=a(k,!0,!1)}return L&&(b+="?",b+=a(L,!1,!1)),j&&(b+="#",b+=n?j:u(j,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(s)?i.replace(s,n=>t(n)):i}}),define(be[164],we([1,0,4]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Qp=e.$Pp=e.$Op=void 0;function O($){const C=$;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$Op=O;function r($){const C=[];let S;try{const v=JSON.parse($.arguments),d=v[v.length-1];d&&d.__$stack&&(v.pop(),S=d.__$stack),C.push(...v)}catch{C.push("Unable to log remote console arguments",$.arguments)}return{args:C,stack:S}}e.$Pp=r;function P($){if(typeof $!="string")return P(r($).stack);const C=$;if(C){const S=A(C),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Qp=P;function A($){if(!$)return $;const C=$.indexOf(`
`);return C===-1?$:$.substring(0,C)}function I($,C){const{args:S,stack:v}=r($),d=typeof S[0]=="string"&&S.length===1;let g=A(v);g&&(g=`(${g.trim()})`);let m=[];if(typeof S[0]=="string"?g&&d?m=[`%c[${C}] %c${S[0]} %c${g}`,w("blue"),w(""),w("grey")]:m=[`%c[${C}] %c${S[0]}`,w("blue"),w(""),...S.slice(1)]:m=[`%c[${C}]%`,w("blue"),...S],g&&!d&&m.push(g),typeof console[$.severity]!="function")throw new Error("Unknown console method");console[$.severity].apply(console,m)}e.log=I;function w($){return`color: ${$}`}}),define(be[50],we([1,0,15,4]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ih=e.$hh=e.$gh=void 0;function r(w){return JSON.stringify(w,A)}e.$gh=r;function P(w){let $=JSON.parse(w);return $=I($),$}e.$hh=P;function A(w,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:$.flags}:$}function I(w,$=0){if(!w||$>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return O.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 17:return new Date(w.source)}if(w instanceof D.$_d||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let C=0;C<w.length;++C)w[C]=I(w[C],$+1);else for(const C in w)Object.hasOwnProperty.call(w,C)&&(w[C]=I(w[C],$+1))}return w}e.$ih=I}),define(be[12],we([1,0,11,3,4]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.Schemas=void 0;var P;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(P||(e.Schemas=P={})),e.$5f="vscode-tkn",e.$6f="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(C){this.d=C}setDelegate(C){this.e=C}setServerRootPath(C){this.f=`${C}/${P.vscodeRemoteResource}`}set(C,S,v){this.a[C]=S,this.b[C]=v}setConnectionToken(C,S){this.c[C]=S}getPreferredWebSchema(){return this.d}rewrite(C){if(this.e)try{return this.e(C)}catch(l){return D.$Y(l),C}const S=C.authority;let v=this.a[S];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const d=this.b[S],g=this.c[S];let m=`path=${encodeURIComponent(C.path)}`;return typeof g=="string"&&(m+=`&${e.$6f}=${encodeURIComponent(g)}`),r.URI.from({scheme:O.$o?this.d:P.vscodeRemoteResource,authority:`${v}:${d}`,path:this.f,query:m})}}e.$7f=new A,e.$8f="vs/../../extensions",e.$9f="vs/../../node_modules",e.$0f="vs/../../node_modules.asar",e.$$f="vs/../../node_modules.asar.unpacked";class I{static{this.a="vscode-app"}asBrowserUri(C){const S=this.b(C,le);return this.uriToBrowserUri(S)}uriToBrowserUri(C){return C.scheme===P.vscodeRemote?e.$7f.rewrite(C):C.scheme===P.file&&(O.$m||O.$p&&O.$g.origin===`${P.vscodeFileResource}://${I.a}`)?C.with({scheme:P.vscodeFileResource,authority:C.authority||I.a,query:null,fragment:null}):C}asFileUri(C){const S=this.b(C,le);return this.uriToFileUri(S)}uriToFileUri(C){return C.scheme===P.vscodeFileResource?C.with({scheme:P.file,authority:C.authority!==I.a?C.authority:null,query:null,fragment:null}):C}b(C,S){return r.URI.isUri(C)?C:r.URI.parse(S.toUrl(C))}}e.$_f=new I;var w;(function($){const C=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(C.get("3"));const S="vscode-coi";function v(g){let m;typeof g=="string"?m=new URL(g).searchParams:g instanceof URL?m=g.searchParams:r.URI.isUri(g)&&(m=new URL(g.toString(!0)).searchParams);const l=m?.get(S);if(l)return C.get(l)}$.getHeadersFromQuery=v;function d(g,m,l){if(!globalThis.crossOriginIsolated)return;const f=m&&l?"3":l?"2":"1";g instanceof URLSearchParams?g.set(S,f):g[S]=f}$.addSearchParam=d})(w||(e.COI=w={}))}),define(be[165],we([1,0,93,12,3,4]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class A{constructor(v,d,g){this.id=v,this.dependencies=d,this.callback=g}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,d,g)=>{typeof v!="string"&&(g=d,d=v,v=null),(typeof d!="object"||!Array.isArray(d))&&(g=d,d=null),this.c.push(new A(v,d,g))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const d=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!d)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(d.dependencies)&&d.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${d.dependencies.join(", ")}`);return typeof d.callback=="function"?d.callback([]):d.callback}h(v){return new Promise((d,g)=>{const m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript");const l=()=>{m.removeEventListener("load",f),m.removeEventListener("error",u)},f=c=>{l(),d(this.c.pop())},u=c=>{l(),g(c)};m.addEventListener("load",f),m.addEventListener("error",u),this.f&&(v=this.f.createScriptURL(v)),m.setAttribute("src",v),document.getElementsByTagName("head")[0].appendChild(m)})}i(v){return new Promise((d,g)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),d(this.c.pop())}catch(m){g(m)}})}async j(v){try{const d=globalThis._VSCODE_NODE_MODULES.fs,g=globalThis._VSCODE_NODE_MODULES.vm,m=globalThis._VSCODE_NODE_MODULES.module,l=P.URI.parse(v).fsPath,f=d.readFileSync(l).toString(),u=m.wrap(f.replace(/^#!.*/,""));return new g.Script(u).runInThisContext().apply(),this.c.pop()}catch(d){throw d}}}const w=new Map;let $={};typeof globalThis.require=="object"&&($=globalThis.require.paths??{});async function C(S,v,d){if(D.$R){d===void 0&&(d=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),$[S]&&(S=$[S]);const g=`${S}/${v}`;if(w.has(g))return w.get(g);let m;if(/^\w[\w\d+.-]*:\/\//.test(g))m=g;else{const c=`${d&&!r.$o?O.$0f:O.$9f}/${g}`;m=O.$_f.asBrowserUri(c).toString(!0)}const l=I.INSTANCE.load(m);return w.set(g,l),l}else return await new Promise((g,m)=>{le([S],g,m)})}e.$dC=C}),define(be[19],we([1,0,39,12,7,3,17,4]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.DataUri=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function w(d){return(0,I.$uc)(d,!0)}e.$gg=w;class ${constructor(g){this.a=g}compare(g,m,l=!1){return g===m?0:(0,A.$Se)(this.getComparisonKey(g,l),this.getComparisonKey(m,l))}isEqual(g,m,l=!1){return g===m?!0:!g||!m?!1:this.getComparisonKey(g,l)===this.getComparisonKey(m,l)}getComparisonKey(g,m=!1){return g.with({path:this.a(g)?g.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(g){return this.a(g)}isEqualOrParent(g,m,l=!1){if(g.scheme===m.scheme){if(g.scheme===O.Schemas.file)return D.$Vf(w(g),w(m),this.a(g))&&g.query===m.query&&(l||g.fragment===m.fragment);if((0,e.$xg)(g.authority,m.authority))return D.$Vf(g.path,m.path,this.a(g),"/")&&g.query===m.query&&(l||g.fragment===m.fragment)}return!1}joinPath(g,...m){return I.URI.joinPath(g,...m)}basenameOrAuthority(g){return(0,e.$pg)(g)||g.authority}basename(g){return r.$ec.basename(g.path)}extname(g){return r.$ec.extname(g.path)}dirname(g){if(g.path.length===0)return g;let m;return g.scheme===O.Schemas.file?m=I.URI.file(r.$kc(w(g))).path:(m=r.$ec.dirname(g.path),g.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${g.toString})) resulted in a relative path`),m="/")),g.with({path:m})}normalizePath(g){if(!g.path.length)return g;let m;return g.scheme===O.Schemas.file?m=I.URI.file(r.$fc(w(g))).path:m=r.$ec.normalize(g.path),g.with({path:m})}relativePath(g,m){if(g.scheme!==m.scheme||!(0,e.$xg)(g.authority,m.authority))return;if(g.scheme===O.Schemas.file){const u=r.$jc(w(g),w(m));return P.$i?D.$Pf(u):u}let l=g.path||"/";const f=m.path||"/";if(this.a(g)){let u=0;for(const c=Math.min(l.length,f.length);u<c&&!(l.charCodeAt(u)!==f.charCodeAt(u)&&l.charAt(u).toLowerCase()!==f.charAt(u).toLowerCase());u++);l=f.substr(0,u)+l.substr(u)}return r.$ec.relative(l,f)}resolvePath(g,m){if(g.scheme===O.Schemas.file){const l=I.URI.file(r.$ic(w(g),m));return g.with({authority:l.authority,path:l.path})}return m=D.$Qf(m),g.with({path:r.$ec.resolve(g.path,m)})}isAbsolutePath(g){return!!g.path&&g.path[0]==="/"}isEqualAuthority(g,m){return g===m||g!==void 0&&m!==void 0&&(0,A.$Ze)(g,m)}hasTrailingPathSeparator(g,m=r.sep){if(g.scheme===O.Schemas.file){const l=w(g);return l.length>D.$Rf(l).length&&l[l.length-1]===m}else{const l=g.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(g.fsPath)}}removeTrailingPathSeparator(g,m=r.sep){return(0,e.$yg)(g,m)?g.with({path:g.path.substr(0,g.path.length-1)}):g}addTrailingPathSeparator(g,m=r.sep){let l=!1;if(g.scheme===O.Schemas.file){const f=w(g);l=f!==void 0&&f.length===D.$Rf(f).length&&f[f.length-1]===m}else{m="/";const f=g.path;l=f.length===1&&f.charCodeAt(f.length-1)===47}return!l&&!(0,e.$yg)(g,m)?g.with({path:g.path+"/"}):g}}e.$hg=$,e.$ig=new $(()=>!1),e.$jg=new $(d=>d.scheme===O.Schemas.file?!P.$k:!0),e.$kg=new $(d=>!0),e.$lg=e.$ig.isEqual.bind(e.$ig),e.$mg=e.$ig.isEqualOrParent.bind(e.$ig),e.$ng=e.$ig.getComparisonKey.bind(e.$ig),e.$og=e.$ig.basenameOrAuthority.bind(e.$ig),e.$pg=e.$ig.basename.bind(e.$ig),e.$qg=e.$ig.extname.bind(e.$ig),e.$rg=e.$ig.dirname.bind(e.$ig),e.$sg=e.$ig.joinPath.bind(e.$ig),e.$tg=e.$ig.normalizePath.bind(e.$ig),e.$ug=e.$ig.relativePath.bind(e.$ig),e.$vg=e.$ig.resolvePath.bind(e.$ig),e.$wg=e.$ig.isAbsolutePath.bind(e.$ig),e.$xg=e.$ig.isEqualAuthority.bind(e.$ig),e.$yg=e.$ig.hasTrailingPathSeparator.bind(e.$ig),e.$zg=e.$ig.removeTrailingPathSeparator.bind(e.$ig),e.$Ag=e.$ig.addTrailingPathSeparator.bind(e.$ig);function C(d,g){const m=[];for(let l=0;l<d.length;l++){const f=g(d[l]);d.some((u,c)=>c===l?!1:(0,e.$mg)(f,g(u)))||m.push(d[l])}return m}e.$Bg=C;var S;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function g(m){const l=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[y,h]=c.split(":");y&&h&&l.set(y,h)});const u=m.path.substring(0,m.path.indexOf(";"));return u&&l.set(d.META_DATA_MIME,u),l}d.parseMetaData=g})(S||(e.DataUri=S={}));function v(d,g,m){if(g){let l=d.path;return l&&l[0]!==r.$ec.sep&&(l=r.$ec.sep+l),d.with({scheme:m,authority:g,path:l})}return d.with({scheme:m})}e.$Cg=v}),define(be[14],we([1,0,20,11,5,2,19,3,148]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ch=e.$bh=e.$ah=e.Promises=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=void 0;function $(R){return!!R&&typeof R.then=="function"}e.$Dg=$;function C(R){const F=new D.$Vd,G=R(F.token),T=new Promise((q,z)=>{const ie=F.token.onCancellationRequested(()=>{ie.dispose(),F.dispose(),z(new O.$3)});Promise.resolve(G).then(B=>{ie.dispose(),F.dispose(),q(B)},B=>{ie.dispose(),F.dispose(),z(B)})});return new class{cancel(){F.cancel()}then(q,z){return T.then(q,z)}catch(q){return this.then(void 0,q)}finally(q){return T.finally(q)}}}e.$Eg=C;function S(R,F,G){return new Promise((T,q)=>{const z=F.onCancellationRequested(()=>{z.dispose(),T(G)});R.then(T,q).finally(()=>z.dispose())})}e.$Fg=S;function v(R,F){return new Promise((G,T)=>{const q=F.onCancellationRequested(()=>{q.dispose(),T(new O.$3)});R.then(G,T).finally(()=>q.dispose())})}e.$Gg=v;async function d(R){let F=-1;const G=R.map((T,q)=>T.then(z=>(F=q,z)));try{return await Promise.race(G)}finally{R.forEach((T,q)=>{q!==F&&T.cancel()})}}e.$Hg=d;function g(R,F,G){let T;const q=setTimeout(()=>{T?.(void 0),G?.()},F);return Promise.race([R.finally(()=>clearTimeout(q)),new Promise(z=>T=z)])}e.$Ig=g;function m(R){return new Promise((F,G)=>{const T=R();$(T)?T.then(F,G):F(T)})}e.$Jg=m;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(F){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=F,!this.b){const G=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(G,G).then(T)})}return new Promise((G,T)=>{this.b.then(G,T)})}return this.a=F(),new Promise((G,T)=>{this.a.then(q=>{this.a=null,G(q)},q=>{this.a=null,T(q)})})}dispose(){this.f=!0}}e.$Kg=l;class f{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.$Lg=f;class u{constructor(){this.a=new Map}queue(F,G){const q=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(F)===q&&this.a.delete(F)});return this.a.set(F,q),q}}e.$Mg=u;const c=(R,F)=>{let G=!0;const T=setTimeout(()=>{G=!1,F()},R);return{isTriggered:()=>G,dispose:()=>{clearTimeout(T),G=!1}}},y=R=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,R())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class h{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,G=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((q,z)=>{this.d=q,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=G===w.$Id?y(T):c(G,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Ng=h;class t{constructor(F){this.a=new h(F),this.b=new l}trigger(F,G){return this.a.trigger(()=>this.b.queue(F),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Og=t;class s{constructor(){this.a=!1,this.b=new Promise((F,G)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Pg=s;class o extends s{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.$Qg=o;function i(R,F){return F?new Promise((G,T)=>{const q=setTimeout(()=>{z.dispose(),G()},R),z=F.onCancellationRequested(()=>{clearTimeout(q),z.dispose(),T(new O.$3)})}):C(G=>i(R,G))}e.$Rg=i;function n(R,F=0,G){const T=setTimeout(()=>{R(),G&&q.dispose()},F),q=(0,P.$Oc)(()=>{clearTimeout(T),G?.deleteAndLeak(q)});return G?.add(q),q}e.$Sg=n;function a(R){const F=[];let G=0;const T=R.length;function q(){return G<T?R[G++]():null}function z(ie){ie!=null&&F.push(ie);const B=q();return B?B.then(z):Promise.resolve(F)}return Promise.resolve(null).then(z)}e.$Tg=a;function b(R,F=T=>!!T,G=null){let T=0;const q=R.length,z=()=>{if(T>=q)return Promise.resolve(G);const ie=R[T++];return Promise.resolve(ie()).then(X=>F(X)?Promise.resolve(X):z())};return z()}e.$Ug=b;function p(R,F=T=>!!T,G=null){if(R.length===0)return Promise.resolve(G);let T=R.length;const q=()=>{T=-1;for(const z of R)z.cancel?.()};return new Promise((z,ie)=>{for(const B of R)B.then(X=>{--T>=0&&F(X)?(q(),z(X)):T===0&&z(G)}).catch(X=>{--T>=0&&(q(),ie(X))})})}e.$Vg=p;class E{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new r.$Ld}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((G,T)=>{this.f.push({factory:F,c:G,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const G=F.factory();G.then(F.c,F.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Wg=E;class k extends E{constructor(){super(1)}}e.$Xg=k;class L{constructor(){this.a=new te,this.b=0}queue(F){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,F())):this.a.run(this.b++,F())}}e.$Yg=L;class j{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const F=new V;return this.b.add(F),F.p}g(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,G=A.$ig){const T=G.getComparisonKey(F);let q=this.a.get(T);if(!q){q=new k;const z=this.f++,ie=r.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(z),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$Yc),this.d.set(z,ie),this.a.set(T,q)}return q}h(){this.g()&&this.j()}j(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Zg=j;class Y{constructor(F,G){this.a=-1,typeof F=="function"&&typeof G=="number"&&this.setIfNotSet(F,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},G)}setIfNotSet(F,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},G))}}e.$1g=Y;class ce{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,G){this.cancel(),this.a=setInterval(()=>{F()},G)}}e.$2g=ce;class x{constructor(F,G){this.b=-1,this.a=F,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$3g=x;class ne{constructor(F,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=F,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$4g=ne;class ue extends x{constructor(F,G){super(F,G),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.$5g=ue;class _ extends P.$Qc{constructor(F,G){super(),this.g=F,this.h=G,this.a=[],this.b=this.B(new P.$Rc),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of F)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$6g=_,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$7g=R=>{(0,I.$A)(()=>{if(F)return;const G=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.$7g=(R,F)=>{const G=requestIdleCallback(R,typeof F=="number"?{timeout:F}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(G))}}}}();class he{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(G){this.g=G}finally{this.d=!0}},this.b=(0,e.$7g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$8g=he;async function ee(R,F,G){let T;for(let q=0;q<G;q++)try{return await R()}catch(z){T=z,await i(F)}throw T}e.$9g=ee;class te{isRunning(F){return typeof F=="number"?this.a?.taskId===F:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(F,G,T){return this.a={taskId:F,cancel:()=>T?.(),promise:G},G.then(()=>this.d(F),()=>this.d(F)),G}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}queue(F){if(this.b)this.b.run=F;else{let G,T;const q=new Promise((z,ie)=>{G=z,T=ie});this.b={run:F,promise:q,promiseResolve:G,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$0g=te;class W{constructor(F,G=()=>Date.now()){this.d=F,this.f=G,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.$$g=W;var K;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(K||(K={}));class V{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((F,G)=>{this.a=F,this.b=G})}complete(F){return new Promise(G=>{this.a(F),this.d={outcome:0,value:F},G()})}error(F){return new Promise(G=>{this.b(F),this.d={outcome:1,value:F},G()})}cancel(){return this.error(new O.$3)}}e.$_g=V;var oe;(function(R){async function F(T){let q;const z=await Promise.all(T.map(ie=>ie.then(B=>B,B=>{q||(q=B)})));if(typeof q<"u")throw q;return z}R.settled=F;function G(T){return new Promise(async(q,z)=>{try{await T(q,z)}catch(ie){z(ie)}})}R.withAsyncBody=G})(oe||(e.Promises=oe={}));var me;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(me||(me={}));class se{static fromArray(F){return new se(G=>{G.emitMany(F)})}static fromPromise(F){return new se(async G=>{G.emitMany(await F)})}static fromPromises(F){return new se(async G=>{await Promise.all(F.map(async T=>G.emitOne(await T)))})}static merge(F){return new se(async G=>{await Promise.all(F.map(async T=>{for await(const q of T)G.emitOne(q)}))})}static{this.EMPTY=se.fromArray([])}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new r.$Ld,queueMicrotask(async()=>{const G={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(F(G)),this.j()}catch(T){this.k(T)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(F,G){return new se(async T=>{for await(const q of F)T.emitOne(G(q))})}map(F){return se.map(this,F)}static filter(F,G){return new se(async T=>{for await(const q of F)G(q)&&T.emitOne(q)})}filter(F){return se.filter(this,F)}static coalesce(F){return se.filter(F,G=>!!G)}coalesce(){return se.coalesce(this)}static async toPromise(F){const G=[];for await(const T of F)G.push(T);return G}toPromise(){return se.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}e.$ah=se;class U extends se{constructor(F,G){super(G),this.l=F}cancel(){this.l.cancel()}}e.$bh=U;function Z(R){const F=new D.$Vd,G=R(F.token);return new U(F,async T=>{const q=F.token.onCancellationRequested(()=>{q.dispose(),F.dispose(),T.reject(new O.$3)});try{for await(const z of G){if(F.token.isCancellationRequested)return;T.emitOne(z)}q.dispose(),F.dispose()}catch(z){q.dispose(),F.dispose(),T.reject(z)}})}e.$ch=Z}),define(be[78],we([1,0,18,14,39,26,7,3,17]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=void 0;function $(){return Object.create(null)}e.$nj=$,e.$oj="**",e.$pj="/";const C="[/\\\\]",S="[^/\\\\]",v=/\//g;function d(te,W){switch(te){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${W?`|${C}${S}+`:""})*?`}}function g(te,W){if(!te)return[];const K=[];let V=!1,oe=!1,me="";for(const se of te){switch(se){case W:if(!V&&!oe){K.push(me),me="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}me+=se}return me&&K.push(me),K}e.$qj=g;function m(te){if(!te)return"";let W="";const K=g(te,e.$pj);if(K.every(V=>V===e.$oj))W=".*";else{let V=!1;K.forEach((oe,me)=>{if(oe===e.$oj){if(V)return;W+=d(2,me===K.length-1)}else{let se=!1,U="",Z=!1,R="";for(const F of oe){if(F!=="}"&&se){U+=F;continue}if(Z&&(F!=="]"||!R)){let G;F==="-"?G=F:(F==="^"||F==="!")&&!R?G="^":F===e.$pj?G="":G=(0,w.$De)(F),R+=G;continue}switch(F){case"{":se=!0;continue;case"[":Z=!0;continue;case"}":{const T=`(?:${g(U,",").map(q=>m(q)).join("|")})`;W+=T,se=!1,U="";break}case"]":{W+="["+R+"]",Z=!1,R="";break}case"?":W+=S;continue;case"*":W+=d(1);continue;default:W+=(0,w.$De)(F)}}me<K.length-1&&(K[me+1]!==e.$oj||me+2<K.length)&&(W+=C)}V=oe===e.$oj})}return W}const l=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Bc(1e4),s=function(){return!1},o=function(){return null};function i(te,W){if(!te)return o;let K;typeof te!="string"?K=te.pattern:K=te,K=K.trim();const V=`${K}_${!!W.trimForExclusions}`;let oe=t.get(V);if(oe)return n(oe,te);let me;return l.test(K)?oe=b(K.substr(4),K):(me=f.exec(a(K,W)))?oe=p(me[1],K):(W.trimForExclusions?c:u).test(K)?oe=E(K,W):(me=y.exec(a(K,W)))?oe=k(me[1].substr(1),K,!0):(me=h.exec(a(K,W)))?oe=k(me[1],K,!1):oe=L(K),t.set(V,oe),n(oe,te)}function n(te,W){if(typeof W=="string")return te;const K=function(V,oe){return(0,r.$Vf)(V,W.base,!I.$k)?te((0,w.$He)(V.substr(W.base.length),A.sep),oe):null};return K.allBasenames=te.allBasenames,K.allPaths=te.allPaths,K.basenames=te.basenames,K.patterns=te.patterns,K}function a(te,W){return W.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function b(te,W){return function(K,V){return typeof K=="string"&&K.endsWith(te)?W:null}}function p(te,W){const K=`/${te}`,V=`\\${te}`,oe=function(se,U){return typeof se!="string"?null:U?U===te?W:null:se===te||se.endsWith(K)||se.endsWith(V)?W:null},me=[te];return oe.basenames=me,oe.patterns=[W],oe.allBasenames=me,oe}function E(te,W){const K=he(te.slice(1,-1).split(",").map(U=>i(U,W)).filter(U=>U!==o),te),V=K.length;if(!V)return o;if(V===1)return K[0];const oe=function(U,Z){for(let R=0,F=K.length;R<F;R++)if(K[R](U,Z))return te;return null},me=K.find(U=>!!U.allBasenames);me&&(oe.allBasenames=me.allBasenames);const se=K.reduce((U,Z)=>Z.allPaths?U.concat(Z.allPaths):U,[]);return se.length&&(oe.allPaths=se),oe}function k(te,W,K){const V=A.sep===A.$ec.sep,oe=V?te:te.replace(v,A.sep),me=A.sep+oe,se=A.$ec.sep+te;let U;return K?U=function(Z,R){return typeof Z=="string"&&(Z===oe||Z.endsWith(me)||!V&&(Z===te||Z.endsWith(se)))?W:null}:U=function(Z,R){return typeof Z=="string"&&(Z===oe||!V&&Z===te)?W:null},U.allPaths=[(K?"*/":"./")+te],U}function L(te){try{const W=new RegExp(`^${m(te)}$`);return function(K){return W.lastIndex=0,typeof K=="string"&&W.test(K)?te:null}}catch{return o}}function j(te,W,K){return!te||typeof W!="string"?!1:Y(te)(W,void 0,K)}e.$rj=j;function Y(te,W={}){if(!te)return s;if(typeof te=="string"||ce(te)){const K=i(te,W);if(K===o)return s;const V=function(oe,me){return!!K(oe,me)};return K.allBasenames&&(V.allBasenames=K.allBasenames),K.allPaths&&(V.allPaths=K.allPaths),V}return ue(te,W)}e.$sj=Y;function ce(te){const W=te;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.$tj=ce;function x(te){return te.allBasenames||[]}e.$uj=x;function ne(te){return te.allPaths||[]}e.$vj=ne;function ue(te,W){const K=he(Object.getOwnPropertyNames(te).map(U=>_(U,te[U],W)).filter(U=>U!==o)),V=K.length;if(!V)return o;if(!K.some(U=>!!U.requiresSiblings)){if(V===1)return K[0];const U=function(F,G){let T;for(let q=0,z=K.length;q<z;q++){const ie=K[q](F,G);if(typeof ie=="string")return ie;(0,O.$Dg)(ie)&&(T||(T=[]),T.push(ie))}return T?(async()=>{for(const q of T){const z=await q;if(typeof z=="string")return z}return null})():null},Z=K.find(F=>!!F.allBasenames);Z&&(U.allBasenames=Z.allBasenames);const R=K.reduce((F,G)=>G.allPaths?F.concat(G.allPaths):F,[]);return R.length&&(U.allPaths=R),U}const oe=function(U,Z,R){let F,G;for(let T=0,q=K.length;T<q;T++){const z=K[T];z.requiresSiblings&&R&&(Z||(Z=(0,A.$lc)(U)),F||(F=Z.substr(0,Z.length-(0,A.$mc)(U).length)));const ie=z(U,Z,F,R);if(typeof ie=="string")return ie;(0,O.$Dg)(ie)&&(G||(G=[]),G.push(ie))}return G?(async()=>{for(const T of G){const q=await T;if(typeof q=="string")return q}return null})():null},me=K.find(U=>!!U.allBasenames);me&&(oe.allBasenames=me.allBasenames);const se=K.reduce((U,Z)=>Z.allPaths?U.concat(Z.allPaths):U,[]);return se.length&&(oe.allPaths=se),oe}function _(te,W,K){if(W===!1)return o;const V=i(te,K);if(V===o)return o;if(typeof W=="boolean")return V;if(W){const oe=W.when;if(typeof oe=="string"){const me=(se,U,Z,R)=>{if(!R||!V(se,U))return null;const F=oe.replace("$(basename)",()=>Z),G=R(F);return(0,O.$Dg)(G)?G.then(T=>T?te:null):G?te:null};return me.requiresSiblings=!0,me}}return V}function he(te,W){const K=te.filter(U=>!!U.basenames);if(K.length<2)return te;const V=K.reduce((U,Z)=>{const R=Z.basenames;return R?U.concat(R):U},[]);let oe;if(W){oe=[];for(let U=0,Z=V.length;U<Z;U++)oe.push(W)}else oe=K.reduce((U,Z)=>{const R=Z.patterns;return R?U.concat(R):U},[]);const me=function(U,Z){if(typeof U!="string")return null;if(!Z){let F;for(F=U.length;F>0;F--){const G=U.charCodeAt(F-1);if(G===47||G===92)break}Z=U.substr(F)}const R=V.indexOf(Z);return R!==-1?oe[R]:null};me.basenames=V,me.patterns=oe,me.allBasenames=V;const se=te.filter(U=>!U.basenames);return se.push(me),se}function ee(te,W){return(0,D.$sb)(te,W,(K,V)=>typeof K=="string"&&typeof V=="string"?K===V:typeof K!="string"&&typeof V!="string"?K.base===V.base&&K.pattern===V.pattern:!1)}e.$wj=ee}),define(be[101],we([1,0,11,149,19,17,4]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.MarkdownStringTextNewlineStyle=void 0;var I;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(I||(e.MarkdownStringTextNewlineStyle=I={}));class w{constructor(f="",u=!1){if(this.value=f,typeof this.value!="string")throw(0,D.$5)("value");typeof u=="boolean"?(this.isTrusted=u,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=u.isTrusted??void 0,this.supportThemeIcons=u.supportThemeIcons??!1,this.supportHtml=u.supportHtml??!1)}appendText(f,u=0){return this.value+=v(this.supportThemeIcons?(0,O.$Sj)(f):f).replace(/([ \t]+)/g,(c,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,u===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,u){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=u,this.value+="\n```\n",this}appendLink(f,u,c){return this.value+="[",this.value+=this.c(u,"]"),this.value+="](",this.value+=this.c(String(f),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(f,u){const c=new RegExp((0,P.$De)(u),"g");return f.replace(c,(y,h)=>f.charAt(h-1)!=="\\"?`\\${y}`:y)}}e.$Yj=w;function $(l){return C(l)?!l.value:Array.isArray(l)?l.every($):!0}e.$Zj=$;function C(l){return l instanceof w?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.$1j=C;function S(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons&&l.supportHtml===f.supportHtml&&(l.baseUri===f.baseUri||!!l.baseUri&&!!f.baseUri&&(0,r.$lg)(A.URI.from(l.baseUri),A.URI.from(f.baseUri)))}e.$2j=S;function v(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$3j=v;function d(l){return l.replace(/"/g,"&quot;")}e.$4j=d;function g(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$5j=g;function m(l){const f=[],u=l.split("|").map(y=>y.trim());l=u[0];const c=u[1];if(c){const y=/height=(\d+)/.exec(c),h=/width=(\d+)/.exec(c),t=y?y[1]:"",s=h?h[1]:"",o=isFinite(parseInt(s)),i=isFinite(parseInt(t));o&&f.push(`width="${s}"`),i&&f.push(`height="${t}"`)}return{href:l,dimensions:f}}e.$6j=m}),define(be[166],we([1,0,18,39,7,3,19,17]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=void 0;function w(i,n){const{os:a,tildify:b,relative:p}=n;if(p){const L=$(i,p,a);if(typeof L=="string")return L}let E=i.fsPath;if(a===1&&!P.$i?E=E.replace(/\//g,"\\"):a!==1&&P.$i&&(E=E.replace(/\\/g,"/")),a!==1&&b?.userHome){const L=b.userHome.fsPath;let j;i.scheme!==b.userHome.scheme&&i.path.startsWith(r.$ec.sep)?j=b.userHome.with({path:i.path}).fsPath:j=i.fsPath,E=v(j,L,a)}return(a===1?r.$dc:r.$ec).normalize(C(E,a===1))}e.$iv=w;function $(i,n,a){const b=a===1?r.$dc:r.$ec,p=a===3?A.$ig:A.$kg,E=n.getWorkspace(),k=(0,D.$Mb)(E.folders);if(!k)return;i.scheme!==k.uri.scheme&&i.path.startsWith(r.$ec.sep)&&(i=k.uri.with({path:i.path}));const L=n.getWorkspaceFolder(i);if(!L)return;let j;if(p.isEqual(L.uri,i)?j="":j=p.relativePath(L.uri,i)??"",j&&(j=b.normalize(j)),E.folders.length>1&&!n.noPrefix){const Y=L.name?L.name:p.basenameOrAuthority(L.uri);j=j?`${Y} \u2022 ${j}`:Y}return j}function C(i,n=P.$i){return(0,O.$Zf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$jv=C;let S=Object.create(null);function v(i,n,a=P.OS){if(a===1||!i||!n)return i;let b=S.original===n?S.normalized:void 0;b||(b=n,P.$i&&(b=(0,O.$Pf)(b)),b=`${(0,I.$Ie)(b,r.$ec.sep)}${r.$ec.sep}`,S={original:n,normalized:b});let p=i;return P.$i&&(p=(0,O.$Pf)(p)),(a===3?p.startsWith(b):(0,I.$1e)(p,b))?`~/${p.substr(b.length)}`:i}e.$kv=v;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$lv=d;const g="\u2026",m="\\\\",l="~";function f(i,n=r.sep){const a=new Array(i.length);let b=!1;for(let p=0;p<i.length;p++){const E=i[p];if(E===""){a[p]=`.${n}`;continue}if(!E){a[p]=E;continue}b=!0;let k="",L=E;L.indexOf(m)===0?(k=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length)):L.indexOf(n)===0?(k=L.substr(0,L.indexOf(n)+n.length),L=L.substr(L.indexOf(n)+n.length)):L.indexOf(l)===0&&(k=L.substr(0,L.indexOf(l)+l.length),L=L.substr(L.indexOf(l)+l.length));const j=L.split(n);for(let Y=1;b&&Y<=j.length;Y++)for(let ce=j.length-Y;b&&ce>=0;ce--){b=!1;let x=j.slice(ce,ce+Y).join(n);for(let ne=0;!b&&ne<i.length;ne++)if(ne!==p&&i[ne]&&i[ne].indexOf(x)>-1){const ue=ce+Y===j.length,_=ce>0&&i[ne].indexOf(n)>-1?n+x:x,he=i[ne].endsWith(_);b=!ue||he}if(!b){let ne="";(j[0].endsWith(":")||k!=="")&&(ce===1&&(ce=0,Y++,x=j[0]+n+x),ce>0&&(ne=j[0]+n),ne=k+ne),ce>0&&(ne=ne+g+n),ne=ne+x,ce+Y<j.length&&(ne=ne+n+g),a[p]=ne}}b&&(a[p]=E)}return a}e.$mv=f;var u;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function c(i,n=Object.create(null)){const a=[];let b=!1,p="";for(const E of i)if(E==="$"||b&&E==="{")p&&a.push({value:p,type:u.TEXT}),p="",b=!0;else if(E==="}"&&b){const k=n[p];if(typeof k=="string")k.length&&a.push({value:k,type:u.VARIABLE});else if(k){const L=a[a.length-1];(!L||L.type!==u.SEPARATOR)&&a.push({value:k.label,type:u.SEPARATOR})}p="",b=!1}else p+=E;return p&&!b&&a.push({value:p,type:u.TEXT}),a.filter((E,k)=>{if(E.type===u.SEPARATOR){const L=a[k-1],j=a[k+1];return[L,j].every(Y=>Y&&(Y.type===u.VARIABLE||Y.type===u.TEXT)&&Y.value.length>0)}return!0}).map(E=>E.value).join("")}e.$nv=c;function y(i,n){return P.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$ov=y;function h(i,n){return P.$j||n?i.replace(/\(&&\w\)|&&/g,""):P.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$pv=h;function t(i){return i.replace(/&/g,"&&")}e.$qv=t;function s(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=o(i.substring(0,n));return{name:a.name,parentPath:a.parentPath+i.substring(n)}}}return o(i)}e.$rv=s;function o(i){const n=i.indexOf("/")!==-1?r.$ec:r.$dc,a=n.basename(i),b=n.dirname(i);return a.length?{name:a,parentPath:b}:{name:b,parentPath:""}}}),define(be[51],we([1,0,15,4]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=void 0;function r(S){return S.toJSON()}class P{constructor(v){this.a=v}transformIncoming(v){const d=this.a.transformIncoming(v);return d===v?v:r(O.URI.from(d))}transformOutgoing(v){const d=this.a.transformOutgoing(v);return d===v?v:r(O.URI.from(d))}transformOutgoingURI(v){const d=this.a.transformOutgoing(v);return d===v?v:O.URI.from(d)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$Cm=P,e.$Dm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,v,d){if(!S||d>200)return null;if(typeof S=="object"){if(S instanceof O.URI)return v.transformOutgoing(S);for(const g in S)if(Object.hasOwnProperty.call(S,g)){const m=A(S[g],v,d+1);m!==null&&(S[g]=m)}}return null}function I(S,v){const d=A(S,v,0);return d===null?S:d}e.$Em=I;function w(S,v,d,g){if(!S||g>200)return null;if(typeof S=="object"){if(S.$mid===1)return d?O.URI.revive(v.transformIncoming(S)):v.transformIncoming(S);if(S instanceof D.$_d)return null;for(const m in S)if(Object.hasOwnProperty.call(S,m)){const l=w(S[m],v,d,g+1);l!==null&&(S[m]=l)}}return null}function $(S,v){const d=w(S,v,!1,0);return d===null?S:d}e.$Fm=$;function C(S,v){const d=w(S,v,!0,0);return d===null?S:d}e.$Gm=C}),define(be[167],we([1,0,27,292,293,3]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cg=void 0;async function A(I){if(P.$j||P.$i)return;let w;for(const $ of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{w=await(0,O.open)($,D.constants.R_OK);break}catch{}if(!w){I("Unable to retrieve release information from known identifier paths.");return}try{const $=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),C={id:"unknown"};for await(const S of(0,r.createInterface)({input:w.createReadStream(),crlfDelay:1/0})){if(!S.includes("="))continue;const v=S.split("=")[0].toUpperCase().trim();if($.has(v)){const d=S.split("=")[1].replace(/"/g,"").toLowerCase().trim();v==="ID"||v==="DISTRIB_ID"?C.id=d:v==="ID_LIKE"?C.id_like=d:(v==="VERSION_ID"||v==="DISTRIB_RELEASE")&&(C.version_id=d)}}return C}catch($){I($)}}e.$cg=A}),define(be[21],we([1,0,27,28,294,14,39,97,7,3,19,4]),function(le,e,D,O,r,P,A,I,w,$,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function d(_,he=v.UNLINK,ee){if((0,A.$Yf)(_))throw new Error("rimraf - will refuse to recursively delete root");return he===v.UNLINK?m(_):g(_,ee)}async function g(_,he=(0,A.$4f)((0,O.tmpdir)())){try{try{await D.promises.rename(_,he)}catch(ee){return ee.code==="ENOENT"?void 0:m(_)}m(he).catch(ee=>{})}catch(ee){if(ee.code!=="ENOENT")throw ee}}async function m(_){return(0,r.promisify)(D.rm)(_,{recursive:!0,force:!0,maxRetries:3})}function l(_){if((0,A.$Yf)(_))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=l;async function f(_,he){return y(await(he?u(_):(0,r.promisify)(D.readdir)(_)))}async function u(_){try{return await(0,r.promisify)(D.readdir)(_,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const he=[],ee=await f(_);for(const te of ee){let W=!1,K=!1,V=!1;try{const oe=await e.Promises.lstat((0,w.$hc)(_,te));W=oe.isFile(),K=oe.isDirectory(),V=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}he.push({name:te,isFile:()=>W,isDirectory:()=>K,isSymbolicLink:()=>V})}return he}function c(_){return y(D.readdirSync(_))}e.readdirSync=c;function y(_){return _.map(he=>typeof he=="string"?$.$j?(0,I.$il)(he):he:(he.name=$.$j?(0,I.$il)(he.name):he.name,he))}async function h(_){const he=await f(_),ee=[];for(const te of he)await s.existsDirectory((0,w.$hc)(_,te))&&ee.push(te);return ee}function t(_,he=1e3){return new Promise(ee=>{let te=!1;const W=setInterval(()=>{te||(te=!0,D.access(_,K=>{te=!1,K&&(clearInterval(W),ee(void 0))}))},he)})}e.whenDeleted=t;var s;(function(_){async function he(W){let K;try{if(K=await e.Promises.lstat(W),!K.isSymbolicLink())return{stat:K}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if($.$i&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw oe}throw V}}_.stat=he;async function ee(W){try{const{stat:K,symbolicLink:V}=await _.stat(W);return K.isFile()&&V?.dangling!==!0}catch{}return!1}_.existsFile=ee;async function te(W){try{const{stat:K,symbolicLink:V}=await _.stat(W);return K.isDirectory()&&V?.dangling!==!0}catch{}return!1}_.existsDirectory=te})(s||(e.SymlinkSupport=s={}));const o=new P.$Zg;function i(_,he,ee){return o.queueFor(S.URI.file(_),C.$jg).queue(()=>{const te=E(ee);return new Promise((W,K)=>b(_,he,te,V=>V?K(V):W()))})}let n=!0;function a(_){n=_}e.configureFlushOnWrite=a;function b(_,he,ee,te){if(!n)return D.writeFile(_,he,{mode:ee.mode,flag:ee.flag},te);D.open(_,ee.flag,ee.mode,(W,K)=>{if(W)return te(W);D.writeFile(K,he,V=>{if(V)return D.close(K,()=>te(V));D.fdatasync(K,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),a(!1)),D.close(K,me=>te(me))))})})}function p(_,he,ee){const te=E(ee);if(!n)return D.writeFileSync(_,he,{mode:te.mode,flag:te.flag});const W=D.openSync(_,te.flag,te.mode);try{D.writeFileSync(W,he);try{D.fdatasyncSync(W)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),a(!1)}}finally{D.closeSync(W)}}e.writeFileSync=p;function E(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function k(_,he,ee=6e4){if(_!==he)try{$.$i&&typeof ee=="number"?await L(_,he,Date.now(),ee):await(0,r.promisify)(D.rename)(_,he)}catch(te){if(_.toLowerCase()!==he.toLowerCase()&&te.code==="EXDEV"||_.endsWith("."))await j(_,he,{preserveSymlinks:!1}),await d(_,v.MOVE);else throw te}}async function L(_,he,ee,te,W=0){try{return await(0,r.promisify)(D.rename)(_,he)}catch(K){if(K.code!=="EACCES"&&K.code!=="EPERM"&&K.code!=="EBUSY")throw K;if(Date.now()-ee>=te)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${K}`),K;if(W===0){let V=!1;try{const{stat:oe}=await s.stat(he);oe.isFile()||(V=!0)}catch{}if(V)throw K}return await(0,P.$Rg)(Math.min(100,W*10)),L(_,he,ee,te,W+1)}}async function j(_,he,ee){return ce(_,he,{root:{source:_,target:he},options:ee,handledSourcePaths:new Set})}const Y=511;async function ce(_,he,ee){if(ee.handledSourcePaths.has(_))return;ee.handledSourcePaths.add(_);const{stat:te,symbolicLink:W}=await s.stat(_);if(W){if(ee.options.preserveSymlinks)try{return await ue(_,he,ee)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}if(W.dangling)return}return te.isDirectory()?x(_,he,te.mode&Y,ee):ne(_,he,te.mode&Y)}async function x(_,he,ee,te){await e.Promises.mkdir(he,{recursive:!0,mode:ee});const W=await f(_);for(const K of W)await ce((0,w.$hc)(_,K),(0,w.$hc)(he,K),te)}async function ne(_,he,ee){await e.Promises.copyFile(_,he),await e.Promises.chmod(he,ee)}async function ue(_,he,ee){let te=await e.Promises.readlink(_);(0,A.$Vf)(te,ee.root.source,!$.$k)&&(te=(0,w.$hc)(ee.root.target,te.substr(ee.root.source.length+1))),await e.Promises.symlink(te,he)}e.Promises=new class{get access(){return(0,r.promisify)(D.access)}get stat(){return(0,r.promisify)(D.stat)}get lstat(){return(0,r.promisify)(D.lstat)}get utimes(){return(0,r.promisify)(D.utimes)}get read(){return(_,he,ee,te,W)=>new Promise((K,V)=>{D.read(_,he,ee,te,W,(oe,me,se)=>oe?V(oe):K({bytesRead:me,buffer:se}))})}get readFile(){return(0,r.promisify)(D.readFile)}get write(){return(_,he,ee,te,W)=>new Promise((K,V)=>{D.write(_,he,ee,te,W,(oe,me,se)=>oe?V(oe):K({bytesWritten:me,buffer:se}))})}get appendFile(){return(0,r.promisify)(D.appendFile)}get fdatasync(){return(0,r.promisify)(D.fdatasync)}get truncate(){return(0,r.promisify)(D.truncate)}get copyFile(){return(0,r.promisify)(D.copyFile)}get open(){return(0,r.promisify)(D.open)}get close(){return(0,r.promisify)(D.close)}get symlink(){return(0,r.promisify)(D.symlink)}get readlink(){return(0,r.promisify)(D.readlink)}get chmod(){return(0,r.promisify)(D.chmod)}get mkdir(){return(0,r.promisify)(D.mkdir)}get unlink(){return(0,r.promisify)(D.unlink)}get rmdir(){return(0,r.promisify)(D.rmdir)}get realpath(){return(0,r.promisify)(D.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return d}get rename(){return k}get copy(){return j}}}),define(be[168],we([1,0,27,7,3,17,21]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=e.$Xp=e.$Wp=e.$Vp=void 0;function I(v){if(r.$k)return v;const d=(0,O.$kc)(v);if(v===d)return v;const g=((0,O.$lc)(v)||v).toLowerCase();try{const l=(0,A.readdirSync)(d).filter(f=>f.toLowerCase()===g);if(l.length===1){const f=I(d);if(f)return(0,O.$hc)(f,l[0])}else if(l.length>1){const f=l.indexOf(g);if(f>=0){const u=I(d);if(u)return(0,O.$hc)(u,l[f])}}}catch{}return null}e.$Vp=I;async function w(v){if(r.$k)return v;const d=(0,O.$kc)(v);if(v===d)return v;const g=((0,O.$lc)(v)||v).toLowerCase();try{const l=(await A.Promises.readdir(d)).filter(f=>f.toLowerCase()===g);if(l.length===1){const f=await w(d);if(f)return(0,O.$hc)(f,l[0])}else if(l.length>1){const f=l.indexOf(g);if(f>=0){const u=await w(d);if(u)return(0,O.$hc)(u,l[f])}}}catch{}return null}e.$Wp=w;async function $(v){try{return await A.Promises.realpath(v)}catch{const g=S(v);return await A.Promises.access(g,D.constants.R_OK),g}}e.$Xp=$;function C(v){try{return D.realpathSync(v)}catch{const g=S(v);return D.accessSync(g,D.constants.R_OK),g}}e.$Yp=C;function S(v){return(0,P.$Ie)((0,O.$fc)(v),O.sep)}}),define(be[102],we([1,0,28,7,21]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sl=e.$rl=void 0;const P=/^\d+$/,A=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var w;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(w||(w={}));let $;switch(process.arch){case"ia32":$=1;break;case"arm":case"arm64":$=2;break;default:$=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class S{constructor(h,t,s){this.exePath=h,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:y=!1}={}){return y?$===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:y=!1,findPreview:h=!1}={}){const t=v({useAlternateBitness:y});if(!t)return null;const s=O.$hc(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(s))return null;let o=-1,i=null;for(const b of await r.Promises.readdir(s)){let p=-1;if(h){const k=b.indexOf("-");if(k<0)continue;const L=b.substring(0,k);if(!P.test(L)||b.substring(k+1)!=="preview")continue;p=parseInt(L,10)}else{if(!P.test(b))continue;p=parseInt(b,10)}if(p<=o)continue;const E=O.$hc(s,b,"pwsh.exe");await r.SymlinkSupport.existsFile(E)&&(i=E,o=p)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=h?" Preview":"";return new S(i,`PowerShell${a}${n}`,!0)}async function g({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const h=O.$hc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=y?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const o of await r.Promises.readdir(h))if(t.test(o)){const i=O.$hc(h,o,"pwsh.exe");return new S(i,s)}return null}function m(){const y=O.$hc(D.homedir(),".dotnet","tools","pwsh.exe");return new S(y,".NET Core PowerShell Global Tool")}function l(){const y=O.$hc(process.env.windir,$===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(y,"Windows PowerShell",!0)}async function*f(){let y=await d();y&&(yield y),y=await d({useAlternateBitness:!0}),y&&(yield y),y=await g(),y&&(yield y),y=m(),y&&(yield y),y=await d({findPreview:!0}),y&&(yield y),y=await g({findPreview:!0}),y&&(yield y),y=await d({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=l(),y&&(yield y)}async function*u(){for await(const y of f())await y.exists()&&(yield y)}e.$rl=u;async function c(){for await(const y of u())return y;return null}e.$sl=c}),define(be[103],we([1,0,7,3,29,63,10,21]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$wl=e.$vl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function w(S=r.env){return S.comspec||"cmd.exe"}e.$vl=w;function $(S){let v=[],d=!1;const g=function(m){if(d){v.push(m);return}(!S.send(m,f=>{if(f&&console.error(f),d=!1,v.length>0){const u=v.slice(0);v=[],u.forEach(c=>g(c))}})||O.$i)&&(d=!0)};return{send:g}}e.$wl=$;var C;(function(S){async function v(d,g,m){if(D.$gc(d))return d;if(g===void 0&&(g=r.cwd()),D.$kc(d)!=="."||(m===void 0&&A.$wf(r.env.PATH)&&(m=r.env.PATH.split(D.$rc)),m===void 0||m.length===0))return D.$hc(g,d);async function f(u){if(await I.Promises.exists(u)){let c;try{c=await I.Promises.stat(u)}catch(y){y.message.startsWith("EACCES")&&(c=await I.Promises.lstat(u))}return c?!c.isDirectory():!1}return!1}for(const u of m){let c;if(D.$gc(u)?c=D.$hc(u,d):c=D.$hc(g,u,d),await f(c))return c;let y=c+".com";if(await f(y)||(y=c+".exe",await f(y)))return y}return D.$hc(g,d)}S.findExecutable=v})(C||(e.win32=C={}))}),define(be[104],we([1,0,52,12]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=void 0;function r(A){return new Promise((I,w)=>{let $;const C=new Map;function S(d,g,m,l,f){const u=C.get(g);if(d===A||u){const c={name:v(m),cmd:m,pid:d,ppid:g,load:l,mem:f};C.set(d,c),d===A&&($=c),u&&(u.children||(u.children=[]),u.children.push(c),u.children.length>1&&(u.children=u.children.sort((y,h)=>y.pid-h.pid)))}}function v(d){const g=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,l=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(l.exec(d))return"electron-crash-reporter";if(f.exec(d))return"winpty-agent";if(u.exec(d))return"conpty-agent";let y=c.exec(d);if(y&&y.length===2)return y[1]==="renderer"?"window":y[1]==="utility"?g.exec(d)?"utility-network-service":"utility-process":y[1]==="extensionHost"?"extension-host":y[1];const h=/[a-zA-Z-]+\.js/g;let t="";do y=h.exec(d),y&&(t+=y+" ");while(y);return t&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${t})`:m.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substring(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substring(5):g;new Promise((g,m)=>{le(["@vscode/windows-process-tree"],g,m)}).then(g=>{g.getProcessList(A,m=>{if(!m){w(new Error(`Root process ${A} not found`));return}g.getProcessCpuUsage(m,l=>{const f=new Map;l.forEach(u=>{const c=d(u.commandLine||"");f.set(u.pid,{name:v(c),cmd:c,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),$=f.get(A),$?(f.forEach(u=>{const c=f.get(u.ppid);c&&(c.children||(c.children=[]),c.children.push(u))}),f.forEach(u=>{u.children&&(u.children=u.children.sort((c,y)=>c.pid-y.pid))}),I($)):w(new Error(`Root process ${A} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{let d=function(){let g=[$];const m=[];for(;g.length;){const f=g.shift();f&&(m.push(f.pid),f.children&&(g=g.concat(f.children)))}let l=JSON.stringify(O.$_f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);l+=" "+m.join(" "),(0,D.exec)(l,{},(f,u,c)=>{if(f||c)w(f||new Error(c.toString()));else{const y=u.toString().split(`
`);for(let h=0;h<m.length;h++){const t=C.get(m[h]);t.load=parseFloat(y[h])}if(!$){w(new Error(`Root process ${A} not found`));return}I($)}})};(0,D.exec)("which ps",{},(g,m,l)=>{if(g||l)if(process.platform!=="linux")w(g||new Error(l.toString()));else{const f=JSON.stringify(O.$_f.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(f,{},(u,c,y)=>{u||y?w(u||new Error(y.toString())):(P(c,S),d())})}else{const f=m.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${f} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,y,h)=>{c||h&&!h.includes("screen size is bogus")?w(c||new Error(h.toString())):(P(y,S),process.platform==="linux"?d():$?I($):w(new Error(`Root process ${A} not found`)))})}})}})}e.$tr=r;function P(A,I){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,$=A.toString().split(`
`);for(const C of $){const S=w.exec(C.trim());S&&S.length===6&&I(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(be[105],we([1,0,28,3,102,103]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=void 0;async function A(S,v){return S===1?O.$i?C():P.$vl(v):w(S,v)}e.$xl=A;let I=null;function w(S,v){if(O.$k&&S===2||O.$j&&S===3)return"/bin/bash";if(!I){let d;if(O.$i)d="/bin/bash";else{if(d=v.SHELL,!d)try{d=(0,D.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}I=d}return I}let $=null;async function C(){return $||($=(await(0,r.$sl)()).exePath),$}});var Oe=this&&this.__decorate||function(le,e,D,O){var r=arguments.length,P=r<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,D):O,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(le,e,D,O);else for(var I=le.length-1;I>=0;I--)(A=le[I])&&(P=(r<3?A(P):r>3?A(e,D,P):A(e,D))||P);return r>3&&P&&Object.defineProperty(e,D,P),P};define(be[43],we([1,0,18,14,15,20,73,11,5,2,50,17,10]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.ProxyChannel=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.RequestInitiator=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=void 0;var d;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(d||(d={}));function g(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(m||(m={}));function l(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(f||(f={}));function u(W){let K=0;for(let V=0;;V+=7){const oe=W.read(1);if(K|=(oe.buffer[0]&127)<<V,!(oe.buffer[0]&128))return K}}const c=o(0);function y(W,K){if(K===0){W.write(c);return}let V=0;for(let me=K;me!==0;me=me>>>7)V++;const oe=r.$_d.alloc(V);for(let me=0;K!==0;me++)oe.buffer[me]=K&127,K=K>>>7,K>0&&(oe.buffer[me]|=128);W.write(oe)}class h{constructor(K){this.b=K,this.a=0}read(K){const V=this.b.slice(this.a,this.a+K);return this.a+=V.byteLength,V}}e.$jh=h;class t{constructor(){this.a=[]}get buffer(){return r.$_d.concat(this.a)}write(K){this.a.push(K)}}e.$kh=t;var s;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(s||(s={}));function o(W){const K=r.$_d.alloc(1);return K.writeUInt8(W,0),K}const i={Undefined:o(s.Undefined),String:o(s.String),Buffer:o(s.Buffer),VSBuffer:o(s.VSBuffer),Array:o(s.Array),Object:o(s.Object),Uint:o(s.Int)},n=typeof Buffer<"u";function a(W,K){if(typeof K>"u")W.write(i.Undefined);else if(typeof K=="string"){const V=r.$_d.fromString(K);W.write(i.String),y(W,V.byteLength),W.write(V)}else if(n&&Buffer.isBuffer(K)){const V=r.$_d.wrap(K);W.write(i.Buffer),y(W,V.byteLength),W.write(V)}else if(K instanceof r.$_d)W.write(i.VSBuffer),y(W,K.byteLength),W.write(K);else if(Array.isArray(K)){W.write(i.Array),y(W,K.length);for(const V of K)a(W,V)}else if(typeof K=="number"&&(K|0)===K)W.write(i.Uint),y(W,K);else{const V=r.$_d.fromString(JSON.stringify(K));W.write(i.Object),y(W,V.byteLength),W.write(V)}}e.$lh=a;function b(W){switch(W.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return W.read(u(W)).toString();case s.Buffer:return W.read(u(W)).buffer;case s.VSBuffer:return W.read(u(W));case s.Array:{const V=u(W),oe=[];for(let me=0;me<V;me++)oe.push(b(W));return oe}case s.Object:return JSON.parse(W.read(u(W)).toString());case s.Int:return u(W)}}e.$mh=b;class p{constructor(K,V,oe=null,me=1e3){this.h=K,this.j=V,this.k=oe,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:200})}registerChannel(K,V){this.b.set(K,V),setTimeout(()=>this.w(K),0)}m(K){switch(K.type){case 200:{const V=this.o([K.type]);this.k?.logOutgoing(V,0,1,l(K.type));return}case 201:case 202:case 204:case 203:{const V=this.o([K.type,K.id],K.data);this.k?.logOutgoing(V,K.id,1,l(K.type),K.data);return}}}o(K,V=void 0){const oe=new t;return a(oe,K),a(oe,V),this.p(oe.buffer)}p(K){try{return this.h.send(K),K.byteLength}catch{return 0}}q(K){const V=new h(K),oe=b(V),me=b(V),se=oe[0];switch(se){case 100:return this.k?.logIncoming(K.byteLength,oe[1],1,`${g(se)}: ${oe[2]}.${oe[3]}`,me),this.s({type:se,id:oe[1],channelName:oe[2],name:oe[3],arg:me});case 102:return this.k?.logIncoming(K.byteLength,oe[1],1,`${g(se)}: ${oe[2]}.${oe[3]}`,me),this.t({type:se,id:oe[1],channelName:oe[2],name:oe[3],arg:me});case 101:return this.k?.logIncoming(K.byteLength,oe[1],1,`${g(se)}`),this.u({type:se,id:oe[1]});case 103:return this.k?.logIncoming(K.byteLength,oe[1],1,`${g(se)}`),this.u({type:se,id:oe[1]})}}s(K){const V=this.b.get(K.channelName);if(!V){this.v(K);return}const oe=new P.$Vd;let me;try{me=V.call(this.j,K.name,K.arg,oe.token)}catch(Z){me=Promise.reject(Z)}const se=K.id;me.then(Z=>{this.m({id:se,data:Z,type:201})},Z=>{Z instanceof Error?this.m({id:se,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:202}):this.m({id:se,data:Z,type:203})}).finally(()=>{U.dispose(),this.d.delete(K.id)});const U=(0,$.$Oc)(()=>oe.cancel());this.d.set(K.id,U)}t(K){const V=this.b.get(K.channelName);if(!V){this.v(K);return}const oe=K.id,se=V.listen(this.j,K.name,K.arg)(U=>this.m({id:oe,data:U,type:204}));this.d.set(K.id,se)}u(K){const V=this.d.get(K.id);V&&(V.dispose(),this.d.delete(K.id))}v(K){let V=this.g.get(K.channelName);V||(V=[],this.g.set(K.channelName,V));const oe=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.m({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:K,timeoutTimer:oe})}w(K){const V=this.g.get(K);if(V){for(const oe of V)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(K)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,$.$Lc)(this.d.values()),this.d.clear()}}e.$nh=p;var E;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class k{constructor(K,V=null){this.l=K,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$Ld,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=V}getChannel(K){const V=this;return{call(oe,me,se){return V.a?Promise.reject(new I.$3):V.m(K,oe,me,se)},listen(oe,me){return V.a?w.Event.None:V.o(K,oe,me)}}}m(K,V,oe,me=P.CancellationToken.None){const se=this.g++,Z={id:se,type:100,channelName:K,name:V,arg:oe};if(me.isCancellationRequested)return Promise.reject(new I.$3);let R;return new Promise((G,T)=>{if(me.isCancellationRequested)return T(new I.$3);const q=()=>{const X=H=>{switch(H.type){case 201:this.f.delete(se),G(H.data);break;case 202:{this.f.delete(se);const Q=new Error(H.data.message);Q.stack=Array.isArray(H.data.stack)?H.data.stack.join(`
`):H.data.stack,Q.name=H.data.name,T(Q);break}case 203:this.f.delete(se),T(H.data);break}};this.f.set(se,X),this.p(Z)};let z=null;this.b===f.Idle?q():(z=(0,O.$Eg)(X=>this.u()),z.then(()=>{z=null,q()}));const ie=()=>{z?(z.cancel(),z=null):this.p({id:se,type:101}),T(new I.$3)},B=me.onCancellationRequested(ie);R=(0,$.$Nc)((0,$.$Oc)(ie),B),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(K,V,oe){const me=this.g++,U={id:me,type:102,channelName:K,name:V,arg:oe};let Z=null;const R=new w.$Ld({onWillAddFirstListener:()=>{Z=(0,O.$Eg)(G=>this.u()),Z.then(()=>{Z=null,this.d.add(R),this.p(U)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.d.delete(R),this.p({id:me,type:103}))}}),F=G=>R.fire(G.data);return this.f.set(me,F),R.event}p(K){switch(K.type){case 100:case 102:{const V=this.q([K.type,K.id,K.channelName,K.name],K.arg);this.j?.logOutgoing(V,K.id,0,`${g(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const V=this.q([K.type,K.id]);this.j?.logOutgoing(V,K.id,0,g(K.type));return}}}q(K,V=void 0){const oe=new t;return a(oe,K),a(oe,V),this.r(oe.buffer)}r(K){try{return this.l.send(K),K.byteLength}catch{return 0}}s(K){const V=new h(K),oe=b(V),me=b(V),se=oe[0];switch(se){case 200:return this.j?.logIncoming(K.byteLength,0,0,l(se)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(K.byteLength,oe[1],0,l(se),me),this.t({type:oe[0],id:oe[1],data:me})}}t(K){if(K.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(K.id)?.(K)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,$.$Lc)(this.d.values()),this.d.clear()}}e.$oh=k,Oe([A.$dh],k.prototype,"onDidInitializePromise",null);class L{get connections(){const K=[];return this.f.forEach(V=>K.push(V)),K}constructor(K){this.a=new Map,this.f=new Set,this.g=new w.$Ld,this.onDidAddConnection=this.g.event,this.h=new w.$Ld,this.onDidRemoveConnection=this.h.event,this.j=new $.$Pc,this.j.add(K(({protocol:V,onDidClientDisconnect:oe})=>{const me=w.Event.once(V.onMessage);this.j.add(me(se=>{const U=new h(se),Z=b(U),R=new p(V,Z),F=new k(V);this.a.forEach((T,q)=>R.registerChannel(q,T));const G={channelServer:R,channelClient:F,ctx:Z};this.f.add(G),this.g.fire(G),this.j.add(oe(()=>{R.dispose(),F.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(K,V){const oe=this;return{call(me,se,U){let Z;if((0,v.$Kf)(V)){const F=(0,D.$2b)(oe.connections.filter(V));Z=F?Promise.resolve(F):w.Event.toPromise(w.Event.filter(oe.onDidAddConnection,V))}else Z=V.routeCall(oe,me,se);const R=Z.then(F=>F.channelClient.getChannel(K));return Y(R).call(me,se,U)},listen(me,se){if((0,v.$Kf)(V))return oe.k(K,V,me,se);const U=V.routeEvent(oe,me,se).then(Z=>Z.channelClient.getChannel(K));return Y(U).listen(me,se)}}}k(K,V,oe,me){const se=this;let U;const Z=new w.$Ld({onWillAddFirstListener:()=>{U=new $.$Pc;const R=new w.$Rd,F=new Map,G=q=>{const ie=q.channelClient.getChannel(K).listen(oe,me),B=R.add(ie);F.set(q,B)},T=q=>{const z=F.get(q);z&&(z.dispose(),F.delete(q))};se.connections.filter(V).forEach(G),w.Event.filter(se.onDidAddConnection,V)(G,void 0,U),se.onDidRemoveConnection(T,void 0,U),R.event(Z.fire,Z,U),U.add(R)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return Z.event}registerChannel(K,V){this.a.set(K,V);for(const oe of this.f)oe.channelServer.registerChannel(K,V)}dispose(){this.j.dispose();for(const K of this.f)K.channelClient.dispose(),K.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ph=L;class j{constructor(K,V,oe=null){const me=new t;a(me,V),K.send(me.buffer),this.a=new k(K,oe),this.d=new p(K,V,oe)}getChannel(K){return this.a.getChannel(K)}registerChannel(K,V){this.d.registerChannel(K,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$qh=j;function Y(W){return{call(K,V,oe){return W.then(me=>me.call(K,V,oe))},listen(K,V){const oe=new w.$Ud;return W.then(me=>oe.input=me.listen(K,V)),oe.event}}}e.$rh=Y;function ce(W){let K=!1;return{call(V,oe,me){return K?W.call(V,oe,me):(0,O.$Rg)(0).then(()=>K=!0).then(()=>W.call(V,oe,me))},listen(V,oe){if(K)return W.listen(V,oe);const me=new w.$Ud;return(0,O.$Rg)(0).then(()=>K=!0).then(()=>me.input=W.listen(V,oe)),me.event}}}e.$sh=ce;class x{constructor(K){this.a=K}routeCall(K){return this.b(K)}routeEvent(K){return this.b(K)}async b(K){for(const V of K.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await w.Event.toPromise(K.onDidAddConnection),await this.b(K)}}e.$th=x;var ne;(function(W){function K(se,U,Z){const R=se,F=Z&&Z.disableMarshalling,G=new Map;for(const T in R)oe(T)&&G.set(T,w.Event.buffer(R[T],!0,void 0,U));return new class{listen(T,q,z){const ie=G.get(q);if(ie)return ie;if(me(q)){const B=R[q];if(typeof B=="function")return B.call(R,z)}throw new I.$_(`Event not found: ${q}`)}call(T,q,z){const ie=R[q];if(typeof ie=="function"){if(!F&&Array.isArray(z))for(let X=0;X<z.length;X++)z[X]=(0,C.$ih)(z[X]);let B=ie.apply(R,z);return B instanceof Promise||(B=Promise.resolve(B)),B}throw new I.$_(`Method not found: ${q}`)}}}W.fromService=K;function V(se,U){const Z=U&&U.disableMarshalling;return new Proxy({},{get(R,F){if(typeof F=="string")return U?.properties?.has(F)?U.properties.get(F):me(F)?function(G){return se.listen(F,G)}:oe(F)?se.listen(F):async function(...G){let T;U&&!(0,v.$Ff)(U.context)?T=[U.context,...G]:T=G;const q=await se.call(F,T);return Z?q:(0,C.$ih)(q)};throw new I.$_(`Property not found: ${String(F)}`)}})}W.toService=V;function oe(se){return se[0]==="o"&&se[1]==="n"&&S.$Ye(se.charCodeAt(2))}function me(se){return/^onDynamic/.test(se)&&S.$Ye(se.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const K=W.toString();if(K!=="[object Object]")return K}return W}function he(W){return Array.isArray(W)?W.map(_):_(W)}function ee(W,K,V,oe,me,se,U){U=he(U);const Z=ue[me],R=Z[oe%Z.length];let F=[`%c[${W}]%c[${String(K).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(se)?(F=F.concat(U),F.push(")")):F.push(U),console.log.apply(console,F)}class te{constructor(K,V){this.d=K,this.f=V,this.a=0,this.b=0}logOutgoing(K,V,oe,me,se){this.b+=K,ee(this.d,this.b,K,V,oe,me,se)}logIncoming(K,V,oe,me,se){this.a+=K,ee(this.f,this.a,K,V,oe,me,se)}}e.$uh=te}),define(be[106],we([1,0,15,5,2,43]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=e.$wh=e.ProtocolConstants=e.$vh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function b(E,k){if(!n.has(E)){const L=String(++a);n.set(E,L)}return n.get(E)}function p(E,k,L,j){if(!i.enableDiagnostics)return;const Y=b(E,k);if(j instanceof D.$_d||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const ce=D.$_d.alloc(j.byteLength);ce.set(j),i.records.push({timestamp:Date.now(),id:Y,label:k,type:L,buff:ce})}else i.records.push({timestamp:Date.now(),id:Y,label:k,type:L,data:j})}i.traceSocketEvent=p})(I||(e.SocketDiagnostics=I={}));var w;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(w||(e.SocketCloseEventType=w={}));let $=null;function C(){return $||($=D.$_d.alloc(0)),$}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return C();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const k=this.a[0];return a&&(this.a.shift(),this.b-=n),k}if(this.a[0].byteLength>n){const k=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),k}const b=D.$_d.alloc(n);let p=0,E=0;for(;n>0;){const k=this.a[E];if(k.byteLength>n){const L=k.slice(0,n);b.set(L,p),p+=n,a&&(this.a[E]=k.slice(n),this.b-=n),n-=n}else b.set(k,p),p+=k.byteLength,a?(this.a.shift(),this.b-=k.byteLength):E++,n-=k.byteLength}return b}}e.$vh=S;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function d(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var g;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(g||(e.ProtocolConstants=g={}));class m{constructor(n,a,b,p){this.type=n,this.id=a,this.ack=b,this.data=p,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends r.$Qc{constructor(n){super(),this.f=this.B(new O.$Ld),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new S,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:d(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,p=this.g.id,E=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new m(b,p,E,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=D.$_d.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:d(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const b=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,b}h(){const n=D.$_d.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class u extends r.$Qc{constructor(n){super(),this.f=new O.$Ld,this.onMessage=this.f.event,this.g=new O.$Ld,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new f(this.a)),this.c=this.B(new l(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$wh=u;class c extends P.$qh{static fromSocket(n,a){return new c(new u(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,b=null){super(n,a,b),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$xh=c;class y{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$Ld({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$yh=y;class h{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,b=this.a;for(;b;)n[a++]=b.data,b=b.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new h(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<s.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=s.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+s.a)*1e3;let b=0;for(let p=0;p<s.a;p++)n-this.c[p]<=a&&b++;return 1-b/s.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new y,this.onControlMessage=this.u.event,this.v=new y,this.onMessage=this.v.event,this.w=new y,this.onDidDispose=this.w.event,this.x=new y,this.onSocketClose=this.x.event,this.y=new y,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$Pc,this.o=n.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,C());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,C());this.p.write(n)}sendResume(){const n=new m(8,0,0,C());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new r.$Pc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new l(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,C());this.p.write(n);const a=this.b.toArray();for(let b=0,p=a.length;b<p;b++)this.p.write(a[b]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new m(6,0,0,C())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let b=0,p=a.length;b<p;b++)this.p.write(a[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const b=new m(1,a,this.h,n);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(n){const a=new m(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,b=Date.now()-this.q.lastReadTime,p=Date.now()-this.n;if(a>=2e4&&b>=2e4&&p>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:b});return}const E=Math.max(2e4-a,2e4-b,2e4-p,500);this.f=setTimeout(()=>{this.f=null,this.B()},E)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,C());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,C());this.p.write(n)}}e.$zh=o}),define(be[107],we([1,0,52,14,15,20,164,11,5,2,22,103,63,43]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;class g extends d.$nh{constructor(f){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",u=>r.$_d.wrap(Buffer.from(u,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$Sp=g;class m{constructor(f,u){this.i=f,this.j=u,this.c=new Set,this.g=new Map,this.h=new w.$Ld,this.onDidProcessExit=this.h.event;const c=u&&u.timeout?u.timeout:6e4;this.b=new O.$Ng(c),this.d=null,this.f=null}getChannel(f){const u=this;return{call(c,y,h){return u.k(f,c,y,h)},listen(c,y){return u.l(f,c,y)}}}k(f,u,c,y=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(I.$4());this.b.cancel();const h=this.n(f),t=(0,O.$Eg)(i=>h.call(u,c,i)),s=y.onCancellationRequested(()=>t.cancel()),o=(0,$.$Oc)(()=>t.cancel());return this.c.add(o),t.finally(()=>{s.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,u,c){if(!this.b)return w.Event.None;this.b.cancel();let y;const h=new w.$Ld({onWillAddFirstListener:()=>{y=this.n(f).listen(u,c)(h.fire,h),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,C.$Wm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$ul)(u.env),this.d=(0,D.fork)(this.i,f,u);const c=new w.$Ld;w.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$Op)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}c.fire(r.$_d.wrap(Buffer.from(n,"base64")))});const h=this.j.useQueue?(0,S.$wl)(this.d):this.d,t=n=>this.d&&this.d.connected&&h.send(n.buffer.toString("base64")),s=c.event,o={send:t,onMessage:s};this.f=new d.$oh(o);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,$.$Lc)(b)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(f){let u=this.g.get(f);return u||(u=this.m.getChannel(f),this.g.set(f,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Tp=m}),define(be[169],we([1,0,14,5,2,50,10]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$To=e.$So=e.StorageState=e.$Ro=e.StorageHint=void 0;var I;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function w(v){const d=v;return d?.changed instanceof Map||d?.deleted instanceof Set}e.$Ro=w;var $;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})($||(e.StorageState=$={}));class C extends r.$Qc{static{this.a=100}constructor(d,g=Object.create(null)){super(),this.r=d,this.s=g,this.b=this.B(new O.$Od),this.onDidChangeStorage=this.b.event,this.c=$.None,this.f=new Map,this.g=this.B(new D.$Og(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((g,m)=>this.w(m,g)),d.deleted?.forEach(g=>this.w(g,void 0))}finally{this.b.resume()}}w(d,g){if(this.c===$.Closed)return;let m=!1;(0,A.$Ff)(g)?m=this.f.delete(d):this.f.get(d)!==g&&(this.f.set(d,g),m=!0),m&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===$.None&&(this.c=$.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,g){const m=this.f.get(d);return(0,A.$Ff)(m)?g:m}getBoolean(d,g){const m=this.get(d);return(0,A.$Ff)(m)?g:m==="true"}getNumber(d,g){const m=this.get(d);return(0,A.$Ff)(m)?g:parseInt(m,10)}getObject(d,g){const m=this.get(d);return(0,A.$Ff)(m)?g:(0,P.$hh)(m)}async set(d,g,m=!1){if(this.c===$.Closed)return;if((0,A.$Ff)(g))return this.delete(d,m);const l=(0,A.$yf)(g)||Array.isArray(g)?(0,P.$gh)(g):String(g);if(this.f.get(d)!==l)return this.f.set(d,l),this.j.set(d,l),this.h.delete(d),this.b.fire({key:d,external:m}),this.D()}async delete(d,g=!1){if(!(this.c===$.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:g}),this.D()}async optimize(){if(this.c!==$.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=$.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(this.z)return this.D(d)}async D(d){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$So=C;class S{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((g,m)=>this.a.set(m,g)),d.delete?.forEach(g=>this.a.delete(g))}async optimize(){}async close(){}}e.$To=S}),define(be[170],we([8,9]),function(le,e){return le.create("vs/base/node/zip",e)}),define(be[171],we([8,9]),function(le,e){return le.create("vs/editor/common/languages",e)}),define(be[172],we([1,0,49,4,154,42,155,171]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$ct=e.$bt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$at=e.$_s=e.SymbolKinds=e.SymbolTag=e.$$s=e.$0s=e.SymbolKind=e.$9s=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$8s=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$7s=e.$6s=e.$5s=void 0;class w{constructor(ne,ue,_){this.offset=ne,this.type=ue,this.language=_,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$5s=w;class ${constructor(ne,ue){this.tokens=ne,this.endState=ue,this._tokenizationResultBrand=void 0}}e.$6s=$;class C{constructor(ne,ue){this.tokens=ne,this.endState=ue,this._encodedTokenizationResultBrand=void 0}}e.$7s=C;var S;(function(x){x[x.Method=0]="Method",x[x.Function=1]="Function",x[x.Constructor=2]="Constructor",x[x.Field=3]="Field",x[x.Variable=4]="Variable",x[x.Class=5]="Class",x[x.Struct=6]="Struct",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Event=10]="Event",x[x.Operator=11]="Operator",x[x.Unit=12]="Unit",x[x.Value=13]="Value",x[x.Constant=14]="Constant",x[x.Enum=15]="Enum",x[x.EnumMember=16]="EnumMember",x[x.Keyword=17]="Keyword",x[x.Text=18]="Text",x[x.Color=19]="Color",x[x.File=20]="File",x[x.Reference=21]="Reference",x[x.Customcolor=22]="Customcolor",x[x.Folder=23]="Folder",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue",x[x.Snippet=27]="Snippet"})(S||(e.CompletionItemKind=S={}));var v;(function(x){const ne=new Map;ne.set(0,D.$Qj.symbolMethod),ne.set(1,D.$Qj.symbolFunction),ne.set(2,D.$Qj.symbolConstructor),ne.set(3,D.$Qj.symbolField),ne.set(4,D.$Qj.symbolVariable),ne.set(5,D.$Qj.symbolClass),ne.set(6,D.$Qj.symbolStruct),ne.set(7,D.$Qj.symbolInterface),ne.set(8,D.$Qj.symbolModule),ne.set(9,D.$Qj.symbolProperty),ne.set(10,D.$Qj.symbolEvent),ne.set(11,D.$Qj.symbolOperator),ne.set(12,D.$Qj.symbolUnit),ne.set(13,D.$Qj.symbolValue),ne.set(15,D.$Qj.symbolEnum),ne.set(14,D.$Qj.symbolConstant),ne.set(15,D.$Qj.symbolEnum),ne.set(16,D.$Qj.symbolEnumMember),ne.set(17,D.$Qj.symbolKeyword),ne.set(27,D.$Qj.symbolSnippet),ne.set(18,D.$Qj.symbolText),ne.set(19,D.$Qj.symbolColor),ne.set(20,D.$Qj.symbolFile),ne.set(21,D.$Qj.symbolReference),ne.set(22,D.$Qj.symbolCustomColor),ne.set(23,D.$Qj.symbolFolder),ne.set(24,D.$Qj.symbolTypeParameter),ne.set(25,D.$Qj.account),ne.set(26,D.$Qj.issues);function ue(ee){let te=ne.get(ee);return te||(console.info("No codicon found for CompletionItemKind "+ee),te=D.$Qj.symbolProperty),te}x.toIcon=ue;const _=new Map;_.set("method",0),_.set("function",1),_.set("constructor",2),_.set("field",3),_.set("variable",4),_.set("class",5),_.set("struct",6),_.set("interface",7),_.set("module",8),_.set("property",9),_.set("event",10),_.set("operator",11),_.set("unit",12),_.set("value",13),_.set("constant",14),_.set("enum",15),_.set("enum-member",16),_.set("enumMember",16),_.set("keyword",17),_.set("snippet",27),_.set("text",18),_.set("color",19),_.set("file",20),_.set("reference",21),_.set("customcolor",22),_.set("folder",23),_.set("type-parameter",24),_.set("typeParameter",24),_.set("account",25),_.set("issue",26);function he(ee,te){let W=_.get(ee);return typeof W>"u"&&!te&&(W=9),W}x.fromString=he})(v||(e.CompletionItemKinds=v={}));var d;(function(x){x[x.Deprecated=1]="Deprecated"})(d||(e.CompletionItemTag=d={}));var g;(function(x){x[x.None=0]="None",x[x.KeepWhitespace=1]="KeepWhitespace",x[x.InsertAsSnippet=4]="InsertAsSnippet"})(g||(e.CompletionItemInsertTextRule=g={}));var m;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m||(e.CompletionTriggerKind=m={}));var l;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(l||(e.InlineCompletionTriggerKind=l={}));class f{constructor(ne,ue,_,he){this.range=ne,this.text=ue,this.completionKind=_,this.isSnippetText=he}equals(ne){return P.$ls.lift(this.range).equalsRange(ne.range)&&this.text===ne.text&&this.completionKind===ne.completionKind&&this.isSnippetText===ne.isSnippetText}}e.$8s=f;var u;(function(x){x[x.Invoke=1]="Invoke",x[x.Auto=2]="Auto"})(u||(e.CodeActionTriggerType=u={}));var c;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(c||(e.SignatureHelpTriggerKind=c={}));var y;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(y||(e.DocumentHighlightKind=y={}));function h(x){return x&&O.URI.isUri(x.uri)&&P.$ls.isIRange(x.range)&&(P.$ls.isIRange(x.originSelectionRange)||P.$ls.isIRange(x.targetSelectionRange))}e.$9s=h;var t;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$0s={[17]:(0,I.localize)(0,null),[16]:(0,I.localize)(1,null),[4]:(0,I.localize)(2,null),[13]:(0,I.localize)(3,null),[8]:(0,I.localize)(4,null),[9]:(0,I.localize)(5,null),[21]:(0,I.localize)(6,null),[23]:(0,I.localize)(7,null),[7]:(0,I.localize)(8,null),[0]:(0,I.localize)(9,null),[11]:(0,I.localize)(10,null),[10]:(0,I.localize)(11,null),[19]:(0,I.localize)(12,null),[5]:(0,I.localize)(13,null),[1]:(0,I.localize)(14,null),[2]:(0,I.localize)(15,null),[20]:(0,I.localize)(16,null),[15]:(0,I.localize)(17,null),[18]:(0,I.localize)(18,null),[24]:(0,I.localize)(19,null),[3]:(0,I.localize)(20,null),[6]:(0,I.localize)(21,null),[14]:(0,I.localize)(22,null),[22]:(0,I.localize)(23,null),[25]:(0,I.localize)(24,null),[12]:(0,I.localize)(25,null)};function s(x,ne){return(0,I.localize)(26,null,x,e.$0s[ne])}e.$$s=s;var o;(function(x){x[x.Deprecated=1]="Deprecated"})(o||(e.SymbolTag=o={}));var i;(function(x){const ne=new Map;ne.set(0,D.$Qj.symbolFile),ne.set(1,D.$Qj.symbolModule),ne.set(2,D.$Qj.symbolNamespace),ne.set(3,D.$Qj.symbolPackage),ne.set(4,D.$Qj.symbolClass),ne.set(5,D.$Qj.symbolMethod),ne.set(6,D.$Qj.symbolProperty),ne.set(7,D.$Qj.symbolField),ne.set(8,D.$Qj.symbolConstructor),ne.set(9,D.$Qj.symbolEnum),ne.set(10,D.$Qj.symbolInterface),ne.set(11,D.$Qj.symbolFunction),ne.set(12,D.$Qj.symbolVariable),ne.set(13,D.$Qj.symbolConstant),ne.set(14,D.$Qj.symbolString),ne.set(15,D.$Qj.symbolNumber),ne.set(16,D.$Qj.symbolBoolean),ne.set(17,D.$Qj.symbolArray),ne.set(18,D.$Qj.symbolObject),ne.set(19,D.$Qj.symbolKey),ne.set(20,D.$Qj.symbolNull),ne.set(21,D.$Qj.symbolEnumMember),ne.set(22,D.$Qj.symbolStruct),ne.set(23,D.$Qj.symbolEvent),ne.set(24,D.$Qj.symbolOperator),ne.set(25,D.$Qj.symbolTypeParameter);function ue(_){let he=ne.get(_);return he||(console.info("No codicon found for SymbolKind "+_),he=D.$Qj.symbolProperty),he}x.toIcon=ue})(i||(e.SymbolKinds=i={}));class n{static asEditOperation(ne){return r.$ms.replace(P.$ls.lift(ne.range),ne.text)}}e.$_s=n;class a{static{this.Comment=new a("comment")}static{this.Imports=new a("imports")}static{this.Region=new a("region")}static fromValue(ne){switch(ne){case"comment":return a.Comment;case"imports":return a.Imports;case"region":return a.Region}return new a(ne)}constructor(ne){this.value=ne}}e.$at=a;var b;(function(x){function ne(ue){return!ue||typeof ue!="object"?!1:typeof ue.id=="string"&&typeof ue.title=="string"}x.is=ne})(b||(e.Command=b={}));var p;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(p||(e.CommentThreadCollapsibleState=p={}));var E;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(E||(e.CommentThreadState=E={}));var k;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(k||(e.CommentMode=k={}));var L;(function(x){x[x.Published=0]="Published",x[x.Draft=1]="Draft"})(L||(e.CommentState=L={}));var j;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(j||(e.InlayHintKind=j={}));class Y{constructor(ne){this.b=ne,this.a=null}dispose(){this.a&&this.a.then(ne=>{ne&&ne.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$bt=Y,e.$ct=new A.$Ws;var ce;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(ce||(e.ExternalUriOpenerPriority=ce={}))}),define(be[173],we([8,9]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[174],we([8,9]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(be[175],we([8,9]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(be[176],we([8,9]),function(le,e){return le.create("vs/platform/environment/node/argv",e)}),define(be[177],we([8,9]),function(le,e){return le.create("vs/platform/environment/node/argvHelper",e)}),define(be[178],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[179],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[180],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[181],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[182],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[183],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[184],we([8,9]),function(le,e){return le.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[185],we([8,9]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[186],we([8,9]),function(le,e){return le.create("vs/platform/files/common/fileService",e)}),define(be[187],we([8,9]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(be[188],we([8,9]),function(le,e){return le.create("vs/platform/files/common/io",e)}),define(be[189],we([8,9]),function(le,e){return le.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[190],we([8,9]),function(le,e){return le.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[191],we([8,9]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(be[192],we([8,9]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(be[193],we([8,9]),function(le,e){return le.create("vs/platform/shell/node/shellEnv",e)}),define(be[194],we([8,9]),function(le,e){return le.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[195],we([8,9]),function(le,e){return le.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[196],we([8,9]),function(le,e){return le.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[197],we([8,9]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[198],we([8,9]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(be[199],we([8,9]),function(le,e){return le.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(be[200],we([8,9]),function(le,e){return le.create("vs/server/node/serverEnvironmentService",e)}),define(be[201],we([8,9]),function(le,e){return le.create("vs/server/node/serverServices",e)}),define(be[202],we([8,9]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(be[203],we([8,9]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(be[204],we([8,9]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[205],we([8,9]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[206],we([1,0,11,175]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.TokenType=void 0;var r;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(r||(e.TokenType=r={}));function P(...$){switch($.length){case 1:return(0,O.localize)(0,null,$[0]);case 2:return(0,O.localize)(1,null,$[0],$[1]);case 3:return(0,O.localize)(2,null,$[0],$[1],$[2]);default:return}}const A=(0,O.localize)(3,null),I=(0,O.localize)(4,null);class w{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,D.$6)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,v=this.c.substring(this.d,this.e),d={type:19,offset:this.d,lexeme:v};this.g.push({offset:S,lexeme:v,additionalInfo:C}),this.f.push(d)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),v=w.b.get(S);v?this.k(v):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,v=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(I);return}const g=this.c.charCodeAt(C);if(S)S=!1;else if(g===47&&!v){C++;break}else g===91?v=!0:g===92?S=!0:g===93&&(v=!1);C++}for(;C<this.c.length&&w.a.has(this.c.charCodeAt(C));)C++;this.e=C;const d=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$Gi=w}),define(be[207],we([1,0,5,2]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=e.$Cn=void 0;class r{constructor(){this.a=new D.$Ld,this.b=new D.$Ld,this.c=new D.$Ld,this.d=new D.$Ld}static{this.ChannelName="extensionhostdebugservice"}call(I,w,$){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:$[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:$[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:$[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:$[0],port:$[1],subId:$[2]}))}throw new Error("Method not implemented.")}listen(I,w,$){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Cn=r;class P extends O.$Qc{constructor(I){super(),this.b=I}reload(I){this.b.call("reload",[I])}get onReload(){return this.b.listen("reload")}close(I){this.b.call("close",[I])}get onClose(){return this.b.listen("close")}attachSession(I,w,$){this.b.call("attach",[I,w,$])}get onAttachSession(){return this.b.listen("attach")}terminateSession(I,w){this.b.call("terminate",[I,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(I,w){return this.b.call("openExtensionDevelopmentHostWindow",[I,w])}}e.$Dn=P}),define(be[208],we([1,0,4]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=void 0;class O{constructor(A){this.a=A}listen(A,I,w){throw new Error("Invalid listen")}call(A,I,w){switch(I){case"download":return this.a.download(D.URI.revive(w[0]),D.URI.revive(w[1]))}throw new Error("Invalid call")}}e.$Fn=O;class r{constructor(A,I){this.a=A,this.b=I}async download(A,I){const w=this.b();w&&(A=w.transformOutgoingURI(A),I=w.transformOutgoingURI(I)),await this.a.call("download",[A,I])}}e.$Gn=r}),define(be[209],we([1,0,159,73,12,7,29,19,4]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=e.$$l=e.$0l=e.$9l=void 0,e.$9l=/^([^.]+\..+):(.+)$/;class ${get appRoot(){return(0,P.$kc)(r.$_f.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,P.$hc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,I.$sg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$sg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,D.$8l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,P.$hc)(this.userDataPath,"logs",d)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$sg)(w.URI.file((0,P.$hc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$sg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$sg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$sg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=A.env.VSCODE_PORTABLE;return d?w.URI.file((0,P.$hc)(d,"argv.json")):(0,I.$sg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,P.$hc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,P.$ic)(d):(0,P.$fc)((0,P.$hc)(r.$_f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,P.$ic)(d)):w.URI.file((0,P.$hc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,P.$ic)(d);const g=A.env.VSCODE_EXTENSIONS;if(g)return g;const m=A.env.VSCODE_PORTABLE;return m?(0,P.$hc)(m,"extensions"):(0,I.$sg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?w.URI.parse(g):w.URI.file((0,P.$fc)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,P.$fc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$9l.test(d))}get extensionLogLevel(){const d=[];for(const g of this.args.log||[]){const m=e.$9l.exec(g);m&&m[1]&&m[2]&&d.push([m[1],m[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,I.$sg)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=A.env.VSCODE_PORTABLE;return d?w.URI.file((0,P.$hc)(d,"policy.json")):(0,I.$sg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,g,m){this.a=d,this.b=g,this.c=m,this.editSessionId=this.args.editSessionId}}e.$0l=$,Oe([O.$dh],$.prototype,"appRoot",null),Oe([O.$dh],$.prototype,"userHome",null),Oe([O.$dh],$.prototype,"userDataPath",null),Oe([O.$dh],$.prototype,"appSettingsHome",null),Oe([O.$dh],$.prototype,"tmpDir",null),Oe([O.$dh],$.prototype,"cacheHome",null),Oe([O.$dh],$.prototype,"stateResource",null),Oe([O.$dh],$.prototype,"userRoamingDataHome",null),Oe([O.$dh],$.prototype,"userDataSyncHome",null),Oe([O.$dh],$.prototype,"sync",null),Oe([O.$dh],$.prototype,"machineSettingsResource",null),Oe([O.$dh],$.prototype,"workspaceStorageHome",null),Oe([O.$dh],$.prototype,"localHistoryHome",null),Oe([O.$dh],$.prototype,"keyboardLayoutResource",null),Oe([O.$dh],$.prototype,"argvResource",null),Oe([O.$dh],$.prototype,"isExtensionDevelopment",null),Oe([O.$dh],$.prototype,"untitledWorkspacesHome",null),Oe([O.$dh],$.prototype,"builtinExtensionsPath",null),Oe([O.$dh],$.prototype,"extensionsPath",null),Oe([O.$dh],$.prototype,"extensionDevelopmentLocationURI",null),Oe([O.$dh],$.prototype,"extensionDevelopmentKind",null),Oe([O.$dh],$.prototype,"extensionTestsLocationURI",null),Oe([O.$dh],$.prototype,"debugExtensionHost",null),Oe([O.$dh],$.prototype,"logLevel",null),Oe([O.$dh],$.prototype,"extensionLogLevel",null),Oe([O.$dh],$.prototype,"serviceMachineIdResource",null),Oe([O.$dh],$.prototype,"disableTelemetry",null),Oe([O.$dh],$.prototype,"disableWorkspaceTrust",null),Oe([O.$dh],$.prototype,"useInMemorySecretStorage",null),Oe([O.$dh],$.prototype,"policyFile",null);function C(v,d){return S(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId,v.extensionEnvironment)}e.$$l=C;function S(v,d,g,m,l,f){const c=Number(d||v)||(m?null:g),y=c?!!d:!1;let h;if(f)try{h=JSON.parse(f)}catch{}return{port:c,break:y,debugId:l,env:h}}e.$_l=S}),define(be[64],we([1,0,295,3,176]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=void 0;const P={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$yl=["tunnel","serve-web"],e.$zl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function I(m,l,f=A){const u=m.find(a=>a.length>0&&a[0]!=="-"),c={},y=["_"],h=[],t={};let s;for(const a in l){const b=l[a];b.type==="subcommand"?a===u&&(s=b):(b.alias&&(c[a]=b.alias),b.type==="string"||b.type==="string[]"?(y.push(a),b.deprecates&&y.push(...b.deprecates)):b.type==="boolean"&&(h.push(a),b.deprecates&&h.push(...b.deprecates)),b.global&&(t[a]=b))}if(s&&u){const a=t;for(const k in s.options)a[k]=s.options[k];const b=m.filter(k=>k!==u),p=f.getSubcommandReporter?f.getSubcommandReporter(u):void 0,E=I(b,a,p);return{[u]:E,_:[]}}const o=D(m,{string:y,boolean:h,alias:c}),i={},n=o;i._=o._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in l){const b=l[a];if(b.type==="subcommand")continue;b.alias&&delete n[b.alias];let p=n[a];if(b.deprecates)for(const E of b.deprecates)n.hasOwnProperty(E)&&(p||(p=n[E],p&&f.onDeprecatedOption(E,b.deprecationMessage||(0,r.localize)(37,null,a))),delete n[E]);if(typeof p<"u"){if(b.type==="string[]"){if(Array.isArray(p)||(p=[p]),!b.allowEmptyValue){const E=p.filter(k=>k.length>0);E.length!==p.length&&(f.onEmptyValue(a),p=E.length>0?E:void 0)}}else b.type==="string"&&(Array.isArray(p)?(p=p.pop(),f.onMultipleValues(a,p)):!p&&!b.allowEmptyValue&&(f.onEmptyValue(a),p=void 0));i[a]=p,b.deprecationMessage&&f.onDeprecatedOption(a,b.deprecationMessage)}delete n[a]}for(const a in n)f.onUnknownOption(a);return i}e.$Al=I;function w(m,l){let f="";return l.args&&(Array.isArray(l.args)?f=` <${l.args.join("> <")}>`:f=` <${l.args}>`),l.alias?`-${l.alias} --${m}${f}`:`--${m}${f}`}function $(m,l){const f=[];for(const u in m){const c=m[u],y=w(u,c);f.push([y,c.description])}return C(f,l)}e.$Bl=$;function C(m,l){const u=m.reduce((h,t)=>Math.max(h,t[0].length),12)+2+1;if(l-u<25)return m.reduce((h,t)=>h.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const c=l-u-1,y=[];for(const h of m){const t=h[0],s=v(h[1],c),o=S(u-t.length-2);y.push("  "+t+o+s[0]);for(let i=1;i<s.length;i++)y.push(S(u)+s[i])}return y}function S(m){return" ".repeat(m)}function v(m,l){const f=[];for(;m.length;){const u=m.length<l?m.length:m.lastIndexOf(" ",l),c=m.slice(0,u).trim();m=m.slice(u),f.push(c)}return f}function d(m,l,f,u,c){const y=process.stdout.isTTY&&process.stdout.columns||80,h=c?.noInputFiles!==!0?`[${(0,r.localize)(38,null)}...]`:"",t=[`${m} ${f}`];t.push(""),t.push(`${(0,r.localize)(39,null)}: ${l} [${(0,r.localize)(40,null)}]${h}`),t.push(""),c?.noPipe!==!0&&(O.$i?t.push((0,r.localize)(41,null,l)):t.push((0,r.localize)(42,null,l)),t.push(""));const s={},o=[];for(const i in u){const n=u[i];if(n.type==="subcommand")n.description&&o.push({command:i,description:n.description});else if(n.description&&n.cat){let a=s[n.cat];a||(s[n.cat]=a={}),a[i]=n}}for(const i in s){const n=i,a=s[n];a&&(t.push(P[n]),t.push(...$(a,y)),t.push(""))}return o.length&&(t.push((0,r.localize)(43,null)),t.push(...C(o.map(i=>[i.command,i.description]),y)),t.push("")),t.join(`
`)}e.$Cl=d;function g(m,l){return`${m||(0,r.localize)(44,null)}
${l||(0,r.localize)(45,null)}
${process.arch}`}e.$Dl=g}),define(be[210],we([1,0,296,177,64]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$Gl=e.$Fl=e.$El=void 0;function P(S,v){const d=(c,y)=>{console.warn((0,O.localize)(0,null,c,y))},g=c=>{console.warn((0,O.localize)(1,null,c))},m=(c,y)=>{console.warn((0,O.localize)(2,null,c,y))},l=c=>({onUnknownOption:y=>{r.$yl.includes(c)||console.warn((0,O.localize)(3,null,y,c))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:m,getSubcommandReporter:r.$yl.includes(c)?l:void 0}),f={onUnknownOption:c=>{console.warn((0,O.localize)(4,null,c))},onMultipleValues:d,onEmptyValue:g,onDeprecatedOption:m,getSubcommandReporter:l},u=(0,r.$Al)(S,r.$zl,v?f:void 0);return u.goto&&u._.forEach(c=>D(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(c),(0,O.localize)(5,null))),u}function A(S){const v=S.findIndex(d=>!/^-/.test(d));if(v>-1)return[...S.slice(0,v),...S.slice(v+1)]}function I(S){let[,...v]=S;process.env.VSCODE_DEV&&(v=A(v)||[]);const d=!C(process.env);return P(v,d)}e.$El=I;function w(S){let[,,...v]=S;return process.env.VSCODE_DEV&&(v=A(v)||[]),P(v,!0)}e.$Fl=w;function $(S,...v){const d=S.indexOf("--");return d===-1?S.push(...v):S.splice(d,0,...v),S}e.$Gl=$;function C(S){return S.VSCODE_CLI==="1"}e.$Hl=C}),function(){"use strict";function le(e,D,O){function r(A,I){const w=P(A,I),$=[w];return e.isAbsolute(w)||$.unshift(O),e.resolve(...$)}function P(A,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let $=process.env.VSCODE_APPDATA;if($)return e.join($,I);const C=A["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if($=process.env.APPDATA,!$){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");$=e.join(S,"AppData","Roaming")}break;case"darwin":$=e.join(D.homedir(),"Library","Application Support");break;case"linux":$=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join($,I)}return{getUserDataPath:r}}if(typeof define=="function")define(be[211],we([76,28,29]),function(e,D,O){return le(e,D,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=le(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[108],we([1,0,28,209,211]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=e.$bm=e.$am=void 0;class P extends O.$0l{constructor($,C){super($,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,r.getUserDataPath)($,C.nameShort)},C)}}e.$am=P;function A(w,$){return(0,O.$_l)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,$,w.extensionEnvironment)}e.$bm=A;function I(w,$){return(0,O.$_l)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,$,w.extensionEnvironment)}e.$cm=I}),define(be[212],we([1,0,10,181]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=void 0;function r(A,I,w,$){try{P(A,I,w,$)}catch(C){A.error(C?.message??C)}return I}e.$op=r;function P(A,I,w,$){const C=(S,v,d)=>{const g=S[v];if((0,D.$wf)(g)){const m=g,l=m.length;if(l>1&&m[0]==="%"&&m[l-1]==="%"){const f=m.substr(1,l-2);let u=w[f];u===void 0&&$&&(u=$[f]);const c=typeof u=="string"?u:u?.message,y=$?.[f],h=typeof y=="string"?y:y?.message;if(!c){h||A.warn(`[${I.name}]: ${(0,O.localize)(0,null,f)}`);return}if(d&&(v==="title"||v==="category")&&h&&h!==c){const t={value:c,original:h};S[v]=t}else S[v]=c}}else if((0,D.$yf)(g))for(const m in g)g.hasOwnProperty(m)&&(m==="commands"?C(g,m,!0):C(g,m,d));else if(Array.isArray(g))for(let m=0;m<g.length;m++)C(g,m,d)};for(const S in I)I.hasOwnProperty(S)&&C(I,S)}}),define(be[79],we([1,0,19,60,185,53]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function w(f){return f=f.trim(),f==="*"||A.test(f)}e.$Co=w;function $(f){if(!w(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=f.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$Do=$;function C(f){if(!f)return null;const u=f.majorBase,c=f.majorMustEqual,y=f.minorBase;let h=f.minorMustEqual;const t=f.patchBase;let s=f.patchMustEqual;f.hasCaret&&(u===0||(h=!1),s=!1);let o=0;if(f.preRelease){const i=I.exec(f.preRelease);if(i){const[,n,a,b]=i;o=Date.UTC(Number(n),Number(a)-1,Number(b))}}return{majorBase:u,majorMustEqual:c,minorBase:y,minorMustEqual:h,patchBase:t,patchMustEqual:s,isMinimum:f.hasGreaterEquals,notBefore:o}}e.$Eo=C;function S(f,u,c){let y;typeof f=="string"?y=C($(f)):y=f;let h;u instanceof Date?h=u.getTime():typeof u=="string"&&(h=new Date(u).getTime());let t;if(typeof c=="string"?t=C($(c)):t=c,!y||!t)return!1;const s=y.majorBase,o=y.minorBase,i=y.patchBase;let n=t.majorBase,a=t.minorBase,b=t.patchBase;const p=t.notBefore;let E=t.majorMustEqual,k=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:o>a?!0:o<a||h&&h<p?!1:i>=b:(s===1&&n===0&&(!E||!k||!L)&&(n=1,a=0,b=0,E=!0,k=!1,L=!1),s<n?!1:s>n?!E:o<a?!1:o>a?!k:i<b?!1:i>b?!L:!(h&&h<p))}e.$Fo=S;function v(f,u,c,y,h){const t=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return t.push([O.default.Error,r.localize(0,null)]),t;if(typeof y.name!="string")return t.push([O.default.Error,r.localize(1,null,"name")]),t;if(typeof y.version!="string")return t.push([O.default.Error,r.localize(2,null,"version")]),t;if(!y.engines)return t.push([O.default.Error,r.localize(3,null,"engines")]),t;if(typeof y.engines.vscode!="string")return t.push([O.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof y.extensionDependencies<"u"&&!l(y.extensionDependencies))return t.push([O.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof y.activationEvents<"u"){if(!l(y.activationEvents))return t.push([O.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof y.main>"u"&&typeof y.browser>"u")return t.push([O.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&t.push([O.default.Warning,r.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return t.push([O.default.Error,r.localize(9,null,"main")]),t;{const i=(0,D.$sg)(c,y.main);(0,D.$mg)(i,c)||t.push([O.default.Warning,r.localize(10,null,i.path,c.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return t.push([O.default.Error,r.localize(11,null,"browser")]),t;{const i=(0,D.$sg)(c,y.browser);(0,D.$mg)(i,c)||t.push([O.default.Warning,r.localize(12,null,i.path,c.path)])}}if(!P.valid(y.version))return t.push([O.default.Error,r.localize(13,null)]),t;const s=[];if(!d(f,u,y,h,s))for(const i of s)t.push([O.default.Error,i]);return t}e.$Go=v;function d(f,u,c,y,h){return y||typeof c.main>"u"&&typeof c.browser>"u"?!0:m(f,u,c.engines.vscode,h)}e.$Ho=d;function g(f,u,c){return f==="*"||m(u,c,f)}e.$Io=g;function m(f,u,c,y=[]){const h=C($(c));if(!h)return y.push(r.localize(14,null,c)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return y.push(r.localize(15,null,c)),!1}else if(!h.majorMustEqual)return y.push(r.localize(16,null,c)),!1;return S(f,u,h)?!0:(y.push(r.localize(17,null,f,c)),!1)}function l(f){if(!Array.isArray(f))return!1;for(let u=0,c=f.length;u<c;u++)if(typeof f[u]!="string")return!1;return!0}}),define(be[213],we([1,0,15,23]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function r(P,A,I){let w=I&&I.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const C=(await A.readFile(P.serviceMachineIdResource)).value.toString();w=(0,O.$ag)(C)?C:null}catch{w=null}if(!w){w=(0,O.$bg)();try{await A.writeFile(P.serviceMachineIdResource,D.$_d.fromString(w))}catch{}}return I?.store("storage.serviceMachineId",w,-1,1),w}e.$3o=r}),define(be[65],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=void 0;class D{constructor(r,P=[],A=!1){this.ctor=r,this.staticArguments=P,this.supportsDelayedInstantiation=A}}e.$Ih=D}),define(be[214],we([1,0,65]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.InstantiationType=void 0;const O=[];var r;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function P(I,w,$){w instanceof D.$Ih||(w=new D.$Ih(w,[],!!$)),O.push([I,w])}e.$nr=P;function A(){return O}e.$or=A}),define(be[215],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=void 0;class D{constructor(P,A){this.key=P,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$5p=D;class O{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const A of this.a.values())A.outgoing.size===0&&P.push(A);return P}insertEdge(P,A){const I=this.lookupOrInsertNode(P),w=this.lookupOrInsertNode(A);I.outgoing.set(w.key,w),w.incoming.set(I.key,I)}removeNode(P){const A=this.b(P);this.a.delete(A);for(const I of this.a.values())I.outgoing.delete(A),I.incoming.delete(A)}lookupOrInsertNode(P){const A=this.b(P);let I=this.a.get(A);return I||(I=new D(A,P),this.a.set(A,I)),I}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[A,I]of this.a)P.push(`${A}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,A]of this.a){const I=new Set([P]),w=this.c(A,I);if(w)return w}}c(P,A){for(const[I,w]of P.outgoing){if(A.has(I))return[...A,I].join(" -> ");A.add(I);const $=this.c(w,A);if($)return $;A.delete(I)}}}e.$6p=O}),define(be[6],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function I(w){return w[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=I})(D||(e._util=D={})),e.$Kh=r("instantiationService");function O(A,I,w){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:A,index:w}):(I[D.DI_DEPENDENCIES]=[{id:A,index:w}],I[D.DI_TARGET]=I)}function r(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const I=function(w,$,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(I,w,C)};return I.toString=()=>A,D.serviceIds.set(A,I),I}e.$Lh=r;function P(A){return A}e.$Mh=P}),define(be[24],we([1,0,10,4,6]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.ConfigurationTarget=e.$hi=e.$gi=e.$fi=void 0,e.$fi=(0,r.$Lh)("configurationService");function P(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof O.URI)}e.$gi=P;function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof O.URI)}e.$hi=A;var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function w(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$ii=w;function $(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}e.$ji=$;function C(f,u){const c=Object.create(null);for(const y in f)S(c,y,f[y],u);return c}e.$ki=C;function S(f,u,c,y){const h=u.split("."),t=h.pop();let s=f;for(let o=0;o<h.length;o++){const i=h[o];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":break;default:y(`Ignoring ${u} as ${h.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=c}catch{y(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(s)}`)}else y(`Ignoring ${u} as ${h.join(".")} is ${JSON.stringify(s)}`)}e.$li=S;function v(f,u){const c=u.split(".");d(f,c)}e.$mi=v;function d(f,u){const c=u.shift();if(u.length===0){delete f[c];return}if(Object.keys(f).indexOf(c)!==-1){const y=f[c];typeof y=="object"&&!Array.isArray(y)&&(d(y,u),Object.keys(y).length===0&&delete f[c])}}function g(f,u,c){function y(s,o){let i=s;for(const n of o){if(typeof i!="object"||i===null)return;i=i[n]}return i}const h=u.split("."),t=y(f,h);return typeof t>"u"?c:t}e.$ni=g;function m(f,u,c){Object.keys(u).forEach(y=>{y!=="__proto__"&&(y in f?D.$yf(f[y])&&D.$yf(u[y])?m(f[y],u[y],c):c&&(f[y]=u[y]):f[y]=u[y])})}e.$oi=m;function l(f){return f.replace(/[\[\]]/g,"")}e.$pi=l}),define(be[66],we([1,0,3,17,206,6,174,11]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.ContextKeyExprType=e.$Hi=void 0;const w=new Map;w.set("false",!1),w.set("true",!0),w.set("isMac",D.$j),w.set("isLinux",D.$k),w.set("isWindows",D.$i),w.set("isWeb",D.$o),w.set("isMacNative",D.$j&&!D.$o),w.set("isEdge",D.$G),w.set("isFirefox",D.$E),w.set("isChrome",D.$D),w.set("isSafari",D.$F);function $(Z,R){if(w.get(Z)!==void 0)throw(0,I.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");w.set(Z,R)}e.$Hi=$;const C=Object.prototype.hasOwnProperty;var S;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const v={regexParsingWithErrorRecovery:!0},d=(0,A.localize)(0,null),g=(0,A.localize)(1,null),m=(0,A.localize)(2,null),l=(0,A.localize)(3,null),f=(0,A.localize)(4,null),u=(0,A.localize)(5,null),c=(0,A.localize)(6,null),y=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=v){this.k=R,this.d=new r.$Gi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:g});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const G=this.D(),T=G.type===17?u:void 0;throw this.h.push({message:f,offset:G.offset,lexeme:r.$Gi.getLexeme(G),additionalInfo:T}),h.c}return F}catch(F){if(F!==h.c)throw F;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const F=this.o();R.push(F)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const F=this.s();R.push(F)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,l),F?.negate()}case 17:return this.z(),j.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,l),F}case 17:{const F=R.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const q=T.lexeme,z=q.lastIndexOf("/"),ie=z===q.length-1?void 0:this.w(q.substring(z+1));let B;try{B=new RegExp(q.substring(1,z),ie)}catch{throw this.B("REGEX",T)}return _.create(F,B)}switch(T.type){case 10:case 19:{const q=[T.lexeme];this.z();let z=this.D(),ie=0;for(let re=0;re<T.lexeme.length;re++)T.lexeme.charCodeAt(re)===40?ie++:T.lexeme.charCodeAt(re)===41&&ie--;for(;!this.E()&&z.type!==15&&z.type!==16;){switch(z.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let re=0;re<z.lexeme.length;re++)z.lexeme.charCodeAt(re)===40?ie++:T.lexeme.charCodeAt(re)===41&&ie--}if(ie<0)break;q.push(r.$Gi.getLexeme(z)),this.z(),z=this.D()}const B=q.join(""),X=B.lastIndexOf("/"),H=X===B.length-1?void 0:this.w(B.substring(X+1));let Q;try{Q=new RegExp(B.substring(1,X),H)}catch{throw this.B("REGEX",T)}return t.regex(F,Q)}case 18:{const q=T.lexeme;this.z();let z=null;if(!(0,O.$ze)(q)){const ie=q.indexOf("/"),B=q.lastIndexOf("/");if(ie!==B&&ie>=0){const X=q.slice(ie+1,B),H=q[B+1]==="i"?"i":"";try{z=new RegExp(X,H)}catch{throw this.B("REGEX",T)}}}if(z===null)throw this.B("REGEX",T);return _.create(F,z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const T=this.u();return t.notIn(F,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(F,T);switch(T){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(F,T);switch(T){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,T)}}case 5:return this.z(),ne.create(F,this.u());case 6:return this.z(),ue.create(F,this.u());case 7:return this.z(),ce.create(F,this.u());case 8:return this.z(),x.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:c,offset:R.offset,lexeme:"",additionalInfo:y}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,F){if(this.C(R))return this.z();throw this.B(F,this.D())}B(R,F,G){const T=(0,A.localize)(8,null,R,r.$Gi.getLexeme(F)),q=F.offset,z=r.$Gi.getLexeme(F);return this.h.push({message:T,offset:q,lexeme:z,additionalInfo:G}),h.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Ii=h;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(R){return b.create(R)}static equals(R,F){return p.create(R,F)}static notEquals(R,F){return L.create(R,F)}static regex(R,F){return _.create(R,F)}static in(R,F){return E.create(R,F)}static notIn(R,F){return k.create(R,F)}static not(R){return j.create(R)}static and(...R){return te.create(R,null,!0)}static or(...R){return W.create(R,null,!0)}static greater(R,F){return ce.create(R,F)}static greaterEquals(R,F){return x.create(R,F)}static smaller(R,F){return ne.create(R,F)}static smallerEquals(R,F){return ue.create(R,F)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$Ji=t;function s(Z){const R=new h({regexParsingWithErrorRecovery:!1});return Z.map(F=>(R.parse(F),R.lexingErrors.length>0?R.lexingErrors.map(G=>({errorMessage:G.additionalInfo?(0,A.localize)(9,null,G.additionalInfo):(0,A.localize)(10,null),offset:G.offset,length:G.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(G=>({errorMessage:G.additionalInfo?`${G.message}. ${G.additionalInfo}`:G.message,offset:G.offset,length:G.lexeme.length})):[]))}e.$Ki=s;function o(Z,R){const F=Z?Z.substituteConstants():void 0,G=R?R.substituteConstants():void 0;return!F&&!G?!0:!F||!G?!1:F.equals(G)}e.$Li=o;function i(Z,R){return Z.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.$Mi=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$Ni=a;class b{static create(R,F=null){const G=w.get(R);return typeof G=="boolean"?G?a.INSTANCE:n.INSTANCE:new b(R,F)}constructor(R,F){this.key=R,this.c=F,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:V(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=w.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$Oi=b;class p{static create(R,F,G=null){if(typeof F=="boolean")return F?b.create(R,G):j.create(R,G);const T=w.get(R);return typeof T=="boolean"?F===(T?"true":"false")?a.INSTANCE:n.INSTANCE:new p(R,F,G)}constructor(R,F,G){this.c=R,this.d=F,this.f=G,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=w.get(this.c);if(typeof R=="boolean"){const F=R?"true":"false";return this.d===F?a.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Pi=p;class E{static create(R,F){return new E(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const F=R.getValue(this.f),G=R.getValue(this.d);return Array.isArray(F)?F.includes(G):typeof G=="string"&&typeof F=="object"&&F!==null?C.call(F,G):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Qi=E;class k{static create(R,F){return new k(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=11,this.c=E.create(R,F)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ri=k;class L{static create(R,F,G=null){if(typeof F=="boolean")return F?j.create(R,G):b.create(R,G);const T=w.get(R);return typeof T=="boolean"?F===(T?"true":"false")?n.INSTANCE:a.INSTANCE:new L(R,F,G)}constructor(R,F,G){this.c=R,this.d=F,this.f=G,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=w.get(this.c);if(typeof R=="boolean"){const F=R?"true":"false";return this.d===F?n.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$Si=L;class j{static create(R,F=null){const G=w.get(R);return typeof G=="boolean"?G?n.INSTANCE:a.INSTANCE:new j(R,F)}constructor(R,F){this.c=R,this.d=F,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=w.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:a.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ti=j;function Y(Z,R){if(typeof Z=="string"){const F=parseFloat(Z);isNaN(F)||(Z=F)}return typeof Z=="string"||typeof Z=="number"?R(Z):n.INSTANCE}class ce{static create(R,F,G=null){return Y(F,T=>new ce(R,T,G))}constructor(R,F,G){this.c=R,this.d=F,this.f=G,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Ui=ce;class x{static create(R,F,G=null){return Y(F,T=>new x(R,T,G))}constructor(R,F,G){this.c=R,this.d=F,this.f=G,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Vi=x;class ne{static create(R,F,G=null){return Y(F,T=>new ne(R,T,G))}constructor(R,F,G){this.c=R,this.d=F,this.f=G,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Wi=ne;class ue{static create(R,F,G=null){return Y(F,T=>new ue(R,T,G))}constructor(R,F,G){this.c=R,this.d=F,this.f=G,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:oe(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$Xi=ue;class _{static create(R,F){return new _(R,F)}constructor(R,F){this.d=R,this.f=F,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const F=this.f?this.f.source:"",G=R.f?R.f.source:"";return F<G?-1:F>G?1:0}equals(R){if(R.type===this.type){const F=this.f?this.f.source:"",G=R.f?R.f.source:"";return this.d===R.d&&F===G}return!1}substituteConstants(){return this}evaluate(R){const F=R.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=he.create(this)),this.c}}e.$Yi=_;class he{static create(R){return new he(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new he(this.c.map(R))}negate(){return this.c}}e.$Zi=he;function ee(Z){let R=null;for(let F=0,G=Z.length;F<G;F++){const T=Z[F].substituteConstants();if(Z[F]!==T&&R===null){R=[];for(let q=0;q<F;q++)R[q]=Z[q]}R!==null&&(R[F]=T)}return R===null?Z:R}class te{static create(R,F,G){return te.d(R,F,G)}constructor(R,F){this.expr=R,this.c=F,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let F=0,G=this.expr.length;F<G;F++){const T=i(this.expr[F],R.expr[F]);if(T!==0)return T}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let F=0,G=this.expr.length;F<G;F++)if(!this.expr[F].equals(R.expr[F]))return!1;return!0}return!1}substituteConstants(){const R=ee(this.expr);return R===this.expr?this:te.create(R,this.c,!1)}evaluate(R){for(let F=0,G=this.expr.length;F<G;F++)if(!this.expr[F].evaluate(R))return!1;return!0}static d(R,F,G){const T=[];let q=!1;for(const z of R)if(z){if(z.type===1){q=!0;continue}if(z.type===0)return n.INSTANCE;if(z.type===6){T.push(...z.expr);continue}T.push(z)}if(T.length===0&&q)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(i);for(let z=1;z<T.length;z++)T[z-1].equals(T[z])&&(T.splice(z,1),z--);if(T.length===1)return T[0];for(;T.length>1;){const z=T[T.length-1];if(z.type!==9)break;T.pop();const ie=T.pop(),B=T.length===0,X=W.create(z.expr.map(H=>te.create([H,ie],null,G)),null,B);X&&(T.push(X),T.sort(i))}if(T.length===1)return T[0];if(G){for(let z=0;z<T.length;z++)for(let ie=z+1;ie<T.length;ie++)if(T[z].negate().equals(T[ie]))return n.INSTANCE;if(T.length===1)return T[0]}return new te(T,F)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const F of this.expr)R.push(...F.keys());return R}map(R){return new te(this.expr.map(F=>F.map(R)),null)}negate(){if(!this.c){const R=[];for(const F of this.expr)R.push(F.negate());this.c=W.create(R,this,!0)}return this.c}}e.$1i=te;class W{static create(R,F,G){return W.d(R,F,G)}constructor(R,F){this.expr=R,this.c=F,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let F=0,G=this.expr.length;F<G;F++){const T=i(this.expr[F],R.expr[F]);if(T!==0)return T}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let F=0,G=this.expr.length;F<G;F++)if(!this.expr[F].equals(R.expr[F]))return!1;return!0}return!1}substituteConstants(){const R=ee(this.expr);return R===this.expr?this:W.create(R,this.c,!1)}evaluate(R){for(let F=0,G=this.expr.length;F<G;F++)if(this.expr[F].evaluate(R))return!0;return!1}static d(R,F,G){let T=[],q=!1;if(R){for(let z=0,ie=R.length;z<ie;z++){const B=R[z];if(B){if(B.type===0){q=!0;continue}if(B.type===1)return a.INSTANCE;if(B.type===9){T=T.concat(B.expr);continue}T.push(B)}}if(T.length===0&&q)return n.INSTANCE;T.sort(i)}if(T.length!==0){if(T.length===1)return T[0];for(let z=1;z<T.length;z++)T[z-1].equals(T[z])&&(T.splice(z,1),z--);if(T.length===1)return T[0];if(G){for(let z=0;z<T.length;z++)for(let ie=z+1;ie<T.length;ie++)if(T[z].negate().equals(T[ie]))return a.INSTANCE;if(T.length===1)return T[0]}return new W(T,F)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const F of this.expr)R.push(...F.keys());return R}map(R){return new W(this.expr.map(F=>F.map(R)),null)}negate(){if(!this.c){const R=[];for(const F of this.expr)R.push(F.negate());for(;R.length>1;){const F=R.shift(),G=R.shift(),T=[];for(const q of U(F))for(const z of U(G))T.push(te.create([q,z],null,!1));R.unshift(W.create(T,null,!1))}this.c=W.create(R,this,!0)}return this.c}}e.$2i=W;class K extends b{static{this.d=[]}static all(){return K.d.values()}constructor(R,F,G){super(R,null),this.f=F,typeof G=="object"?K.d.push({...G,key:R}):G!==!0&&K.d.push({key:R,description:G,type:F!=null?typeof F:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return p.create(this.key,R)}notEqualsTo(R){return L.create(this.key,R)}}e.$3i=K,e.$4i=(0,P.$Lh)("contextKeyService");function V(Z,R){return Z<R?-1:Z>R?1:0}function oe(Z,R,F,G){return Z<F?-1:Z>F?1:R<G?-1:R>G?1:0}function me(Z,R){if(Z.type===0||R.type===1)return!0;if(Z.type===9)return R.type===9?se(Z.expr,R.expr):!1;if(R.type===9){for(const F of R.expr)if(me(Z,F))return!0;return!1}if(Z.type===6){if(R.type===6)return se(R.expr,Z.expr);for(const F of Z.expr)if(me(F,R))return!0;return!1}return Z.equals(R)}e.$5i=me;function se(Z,R){let F=0,G=0;for(;F<Z.length&&G<R.length;){const T=Z[F].cmp(R[G]);if(T<0)return!1;T===0&&F++,G++}return F===Z.length}function U(Z){return Z.type===9?Z.expr:[Z]}}),define(be[216],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.ID=void 0,e.ID="diagnosticsService",e.$hm=(0,D.$Lh)(e.ID);function O(P){return!!P.hostName&&!!P.errorMessage}e.$im=O;class r{async getPerformanceInfo(A,I){return{}}async getSystemInfo(A,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,I){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.$jm=r}),define(be[80],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$En=(0,D.$Lh)("downloadService")}),define(be[25],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=void 0,e.$Sh=(0,D.$Lh)("environmentService"),e.$Th=(0,D.$Mh)(e.$Sh)}),define(be[30],we([1,0,179,6]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$1n=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=void 0,e.$Nn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$On=new RegExp(e.$Nn),e.$Pn="__web_extension",e.$Qn="skipWalkthrough",e.$Rn="extensionsSync",e.$Sn="dependecyOrPackExtensionInstall";function r(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Tn=r;function P(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Un=P;function A(u,c){switch(u){case 3:return c==="x64"?"win32-x64":c==="ia32"?"win32-ia32":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Vn=A;function I(u,c){return c==="web"&&!u.includes("web")}e.$Wn=I;function w(u,c,y){return I(c,y)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===y?!0:$(y).includes(u)}e.$Xn=w;function $(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Yn=$;function C(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$Zn=C;var S;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var v;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var d;(function(u){u.Install="install",u.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var g;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(g||(e.InstallOperation=g={})),e.$1n=(0,O.$Lh)("extensionGalleryService");var m;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));var l;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(l||(e.ExtensionSignaturetErrorCode=l={}));class f extends Error{constructor(c,y){super(c),this.code=y,this.name=y}}e.$2n=f,e.$3n=(0,O.$Lh)("extensionManagementService"),e.$4n="extensionsIdentifiers/disabled",e.$5n="extensionsIdentifiers/enabled",e.$6n=(0,O.$Lh)("IGlobalExtensionEnablementService"),e.$7n=(0,O.$Lh)("IExtensionTipsService"),e.$8n=(0,D.localize)(0,null),e.$9n={value:e.$8n,original:"Extensions"},e.$0n={value:(0,D.localize)(1,null),original:"Preferences"}}),define(be[217],we([1,0,5,2,22,4,51,30]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.$$o=void 0;function w(l,f){return l?P.URI.revive(f?f.transformIncoming(l):l):void 0}function $(l,f){return f?f.transformOutgoingURI(l):l}function C(l,f){f=f||A.$Dm;const u=l.manifest;return{...(0,A.$Gm)({...l,manifest:void 0},f),manifest:u}}function S(l,f){return l?.profileLocation?(0,A.$Gm)(l,f??A.$Dm):l}function v(l,f){return f?(0,r.$Ym)(l,u=>u instanceof P.URI?f.transformOutgoingURI(u):void 0):l}class d{constructor(f,u){this.a=f,this.b=u,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,u){const c=this.b(f);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,y=>({...y,profileLocation:y.profileLocation?$(y.profileLocation,c):y.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,y=>y.map(h=>({...h,local:h.local?v(h.local,c):h.local,profileLocation:h.profileLocation?$(h.profileLocation,c):h.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,y=>({...y,profileLocation:y.profileLocation?$(y.profileLocation,c):y.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,y=>({...y,profileLocation:y.profileLocation?$(y.profileLocation,c):y.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,y=>v(y,c))}throw new Error("Invalid listen")}async call(f,u,c){const y=this.b(f);switch(u){case"zip":{const h=C(c[0],y),t=await this.a.zip(h);return $(t,y)}case"unzip":return this.a.unzip(w(c[0],y));case"install":return this.a.install(w(c[0],y),S(c[1],y));case"installFromLocation":return this.a.installFromLocation(w(c[0],y),w(c[1],y));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(c[0],w(c[1],y),w(c[2],y));case"getManifest":return this.a.getManifest(w(c[0],y));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(c[0]);case"installFromGallery":return this.a.installFromGallery(c[0],S(c[1],y));case"installGalleryExtensions":{const h=c[0];return this.a.installGalleryExtensions(h.map(({extension:t,options:s})=>({extension:t,options:S(s,y)??{}})))}case"uninstall":return this.a.uninstall(C(c[0],y),S(c[1],y));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(c[0],y));case"getInstalled":return(await this.a.getInstalled(c[0],w(c[1],y))).map(t=>v(t,y));case"toggleAppliationScope":{const h=await this.a.toggleAppliationScope(C(c[0],y),w(c[1],y));return v(h,y)}case"copyExtensions":return this.a.copyExtensions(w(c[0],y),w(c[1],y));case"updateMetadata":{const h=await this.a.updateMetadata(C(c[0],y),c[1],w(c[2],y));return v(h,y)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(c[0],c[1],c[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$$o=d;class g extends O.$Qc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new D.$Ld),this.f=this.B(new D.$Ld),this.g=this.B(new D.$Ld),this.h=this.B(new D.$Ld),this.j=this.B(new D.$Ld),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?P.URI.revive(u.source):u.source,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(c=>({...c,local:c.local?C(c.local,null):c.local,source:this.r(c.source)?P.URI.revive(c.source):c.source,profileLocation:P.URI.revive(c.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:P.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(C(u,null))))}n(f,u){f.fire(u)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const u=await this.getTargetPlatform();return f.allTargetPlatforms.some(c=>(0,I.$Xn)(c,f.allTargetPlatforms,u))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(u=>P.URI.revive(u)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,u){return Promise.resolve(this.m.call("install",[f,u])).then(c=>C(c,null))}installFromLocation(f,u){return Promise.resolve(this.m.call("installFromLocation",[f,u])).then(c=>C(c,null))}async installExtensionsFromProfile(f,u,c){return(await this.m.call("installExtensionsFromProfile",[f,u,c])).map(h=>C(h,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,u){return Promise.resolve(this.m.call("installFromGallery",[f,u])).then(c=>C(c,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(c=>({...c,local:c.local?C(c.local,null):c.local,source:this.r(c.source)?P.URI.revive(c.source):c.source,profileLocation:P.URI.revive(c.profileLocation)}))}uninstall(f,u){return Promise.resolve(this.m.call("uninstall",[f,u]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(u=>C(u,null))}getInstalled(f=null,u){return Promise.resolve(this.m.call("getInstalled",[f,u])).then(c=>c.map(y=>C(y,null)))}updateMetadata(f,u,c){return Promise.resolve(this.m.call("updateMetadata",[f,u,c])).then(y=>C(y,null))}toggleAppliationScope(f,u){return this.m.call("toggleAppliationScope",[f,u]).then(c=>C(c,null))}copyExtensions(f,u){return this.m.call("copyExtensions",[f,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,u,c){const y=await this.m.call("download",[f,u,c]);return P.URI.revive(y)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$_o=g;class m{constructor(f){this.a=f}listen(f,u){throw new Error("Invalid listen")}call(f,u,c){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(P.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$ap=m}),define(be[81],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9o=e.$8o=void 0,e.$8o=(0,D.$Lh)("IExtensionSignatureVerificationService");class O{b(){return this.a||(this.a=new Promise((P,A)=>le(["node-vsce-sign"],async I=>P(I),A))),this.a}async verify(P,A,I){let w;try{w=await this.b()}catch{return!1}return w.verify(P,A,I)}}e.$9o=O}),define(be[16],we([1,0,61,7,17,10,4,187,6,3,12]),function(le,e,D,O,r,P,A,I,w,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.FileKind=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileOperationResult=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.FileChangeType=e.$lk=e.FileOperation=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.FileSystemProviderErrorCode=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$8j=e.$7j=void 0,e.$7j=(0,w.$Lh)("fileService");function S(V){return V.create===!0}e.$8j=S;var v;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var d;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var g;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function m(V){return!!(V.capabilities&2)}e.$9j=m;function l(V){return!!(V.capabilities&8)}e.$0j=l;function f(V){return!!(V.capabilities&131072)}e.$$j=f;function u(V){return!!(V.capabilities&4)}e.$_j=u;function c(V){return!!(V.capabilities&16)}e.$ak=c;function y(V){return m(V)?!!(V.capabilities&16384):!1}e.$bk=y;function h(V){return m(V)?!!(V.capabilities&32768):!1}e.$ck=h;function t(V){return!!(V.capabilities&65536)}e.$dk=t;function s(V){return!!(V.capabilities&2048)}e.$ek=s;var o;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class i extends Error{static create(oe,me){const se=new i(oe.toString(),me);return b(se,me),se}constructor(oe,me){super(oe),this.code=me}}e.$fk=i;function n(V,oe){return i.create(V,oe)}e.$gk=n;function a(V){return V||n((0,I.localize)(0,null),o.Unknown)}e.$hk=a;function b(V,oe){return V.name=oe?`${oe} (FileSystemError)`:"FileSystemError",V}e.$ik=b;function p(V){if(!V)return o.Unknown;if(V instanceof i)return V.code;const oe=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!oe)return o.Unknown;switch(oe[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.$jk=p;function E(V){if(V instanceof x)return V.fileOperationResult;switch(p(V)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}e.$kk=E;var k;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(k||(e.FileOperation=k={}));class L{constructor(oe,me,se){this.resource=oe,this.operation=me,this.target=se}isOperation(oe){return this.operation===oe}}e.$lk=L;var j;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class Y{constructor(oe,me){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const se=new Map;for(const U of oe){const Z=se.get(U.type);switch(Z?Z.push([U.resource,U]):se.set(U.type,[[U.resource,U]]),U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}}for(const[U,Z]of se)switch(U){case 1:this.a=D.$Rh.forUris(()=>me),this.a.fill(Z);break;case 0:this.b=D.$Rh.forUris(()=>me),this.b.fill(Z);break;case 2:this.c=D.$Rh.forUris(()=>me),this.c.fill(Z);break}}contains(oe,...me){return this.d(oe,{includeChildren:!1},...me)}affects(oe,...me){return this.d(oe,{includeChildren:!0},...me)}d(oe,me,...se){if(!oe)return!1;const U=se.length>0;return!!((!U||se.includes(1))&&(this.a?.get(oe)||me.includeChildren&&this.a?.findSuperstr(oe))||(!U||se.includes(0))&&(this.b?.get(oe)||me.includeChildren&&this.b?.findSuperstr(oe))||(!U||se.includes(2))&&(this.c?.findSubstr(oe)||me.includeChildren&&this.c?.findSuperstr(oe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$mk=Y;function ce(V,oe,me){return!V||!oe||V===oe||oe.length>V.length?!1:(oe.charAt(oe.length-1)!==O.sep&&(oe+=O.sep),me?(0,r.$1e)(V,oe):V.indexOf(oe)===0)}e.$nk=ce;class x extends Error{constructor(oe,me,se){super(oe),this.fileOperationResult=me,this.options=se}}e.$ok=x;class ne extends x{constructor(oe,me,se,U){super(oe,me,U),this.fileOperationResult=me,this.size=se}}e.$pk=ne;class ue extends x{constructor(oe,me,se){super(oe,2,se),this.stat=me}}e.$qk=ue;var _;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(_||(e.FileOperationResult=_={})),e.$rk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$sk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$tk="files.associations",e.$uk="files.exclude",e.$vk="files.readonlyInclude",e.$wk="files.readonlyExclude",e.$xk="files.readonlyFromPermissions";var he;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$yk="";function ee(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$zk=ee;async function te(V,oe){if(!oe.hasProvider(A.URI.from({scheme:V.scheme})))return new Promise(me=>{const se=oe.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===V.scheme&&U.added&&(se.dispose(),me())})})}e.$Ak=te;class W{static{this.KB=1024}static{this.MB=W.KB*W.KB}static{this.GB=W.MB*W.KB}static{this.TB=W.GB*W.KB}static formatSize(oe){return(0,P.$Af)(oe)||(oe=0),oe<W.KB?(0,I.localize)(1,null,oe.toFixed(0)):oe<W.MB?(0,I.localize)(2,null,(oe/W.KB).toFixed(2)):oe<W.GB?(0,I.localize)(3,null,(oe/W.MB).toFixed(2)):oe<W.TB?(0,I.localize)(4,null,(oe/W.GB).toFixed(2)):(0,I.localize)(5,null,(oe/W.TB).toFixed(2))}}e.$Bk=W;function K(V){const oe=typeof V=="string"||V?.scheme===C.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===C.Schemas.file?1024*W.MB:oe?10*W.MB:$.$o?50*W.MB:1024*W.MB}e.$Ck=K}),define(be[218],we([1,0,15,38,11,5,2,48,4,23,16]),function(le,e,D,O,r,P,A,I,w,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=e.$bN=void 0,e.$bN="localFilesystem";class S extends A.$Qc{constructor(d,g){super(),this.a=d,this.b=g,this.onDidChangeCapabilities=P.Event.None,this.f=this.B(new P.$Ld),this.onDidChangeFile=this.f.event,this.g=this.B(new P.$Ld),this.onDidWatchError=this.g.event,this.h=(0,$.$bg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,g){const{buffer:m}=await this.a.call("readFile",[d,g]);return m}readFileStream(d,g,m){const l=(0,I.$Zd)(u=>D.$_d.concat(u.map(c=>D.$_d.wrap(c))).buffer),f=new A.$Pc;return f.add(this.a.listen("readFileStream",[d,g])(u=>{if(u instanceof D.$_d)l.write(u.buffer);else{if(u==="end")l.end();else{let c;if(u instanceof Error)c=u;else{const y=u;c=(0,C.$gk)(y.message??(0,O.$wi)(y),y.code??C.FileSystemProviderErrorCode.Unknown)}l.error(c),l.end()}f.dispose()}})),f.add(m.onCancellationRequested(()=>{l.error((0,r.$4)()),l.end(),f.dispose()})),l}writeFile(d,g,m){return this.a.call("writeFile",[d,D.$_d.wrap(g),m])}open(d,g){return this.a.call("open",[d,g])}close(d){return this.a.call("close",[d])}async read(d,g,m,l,f){const[u,c]=await this.a.call("read",[d,g,f]);return m.set(u.buffer.slice(0,c),l),c}write(d,g,m,l,f){return this.a.call("write",[d,g,D.$_d.wrap(m),l,f])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,g){return this.a.call("delete",[d,g])}rename(d,g,m){return this.a.call("rename",[d,g,m])}copy(d,g,m){return this.a.call("copy",[d,g,m])}cloneFile(d,g){return this.a.call("cloneFile",[d,g])}j(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const g=d;this.f.fire(g.map(m=>({resource:w.URI.revive(m.resource),type:m.type})))}else{const g=d;this.g.fire(g)}}))}watch(d,g){const m=(0,$.$bg)();return this.a.call("watch",[this.h,m,d,g]),(0,A.$Oc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$cN=S}),define(be[109],we([1,0,15,11,188,16]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;async function A(C,S,v,d,g,m){let l;try{await I(C,S,v,d,g,m)}catch(f){l=f}finally{l&&g.errorTransformer&&(l=g.errorTransformer(l)),typeof l<"u"&&v.error(l),v.end()}}e.$Dp=A;async function I(C,S,v,d,g,m){w(m);const l=await C.open(S,{create:!1});try{w(m);let f=0,u=0,c=g&&typeof g.length=="number"?g.length:void 0,y=D.$_d.alloc(Math.min(g.bufferSize,typeof c=="number"?c:g.bufferSize)),h=g&&typeof g.position=="number"?g.position:0,t=0;do u=await C.read(l,h,y.buffer,t,y.byteLength-t),h+=u,t+=u,f+=u,typeof c=="number"&&(c-=u),t===y.byteLength&&(await v.write(d(y)),y=D.$_d.alloc(Math.min(g.bufferSize,typeof c=="number"?c:g.bufferSize)),t=0);while(u>0&&(typeof c!="number"||c>0)&&w(m)&&$(f,g));if(t>0){let s=t;typeof c=="number"&&(s=Math.min(t,c)),v.write(d(y.slice(0,s)))}}catch(f){throw(0,P.$hk)(f)}finally{await C.close(l)}}function w(C){if(C.isCancellationRequested)throw(0,O.$4)();return!0}function $(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,P.$gk)((0,r.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(be[67],we([1,0,78,2,7,3,4,16]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;function w(f){return f.recursive===!0}e.$Fp=w;class $ extends O.$Qc{static{this.a=5}constructor(u,c,y,h){super(),this.h=u,this.j=c,this.m=y,this.n=h,this.c=this.B(new O.$Rc),this.f=void 0,this.g=0}s(){const u=new O.$Pc;this.c.value=u,this.b=this.r(u),this.b.setVerboseLogging(this.m),u.add(this.b.onDidChangeFile(c=>this.h(c))),u.add(this.b.onDidLogMessage(c=>this.j(c))),u.add(this.b.onDidError(c=>this.t(c)))}t(u){this.n.restartOnError?this.g<$.a&&this.f?(this.w(`restarting watcher after error: ${u}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${u}`):this.w(u)}u(u){this.g++,this.s(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.m=u,await this.b?.setVerboseLogging(u)}w(u){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${u}`})}y(u){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Gp=$;class C extends ${constructor(u,c,y){super(u,c,y,{type:"node.js",restartOnError:!1})}}e.$Hp=C;class S extends ${constructor(u,c,y){super(u,c,y,{type:"universal",restartOnError:!0})}}e.$Ip=S;function v(f){return f.map(u=>({type:u.type,resource:A.URI.file(u.path)}))}e.$Jp=v;function d(f){const u=new l;for(const c of f)u.processEvent(c);return u.coalesce()}e.$Kp=d;function g(f,u){return typeof u=="string"&&!u.startsWith(D.$oj)&&!(0,r.$gc)(u)?{base:f,pattern:u}:u}e.$Lp=g;function m(f,u){const c=[];for(const y of u)c.push((0,D.$sj)(g(f,y)));return c}e.$Mp=m;class l{constructor(){this.a=new Set,this.b=new Map}c(u){return P.$k?u.path:u.path.toLowerCase()}processEvent(u){const c=this.b.get(this.c(u));let y=!1;if(c){const h=c.type,t=u.type;c.path!==u.path&&(u.type===2||u.type===1)?y=!0:h===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(c)):h===2&&t===1?c.type=0:h===1&&t===0||(c.type=t)}else y=!0;y&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],c=[];return Array.from(this.a).filter(y=>y.type!==2?(u.push(y),!1):!0).sort((y,h)=>y.path.length-h.path.length).filter(y=>c.some(h=>(0,I.$nk)(y.path,h,!P.$k))?!1:(c.push(y.path),!0)).concat(u)}}}),define(be[219],we([1,0,27,14,20,39,2,97,7,3,168,21,67]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=e.$Zp=void 0;class d extends A.$Qc{static{this.a=100}static{this.b=75}constructor(l,f,u,c){super(),this.m=l,this.n=f,this.r=u,this.s=c,this.c=this.B(new O.$6g({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.n(y))),this.f=this.B(new O.$5g(y=>this.z(y),d.b)),this.g=(0,v.$Mp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,v.$Mp)(this.m.path,this.m.includes):void 0,this.j=new r.$Vd,this.ready=this.t()}async t(){try{const l=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const f=await S.Promises.stat(l);this.B(await this.w(l,f.isDirectory()))}catch(l){l.code!=="ENOENT"?this.D(l):this.G(l)}}async u(l){let f=l.path;try{f=await S.Promises.realpath(l.path),l.path===f&&(f=await(0,C.$Wp)(l.path)??l.path),l.path!==f&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${l.path}, real: ${f})`)}catch{}return f}async w(l,f){if($.$j&&(0,P.$Vf)(l,"/Volumes/",!0))return this.D(`Refusing to watch ${l} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$Qc.None;const u=new r.$Vd(this.j.token),c=new A.$Pc;try{const y=(0,w.$lc)(l),h=(0,D.watch)(l);c.add((0,A.$Oc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${l}'`);const t=new Set;if(f)try{for(const o of await S.Promises.readdir(l))t.add(o)}catch(o){this.D(o)}const s=new Map;c.add((0,A.$Oc)(()=>{for(const[,o]of s)o.dispose();s.clear()})),h.on("error",(o,i)=>{this.D(`Failed to watch ${l} for changes using fs.watch() (${o}, ${i})`),this.dispose()}),h.on("change",(o,i)=>{if(u.token.isCancellationRequested)return;this.G(`[raw] ["${o}"] ${i}`);let n="";if(i&&(n=i.toString(),$.$j&&(n=(0,I.$il)(n))),!(!n||o!=="change"&&o!=="rename"))if(f)if(o==="rename"){s.get(n)?.dispose();const a=setTimeout(async()=>{if(s.delete(n),n===y&&!await S.Promises.exists(l)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const b=await this.C((0,w.$hc)(l,n));if(u.token.isCancellationRequested)return;let p;b?t.has(n)?p=0:(p=1,t.add(n)):(t.delete(n),p=2),this.y({path:(0,w.$hc)(this.m.path,n),type:p})},d.a);s.set(n,(0,A.$Oc)(()=>clearTimeout(a)))}else{let a;t.has(n)?a=0:(a=1,t.add(n)),this.y({path:(0,w.$hc)(this.m.path,n),type:a})}else if(o==="rename"||n!==y){const a=setTimeout(async()=>{const b=await S.Promises.exists(l);u.token.isCancellationRequested||(b?(this.y({path:this.m.path,type:0},!0),c.add(await this.w(l,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);c.clear(),c.add((0,A.$Oc)(()=>clearTimeout(a)))}else this.y({path:this.m.path,type:0},!0)})}catch(y){await S.Promises.exists(l)&&!u.token.isCancellationRequested&&this.D(`Failed to watch ${l} for changes using fs.watch() (${y.toString()})`)}return(0,A.$Oc)(()=>{u.dispose(!0),c.dispose()})}y(l,f=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`),!f&&this.g.some(u=>u(l.path))?this.s&&this.G(` >> ignored (excluded) ${l.path}`):!f&&this.h&&this.h.length>0&&!this.h.some(u=>u(l.path))?this.s&&this.G(` >> ignored (not included) ${l.path}`):this.f.work(l))}z(l){const f=(0,v.$Kp)(l);if(f.length>0){if(this.s)for(const c of f)this.G(`>> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`);this.c.work(f)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${f.length}, most recent change: ${f[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(l){if($.$k)return S.Promises.exists(l);try{const f=(0,w.$lc)(l);return(await S.Promises.readdir((0,w.$kc)(l))).some(c=>c===f)}catch(f){return this.G(f),!1}}setVerboseLogging(l){this.s=l}D(l){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${l}`})}F(l){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${l}`})}G(l){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${l}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Zp=d;async function g(m,l,f,u,c=512){const y=await S.Promises.open(m,"r"),h=Buffer.allocUnsafe(c),t=new r.$Vd(u);let s,o=!1;const i={path:m,excludes:[],recursive:!1},n=new d(i,a=>{(async()=>{for(const{type:b}of a)if(b===0){if(o)return;o=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:p}=await S.Promises.read(y,h,0,c,null);if(!p||t.token.isCancellationRequested)break;l(h.slice(0,p))}}catch(p){s=new Error(p),t.dispose(!0)}finally{o=!1}}})()});return await n.ready,f(),new Promise((a,b)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await S.Promises.close(y)}catch(p){s=new Error(p)}s?b(s):a()})})}e.$1p=g}),define(be[220],we([1,0,5,78,2,3,219]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class I extends r.$Qc{constructor(){super(...arguments),this.a=this.B(new D.$Ld),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Ld),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch($){const C=this.j($),S=C.filter(d=>{const g=this.c.get(d.path);return g?!(0,O.$wj)(g.request.excludes,d.excludes)||!(0,O.$wj)(g.request.includes,d.includes):!0}),v=Array.from(this.c.values()).filter(({request:d})=>!C.find(g=>g.path===d.path&&(0,O.$wj)(g.excludes,d.excludes)&&(0,O.$wj)(g.includes,d.includes))).map(({request:d})=>d.path);S.length&&this.m(`Request to start watching: ${S.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const d of v)this.h(d);for(const d of S)this.g(d)}g($){const C=new A.$Zp($,v=>this.a.fire(v),v=>this.b.fire(v),this.f),S={request:$,instance:C};this.c.set($.path,S)}async stop(){for(const[$]of this.c)this.h($);this.c.clear()}h($){const C=this.c.get($);C&&(this.c.delete($),C.instance.dispose())}j($){const C=new Map;for(const S of $){const v=P.$k?S.path:S.path.toLowerCase();C.set(v,S)}return Array.from(C.values())}async setVerboseLogging($){this.f=$;for(const[,C]of this.c)C.instance.setVerboseLogging($)}m($){this.f&&this.b.fire({type:"trace",message:this.n($)})}n($,C){return C?`[File Watcher (node.js)] ${$} (path: ${C.request.path})`:`[File Watcher (node.js)] ${$}`}}e.$2p=I}),define(be[221],we([1,0,67,220]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;class r extends D.$Hp{constructor(A,I,w){super(A,I,w),this.s()}r(A){return A.add(new O.$2p)}}e.$3p=r}),define(be[222],we([1,0,12,43,107,67]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;class A extends P.$Ip{constructor(w,$,C){super(w,$,C),this.s()}r(w){const $=w.add(new r.$Tp(D.$_f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add($.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),O.ProxyChannel.toService((0,O.$sh)($.getChannel("watcher")))}}e.$Up=A}),define(be[82],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=void 0;class D{constructor(...r){this.a=new Map;for(const[P,A]of r)this.set(P,A)}set(r,P){const A=this.a.get(r);return this.a.set(r,P),A}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$Jh=D}),define(be[110],we([1,0,14,11,2,65,215,6,82,96]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0;const C=!1;class S extends Error{constructor(l){super("cyclic dependency between services"),this.message=l.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class v{constructor(l=new w.$Jh,f=!1,u,c=C){this.f=l,this.g=f,this.h=u,this.i=c,this.o=new Set,this.f.set(I.$Kh,this),this._globalGraph=c?u?._globalGraph??new A.$6p(y=>y):void 0}createChild(l){return new v(l,this.g,this,this.i)}invokeFunction(l,...f){const u=g.traceInvocation(this.i,l);let c=!1;try{return l({get:h=>{if(c)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(h,u);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...f)}finally{c=!0,u.stop()}}createInstance(l,...f){let u,c;return l instanceof P.$Ih?(u=g.traceCreation(this.i,l.ctor),c=this.j(l.ctor,l.staticArguments.concat(f),u)):(u=g.traceCreation(this.i,l),c=this.j(l,f,u)),u.stop(),c}j(l,f=[],u){const c=I._util.getServiceDependencies(l).sort((t,s)=>t.index-s.index),y=[];for(const t of c){const s=this.m(t.id,u);s||this.u(`[createInstance] ${l.name} depends on UNKNOWN service ${t.id}.`,!1),y.push(s)}const h=c.length>0?c[0].index:f.length;if(f.length!==h){console.trace(`[createInstance] First service dependency of ${l.name} at position ${h+1} conflicts with ${f.length} static arguments`);const t=h-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,h)}return Reflect.construct(l,f.concat(y))}k(l,f){if(this.f.get(l)instanceof P.$Ih)this.f.set(l,f);else if(this.h)this.h.k(l,f);else throw new Error("illegalState - setting UNKNOWN service instance")}l(l){const f=this.f.get(l);return!f&&this.h?this.h.l(l):f}m(l,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(l));const u=this.l(l);return u instanceof P.$Ih?this.q(l,u,f.branch(l,!0)):(f.branch(l,!1),u)}q(l,f,u){if(this.o.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this.o.add(l);try{return this.r(l,f,u)}finally{this.o.delete(l)}}r(l,f,u){const c=new A.$6p(t=>t.id.toString());let y=0;const h=[{id:l,desc:f,_trace:u}];for(;h.length;){const t=h.pop();if(c.lookupOrInsertNode(t),y++>1e3)throw new S(c);for(const s of I._util.getServiceDependencies(t.desc.ctor)){const o=this.l(s.id);if(o||this.u(`[createInstance] ${l} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),o instanceof P.$Ih){const i={id:s.id,desc:o,_trace:t._trace.branch(s.id,!0)};c.insertEdge(t,i),h.push(i)}}}for(;;){const t=c.roots();if(t.length===0){if(!c.isEmpty())throw new S(c);break}for(const{data:s}of t){if(this.l(s.id)instanceof P.$Ih){const i=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,i)}c.removeNode(s)}}return this.l(l)}s(l,f,u=[],c,y){if(this.f.get(l)instanceof P.$Ih)return this.t(l,f,u,c,y);if(this.h)return this.h.s(l,f,u,c,y);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}t(l,f,u=[],c,y){if(c){const h=new v(void 0,this.g,this,this.i);h.c=String(l);const t=new Map,s=new D.$8g(()=>{const o=h.j(f,u,y);for(const[i,n]of t){const a=o[i];if(typeof a=="function")for(const b of n)a.apply(o,b)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,i){if(!s.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new $.$Zc,t.set(i,b)),(E,k,L)=>{const j=b.push([E,k,L]);return(0,r.$Oc)(j)}}if(i in o)return o[i];const n=s.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),o[i]=a),a},set(o,i,n){return s.value[i]=n,!0},getPrototypeOf(o){return f.prototype}})}else return this.j(f,u,y)}u(l,f){if(f&&console.warn(l),this.g)throw new Error(l)}}e.$7p=v;var d;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(d||(d={}));class g{static{this.all=new Set}static{this.c=new class extends g{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(l,f){return l?new g(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):g.c}static traceCreation(l,f){return l?new g(1,f.name):g.c}static{this.f=0}constructor(l,f){this.type=l,this.name=f,this.g=Date.now(),this.h=[]}branch(l,f){const u=new g(3,l.toString());return this.h.push([l,f,u]),u}stop(){const l=Date.now()-this.g;g.f+=l;let f=!1;function u(y,h){const t=[],s=new Array(y+1).join("	");for(const[o,i,n]of h.h)if(i&&n){f=!0,t.push(`${s}CREATES -> ${o}`);const a=u(y+1,n);a&&t.push(a)}else t.push(`${s}uses -> ${o}`);return t.join(`
`)}const c=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${g.f.toFixed(2)}ms)`];(l>2||f)&&g.all.add(c.join(`
`))}}e.$8p=g}),define(be[223],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$Qu=void 0,e.$Qu=(0,D.$Lh)("labelService");var O;(function(r){r[r.SHORT=0]="SHORT",r[r.MEDIUM=1]="MEDIUM",r[r.LONG=2]="LONG"})(O||(e.Verbosity=O={}))});var Ae=this&&this.__param||function(le,e){return function(D,O){e(D,O,le)}};define(be[83],we([1,0,20,2,3,190,30,6]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=void 0;function w(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$Iq=w,e.$Jq=(0,I.$Lh)("languagePackService");let $=class extends O.$Qc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new D.$Vd;setTimeout(()=>S.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const g=v.firstPage.filter(m=>m.properties.localizedLanguages?.length&&m.tags.some(l=>l.startsWith("lp-"))).map(m=>{const l=m.properties.localizedLanguages?.[0],f=w(m);return{...this.f(f,l,m),extensionId:m.identifier.id,galleryExtension:m}});return g.push(this.f("en","English")),g}f(S,v,d){const g=v??S;let m;if(g!==S&&(m=`(${S})`),S.toLowerCase()===r.$v.toLowerCase()&&(m??="",m+=(0,P.localize)(0,null)),d?.installCount){m??="";const l=d.installCount;let f;l>1e6?f=`${Math.floor(l/1e5)/10}M`:l>1e3?f=`${Math.floor(l/1e3)}K`:f=String(l),m+=` $(cloud-download) ${f}`}return{id:S,label:g,description:m}}};e.$Kq=$,e.$Kq=$=Oe([Ae(0,A.$1n)],$)}),define(be[13],we([1,0,38,5,59,2,26,3,19,10,4,66,6]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.log=e.$9i=e.LogLevel=e.$8i=e.$7i=e.$6i=void 0,e.$6i=(0,v.$Lh)("logService"),e.$7i=(0,v.$Lh)("loggerService");function d(){return new Date().toISOString()}function g(E){return(0,$.$Af)(E)}e.$8i=g;var m;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$9i=m.Info;function l(E,k,L){switch(k){case m.Trace:E.trace(L);break;case m.Debug:E.debug(L);break;case m.Info:E.info(L);break;case m.Warning:E.warn(L);break;case m.Error:E.error(L);break;case m.Off:break;default:throw new Error(`Invalid log level ${k}`)}}e.log=l;function f(E,k=!1){let L="";for(let j=0;j<E.length;j++){let Y=E[j];if(Y instanceof Error&&(Y=(0,D.$wi)(Y,k)),typeof Y=="object")try{Y=JSON.stringify(Y)}catch{}L+=(j>0?" ":"")+Y}return L}class u extends P.$Qc{constructor(){super(...arguments),this.b=e.$9i,this.c=this.B(new O.$Ld),this.onDidChangeLogLevel=this.c.event}setLevel(k){this.b!==k&&(this.b=k,this.c.fire(this.b))}getLevel(){return this.b}f(k){return this.b!==m.Off&&this.b<=k}}e.$$i=u;class c extends u{constructor(k){super(),this.h=k}f(k){return this.h||super.f(k)}trace(k,...L){this.f(m.Trace)&&this.g(m.Trace,f([k,...L],!0))}debug(k,...L){this.f(m.Debug)&&this.g(m.Debug,f([k,...L]))}info(k,...L){this.f(m.Info)&&this.g(m.Info,f([k,...L]))}warn(k,...L){this.f(m.Warning)&&this.g(m.Warning,f([k,...L]))}error(k,...L){if(this.f(m.Error))if(k instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=k.stack,this.g(m.Error,f(j))}else this.g(m.Error,f([k,...L]))}flush(){}}e.$_i=c;class y extends u{constructor(k=e.$9i){super(),this.setLevel(k),this.g=!I.$i}trace(k,...L){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...L):console.log(`[main ${d()}]`,k,...L))}debug(k,...L){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...L):console.log(`[main ${d()}]`,k,...L))}info(k,...L){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,k,...L):console.log(`[main ${d()}]`,k,...L))}warn(k,...L){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,k,...L):console.warn(`[main ${d()}]`,k,...L))}error(k,...L){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,k,...L):console.error(`[main ${d()}]`,k,...L))}dispose(){}flush(){}}e.$aj=y;class h extends u{constructor(k=e.$9i,L=!0){super(),this.g=L,this.setLevel(k)}trace(k,...L){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",k,...L):console.log(k,...L))}debug(k,...L){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",k,...L):console.log(k,...L))}info(k,...L){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",k,...L):console.log(k,...L))}warn(k,...L){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",k,...L):console.log(k,...L))}error(k,...L){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",k,...L):console.error(k,...L))}dispose(){}flush(){}}e.$bj=h;class t extends u{constructor(k,L=e.$9i){super(),this.g=k,this.setLevel(L)}trace(k,...L){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(k),...L])}debug(k,...L){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(k),...L])}info(k,...L){this.f(m.Info)&&this.g.log(m.Info,[this.h(k),...L])}warn(k,...L){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(k),...L])}error(k,...L){this.f(m.Error)&&this.g.log(m.Error,[this.h(k),...L])}h(k){return typeof k=="string"?k:(0,D.$wi)(k,this.f(m.Trace))}dispose(){}flush(){}}e.$cj=t;class s extends u{constructor(k){super(),this.g=k,k.length&&this.setLevel(k[0].getLevel())}setLevel(k){for(const L of this.g)L.setLevel(k);super.setLevel(k)}trace(k,...L){for(const j of this.g)j.trace(k,...L)}debug(k,...L){for(const j of this.g)j.debug(k,...L)}info(k,...L){for(const j of this.g)j.info(k,...L)}warn(k,...L){for(const j of this.g)j.warn(k,...L)}error(k,...L){for(const j of this.g)j.error(k,...L)}flush(){for(const k of this.g)k.flush()}dispose(){for(const k of this.g)k.dispose()}}e.$dj=s;class o extends P.$Qc{constructor(k,L,j){if(super(),this.h=k,this.j=L,this.b=new A.$yc,this.c=this.B(new O.$Ld),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$Ld),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$Ld),this.onDidChangeVisibility=this.g.event,j)for(const Y of j)this.b.set(Y.resource,{logger:void 0,info:Y})}m(k){return(0,$.$wf)(k)?[...this.b.values()].find(L=>L.info.id===k):this.b.get(k)}getLogger(k){return this.m(k)?.logger}createLogger(k,L){const j=this.n(k),Y=(0,$.$wf)(k)?k:L?.id??(0,r.$zi)(j.toString()).toString(16);let ce=this.b.get(j)?.logger;const x=L?.logLevel==="always"?m.Trace:L?.logLevel;ce||(ce=this.s(j,x??this.getLogLevel(j)??this.h,{...L,id:Y}));const ne={logger:ce,info:{resource:j,id:Y,logLevel:x,name:L?.name,hidden:L?.hidden,extensionId:L?.extensionId,when:L?.when}};return this.registerLogger(ne.info),this.b.set(j,ne),ce}n(k){return(0,$.$wf)(k)?(0,w.$sg)(this.j,`${k}.log`):k}setLogLevel(k,L){if(C.URI.isUri(k)){const j=k,Y=L,ce=this.b.get(j);ce&&Y!==ce.info.logLevel&&(ce.info.logLevel=Y===this.h?void 0:Y,ce.logger?.setLevel(Y),this.b.set(ce.info.resource,ce),this.f.fire([j,Y]))}else{this.h=k;for(const[j,Y]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&Y.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(k,L){const j=this.m(k);j&&L!==!j.info.hidden&&(j.info.hidden=!L,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,L]))}getLogLevel(k){let L;return k&&(L=this.b.get(k)?.info.logLevel),L??this.h}registerLogger(k){const L=this.b.get(k.resource);L?L.info.hidden!==k.hidden&&this.setVisibility(k.resource,!k.hidden):(this.b.set(k.resource,{info:k,logger:void 0}),this.c.fire({added:[k],removed:[]}))}deregisterLogger(k){const L=this.b.get(k);L&&(L.logger&&L.logger.dispose(),this.b.delete(k),this.c.fire({added:[],removed:[L.info]}))}*getRegisteredLoggers(){for(const k of this.b.values())yield k.info}getRegisteredLogger(k){return this.b.get(k)?.info}dispose(){this.b.forEach(k=>k.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ej=o;class i{constructor(){this.onDidChangeLogLevel=new O.$Ld().event}setLevel(k){}getLevel(){return m.Info}trace(k,...L){}debug(k,...L){}info(k,...L){}warn(k,...L){}error(k,...L){}critical(k,...L){}dispose(){}flush(){}}e.$fj=i;class n extends i{}e.$gj=n;function a(E){if(E.verbose)return m.Trace;if(typeof E.logLevel=="string"){const k=p(E.logLevel.toLowerCase());if(k!==void 0)return k}return e.$9i}e.$hj=a;function b(E){switch(E){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$ij=b;function p(E){switch(E){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$jj=p,e.$kj=new S.$3i("logLevel",b(m.Info))}),define(be[224],we([1,0,18,14,11,5,2,7,67,13]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class C extends A.$Qc{constructor(v,d){super(),this.a=v,this.b=d,this.c=this.B(new P.$Ld),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Ld),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Og(0)),this.w=[],this.y=this.B(new O.$Og(0))}watch(v,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(v,d):this.z(v,d)}n(v,d){const g={path:this.H(v),excludes:d.excludes,includes:d.includes,recursive:d.recursive},m=(0,D.$Sb)(this.j,g);return this.r(),(0,A.$Oc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,r.$Y)(v))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,w.$Jp)(d)),d=>this.G(d),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const d of this.j)(0,w.$Fp)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const d of this.j)(0,w.$Fp)(d)&&v.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,d){const g={path:this.H(v),excludes:d.excludes,includes:d.includes,recursive:!1},m=(0,D.$Sb)(this.w,g);return this.C(),(0,A.$Oc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,r.$Y)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,w.$Jp)(v)),v=>this.G(v),this.a.getLevel()===$.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===$.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,I.$fc)(v.fsPath)}}e.$Np=C}),define(be[111],we([1,0,18,14,15,20,5,59,47,2,61,12,41,19,48,186,16,109,13,11]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=void 0;let y=class extends $.$Qc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new A.$Ld),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Ld),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Ld),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Ld),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Ld),this.onDidFilesChange=this.X.event,this.Y=this.B(new A.$Ld),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new O.$Zg)}registerProvider(t,s){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const o=new $.$Pc;return this.h.set(t,s),this.c.fire({added:!0,scheme:t,provider:s}),o.add(s.onDidChangeFile(i=>this.X.fire(new l.$mk(i,!this.S(s))))),typeof s.onDidWatchError=="function"&&o.add(s.onDidWatchError(i=>this.Y.fire(new Error(i)))),o.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:t}))),(0,$.$Oc)(()=>{this.c.fire({added:!1,scheme:t,provider:s}),this.h.delete(t),(0,$.$Lc)(o)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const s=[];this.f.fire({scheme:t,join(o){s.push(o)}}),!this.h.has(t)&&await O.Promises.settled(s)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,s){const o=this.h.get(t.scheme);return!!(o&&o.capabilities&s)}listCapabilities(){return w.Iterable.map(this.h,([t,s])=>({scheme:t,capabilities:s.capabilities}))}async j(t){if(!(0,d.$wg)(t))throw new l.$ok((0,m.localize)(0,null,this.qb(t)),8);await this.activateProvider(t.scheme);const s=this.h.get(t.scheme);if(!s){const o=new c.$_;throw o.message=(0,m.localize)(1,null,t.toString()),o}return s}async m(t){const s=await this.j(t);if((0,l.$_j)(s)||(0,l.$9j)(s)||(0,l.$ak)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const s=await this.j(t);if((0,l.$_j)(s)||(0,l.$9j)(s))return s;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,s){try{return await this.s(t,s)}catch(o){throw(0,l.$jk)(o)===l.FileSystemProviderErrorCode.FileNotFound?new l.$ok((0,m.localize)(2,null,this.qb(t)),1):(0,l.$hk)(o)}}async s(t,s){const o=await this.j(t),i=this.S(o),n=s?.resolveTo,a=s?.resolveSingleChildDescendants,b=s?.resolveMetadata,p=await o.stat(t);let E;return this.t(o,t,p,void 0,!!b,(k,L)=>(E||(E=C.$Rh.forUris(()=>!i),E.set(t,!0),n&&E.fill(!0,n)),E.get(k.resource)||E.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?L===1:!1))}async t(t,s,o,i,n,a){const{providerExtUri:b}=this.R(t),p={resource:s,name:b.basename(s),isFile:(o.type&l.FileType.File)!==0,isDirectory:(o.type&l.FileType.Directory)!==0,isSymbolicLink:(o.type&l.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:!!((o.permissions??0)&l.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((o.permissions??0)&l.FilePermission.Locked),etag:(0,l.$zk)({mtime:o.mtime,size:o.size}),children:void 0};if(p.isDirectory&&a(p,i)){try{const E=await t.readdir(s),k=await O.Promises.settled(E.map(async([L,j])=>{try{const Y=b.joinPath(s,L),ce=n?await t.stat(Y):{type:j};return await this.t(t,Y,ce,E.length,n,a)}catch(Y){return this.b.trace(Y),null}}));p.children=(0,D.$Fb)(k)}catch(E){this.b.trace(E),p.children=[]}return p}return p}async resolveAll(t){return O.Promises.settled(t.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(o){return this.b.trace(o),{stat:void 0,success:!1}}}))}async stat(t){const s=await this.j(t),o=await s.stat(t);return this.t(s,t,o,void 0,!0,()=>!1)}async exists(t){const s=await this.j(t);try{return!!await s.stat(t)}catch{return!1}}async canCreateFile(t,s){try{await this.u(t,s)}catch(o){return o}return!0}async u(t,s){if(!s?.overwrite&&await this.exists(t))throw new l.$ok((0,m.localize)(3,null,this.qb(t)),3,s)}async createFile(t,s=r.$_d.fromString(""),o){await this.u(t,o);const i=await this.writeFile(t,s);return this.r.fire(new l.$lk(t,0,i)),i}async writeFile(t,s,o){const i=this.ob(await this.n(t),t),{providerExtUri:n}=this.R(i);let a=o;if((0,l.$ck)(i)&&!a?.atomic){const b=i.enforceAtomicWriteFile?.(t);b&&(a={...o,atomic:b})}try{await this.w(i,t,a)||await this.U(i,n.dirname(t));let p;if((0,l.$9j)(i)&&!(s instanceof r.$_d))if((0,g.$Xd)(s)){const E=await(0,g.$5d)(s,3);E.ended?p=r.$_d.concat(E.buffer):p=E}else p=(0,g.$2d)(s,E=>r.$_d.concat(E),3);else p=s;!(0,l.$_j)(i)||(0,l.$9j)(i)&&p instanceof r.$_d||(0,l.$9j)(i)&&(0,l.$ck)(i)&&a?.atomic?await this.fb(i,t,a,p):await this.bb(i,t,a,p instanceof r.$_d?(0,r.$ke)(p):p),this.r.fire(new l.$lk(t,4))}catch(b){throw new l.$ok((0,m.localize)(4,null,this.qb(t),(0,l.$hk)(b).toString()),(0,l.$kk)(b),a)}return this.resolve(t,{resolveMetadata:!0})}async w(t,s,o){const i=!!o?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,m.localize)(5,null,this.qb(s)));if(!!o?.atomic){if(!(t.capabilities&32768))throw new Error((0,m.localize)(6,null,this.qb(s)));if(!(t.capabilities&2))throw new Error((0,m.localize)(7,null,this.qb(s)));if(i)throw new Error((0,m.localize)(8,null,this.qb(s)))}let a;try{a=await t.stat(s)}catch{return}if(a.type&l.FileType.Directory)throw new l.$ok((0,m.localize)(9,null,this.qb(s)),0,o);if(this.pb(s,a),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==l.$yk&&typeof a.mtime=="number"&&typeof a.size=="number"&&o.mtime<a.mtime&&o.etag!==(0,l.$zk)({mtime:o.mtime,size:a.size}))throw new l.$ok((0,m.localize)(10,null),3,o);return a}async readFile(t,s,o){const i=await this.m(t);return s?.atomic?this.z(i,t,s,o):this.C(i,t,s,o)}async z(t,s,o,i){return new Promise((n,a)=>{this.ab.queueFor(s,this.R(t).providerExtUri).queue(async()=>{try{const b=await this.C(t,s,o,i);n(b)}catch(b){a(b)}})})}async C(t,s,o,i){const n=await this.D(t,s,{...o,preferUnbuffered:!0},i);return{...n,value:await(0,r.$le)(n.value)}}async readFileStream(t,s,o){const i=await this.m(t);return this.D(i,t,s,o)}async D(t,s,o,i){const n=new P.$Vd(i);let a=o;(0,l.$bk)(t)&&t.enforceAtomicReadFile?.(s)&&(a={...o,atomic:!0});const b=this.J(s,a).then(E=>E,E=>{throw n.dispose(!0),E});let p;try{return typeof a?.etag=="string"&&a.etag!==l.$yk&&await b,a?.atomic&&(0,l.$bk)(t)||!((0,l.$_j)(t)||(0,l.$ak)(t))||(0,l.$9j)(t)&&a?.preferUnbuffered?p=this.I(t,s,a):(0,l.$ak)(t)?p=this.G(t,s,n.token,a):p=this.H(t,s,n.token,a),p.on("end",()=>n.dispose()),p.on("error",()=>n.dispose()),{...await b,value:p}}catch(E){throw p&&await(0,g.$3d)(p),this.F(E,s,a)}}F(t,s,o){const i=(0,m.localize)(11,null,this.qb(s),(0,l.$hk)(t).toString());return t instanceof l.$qk?new l.$qk(i,t.stat,o):t instanceof l.$pk?new l.$pk(i,t.fileOperationResult,t.size,t.options):new l.$ok(i,(0,l.$kk)(t),o)}G(t,s,o,i=Object.create(null)){const n=t.readFileStream(s,i,o);return(0,g.$9d)(n,{data:a=>a instanceof r.$_d?a:r.$_d.wrap(a),error:a=>this.F(a,s,i)},a=>r.$_d.concat(a))}H(t,s,o,i=Object.create(null)){const n=(0,r.$pe)();return(0,f.$Dp)(t,s,n,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,s,i)},o),n}I(t,s,o){const i=(0,g.$Zd)(n=>r.$_d.concat(n));return(async()=>{try{let n;o?.atomic&&(0,l.$bk)(t)?n=await t.readFile(s,{atomic:!0}):n=await t.readFile(s),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.L(s,n.byteLength,o),i.end(r.$_d.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,s){const o=await this.resolve(t,{resolveMetadata:!0});if(o.isDirectory)throw new l.$ok((0,m.localize)(12,null,this.qb(t)),0,s);if(typeof s?.etag=="string"&&s.etag!==l.$yk&&s.etag===o.etag)throw new l.$qk((0,m.localize)(13,null),o,s);return this.L(t,o.size,s),o}L(t,s,o){if(typeof o?.limits?.size=="number"&&s>o.limits.size)throw new l.$pk((0,m.localize)(14,null,this.qb(t)),7,s,o)}async canMove(t,s,o){return this.M(t,s,"move",o)}async canCopy(t,s,o){return this.M(t,s,"copy",o)}async M(t,s,o,i){if(t.toString()!==s.toString())try{const n=o==="move"?this.ob(await this.n(t),t):await this.m(t),a=this.ob(await this.n(s),s);await this.Q(n,t,a,s,o,i)}catch(n){return n}return!0}async move(t,s,o){const i=this.ob(await this.n(t),t),n=this.ob(await this.n(s),s),a=await this.N(i,t,n,s,"move",!!o),b=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new l.$lk(t,a==="move"?2:3,b)),b}async copy(t,s,o){const i=await this.m(t),n=this.ob(await this.n(s),s),a=await this.N(i,t,n,s,"copy",!!o),b=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new l.$lk(t,a==="copy"?3:2,b)),b}async N(t,s,o,i,n,a){if(s.toString()===i.toString())return n;const{exists:b,isSameResourceWithDifferentPathCase:p}=await this.Q(t,s,o,i,n,a);if(b&&!p&&a&&await this.del(i,{recursive:!0}),await this.U(o,this.R(o).providerExtUri.dirname(i)),n==="copy"){if(t===o&&(0,l.$0j)(t))await t.copy(s,i,{overwrite:a});else{const E=await this.resolve(s);E.isDirectory?await this.P(t,E,o,i):await this.O(t,s,o,i)}return n}else return t===o?(await t.rename(s,i,{overwrite:a}),n):(await this.N(t,s,o,i,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(t,s,o,i){if((0,l.$_j)(t)&&(0,l.$_j)(o))return this.hb(t,s,o,i);if((0,l.$_j)(t)&&(0,l.$9j)(o))return this.nb(t,s,o,i);if((0,l.$9j)(t)&&(0,l.$_j)(o))return this.lb(t,s,o,i);if((0,l.$9j)(t)&&(0,l.$9j)(o))return this.jb(t,s,o,i)}async P(t,s,o,i){await o.mkdir(i),Array.isArray(s.children)&&await O.Promises.settled(s.children.map(async n=>{const a=this.R(o).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),o,a):this.O(t,n.resource,o,a)}))}async Q(t,s,o,i,n,a){let b=!1;if(t===o){const{providerExtUri:E,isPathCaseSensitive:k}=this.R(t);if(k||(b=E.isEqual(s,i)),b&&n==="copy")throw new Error((0,m.localize)(15,null,this.qb(s),this.qb(i)));if(!b&&E.isEqualOrParent(i,s))throw new Error((0,m.localize)(16,null,this.qb(s),this.qb(i)))}const p=await this.exists(i);if(p&&!b){if(!a)throw new l.$ok((0,m.localize)(17,null,this.qb(s),this.qb(i)),4);if(t===o){const{providerExtUri:E}=this.R(t);if(E.isEqualOrParent(s,i))throw new Error((0,m.localize)(18,null,this.qb(s),this.qb(i)))}}return{exists:p,isSameResourceWithDifferentPathCase:b}}R(t){const s=this.S(t);return{providerExtUri:s?d.$ig:d.$kg,isPathCaseSensitive:s}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const s=this.ob(await this.j(t),t);await this.U(s,t);const o=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new l.$lk(t,0,o)),o}async U(t,s){const o=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(s,i.dirname(s));)try{if(!((await t.stat(s)).type&l.FileType.Directory))throw new Error((0,m.localize)(19,null,this.qb(s)));break}catch(n){if((0,l.$jk)(n)!==l.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(i.basename(s)),s=i.dirname(s)}for(let n=o.length-1;n>=0;n--){s=i.joinPath(s,o[n]);try{await t.mkdir(s)}catch(a){if((0,l.$jk)(a)!==l.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,s){try{await this.W(t,s)}catch(o){return o}return!0}async W(t,s){const o=this.ob(await this.j(t),t),i=!!s?.useTrash;if(i&&!(o.capabilities&4096))throw new Error((0,m.localize)(20,null,this.qb(t)));const n=s?.atomic;if(n&&!(o.capabilities&65536))throw new Error((0,m.localize)(21,null,this.qb(t)));if(i&&n)throw new Error((0,m.localize)(22,null,this.qb(t)));let a;try{a=await o.stat(t)}catch{}if(a)this.pb(t,a);else throw new l.$ok((0,m.localize)(23,null,this.qb(t)),1);if(!!!s?.recursive){const p=await this.resolve(t);if(p.isDirectory&&Array.isArray(p.children)&&p.children.length>0)throw new Error((0,m.localize)(24,null,this.qb(t)))}return o}async del(t,s){const o=await this.W(t,s);let i=s;if((0,l.$dk)(o)&&!i?.atomic){const p=o.enforceAtomicDelete?.(t);p&&(i={...s,atomic:p})}const n=!!i?.useTrash,a=!!i?.recursive,b=i?.atomic??!1;await o.delete(t,{recursive:a,useTrash:n,atomic:b}),this.r.fire(new l.$lk(t,1))}async cloneFile(t,s){const o=await this.j(t),i=this.ob(await this.n(s),s);if(o===i&&this.R(o).providerExtUri.isEqual(t,s))return;if(o===i&&(0,l.$$j)(o))return o.cloneFile(t,s);await this.U(i,this.R(i).providerExtUri.dirname(s));const n=this.ab.queueFor(t,this.R(o).providerExtUri);return o===i&&(0,l.$0j)(o)?n.queue(()=>o.copy(t,s,{overwrite:!0})):n.queue(()=>this.O(o,t,i,s))}watch(t,s={recursive:!1,excludes:[]}){const o=new $.$Pc;let i=!1,n=()=>{i=!0};return o.add((0,$.$Oc)(()=>n())),(async()=>{try{const a=await this.$(t,s);i?(0,$.$Lc)(a):n=()=>(0,$.$Lc)(a)}catch(a){this.b.error(a)}})(),o}async $(t,s){const o=await this.j(t),i=(0,I.$zi)([this.R(o).providerExtUri.getComparisonKey(t),s]);let n=this.Z.get(i);return n||(n={count:0,disposable:o.watch(t,s)},this.Z.set(i,n)),n.count+=1,(0,$.$Oc)(()=>{n&&(n.count--,n.count===0&&((0,$.$Lc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,$.$Lc)(t.disposable);this.Z.clear()}async bb(t,s,o,i){return this.ab.queueFor(s,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(s,{create:!0,unlock:o?.unlock??!1});try{(0,g.$Xd)(i)||(0,g.$Yd)(i)?await this.cb(t,n,i):await this.db(t,n,i)}catch(a){throw(0,l.$hk)(a)}finally{await t.close(n)}})}async cb(t,s,o){let i=0,n;if((0,g.$Yd)(o)){if(o.buffer.length>0){const a=r.$_d.concat(o.buffer);await this.eb(t,s,a,a.byteLength,i,0),i+=a.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((a,b)=>{(0,g.$4d)(n,{onData:async p=>{n.pause();try{await this.eb(t,s,p,p.byteLength,i,0)}catch(E){return b(E)}i+=p.byteLength,setTimeout(()=>n.resume())},onError:p=>b(p),onEnd:()=>a()})})}async db(t,s,o){let i=0,n;for(;(n=o.read())!==null;)await this.eb(t,s,n,n.byteLength,i,0),i+=n.byteLength}async eb(t,s,o,i,n,a){let b=0;for(;b<i;){const p=await t.write(s,n+b,o.buffer,a+b,i-b);b+=p}}async fb(t,s,o,i){return this.ab.queueFor(s,this.R(t).providerExtUri).queue(()=>this.gb(t,s,o,i))}async gb(t,s,o,i){let n;i instanceof r.$_d?n=i:(0,g.$Xd)(i)?n=await(0,r.$le)(i):(0,g.$Yd)(i)?n=await(0,r.$me)(i):n=(0,r.$je)(i),await t.writeFile(s,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1,atomic:o?.atomic??!1})}async hb(t,s,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.ib(t,s,o,i))}async ib(t,s,o,i){let n,a;try{n=await t.open(s,{create:!1}),a=await o.open(i,{create:!0,unlock:!1});const b=r.$_d.alloc(this.a);let p=0,E=0,k=0;do k=await t.read(n,p,b.buffer,E,b.byteLength-E),await this.eb(o,a,b,k,p,E),p+=k,E+=k,E===b.byteLength&&(E=0);while(k>0)}catch(b){throw(0,l.$hk)(b)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof a=="number"?o.close(a):Promise.resolve()])}}async jb(t,s,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.kb(t,s,o,i))}async kb(t,s,o,i){return o.writeFile(i,await t.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async lb(t,s,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.mb(t,s,o,i))}async mb(t,s,o,i){const n=await o.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(s);await this.eb(o,n,r.$_d.wrap(a),a.byteLength,0,0)}catch(a){throw(0,l.$hk)(a)}finally{await o.close(n)}}async nb(t,s,o,i){const n=await(0,r.$le)(this.H(t,s,P.CancellationToken.None));await this.fb(o,i,void 0,n)}ob(t,s){if(t.capabilities&2048)throw new l.$ok((0,m.localize)(25,null,this.qb(s)),6);return t}pb(t,s){if((s.permissions??0)&l.FilePermission.Readonly)throw new l.$ok((0,m.localize)(26,null,this.qb(t)),6)}qb(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};e.$Ep=y,e.$Ep=y=Oe([Ae(0,u.$6i)],y)}),define(be[68],we([1,0,27,297,14,26,15,5,39,2,7,3,19,48,21,189,16,109,224,38,222,221]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0,(()=>{try{(0,O.gracefulify)(D)}catch(s){console.error(`Error enabling graceful-fs: ${(0,c.$wi)(s)}`)}})();class t extends u.$Np{static{this.I=!1}constructor(o,i){super(o,i),this.onDidChangeCapabilities=I.Event.None,this.N=new P.$yc(n=>v.$jg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(o){try{const{stat:i,symbolicLink:n}=await g.SymlinkSupport.stat(this.H(o));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:l.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const i=await g.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let b;a.isSymbolicLink()?b=(await this.stat((0,v.$sg)(o,a.name))).type:b=this.M(a),n.push([a.name,b])}catch(b){this.a.trace(b)}})),n}catch(i){throw this.fb(i)}}M(o,i){let n;return i?.dangling?n=l.FileType.Unknown:o.isFile()?n=l.FileType.File:o.isDirectory()?n=l.FileType.Directory:n=l.FileType.Unknown,i&&(n|=l.FileType.SymbolicLink),n}async O(o){const i=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new r.$Pg;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,$.$Oc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(o,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const a=this.H(o);return await g.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,i,n){const a=(0,d.$Zd)(b=>A.$_d.concat(b.map(p=>A.$_d.wrap(p))).buffer);return(0,f.$Dp)(this,o,a,b=>b.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(o,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(o)?this.R(o,(0,v.$sg)((0,v.$rg)(o),`${(0,v.$pg)(o)}${n.atomic.postfix}`),i,n):this.S(o,i,n)}async Q(o){try{const i=this.H(o),{symbolicLink:n}=await g.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(o,i,n,a){const b=new $.$Pc;try{b.add(await this.O(o)),b.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,o,{overwrite:!0})}catch(p){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw p}}finally{b.dispose()}}async S(o,i,n,a){let b;try{const p=this.H(o);if(!n.create||!n.overwrite){if(await g.Promises.exists(p)){if(!n.overwrite)throw(0,l.$gk)((0,m.localize)(0,null),l.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,l.$gk)((0,m.localize)(1,null),l.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(o,{create:!0,unlock:n.unlock},a),await this.write(b,0,i,0,i.byteLength)}catch(p){throw await this.gb(o,p)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(o){t.Y=o}async open(o,i,n){const a=this.H(o);let b;(0,l.$8j)(i)&&!n&&(b=await this.O(o));let p;try{if((0,l.$8j)(i)&&i.unlock)try{const{stat:k}=await g.SymlinkSupport.stat(a);k.mode&128||await g.Promises.chmod(a,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let E;if((0,l.$8j)(i)){if(S.$i)try{await g.Promises.truncate(a,0),E="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}E||(E="w")}else E="r";p=await g.Promises.open(a,E)}catch(E){throw b?.dispose(),(0,l.$8j)(i)?await this.gb(o,E):this.fb(E)}if(this.U.set(p,0),(0,l.$8j)(i)&&this.X.set(p,o),b){const E=this.W.get(p);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${p} (${a})`),this.W.set(p,b),E&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${p} (${a})`),E.dispose())}return p}async close(o){const i=this.W.get(o);try{if(this.U.delete(o),this.X.delete(o)&&t.Y)try{await g.Promises.fdatasync(o)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await g.Promises.close(o)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(o)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.W.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),i.dispose())}}async read(o,i,n,a,b){const p=this.Z(o,i);let E=null;try{E=(await g.Promises.read(o,n,a,b,p)).bytesRead}catch(k){throw this.fb(k)}finally{this.$(o,p,E)}return E}Z(o,i){return i===this.U.get(o)?null:i}$(o,i,n){const a=this.U.get(o);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(o,a+n):this.U.delete(o)))}async write(o,i,n,a,b){return(0,r.$9g)(()=>this.ab(o,i,n,a,b),100,3)}async ab(o,i,n,a,b){const p=this.Z(o,i);let E=null;try{E=(await g.Promises.write(o,n,a,b,p)).bytesWritten}catch(k){throw await this.gb(this.X.get(o),k)}finally{this.$(o,p,E)}return E}async mkdir(o){try{await g.Promises.mkdir(this.H(o))}catch(i){throw this.fb(i)}}async delete(o,i){try{const n=this.H(o);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,C.$hc)((0,C.$kc)(n),`${(0,C.$lc)(n)}${i.atomic.postfix}`)),await g.Promises.rm(n,g.RimRafMode.MOVE,a)}else try{await g.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let b=!1;try{const{stat:p,symbolicLink:E}=await g.SymlinkSupport.stat(n);b=p.isDirectory()&&!E}catch{}if(b)await g.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(o,i,n){const a=this.H(o),b=this.H(i);if(a!==b)try{await this.bb(o,i,"move",n.overwrite),await g.Promises.rename(a,b)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,m.localize)(2,null,(0,C.$lc)(a),(0,C.$lc)((0,C.$kc)(b)),p.toString()))),this.fb(p)}}async copy(o,i,n){const a=this.H(o),b=this.H(i);if(a!==b)try{await this.bb(o,i,"copy",n.overwrite),await g.Promises.copy(a,b,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,m.localize)(3,null,(0,C.$lc)(a),(0,C.$lc)((0,C.$kc)(b)),p.toString()))),this.fb(p)}}async bb(o,i,n,a){const b=this.H(o),p=this.H(i);let E=!1;if(!!(this.capabilities&1024)||(E=(0,w.$Uf)(b,p,!0)),E){if(n==="copy")throw(0,l.$gk)((0,m.localize)(4,null),l.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const L=await this.L(o);if(!L)throw(0,l.$gk)((0,m.localize)(5,null),l.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!a)throw(0,l.$gk)((0,m.localize)(6,null),l.FileSystemProviderErrorCode.FileExists);L.type&l.FileType.File&&j.type&l.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,i){return this.cb(o,i,!1)}async cb(o,i,n){const a=this.H(o),b=this.H(i),p=!!(this.capabilities&1024);if((0,w.$Uf)(a,b,!p))return;const E=new $.$Pc;try{E.add(await this.O(o)),E.add(await this.O(i)),n&&await g.Promises.mkdir((0,C.$kc)(b),{recursive:!0}),await g.Promises.copyFile(a,b)}catch(k){if(k.code==="ENOENT"&&!n)return this.cb(o,i,!0);throw this.fb(k)}finally{E.dispose()}}t(o,i,n){return new y.$Up(a=>o(a),a=>i(a),n)}F(o,i,n){return new h.$3p(a=>o(a),a=>i(a),n)}fb(o){if(o instanceof l.$fk)return o;let i=o,n;switch(o.code){case"ENOENT":n=l.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=l.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=l.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=l.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=l.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=l.FileSystemProviderErrorCode.Unknown;break;default:n=l.FileSystemProviderErrorCode.Unknown}return(0,l.$gk)(i,n)}async gb(o,i){let n=this.fb(i);if(o&&n.code===l.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await g.SymlinkSupport.stat(this.H(o));a.mode&128||(n=(0,l.$gk)(i,l.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$4p=t}),define(be[225],we([1,0,5,68,2,15,48,20]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=void 0;class w extends r.$Qc{constructor(S,v){super(),this.a=S,this.b=v,this.F=new Map,this.G=new Map}call(S,v,d){const g=this.c(S);switch(v){case"stat":return this.g(g,d[0]);case"readdir":return this.h(g,d[0]);case"open":return this.r(g,d[0],d[1]);case"close":return this.s(d[0]);case"read":return this.t(d[0],d[1],d[2]);case"readFile":return this.j(g,d[0],d[1]);case"write":return this.u(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.n(g,d[0],d[1],d[2]);case"rename":return this.z(g,d[0],d[1],d[2]);case"copy":return this.C(g,d[0],d[1],d[2]);case"cloneFile":return this.D(g,d[0],d[1]);case"mkdir":return this.w(g,d[0]);case"delete":return this.y(g,d[0],d[1]);case"watch":return this.I(g,d[0],d[1],d[2],d[3]);case"unwatch":return this.J(d[0],d[1])}throw new Error(`IPC Command ${v} not found`)}listen(S,v,d){const g=this.c(S);switch(v){case"fileChange":return this.H(g,d[0]);case"readFileStream":return this.m(g,d[0],d[1])}throw new Error(`Unknown event ${v}`)}g(S,v){const d=this.f(S,v,!0);return this.a.stat(d)}h(S,v){const d=this.f(S,v);return this.a.readdir(d)}async j(S,v,d){const g=this.f(S,v,!0),m=await this.a.readFile(g,d);return P.$_d.wrap(m)}m(S,v,d){const g=this.f(S,v,!0),m=new I.$Vd,l=new D.$Ld({onDidRemoveLastListener:()=>{m.cancel()}}),f=this.a.readFileStream(g,d,m.token);return(0,A.$4d)(f,{onData:u=>l.fire(P.$_d.wrap(u)),onError:u=>l.fire(u),onEnd:()=>{l.fire("end"),l.dispose(),m.dispose()}}),l.event}n(S,v,d,g){const m=this.f(S,v);return this.a.writeFile(m,d.buffer,g)}r(S,v,d){const g=this.f(S,v,!0);return this.a.open(g,d)}s(S){return this.a.close(S)}async t(S,v,d){const g=P.$_d.alloc(d),m=0,l=await this.a.read(S,v,g.buffer,m,d);return[g,l]}u(S,v,d,g,m){return this.a.write(S,v,d.buffer,g,m)}w(S,v){const d=this.f(S,v);return this.a.mkdir(d)}y(S,v,d){const g=this.f(S,v);return this.a.delete(g,d)}z(S,v,d,g){const m=this.f(S,v),l=this.f(S,d);return this.a.rename(m,l,g)}C(S,v,d,g){const m=this.f(S,v),l=this.f(S,d);return this.a.copy(m,l,g)}D(S,v,d){const g=this.f(S,v),m=this.f(S,d);return this.a.cloneFile(g,m)}H(S,v){const d=new D.$Ld({onWillAddFirstListener:()=>{this.F.set(v,this.L(S,d))},onDidRemoveLastListener:()=>{(0,r.$Lc)(this.F.get(v)),this.F.delete(v)}});return d.event}async I(S,v,d,g,m){const l=this.F.get(v);if(l){const f=this.f(S,g),u=l.watch(d,f,m);this.G.set(v+d,u)}}async J(S,v){const d=S+v,g=this.G.get(d);g&&((0,r.$Lc)(g),this.G.delete(d))}dispose(){super.dispose();for(const[,S]of this.G)S.dispose();this.G.clear();for(const[,S]of this.F)S.dispose();this.F.clear()}}e.$zr=w;class $ extends r.$Qc{constructor(S,v,d,g){super(),this.c=S,this.f=d,this.g=g,this.a=new Map,this.b=this.B(new O.$4p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(S){const v=this.B(new D.$Ld);this.B(v.event(d=>{S.fire(d.map(g=>({resource:this.c.transformOutgoingURI(g.resource),type:g.type})))})),this.B(this.b.onDidChangeFile(d=>v.fire(d))),this.B(this.b.onDidWatchError(d=>S.fire(d)))}j(S){}m(S){}watch(S,v,d){const g=this.m(this.g);return Array.isArray(g)&&(d.excludes=[...d.excludes,...g]),this.a.set(S,this.b.watch(v,d)),(0,r.$Oc)(()=>{(0,r.$Lc)(this.a.get(S)),this.a.delete(S)})}dispose(){for(const[,S]of this.a)S.dispose();this.a.clear(),super.dispose()}}e.$Ar=$}),define(be[112],we([1,0,4,5,13,2]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=e.$3q=e.$2q=void 0;class A extends r.$ej{constructor(S,v,d,g,m){super(v,d,g),this.r=S,this.t=m,this.B(m.listen("onDidChangeLogLevel",S)(l=>{(0,r.$8i)(l)?super.setLogLevel(l):super.setLogLevel(D.URI.revive(l[0]),l[1])})),this.B(m.listen("onDidChangeVisibility",S)(([l,f])=>super.setVisibility(D.URI.revive(l),f))),this.B(m.listen("onDidChangeLoggers",S)(({added:l,removed:f})=>{for(const u of l)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of f)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new r.$cj({log:(S,v)=>{this.t.call("consoleLog",[S,v])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,v){super.setLogLevel(S,v),this.t.call("setLogLevel",[S,v])}setVisibility(S,v){super.setVisibility(S,v),this.t.call("setVisibility",[this.n(S),v])}s(S,v,d){return new I(this.t,S,v,d,this.r)}static setLogLevel(S,v,d){return S.call("setLogLevel",[v,d])}}e.$2q=A;class I extends r.$_i{constructor(S,v,d,g,m){super(g?.logLevel==="always"),this.r=S,this.s=v,this.m=!1,this.n=[],this.setLevel(d),this.r.call("createLogger",[v,g,m]).then(()=>{this.u(this.n),this.m=!0})}g(S,v){const d=[[S,v]];this.m?this.u(d):this.n.push(...d)}u(S){this.r.call("log",[this.s,S])}}class w{constructor(S,v){this.a=S,this.b=v}listen(S,v){const d=this.b(S);switch(v){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,g=>({added:[...g.added].map(m=>this.c(m,d)),removed:[...g.removed].map(m=>this.c(m,d))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,g=>[d.transformOutgoingURI(g[0]),g[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,g=>(0,r.$8i)(g)?g:[d.transformOutgoingURI(g[0]),g[1]])}throw new Error(`Event not found: ${v}`)}async call(S,v,d){const g=this.b(S);switch(v){case"setLogLevel":return(0,r.$8i)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(D.URI.revive(g.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,g)))}throw new Error(`Call not found: ${v}`)}c(S,v){return{...S,resource:v.transformOutgoingURI(S.resource)}}}e.$3q=w;class $ extends P.$Qc{constructor(S,v){super(),v.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(d=>v.call("setLogLevel",[d]))),v.call("getRegisteredLoggers").then(d=>{for(const g of d)S.registerLogger({...g,resource:D.URI.revive(g.resource)})}),this.B(v.listen("onDidChangeVisibility")(([d,g])=>S.setVisibility(D.URI.revive(d),g))),this.B(v.listen("onDidChangeLoggers")(({added:d,removed:g})=>{for(const m of d)S.registerLogger({...m,resource:D.URI.revive(m.resource)});for(const m of g)S.deregisterLogger(m.resource)}))}}e.$4q=$}),define(be[113],we([1,0,2,13]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tN=void 0;class r extends D.$Qc{constructor(A,I=[]){super(),this.a=new O.$dj([A,...I]),this.B(A.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...I){this.a.trace(A,...I)}debug(A,...I){this.a.debug(A,...I)}info(A,...I){this.a.info(A,...I)}warn(A,...I){this.a.warn(A,...I)}error(A,...I){this.a.error(A,...I)}flush(){this.a.flush()}}e.$tN=r}),define(be[226],we([1,0,16,13]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iN=void 0;var r;(function($){$[$.Trace=0]="Trace",$[$.Debug=1]="Debug",$[$.Info=2]="Info",$[$.Warning=3]="Warning",$[$.Error=4]="Error",$[$.Critical=5]="Critical",$[$.Off=6]="Off"})(r||(r={}));async function P($,C,S,v,d){try{const g=await new Promise((l,f)=>{le(["@vscode/spdlog"],l,f)});g.setFlushOn(r.Trace);const m=await g.createAsyncRotatingLogger($,C,S,v);return d?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(g){console.error(g)}return null}function A($,C,S){switch(C){case O.LogLevel.Trace:$.trace(S);break;case O.LogLevel.Debug:$.debug(S);break;case O.LogLevel.Info:$.info(S);break;case O.LogLevel.Warning:$.warn(S);break;case O.LogLevel.Error:$.error(S);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function I($,C){switch(C){case O.LogLevel.Trace:$.setLevel(r.Trace);break;case O.LogLevel.Debug:$.setLevel(r.Debug);break;case O.LogLevel.Info:$.setLevel(r.Info);break;case O.LogLevel.Warning:$.setLevel(r.Warning);break;case O.LogLevel.Error:$.setLevel(r.Error);break;case O.LogLevel.Off:$.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${C}`)}}class w extends O.$_i{constructor(C,S,v,d,g){super(),this.m=[],this.setLevel(g),this.n=this.s(C,S,v,d),this.B(this.onDidChangeLogLevel(m=>{this.r&&I(this.r,m)}))}async s(C,S,v,d){const g=v?6:1,m=30/g*D.$Bk.MB,l=await P(C,S,m,g,d);if(l){this.r=l,I(this.r,this.getLevel());for(const{level:f,message:u}of this.m)A(this.r,f,u);this.m=[]}}g(C,S){this.r?A(this.r,C,S):this.getLevel()<=C&&this.m.push({level:C,message:S})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$iN=w}),define(be[114],we([1,0,23,13,226]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=void 0;class P extends O.$ej{s(I,w,$){return new r.$iN((0,D.$bg)(),I.fsPath,!$?.donotRotate,!!$?.donotUseFormatters,w)}}e.$jN=P}),define(be[227],we([1,0,60,191,6]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var A;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(w){function $(g,m){return m-g}w.compare=$;const C=Object.create(null);C[w.Error]=(0,O.localize)(0,null),C[w.Warning]=(0,O.localize)(1,null),C[w.Info]=(0,O.localize)(2,null);function S(g){return C[g]||""}w.toString=S;function v(g){switch(g){case D.default.Error:return w.Error;case D.default.Warning:return w.Warning;case D.default.Info:return w.Info;case D.default.Ignore:return w.Hint}}w.fromSeverity=v;function d(g){switch(g){case w.Error:return D.default.Error;case w.Warning:return D.default.Warning;case w.Info:return D.default.Info;case w.Hint:return D.default.Ignore}}w.toSeverity=d}(A||(e.MarkerSeverity=A={}));var I;(function(w){const $="";function C(v){return S(v,!0)}w.makeKey=C;function S(v,d){const g=[$];return v.source?g.push(v.source.replace("\xA6","\\\xA6")):g.push($),v.code?typeof v.code=="string"?g.push(v.code.replace("\xA6","\\\xA6")):g.push(v.code.value.replace("\xA6","\\\xA6")):g.push($),v.severity!==void 0&&v.severity!==null?g.push(A.toString(v.severity)):g.push($),v.message&&d?g.push(v.message.replace("\xA6","\\\xA6")):g.push($),v.startLineNumber!==void 0&&v.startLineNumber!==null?g.push(v.startLineNumber.toString()):g.push($),v.startColumn!==void 0&&v.startColumn!==null?g.push(v.startColumn.toString()):g.push($),v.endLineNumber!==void 0&&v.endLineNumber!==null?g.push(v.endLineNumber.toString()):g.push($),v.endColumn!==void 0&&v.endColumn!==null?g.push(v.endColumn.toString()):g.push($),g.push($),g.join("\xA6")}w.makeKeyOptionalMessage=S})(I||(e.IMarkerData=I={})),e.$4s=(0,r.$Lh)("markerService")}),define(be[69],we([1,0,5,47,2,6]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$an=e.$_m=e.$$m=void 0,e.$$m=(0,P.$Lh)("policy");class A extends r.$Qc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Ld),this.onDidChange=this.h.event}async updatePolicyDefinitions($){const C=Object.keys(this.f).length;return this.f={...$,...this.f},C!==Object.keys(this.f).length&&await this.j($),O.Iterable.reduce(this.g.entries(),(S,[v,d])=>({...S,[v]:d}),{})}getPolicyValue($){return this.g.get($)}serialize(){return O.Iterable.reduce(Object.entries(this.f),($,[C,S])=>({...$,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$_m=A;class I{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$an=I}),define(be[54],we([1,0,3,29]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof D.$g.vscode<"u"&&typeof D.$g.vscode.context<"u"){const P=D.$g.vscode.context.configuration();if(P)r=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:P.version})}}else r={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"ms-vscode.vscode-typescript-tslint-plugin":{onFileOpen:[{pathGlob:"{**/tslint.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"felipecaputo.git-project-manager":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"GoogleCloudTools.cloudcode":{onFileOpen:[{pathGlob:"{**/skaffold.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"Pivotal.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testMessageContextValue"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","saveEditor"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging","languageConfigurationAutoClosingPairs"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","contribShareMenu","fileComments","contribCommentPeekContext","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","readonlyMessage","treeViewMarkdownMessage","shareProvider","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["handleIssueUri","interactive","interactiveUserActions","terminalContextMenu","terminalDataWriteEvent","terminalSelection","terminalQuickFixProvider","chatSlashCommands","chatVariables","chatAgents","readonlyMessage","chatProvider","mappedEditsProvider","aiRelatedInformation"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare","github.copilot","github.copilot-chat","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.83.1",sha256:"1452fdbab8d0d83ca5765bb66170d50b005c97ca4dcd13e154c3401d842a92d4",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",sha256:"b9dab017506d9e6a469a0f82b392e4cb1d7a25a4843f1db8ba396cbee209cfc5",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.19",sha256:"926095d290dc7cdb9daf40ef5ae7591db12171ba1af1f61afcb5a368d0fc66aa",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],walkthroughMetadata:[{id:"Setup",steps:[{id:"copilotInstall",title:"Supercharge your coding with AI-based suggestions",description:`Throw that rubber duck away! Code more efficiently with AI at your fingertips. Try [GitHub Copilot](command:extension.open?"github.copilot") free for 60 days.
[Install Copilot](command:workbench.extensions.installExtension?%22github.copilot%22)`,media:{type:"image",altText:"Copilot Statistics",path:"copilotStep.png"}}]}],featuredExtensions:[{id:"github.copilot",title:"GitHub Copilot",description:"Supercharge your coding experience for as little as $10/month with cutting edge AI code generation."}],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},version:"1.83.1",commit:"f1b07bd25dfad64b0167beb15359ae573aecd2cc",date:"2023-10-10T23:16:05.212Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(be[31],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=void 0,e.$lj=(0,D.$Lh)("productService"),e.$mj="vscode://schemas/vscode-product"}),define(be[35],we([1,0,94,10]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;class r{constructor(){this.a=new Map}add(A,I){D.ok(O.$wf(A)),D.ok(O.$yf(I)),D.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,I)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$9m=new r}),define(be[228],we([1,0,5,35]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=void 0,e.$0m={JSONContribution:"base.contributions.json"};function r(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class P{constructor(){this.b=new D.$Ld,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,$){this.a[r(w)]=$,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const A=new P;O.$9m.add(e.$0m.JSONContribution,A)}),define(be[55],we([1,0,18,5,10,173,24,228,35]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.ConfigurationScope=e.$bn=e.EditPresentationTypes=void 0;var $;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$bn={Configuration:"base.contributions.configuration"};var C;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn={properties:{},patternProperties:{}},e.$in="vscode://schemas/settings/resourceLanguage",e.$jn="vscode://schemas/settings/configurationDefaults";const S=w.$9m.as(I.$0m.JSONContribution);class v{constructor(){this.h=new Set,this.i=new O.$Ld,this.onDidSchemaChange=this.i.event,this.j=new O.$Ld,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$in,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const o=new Set;this.n(t,s,o),S.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const s=new Set;this.o(t,s),S.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const o=new Set;this.o(s,o),this.n(t,!1,o),S.registerSchema(e.$in,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const o=[];for(const{overrides:i,source:n}of t)for(const a in i)if(s.add(a),e.$ln.test(a)){const b=this.a.get(a),p=b?.valuesSources??new Map;if(n)for(const j of Object.keys(i[a]))p.set(j,n);const E={...b?.value||{},...i[a]};this.a.set(a,{source:n,value:E,valuesSources:p});const k=(0,A.$pi)(a),L={type:"object",default:E,description:P.localize(1,null,k),$ref:e.$in,defaultDefaultValue:E,source:r.$wf(n)?void 0:n,defaultValueSource:n};o.push(...m(a)),this.d[a]=L,this.b.properties[a]=L}else{this.a.set(a,{value:i[a],source:n});const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}this.m(o)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:o,source:i}of t)for(const n in o){const a=this.a.get(n),b=r.$wf(i)?i:i?.id,p=r.$wf(a?.source)?a?.source:a?.source?.id;if(b===p)if(s.add(n),this.a.delete(n),e.$ln.test(n))delete this.d[n],delete this.b.properties[n];else{const E=this.d[n];E&&(this.w(n,E),this.r(n,E))}}this.u()}deltaConfiguration(t){let s=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,o){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,o),this.c.push(i),this.q(i)})}o(t,s){const o=i=>{if(i.properties)for(const n in i.properties){s.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>o(n))};for(const i of t){o(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,o,i,n=3,a){n=r.$Ff(t.scope)?n:t.scope;const b=t.properties;if(b)for(const E in b){const k=b[E];if(s&&c(E,k)){delete b[E];continue}if(k.source=o,k.defaultDefaultValue=b[E].default,this.w(E,k),e.$ln.test(E)?k.scope=void 0:(k.scope=r.$Ff(k.scope)?n:k.scope,k.restricted=r.$Ff(k.restricted)?!!i?.includes(E):k.restricted),b[E].hasOwnProperty("included")&&!b[E].included){this.f[E]=b[E],delete b[E];continue}else this.d[E]=b[E],b[E].policy?.name&&this.e.set(b[E].policy.name,E);!b[E].deprecationMessage&&b[E].markdownDeprecationMessage&&(b[E].deprecationMessage=b[E].markdownDeprecationMessage),a.add(E)}const p=t.allOf;if(p)for(const E of p)this.p(E,s,o,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=o=>{const i=o.properties;if(i)for(const a in i)this.r(a,i[a]);o.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$cn.properties[t]=s,s.scope){case 1:e.$dn.properties[t]=s;break;case 2:e.$en.properties[t]=s;break;case 6:e.$fn.properties[t]=s;break;case 3:e.$gn.properties[t]=s;break;case 4:e.$hn.properties[t]=s;break;case 5:e.$hn.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$cn.properties[t],s.scope){case 1:delete e.$dn.properties[t];break;case 2:delete e.$en.properties[t];break;case 6:delete e.$fn.properties[t];break;case 3:delete e.$gn.properties[t];break;case 4:case 5:delete e.$hn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,o={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$in};this.w(s,o),e.$cn.properties[s]=o,e.$dn.properties[s]=o,e.$en.properties[s]=o,e.$fn.properties[s]=o,e.$gn.properties[s]=o,e.$hn.properties[s]=o}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$in};e.$cn.patternProperties[e.$kn]=t,e.$dn.patternProperties[e.$kn]=t,e.$en.patternProperties[e.$kn]=t,e.$fn.patternProperties[e.$kn]=t,e.$gn.patternProperties[e.$kn]=t,e.$hn.patternProperties[e.$kn]=t,this.i.fire()}w(t,s){const o=this.a.get(t);let i=o?.value,n=o?.source;r.$Df(i)&&(i=s.defaultDefaultValue,n=void 0),r.$Df(i)&&(i=f(s.type)),s.default=i,s.defaultValueSource=n}}const d="\\[([^\\]]+)\\]",g=new RegExp(d,"g");e.$kn=`^(${d})+$`,e.$ln=new RegExp(e.$kn);function m(h){const t=[];if(e.$ln.test(h)){let s=g.exec(h);for(;s?.length;){const o=s[1].trim();o&&t.push(o),s=g.exec(h)}}return(0,D.$Kb)(t)}e.$mn=m;function l(h){return h.reduce((t,s)=>`${t}[${s}]`,"")}e.$nn=l;function f(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$on=f;const u=new v;w.$9m.add(e.$bn.Configuration,u);function c(h,t){return h.trim()?e.$ln.test(h)?P.localize(7,null,h):u.getConfigurationProperties()[h]!==void 0?P.localize(8,null,h):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,h,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$pn=c;function y(){const h=[],t=u.getConfigurationProperties();for(const s of Object.keys(t))h.push([s,t[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$qn=y}),define(be[115],we([1,0,18,5,75,2,26,22,10,4,24,55,35]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=void 0;function d(s){return Object.isFrozen(s)?s:I.$Xm(s)}class g{constructor(o={},i=[],n=[],a){this.b=o,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(i=>{if(i instanceof g)return i;const n=new m("");return n.parseRaw(i),n.configurationModel});this.f=o.reduce((i,n)=>n===i?n:i.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,C.$ni)(this.contents,o):this.contents}inspect(o,i){const n=this.rawConfiguration.getValue(o),a=i?this.rawConfiguration.getOverrideValue(o,i):void 0,b=i?this.rawConfiguration.override(i).getValue(o):n;return{value:n,override:a,merged:b}}getOverrideValue(o,i){const n=this.i(i);return n?o?(0,C.$ni)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const n of this.overrides)n.identifiers.includes(o)&&i.push(...n.keys);return D.$Kb(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return D.$Kb(o)}override(o){let i=this.a.get(o);return i||(i=this.g(o),this.a.set(o,i)),i}merge(...o){const i=I.$Wm(this.contents),n=I.$Wm(this.overrides),a=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const p of o)if(b.push(...p.raw?.length?p.raw:[p]),!p.isEmpty()){this.h(i,p.contents);for(const E of p.overrides){const[k]=n.filter(L=>D.$sb(L.identifiers,E.identifiers));k?(this.h(k.contents,E.contents),k.keys.push(...E.keys),k.keys=D.$Kb(k.keys)):n.push(I.$Wm(E))}for(const E of p.keys)a.indexOf(E)===-1&&a.push(E)}return new g(i,a,n,b.every(p=>p instanceof g)?void 0:b)}g(o){const i=this.i(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of D.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[a];const p=i[a];p&&(typeof b=="object"&&typeof p=="object"?(b=I.$Wm(b),this.h(b,p)):b=p),n[a]=b}return new g(n,this.keys,this.overrides)}h(o,i){for(const n of Object.keys(i)){if(n in o&&w.$yf(o[n])&&w.$yf(i[n])){this.h(o[n],i[n]);continue}o[n]=I.$Wm(i[n])}}i(o){let i=null,n=null;const a=b=>{b&&(n?this.h(n,b):n=I.$Wm(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===o?i=b.contents:b.identifiers.includes(o)&&a(b.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,i){this.j(o,i,!0)}setValue(o,i){this.j(o,i,!1)}removeValue(o){const i=this.keys.indexOf(o);i!==-1&&(this.keys.splice(i,1),(0,C.$mi)(this.contents,o),S.$ln.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>D.$sb(n.identifiers,(0,S.$mn)(o))),1))}j(o,i,n){(0,C.$li)(this.contents,o,i,a=>console.error(a)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),S.$ln.test(o)&&this.overrides.push({identifiers:(0,S.$mn)(o),keys:Object.keys(this.contents[o]),contents:(0,C.$ki)(this.contents[o],a=>console.error(a))})}}e.$rn=g;class m{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new g}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,i){if(!w.$Ff(o)){const n=this.g(o);this.parseRaw(n,i)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,i){this.a=o;const{contents:n,keys:a,overrides:b,restricted:p,hasExcludedProperties:E}=this.h(o,i);this.b=new g(n,a,b,E?[o]:void 0),this.c=p||[]}g(o){let i={},n=null,a=[];const b=[],p=[];function E(L){Array.isArray(a)?a.push(L):n!==null&&(a[n]=L)}const k={onObjectBegin:()=>{const L={};E(L),b.push(a),a=L,n=null},onObjectProperty:L=>{n=L},onObjectEnd:()=>{a=b.pop()},onArrayBegin:()=>{const L=[];E(L),b.push(a),a=L,n=null},onArrayEnd:()=>{a=b.pop()},onLiteralValue:E,onError:(L,j,Y)=>{p.push({error:L,offset:j,length:Y})}};if(o)try{r.$Tm(o,k),i=a[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}h(o,i){const n=v.$9m.as(S.$bn.Configuration).getConfigurationProperties(),a=this.i(o,n,!0,i);o=a.raw;const b=(0,C.$ki)(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`)),p=Object.keys(o),E=this.j(o,k=>console.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:b,keys:p,overrides:E,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,i,n,a){let b=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:b};const p={},E=[];for(const k in o)if(S.$ln.test(k)&&n){const L=this.i(o[k],i,!1,a);p[k]=L.raw,b=b||L.hasExcludedProperties,E.push(...L.restricted)}else{const L=i[k],j=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&E.push(k),!a.exclude?.includes(k)&&(a.include?.includes(k)||(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&!(a.skipRestricted&&L?.restricted))?p[k]=o[k]:b=!0}return{raw:p,restricted:E,hasExcludedProperties:b}}j(o,i){const n=[];for(const a of Object.keys(o))if(S.$ln.test(a)){const b={};for(const p in o[a])b[p]=o[a][p];n.push({identifiers:(0,S.$mn)(a),keys:Object.keys(b),contents:(0,C.$ki)(b,i)})}return n}}e.$sn=m;class l extends P.$Qc{constructor(o,i,n,a){super(),this.c=o,this.f=i,this.g=a,this.b=this.B(new O.$Ld),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&n.isEqual(b.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new g}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$tn=l;class f{constructor(o,i,n,a,b,p,E,k,L,j,Y,ce,x){this.a=o,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=b,this.f=p,this.g=E,this.h=k,this.i=L,this.j=j,this.k=Y,this.l=ce,this.m=x}get value(){return d(this.c)}n(o,i,n){const a=o.inspect(i,n);return{get value(){return d(a.value)},get override(){return d(a.override)},get merged(){return d(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(o,i,n,a,b=new g,p=new g,E=new A.$yc,k=new g,L=new A.$yc){this.c=o,this.d=i,this.f=n,this.g=a,this.h=b,this.i=p,this.j=E,this.l=k,this.m=L,this.a=null,this.b=new A.$yc,this.n=null}getValue(o,i,n){return this.q(o,i,n).getValue(o)}updateValue(o,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new g,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(o):a.setValue(o,i),n.resource||(this.a=null)}inspect(o,i,n){const a=this.q(o,i,n),b=this.u(i.resource,n),p=i.resource?this.m.get(i.resource)||this.l:this.l,E=new Set;for(const k of a.overrides)for(const L of k.identifiers)a.getOverrideValue(o,L)!==void 0&&E.add(L);return new f(o,i,a.getValue(o),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,b||void 0,p)}keys(o){const i=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,i){this.j.set(o,i),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const n=[];if(!i){const{added:a,updated:b,removed:p}=h(this.c,o);i=[...a,...b,...p]}for(const a of i)for(const b of(0,S.$mn)(a)){const p=this.c.getKeysForOverrideIdentifier(b),E=o.getKeysForOverrideIdentifier(b),k=[...E.filter(L=>p.indexOf(L)===-1),...p.filter(L=>E.indexOf(L)===-1),...p.filter(L=>!I.$1m(this.c.override(b).getValue(L),o.override(b).getValue(L)))];n.push([b,k])}return this.updateDefaultConfiguration(o),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:i,updated:n,removed:a}=h(this.d,o),b=[...i,...n,...a];return b.length&&this.updatePolicyConfiguration(o),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:i,updated:n,removed:a,overrides:b}=h(this.applicationConfiguration,o),p=[...i,...n,...a];return p.length&&this.updateApplicationConfiguration(o),{keys:p,overrides:b}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:n,removed:a,overrides:b}=h(this.localUserConfiguration,o),p=[...i,...n,...a];return p.length&&this.updateLocalUserConfiguration(o),{keys:p,overrides:b}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:n,removed:a,overrides:b}=h(this.remoteUserConfiguration,o),p=[...i,...n,...a];return p.length&&this.updateRemoteUserConfiguration(o),{keys:p,overrides:b}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:n,removed:a,overrides:b}=h(this.workspaceConfiguration,o),p=[...i,...n,...a];return p.length&&this.updateWorkspaceConfiguration(o),{keys:p,overrides:b}}compareAndUpdateFolderConfiguration(o,i){const n=this.p.get(o),{added:a,updated:b,removed:p,overrides:E}=h(n,i),k=[...a,...b,...p];return(k.length||!n)&&this.updateFolderConfiguration(o,i),{keys:k,overrides:E}}compareAndDeleteFolderConfiguration(o){const i=this.p.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:a,removed:b,overrides:p}=h(i,void 0);return{keys:[...n,...a,...b],overrides:p}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,i,n){let a=this.r(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}r({resource:o},i){let n=this.s();if(i&&o){const a=i.getFolder(o);a&&(n=this.t(a.uri)||n);const b=this.m.get(o);b&&(n=n.merge(b))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let i=this.b.get(o);if(!i){const n=this.s(),a=this.j.get(o);a?(i=n.merge(a),this.b.set(o,i)):i=n}return i}u(o,i){if(i&&o){const n=i.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,i)=>{const{contents:n,overrides:a,keys:b}=this.j.get(i);return o.push([i,{contents:n,overrides:a,keys:b}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(i=>o.add(i)),this.userConfiguration.keys.forEach(i=>o.add(i)),this.i.keys.forEach(i=>o.add(i)),this.j.forEach(i=>i.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const i=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a))),[...i.values()]}static parse(o){const i=this.x(o.defaults),n=this.x(o.policy),a=this.x(o.application),b=this.x(o.user),p=this.x(o.workspace),E=o.folders.reduce((k,L)=>(k.set($.URI.revive(L[0]),this.x(L[1])),k),new A.$yc);return new u(i,n,a,b,new g,p,E,new g,new A.$yc)}static x(o){return new g(o.contents,o.keys,o.overrides)}}e.$un=u;function c(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const o=new Set,i=new Map;for(const a of s)a.keys.forEach(b=>o.add(b)),a.overrides.forEach(([b,p])=>{const E=(0,A.$vc)(i,b,new Set);p.forEach(k=>E.add(k))});const n=[];return i.forEach((a,b)=>n.push([b,[...a.values()]])),{keys:[...o.values()],overrides:n}}e.$vn=c;class y{constructor(o,i,n,a){this.change=o,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const b of o.keys)this.affectedKeys.add(b);for(const[,b]of o.overrides)for(const p of b)this.affectedKeys.add(p);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(o,i){const n=this.a+o,a=this.d.indexOf(n);if(a<0)return!1;const b=a+n.length;if(b>=this.d.length)return!1;const p=this.d.charCodeAt(b);if(p!==this.b&&p!==this.c)return!1;if(i){const E=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.f?.workspace):void 0,k=this.g.getValue(o,i,this.h);return!I.$1m(E,k)}return!0}}e.$wn=y;function h(s,o){const{added:i,removed:n,updated:a}=t(o?.rawConfiguration,s?.rawConfiguration),b=[],p=s?.getAllOverrideIdentifiers()||[],E=o?.getAllOverrideIdentifiers()||[];if(o){const k=E.filter(L=>!p.includes(L));for(const L of k)b.push([L,o.getKeysForOverrideIdentifier(L)])}if(s){const k=p.filter(L=>!E.includes(L));for(const L of k)b.push([L,s.getKeysForOverrideIdentifier(L)])}if(o&&s){for(const k of p)if(E.includes(k)){const L=t({contents:s.getOverrideValue(void 0,k)||{},keys:s.getKeysForOverrideIdentifier(k)},{contents:o.getOverrideValue(void 0,k)||{},keys:o.getKeysForOverrideIdentifier(k)});b.push([k,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:n,updated:a,overrides:b}}function t(s,o){const i=s?o?s.keys.filter(b=>o.keys.indexOf(b)===-1):[...s.keys]:[],n=o?s?o.keys.filter(b=>s.keys.indexOf(b)===-1):[...o.keys]:[],a=[];if(s&&o){for(const b of o.keys)if(s.keys.indexOf(b)!==-1){const p=(0,C.$ni)(o.contents,b),E=(0,C.$ni)(s.contents,b);I.$1m(p,E)||a.push(b)}}return{added:i,removed:n,updated:a}}}),define(be[229],we([1,0,18,5,2,22,10,115,55,13,69,35]),function(le,e,D,O,r,P,A,I,w,$,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=e.$xn=void 0;class v extends r.$Qc{constructor(){super(...arguments),this.a=this.B(new O.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new I.$rn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$9m.as(w.$bn.Configuration).onDidUpdateConfiguration(({properties:l,defaultsOverrides:f})=>this.c(Array.from(l),f))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(l,f){this.h(l,S.$9m.as(w.$bn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:l})}f(){return{}}g(){this.b=new I.$rn;const l=S.$9m.as(w.$bn.Configuration).getConfigurationProperties();this.h(Object.keys(l),l)}h(l,f){const u=this.f();for(const c of l){const y=u[c],h=f[c];y!==void 0?this.b.addValue(c,y):h?this.b.addValue(c,h.default):this.b.removeValue(c)}}}e.$xn=v;class d{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new I.$rn}async initialize(){return this.configurationModel}}e.$yn=d;let g=class extends r.$Qc{get configurationModel(){return this.b}constructor(l,f,u){super(),this.c=l,this.f=f,this.g=u,this.a=this.B(new O.$Ld),this.onDidChangeConfiguration=this.a.event,this.b=new I.$rn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(l=>this.j(l))),this.B(this.c.onDidChangeConfiguration(async({properties:l})=>this.m(await this.h(l),!0))),this.b}async h(l){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",l);const f={},u=[],c=S.$9m.as(w.$bn.Configuration).getConfigurationProperties();for(const y of l){const h=c[y];if(!h){u.push(y);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}u.push(y),f[h.policy.name]={type:h.type}}}return(0,A.$Jf)(f)||await this.f.updatePolicyDefinitions(f),u}j(l){this.g.trace("PolicyConfiguration#onDidChangePolicies",l);const f=S.$9m.as(w.$bn.Configuration).getPolicyConfigurations(),u=(0,D.$Fb)(l.map(c=>f.get(c)));this.m(u,!0)}m(l,f){this.g.trace("PolicyConfiguration#update",l);const u=S.$9m.as(w.$bn.Configuration).getConfigurationProperties(),c=[],y=this.b.isEmpty();for(const h of l){const t=u[h]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(y?s!==void 0:!(0,P.$1m)(this.b.getValue(h),s))&&c.push([h,s])}else this.b.getValue(h)!==void 0&&c.push([h,void 0])}if(c.length){this.g.trace("PolicyConfiguration#changed",c);const h=this.b;this.b=new I.$rn;for(const t of h.keys)this.b.setValue(t,h.getValue(t));for(const[t,s]of c)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);f&&this.a.fire(this.b)}}};e.$zn=g,e.$zn=g=Oe([Ae(1,C.$$m),Ae(2,$.$6i)],g)}),define(be[116],we([1,0,14,5,2,19,24,115,229,69]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=void 0;class C extends r.$Qc{constructor(v,d,g,m){super(),this.j=v,this.h=this.B(new O.$Ld),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$xn),this.c=g instanceof $.$an?new w.$yn:this.B(new w.$zn(this.b,g,m)),this.f=this.B(new I.$tn(this.j,{},P.$jg,d)),this.a=new I.$un(this.b.configurationModel,this.c.configurationModel,new I.$rn,new I.$rn),this.g=this.B(new D.$3g(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:l,properties:f})=>this.n(l,f))),this.B(this.c.onDidChangeConfiguration(l=>this.r(l))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,d,g]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new I.$un(v,d,new I.$rn,g)}getConfigurationData(){return this.a.toData()}getValue(v,d){const g=typeof v=="string"?v:void 0,m=(0,A.$gi)(v)?v:(0,A.$gi)(d)?d:{};return this.a.getValue(g,m,void 0)}updateValue(v,d,g,m){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.m(v)}m(v){const d=this.a.toData(),g=this.a.compareAndUpdateLocalUserConfiguration(v);this.s(g,d,2)}n(v,d){const g=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(v,d);this.s(m,g,7)}r(v){const d=this.a.toData(),g=this.a.compareAndUpdatePolicyConfiguration(v);this.s(g,d,7)}s(v,d,g){const m=new I.$wn(v,{data:d},this.a);m.source=g,m.sourceConfig=this.t(g),this.h.fire(m)}t(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$An=C}),define(be[117],we([1,0,11,6]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ok=e.$Nk=e.RemoteAuthorityResolverErrorCode=e.$Mk=e.$Lk=e.RemoteConnectionType=e.$Kk=void 0,e.$Kk=(0,O.$Lh)("remoteAuthorityResolverService");var r;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class P{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Lk=P;class A{constructor(S,v){this.host=S,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Mk=A;var I;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class w extends D.$_{static isNotAvailable(S){return S instanceof w&&S._code===I.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof w&&S._code===I.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof w&&S._code===I.NoResolverFound}static isInvalidAuthority(S){return S instanceof w&&S._code===I.InvalidAuthority}static isHandled(S){return S instanceof w&&S.isHandled}constructor(S,v=I.Unknown,d){super(S),this._message=S,this._code=v,this._detail=d,this.isHandled=v===I.NotAvailable&&d===!0,Object.setPrototypeOf(this,w.prototype)}}e.$Nk=w;function $(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$Ok=$}),define(be[230],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wN=e.$vN=void 0,e.$vN=(0,D.$Lh)("IRemoteExtensionsScannerService"),e.$wN="remoteExtensionsScanner"}),define(be[56],we([1,0,12]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=void 0;function O($){return $.scheme===D.Schemas.vscodeRemote?$.authority:void 0}e.$Pk=O;function r($){if(!$)return;const C=$.indexOf("+");return C<0?$:$.substr(0,C)}e.$Qk=r;function P($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Rk=P;function A($){const{host:C,port:S}=w($);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:S}}e.$Sk=A;function I($,C){let{host:S,port:v}=w($);return typeof v>"u"&&(v=C),{host:S,port:v}}e.$Tk=I;function w($){const C=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=$.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const v=$.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:$,port:void 0}}}),define(be[40],we([1,0,17,6,56]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.TargetPlatform=e.ExtensionType=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=void 0,e.$Ql="extensions.user.cache",e.$Rl="extensions.builtin.cache",e.$Sl="undefined_publisher",e.$Tl=["ui","workspace","web"];function P(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$Ul=P,e.$Vl=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(A||(e.ExtensionType=A={}));var I;(function(m){m.WIN32_X64="win32-x64",m.WIN32_IA32="win32-ia32",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class w{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,f){if(typeof l>"u"||l===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof l=="string"||typeof f=="string"){const u=typeof l=="string"?l:l.value,c=typeof f=="string"?f:f.value;return D.$Ze(u,c)}return l._lower===f._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$Wl=w;class ${get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const f of l)this.add(f)}add(l){this.c.add(w.toKey(l))}delete(l){return this.c.delete(w.toKey(l))}has(l){return this.c.has(w.toKey(l))}}e.$Xl=$;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(w.toKey(l))}get(l){return this.c.get(w.toKey(l))}has(l){return this.c.has(w.toKey(l))}set(l,f){this.c.set(w.toKey(l),f)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Yl=C;function S(m){return v(m)}e.$Zl=S;function v(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$1l=v;function d(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$2l=d;function g(m,l){if(l){const f=`onResolveRemoteAuthority:${(0,r.$Qk)(l)}`;return!!m.activationEvents?.includes(f)}return!1}e.$3l=g,e.$4l=(0,O.$Lh)("IBuiltinExtensionsScannerService")}),define(be[231],we([1,0,2,40,16]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xp=void 0;class P extends D.$Qc{constructor(I,w,$,C,S){super(),this.a=I,this.b=w,this.c=$,this.f=S,this.B(C.onDidInstallExtensions(v=>this.g(v))),this.B(C.onDidUninstallExtension(v=>this.h(v)))}g(I){for(const w of I)w.local&&this.invalidate(w.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,I)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,O.$Ql))}catch(w){(0,r.$kk)(w)!==1&&this.f.error(w)}}}e.$xp=P}),define(be[44],we([1,0,15,11,2,192,55,6,13,35]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0,e.$Jo=(0,I.$Lh)("requestService");class C{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class S extends r.$Qc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,P.localize)(0,null),when:w.$kj.isEqualTo((0,w.$ij)(w.LogLevel.Trace)).serialize()})}async c(h,t,s){const o=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new C(t.headers??{}));try{const i=await s();return this.a.trace(`${o} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${o} - error`,t.type,(0,O.$8)(i)),i}}}e.$Ko=S;function v(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}e.$Lo=v;function d(y){return y.res.statusCode===204}e.$Mo=d;async function g(y){return d(y)?null:(await(0,D.$le)(y.stream)).toString()}e.$No=g;async function m(y){if(!v(y))throw new Error("Server returned "+y.res.statusCode);return g(y)}e.$Oo=m;async function l(y){if(!v(y))throw new Error("Server returned "+y.res.statusCode);if(d(y))return null;const t=(await(0,D.$le)(y.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}e.$Po=l;function f(y){c(y)}e.$Qo=f;let u;function c(y){const h=$.$9m.as(A.$bn.Configuration),t=u;u={id:"http",order:15,title:(0,P.localize)(1,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,P.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(6,null),(0,P.localize)(7,null),(0,P.localize)(8,null),(0,P.localize)(9,null)],default:"override",description:(0,P.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,P.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[u],remove:t?[t]:[]})}c(1)}),define(be[232],we([1,0,20,12,16,44]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;let A=class{constructor(w,$){this.a=w,this.b=$}async download(w,$,C=D.CancellationToken.None){if(w.scheme===O.Schemas.file||w.scheme===O.Schemas.vscodeRemote){await this.b.copy(w,$);return}const S={type:"GET",url:w.toString(!0)},v=await this.a.request(S,C);if(v.res.statusCode===200)await this.b.writeFile($,v.stream);else{const d=await(0,P.$Oo)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${d}`)}}};e.$IN=A,e.$IN=A=Oe([Ae(0,P.$Jo),Ae(1,r.$7j)],A)}),define(be[233],we([1,0,15,20]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;class r{constructor(I){this.a=I}listen(I,w){throw new Error("Invalid listen")}call(I,w,$,C=O.CancellationToken.None){switch(w){case"request":return this.a.request($[0],C).then(async({res:S,stream:v})=>{const d=await(0,D.$le)(v);return[{statusCode:S.statusCode,headers:S.headers},d]});case"resolveProxy":return this.a.resolveProxy($[0])}throw new Error("Invalid call")}}e.$Mq=r;class P{constructor(I){this.a=I}async request(I,w){const[$,C]=await this.a.call("request",[I],w);return{res:$,stream:(0,D.$ne)(C)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}}e.$Nq=P}),define(be[234],we([1,0,84,10]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;function r(A,I){return A.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:A.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function P(A,I,w={}){const $=(0,D.parse)(A),C=w.proxyUrl||r($,I);if(!C)return null;const S=(0,D.parse)(C);if(!/^https?:$/.test(S.protocol||""))return null;const v={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,O.$Cf)(w.strictSSL)?w.strictSSL:!0};return $.protocol==="http:"?new(await new Promise((d,g)=>{le(["http-proxy-agent"],d,g)}))(v):new(await new Promise((d,g)=>{le(["https-proxy-agent"],d,g)}))(v)}e.$Oq=P}),define(be[85],we([1,0,52,7,193,20,38,11,3,23,105,210,14,144]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nl=void 0;let g;async function m(f,u,c,y){return c["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$i?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.$Hl)(y)&&!c["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.$Hl)(y)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),g||(g=v.Promises.withAsyncBody(async(h,t)=>{const s=new P.$Vd;let o=1e4;const i=f.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(o=(0,d.$Il)(i,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),t(new Error((0,r.localize)(0,null)))},o);try{h(await l(u,s.token))}catch(a){!(0,I.$2)(a)&&!s.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,A.$wi)(a)))):h({})}finally{clearTimeout(n),s.dispose()}})),g)}e.$Nl=m;async function l(f,u){const c=process.env.ELECTRON_RUN_AS_NODE;f.trace("getUnixShellEnvironment#runAsNode",c);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;f.trace("getUnixShellEnvironment#noAttach",y);const h=(0,$.$bg)().replace(/-/g,"").substr(0,12),t=new RegExp(h+"({.*})"+h),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};f.trace("getUnixShellEnvironment#env",s);const o=await(0,C.$xl)(w.OS,s);return f.trace("getUnixShellEnvironment#shell",o),new Promise((i,n)=>{if(u.isCancellationRequested)return n(new I.$3);const a=(0,O.$lc)(o);let b,p;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(b=`& '${process.execPath}' ${E} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,p=["-Login","-Command"]):a==="nu"?(b=`^'${process.execPath}' ${E} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,p=["-i","-l","-c"]):(b=`'${process.execPath}' ${E} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,a==="tcsh"||a==="csh"?p=["-ic"]:p=["-i","-l","-c"]),f.trace("getUnixShellEnvironment#spawn",JSON.stringify(p),b);const k=(0,D.spawn)(o,[...p,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});u.onCancellationRequested(()=>(k.kill(),n(new I.$3))),k.on("error",Y=>{f.error("getUnixShellEnvironment#errorChildProcess",(0,A.$wi)(Y)),n(Y)});const L=[];k.stdout.on("data",Y=>L.push(Y));const j=[];k.stderr.on("data",Y=>j.push(Y)),k.on("close",(Y,ce)=>{const x=Buffer.concat(L).toString("utf8");f.trace("getUnixShellEnvironment#raw",x);const ne=Buffer.concat(j).toString("utf8");if(ne.trim()&&f.trace("getUnixShellEnvironment#stderr",ne),Y||ce)return n(new Error((0,r.localize)(2,null,Y,ce)));const ue=t.exec(x),_=ue?ue[1]:"{}";try{const he=JSON.parse(_);c?he.ELECTRON_RUN_AS_NODE=c:delete he.ELECTRON_RUN_AS_NODE,y?he.ELECTRON_NO_ATTACH_CONSOLE=y:delete he.ELECTRON_NO_ATTACH_CONSOLE,delete he.VSCODE_RESOLVING_ENVIRONMENT,delete he.XDG_RUNTIME_DIR,f.trace("getUnixShellEnvironment#result",he),i(he)}catch(he){f.error("getUnixShellEnvironment#errorCaught",(0,A.$wi)(he)),n(he)}})})}}),define(be[235],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0,e.$kN=(0,D.$Lh)("stateReadService"),e.$lN=(0,D.$Lh)("stateService")}),define(be[236],we([1,0,14,15,2,10,25,16,13]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.$nN=e.$mN=e.SaveStrategy=void 0;var $;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})($||(e.SaveStrategy=$={}));class C extends r.$Qc{constructor(g,m,l,f){super(),this.h=g,this.j=l,this.m=f,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=m===0?void 0:this.B(new D.$Og(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(g){g.fileOperationResult!==1&&this.j.error(g)}}getItem(g,m){const l=this.a[g];return(0,P.$Ff)(l)?m:l}setItem(g,m){this.setItems([{key:g,data:m}])}setItems(g){let m=!1;for(const{key:l,data:f}of g)this.a[l]!==f&&((0,P.$Ff)(f)?(0,P.$Df)(this.a[l])||(this.a[l]=void 0,m=!0):(this.a[l]=f,m=!0));m&&this.r()}removeItem(g){(0,P.$Df)(this.a[g])||(this.a[g]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const g=JSON.stringify(this.a,null,4);if(g!==this.b)try{await this.m.writeFile(this.h,O.$_d.fromString(g),{atomic:{postfix:".vsctmp"}}),this.b=g}catch(m){this.j.error(m)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$mN=C;let S=class extends r.$Qc{constructor(g,m,l,f){super(),this.a=this.B(new C(m.stateResource,g,l,f))}async init(){await this.a.init()}getItem(g,m){return this.a.getItem(g,m)}};e.$nN=S,e.$nN=S=Oe([Ae(1,A.$Sh),Ae(2,w.$6i),Ae(3,I.$7j)],S);class v extends S{setItem(g,m){this.a.setItem(g,m)}setItems(g){this.a.setItems(g)}removeItem(g){this.a.removeItem(g)}close(){return this.a.close()}}e.$oN=v}),define(be[118],we([1,0,3,29,23]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=e.$$n=void 0;function P(w){if(D.$t===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}function A(w,$,C,S,v,d,g,m){const l=Object.create(null);l["common.machineId"]=d,l.sessionID=(0,r.$bg)()+Date.now(),l.commitHash=S,l.version=v,l["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$t),l["common.nodePlatform"]=O.$bc,l["common.nodeArch"]=C,l["common.product"]=m||"desktop",g&&(l["common.msftInternal"]=g);let f=0;const u=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const c=P($);return c&&(l["common.platformDetail"]=c),l}e.$$n=A;function I(w){const $=O.env.USERDNSDOMAIN;if(!$)return!1;const C=$.toLowerCase();return w.some(S=>C===S)}e.$_n=I}),define(be[237],we([1,0,18,11,2,22,16]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var I;(function($){function C(S,v){return S.callstack<v.callstack?-1:S.callstack>v.callstack?1:0}$.compare=C})(I||(e.ErrorEvent=I={}));class w{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(C,S=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new r.$Pc,this.c=C,this.d=S;const v=O.$V.addListener(d=>this.j(d));this.h.add((0,r.$Oc)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(C){if(!C||C.code||(C.detail&&C.detail.stack&&(C=C.detail),O.$_.isErrorNoTelemetry(C)||C instanceof A.$ok||typeof C?.message=="string"&&C.message.includes("Unable to read file")))return;const S=Array.isArray(C.stack)?C.stack.join(`
`):C.stack,v=C.message?C.message:(0,P.$2m)(C);S&&this.k({msg:v,callstack:S})}k(C){const S=(0,D.$ub)(this.g,C,I.compare);S<0?(C.count=1,this.g.splice(~S,0,C)):(this.g[S].count||(this.g[S].count=0),this.g[S].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const C of this.g)this.c.publicLogError2("UnhandledError",C);this.g.length=0}}e.default=w}),define(be[238],we([1,0,2]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0;class O extends D.$Qc{constructor(P,A){super(),this.a=P,this.b=A}async call(P,A,I){switch(A){case"updateTelemetryLevel":{const{telemetryLevel:w}=I;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:$}=I;return this.b?this.b.log(w,$):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${A} not found`)}listen(P,A,I){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Fr=O}),define(be[32],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$gl=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=void 0,e.$0k=(0,D.$Lh)("telemetryService"),e.$$k=(0,D.$Lh)("customEndpointTelemetryService"),e.$_k="telemetry.currentSessionDate",e.$al="telemetry.firstSessionDate",e.$bl="telemetry.lastSessionDate",e.$cl="telemetry.machineId",e.$dl="telemetry",e.$el="telemetry.telemetryLevel",e.$fl="telemetry.enableCrashReporter",e.$gl="telemetry.enableTelemetry";var O;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var r;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(be[239],we([1,0,28,14,75,12,7,3,4,99,21,104,216,16,31,32]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xr=e.$wr=e.$vr=e.$ur=void 0;const l=new Map;async function f(t,s){const o=`${t}::${s.join(":")}`,i=l.get(o);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,b=new Map,p=2e4;function E(L,j,Y,ce){const x=j.substring(L.length+1);return O.Promises.withAsyncBody(async ne=>{let ue;try{ue=await C.Promises.readdir(j,{withFileTypes:!0})}catch{ne();return}if(ce.count>=p){ce.count+=ue.length,ce.maxReached=!0,ne();return}let _=ue.length;if(_===0){ne();return}let he=ue;ce.count+ue.length>p&&(ce.maxReached=!0,_=p-ce.count,he=ue.slice(0,_)),ce.count+=ue.length;for(const ee of he)if(ee.isDirectory()){if(Y.includes(ee.name)||await E(L,(0,A.$hc)(j,ee.name),Y,ce),--_===0){ne();return}}else{const te=ee.name.lastIndexOf(".");if(te>=0){const W=ee.name.substring(te+1);W&&a.set(W,(a.get(W)??0)+1)}for(const W of n)W.relativePathPattern?.test(x)!==!1&&W.filePattern.test(ee.name)&&b.set(W.tag,(b.get(W.tag)??0)+1);if(--_===0){ne();return}}})}const k=O.Promises.withAsyncBody(async L=>{const j={count:0,maxReached:!1};await E(t,t,s,j);const Y=await y(t);L({configFiles:u(b),fileTypes:u(a),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:Y})});return l.set(o,k),k}e.$ur=f;function u(t){return Array.from(t.entries(),([s,o])=>({name:s,count:o})).sort((s,o)=>o.count-s.count)}function c(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/d.$Bk.GB).toFixed(2)}GB (${(D.freemem()/d.$Bk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round($.$Im.value()*100)}%`},s=D.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}e.$vr=c;async function y(t){try{const s=new Map,o=(0,A.$hc)(t,".vscode","launch.json"),i=await C.Promises.readFile(o),n=[],a=(0,r.$Mm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,r.$Vm)(a)==="object"&&a.configurations)for(const b of a.configurations){const p=b.type;p&&(s.has(p)?s.set(p,s.get(p)+1):s.set(p,1))}return u(s)}catch{return[]}}e.$wr=y;let h=class{constructor(s,o){this.c=s,this.d=o}f(s){const o=[];return o.push(`OS Version:       ${s.os}`),o.push(`CPUs:             ${s.cpus}`),o.push(`Memory (System):  ${s.memory}`),o.push(`VM:               ${s.vmHint}`),o.join(`
`)}g(s){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&o.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),o.push(`Memory (System):  ${(D.totalmem()/d.$Bk.GB).toFixed(2)}GB (${(D.freemem()/d.$Bk.GB).toFixed(2)}GB free)`),I.$i||o.push(`Load (avg):       ${D.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round($.$Im.value()*100)}%`),o.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${s.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(s,o){return Promise.all([(0,S.$tr)(s.mainPID),this.k(s)]).then(async i=>{let[n,a]=i,b=this.m(s,n);return o.forEach(p=>{if((0,v.$im)(p))b+=`
${p.errorMessage}`,a+=`
${p.errorMessage}`;else if(b+=`

Remote: ${p.hostName}`,p.processes&&(b+=`
${this.m(s,p.processes)}`),p.workspaceMetadata){a+=`
|  Remote: ${p.hostName}`;for(const E of Object.keys(p.workspaceMetadata)){const k=p.workspaceMetadata[E];let L=`${k.fileCount} files`;k.maxFilesReached&&(L=`more than ${L}`),a+=`|    Folder (${E}): ${L}`,a+=this.h(k)}}}),{processInfo:b,workspaceInfo:a}})}async getSystemInfo(s,o){const{memory:i,vmHint:n,os:a,cpus:b}=c(),p={os:a,memory:i,cpus:b,vmHint:n,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:o};return I.$i||(p.load=`${D.loadavg().map(E=>Math.round(E)).join(", ")}`),I.$k&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(s,o){const i=[];return(0,S.$tr)(s.mainPID).then(async n=>(i.push(""),i.push(this.g(s)),i.push(""),i.push(this.m(s,n)),s.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(s))),o.forEach(a=>{if((0,v.$im)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(s,a.processes)),a.workspaceMetadata)for(const b of Object.keys(a.workspaceMetadata)){const p=a.workspaceMetadata[b];let E=`${p.fileCount} files`;p.maxFilesReached&&(E=`more than ${E}`),i.push(`Folder (${b}): ${E}`),i.push(this.h(p))}}),i.push(""),i.push(""),i.join(`
`)))}h(s){const o=[];let n=0;const a=(k,L)=>{const j=` ${k}(${L})`;n+j.length>60?(o.push(b),b="|                 ",n=b.length):n+=j.length,b+=j};let b="|      File types:";const p=10,E=s.fileTypes.length>p?p:s.fileTypes.length;for(let k=0;k<E;k++){const L=s.fileTypes[k];a(L.name,L.count)}if(o.push(b),s.configFiles.length>=0&&(b="|      Conf files:",n=0,s.configFiles.forEach(k=>{a(k.name,k.count)}),o.push(b)),s.launchConfigFiles.length>0){let k="|      Launch Configs:";s.launchConfigFiles.forEach(L=>{const j=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`;k+=j}),o.push(k)}return o.join(`
`)}j(s){const o=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(o-i.length)}  ${s[i]}`).join(`
                  `)}k(s){const o=[],i=[];return s.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const b=w.URI.revive(a);if(b.scheme===P.Schemas.file){const p=b.fsPath;i.push(f(p,["node_modules",".git"]).then(E=>{let k=`${E.fileCount} files`;E.maxFilesReached&&(k=`more than ${k}`),o.push(`|    Folder (${(0,A.$lc)(p)}): ${k}`),o.push(this.h(E))}).catch(E=>{o.push(`|      Error: Unable to collect workspace stats for folder ${p} (${E.toString()})`)}))}else o.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(s,o){const i=new Map;s.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),s.pidToNames.forEach(({pid:a,name:b})=>i.set(a,b));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(s.mainPID,i,n,o,0),n.join(`
`)}n(s,o,i,n,a){const b=a===0;let p;b?p=n.pid===s?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?p=o.get(n.pid):p=`${"  ".repeat(a)} ${n.name}`;const E=process.platform==="win32"?n.mem:D.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(E/d.$Bk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(n.children)&&n.children.forEach(k=>this.n(s,o,i,k,a+1))}async getWorkspaceFileExtensions(s){const o=new Set;for(const{uri:i}of s.folders){const n=w.URI.revive(i);if(n.scheme!==P.Schemas.file)continue;const a=n.fsPath;try{(await f(a,["node_modules",".git"])).fileTypes.forEach(p=>o.add(p.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(s){for(const{uri:o}of s.folders){const i=w.URI.revive(o);if(i.scheme!==P.Schemas.file)continue;const n=i.fsPath;try{const a=await f(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),a.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:b.name,count:b.count})}),a.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:b.name,count:b.count})}),a.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$xr=h,e.$xr=h=Oe([Ae(0,m.$0k),Ae(1,g.$lj)],h)}),define(be[36],we([1,0,22,10,5,24,56,118,32]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=void 0;class ${constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$ao=$;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$bo=C,e.$co=new C;class S{async publicLog(n,a,b){}async publicLogError(n,a,b){}}e.$do=S,e.$eo="telemetry",e.$fo="extensionTelemetryLog",e.$go={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,n){return r.Event.debounce(n.onDidChangeConfiguration,(b,p)=>{const E=b?new Set([...b.affectedKeys,...p.affectedKeys]):p.affectedKeys;return{...p,affectedKeys:E}},1e3,!0)(b=>{b.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,P.$ii)(b.source),configurationKeys:Array.from(b.affectedKeys)})})}e.$ho=v;function d(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$io=d;function g(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$jo=g;function m(i){const n=i.getValue(w.$el),a=i.getValue(w.$fl);if(i.getValue(w.$gl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$ko=m;function l(i){const n={},a={},b={};c(i,b);for(let p in b){p=p.length>150?p.substr(p.length-149):p;const E=b[p];typeof E=="number"?a[p]=E:typeof E=="boolean"?a[p]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${E.length}`),n[p]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[p]=E)}return{properties:n,measurements:a}}e.$lo=l;const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const n=(0,A.$Qk)(i);return f.has(n)?n:"other"}e.$mo=u;function c(i,n,a=0,b){if(i)for(const p of Object.getOwnPropertyNames(i)){const E=i[p],k=b?b+p:p;Array.isArray(E)?n[k]=(0,D.$2m)(E):E instanceof Date?n[k]=E.toISOString():(0,O.$yf)(E)?a<2?c(E,n,a+1,k+"."):n[k]=(0,D.$2m)(E):n[k]=E}}function y(i,n){const a=i.msftInternalDomains||[],b=n.getValue("telemetry.internalTesting");return(0,I.$_n)(a)||b}e.$no=y;function h(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$oo=h;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const b=[];for(const L of n)for(;;){const j=L.exec(i);if(!j)break;b.push([j.index,L.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let k=0;for(a="";;){const L=E.exec(i);if(!L)break;const j=b.some(([Y,ce])=>L.index<ce&&Y<E.lastIndex);!p.test(L[0])&&!j&&(a+=i.substring(k,L.index)+"<REDACTED: user-file-path>",k=E.lastIndex)}return k<i.length&&(a+=i.substr(k)),a}function s(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function o(i,n){return(0,D.$Ym)(i,a=>{if(a instanceof $||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let b=a.replaceAll("%20"," ");b=t(b,n);for(const p of n)b=b.replace(p,"");return b=s(b),b}})}e.$po=o}),define(be[37],we([1,0,17,30,40,3,4,11,29,36]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=void 0;function C(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,D.$Ue)(o.id,i.id)===0}e.$qo=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,n,a)}static parse(i){const n=S.exec(i);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$ro=v;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function g(o){const i=d.exec(o);return i&&i[1]?[l(i[1]),i[2]]:[l(o),void 0]}e.$so=g;function m(o,i){return`${o}.${i}`}e.$to=m;function l(o){return o.toLowerCase()}e.$uo=l;function f(o,i){return l(m(o??r.$Sl,i))}e.$vo=f;function u(o,i){const n=[],a=b=>{for(const p of n)if(p.some(E=>C(i(E),i(b))))return p;return null};for(const b of o){const p=a(b);p?p.push(b):n.push([b])}return n}e.$wo=u;function c(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$xo=c;function y(o){return{id:new $.$ao(o.identifier.id),name:new $.$ao(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$yo=y,e.$zo=new r.$Wl("pprice.better-merge");function h(o,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const b=a.shift();if(b&&n.every(p=>!C(p.identifier,{id:b}))){const p=o.filter(E=>C(E.identifier,{id:b}));p.length===1&&(n.push(p[0]),a.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Ao=h;async function t(o,i){if(!P.$k)return!1;let n;try{n=(await o.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,I.$8)(b))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(o,i){const n=await t(o,i),a=(0,O.$Vn)(n?"alpine":P.$t,w.$cc);return i.debug("ComputeTargetPlatform:",a),a}e.$Bo=s}),define(be[119],we([1,0,20,11,12,19,53,4,180,30,37,40]),function(le,e,D,O,r,P,A,I,w,$,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0o=void 0;const v=l=>(0,w.localize)(0,null,l),d=(0,w.localize)(1,null,"ms-dotnettools.csharp");function g(l,f){return f?`${l.publisher}.${l.name}@${l.version}`:`${l.publisher}.${l.name}`}let m=class{constructor(f,u,c){this.a=f,this.b=u,this.d=c}get f(){}async listExtensions(f,u,c){let y=await this.b.getInstalled(1,c);const h=S.$Vl.map(s=>s.toLowerCase());if(u&&u!==""){if(h.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}y=y.filter(s=>s.manifest.categories?s.manifest.categories.map(i=>i.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),h.forEach(s=>{this.a.info(s)});return}this.f&&this.a.info((0,w.localize)(2,null,this.f)),y=y.sort((s,o)=>s.identifier.id.localeCompare(o.identifier.id));let t;for(const s of y)t!==s.identifier.id&&(t=s.identifier.id,this.a.info(g(s.manifest,f)))}async installExtensions(f,u,c,y){const h=[];try{const t=[];f.length&&this.a.info(this.f?(0,w.localize)(3,null,this.f):(0,w.localize)(4,null));const s=[];let o=[];const i=(a,b,p)=>{o.push({id:a,version:b!=="prerelease"?b:void 0,installOptions:{...c,isBuiltin:p,installPreReleaseVersion:b==="prerelease"||c.installPreReleaseVersion}})};for(const a of f)if(a instanceof I.URI)s.push({vsix:a,installOptions:c});else{const[b,p]=(0,C.$so)(a);i(b,p,!1)}for(const a of u)if(a instanceof I.URI)s.push({vsix:a,installOptions:{...c,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[b,p]=(0,C.$so)(a);i(b,p,!0)}const n=await this.b.getInstalled(1,c.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:a,installOptions:b})=>{try{const p=await this.g(a,b,y,n);p&&t.push(p)}catch(p){this.a.error(p),h.push(a.toString())}})),o.length&&(o=o.filter(({id:a,version:b})=>{const p=n.find(E=>(0,C.$qo)(E.identifier,{id:a}));if(p){if(!y&&(!b||b==="prerelease"&&p.preRelease))return this.a.info((0,w.localize)(5,null,a,p.manifest.version,a)),!1;if(b&&p.manifest.version===b)return this.a.info((0,w.localize)(6,null,`${a}@${b}`)),!1}return!0}),o.length)){const a=await this.h(o);await Promise.all(o.map(async b=>{const p=a.get(b.id.toLowerCase());if(p)try{const E=await this.j(b,p,n);E&&t.push(E)}catch(E){this.a.error(E.message||E.stack||E),h.push(b.id)}else this.a.error(`${v(b.version?`${b.id}@${b.version}`:b.id)}
${d}`),h.push(b.id)}))}}catch(t){throw this.a.error((0,w.localize)(7,null,(0,O.$8)(t))),t}if(h.length)throw new Error((0,w.localize)(8,null,h.join(", ")))}async g(f,u,c,y){const h=await this.b.getManifest(f);if(!h)throw new Error("Invalid vsix");if(await this.l(h,c,u.profileLocation,y))try{return await this.b.install(f,u),this.a.info((0,w.localize)(9,null,(0,P.$pg)(f))),h}catch(s){if((0,O.$2)(s))return this.a.info((0,w.localize)(10,null,(0,P.$pg)(f))),null;throw s}return null}async h(f){const u=new Map,c=f.some(t=>t.installOptions.installPreReleaseVersion),y=await this.b.getTargetPlatform(),h=[];for(const t of f)$.$On.test(t.id)&&h.push({...t,preRelease:c});if(h.length){const t=await this.d.getExtensions(h,{targetPlatform:y},D.CancellationToken.None);for(const s of t)u.set(s.identifier.id.toLowerCase(),s)}return u}async j({id:f,version:u,installOptions:c},y,h){const t=await this.d.getManifest(y,D.CancellationToken.None);if(t&&!this.k(t))return null;const s=h.find(o=>(0,C.$qo)(o.identifier,y.identifier));if(s){if(y.version===s.manifest.version)return this.a.info((0,w.localize)(11,null,u?`${f}@${u}`:f)),null;this.a.info((0,w.localize)(12,null,f,y.version))}try{c.isBuiltin?this.a.info(u?(0,w.localize)(13,null,f,u):(0,w.localize)(14,null,f)):this.a.info(u?(0,w.localize)(15,null,f,u):(0,w.localize)(16,null,f));const o=await this.b.installFromGallery(y,{...c,installGivenVersion:!!u});return this.a.info((0,w.localize)(17,null,f,o.manifest.version)),t}catch(o){if((0,O.$2)(o))return this.a.info((0,w.localize)(18,null,f)),null;throw o}}k(f){return!0}async l(f,u,c,y){if(!u){const h={id:(0,C.$vo)(f.publisher,f.name)},t=y.find(s=>(0,C.$qo)(h,s.identifier)&&(0,A.gt)(s.manifest.version,f.version));if(t)return this.a.info((0,w.localize)(19,null,t.identifier.id,t.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,u,c){const y=async t=>{if(t instanceof I.URI){const s=await this.b.getManifest(t);return g(s)}return t},h=[];for(const t of f){const s=await y(t),i=(await this.b.getInstalled(void 0,c)).filter(n=>(0,C.$qo)(n.identifier,{id:s}));if(!i.length)throw new Error(`${this.m(s)}
${d}`);if(i.some(n=>n.type===0)){this.a.info((0,w.localize)(20,null,s));return}if(!u&&i.some(n=>n.isBuiltin)){this.a.info((0,w.localize)(21,null,s));return}this.a.info((0,w.localize)(22,null,s));for(const n of i)await this.b.uninstall(n,{profileLocation:c}),h.push(n);this.f?this.a.info((0,w.localize)(23,null,s,this.f)):this.a.info((0,w.localize)(24,null,s))}}async locateExtension(f){const u=await this.b.getInstalled();f.forEach(c=>{u.forEach(y=>{if(y.identifier.id===c&&y.location.scheme===r.Schemas.file){this.a.info(y.location.fsPath);return}})})}m(f){return this.f?(0,w.localize)(25,null,f,this.f):(0,w.localize)(26,null,f)}};e.$0o=m,e.$0o=m=Oe([Ae(1,$.$3n),Ae(2,$.$1n)],m)}),define(be[240],we([1,0,5,2,26,37,40]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=void 0;class I extends O.$Qc{constructor($,C,S,v,d,g,m){super(),this.f=$,this.g=C,this.h=S,this.j=v,this.m=d,this.n=g,this.r=m,this.a=this.B(new D.$Ld),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$Yc),this.s().then(null,l=>m.error(l))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles($=>this.u($.added))),this.B(this.j.onAddExtensions($=>this.w($))),this.B(this.j.onDidAddExtensions($=>this.y($))),this.B(this.j.onRemoveExtensions($=>this.z($))),this.B(this.j.onDidRemoveExtensions($=>this.C($))),this.B(this.n.onDidFilesChange($=>this.D($)))}async u($){try{$.length&&await Promise.all($.map(C=>(this.c.set(C.id,(0,O.$Nc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w($){for(const C of $.extensions)this.I(this.L(C.identifier,C.version),$.profileLocation)}async y($){for(const C of $.extensions){const S=this.L(C.identifier,C.version);$.error?this.J(S,$.profileLocation):this.I(S,$.profileLocation)}}async z($){for(const C of $.extensions)this.J(this.L(C.identifier,C.version),$.profileLocation)}async C($){const C=[],S=[];for(const v of $.extensions){const d=this.L(v.identifier,v.version);$.error?this.I(d,$.profileLocation):(this.J(d,$.profileLocation),this.b.has(d)||(this.r.debug("Extension is removed from all profiles",v.identifier.id,v.version),S.push(this.f.scanInstalledExtensionAtLocation(v.location).then(g=>{g?C.push(g):this.r.info("Extension not found at the location",v.location.toString())},g=>this.r.error(g)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(v){this.r.error(v)}}D($){for(const C of this.h.profiles)$.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F($){const C=[],S=[],v=await this.j.scanProfileExtensions($),d=new Set,g=new Set;for(const[m,l]of this.b)l.has($)&&g.add(m);for(const m of v){const l=this.L(m.identifier,m.version);d.add(l),g.has(l)||(C.push(m.identifier),this.I(l,$))}for(const m of g)if(!d.has(m)){const l=this.M(m);l&&(S.push(l.identifier),this.J(m,$))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:$}:void 0,removed:S.length?{extensions:S,profileLocation:$}:void 0})}async G($){const C=await this.j.scanProfileExtensions($);for(const S of C)this.I(this.L(S.identifier,S.version),$)}async H($){$||($=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),$.length&&await this.f.markAsUninstalled(...$)}I($,C){let S=this.b.get($);S||this.b.set($,S=new r.$zc(v=>this.m.extUri.getComparisonKey(v))),S.add(C)}J($,C){const S=this.b.get($);S&&S.delete(C),S?.size||this.b.delete($)}L($,C){return`${A.$Wl.toKey($.id)}@${C}`}M($){const[C,S]=(0,P.$so)($);return S?{identifier:{id:C},version:S}:void 0}}e.$yp=I}),define(be[241],we([1,0,213,36]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=void 0;async function r(P,A,I,w,$,C,S){const v={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P} (${A.nameShort})`};if((0,O.$io)(A,I)&&(0,O.$ko)(w)===3){const d=await(0,D.$3o)(I,$,C);v["X-Market-User-Id"]=d,v["VSCode-SessionId"]=S.machineId||d}return v}e.$4o=r}),define(be[120],we([1,0,86,18,14,2,12,7,21,25,30,37,13,83,4]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;let m=class extends d.$Kq{constructor(c,y,h,t){super(h),this.h=c,this.j=t,this.g=this.B(new l(y,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(c,y){const t=(await this.g.getLanguagePacks())[y];if(!t){this.j.warn(`No language pack found for ${y}`);return}const s=t.translations[c];return s?g.URI.file(s):void 0}async getInstalledLanguages(){const c=await this.g.getLanguagePacks(),y=Object.keys(c).map(h=>{const t=c[h];return{...this.f(h,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return y.push(this.f("en","English")),y.sort((h,t)=>h.label.localeCompare(t.label)),y}async m(c){c&&c.manifest&&c.manifest.contributes&&c.manifest.contributes.localizations&&c.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",c.identifier.id),await this.update())}async n(c){const y=await this.g.getLanguagePacks();Object.keys(y).some(h=>y[h]&&y[h].extensions.some(t=>(0,S.$qo)(t.extensionIdentifier,c.identifier)))&&(this.j.info("Removing language packs from the extension",c.identifier.id),await this.update())}async update(){const[c,y]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(y);return!(0,O.$sb)(Object.keys(c),Object.keys(h))}};e.$Lq=m,e.$Lq=m=Oe([Ae(0,C.$3n),Ae(1,$.$Th),Ae(2,C.$1n),Ae(3,v.$6i)],m);let l=class extends P.$Qc{constructor(c,y){super(),this.j=y,this.c={},this.f=(0,I.$hc)(c.userDataPath,"languagepacks.json"),this.g=new r.$Xg}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(c){return this.s(y=>{Object.keys(y).forEach(h=>delete y[h]),this.m(y,...c)}).then(()=>this.c)}m(c,...y){for(const h of y)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(c,h);Object.keys(c).forEach(h=>this.r(c[h]))}n(c,y){const h=y.identifier,t=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const s of t)if(y.location.scheme===A.Schemas.file&&f(s)){let o=c[s.languageId];o||(o={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},c[s.languageId]=o);const i=o.extensions.filter(n=>(0,S.$qo)(n.extensionIdentifier,h))[0];i?i.version=y.manifest.version:o.extensions.push({extensionIdentifier:h,version:y.manifest.version});for(const n of s.translations)o.translations[n.id]=(0,I.$hc)(y.location.fsPath,n.path)}}r(c){if(c){const y=(0,D.createHash)("md5");for(const h of c.extensions)y.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);c.hash=y.digest("hex")}}s(c=()=>null){return this.g.queue(()=>{let y=null;return w.Promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(y=c(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.c=h,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),w.Promises.writeFile(this.f,t)}).then(()=>y,h=>this.j.error(h))})}};l=Oe([Ae(0,$.$Th),Ae(1,v.$6i)],l);function f(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const c of u.translations)if(typeof c.id!="string"||typeof c.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(be[242],we([1,0,165,11,22,36]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function w(C,S,v){const d=await(0,D.$dC)("@microsoft/1ds-core-js","dist/ms.core.js"),g=await(0,D.$dC)("@microsoft/1ds-post-js","dist/ms.post.js"),m=new d.AppInsightsCore,l=new g.PostChannel,f={instrumentationKey:C,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[l]]};if(v){f.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:v};f.extensionConfig[l.identifier]=u}return m.initialize(f,[]),m.addTelemetryInitializer(u=>{S&&(u.ext=u.ext??{},u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),m}class ${constructor(S,v,d,g,m){this.e=S,this.f=v,this.g=d,this.h=m,this.c=A,this.d=I,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(v=>{S(v)},v=>{(0,O.$Y)(v),console.error(v)})}}log(S,v){if(!this.a)return;v=(0,r.$Zm)(v,this.g),v=(0,P.$lo)(v);const d=this.f+"/"+S;try{this.i(g=>{g.pluginVersionString=v?.properties.version??"Unknown",g.track({name:d,baseData:{name:d,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$gN=$}),define(be[243],we([1,0,2,22,3,17,194,24,55,54,31,35,32,36]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let g=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,u,c){this.k=u,this.l=c,this.d={},this.i=new D.$Pc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,P.$De)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,P.$De)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(v.$el)||y.affectsConfiguration(v.$gl)||y.affectsConfiguration(v.$fl))&&this.m()}))}setExperimentProperty(f,u){this.d[f]=u}m(){let f=(0,d.$ko)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const c=u.usage?3:u.error?2:0;f=Math.min(f,c)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,u,c){this.g<u||(c=(0,O.$Zm)(c,this.d),c=(0,d.$po)(c,this.j),c=(0,O.$Zm)(c,this.c),this.b.forEach(y=>y.log(f,c)))}publicLog(f,u){this.n(f,3,u)}publicLog2(f,u){this.publicLog(f,u)}publicLogError(f,u){this.h&&this.n(f,2,u)}publicLogError2(f,u){this.publicLogError(f,u)}};e.$Rq=g,e.$Rq=g=Oe([Ae(1,I.$fi),Ae(2,C.$lj)],g);function m(){const l=(0,A.localize)(0,null,$.default.nameLong),f=$.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",$.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=r.$o?"":(0,A.localize)(3,null),c=(0,A.localize)(4,null),y=(0,A.localize)(5,null),h=(0,A.localize)(6,null),t=(0,A.localize)(7,null),s=`
|       | ${c} | ${y} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,A.localize)(8,null);return`
${l} ${f} ${u}

&nbsp;

${t}
${s}

&nbsp;

${o}
`}S.$9m.as(w.$bn.Configuration).registerConfiguration({id:v.$dl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[v.$el]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$9m.as(w.$bn.Configuration).registerConfiguration({id:v.$dl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[v.$gl]:{type:"boolean",markdownDescription:$.default.privacyStatementUrl?(0,A.localize)(16,null,$.default.nameLong,$.default.privacyStatementUrl):(0,A.localize)(15,null,$.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${v.$el}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[244],we([1,0,24,6,31,32,243,36]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Er=e.$Dr=e.$Cr=void 0;let w=class extends A.$Rq{constructor(C,S,v,d){super(C,v,d),this.o=S}publicLog(C,S){if(!(this.o<3))return super.publicLog(C,S)}publicLog2(C,S){return this.publicLog(C,S)}publicLogError(C,S){return this.o<2?Promise.resolve(void 0):super.publicLogError(C,S)}publicLogError2(C,S){return this.publicLogError(C,S)}async updateInjectedTelemetryLevel(C){if(C===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,C):C,this.o===0&&this.dispose()}};e.$Cr=w,e.$Cr=w=Oe([Ae(2,D.$fi),Ae(3,r.$lj)],w),e.$Dr=new class extends I.$bo{async updateInjectedTelemetryLevel(){}},e.$Er=(0,O.$Mh)(P.$0k)}),define(be[245],we([1,0,15,20,298,242]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=void 0;async function A(C,S){const v=await S.request(C,O.CancellationToken.None),d=(await(0,D.$le)(v.stream)).toString(),g=v.res.statusCode??200;return{headers:v.res.headers,statusCode:g,responseData:d}}async function I(C){const S={method:C.type,headers:C.headers};return new Promise((d,g)=>{const m=r.request(C.url??"",S,l=>{l.on("data",function(f){d({headers:l.headers,statusCode:l.statusCode??200,responseData:f.toString()})}),l.on("error",function(f){g(f)})});m.write(C.data,l=>{l&&g(l)}),m.end()})}async function w(C,S,v){const d=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),g={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:d};try{const m=C?await A(g,C):await I(g);v(m.statusCode,m.headers,m.responseData)}catch{v(0,{})}}class $ extends P.$gN{constructor(S,v,d,g,m){const l={sendPOST:(f,u)=>{w(S,f,u)}};super(v,d,g,m,l)}}e.$hN=$}),define(be[246],we([1,0,11,237]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class r extends O.default{i(){(0,D.setUnexpectedErrorHandler)(I=>console.error(I));const A=[];process.on("unhandledRejection",(I,w)=>{A.push(w),setTimeout(()=>{const $=A.indexOf(w);$>=0&&w.catch(C=>{A.splice($,1),(0,D.$2)(C)||(console.warn(`rejected promise not handled within 1 second: ${C}`),C.stack&&console.warn(`stack trace: ${C.stack}`),I&&(0,D.$Y)(I))})},1e3)}),process.on("rejectionHandled",I=>{const w=A.indexOf(I);w>=0&&A.splice(w,1)}),process.on("uncaughtException",I=>{(0,D.$X)(I)||(0,D.$Y)(I)})}}e.default=r}),define(be[121],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var D;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(D||(e.EnvironmentVariableMutatorType=D={}))}),define(be[122],we([1,0,3,121]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;const r=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class P{constructor(C){this.collections=C,this.a=new Map,this.b=new Map,C.forEach((S,v)=>{this.d(S,v);const d=S.map.entries();let g=d.next();for(;!g.done;){const m=g.value[1],l=g.value[0];let f=this.a.get(l);if(f||(f=[],this.a.set(l,f)),f.length>0&&f[0].type===O.EnvironmentVariableMutatorType.Replace){g=d.next();continue}const u={extensionIdentifier:v,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};u.scope||delete u.scope,f.unshift(u),g=d.next()}})}async applyToProcessEnvironment(C,S,v){let d;D.$i&&(d={},Object.keys(C).forEach(g=>d[g.toLowerCase()]=g));for(const[g,m]of this.getVariableMap(S)){const l=D.$i&&d[g.toLowerCase()]||g;for(const f of m){const u=v?await v(f.value):f.value;if(f.options?.applyAtProcessCreation??!0)switch(f.type){case O.EnvironmentVariableMutatorType.Append:C[l]=(C[l]||"")+u;break;case O.EnvironmentVariableMutatorType.Prepend:C[l]=u+(C[l]||"");break;case O.EnvironmentVariableMutatorType.Replace:C[l]=u;break}if(f.options?.applyAtShellIntegration??!1){const c=`VSCODE_ENV_${r.get(f.type)}`;C[c]=(C[c]?C[c]+":":"")+g+"="+this.c(u)}}}}c(C){return C.replaceAll(":","\\x3a")}diff(C,S){const v=new Map,d=new Map,g=new Map;if(C.getVariableMap(S).forEach((m,l)=>{const f=this.getVariableMap(S).get(l),u=I(m,f);u&&v.set(l,u)}),this.getVariableMap(S).forEach((m,l)=>{const f=C.getVariableMap(S).get(l),u=I(m,f);u&&g.set(l,u)}),this.getVariableMap(S).forEach((m,l)=>{const f=C.getVariableMap(S).get(l),u=w(m,f);u&&d.set(l,u)}),!(v.size===0&&d.size===0&&g.size===0))return{added:v,changed:d,removed:g}}getVariableMap(C){const S=new Map;for(const v of this.a.values()){const d=v.filter(g=>A(g,C));d.length>0&&S.set(d[0].variable,d)}return S}getDescriptionMap(C){const S=new Map;for(const v of this.b.values()){const d=v.filter(g=>A(g,C,!0));for(const g of d)S.set(g.extensionIdentifier,g.description)}return S}d(C,S){if(!C.descriptionMap)return;const v=C.descriptionMap.entries();let d=v.next();for(;!d.done;){const g=d.value[1],m=d.value[0];let l=this.b.get(m);l||(l=[],this.b.set(m,l));const f={extensionIdentifier:S,scope:g.scope,description:g.description};f.scope||delete f.scope,l.push(f),d=v.next()}}}e.$hr=P;function A($,C,S=!1){return $.scope?!!($.scope.workspaceFolder&&C?.workspaceFolder&&$.scope.workspaceFolder.index===C.workspaceFolder.index):S?C===$.scope:!0}function I($,C){if(!C)return $;const S=new Set;C.forEach(d=>S.add(d.extensionIdentifier));const v=[];return $.forEach(d=>{S.has(d.extensionIdentifier)||v.push(d)}),v.length===0?void 0:v}function w($,C){if(!C)return;const S=new Map;C.forEach(d=>S.set(d.extensionIdentifier,d));const v=[];return $.forEach(d=>{const g=S.get(d.extensionIdentifier);g&&(d.type!==g.type||d.value!==g.value||d.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&v.push(g)}),v.length===0?void 0:v}}),define(be[87],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=e.$er=e.$dr=e.$cr=e.$br=void 0;function D(w){return[...w.entries()]}e.$br=D;function O(w){return w?[...w.entries()]:[]}e.$cr=O;function r(w){return new Map(w)}e.$dr=r;function P(w){return new Map(w??[])}e.$er=P;function A(w){return Array.from(w.entries()).map($=>[$[0],D($[1].map),O($[1].descriptionMap)])}e.$fr=A;function I(w){return new Map(w.map($=>[$[0],{map:r($[1]),descriptionMap:P($[2])}]))}e.$gr=I}),define(be[247],we([1,0,14,20,5,2,13]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=void 0;let I=class extends P.$Qc{constructor($,C){super(),this.h=C,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$Ld),this.onCreateRequest=this.g.event,this.b=$===void 0?15e3:$,this.B((0,P.$Oc)(()=>{for(const S of this.f.values())(0,P.$Lc)(S)}))}createRequest($){return new Promise((C,S)=>{const v=++this.a;this.c.set(v,C),this.g.fire({requestId:v,...$});const d=new O.$Vd;(0,D.$Rg)(this.b,d.token).then(()=>S(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,P.$Oc)(()=>d.cancel())])})}acceptReply($,C){const S=this.c.get($);S?(this.c.delete($),(0,P.$Lc)(this.f.get($)||[]),this.f.delete($),S(C)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${$}`)}};e.$5q=I,e.$5q=I=Oe([Ae(1,A.$6i)],I)}),define(be[88],we([1,0,6,66,35]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Xq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Wq=void 0,e.$Wq=new O.$3i("terminalTabFocusMode",!1,!0);var P;(function(h){h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(P||(e.TerminalSettingPrefix=P={}));var A;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var I;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh"})(I||(e.PosixShellType=I={}));var w;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash"})(w||(e.WindowsShellType=w={}));var $;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})($||(e.TitleEventSource=$={}));var C;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(C||(e.TerminalIpcChannels=C={}));var S;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(S||(e.ProcessPropertyType=S={})),e.$Xq=(0,D.$Lh)("ptyService");var v;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var d;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(d||(e.TerminalLocation=d={}));var g;(function(h){h.TerminalView="view",h.Editor="editor"})(g||(e.TerminalLocationString=g={}));var m;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var l;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(l||(e.FlowControlConstants=l={}));var f;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(f||(e.ProfileSource=f={}));var u;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(u||(e.ShellIntegrationStatus=u={}));var c;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(c||(e.TerminalExitReason=c={})),e.$Yq={Backend:"workbench.contributions.terminal.processBackend"};class y{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$9m.add(e.$Yq.Backend,new y),e.$Zq=(0,D.$Lh)("localPtyService"),e.$1q=(0,D.$Lh)("terminalLogService")}),define(be[248],we([1,0,3]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YM=e.$XM=e.$WM=void 0;function O(A){let I=A;I.includes("\\")&&(I=I.replace(/\\/g,"\\\\"));const w=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return I=I.replace(w,""),`'${I}'`}e.$WM=O;function r(A,I,w){if(!A)return"";if(!I)return A;I.match(/[\/\\]$/)&&(I=I.slice(0,I.length-1));const $=A.replace(/\\/g,"/").toLowerCase(),C=I.replace(/\\/g,"/").toLowerCase();return $.includes(C)?`~${w}${A.slice(I.length+1)}`:A}e.$XM=r;function P(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),D.OS===1&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}e.$YM=P}),define(be[249],we([1,0,49,4,196,98]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=e.$8q=e.$7q=e.$6q=void 0;function A(v,d){const g=[{name:null,description:(0,r.localize)(0,null)}];return g.push(...v.map(m=>({name:m.profileName,description:I(m)}))),d&&g.push(...d.map(m=>({name:m.title,description:w(m)}))),{values:g.map(m=>m.name),markdownDescriptions:g.map(m=>m.description)}}e.$6q=A;function I(v){let d=`$(${P.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.$Qj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?d+=`
- args: "${v.args}"`:d+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(d+=`
- overrideName: ${v.overrideName}`),v.color&&(d+=`
- color: ${v.color}`),v.env&&(d+=`
- env: ${JSON.stringify(v.env)}`),d}function w(v){return`$(${P.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.$Qj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function $(v,d){if(!v&&!d)return!0;if(typeof v=="string"&&typeof d=="string")return v===d;if(Array.isArray(v)&&Array.isArray(d)){if(v.length!==d.length)return!1;for(let g=0;g<v.length;g++)if(v[g]!==d[g])return!1;return!0}return!1}e.$7q=$;function C(v,d){if(!v&&!d)return!0;if(!v||!d)return!1;if(P.ThemeIcon.isThemeIcon(v)&&P.ThemeIcon.isThemeIcon(d))return v.id===d.id&&v.color===d.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof d=="object"&&"light"in d&&"dark"in d){const g=v,m=d;if((O.URI.isUri(g.light)||S(g.light))&&(O.URI.isUri(g.dark)||S(g.dark))&&(O.URI.isUri(m.light)||S(m.light))&&(O.URI.isUri(m.dark)||S(m.dark)))return g.light.path===m.light.path&&g.dark.path===m.dark.path}if(O.URI.isUri(v)&&O.URI.isUri(d)||S(v)||S(d)){const g=v,m=d;return g.path===m.path&&g.scheme===m.scheme}return!1}e.$8q=C;function S(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$9q=S}),define(be[250],we([1,0,49,3,195,55,35,249]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=e.$$q=e.$0q=void 0,e.$0q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$$q={type:"string",enum:Array.from((0,D.$Pj)(),l=>l.id),markdownEnumDescriptions:Array.from((0,D.$Pj)(),l=>`$(${l.id})`)};const w={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$$q},color:{description:(0,r.localize)(3,null),...e.$0q},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},$={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...w}},C={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...w}};function S(l){const f=l===2?"linux":l===1?"osx":"windows";return(0,r.localize)(7,null,(0,O.$h)(l),'```json\n"terminal.integrated.profile.'+f+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:S(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...w}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...w}},{type:"null"},$]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:S(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...w}},{type:"null"},$]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:S(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...w}},{type:"null"},$]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,r.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function d(){A.$9m.as(P.$bn.Configuration).registerConfiguration(v),m()}e.$_q=d;let g;function m(l,f){const u=A.$9m.as(P.$bn.Configuration);let c;l&&(c=(0,I.$6q)(l?.profiles,f));const y=g;g={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:l?.os===3?c?.values:void 0,markdownEnumDescriptions:l?.os===3?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:l?.os===2?c?.values:void 0,markdownEnumDescriptions:l?.os===2?c?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:l?.os===1?c?.values:void 0,markdownEnumDescriptions:l?.os===1?c?.markdownDescriptions:void 0}}},u.updateConfigurations({add:[g],remove:y?[y]:[]})}e.$ar=m}),define(be[251],we([1,0,2,12,107,25,108]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BN=void 0;let I=class extends D.$Qc{constructor($,C){super(),this.a=$,this.b=C}start(){const $={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:O.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},C=(0,A.$bm)(this.b.args,this.b.isBuilt);C&&(C.break&&C.port?$.debugBrk=C.port:!C.break&&C.port&&($.debug=C.port));const S=new r.$Tp(O.$_f.asFileUri("bootstrap-fork").fsPath,$),v=new D.$Pc;return v.add(S),{client:S,store:v,onDidProcessExit:S.onDidProcessExit}}};e.$BN=I,e.$BN=I=Oe([Ae(1,P.$Sh)],I)}),define(be[252],we([1,0,28,12,22,7,3,29,17,10,21,121,87,122]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=e.$ir=void 0;function g(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$ir=g;async function m(i,n,a,b=I.env,p=C.Promises.exists){if(P.$gc(i))return await p(i)?i:void 0;if(n===void 0&&(n=I.cwd()),P.$kc(i)!=="."){const j=P.$hc(n,i);return await p(j)?j:void 0}const k=(0,r.$4m)(b,"PATH");if(a===void 0&&(0,$.$wf)(k)&&(a=k.split(P.$rc)),a===void 0||a.length===0){const j=P.$hc(n,i);return await p(j)?j:void 0}for(const j of a){let Y;if(P.$gc(j)?Y=P.$hc(j,i):Y=P.$hc(n,j,i),await p(Y))return Y;if(A.$i){let ce=Y+".com";if(await p(ce)||(ce=Y+".exe",await p(ce)))return ce}}const L=P.$hc(n,i);return await p(L)?L:void 0}e.$jr=m;function l(i,n,a,b,p){const E=A.$i&&(!n.windowsEnableConpty||g()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||E)return;const k=i.args,L=I.$bc==="win32"?P.$lc(i.executable).toLowerCase():P.$lc(i.executable),j=P.$kc(O.$_f.asFileUri("").fsPath);let Y;const ce={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(ce.VSCODE_NONCE=n.shellIntegration.nonce),A.$i){if(L==="pwsh.exe"||L==="powershell.exe")return!k||s(k)?Y=c.get(u.WindowsPwsh):t(k)&&(Y=c.get(u.WindowsPwshLogin)),Y?(Y=[...Y],Y[Y.length-1]=(0,w.$Ae)(Y[Y.length-1],j,""),{newArgs:Y,envMixin:ce}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(L){case"bash":return!k||k.length===0?Y=c.get(u.Bash):o(k)&&(ce.VSCODE_SHELL_LOGIN="1",f(n,ce),Y=c.get(u.Bash)),Y?(Y=[...Y],Y[Y.length-1]=(0,w.$Ae)(Y[Y.length-1],j),{newArgs:Y,envMixin:ce}):void 0;case"fish":{const x=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ce.XDG_DATA_DIRS=`${x}:${ne}`,f(n,ce),{newArgs:void 0,envMixin:ce}}case"pwsh":return!k||s(k)?Y=c.get(u.Pwsh):t(k)&&(Y=c.get(u.PwshLogin)),Y?(Y=[...Y],Y[Y.length-1]=(0,w.$Ae)(Y[Y.length-1],j,""),{newArgs:Y,envMixin:ce}):void 0;case"zsh":{if(!k||k.length===0?Y=c.get(u.Zsh):o(k)?(Y=c.get(u.ZshLogin),f(n,ce)):(k===c.get(u.Zsh)||k===c.get(u.ZshLogin))&&(Y=k),!Y)return;Y=[...Y],Y[Y.length-1]=(0,w.$Ae)(Y[Y.length-1],j);let x;try{x=D.userInfo().username}catch{x="unknown"}const ne=P.$hc(D.tmpdir(),`${x}-${p.applicationName}-zsh`);ce.ZDOTDIR=ne;const ue=a?.ZDOTDIR??D.homedir()??"~";ce.USER_ZDOTDIR=ue;const _=[];return _.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:P.$hc(ne,".zshrc")}),_.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:P.$hc(ne,".zprofile")}),_.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:P.$hc(ne,".zshenv")}),_.push({source:P.$hc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:P.$hc(ne,".zlogin")}),{newArgs:Y,envMixin:ce,filesToCopy:_}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$kr=l;function f(i,n){if(A.$j&&i.environmentVariableCollections){const a=(0,v.$gr)(i.environmentVariableCollections),p=new d.$hr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),E=[];if(p)for(const k of p)k.type===S.EnvironmentVariableMutatorType.Prepend&&E.push(k.value);E.length>0&&(n.VSCODE_PATH_PREFIX=E.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const c=new Map;c.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),c.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),c.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),c.set(u.Zsh,["-i"]),c.set(u.ZshLogin,["-il"]),c.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const y=["-login","-l"],h=["-nol","-nologo"];function t(i){return typeof i=="string"?y.includes(i.toLowerCase()):i.length===1&&y.includes(i[0].toLowerCase())||i.length===2&&(y.includes(i[0].toLowerCase())||y.includes(i[1].toLowerCase()))&&(h.includes(i[0].toLowerCase())||h.includes(i[1].toLowerCase()))}function s(i){return typeof i=="string"?h.includes(i.toLowerCase()):i.length===0||i?.length===1&&h.includes(i[0].toLowerCase())}function o(i){return i==="string"&&y.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&y.includes(i[0].toLowerCase())}}),define(be[253],we([1,0,52,49,7,3,10,21,102,252,76]),function(le,e,D,O,r,P,A,I,w,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;let S,v=!0;function d(n,a,b,p,E=process.env,k,L,j,Y){return k=k||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},P.$i?g(b,k,E,L,p.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:p.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:p.getValue("terminal.integrated.defaultProfile.windows"),Y,j):s(k,L,b,n&&typeof n=="object"?{...n}:p.getValue(P.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:p.getValue(P.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),Y,j,E)}e.$lr=d;async function g(n,a,b,p,E,k,L,j,Y){const ce=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${ce?"Sysnative":"System32"}`;let ne=!1;(0,$.$ir)()>=16299&&(ne=!0),await u(j);const ue=new Map;if(n){ue.set("PowerShell",{source:"PowerShell",icon:O.$Qj.terminalPowershell,isAutoDetected:!0}),ue.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Qj.terminalPowershell,isAutoDetected:!0}),ue.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ue.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:O.$Qj.terminalCmd,isAutoDetected:!0}),ue.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ue.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Qj.terminalBash,isAutoDetected:!0});const he=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ue.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",he],requiresPath:process.env.CMDER_ROOT?he:{path:he,isUnsafe:!0},isAutoDetected:!0})}o(k,ue);const _=await m(ue.entries(),L,a,b,p,Y);if(n&&E)try{const he=await h(`${x}\\${ne?"wsl":"bash"}.exe`,L);for(const ee of he)(!k||!(ee.profileName in k))&&_.push(ee)}catch{v&&(p?.info("WSL is not installed, so could not detect WSL profiles"),v=!1)}return _}async function m(n,a,b,p=process.env,E,k){const L=[];for(const[j,Y]of n)L.push(l(j,Y,a,b,p,E,k));return(await Promise.all(L)).filter(j=>!!j)}async function l(n,a,b,p,E=process.env,k,L){if(a===null)return;let j,Y,ce;if("source"in a&&!("path"in a)){const _=S?.get(a.source);if(!_)return;j=_.paths,Y=a.args||_.args,a.icon?ce=f(a.icon):_.icon&&(ce=_.icon)}else j=Array.isArray(a.path)?a.path:[a.path],Y=P.$i||Array.isArray(a.args)?a.args:void 0,ce=f(a.icon);let x;if(L){const _=j.map(ee=>typeof ee=="string"?ee:ee.path),he=await L(_);x=new Array(j.length);for(let ee=0;ee<j.length;ee++)typeof j[ee]=="string"?x[ee]=he[ee]:x[ee]={path:he[ee],isUnsafe:!0}}else x=j.slice();let ne;if(a.requiresPath){let _;if((0,A.$wf)(a.requiresPath)?_=a.requiresPath:(_=a.requiresPath.path,a.requiresPath.isUnsafe&&(ne=_)),!await p.existsFile(_))return}const ue=await i(n,b,x,p,E,Y,a.env,a.overrideName,a.isAutoDetected,ne);if(!ue){k?.debug("Terminal profile not validated",n,j);return}return ue.isAutoDetected=a.isAutoDetected,ue.icon=ce,ue.color=a.color,ue}function f(n){return typeof n=="string"?{id:n}:n}async function u(n){if(S&&!n)return;const[a,b]=await Promise.all([c(),n||y()]);S=new Map,S.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),S.set("PowerShell",{profileName:"PowerShell",paths:b,icon:O.$Qj.terminalPowershell})}async function c(){const n=new Set,a=await(0,$.$jr)("git.exe");if(a){const E=(0,C.dirname)(a);n.add((0,C.resolve)(E,"../.."))}function b(E,k){k&&E.add(k)}b(n,process.env.ProgramW6432),b(n,process.env.ProgramFiles),b(n,process.env["ProgramFiles(X86)"]),b(n,`${process.env.LocalAppData}\\Program`);const p=[];for(const E of n)p.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return p.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),p.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),p}async function y(){const n=[];for await(const a of(0,w.$rl)())n.push(a.exePath);return n}async function h(n,a){const b=[],p=await new Promise((L,j)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Y,ce)=>{if(Y)return j("Problem occurred when getting wsl distros");L(ce)})});if(!p)return[];const E=new RegExp(/[\r?\n]/),k=p.split(E).filter(L=>L.trim().length>0&&L!=="");for(const L of k){if(L===""||L.startsWith("docker-desktop"))continue;const j=`${L} (WSL)`,Y={profileName:j,path:n,args:["-d",`${L}`],isDefault:j===a,icon:t(L),isAutoDetected:!1};b.push(Y)}return b}function t(n){return n.includes("Ubuntu")?O.$Qj.terminalUbuntu:n.includes("Debian")?O.$Qj.terminalDebian:O.$Qj.terminalLinux}async function s(n,a,b,p,E,k,L,j){const Y=new Map;if(b){const ce=(await n.readFile("/etc/shells")).toString(),x=(k||ce.split(`
`)).map(ue=>{const _=ue.indexOf("#");return _===-1?ue:ue.substring(0,_)}).filter(ue=>ue.trim().length>0),ne=new Map;for(const ue of x){let _=(0,r.$lc)(ue),he=ne.get(_)||0;he++,he>1&&(_=`${_} (${he})`),ne.set(_,he),Y.set(_,{path:ue,isAutoDetected:!0})}}return o(p,Y),await m(Y.entries(),E,n,j,a,L)}function o(n,a){if(n)for(const[b,p]of Object.entries(n))p===null||typeof p!="object"||!("path"in p)&&!("source"in p)?a.delete(b):(p.icon=p.icon||a.get(b)?.icon,a.set(b,p))}async function i(n,a,b,p,E,k,L,j,Y,ce){if(b.length===0)return Promise.resolve(void 0);const x=b.shift();if(x==="")return i(n,a,b,p,E,k,L,j,Y);const ne=typeof x!="string"&&x.isUnsafe,ue=typeof x=="string"?x:x.path,_={profileName:n,path:ue,args:k,env:L,overrideName:j,isAutoDetected:Y,isDefault:n===a,isUnsafePath:ne,requiresUnsafePath:ce};if((0,r.$lc)(ue)===ue){const ee=E.PATH?E.PATH.split(r.$rc):void 0,te=await(0,$.$jr)(ue,void 0,ee,void 0,p.existsFile);return te?(_.path=te,_.isFromPath=!0,_):i(n,a,b,p,E,k)}return await p.existsFile((0,r.$fc)(ue))?_:i(n,a,b,p,E,k,L,j,Y)}}),define(be[254],we([1,0,5,2,3,43,24,13,112,85,247,88,250,253,105,58]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;var l;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(l||(l={}));let f=class extends O.$Qc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(c,y,h,t){super(),this.M=c,this.N=y,this.O=h,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new D.$Ld),this.onPtyHostExit=this.u.event,this.w=this.B(new D.$Ld),this.onPtyHostStart=this.w.event,this.y=this.B(new D.$Ld),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new D.$Ld),this.onPtyHostResponsive=this.z.event,this.C=this.B(new D.$Ld),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new D.$Ld),this.onProcessData=this.D.event,this.F=this.B(new D.$Ld),this.onProcessReady=this.F.event,this.G=this.B(new D.$Ld),this.onProcessReplay=this.G.event,this.H=this.B(new D.$Ld),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new D.$Ld),this.onDidRequestDetach=this.I.event,this.J=this.B(new D.$Ld),this.onDidChangeProperty=this.J.event,this.L=this.B(new D.$Ld),this.onProcessExit=this.L.event,(0,v.$_q)(),this.B(this.M),this.B((0,O.$Oc)(()=>this.W())),this.j=this.B(new C.$5q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&D.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(r.$i)return process.env;try{return await(0,$.$Nl)(this.N,this.O,{_:[]},process.env)}catch(c){return this.O.error("ptyHost was unable to resolve shell environment",c),{}}}U(){const c=this.M.start(),y=c.client;this.O.getLevel()===I.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),P.ProxyChannel.toService(y.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(c.onDidProcessExit(s=>{this.u.fire(s.code),!this.m&&!this.q.isDisposed&&(this.n<=l.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const t=P.ProxyChannel.toService(y.getChannel(S.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(s=>this.D.fire(s))),this.B(t.onProcessReady(s=>this.F.fire(s))),this.B(t.onProcessExit(s=>this.L.fire(s))),this.B(t.onDidChangeProperty(s=>this.J.fire(s))),this.B(t.onProcessReplay(s=>this.G.fire(s))),this.B(t.onProcessOrphanQuestion(s=>this.H.fire(s))),this.B(t.onDidRequestDetach(s=>this.I.fire(s))),this.B(new w.$4q(this.P,y.getChannel(S.TerminalIpcChannels.Logger))),this.a=c,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[c,t]}async createProcess(c,y,h,t,s,o,i,n,a,b,p){const E=setTimeout(()=>this.$(),S.HeartbeatConstants.CreateProcessTimeout),k=await this.f.createProcess(c,y,h,t,s,o,i,n,a,b,p);return clearTimeout(E),k}updateTitle(c,y,h){return this.f.updateTitle(c,y,h)}updateIcon(c,y,h,t){return this.f.updateIcon(c,y,h,t)}attachToProcess(c){return this.f.attachToProcess(c)}detachFromProcess(c,y){return this.f.detachFromProcess(c,y)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(c){return this.f.start(c)}shutdown(c,y){return this.f.shutdown(c,y)}input(c,y){return this.f.input(c,y)}processBinary(c,y){return this.f.processBinary(c,y)}resize(c,y,h){return this.f.resize(c,y,h)}clearBuffer(c){return this.f.clearBuffer(c)}acknowledgeDataEvent(c,y){return this.f.acknowledgeDataEvent(c,y)}setUnicodeVersion(c,y){return this.f.setUnicodeVersion(c,y)}getInitialCwd(c){return this.f.getInitialCwd(c)}getCwd(c){return this.f.getCwd(c)}async getLatency(){const c=new m.$Hd,y=await this.f.getLatency();return c.stop(),[{label:"ptyhostservice<->ptyhost",latency:c.elapsed()},...y]}orphanQuestionReply(c){return this.f.orphanQuestionReply(c)}installAutoReply(c,y){return this.f.installAutoReply(c,y)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(c){return this.f.uninstallAutoReply(c)}getDefaultSystemShell(c){return this.g?.getDefaultSystemShell(c)??(0,g.$xl)(c??r.OS,process.env)}async getProfiles(c,y,h,t=!1){const s=await this.S();return(0,d.$lr)(y,h,t,this.N,s,void 0,this.O,this.bb.bind(this,c))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(c,y){return this.f.getWslPath(c,y)}getRevivedPtyNewId(c,y){return this.f.getRevivedPtyNewId(c,y)}setTerminalLayoutInfo(c){return this.f.setTerminalLayoutInfo(c)}async getTerminalLayoutInfo(c){return this.g?.getTerminalLayoutInfo(c)}async requestDetachInstance(c,y){return this.f.requestDetachInstance(c,y)}async acceptDetachInstanceReply(c,y){return this.f.acceptDetachInstanceReply(c,y)}async freePortKillProcess(c){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(c)}async serializeTerminalState(c){return this.f.serializeTerminalState(c)}async reviveTerminalProcesses(c,y,h){return this.f.reviveTerminalProcesses(c,y,h)}async refreshProperty(c,y){return this.f.refreshProperty(c,y)}async updateProperty(c,y,h){return this.f.updateProperty(c,y,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(c){this.ab(),this.s=setTimeout(()=>this.Y(),c?S.HeartbeatConstants.ConnectingBeatInterval:S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(c,y){return this.j.createRequest({workspaceId:c,originalText:y})}async acceptPtyHostResolvedVariables(c,y){this.j.acceptReply(c,y)}};e.$mr=f,e.$mr=f=Oe([Ae(1,A.$fi),Ae(2,I.$6i),Ae(3,I.$7i)],f)}),define(be[34],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=void 0,e.$Dk=(0,D.$Lh)("IUriIdentityService")}),define(be[123],we([1,0,34,214,16,19,145,5,2]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class ${static{this._clock=0}constructor(v){this.uri=v,this.time=$._clock++}touch(){return this.time=$._clock++,this}}let C=class{constructor(v){this.g=v,this.c=new w.$Pc,this.f=2**16;const d=new Map,g=m=>{let l=d.get(m.scheme);return l===void 0&&(l=v.hasProvider(m)&&!this.g.hasCapability(m,1024),d.set(m.scheme,l)),l};this.c.add(I.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(m=>{d.delete(m.scheme)})),this.extUri=new P.$hg(g),this.d=new A.$pr((m,l)=>this.extUri.compare(m,l,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,P.$tg)(v));const d=this.d.get(v);return d?d.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new $(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((g,m)=>g[1].time<m[1].time?1:g[1].time>m[1].time?-1:0);$._clock=0,this.d.clear();const d=this.f*.5;for(let g=0;g<d;g++)this.d.set(v[g][0],v[g][1].touch())}};e.$qr=C,e.$qr=C=Oe([Ae(0,r.$7j)],C),(0,O.$nr)(D.$Dk,C,1)}),define(be[89],we([1,0,198,7,61,19,4,6,12]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.WorkbenchState=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0,e.$Uh=(0,I.$Lh)("contextService");function $(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$Vh=$;function C(i){return typeof i?.id=="string"&&!$(i)&&!v(i)}e.$Wh=C,e.$Xh={id:"ext-dev"},e.$Yh={id:"empty-window"};function S(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$lc)(i)}:n?e.$Xh:e.$Yh;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Zh=S;function v(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$1h=v;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:A.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$2h=d;var g;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(g||(e.WorkbenchState=g={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$3h=m;function l(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$4h=l;class f{constructor(n,a,b,p,E){this.h=n,this.j=b,this.k=p,this.l=E,this.c=r.$Rh.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=r.$Rh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$5h=f;class u{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,P.$sg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$6h=u;function c(i){return new u({uri:i,index:0,name:(0,P.$og)(i)},{uri:i.toString()})}e.$7h=c,e.$8h="code-workspace",e.$9h=`.${e.$8h}`,e.$0h=[{name:(0,D.localize)(0,null),extensions:[e.$8h]}],e.$$h="workspace.json";function y(i,n){return P.$jg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$_h=y;function h(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===w.Schemas.tmp}e.$ai=h,e.$bi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$bi}e.$ci=t;function s(i,n){return!y(i,n)&&!h(i)}e.$di=s;function o(i){return(typeof i=="string"?(0,O.$mc)(i):(0,P.$qg)(i))===e.$9h}e.$ei=o}),define(be[33],we([1,0,59,5,2,19,4,197,25,16,6,13,89,26,34,14,23,17,10]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.ProfileResourceType=void 0;var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(c||(e.ProfileResourceType=c={}));function y(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Ek=y,e.$Fk=(0,C.$Lh)("IUserDataProfilesService");function h(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Gk=h;function t(i,n,a,b,p,E){return{id:i,name:n,location:a,isDefault:!1,shortName:p?.shortName,icon:p?.icon,globalStorageHome:E&&p?.useDefaultFlags?.globalState?E.globalStorageHome:(0,P.$sg)(a,"globalStorage"),settingsResource:E&&p?.useDefaultFlags?.settings?E.settingsResource:(0,P.$sg)(a,"settings.json"),keybindingsResource:E&&p?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,P.$sg)(a,"keybindings.json"),tasksResource:E&&p?.useDefaultFlags?.tasks?E.tasksResource:(0,P.$sg)(a,"tasks.json"),snippetsHome:E&&p?.useDefaultFlags?.snippets?E.snippetsHome:(0,P.$sg)(a,"snippets"),extensionsResource:E&&p?.useDefaultFlags?.extensions?E.extensionsResource:(0,P.$sg)(a,"extensions.json"),cacheHome:(0,P.$sg)(b,i),useDefaultFlags:p?.useDefaultFlags,isTransient:p?.transient}}e.$Hk=t;let s=class extends r.$Qc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,b,p){super(),this.t=n,this.u=a,this.w=b,this.y=p,this.f=!0,this.h=this.B(new O.$Ld),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$Ld),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$Ld),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$Ld),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new d.$yc,emptyWindows:new Map},this.profilesHome=(0,P.$sg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$sg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const E of this.O()){if(!E.name||!(0,u.$wf)(E.name)||!E.location){this.y.warn("Skipping the invalid stored profile",E.location||E.name);continue}a.push(t((0,P.$pg)(E.location),E.name,E.location,this.g,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},n))}}catch(E){this.y.error(E)}const b=new d.$yc,p=new Map;if(a.length)try{const E=this.Q();if(E.workspaces)for(const[k,L]of Object.entries(E.workspaces)){const j=A.URI.parse(k),Y=a.find(ce=>ce.id===L);Y&&b.set(j,Y)}if(E.emptyWindows)for(const[k,L]of Object.entries(E.emptyWindows)){const j=a.find(Y=>Y.id===L);j&&p.set(k,j)}}catch(E){this.y.error(E)}this.z={profiles:a,workspaces:b,emptyWindows:p}}return this.z}D(){const n=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",b=new RegExp(`${(0,f.$De)(a)}\\s(\\d+)`);let p=0;for(const k of this.profiles){const L=b.exec(k.name),j=L?parseInt(L[1]):0;p=j>p?j:p}const E=`${a} ${p+1}`;return this.createProfile((0,D.$zi)((0,l.$bg)()).toString(16),E,{transient:!0},n)}async createNamedProfile(n,a,b){return this.createProfile((0,D.$zi)((0,l.$bg)()).toString(16),n,a,b)}async createProfile(n,a,b,p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.F(n,a,b);return p&&await this.setProfileForWorkspace(p,E),E}async F(n,a,b){if(!(0,u.$wf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let p=this.r.get(a);return p||(p=(async()=>{try{const E=this.profiles.find(j=>j.name===a||j.id===n);if(E)return E;const k=t(n,a,(0,P.$sg)(this.profilesHome,n),this.g,b,this.defaultProfile);await this.u.createFolder(k.location);const L=[];return this.j.fire({profile:k,join(j){L.push(j)}}),await m.Promises.settled(L),this.I([k],[],[]),k}finally{this.r.delete(a)}})(),this.r.set(a,p)),p}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(p=>p.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);return b=t(b.id,a.name??b.name,b.location,this.g,{shortName:a.shortName??b.shortName,icon:a.icon===null?void 0:a.icon??b.icon,transient:a.transient??b.isTransient,useDefaultFlags:a.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(p=>p.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const b=[];this.m.fire({profile:a,join(p){b.push(p)}});try{await Promise.allSettled(b)}catch(p){this.y.error(p)}for(const p of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(p)?.id&&this.C.emptyWindows.delete(p);for(const p of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(p)?.id&&this.C.workspaces.delete(p);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(p){(0,$.$kk)(p)!==1&&this.y.error(p)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(p=>p.id===a.id);if(!b)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,b)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return A.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,v.$Vh)(n)?n.uri:(0,v.$1h)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,b){const p=[...this.profiles,...n],E=[];this.s.profiles=[];for(let k of p)k.isDefault||a.some(L=>k.id===L.id)||(k=b.find(L=>k.id===L.id)??k,k.isTransient?this.s.profiles.push(k):E.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(E),this.z=void 0,this.J(n,a,b)}J(n,a,b){this.h.fire({added:n,removed:a,updated:b,all:this.profiles})}L(n,a,b){b=a?.isTransient?!0:b,b||this.L(n,void 0,!0);const p=this.G(n),E=b?this.s:this.C;A.URI.isUri(p)?(E.workspaces.delete(p),a&&E.workspaces.set(p,a)):(E.emptyWindows.delete(p),a&&E.emptyWindows.set(p,a)),b||this.M()}M(){const n={};for(const[b,p]of this.C.workspaces.entries())n[b.toString()]=p.id;const a={};for(const[b,p]of this.C.emptyWindows.entries())a[b.toString()]=p.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},b=this.D();if(n.workspaces)for(const[E,k]of Object.entries(n.workspaces)){const L=A.URI.parse(k);a[E]=this.w.extUri.isEqual(L,b.location)?b.id:this.w.extUri.basename(L)}const p={};if(n.emptyWindows)for(const[E,k]of Object.entries(n.emptyWindows)){const L=A.URI.parse(k);p[E]=this.w.extUri.isEqual(L,b.location)?b.id:this.w.extUri.basename(L)}return{workspaces:a,emptyWindows:p}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Ik=s,e.$Ik=s=Oe([Ae(0,w.$Sh),Ae(1,$.$7j),Ae(2,g.$Dk),Ae(3,S.$6i)],s);class o extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Jk=o}),define(be[255],we([1,0,18,14,20,11,5,2,3,10,4,178,30,37,40,13,31,32,34,33]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=e.$ip=e.$hp=e.$gp=void 0;let y=class extends I.$Qc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,a,b,p,E,k){super(),this.z=n,this.C=a,this.D=b,this.F=p,this.G=E,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Ld),this.s=this.B(new A.$Ld),this.t=this.B(new A.$Ld),this.u=this.B(new A.$Ld),this.w=this.B(new A.$Ld),this.y=[],this.B((0,I.$Oc)(()=>{this.j.forEach(({task:L})=>L.cancel()),this.m.forEach(L=>L.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const a=await this.getTargetPlatform();return n.allTargetPlatforms.some(b=>(0,v.$Xn)(b,n.allTargetPlatforms,a))}async installFromGallery(n,a={}){try{const p=(await this.installGalleryExtensions([{extension:n,options:a}])).find(({identifier:E})=>(0,d.$qo)(E,n.identifier));if(p?.local)return p?.local;throw p?.error?p.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(b){throw t(b)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new v.$2n(S.localize(0,null),v.ExtensionManagementErrorCode.Internal);const a=[],b=[];await Promise.allSettled(n.map(async({extension:p,options:E})=>{try{const k=await this.O(p,!!E?.installGivenVersion,!!E?.installPreReleaseVersion);b.push({...k,options:E})}catch(k){a.push({identifier:p.identifier,operation:2,source:p,error:k})}})),b.length&&a.push(...await this.I(b));for(const p of a)p.error&&(this.F.error("Failed to install extension.",p.identifier.id),this.F.error(p.error),p.source&&!C.URI.isUri(p.source)&&s(this.C,"extensionGallery:install",{extensionData:(0,d.$yo)(p.source),error:p.error}));return a}async uninstall(n,a={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,a)}async toggleAppliationScope(n,a){if((0,g.$Zl)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let b=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)||(b=await this.ab(n,this.H.defaultProfile.extensionsResource,a));for(const p of this.H.profiles){const E=(await this.getInstalled(1,p.extensionsResource)).find(k=>(0,d.$qo)(k.identifier,n.identifier));E?this.w.fire(E):this.u.fire({identifier:n.identifier,profileLocation:p.extensionsResource})}return b}else{const b=this.D.extUri.isEqual(a,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,a,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:b.identifier,operation:2,local:b,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),b}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const a=[];return await Promise.allSettled(n.map(async b=>{try{const p=await this.J(b);a.push(...p)}catch(p){a.push({identifier:{id:(0,d.$vo)(b.manifest.publisher,b.manifest.name)},operation:2,source:b.extension,error:p})}})),this.s.fire(a),a}async J({manifest:n,extension:a,options:b}){const p=b.isApplicationScoped||b.isBuiltin||(0,g.$Zl)(n),E={...b,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(a)?b.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:p,profileLocation:p?this.H.defaultProfile.extensionsResource:b.profileLocation??this.Y()},k=ne=>`${d.$ro.create(ne).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!C.URI.isUri(a)){const ne=this.j.get(k(a));if(ne)return this.F.info("Extensions is already requested to install",a.identifier.id),await ne.task.waitUntilTaskIsFinished(),[]}const L=[],j=[],Y=[],ce=this.Z(n,a,E);C.URI.isUri(a)||this.j.set(k(a),{task:ce,waitingTasks:[]}),this.n.fire({identifier:ce.identifier,source:a,profileLocation:E.profileLocation}),this.F.info("Installing extension:",ce.identifier.id),L.push({task:ce,manifest:n});let x=!1;try{if(E.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",ce.identifier.id);else try{const ue=await this.N(ce.identifier,n,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),_=await this.getInstalled(void 0,E.profileLocation),he={...E,donotIncludePackAndDependencies:!0,context:{...E.context,[v.$Sn]:!0}};for(const{gallery:ee,manifest:te}of(0,D.$Kb)(ue,({gallery:W})=>W.identifier.id)){x=x||!!te.extensionDependencies?.some(V=>(0,d.$qo)({id:V},ce.identifier));const W=k(ee),K=this.j.get(W);if(K){if(this.L(ce,K.task)){const V=K.task.identifier;this.F.info("Waiting for already requested installing extension",V.id,ce.identifier.id),K.waitingTasks.push(ce),j.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,oe=>oe.some(me=>(0,d.$qo)(me.identifier,V)))).then(oe=>{if(this.F.info("Finished waiting for already requested installing extension",V.id,ce.identifier.id),!oe.find(se=>(0,d.$qo)(se.identifier,V))?.local)throw new Error(`Extension ${V.id} is not installed`)}))}}else if(!_.some(({identifier:V})=>(0,d.$qo)(V,ee.identifier))){const V=this.Z(te,ee,he);this.j.set(W,{task:V,waitingTasks:[ce]}),this.n.fire({identifier:V.identifier,source:ee,profileLocation:E.profileLocation}),this.F.info("Installing extension:",V.identifier.id,ce.identifier.id),L.push({task:V,manifest:te})}}}catch(ue){if(C.URI.isUri(ce.source))(0,D.$Jb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",ce.identifier.id,ue.message),(0,D.$Jb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",ce.identifier.id,ue.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",ce.identifier.id),ue}const ne=L.reduce((ue,{task:_,manifest:he})=>(ue.set(_.identifier.id.toLowerCase(),{task:_,manifest:he}),ue),new Map);for(;ne.size;){let ue;const _=[...ne.values()].filter(({manifest:he})=>!he.extensionDependencies?.some(ee=>ne.has(ee.toLowerCase())));_.length?ue=ne.size===1?_:_.filter(({task:he})=>!(he===ce&&!x)):(this.F.info("Found extensions with circular dependencies",_.map(({task:he})=>he.identifier.id)),ue=[...ne.values()]),await this.M(ue.map(async({task:he})=>{const ee=new Date().getTime();try{const te=await he.run();if(await this.M(this.y.map(W=>W.postInstall(te,he.source,E,r.CancellationToken.None))),!C.URI.isUri(he.source)){const W=he.operation===3,K=W?void 0:(new Date().getTime()-he.source.lastUpdated)/1e3;if(s(this.C,W?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$yo)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-ee,durationSinceUpdate:K}),w.$o&&he.operation!==3)try{await this.z.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch{}}Y.push({local:te,identifier:he.identifier,operation:he.operation,source:he.source,context:he.options.context,profileLocation:he.profileLocation,applicationScoped:te.isApplicationScoped})}catch(te){throw C.URI.isUri(he.source)||s(this.C,he.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,d.$yo)(he.source),verificationStatus:he.verificationStatus,duration:new Date().getTime()-ee,error:te}),this.F.error("Error while installing the extension:",he.identifier.id),te}finally{ne.delete(he.identifier.id.toLowerCase())}}))}return j.length&&await this.M(j),Y.forEach(({identifier:ue})=>this.F.info("Extension installed successfully:",ue.id)),Y}catch(ne){if(L.forEach(({task:ue})=>ue.cancel()),Y.length)try{const ue=await Promise.allSettled(Y.map(({local:_})=>this.$(_,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let _=0;_<ue.length;_++){const he=ue[_],{identifier:ee}=Y[_];he.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",ee.id):this.F.warn("Rollback: Error while uninstalling extension",ee.id,(0,P.$8)(he.reason))}}catch(ue){this.F.warn("Error while rolling back extensions",(0,P.$8)(ue),Y.map(({identifier:_})=>_.id))}return L.map(({task:ue})=>({identifier:ue.identifier,operation:2,source:ue.source,context:E.context,profileLocation:E.profileLocation,error:ne}))}finally{for(const{task:ne}of L)ne.source&&!C.URI.isUri(ne.source)&&this.j.delete(k(ne.source))}}L(n,a){for(const[,{task:b,waitingTasks:p}]of this.j.entries())if(b===n&&(p.includes(a)||p.some(E=>this.L(E,a)))||b===a&&p[0]&&!this.L(n,p[0]))return!1;return!0}async M(n){const a=[],b=[],p=await Promise.allSettled(n);for(const E of p)E.status==="fulfilled"?a.push(E.value):b.push(E.reason);if(b.length)throw h(b);return a}async N(n,a,b,p,E){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,E),L=[],j=[],Y=async(ce,x)=>{L.push(ce);const ne=x.extensionDependencies||[],ue=[...ne];if(x.extensionPack){const _=b?k.find(he=>(0,d.$qo)(he.identifier,ce)):void 0;for(const he of x.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(ee=>(0,d.$qo)({id:ee},{id:he}))||ue.every(ee=>!(0,d.$qo)({id:ee},{id:he}))&&ue.push(he)}if(ue.length){const _=ue.filter(he=>L.every(ee=>!(0,d.$qo)(ee,{id:he})));if(_.length){const he=await this.z.getExtensions(_.map(ee=>({id:ee,preRelease:p})),r.CancellationToken.None);for(const ee of he){if(L.find(K=>(0,d.$qo)(K,ee.identifier)))continue;const te=ne.some(K=>(0,d.$qo)({id:K},ee.identifier));let W;try{W=await this.O(ee,!1,p)}catch(K){if(te)throw K;this.F.info("Skipping the packed extension as it cannot be installed",ee.identifier.id,(0,P.$8)(K));continue}j.push({gallery:W.extension,manifest:W.manifest}),await Y(W.extension.identifier,W.manifest)}}}};return await Y(n,a),j}async O(n,a,b){let p;const E=await this.getExtensionsControlManifest();if(E.malicious.some(j=>(0,d.$qo)(n.identifier,j)))throw new v.$2n(S.localize(1,null,n.identifier.id),v.ExtensionManagementErrorCode.Malicious);const k=E.deprecated[n.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),p=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},r.CancellationToken.None))[0],!p)throw new v.$2n(S.localize(2,null,n.identifier.id,k.extension.id),v.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const j=await this.getTargetPlatform();throw new v.$2n(S.localize(3,null,n.identifier.id,this.G.nameLong,(0,v.$Tn)(j)),v.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(p=await this.P(n,a,b),!p)throw!b&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],r.CancellationToken.None))[0]?new v.$2n(S.localize(4,null,n.identifier.id),v.ExtensionManagementErrorCode.ReleaseVersionNotFound):new v.$2n(S.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),v.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",p.identifier.id);const L=await this.z.getManifest(p,r.CancellationToken.None);if(L===null)throw new v.$2n(`Missing manifest for extension ${p.identifier.id}`,v.ExtensionManagementErrorCode.Invalid);if(L.version!==p.version)throw new v.$2n(`Cannot install '${p.identifier.id}' extension because of version mismatch in Marketplace`,v.ExtensionManagementErrorCode.Invalid);return{extension:p,manifest:L}}async P(n,a,b){const p=await this.getTargetPlatform();let E=null;return!a&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==b&&(E=(await this.z.getExtensions([{...n.identifier,preRelease:b}],{targetPlatform:p,compatible:!0},r.CancellationToken.None))[0]||null),!E&&await this.z.isExtensionCompatible(n,b,p)&&(E=n),E||(a?E=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:p,compatible:!0},r.CancellationToken.None))[0]||null:E=await this.z.getCompatibleExtension(n,b,p)),E}async Q(n,a){const b={...a,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},p=ce=>`${ce.id.toLowerCase()}${b.versionOnly?`-${n.manifest.version}`:""}${b.profileLocation?`@${b.profileLocation.toString()}`:""}`,E=this.m.get(p(n.identifier));if(E)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),E.waitUntilTaskIsFinished();const k=ce=>{const x=this.$(ce,b);return this.m.set(p(x.extension.identifier),x),b.profileLocation?this.F.info("Uninstalling extension from the profile:",`${ce.identifier.id}@${ce.manifest.version}`,b.profileLocation.toString()):this.F.info("Uninstalling extension:",`${ce.identifier.id}@${ce.manifest.version}`),this.t.fire({identifier:ce.identifier,profileLocation:b.profileLocation,applicationScoped:ce.isApplicationScoped}),x},L=(ce,x)=>{x?b.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${ce.identifier.id}@${ce.manifest.version}`,b.profileLocation.toString(),x.message):this.F.error("Failed to uninstall extension:",`${ce.identifier.id}@${ce.manifest.version}`,x.message):b.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${ce.identifier.id}@${ce.manifest.version}`,b.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${ce.identifier.id}@${ce.manifest.version}`),s(this.C,"extensionGallery:uninstall",{extensionData:(0,d.$xo)(ce),error:x}),this.u.fire({identifier:ce.identifier,error:x?.code,profileLocation:b.profileLocation,applicationScoped:ce.isApplicationScoped})},j=[],Y=[];try{j.push(k(n));const ce=await this.getInstalled(1,b.profileLocation);if(b.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const x=this.U(n,ce);for(const ne of x)this.m.has(p(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):j.push(k(ne))}b.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(j.map(x=>x.extension),ce,n),await this.M(j.map(async x=>{try{if(await x.run(),await this.M(this.y.map(ne=>ne.postUninstall(x.extension,b,r.CancellationToken.None))),x.extension.identifier.uuid)try{await this.z.reportStatistic(x.extension.manifest.publisher,x.extension.manifest.name,x.extension.manifest.version,"uninstall")}catch{}L(x.extension)}catch(ne){const ue=ne instanceof v.$2n?ne:new v.$2n((0,P.$8)(ne),v.ExtensionManagementErrorCode.Internal);throw L(x.extension,ue),ue}finally{Y.push(x)}}))}catch(ce){const x=ce instanceof v.$2n?ce:new v.$2n((0,P.$8)(ce),v.ExtensionManagementErrorCode.Internal);for(const ne of j){try{ne.cancel()}catch{}Y.includes(ne)||L(ne.extension,x)}throw x}finally{for(const ce of j)this.m.delete(p(ce.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",ce.extension.identifier.id)}}R(n,a,b){for(const p of n){const E=this.W(p,a);if(E.length){const k=E.filter(L=>!n.some(j=>(0,d.$qo)(j.identifier,L.identifier)));if(k.length)throw new Error(this.S(p,k,b))}}}S(n,a,b){return b===n?a.length===1?S.localize(6,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?S.localize(7,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):S.localize(8,null,b.manifest.displayName||b.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):a.length===1?S.localize(9,null,b.manifest.displayName||b.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name):a.length===2?S.localize(10,null,b.manifest.displayName||b.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name):S.localize(11,null,b.manifest.displayName||b.manifest.name,n.manifest.displayName||n.manifest.name,a[0].manifest.displayName||a[0].manifest.name,a[1].manifest.displayName||a[1].manifest.name)}U(n,a,b=[]){if(b.indexOf(n)!==-1)return[];b.push(n);const p=n.manifest.extensionPack?n.manifest.extensionPack:[];if(p.length){const E=a.filter(L=>!L.isBuiltin&&p.some(j=>(0,d.$qo)({id:j},L.identifier))),k=[];for(const L of E)k.push(...this.U(L,a,b));return[...E,...k]}return[]}W(n,a){return a.filter(b=>b.manifest.extensionDependencies&&b.manifest.extensionDependencies.some(p=>(0,d.$qo)({id:p},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$gp=y,e.$gp=y=Oe([Ae(0,v.$1n),Ae(1,f.$0k),Ae(2,u.$Dk),Ae(3,m.$6i),Ae(4,l.$lj),Ae(5,c.$Fk)],y);function h(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((a,b)=>new Error(`${a.message}${a.message?",":""}${b instanceof Error?b.message:b}`),new Error(""))}e.$hp=h;function t(i){if(i instanceof v.$2n)return i;const n=new v.$2n(i.message,v.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$ip=t;function s(i,n,{extensionData:a,verificationStatus:b,duration:p,error:E,durationSinceUpdate:k}){let L,j;(0,$.$Ef)(b)&&(b===!0?b="Verified":(b===!1||(L=v.ExtensionManagementErrorCode.Signature,j=b),b="Unverified")),E&&(E instanceof v.$2n?(L=E.code,E.code===v.ExtensionManagementErrorCode.Signature&&(j=E.message)):L=v.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...a,verificationStatus:b,success:!E,duration:p,errorcode:L,errorcodeDetail:j,durationSinceUpdate:k})}class o{constructor(){this.d=new O.$Pg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,O.$Eg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$Eg)(n=>new Promise((a,b)=>{const p=n.onCancellationRequested(()=>{p.dispose(),b(new P.$3)})})),this.d.open()),this.g.cancel()}}e.$jp=o}),define(be[45],we([1,0,14,15,2,5,26,4,30,37,16,6,13,33,34,10,11,32]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=e.$lp=e.$kp=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class c extends Error{constructor(o,i){super(o),this.code=i}}e.$kp=c,e.$lp=(0,S.$Lh)("IExtensionsProfileScannerService");let y=class extends r.$Qc{constructor(o,i,n,a,b,p){super(),this.j=o,this.m=i,this.n=n,this.r=a,this.s=b,this.t=p,this.b=this.B(new P.$Ld),this.onAddExtensions=this.b.event,this.c=this.B(new P.$Ld),this.onDidAddExtensions=this.c.event,this.f=this.B(new P.$Ld),this.onRemoveExtensions=this.f.event,this.g=this.B(new P.$Ld),this.onDidRemoveExtensions=this.g.event,this.h=new A.$yc}scanProfileExtensions(o,i){return this.u(o,void 0,i)}async addExtensionsToProfile(o,i){const n=[],a=[];try{return await this.u(i,b=>{const p=[];for(const E of b)o.some(([k])=>(0,$.$qo)(k.identifier,E.identifier)&&k.manifest.version!==E.version)?n.push(E):p.push(E);for(const[E,k]of o){const L=p.findIndex(Y=>(0,$.$qo)(Y.identifier,E.identifier)&&Y.version===E.manifest.version),j={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:k};L===-1?(a.push(j),p.push(j)):p.splice(L,1,j)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),p}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:b,profileLocation:i}),b}}async updateMetadata(o,i){const n=[];return await this.u(i,a=>{const b=[];for(const p of a){const E=o.find(([k])=>(0,$.$qo)(k.identifier,p.identifier)&&k.manifest.version===p.version);E&&(p.metadata={...p.metadata,...E[1]},n.push(p)),b.push(p)}return b}),n}async removeExtensionFromProfile(o,i){const n=[];try{await this.u(i,a=>{const b=[];for(const p of a)(0,$.$qo)(p.identifier,o.identifier)?n.push(p):b.push(p);return n.length&&this.f.fire({extensions:n,profileLocation:i}),b}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(o,i,n){return this.F(o).queue(async()=>{let a=[],b;try{const p=await this.m.readFile(o);b=JSON.parse(p.value.toString().trim()||"[]")}catch(p){if((0,C.$kk)(p)!==1)throw p;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&n?.bailOutWhenFileNotFound)throw new c((0,l.$8)(p),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(o);let p=!1;for(const E of b){h(E)||this.w(o);let k;if((0,m.$wf)(E.relativeLocation)&&E.relativeLocation)k=this.z(E.relativeLocation);else if((0,m.$wf)(E.location))k=this.z(E.location),p=!0,E.relativeLocation=E.location,E.location=k.toJSON();else{k=I.URI.revive(E.location);const L=this.y(k);L&&(p=!0,E.relativeLocation=L)}a.push({identifier:E.identifier,location:k,version:E.version,metadata:E.metadata})}p&&await this.m.writeFile(o,O.$_d.fromString(JSON.stringify(b)))}if(i){a=i(a);const p=a.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.y(E.location),metadata:E.metadata}));await this.m.writeFile(o,O.$_d.fromString(JSON.stringify(p)))}return a})}w(o){const i=new c(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(b){if((0,C.$kk)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const b=JSON.parse(n);Array.isArray(b)&&b.every(p=>h(p))?a=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$_d.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,C.$kk)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(o)}catch(b){(0,C.$kk)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,C.$kk)(b)!==1&&this.t.error(b)}return a})()),this.C}F(o){let i=this.h.get(o);return i||(i=new D.$Xg,this.h.set(o,i)),i}};e.$mp=y,e.$mp=y=Oe([Ae(1,C.$7j),Ae(2,d.$Fk),Ae(3,g.$Dk),Ae(4,f.$0k),Ae(5,v.$6i)],y);function h(s){return(0,m.$yf)(s)&&(0,w.$Zn)(s.identifier)&&(t(s.location)||(0,m.$wf)(s.location)&&s.location)&&((0,m.$Df)(s.relativeLocation)||(0,m.$wf)(s.relativeLocation))&&s.version&&(0,m.$wf)(s.version)}function t(s){return s?(0,m.$wf)(s.path)&&(0,m.$wf)(s.scheme):!1}}),define(be[57],we([1,0,18,14,22,15,11,75,162,2,12,7,3,19,53,60,10,4,182,25,37,40,79,16,6,13,31,5,50,45,33,34,212]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t,s,o,i,n,a,b,p,E,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.Translations=void 0;var j;(function(he){function ee(te,W){if(te===W)return!0;const K=Object.keys(te),V=new Set;for(const oe of Object.keys(W))V.add(oe);if(K.length!==V.size)return!1;for(const oe of K){if(te[oe]!==W[oe])return!1;V.delete(oe)}return V.size===0}he.equals=ee})(j||(e.Translations=j={})),e.$pp=(0,o.$Lh)("IExtensionsScannerService");let Y=class extends $.$Qc{constructor(ee,te,W,K,V,oe,me,se,U,Z,R,F){super(),this.systemExtensionsLocation=ee,this.userExtensionsLocation=te,this.r=W,this.s=K,this.t=V,this.u=oe,this.w=me,this.y=se,this.z=U,this.C=Z,this.D=R,this.F=F,this.g=this.B(new a.$Ld),this.onDidChangeCache=this.g.event,this.h=(0,d.$sg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(x,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Bo)(this.w,this.y)),this.G}async scanAllExtensions(ee,te,W){const[K,V]=await Promise.all([this.scanSystemExtensions(ee),this.scanUserExtensions(te)]),oe=W?await this.scanExtensionsUnderDevelopment(ee,[...K,...V]):[];return this.L(K,V,oe,await this.getTargetPlatform(),!0)}async scanSystemExtensions(ee){const te=[];te.push(this.M(!!ee.useCache,ee.language)),te.push(this.N(ee.language,!!ee.checkControlFile));const[W,K]=await Promise.all(te);return this.J([...W,...K],0,ee,!1)}async scanUserExtensions(ee){const te=ee.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",te);const W=this.D.extUri.isEqual(ee.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,K=await this.P(te,!!ee.profileLocation,1,!ee.includeUninstalled,ee.language,!0,W),V=ee.useCache&&!K.devMode&&K.excludeObsolete?this.m:this.n;let oe;try{oe=await V.scanExtensions(K)}catch(me){if(me instanceof p.$kp&&me.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),oe=await V.scanExtensions(K);else throw me}return oe=await this.J(oe,1,ee,!0),this.y.trace("Scanned user extensions:",oe.length),oe}async scanExtensionsUnderDevelopment(ee,te){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(K=>K.scheme===C.Schemas.file).map(async K=>{const V=await this.P(K,!1,1,!0,ee.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(me=>(me.type=te.find(se=>(0,y.$qo)(se.identifier,me.identifier))?.type??me.type,this.n.validate(me,V)))}))).flat();return this.J(W,"development",ee,!0)}return[]}async scanExistingExtension(ee,te,W){const K=await this.P(ee,!1,te,!0,W.language,!0,void 0),V=await this.n.scanExtension(K);return!V||!W.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(ee,te,W){const K=await this.P(ee,!1,te,!0,W.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(K);return this.J(V,te,W,!0)}async scanMetadata(ee){const te=(0,d.$sg)(ee,"package.json"),W=(await this.w.readFile(te)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(ee,te){const W=(0,d.$sg)(ee,"package.json"),K=(await this.w.readFile(W)).value.toString(),V=JSON.parse(K);te.isMachineScoped=te.isMachineScoped||void 0,te.isBuiltin=te.isBuiltin||void 0,V.__metadata={...V.__metadata,...te},await this.w.writeFile((0,d.$sg)(ee,"package.json"),P.$_d.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(ee){if(ee instanceof p.$kp&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw ee}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const ee=await this.scanUserExtensions({includeInvalid:!0});if(ee.length)await this.u.addExtensionsToProfile(ee.map(te=>[te,te.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,P.$_d.fromString(JSON.stringify([])))}catch(te){(0,s.$kk)(te)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$8)(te))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(ee){this.y.error(ee)}finally{this.H=void 0}})()),this.H}async J(ee,te,W,K){return W.includeAllVersions||(ee=this.L(te===0?ee:void 0,te===1?ee:void 0,te==="development"?ee:void 0,await this.getTargetPlatform(),K)),W.includeInvalid||(ee=ee.filter(V=>V.isValid)),ee.sort((V,oe)=>{const me=S.$lc(V.location.fsPath),se=S.$lc(oe.location.fsPath);return me<se?-1:me>se?1:0})}L(ee,te,W,K,V){const oe=(se,U,Z)=>{if(se.isValid&&!U.isValid)return!1;if(se.isValid===U.isValid){if(V&&g.gt(se.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(g.eq(se.manifest.version,U.manifest.version)){if(se.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===K)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return Z?this.y.warn(`Overwriting user extension ${se.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${U.location.path}.`),!0},me=new h.$Yl;return ee?.forEach(se=>{const U=me.get(se.identifier.id);(!U||oe(U,se,!1))&&me.set(se.identifier.id,se)}),te?.forEach(se=>{const U=me.get(se.identifier.id);if(!U&&ee&&se.type===0){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!U||oe(U,se,!1))&&me.set(se.identifier.id,se)}),W?.forEach(se=>{const U=me.get(se.identifier.id);(!U||oe(U,se,!0))&&me.set(se.identifier.id,se),me.set(se.identifier.id,se)}),[...me.values()]}async M(ee,te){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,te,!0,void 0),V=await(ee&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",V.length),V}async N(ee,te){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const K=te?await this.O():{},V=[],oe=f.URI.file(S.$fc(S.$hc(C.$_f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of W){const U=K[se.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":V.push((0,d.$sg)(oe,se.name));break;default:V.push(f.URI.file(U));break}}const me=await Promise.all(V.map(async se=>this.n.scanExtension(await this.P(se,!1,0,!0,ee,!0,void 0))));return this.y.trace("Scanned dev system extensions:",me.length),(0,D.$Fb)(me)}async O(){try{const ee=await this.w.readFile(this.r);return JSON.parse(ee.value.toString())}catch{return{}}}async P(ee,te,W,K,V,oe,me){const se=await this.f(V??v.$v),U=await this.Q(ee),Z=te&&!this.D.extUri.isEqual(ee,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=Z?await this.Q(Z):void 0;return new ce(ee,U,Z,R,te,me,W,K,oe,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,se)}async Q(ee){try{const te=await this.w.stat(ee);if(typeof te.mtime=="number")return te.mtime}catch{}}};e.$qp=Y,e.$qp=Y=Oe([Ae(4,E.$Fk),Ae(5,p.$lp),Ae(6,s.$7j),Ae(7,i.$6i),Ae(8,c.$Sh),Ae(9,n.$lj),Ae(10,k.$Dk),Ae(11,o.$Kh)],Y);class ce{constructor(ee,te,W,K,V,oe,me,se,U,Z,R,F,G,T,q){this.location=ee,this.mtime=te,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=K,this.profile=V,this.profileScanOptions=oe,this.type=me,this.excludeObsolete=se,this.validate=U,this.productVersion=Z,this.productDate=R,this.productCommit=F,this.devMode=G,this.language=T,this.translations=q}static createNlsConfiguration(ee){return{language:ee.language,pseudo:ee.language==="pseudo",devMode:ee.devMode,translations:ee.translations}}static equals(ee,te){return(0,d.$lg)(ee.location,te.location)&&ee.mtime===te.mtime&&(0,d.$lg)(ee.applicationExtensionslocation,te.applicationExtensionslocation)&&ee.applicationExtensionslocationMtime===te.applicationExtensionslocationMtime&&ee.profile===te.profile&&r.$1m(ee.profileScanOptions,te.profileScanOptions)&&ee.type===te.type&&ee.excludeObsolete===te.excludeObsolete&&ee.validate===te.validate&&ee.productVersion===te.productVersion&&ee.productDate===te.productDate&&ee.productCommit===te.productCommit&&ee.devMode===te.devMode&&ee.language===te.language&&j.equals(ee.translations,te.translations)}}e.$rp=ce;let x=class extends $.$Qc{constructor(ee,te,W,K,V){super(),this.f=ee,this.g=te,this.h=W,this.j=K,this.m=V}async scanExtensions(ee){const te=ee.profile?await this.r(ee):await this.n(ee);let W={};if(ee.excludeObsolete&&ee.type===1)try{const K=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(K)}catch{}return(0,l.$Jf)(W)?te:te.filter(K=>!W[y.$ro.create(K).toString()])}async n(ee){const te=await this.j.resolve(ee.location);if(!te.children?.length)return[];const W=await Promise.all(te.children.map(async K=>{if(!K.isDirectory||ee.type===1&&(0,d.$pg)(K.resource).indexOf(".")===0)return null;const V=new ce(K.resource,ee.mtime,ee.applicationExtensionslocation,ee.applicationExtensionslocationMtime,ee.profile,ee.profileScanOptions,ee.type,ee.excludeObsolete,ee.validate,ee.productVersion,ee.productDate,ee.productCommit,ee.devMode,ee.language,ee.translations);return this.scanExtension(V)}));return(0,D.$Fb)(W).sort((K,V)=>K.location.path<V.location.path?-1:1)}async r(ee){let te=await this.s(ee.location,()=>!0,ee);if(ee.applicationExtensionslocation&&!this.h.extUri.isEqual(ee.location,ee.applicationExtensionslocation)){te=te.filter(K=>!K.metadata?.isApplicationScoped);const W=await this.s(ee.applicationExtensionslocation,K=>!!K.metadata?.isBuiltin||!!K.metadata?.isApplicationScoped,ee);te.push(...W)}return te}async s(ee,te,W){const K=await this.g.scanProfileExtensions(ee,W.profileScanOptions);if(!K.length)return[];const V=await Promise.all(K.map(async oe=>{if(te(oe)){const me=new ce(oe.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(me,oe.metadata)}return null}));return(0,D.$Fb)(V)}async scanOneOrMultipleExtensions(ee){try{if(await this.j.exists((0,d.$sg)(ee.location,"package.json"))){const te=await this.scanExtension(ee);return te?[te]:[]}else return await this.scanExtensions(ee)}catch(te){return this.m.error(`Error scanning extensions at ${ee.location.path}:`,(0,A.$8)(te)),[]}}async scanExtension(ee,te){try{let W=await this.scanExtensionManifest(ee.location);if(W){W.publisher||(W.publisher=h.$Sl),te=te??W.__metadata,delete W.__metadata;const K=(0,y.$vo)(W.publisher,W.name),V=te?.id?{id:K,uuid:te.id}:{id:K},oe=te?.isSystem?0:ee.type,me=oe===0||!!te?.isBuiltin;W=await this.t(ee.location,W,ce.createNlsConfiguration(ee));const se={type:oe,identifier:V,manifest:W,location:ee.location,isBuiltin:me,targetPlatform:te?.targetPlatform??"undefined",metadata:te,isValid:!0,validations:[]};return ee.validate?this.validate(se,ee):se}}catch(W){ee.type!==0&&this.m.error(W)}return null}validate(ee,te){let W=!0;const K=(0,t.$Go)(te.productVersion,te.productDate,te.location,ee.manifest,ee.isBuiltin);for(const[V,oe]of K)V===m.default.Error&&(W=!1,this.m.error(this.z(te.location,oe)));return ee.isValid=W,ee.validations=K,ee}async scanExtensionManifest(ee){const te=(0,d.$sg)(ee,"package.json");let W;try{W=(await this.j.readFile(te)).value.toString()}catch(V){return(0,s.$kk)(V)!==1&&this.m.error(this.z(ee,(0,u.localize)(0,null,te.path,V.message))),null}let K;try{K=JSON.parse(W)}catch{const oe=[];(0,I.$Mm)(W,oe);for(const me of oe)this.m.error(this.z(ee,(0,u.localize)(1,null,te.path,me.offset,me.length,(0,w.$np)(me.error))));return null}return(0,I.$Vm)(K)!=="object"?(this.m.error(this.z(ee,(0,u.localize)(2,null,te.path))),null):K}async t(ee,te,W){const K=await this.u(ee,te,W);if(K)try{const V=[],oe=await this.w(K.default,V);if(V.length>0)return V.forEach(se=>{this.m.error(this.z(ee,(0,u.localize)(3,null,K.default?.path,(0,w.$np)(se.error))))}),te;if((0,I.$Vm)(K)!=="object")return this.m.error(this.z(ee,(0,u.localize)(4,null,K.default?.path))),te;const me=K.values||Object.create(null);return(0,L.$op)(this.m,te,me,oe)}catch{}return te}async u(ee,te,W){const K=(0,d.$sg)(ee,"package.nls.json"),V=(U,Z)=>{Z.forEach(R=>{this.m.error(this.z(ee,(0,u.localize)(5,null,U?.path,(0,w.$np)(R.error))))})},oe=U=>{this.m.error(this.z(ee,(0,u.localize)(6,null,U?.path)))},me=`${te.publisher}.${te.name}`,se=W.translations[me];if(se)try{const U=f.URI.file(se),Z=(await this.j.readFile(U)).value.toString(),R=[],F=(0,I.$Mm)(Z,R);return R.length>0?(V(U,R),{values:void 0,default:K}):(0,I.$Vm)(F)!=="object"?(oe(U),{values:void 0,default:K}):{values:F.contents?F.contents.package:void 0,default:K}}catch{return{values:void 0,default:K}}else{if(!await this.j.exists(K))return;let Z;try{Z=await this.y(ee,W)}catch{return}if(!Z.localized)return{values:void 0,default:Z.original};try{const R=(await this.j.readFile(Z.localized)).value.toString(),F=[],G=(0,I.$Mm)(R,F);return F.length>0?(V(Z.localized,F),{values:void 0,default:Z.original}):(0,I.$Vm)(G)!=="object"?(oe(Z.localized),{values:void 0,default:Z.original}):{values:G,default:Z.original}}catch{return{values:void 0,default:Z.original}}}}async w(ee,te){if(ee)try{const W=(await this.j.readFile(ee)).value.toString();return(0,I.$Mm)(W,te)}catch{}}y(ee,te){return new Promise((W,K)=>{const V=oe=>{const me=(0,d.$sg)(ee,`package.nls.${oe}.json`);this.j.exists(me).then(se=>{se&&W({localized:me,original:(0,d.$sg)(ee,"package.nls.json")});const U=oe.lastIndexOf("-");U===-1?W({localized:(0,d.$sg)(ee,"package.nls.json"),original:null}):(oe=oe.substring(0,U),V(oe))})};if(te.devMode||te.pseudo||!te.language)return W({localized:(0,d.$sg)(ee,"package.nls.json"),original:null});V(te.language)})}z(ee,te){return`[${ee.path}]: ${te}`}};x=Oe([Ae(1,p.$lp),Ae(2,k.$Dk),Ae(3,s.$7j),Ae(4,i.$6i)],x);let ne=class extends x{constructor(ee,te,W,K,V,oe,me){super(te,K,V,oe,me),this.G=ee,this.H=W,this.D=this.B(new O.$Og(3e3)),this.F=this.B(new a.$Ld),this.onDidChangeCache=this.F.event}async scanExtensions(ee){const te=this.M(ee),W=await this.I(te);if(this.C=ee,W&&W.input&&ce.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",ee.location.toString()),this.D.trigger(()=>this.L()),W.result.map(V=>(V.location=f.URI.revive(V.location),V));const K=await super.scanExtensions(ee);return await this.J(te,{input:ee,result:K}),K}async I(ee){try{const te=await this.j.readFile(ee),W=JSON.parse(te.value.toString());return{result:W.result,input:(0,b.$ih)(W.input)}}catch(te){this.m.debug("Error while reading the extension cache file:",ee.path,(0,A.$8)(te))}return null}async J(ee,te){try{await this.j.writeFile(ee,P.$_d.fromString(JSON.stringify(te)))}catch(W){this.m.debug("Error while writing the extension cache file:",ee.path,(0,A.$8)(W))}}async L(){if(!this.C)return;const ee=this.M(this.C),te=await this.I(ee);if(!te)return;const W=te.result,K=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!r.$1m(K,W))try{this.m.info("Invalidating Cache",W,K),await this.j.del(ee),this.F.fire()}catch(V){this.m.error(V)}}M(ee){const te=this.N(ee);return this.h.extUri.joinPath(te.cacheHome,ee.type===0?h.$Rl:h.$Ql)}N(ee){return ee.type===0?this.H.defaultProfile:ee.profile?this.h.extUri.isEqual(ee.location,this.G.extensionsResource)?this.G:this.H.profiles.find(te=>this.h.extUri.isEqual(ee.location,te.extensionsResource))??this.G:this.H.defaultProfile}};ne=Oe([Ae(2,E.$Fk),Ae(3,p.$lp),Ae(4,k.$Dk),Ae(5,s.$7j),Ae(6,i.$6i)],ne);function ue(he,ee){const te=(0,y.$to)(he.manifest.publisher,he.manifest.name);return{id:te,identifier:new h.$Wl(te),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:ee,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.$sp=ue;class _ extends Y{constructor(ee,te,W,K,V,oe,me,se,U,Z,R,F){super(ee,te,(0,d.$sg)(W,".vscode-oss-dev","extensions","control.json"),K,V,oe,me,se,U,Z,R,F),this.R=(async()=>{if(v.$y)try{const G=await this.w.readFile(f.URI.file(v.$y));return JSON.parse(G.value.toString())}catch{}return Object.create(null)})()}f(ee){return this.R}}e.$tp=_}),define(be[256],we([1,0,52,14,38,5,2,12,7,21,13,33]),function(le,e,D,O,r,P,A,I,w,$,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=void 0;let v=class extends A.$Qc{constructor(g,m){super(),this.b=g,this.f=m,this.a=new O.$Wg(5)}async postUninstall(g){const m=this.g(g,"uninstall");m&&(this.f.info(g.identifier.id,g.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(m.script,"uninstall",m.args,!0,g),this.f.info("Finished running post uninstall script",g.identifier.id,g.manifest.version)}catch(l){this.f.error("Failed to run post uninstall script",g.identifier.id,g.manifest.version),this.f.error(l)}}));try{await $.Promises.rm(this.m(g))}catch(l){this.f.error("Error while removing extension storage path",g.identifier.id),this.f.error(l)}}g(g,m){const l=`vscode:${m}`;if(g.location.scheme===I.Schemas.file&&g.manifest&&g.manifest.scripts&&typeof g.manifest.scripts[l]=="string"){const f=g.manifest.scripts[l].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(g.identifier.id,g.manifest.version,`${l} should be a node script`),null):{script:(0,w.$hc)(g.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(g,m,l,f,u){return new Promise((c,y)=>{const h=this.j(g,m,l,u);let t;const s=o=>{t&&(clearTimeout(t),t=null),o?y(o):c(void 0)};h.on("error",o=>{s((0,r.$wi)(o)||"Unknown")}),h.on("exit",(o,i)=>{s(o?`post-${m} process exited with code ${o}`:void 0)}),f&&(t=setTimeout(()=>{t=null,h.kill(),y("timed out")},5e3))})}j(g,m,l,f){const u={silent:!0,execArgv:void 0},c=(0,D.fork)(g,[`--type=extension-post-${m}`,...l],u);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const y=P.Event.fromNodeEventEmitter(c.stdout,"data"),h=P.Event.fromNodeEventEmitter(c.stderr,"data");y(o=>this.f.info(f.identifier.id,f.manifest.version,`post-${m}`,o)),h(o=>this.f.error(f.identifier.id,f.manifest.version,`post-${m}`,o));const t=P.Event.any(P.Event.map(y,o=>({data:`%c${o}`,format:[""]})),P.Event.map(h,o=>({data:`%c${o}`,format:["color: red"]})));return P.Event.debounce(t,(o,i)=>o?{data:o.data+i.data,format:[...o.format,...i.format]}:{data:i.data,format:i.format},100)(o=>{console.group(f.identifier.id),console.log(o.data,...o.format),console.groupEnd()}),c}m(g){return(0,w.$hc)(this.b.defaultProfile.globalStorageHome.fsPath,g.identifier.id.toLowerCase())}};e.$vp=v,e.$vp=v=Oe([Ae(0,S.$Fk),Ae(1,C.$6i)],v)}),define(be[124],we([1,0,13,33,34,32,45,16,25,4]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=void 0;let C=class extends A.$mp{constructor(v,d,g,m,l,f){super($.URI.file(v.extensionsPath),d,g,m,l,f)}};e.$sN=C,e.$sN=C=Oe([Ae(0,w.$Th),Ae(1,I.$7j),Ae(2,O.$Fk),Ae(3,r.$Dk),Ae(4,P.$0k),Ae(5,D.$6i)],C)}),define(be[257],we([1,0,14,5,2,41,10,169,6,33]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Wo=e.$Vo=e.$Uo=void 0,e.$Uo="__$__isNewStorageMarker",e.$Vo="__$__targetStorageMarker",e.$Wo=(0,w.$Lh)("storageService");var C;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function d(u){const c=u.get(e.$Vo);if(c)try{return JSON.parse(c)}catch{}return Object.create(null)}e.$Xo=d;class g extends r.$Qc{static{this.a=60*1e3}constructor(c={flushInterval:g.a}){super(),this.m=c,this.b=this.B(new O.$Od),this.c=this.B(new O.$Od),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$Ld),this.onWillSaveState=this.f.event,this.h=this.B(new D.$3g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new r.$Rc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(c,y,h){return O.Event.filter(this.b.event,t=>t.scope===c&&(y===void 0||t.key===y),h)}n(){this.j.value=(0,D.$7g)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,r.$Lc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(c,y){const{key:h,external:t}=y;if(h===e.$Vo){switch(c){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:c})}else this.b.fire({scope:c,key:h,target:this.J(c)[h],external:t})}w(c){this.f.fire({reason:c})}get(c,y,h){return this.P(y)?.get(c,h)}getBoolean(c,y,h){return this.P(y)?.getBoolean(c,h)}getNumber(c,y,h){return this.P(y)?.getNumber(c,h)}getObject(c,y,h){return this.P(y)?.getObject(c,h)}storeAll(c,y){this.y(()=>{for(const h of c)this.store(h.key,h.value,h.scope,h.target,y)})}store(c,y,h,t,s=!1){if((0,A.$Ff)(y)){this.remove(c,h,s);return}this.y(()=>{this.z(c,h,t),this.P(h)?.set(c,y,s)})}remove(c,y,h=!1){this.y(()=>{this.z(c,y,void 0),this.P(y)?.delete(c,h)})}y(c){this.b.pause(),this.c.pause();try{c()}finally{this.b.resume(),this.c.resume()}}keys(c,y){const h=[],t=this.J(c);for(const s of Object.keys(t))t[s]===y&&h.push(s);return h}z(c,y,h,t=!1){const s=this.J(y);typeof h=="number"?s[c]!==h&&(s[c]=h,this.P(y)?.set(e.$Vo,JSON.stringify(s),t)):typeof s[c]=="number"&&(delete s[c],this.P(y)?.set(e.$Vo,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(c){switch(c){case-1:return this.I;case 0:return this.G;default:return this.D}}L(c){const y=this.P(c);return y?d(y):Object.create(null)}isNew(c){return this.getBoolean(e.$Uo,c)===!0}async flush(c=C.NONE){this.f.fire({reason:c});const y=this.P(-1),h=this.P(0),t=this.P(1);switch(c){case C.NONE:await D.Promises.settled([y?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([y?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.P(-1)?.items??new Map,y=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return f(c,y,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(c){return await this.flush(),this.P(c)?.optimize()}async switch(c,y){return this.w(C.NONE),(0,$.$Ek)(c)?this.R(c,y):this.S(c,y)}M(c,y){return!(c.id===y.id||m(y)&&m(c))}N(c,y,h){this.y(()=>{const t=new Set;for(const[s,o]of c)t.add(s),y.get(s)!==o&&this.u(h,{key:s,external:!0});for(const[s]of y.items)t.has(s)||this.u(h,{key:s,external:!0})})}}e.$Yo=g;function m(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$Zo=m;class l extends g{constructor(){super(),this.U=this.B(new I.$So(new I.$To,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$So(new I.$To,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$So(new I.$To,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(c=>this.u(1,c))),this.B(this.W.onDidChangeStorage(c=>this.u(0,c))),this.B(this.U.onDidChangeStorage(c=>this.u(-1,c)))}P(c){switch(c){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(c){return!1}}e.$1o=l;async function f(u,c,y,h,t,s){const o=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;u.forEach((j,Y)=>{i.set(Y,j),n.set(Y,o(j))});const a=new Map,b=new Map;c.forEach((j,Y)=>{a.set(Y,j),b.set(Y,o(j))});const p=new Map,E=new Map;y.forEach((j,Y)=>{p.set(Y,j),E.set(Y,o(j))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const k=[];if(i.forEach((j,Y)=>{k.push({key:Y,value:j})}),console.table(k),console.groupEnd(),console.log(n),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];a.forEach((Y,ce)=>{j.push({key:ce,value:Y})}),console.table(j),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${s})`);const L=[];p.forEach((j,Y)=>{L.push({key:Y,value:j})}),console.table(L),console.groupEnd(),console.log(E)}e.$2o=f}),define(be[125],we([1,0,18,20,11,3,29,10,4,24,25,30,37,79,16,13,31,44,241,257,32,58]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7o=e.$6o=e.$5o=void 0;const t=P.$o?"web":(0,S.$Vn)(P.$t,A.$cc),s="X-Market-Search-Activity-Id";var o;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function i(...R){return String(R.reduce((F,G)=>F|G,0))}var n;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},b={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class k{constructor(F=E){this.d=F}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(F,G=this.d.pageSize){return new k({...this.d,pageNumber:F,pageSize:G})}withFilter(F,...G){const T=[...this.d.criteria,...G.length?G.map(q=>({filterType:F,value:q})):[{filterType:F}]];return new k({...this.d,criteria:T})}withSortBy(F){return new k({...this.d,sortBy:F})}withSortOrder(F){return new k({...this.d,sortOrder:F})}withFlags(...F){return new k({...this.d,flags:F.reduce((G,T)=>G|T,0)})}withAssetTypes(...F){return new k({...this.d,assetTypes:F})}withSource(F){return new k({...this.d,source:F})}get raw(){const{criteria:F,pageNumber:G,pageSize:T,sortBy:q,sortOrder:z,flags:ie,assetTypes:B}=this.d;return{filters:[{criteria:F,pageNumber:G,pageSize:T,sortBy:q,sortOrder:z}],assetTypes:B,flags:ie}}get searchText(){const F=this.d.criteria.filter(G=>G.filterType===n.SearchText)[0];return F&&F.value?F.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(F=>String(F.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(R,F){const G=(R||[]).filter(T=>T.statisticName===F)[0];return G?G.value:0}function j(R){const F="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(T=>T.assetType.indexOf(F)===0).reduce((T,q)=>{const z=x(R,q.assetType);return z&&T.push([q.assetType.substring(F.length),z]),T},[])}function Y(R){if(R.properties){const F=R.properties.filter(q=>q.key===a.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),T=F.filter(q=>G.test(q.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return x(R,a.Repository)}function ce(R){return{uri:`${R.fallbackAssetUri}/${a.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${a.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function x(R,F){return R.files.filter(T=>T.assetType===F)[0]?{uri:`${R.assetUri}/${F}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${F}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ne(R,F){const G=R.properties?R.properties.filter(q=>q.key===F):[],T=G.length>0&&G[0].value;return T?T.split(",").map(q=>(0,v.$uo)(q)):[]}function ue(R){const F=R.properties?R.properties.filter(G=>G.key===b.Engine):[];return F.length>0&&F[0].value||""}function _(R){const F=R.properties?R.properties.filter(G=>G.key===b.PreRelease):[];return F.length>0&&F[0].value==="true"}function he(R){const F=R.properties?R.properties.filter(T=>T.key===b.LocalizedLanguages):[],G=F.length>0&&F[0].value||"";return G?G.split(","):[]}function ee(R){return R.properties?.find(F=>F.key===b.SponsorLink)?.value}function te(R){return R.indexOf("preview")!==-1}function W(R){return R.targetPlatform?(0,S.$Un)(R.targetPlatform):"undefined"}function K(R){const F=(0,D.$Kb)(R.versions.map(W)),G=!!R.tags?.includes(S.$Pn),T=F.indexOf("web");return G?T===-1&&F.push("web"):T!==-1&&F.splice(T,1),F}function V(R,F){const G=(0,S.$Yn)(F);for(let T=0;T<R.length;T++){const q=R[T];if(q.version===R[T-1]?.version){let z=T;const ie=W(q);if(ie===F)for(;z>0&&R[z-1].version===q.version;)z--;else if(G.includes(ie))for(;z>0&&R[z-1].version===q.version&&W(R[z-1])!==F;)z--;z!==T&&(R.splice(T,1),R.splice(z,0,q))}}return R}e.$5o=V;function oe(R,F,G){R.telemetryData={index:F,querySource:G,queryActivityId:R.queryContext?.[s]}}function me(R,F,G,T){const q=R.versions[0],z={manifest:x(F,a.Manifest),readme:x(F,a.Details),changelog:x(F,a.Changelog),license:x(F,a.License),repository:Y(F),download:ce(F),icon:x(F,a.Icon),signature:x(F,a.Signature),coreTranslations:j(F)};return{identifier:{id:(0,v.$vo)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:F.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:ee(q),description:R.shortDescription||"",installCount:L(R.statistics,"install"),rating:L(R.statistics,"averagerating"),ratingCount:L(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:G,assets:z,properties:{dependencies:ne(F,b.Dependency),extensionPack:ne(F,b.ExtensionPack),engine:ue(F),localizedLanguages:he(F),targetPlatform:W(F),isPreReleaseVersion:_(F)},hasPreReleaseVersion:_(q),hasReleaseVersion:!0,preview:te(R.flags),isSigned:!!z.signature,queryContext:T}}let se=class{constructor(F,G,T,q,z,ie,B,X){this.k=G,this.l=T,this.n=q,this.o=z,this.q=ie,this.u=B,this.w=X;const H=B.extensionsGallery,Q=H?.servicePPEUrl&&X.getValue("_extensionsGallery.enablePPE");this.d=Q?H.servicePPEUrl:H?.serviceUrl,this.g=Q?void 0:H?.searchUrl,this.h=H?.controlUrl,this.j=(0,u.$4o)(B.version,B,this.n,this.w,this.q,F,this.o)}x(F=""){return`${this.d}${F}`}isEnabled(){return!!this.d}async getExtensions(F,G,T){const q=O.CancellationToken.isCancellationToken(G)?{}:G,z=O.CancellationToken.isCancellationToken(G)?G:T,ie=[],B=[],X=[],H=[];let Q=!0;for(const Ee of F){Ee.uuid?B.push(Ee.uuid):ie.push(Ee.id);const Ce=!!(Ee.version||Ee.preRelease);X.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Ce}),Ee.version&&H.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),Q=Q&&!!Ee.hasPreRelease&&!Ce}if(!B.length&&!ie.length)return[];let re=new k().withPage(1,F.length);B.length&&(re=re.withFilter(n.ExtensionId,...B)),ie.length&&(re=re.withFilter(n.ExtensionName,...ie)),(q.queryAllVersions||Q)&&(re=re.withFlags(re.flags,o.IncludeVersions)),q.source&&(re=re.withSource(q.source));const{extensions:de}=await this.z(re,{targetPlatform:q.targetPlatform??t,includePreRelease:X,versions:H,compatible:!!q.compatible},z);return q.source&&de.forEach((Ee,Ce)=>oe(Ee,Ce,q.source)),de}async getCompatibleExtension(F,G,T){if((0,S.$Wn)(F.allTargetPlatforms,T))return null;if(await this.isExtensionCompatible(F,G,T))return F;const q=new k().withFlags(o.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,F.identifier.uuid),{extensions:z}=await this.z(q,{targetPlatform:T,compatible:!0,includePreRelease:G},O.CancellationToken.None);return z[0]||null}async isExtensionCompatible(F,G,T){if(!(0,S.$Xn)(F.properties.targetPlatform,F.allTargetPlatforms,T)||!G&&F.properties.isPreReleaseVersion)return!1;let q=F.properties.engine;if(!q){const z=await this.getManifest(F,O.CancellationToken.None);if(!z)throw new Error("Manifest was not found");q=z.engines.vscode}return(0,d.$Io)(q,this.u.version,this.u.date)}async y(F,G,T,q,z){if(!(0,S.$Xn)(W(F),q,z)||G!=="any"&&_(F)!==(G==="prerelease"))return!1;if(T)try{const ie=await this.E(F);if(!(0,d.$Io)(ie,this.u.version,this.u.date))return!1}catch(ie){return this.l.error(`Error while getting the engine for the version ${F.version}.`,(0,r.$8)(ie)),!1}return!0}async query(F,G){let T=F.text||"";const q=F.pageSize??50;let z=new k().withPage(1,q);T?(T=T.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Q,re,de)=>(z=z.withFilter(n.Category,de||re),"")),T=T.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Q,re,de)=>(z=z.withFilter(n.Tag,de||re),"")),T=T.replace(/\bfeatured(\s+|\b|$)/g,()=>(z=z.withFilter(n.Featured),"")),T=T.trim(),T&&(T=T.length<200?T:T.substring(0,200),z=z.withFilter(n.SearchText,T)),z=z.withSortBy(0)):F.ids?z=z.withFilter(n.ExtensionId,...F.ids):F.names?z=z.withFilter(n.ExtensionName,...F.names):z=z.withSortBy(4),typeof F.sortBy=="number"&&(z=z.withSortBy(F.sortBy)),typeof F.sortOrder=="number"&&(z=z.withSortOrder(F.sortOrder)),F.source&&(z=z.withSource(F.source));const ie=async(Q,re)=>{const{extensions:de,total:Ee}=await this.z(Q,{targetPlatform:t,compatible:!1,includePreRelease:!!F.includePreRelease},re);return de.forEach((Ce,Le)=>oe(Ce,(Q.pageNumber-1)*Q.pageSize+Le,F.source)),{extensions:de,total:Ee}},{extensions:B,total:X}=await ie(z,G),H=async(Q,re)=>{if(re.isCancellationRequested)throw new r.$3;const{extensions:de}=await ie(z.withPage(Q+1),re);return de};return{firstPage:B,total:X,pageSize:z.pageSize,getPage:H}}async z(F,G,T){const q=F.flags;F.flags&o.IncludeLatestVersionOnly&&F.flags&o.IncludeVersions&&(F=F.withFlags(F.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(F.flags&o.IncludeLatestVersionOnly)&&!(F.flags&o.IncludeVersions)&&(F=F.withFlags(F.flags,o.IncludeLatestVersionOnly)),G.versions?.length&&(F=F.withFlags(F.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),F=F.withFlags(F.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:z,total:ie,context:B}=await this.B(F,T);if(!(F.flags&o.IncludeLatestVersionOnly)){const re=[];for(const de of z){const Ee=await this.A(de,G,B);Ee&&re.push(Ee)}return{extensions:re,total:ie}}const H=[],Q=new Map;for(let re=0;re<z.length;re++){const de=z[re],Ee={id:(0,v.$vo)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ce=(0,I.$Cf)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Ne=>(0,v.$qo)(Ne,Ee))?.includePreRelease;if(G.compatible&&(0,S.$Wn)(K(de),G.targetPlatform))continue;const Le=await this.A(de,G,B);!Le||Le.properties.isPreReleaseVersion&&(!Ce||!Le.hasReleaseVersion)||!Le.properties.isPreReleaseVersion&&Le.properties.targetPlatform!==G.targetPlatform&&Le.hasPreReleaseVersion?Q.set(de.extensionId,re):H.push([re,Le])}if(Q.size){const re=new h.$Hd,de=new k().withFlags(q&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,Q.size).withFilter(n.ExtensionId,...Q.keys()),{extensions:Ee}=await this.z(de,G,T);this.o.publicLog2("galleryService:additionalQuery",{duration:re.elapsed(),count:Q.size});for(const Ce of Ee){const Le=Q.get(Ce.identifier.uuid);H.push([Le,Ce])}}return{extensions:H.sort((re,de)=>re[0]-de[0]).map(([,re])=>re),total:ie}}async A(F,G,T){const q={id:(0,v.$vo)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},z=G.versions?.find(H=>(0,v.$qo)(H,q))?.version,ie=(0,I.$Cf)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(H=>(0,v.$qo)(H,q))?.includePreRelease,B=K(F),X=V(F.versions,G.targetPlatform);if(G.compatible&&(0,S.$Wn)(B,G.targetPlatform))return null;for(let H=0;H<X.length;H++){const Q=X[H];if(!(z&&Q.version!==z)){if(await this.y(Q,ie?"any":"release",G.compatible,B,G.targetPlatform))return me(F,Q,B,T);if(z&&Q.version===z)return null}}return z||G.compatible?null:me(F,F.versions[0],B)}async B(F,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");F=F.withFlags(F.flags,o.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(o.Unpublished));const T=await this.j,q=JSON.stringify(F.raw),z={...T,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(q.length)},ie=new h.$Hd;let B,X,H=0;try{if(B=await this.k.request({type:"POST",url:this.g&&F.criteria.some(re=>re.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:q,headers:z},G),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:H};const Q=await(0,f.$Po)(B);if(Q){const re=Q.results[0],de=re.extensions,Ee=re.resultMetadata&&re.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return H=Ee&&Ee.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:H,context:{[s]:B.res.headers.activityid}}}return{galleryExtensions:[],total:H}}catch(Q){throw X=Q,Q}finally{this.o.publicLog2("galleryService:query",{...F.telemetryData,requestBodySize:String(q.length),duration:ie.elapsed(),success:!!B&&(0,f.$Lo)(B),responseBodySize:B?.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:X?(0,r.$2)(X)?"canceled":(0,r.$8)(X).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(H)})}}async reportStatistic(F,G,T,q){if(!this.isEnabled())return;const z=P.$o?this.x(`/itemName/${F}.${G}/version/${T}/statType/${q==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${F}/extensions/${G}/${T}/stats?statType=${q}`),ie=P.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",X={...await this.j,Accept:ie};try{await this.k.request({type:"POST",url:z,headers:X},O.CancellationToken.None)}catch{}}async download(F,G,T){this.l.trace("ExtensionGalleryService#download",F.identifier.id);const q=(0,v.$yo)(F),z=new Date().getTime(),ie=re=>this.o.publicLog("galleryService:downloadVSIX",{...q,duration:re}),B=T===2?"install":T===3?"update":"",X=B?{uri:`${F.assets.download.uri}${w.URI.parse(F.assets.download.uri).query?"&":"?"}${B}=true`,fallbackUri:`${F.assets.download.fallbackUri}${w.URI.parse(F.assets.download.fallbackUri).query?"&":"?"}${B}=true`}:F.assets.download,H=F.queryContext?.[s]?{[s]:F.queryContext[s]}:void 0,Q=await this.D(X,H?{headers:H}:void 0);await this.q.writeFile(G,Q.stream),ie(new Date().getTime()-z)}async downloadSignatureArchive(F,G){if(!F.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",F.identifier.id);const T=await this.D(F.assets.signature);await this.q.writeFile(G,T.stream)}async getReadme(F,G){if(F.assets.readme){const T=await this.D(F.assets.readme,{},G);return await(0,f.$Oo)(T)||""}return""}async getManifest(F,G){if(F.assets.manifest){const T=await this.D(F.assets.manifest,{},G),q=await(0,f.$Oo)(T);return q?JSON.parse(q):null}return null}async C(F,G){const T=x(F,a.Manifest);if(!T)throw new Error("Manifest was not found");const q={"Accept-Encoding":"gzip"},z=await this.D(T,{headers:q});return await(0,f.$Po)(z)}async getCoreTranslation(F,G){const T=F.assets.coreTranslations.filter(q=>q[0]===G.toUpperCase())[0];if(T){const q=await this.D(T[1]),z=await(0,f.$Oo)(q);return z?JSON.parse(z):null}return null}async getChangelog(F,G){if(F.assets.changelog){const T=await this.D(F.assets.changelog,{},G);return await(0,f.$Oo)(T)||""}return""}async getAllCompatibleVersions(F,G,T){let q=new k().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);F.identifier.uuid?q=q.withFilter(n.ExtensionId,F.identifier.uuid):q=q.withFilter(n.ExtensionName,F.identifier.id);const{galleryExtensions:z}=await this.B(q,O.CancellationToken.None);if(!z.length)return[];const ie=K(z[0]);if((0,S.$Wn)(ie,T))return[];const B=[];await Promise.all(z[0].versions.map(async Q=>{try{await this.y(Q,G?"any":"release",!0,ie,T)&&B.push(Q)}catch{}}));const X=[],H=new Set;for(const Q of V(B,T))H.has(Q.version)||(H.add(Q.version),X.push({version:Q.version,date:Q.lastUpdated,isPreReleaseVersion:_(Q)}));return X}async D(F,G={},T=O.CancellationToken.None){const q=await this.j,z={type:"GET"},ie={...q,...G.headers||{}};G={...G,...z,headers:ie};const B=F.uri,X=F.fallbackUri,H={...G,url:B};try{const Q=await this.k.request(H,T);if(Q.res.statusCode===200)return Q;const re=await(0,f.$Oo)(Q);throw new Error(`Expected 200, got back ${Q.res.statusCode} instead.

${re}`)}catch(Q){if((0,r.$2)(Q))throw Q;const re=(0,r.$8)(Q);this.o.publicLog2("galleryService:cdnFallback",{url:B,message:re});const de={...G,url:X};return this.k.request(de,T)}}async E(F){let G=ue(F);if(!G){const T=await this.C(F,O.CancellationToken.None);if(!T)throw new Error("Manifest was not found");G=T.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const F=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(F.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,f.$Po)(F),T=[],q={},z=[];if(G){for(const ie of G.malicious)T.push({id:ie});if(G.migrateToPreRelease)for(const[ie,B]of Object.entries(G.migrateToPreRelease))(!B.engine||(0,d.$Io)(B.engine,this.u.version,this.u.date))&&(q[ie.toLowerCase()]={disallowInstall:!0,extension:{id:B.id,displayName:B.displayName,autoMigrate:{storage:!!B.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[ie,B]of Object.entries(G.deprecated))B&&(q[ie.toLowerCase()]=(0,I.$Cf)(B)?{}:B);if(G.search)for(const ie of G.search)z.push(ie)}return{malicious:T,deprecated:q,search:z}}};se=Oe([Ae(1,f.$Jo),Ae(2,m.$6i),Ae(3,C.$Sh),Ae(4,y.$0k),Ae(5,g.$7j),Ae(6,l.$lj),Ae(7,$.$fi)],se);let U=class extends se{constructor(F,G,T,q,z,ie,B,X){super(F,G,T,q,z,ie,B,X)}};e.$6o=U,e.$6o=U=Oe([Ae(0,c.$Wo),Ae(1,f.$Jo),Ae(2,m.$6i),Ae(3,C.$Sh),Ae(4,y.$0k),Ae(5,g.$7j),Ae(6,l.$lj),Ae(7,$.$fi)],U);let Z=class extends se{constructor(F,G,T,q,z,ie,B){super(void 0,F,G,T,q,z,ie,B)}};e.$7o=Z,e.$7o=Z=Oe([Ae(0,f.$Jo),Ae(1,m.$6i),Ae(2,C.$Sh),Ae(3,y.$0k),Ae(4,g.$7j),Ae(5,l.$lj),Ae(6,$.$fi)],Z)}),define(be[258],we([1,0,5,2,33,51]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=void 0;class A{constructor($,C){this.a=$,this.b=C}listen($,C){const S=this.b($);switch(C){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,v=>({all:v.all.map(d=>(0,P.$Em)({...d},S)),added:v.added.map(d=>(0,P.$Em)({...d},S)),removed:v.removed.map(d=>(0,P.$Em)({...d},S)),updated:v.updated.map(d=>(0,P.$Em)({...d},S))}))}throw new Error(`Invalid listen ${C}`)}async call($,C,S){const v=this.b($);switch(C){case"createProfile":{const d=await this.a.createProfile(S[0],S[1],S[2]);return(0,P.$Em)({...d},v)}case"updateProfile":{let d=(0,r.$Gk)((0,P.$Fm)(S[0],v),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,S[1]),(0,P.$Em)({...d},v)}case"removeProfile":{const d=(0,r.$Gk)((0,P.$Fm)(S[0],v),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${C}`)}}e.$zN=A;class I extends O.$Qc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor($,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new D.$Ld),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=$.map(v=>(0,r.$Gk)(v,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(v=>{const d=v.added.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme)),g=v.removed.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme)),m=v.updated.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme));this.a=v.all.map(l=>(0,r.$Gk)(l,this.profilesHome.scheme)),this.b.fire({added:d,removed:g,updated:m,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement($){this.c=$}isEnabled(){return this.c}async createNamedProfile($,C,S){const v=await this.f.call("createNamedProfile",[$,C,S]);return(0,r.$Gk)(v,this.profilesHome.scheme)}async createProfile($,C,S,v){const d=await this.f.call("createProfile",[$,C,S,v]);return(0,r.$Gk)(d,this.profilesHome.scheme)}async createTransientProfile($){const C=await this.f.call("createTransientProfile",[$]);return(0,r.$Gk)(C,this.profilesHome.scheme)}async setProfileForWorkspace($,C){await this.f.call("setProfileForWorkspace",[$,C])}removeProfile($){return this.f.call("removeProfile",[$])}async updateProfile($,C){const S=await this.f.call("updateProfile",[$,C]);return(0,r.$Gk)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$AN=I}),define(be[126],we([1,0,4,25,16,13,235,34,33,10,236]),function(le,e,D,O,r,P,A,I,w,$,C){"use strict";var S,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$rN=e.$qN=e.$pN=void 0;let d=class extends w.$Ik{static{S=this}static{this.a="profileAssociationsMigration"}constructor(f,u,c,y,h){super(c,y,u,h),this.U=f,this.W=c}O(){return this.U.getItem(S.b,[]).map(u=>({...u,location:(0,$.$wf)(u.location)?this.w.extUri.joinPath(this.profilesHome,u.location):D.URI.revive(u.location)}))}Q(){const f=this.U.getItem(S.c,{});return this.U.getItem(S.a,!1)?f:this.N(f)}S(){return this.w.extUri.joinPath(D.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$pN=d,e.$pN=d=S=Oe([Ae(0,A.$kN),Ae(1,I.$Dk),Ae(2,O.$Th),Ae(3,r.$7j),Ae(4,P.$6i)],d);let g=v=class extends d{constructor(f,u,c,y,h){super(f,u,c,y,h),this.$=f}P(f){f.length?this.$.setItem(v.b,f.map(u=>({...u,location:this.w.extUri.basename(u.location)}))):this.$.removeItem(v.b)}O(){const f=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(f),this.$.setItem("userDataProfilesMigration",!0)),f}R(f){f.emptyWindows||f.workspaces?this.$.setItem(v.c,f):this.$.removeItem(v.c)}Q(){const f="workspaceAndProfileInfo",u=this.$.getItem(f,void 0);if(u){this.$.removeItem(f);const y=u.reduce((h,{workspace:t,profile:s})=>(h[D.URI.revive(t).toString()]=D.URI.revive(s).toString(),h),{});this.$.setItem(v.c,{workspaces:y})}const c=super.Q();return this.$.getItem(v.a,!1)||(this.R(c),this.$.setItem(v.a,!0)),c}};e.$qN=g,e.$qN=g=v=Oe([Ae(0,A.$lN),Ae(1,I.$Dk),Ae(2,O.$Th),Ae(3,r.$7j),Ae(4,P.$6i)],g);let m=class extends g{constructor(f,u,c,y){super(new C.$oN(0,u,y,c),f,u,c,y)}async init(){return await this.$.init(),super.init()}};e.$rN=m,e.$rN=m=Oe([Ae(0,I.$Dk),Ae(1,O.$Th),Ae(2,r.$7j),Ae(3,P.$6i)],m)}),define(be[127],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nm=e.$mm=void 0,e.$mm=(0,D.$Lh)("extensionHostStatusService");class O{constructor(){this.a=new Map}setExitInfo(P,A){this.a.set(P,A)}getExitInfo(P){return this.a.get(P)||null}}e.$nm=O}),define(be[259],we([1,0,5,14]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=void 0;function r(A){let I=0,w=0,$=0;A>=1e3&&($=Math.floor(A/1e3),A-=$*1e3),$>=60&&(w=Math.floor($/60),$-=w*60),w>=60&&(I=Math.floor(w/60),w-=I*60);const C=I?`${I}h`:"",S=w?`${w}m`:"",v=$?`${$}s`:"",d=A?`${A}ms`:"";return`${C}${S}${v}${d}`}class P{constructor(I,w,$,C){this.i=I,this.j=w,this.a=new D.$Ld,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=$,this.protocol=C,this.e=!1,this.f=new O.$4g(()=>{this.k(`The reconnection grace time of ${r(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new O.$4g(()=>{this.k(`The reconnection short grace time of ${r(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${r(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(I){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${I}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${r(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const I=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),I.end(),this.a.fire(void 0)}acceptReconnection(I,w,$){this.d=I,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,$),this.protocol.endAcceptReconnection()}}e.$vm=P}),define(be[128],we([1,0,27,12,7,151,54]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.$hl=void 0;const I=r.$hc(O.$_f.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function $(v){return new Promise(d=>D.exists(v,d))}function C(v,d){return $(I).then(g=>{if(!g||!A.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const m=`${v}||${d}`;let l=w.get(m);return l||(l=P.getNLSConfiguration(A.default.commit,d,I,v,v).then(f=>(S.is(f)&&(f._languagePackSupport=!0),f)),w.set(m,l)),l})}e.$hl=C;var S;(function(v){function d(g){const m=g;return m&&typeof m._languagePackId=="string"}v.is=d})(S||(e.InternalNLSConfiguration=S={}))}),define(be[129],we([1,0,19,4,25,45,57,16,6,13,31,34,33,128]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fN=void 0;let g=class extends A.$qp{constructor(l,f,u,c,y,h,t,s){super(O.URI.file(y.builtinExtensionsPath),O.URI.file(y.extensionsPath),(0,D.$sg)(y.userHome,".vscode-oss-dev","extensions","control.json"),l.defaultProfile,l,f,u,c,y,h,t,s),this.R=y}async f(l){const f=await(0,d.$hl)(l,this.R.userDataPath);if(d.InternalNLSConfiguration.is(f))try{const u=await this.w.readFile(O.URI.file(f._translationsConfigFile));return JSON.parse(u.value.toString())}catch{}return Object.create(null)}};e.$fN=g,e.$fN=g=Oe([Ae(0,v.$Fk),Ae(1,P.$lp),Ae(2,I.$7j),Ae(3,$.$6i),Ae(4,r.$Th),Ae(5,C.$lj),Ae(6,S.$Dk),Ae(7,w.$Kh)],g)}),define(be[260],we([1,0,261,27,7,23,12,21]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.ServerConnectionTokenType=void 0;const w=/^[0-9A-Za-z_-]+$/;var $;(function(l){l[l.None=0]="None",l[l.Optional=1]="Optional",l[l.Mandatory=2]="Mandatory"})($||(e.ServerConnectionTokenType=$={}));class C{constructor(){this.type=0}validate(f){return!0}}e.$wm=C;class S{constructor(f){this.value=f,this.type=2}validate(f){return f===this.value}}e.$xm=S;class v{constructor(f){this.message=f}}e.$ym=v;async function d(l,f){const u=l["without-connection-token"],c=l["connection-token"],y=l["connection-token-file"];if(u)return typeof c<"u"||typeof y<"u"?new v("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new C;if(typeof y<"u"){if(typeof c<"u")return new v("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let h;try{h=O.readFileSync(y).toString().replace(/\r?\n$/,"")}catch{return new v(`Unable to read the connection token file at '${y}'.`)}return w.test(h)?new S(h):new v(`The connection token defined in '${y} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof c<"u"?w.test(c)?new S(c):new v(`The connection token '${c} does not adhere to the characters 0-9, a-z, A-Z or -.`):new S(await f())}e.$zm=d;async function g(l){return d(l,async()=>{if(!l["user-data-dir"])return(0,P.$bg)();const u=r.$hc(l["user-data-dir"],"token");try{const h=(await I.Promises.readFile(u)).toString().replace(/\r?\n$/,"");if(w.test(h))return h}catch{}const c=(0,P.$bg)();try{await I.Promises.writeFile(u,c,{mode:384})}catch{}return c})}e.$Am=g;function m(l,f,u){if(l.validate(u.query[A.$6f]))return!0;const c=D.parse(f.headers.cookie||"");return l.validate(c[A.$5f])}e.$Bm=m}),define(be[46],we([1,0,200,108,64,6,25,73]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=e.$em=e.$dm=void 0,e.$dm={host:{type:"string",cat:"o",args:"ip-address",description:D.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:D.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:D.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:D.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:D.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:D.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:D.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:D.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:D.localize(8,null)},"user-data-dir":r.$zl["user-data-dir"],"enable-smoke-test-driver":r.$zl["enable-smoke-test-driver"],"disable-telemetry":r.$zl["disable-telemetry"],"disable-workspace-trust":r.$zl["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:r.$zl.log,logsPath:r.$zl.logsPath,"force-disable-user-env":r.$zl["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:D.localize(9,null)},"default-workspace":{type:"string",description:D.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":r.$zl["extensions-dir"],"extensions-download-dir":r.$zl["extensions-download-dir"],"builtin-extensions-dir":r.$zl["builtin-extensions-dir"],"install-extension":r.$zl["install-extension"],"install-builtin-extension":r.$zl["install-builtin-extension"],"uninstall-extension":r.$zl["uninstall-extension"],"list-extensions":r.$zl["list-extensions"],"locate-extension":r.$zl["locate-extension"],"show-versions":r.$zl["show-versions"],category:r.$zl.category,force:r.$zl.force,"do-not-sync":r.$zl["do-not-sync"],"pre-release":r.$zl["pre-release"],"start-server":{type:"boolean",cat:"e",description:D.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:r.$zl.help,version:r.$zl.version,"locate-shell-integration-path":r.$zl["locate-shell-integration-path"],compatibility:{type:"string"},_:r.$zl._},e.$em=(0,P.$Mh)(A.$Sh);class w extends O.$am{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$fm=w,Oe([I.$dh],w.prototype,"userRoamingDataHome",null)}),define(be[262],we([1,0,27,21,76,84,261,86,39,62,3,13,46,7,12,23,31,44,20,4,15,10,56]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GN=e.$FN=e.CacheControl=e.$EN=void 0;const s={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function o(p,E,k,L){E.writeHead(k,{"Content-Type":"text/plain"}),E.end(L)}e.$EN=o;var i;(function(p){p[p.NO_CACHING=0]="NO_CACHING",p[p.ETAG=1]="ETAG",p[p.NO_EXPIRY=2]="NO_EXPIRY"})(i||(e.CacheControl=i={}));async function n(p,E,k,L,j,Y){try{const ce=await O.Promises.stat(p);if(E===1){const x=`W/"${[ce.ino,ce.size,ce.mtime.getTime()].join("-")}"`;if(L.headers["if-none-match"]===x)return j.writeHead(304),void j.end();Y.Etag=x}else E===2?Y["Cache-Control"]="public, max-age=31536000":E===0&&(Y["Cache-Control"]="no-store");Y["Content-Type"]=s[(0,d.$mc)(p)]||(0,$.$Kr)(p)||"text/plain",j.writeHead(200,Y),(0,D.createReadStream)(p).pipe(j)}catch(ce){return ce.code!=="ENOENT"?(k.error(ce),console.error(ce.toString())):console.error(`File not found: ${p}`),j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}}e.$FN=n;const a=(0,d.$kc)(g.$_f.asFileUri("").fsPath);let b=class{constructor(E,k,L,j,Y){this.f=E,this.g=k,this.h=L,this.i=j,this.j=Y,this.a=this.j.extensionsGallery?.resourceUrlTemplate?c.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const ce=(0,t.$Rk)(Y);this.b=`${ce}/static`,this.c=`${ce}/callback`,this.d=`${ce}/web-extension-resource`}async handle(E,k,L){try{const j=L.pathname;return j.startsWith(this.b)&&j.charCodeAt(this.b.length)===47?this.k(E,k,L):j==="/"?this.n(E,k,L):j===this.c?this.p(k):j.startsWith(this.d)&&j.charCodeAt(this.d.length)===47?this.m(E,k,L):o(E,k,404,"Not found.")}catch(j){return this.h.error(j),console.error(j.toString()),o(E,k,500,"Internal Server Error.")}}async k(E,k,L){const j=Object.create(null),ce=decodeURIComponent(L.pathname).substring(this.b.length+1),x=(0,d.$hc)(a,ce);return(0,w.$Vf)(x,a,!C.$k)?n(x,this.g.isBuilt?2:1,this.h,E,k,j):o(E,k,400,"Bad request.")}l(E){const k=E.authority.indexOf(".");return k!==-1?E.authority.substring(k+1):void 0}async m(E,k,L){if(!this.a)return o(E,k,500,"No extension gallery service configured.");const j=decodeURIComponent(L.pathname),Y=(0,d.$fc)(j.substring(this.d.length+1)),ce=c.URI.parse(Y).with({scheme:this.a.scheme,authority:Y.substring(0,Y.indexOf("/")),path:Y.substring(Y.indexOf("/")+1)});if(this.l(this.a)!==this.l(ce))return o(E,k,403,"Request Forbidden");const x={},ne=W=>{const K=E.headers[W];K&&((0,h.$wf)(K)||K[0])?x[W]=(0,h.$wf)(K)?K:K[0]:W!==W.toLowerCase()&&ne(W.toLowerCase())};ne("X-Client-Name"),ne("X-Client-Version"),ne("X-Machine-Id"),ne("X-Client-Commit");const ue=await this.i.request({type:"GET",url:ce.toString(!0),headers:x},u.CancellationToken.None),_=ue.res.statusCode||500;if(_!==200){let W=null;try{W=await(0,f.$Oo)(ue)}catch{}return o(E,k,_,W||`Request failed with status ${_}`)}const he=Object.create(null),ee=W=>{const K=ue.res.headers[W];K?he[W]=K:W!==W.toLowerCase()&&ee(W.toLowerCase())};ee("Cache-Control"),ee("Content-Type"),k.writeHead(200,he);const te=await(0,y.$le)(ue.stream);return void k.end(te.buffer)}async n(E,k,L){const j=L.query[g.$6f];if(typeof j=="string"){const U=Object.create(null);U["Set-Cookie"]=A.serialize(g.$5f,j,{sameSite:"lax",maxAge:60*60*24*7});const Z=Object.create(null);for(const F in L.query)F!==g.$6f&&(Z[F]=L.query[F]);const R=P.format({pathname:"/",query:Z});return U.Location=R,k.writeHead(302,U),void k.end()}const Y=U=>{const Z=E.headers[U];return Array.isArray(Z)?Z[0]:Z},ce=!this.g.isBuilt&&this.g.args["use-test-resolver"],x=ce?"test+test":Y("x-original-host")||Y("x-forwarded-host")||E.headers.host;if(!x)return o(E,k,400,"Bad request.");function ne(U){return JSON.stringify(U).replace(/"/g,"&quot;")}let ue;this.g.args["enable-smoke-test-driver"]&&(ue=!1);const _=U=>U&&c.URI.file(r.resolve(U)).with({scheme:g.Schemas.vscodeRemote,authority:x}),he=g.$_f.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ee=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.$bg)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,te={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:x,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.g.isBuilt)try{const U=JSON.parse((await O.Promises.readFile((0,d.$hc)(a,"product.overrides.json"))).toString());Object.assign(te,U)}catch{}const W={remoteAuthority:x,_wrapWebWorkerExtHostInIframe:ue,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:_(this.g.args["default-folder"]),workspaceUri:_(this.g.args["default-workspace"]),productConfiguration:te,callbackRoute:this.c},K=this.j.extensionsGallery?.nlsBaseUrl,V={WORKBENCH_WEB_CONFIGURATION:ne(W),WORKBENCH_AUTH_SESSION:ee?ne(ee):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:K?`${K}${K.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};if(ce){const U=[];for(const Z of["vscode-test-resolver","github-authentication"]){const R=JSON.parse((await O.Promises.readFile(g.$_f.asFileUri(`${g.$8f}/${Z}/package.json`).fsPath)).toString());U.push({extensionPath:Z,packageJSON:R})}V.WORKBENCH_BUILTIN_EXTENSIONS=ne(U)}let oe;try{oe=(await O.Promises.readFile(he)).toString().replace(/\{\{([^}]+)\}\}/g,(Z,R)=>V[R]??"undefined")}catch{return k.writeHead(404,{"Content-Type":"text/plain"}),void k.end("Not found")}const se={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(oe).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' ${ce?"":`http://${x}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(se["Set-Cookie"]=A.serialize(g.$5f,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),k.writeHead(200,se),void k.end(oe)}o(E){const k=/<script>([\s\S]+?)<\/script>/img,L=[];let j;for(;j=k.exec(E);){const Y=I.createHash("sha256"),ce=j[1].replace(/\r\n/g,`
`),x=Y.update(Buffer.from(ce)).digest().toString("base64");L.push(`'sha256-${x}'`)}return L}async p(E){const k=g.$_f.asFileUri("vs/code/browser/workbench/callback.html").fsPath,L=(await O.Promises.readFile(k)).toString(),j=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(L).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return E.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":j}),void E.end(L)}};e.$GN=b,e.$GN=b=Oe([Ae(1,v.$em),Ae(2,S.$6i),Ae(3,f.$Jo),Ae(4,l.$lj)],b)}),define(be[263],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=void 0,e.$mM=(0,D.$Lh)("IExtHostInitDataService")}),define(be[264],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0L=e.$9L=void 0,e.$9L=(0,D.$Lh)("IExtHostRpcService");class O{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$0L=O}),define(be[70],we([1,0,51]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;function O(P){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:P,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function r(P){return new D.$Cm(O(P))}e.$rr=r}),define(be[265],we([1,0,3,41,4,70,51,104,239,7,19]),function(le,e,D,O,r,P,A,I,w,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yr=void 0;class S{static{this.a=1}constructor(d,g,m,l){this.b=d,this.c=g,this.d=m,this.e=l}async call(d,g,m){switch(g){case"getEnvironmentData":{const l=m,f=(0,P.$rr)(l.remoteAuthority);let u=await this.f(l.profile);return u=(0,A.$Em)(u,f),u}case"getExtensionHostExitInfo":{const l=m;return this.e.getExitInfo(l.reconnectionToken)}case"getDiagnosticInfo":{const l=m,f={machineInfo:(0,w.$vr)()},u=l.includeProcesses?(0,I.$tr)(process.pid):Promise.resolve();let c=[];const y={};if(l.folders){const h=(0,P.$rr)("");c=l.folders.map(s=>r.URI.revive(h.transformIncoming(s))).filter(s=>s.scheme==="file").map(s=>(0,w.$ur)(s.fsPath,["node_modules",".git"]).then(o=>{y[(0,$.$lc)(s.fsPath)]=o}))}return Promise.all([u,...c]).then(([h,t])=>(f.processes=h||void 0,f.workspaceMetadata=l.folders?y:void 0,f))}}throw new Error(`IPC Command ${g} not found`)}listen(d,g,m){throw new Error("Not supported")}async f(d){return d&&!this.d.profiles.some(g=>g.id===d)&&await this.d.createProfile(d,d),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:r.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,C.$sg)(this.c.logsHome,`exthost${S.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:D.OS,arch:process.arch,marks:O.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(g=>({...g}))}}}}e.$yr=S}),define(be[266],we([1,0,4,70,68,7,225]),function(le,e,D,O,r,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Br=void 0;class I extends A.$zr{constructor(C,S){super(new r.$4p(C),C),this.N=S,this.M=new Map,this.B(this.a)}c(C){let S=this.M.get(C.remoteAuthority);return S||(S=(0,O.$rr)(C.remoteAuthority),this.M.set(C.remoteAuthority,S)),S}f(C,S,v=!1){if(v&&S.path==="/vscode-resource"&&S.query){const d=JSON.parse(S.query).requestResourcePath;return D.URI.from({scheme:"file",path:d})}return D.URI.revive(C.transformIncoming(S))}L(C,S){return new w(C,S,this.b,this.N)}}e.$Br=I;class w extends A.$Ar{constructor(C,S,v,d){super(C,S,v,d)}j(C){const S=C.args["file-watcher-polling"];if(S){const v=S.split(P.$rc),d=Number(v[0]);if(d>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:d}}}m(C){if(C.extensionsPath)return[P.$ec.join(C.extensionsPath,"**")]}}}),define(be[90],we([1,0,203,10,4,2,6,35,16,12,38,157,60]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0D=e.$9D=e.$8D=e.EditorsOrder=e.$7D=e.CloseDirection=e.$6D=e.$5D=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$4D=e.$3D=e.$2D=e.$1D=e.$ZD=e.$YD=e.$XD=e.$WD=e.EditorInputCapabilities=e.$VD=e.SaveReason=e.Verbosity=e.$UD=e.$TD=e.$SD=e.$RD=e.$QD=e.$PD=e.$OD=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=void 0,e.$JD={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$KD={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$LD="workbench.editor.sidebysideEditor",e.$MD="workbench.editors.textDiffEditor",e.$ND="workbench.editors.binaryResourceDiffEditor";var d;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(d||(e.EditorPaneSelectionChangeReason=d={}));var g;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(g||(e.EditorPaneSelectionCompareResult=g={}));function m(se){const U=se;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}e.$OD=m;function l(se,U,Z){for(const R of Z.visibleEditorPanes)if(R.group.id===U&&se.matches(R.input))return R.getViewState()}e.$PD=l;function f(se){if(a(se))return!1;const U=se;return r.URI.isUri(U?.resource)}e.$QD=f;function u(se){if(a(se))return!1;const U=se;return U?.original!==void 0&&U.modified!==void 0}e.$RD=u;function c(se){if(a(se)||u(se))return!1;const U=se;return U?.primary!==void 0&&U.secondary!==void 0}e.$SD=c;function y(se){if(a(se))return!1;const U=se;return U?U.resource===void 0||U.resource.scheme===$.Schemas.untitled||U.forceUntitled===!0:!1}e.$TD=y;function h(se){if(a(se))return!1;const U=se;return r.URI.isUri(U?.base?.resource)&&r.URI.isUri(U?.input1?.resource)&&r.URI.isUri(U?.input2?.resource)&&r.URI.isUri(U?.result?.resource)}e.$UD=h;var t;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(t||(e.Verbosity=t={}));var s;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class o{constructor(){this.a=new Map}registerSource(U,Z){let R=this.a.get(U);return R||(R={source:U,label:Z},this.a.set(U,R)),R.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$VD=new o;var i;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad"})(i||(e.EditorInputCapabilities=i={}));class n extends P.$Qc{}e.$WD=n;function a(se){return se instanceof n}e.$XD=a;function b(se){const U=se;return r.URI.isUri(U?.preferredResource)}function p(se){const U=se;return a(U?.primary)&&a(U?.secondary)}e.$YD=p;function E(se){const U=se;return a(U?.modified)&&a(U?.original)}e.$ZD=E;function k(se,U,Z,R,F){return me(R,[(0,S.$vi)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const G={...Z,limits:{size:Number.MAX_VALUE}};se.openEditor(U,G)}}),(0,S.$vi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>F.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$1D=k;function L(se){return a(se?.editor)}e.$2D=L;function j(se){const U=se;return L(se)&&U?.group!==void 0}e.$3D=j;function Y(se){const U=se;return typeof U?.groupId=="number"&&a(U.editor)}e.$4D=Y;var ce;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(ce||(e.EditorCloseContext=ce={}));var x;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LOCKED=2]="GROUP_LOCKED",se[se.EDITOR_OPEN=3]="EDITOR_OPEN",se[se.EDITOR_CLOSE=4]="EDITOR_CLOSE",se[se.EDITOR_MOVE=5]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=7]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=9]="EDITOR_PIN",se[se.EDITOR_STICKY=10]="EDITOR_STICKY",se[se.EDITOR_DIRTY=11]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(x||(e.GroupModelChangeKind=x={}));var ne;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(ne||(e.SideBySideEditor=ne={}));class ue{getOriginalUri(U,Z){if(!U)return;if(h(U))return e.$6D.getOriginalUri(U.result,Z);if(Z?.supportSideBySide){const{primary:F,secondary:G}=this.a(U);if(F&&G){if(Z?.supportSideBySide===ne.BOTH)return{primary:this.getOriginalUri(F,{filterByScheme:Z.filterByScheme}),secondary:this.getOriginalUri(G,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===ne.ANY)return this.getOriginalUri(F,{filterByScheme:Z.filterByScheme})??this.getOriginalUri(G,{filterByScheme:Z.filterByScheme});U=Z.supportSideBySide===ne.PRIMARY?F:G}}if(u(U)||c(U)||h(U))return;const R=b(U)?U.preferredResource:U.resource;return!R||!Z||!Z.filterByScheme?R:this.b(R,Z.filterByScheme)}a(U){return p(U)||c(U)?{primary:U.primary,secondary:U.secondary}:E(U)||u(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,Z){if(!U)return;if(h(U))return e.$6D.getCanonicalUri(U.result,Z);if(Z?.supportSideBySide){const{primary:F,secondary:G}=this.a(U);if(F&&G){if(Z?.supportSideBySide===ne.BOTH)return{primary:this.getCanonicalUri(F,{filterByScheme:Z.filterByScheme}),secondary:this.getCanonicalUri(G,{filterByScheme:Z.filterByScheme})};if(Z?.supportSideBySide===ne.ANY)return this.getCanonicalUri(F,{filterByScheme:Z.filterByScheme})??this.getCanonicalUri(G,{filterByScheme:Z.filterByScheme});U=Z.supportSideBySide===ne.PRIMARY?F:G}}if(u(U)||c(U)||h(U))return;const R=U.resource;return!R||!Z||!Z.filterByScheme?R:this.b(R,Z.filterByScheme)}b(U,Z){if(Array.isArray(Z)){if(Z.some(R=>U.scheme===R))return U}else if(Z===U.scheme)return U}}var _;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(_||(e.EditorCloseMethod=_={}));function he(se,U,Z,R){if(!se.isSticky(U))return!1;switch(R.preventPinnedEditorClose){case"keyboardAndMouse":return Z===_.MOUSE||Z===_.KEYBOARD;case"mouse":return Z===_.MOUSE;case"keyboard":return Z===_.KEYBOARD}return!1}e.$5D=he,e.$6D=new ue;var ee;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(ee||(e.CloseDirection=ee={}));class te{constructor(){this.c=new Map,this.d=new Map}start(U){const Z=this.a=U.get(A.$Kh);for(const[R,F]of this.c)this.e(R,F,Z);this.c.clear()}e(U,Z,R){const F=R.createInstance(Z);this.d.set(U,F)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,O.$Hf)(this.b)}registerEditorSerializer(U,Z){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,Z,this.a):this.c.set(U,Z),(0,P.$Oc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}I.$9m.add(e.$JD.EditorFactory,new te);async function W(se,U,Z){return!se||!se.length?[]:await Promise.all(se.map(async R=>{const F=r.URI.revive(R.fileUri);if(!F){Z.info("Cannot resolve the path because it is not valid.",R);return}if(!await U.canHandleResource(F)){Z.info("Cannot resolve the path because it cannot be handled",R);return}let T=R.exists,q=R.type;if(typeof T!="boolean"||typeof q!="number")try{q=(await U.stat(F)).isDirectory?w.FileType.Directory:w.FileType.Unknown,T=!0}catch(ie){Z.error(ie),T=!1}if(!T&&R.openOnlyIfExists){Z.info("Cannot resolve the path because it does not exist",R);return}if(q===w.FileType.Directory){Z.info("Cannot resolve the path because it is a directory",R);return}const z={...R.options,pinned:!0};return T?{resource:F,options:z}:{resource:F,options:z,forceUntitled:!0}}))}e.$7D=W;var K;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(K||(e.EditorsOrder=K={}));function V(se){const U=se;if(!U)return!1;const Z=U;if(Z.modified)return V(Z.modified);const R=U;return!!(R.contributionsState&&R.viewState&&Array.isArray(R.cursorState))}e.$8D=V;function oe(se){return(0,C.$xi)(se)}e.$9D=oe;function me(se,U,Z){const R=(0,C.$yi)(se,U);return R.forceMessage=Z?.forceMessage,R.forceSeverity=Z?.forceSeverity,R.allowDialog=Z?.allowDialog,R}e.$0D=me}),define(be[130],we([1,0,15,78,47,62,12,7,3,66]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jI=e.$iI=e.$hI=e.$gI=e.CellStatusbarAlignment=e.$fI=e.$eI=e.$dI=e.NotebookEditorPriority=e.$cI=e.$bI=e.$aI=e.$_H=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$$H=e.$0H=e.$9H=e.$8H=e.CellKind=e.$7H=e.$6H=e.$5H=void 0,e.$5H="workbench.editor.notebook",e.$6H="workbench.editor.notebookTextDiffEditor",e.$7H="workbench.editor.interactive";var C;(function(_){_[_.Markup=1]="Markup",_[_.Code=2]="Code"})(C||(e.CellKind=C={})),e.$8H=["application/json","application/javascript","text/html","image/svg+xml",P.$Ir.latex,P.$Ir.markdown,"image/png","image/jpeg",P.$Ir.text],e.$9H=[P.$Ir.latex,P.$Ir.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$Ir.text],e.$0H=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$$H="_notAvailable";var S;(function(_){_[_.Running=1]="Running",_[_.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var v;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(v||(e.NotebookCellExecutionState=v={}));var d;(function(_){_[_.Unconfirmed=1]="Unconfirmed",_[_.Pending=2]="Pending",_[_.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var g;(function(_){_[_.WithHardKernelDependency=0]="WithHardKernelDependency",_[_.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",_[_.Pure=2]="Pure",_[_.Never=3]="Never"})(g||(e.NotebookRendererMatch=g={}));var m;(function(_){_.Always="always",_.Never="never",_.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var l;(function(_){_[_.ModelChange=1]="ModelChange",_[_.Move=2]="Move",_[_.ChangeCellLanguage=5]="ChangeCellLanguage",_[_.Initialize=6]="Initialize",_[_.ChangeCellMetadata=7]="ChangeCellMetadata",_[_.Output=8]="Output",_[_.OutputItem=9]="OutputItem",_[_.ChangeCellContent=10]="ChangeCellContent",_[_.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",_[_.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",_[_.ChangeCellMime=13]="ChangeCellMime",_[_.Unknown=100]="Unknown"})(l||(e.NotebookCellsChangeType=l={}));var f;(function(_){_[_.Handle=0]="Handle",_[_.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var u;(function(_){_[_.Replace=1]="Replace",_[_.Output=2]="Output",_[_.Metadata=3]="Metadata",_[_.CellLanguage=4]="CellLanguage",_[_.DocumentMetadata=5]="DocumentMetadata",_[_.Move=6]="Move",_[_.OutputItems=7]="OutputItems",_[_.PartialMetadata=8]="PartialMetadata",_[_.PartialInternalMetadata=9]="PartialInternalMetadata"})(u||(e.CellEditType=u={}));var c;(function(_){_.scheme=A.Schemas.vscodeNotebookCell;const he=["W","X","Y","Z","a","b","c","d","e","f"],ee=new RegExp(`^[${he.join("")}]+`),te=7;function W(U,Z){const R=Z.toString(te),G=`${R.length<he.length?he[R.length-1]:"z"}${R}s${(0,D.$te)(D.$_d.fromString(U.scheme),!0,!0)}`;return U.with({scheme:_.scheme,fragment:G})}_.generate=W;function K(U){if(U.scheme!==_.scheme)return;const Z=U.fragment.indexOf("s");if(Z<0)return;const R=parseInt(U.fragment.substring(0,Z).replace(ee,""),te),F=(0,D.$se)(U.fragment.substring(Z+1)).toString();if(!isNaN(R))return{handle:R,notebook:U.with({scheme:F,fragment:null})}}_.parse=K;function V(U,Z){return U.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Z??""},${U.scheme!==A.Schemas.file?U.scheme:""}`})}_.generateCellOutputUri=V;function oe(U){if(U.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Z=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(U.fragment);if(!Z)return;const R=Z[1]&&Z[1]!==""?Z[1]:void 0,F=Z[2];return{outputId:R,notebook:U.with({scheme:F||A.Schemas.file,fragment:null})}}_.parseCellOutputUri=oe;function me(U,Z,R){return _.generate(U,Z).with({scheme:R})}_.generateCellPropertyUri=me;function se(U,Z){if(U.scheme===Z)return _.parse(U.with({scheme:_.scheme}))}_.parseCellPropertyUri=se})(c||(e.CellUri=c={}));const y=_=>w.$i?_.replace(/\//g,"\\"):_;class h{constructor(he=[],ee=e.$8H){this.e=ee,this.d=[...new Set(he)].map(te=>({pattern:te,matches:O.$sj(y(te))}))}sort(he){const ee=new Map(r.Iterable.map(he,W=>[W,y(W)]));let te=[];for(const{matches:W}of this.d)for(const[K,V]of ee)if(W(V)){te.push(K),ee.delete(K);break}return ee.size&&(te=te.concat([...ee.keys()].sort((W,K)=>this.e.indexOf(W)-this.e.indexOf(K)))),te}prioritize(he,ee){const te=this.f(he);if(te===-1){this.d.unshift({pattern:he,matches:O.$sj(y(he))});return}const W=new Set(ee.map(V=>this.f(V,te)));W.delete(-1);const K=Array.from(W).sort();this.d.splice(te+1,0,...K.map(V=>this.d[V]));for(let V=K.length-1;V>=0;V--)this.d.splice(K[V],1)}toArray(){return this.d.map(he=>he.pattern)}f(he,ee=this.d.length){const te=y(he);for(let W=0;W<ee;W++)if(this.d[W].matches(te))return W;return-1}}e.$_H=h;function t(_,he,ee,te=(W,K)=>W===K){const W=[];function K(me,se,U){if(se===0&&U.length===0)return;const Z=W[W.length-1];Z&&Z.start+Z.deleteCount===me?(Z.deleteCount+=se,Z.toInsert.push(...U)):W.push({start:me,deleteCount:se,toInsert:U})}let V=0,oe=0;for(;;){if(V===_.length){K(V,0,he.slice(oe));break}if(oe===he.length){K(V,_.length-V,[]);break}const me=_[V],se=he[oe];if(te(me,se)){V+=1,oe+=1;continue}ee(se)?(K(V,1,[]),V+=1):(K(V,0,[se]),oe+=1)}return W}e.$aI=t,e.$bI=new $.$3i("notebookEditorCursorAtBoundary","none"),e.$cI=new $.$3i("notebookEditorCursorAtLineBoundary","none");var s;(function(_){_.default="default",_.option="option"})(s||(e.NotebookEditorPriority=s={}));function o(_){const he=_;return!!((typeof he.include=="string"||O.$tj(he.include))&&(typeof he.exclude=="string"||O.$tj(he.exclude)))}e.$dI=o;function i(_,he,ee){if(Array.isArray(_.viewType)&&_.viewType.indexOf(he)>=0||_.viewType===he)return!0;if(_.filenamePattern){const te=o(_.filenamePattern)?_.filenamePattern.include:_.filenamePattern,W=o(_.filenamePattern)?_.filenamePattern.exclude:void 0;if(O.$rj(te,(0,I.$lc)(ee.fsPath).toLowerCase()))return!(W&&O.$rj(W,(0,I.$lc)(ee.fsPath).toLowerCase()))}return!1}e.$eI=i,e.$fI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell"};var n;(function(_){_[_.Left=1]="Left",_[_.Right=2]="Right"})(n||(e.CellStatusbarAlignment=n={}));class a{static{this.d="notebook/"}static create(he){return`${a.d}${he}`}static parse(he){if(he.startsWith(a.d))return he.substring(a.d.length)}}e.$gI=a;function b(_){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(_)}e.$hI=b;const p=new TextDecoder;function E(_){const he=[];let ee=!1;for(const V of _)(he.length===0||ee)&&(he.push(V),ee=!0);let te=j(he);const W=D.$_d.concat(he.map(V=>D.$_d.wrap(V))),K=ue(W);return te=te||K.byteLength!==W.byteLength,{data:K,didCompression:te}}e.$iI=E,e.$jI=`${String.fromCharCode(27)}[A`;const k=e.$jI.split("").map(_=>_.charCodeAt(0)),L=10;function j(_){let he=!1;return _.forEach((ee,te)=>{if(te===0||ee.length<e.$jI.length)return;const W=_[te-1],K=ee.subarray(0,e.$jI.length);if(K[0]===k[0]&&K[1]===k[1]&&K[2]===k[2]){const V=W.lastIndexOf(L);if(V===-1)return;he=!0,_[te-1]=W.subarray(0,V),_[te]=ee.subarray(e.$jI.length)}}),he}function Y(_){let he=_;do _=he,he=_.replace(/[^\n]\x08/gm,"");while(he.length<_.length);return _}function ce(_){for(_=_.replace(/\r+\n/gm,`
`);_.search(/\r[^$]/g)>-1;){const he=_.match(/^(.*)\r+/m)[1];let ee=_.match(/\r+(.*)$/m)[1];ee=ee+he.slice(ee.length,he.length),_=_.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ee)}return _}const x="\b".charCodeAt(0),ne="\r".charCodeAt(0);function ue(_){return!_.buffer.includes(x)&&!_.buffer.includes(ne)?_:D.$_d.fromString(ce(Y(p.decode(_.buffer))))}}),define(be[131],we([1,0,18,11,101,26,62,17,10,4,23,40,16,117,130]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g){"use strict";var m,l,f,u,c,y,h,t,s,o,i,n,a,b,p,E,k,L;Object.defineProperty(e,"__esModule",{value:!0}),e.RelatedInformationType=e.$XL=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$WL=e.$VL=e.$UL=e.$TL=e.$SL=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.TestRunProfileKind=e.TestResultState=e.$EL=e.$DL=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$CL=e.$BL=e.$AL=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$zL=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.ColorThemeKind=e.$tL=e.$sL=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$rL=e.DebugConsoleMode=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$lL=e.$kL=e.FileChangeType=e.$jL=e.$iL=e.$hL=e.$gL=e.InlineCompletionTriggerKind=e.$fL=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.$6K=e.ConfigurationTarget=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.$WK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$VK=e.ViewBadge=e.ProgressLocation=e.$UK=e.$TK=e.TaskScope=e.ShellQuoting=e.$SK=e.$RK=e.$QK=e.TaskPanelKind=e.TaskRevealKind=e.$PK=e.TerminalLocation=e.$OK=e.$NK=e.$MK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$LK=e.$KK=e.$JK=e.$IK=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$HK=e.StatusBarAlignment=e.ViewColumn=e.$GK=e.$FK=e.$EK=e.$DK=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$CK=e.$BK=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.LanguageStatusSeverity=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.CodeActionTriggerKind=e.$pK=e.$oK=e.SymbolTag=e.SymbolKind=e.$nK=e.DocumentHighlightKind=e.$mK=e.$lK=e.$kK=e.$jK=e.DiagnosticSeverity=e.DiagnosticTag=e.$iK=e.$hK=e.FileEditType=e.$gK=e.$fK=e.$eK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function j(M){return Object.assign(M,{apply:function(...ae){if(ae.length===0)return Reflect.construct(M,[]);{const pe=ae.length===1?[]:ae[1];return Reflect.construct(M,pe,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(M,[]);{const[pe,...Me]=ae;return Reflect.construct(M,Me,pe.constructor)}}})}var Y;(function(M){M[M.Top=0]="Top",M[M.Bottom=1]="Bottom"})(Y||(e.TerminalOutputAnchor=Y={}));var ce;(function(M){M[M.TerminalCommand=0]="TerminalCommand",M[M.Opener=1]="Opener",M[M.Command=3]="Command"})(ce||(e.TerminalQuickFixType=ce={}));let x=m=class{static from(...N){let ae=N;return new m(function(){if(ae){for(const pe of ae)pe&&typeof pe.dispose=="function"&&pe.dispose();ae=void 0}})}#e;constructor(N){this.#e=N}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$0J=x,e.$0J=x=m=Oe([j],x);let ne=l=class{static Min(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let pe=1;pe<N.length;pe++){const Me=N[pe];Me.isBefore(ae)&&(ae=Me)}return ae}static Max(...N){if(N.length===0)throw new TypeError;let ae=N[0];for(let pe=1;pe<N.length;pe++){const Me=N[pe];Me.isAfter(ae)&&(ae=Me)}return ae}static isPosition(N){if(!N)return!1;if(N instanceof l)return!0;const{line:ae,character:pe}=N;return typeof ae=="number"&&typeof pe=="number"}static of(N){if(N instanceof l)return N;if(this.isPosition(N))return new l(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ae){if(N<0)throw(0,O.$5)("line must be non-negative");if(ae<0)throw(0,O.$5)("character must be non-negative");this.c=N,this.e=ae}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ae=0){if(N===null||ae===null)throw(0,O.$5)();let pe;return typeof N>"u"?pe=0:typeof N=="number"?pe=N:(pe=typeof N.lineDelta=="number"?N.lineDelta:0,ae=typeof N.characterDelta=="number"?N.characterDelta:0),pe===0&&ae===0?this:new l(this.line+pe,this.character+ae)}with(N,ae=this.character){if(N===null||ae===null)throw(0,O.$5)();let pe;return typeof N>"u"?pe=this.line:typeof N=="number"?pe=N:(pe=typeof N.line=="number"?N.line:this.line,ae=typeof N.character=="number"?N.character:this.character),pe===this.line&&ae===this.character?this:new l(pe,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$$J=ne,e.$$J=ne=l=Oe([j],ne);let ue=f=class{static isRange(N){return N instanceof f?!0:N?ne.isPosition(N.start)&&ne.isPosition(N.end):!1}static of(N){if(N instanceof f)return N;if(this.isRange(N))return new f(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ae,pe,Me){let Ge,et;if(typeof N=="number"&&typeof ae=="number"&&typeof pe=="number"&&typeof Me=="number"?(Ge=new ne(N,ae),et=new ne(pe,Me)):ne.isPosition(N)&&ne.isPosition(ae)&&(Ge=ne.of(N),et=ne.of(ae)),!Ge||!et)throw new Error("Invalid arguments");Ge.isBefore(et)?(this.c=Ge,this.e=et):(this.c=et,this.e=Ge)}contains(N){return f.isRange(N)?this.contains(N.start)&&this.contains(N.end):ne.isPosition(N)?!(ne.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ae=ne.Max(N.start,this.c),pe=ne.Min(N.end,this.e);if(!ae.isAfter(pe))return new f(ae,pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ae=ne.Min(N.start,this.c),pe=ne.Max(N.end,this.end);return new f(ae,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ae=this.end){if(N===null||ae===null)throw(0,O.$5)();let pe;return N?ne.isPosition(N)?pe=N:(pe=N.start||this.start,ae=N.end||this.end):pe=this.start,pe.isEqual(this.c)&&ae.isEqual(this.end)?this:new f(pe,ae)}toJSON(){return[this.start,this.end]}};e.$_J=ue,e.$_J=ue=f=Oe([j],ue);let _=u=class extends ue{static isSelection(N){return N instanceof u?!0:N?ue.isRange(N)&&ne.isPosition(N.anchor)&&ne.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ae,pe,Me){let Ge,et;if(typeof N=="number"&&typeof ae=="number"&&typeof pe=="number"&&typeof Me=="number"?(Ge=new ne(N,ae),et=new ne(pe,Me)):ne.isPosition(N)&&ne.isPosition(ae)&&(Ge=ne.of(N),et=ne.of(ae)),!Ge||!et)throw new Error("Invalid arguments");super(Ge,et),this.f=Ge,this.g=et}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$aK=_,e.$aK=_=u=Oe([j],_);const he=M=>{if(typeof M!="string"||M.length===0||!/^[0-9A-Za-z_\-]+$/.test(M))throw(0,O.$5)("connectionToken")};class ee{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae,pe){if(typeof N!="string"||N.length===0)throw(0,O.$5)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,O.$5)("port");typeof pe<"u"&&he(pe),this.host=N,this.port=Math.round(ae),this.connectionToken=pe}}e.$bK=ee;class te{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ae){this.makeConnection=N,this.connectionToken=ae,typeof ae<"u"&&he(ae)}}e.$cK=te;class W extends Error{static NotAvailable(N,ae){return new W(N,d.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(N){return new W(N,d.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ae=d.RemoteAuthorityResolverErrorCode.Unknown,pe){super(N),this._message=N,this._code=ae,this._detail=pe,Object.setPrototypeOf(this,W.prototype)}}e.$dK=W;var K;(function(M){M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(K||(e.EndOfLine=K={}));var V;(function(M){M[M.Replace=1]="Replace",M[M.Append=2]="Append",M[M.Prepend=3]="Prepend"})(V||(e.EnvironmentVariableMutatorType=V={}));let oe=c=class{static isTextEdit(N){return N instanceof c?!0:N?ue.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ae){return new c(N,ae)}static insert(N,ae){return c.replace(new ue(N,N),ae)}static delete(N){return c.replace(N,"")}static setEndOfLine(N){const ae=new c(new ue(new ne(0,0),new ne(0,0)),"");return ae.newEol=N,ae}get range(){return this.c}set range(N){if(N&&!ue.isRange(N))throw(0,O.$5)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,O.$5)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,O.$5)("newEol");this.f=N}constructor(N,ae){this.c=N,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$eK=oe,e.$eK=oe=c=Oe([j],oe);let me=y=class{static isNotebookCellEdit(N){return N instanceof y?!0:N?Nt.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ae){return new y(N,ae)}static insertCells(N,ae){return new y(new Nt(N,N),ae)}static deleteCells(N){return new y(N,[])}static updateCellMetadata(N,ae){const pe=new y(new Nt(N,N),[]);return pe.newCellMetadata=ae,pe}static updateNotebookMetadata(N){const ae=new y(new Nt(0,0),[]);return ae.newNotebookMetadata=N,ae}constructor(N,ae){this.range=N,this.newCells=ae}};e.$fK=me,e.$fK=me=y=Oe([j],me);class se{static isSnippetTextEdit(N){return N instanceof se?!0:N?ue.isRange(N.range)&&R.isSnippetString(N.snippet):!1}static replace(N,ae){return new se(N,ae)}static insert(N,ae){return se.replace(new ue(N,N),ae)}constructor(N,ae){this.range=N,this.snippet=ae}}e.$gK=se;var U;(function(M){M[M.File=1]="File",M[M.Text=2]="Text",M[M.Cell=3]="Cell",M[M.CellReplace=5]="CellReplace",M[M.Snippet=6]="Snippet"})(U||(e.FileEditType=U={}));let Z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ae,pe,Me){this.c.push({_type:1,from:N,to:ae,options:pe,metadata:Me})}createFile(N,ae,pe){this.c.push({_type:1,from:void 0,to:N,options:ae,metadata:pe})}deleteFile(N,ae,pe){this.c.push({_type:1,from:N,to:void 0,options:ae,metadata:pe})}e(N,ae,pe){this.c.push({_type:3,metadata:pe,uri:N,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(N,ae,pe,Me){const Ge=ae.start,et=ae.end;(Ge!==et||pe.length>0)&&this.c.push({_type:5,uri:N,index:Ge,count:et-Ge,cells:pe,metadata:Me})}g(N,ae,pe,Me){this.c.push({_type:3,metadata:Me,uri:N,edit:{editType:3,index:ae,metadata:pe}})}replace(N,ae,pe,Me){this.c.push({_type:2,uri:N,edit:new oe(ae,pe),metadata:Me})}insert(N,ae,pe,Me){this.replace(N,new ue(ae,ae),pe,Me)}delete(N,ae,pe){this.replace(N,ae,"",pe)}has(N){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===N.toString())}set(N,ae){if(ae)for(const pe of ae){if(!pe)continue;let Me,Ge;Array.isArray(pe)?(Me=pe[0],Ge=pe[1]):Me=pe,me.isNotebookCellEdit(Me)?Me.newCellMetadata?this.g(N,Me.range.start,Me.newCellMetadata,Ge):Me.newNotebookMetadata?this.e(N,Me.newNotebookMetadata,Ge):this.f(N,Me.range,Me.newCells,Ge):se.isSnippetTextEdit(Me)?this.c.push({_type:6,uri:N,range:Me.range,edit:Me.snippet,metadata:Ge}):this.c.push({_type:2,uri:N,edit:Me,metadata:Ge})}else{for(let pe=0;pe<this.c.length;pe++){const Me=this.c[pe];switch(Me._type){case 2:case 6:case 3:case 5:Me.uri.toString()===N.toString()&&(this.c[pe]=void 0);break}}(0,D.$Gb)(this.c)}}get(N){const ae=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===N.toString()&&ae.push(pe.edit);return ae}entries(){const N=new P.$yc;for(const ae of this.c)if(ae._type===2){let pe=N.get(ae.uri);pe||(pe=[ae.uri,[]],N.set(ae.uri,pe)),pe[1].push(ae.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$hK=Z,e.$hK=Z=Oe([j],Z);let R=h=class{static isSnippetString(N){return N instanceof h?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=h.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ae=this.e++){if(typeof N=="function"){const pe=new h;pe.e=this.e,N(pe),this.e=pe.e,N=pe.value}else N=h.c(N);return this.value+="${",this.value+=ae,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ae=this.e++){const pe=N.map(Me=>Me.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(N,ae){if(typeof ae=="function"){const pe=new h;pe.e=this.e,ae(pe),this.e=pe.e,ae=pe.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$iK=R,e.$iK=R=h=Oe([j],R);var F;(function(M){M[M.Unnecessary=1]="Unnecessary",M[M.Deprecated=2]="Deprecated"})(F||(e.DiagnosticTag=F={}));var G;(function(M){M[M.Hint=3]="Hint",M[M.Information=2]="Information",M[M.Warning=1]="Warning",M[M.Error=0]="Error"})(G||(e.DiagnosticSeverity=G={}));let T=t=class{static isLocation(N){return N instanceof t?!0:N?ue.isRange(N.range)&&$.URI.isUri(N.uri):!1}constructor(N,ae){if(this.uri=N,ae)if(ue.isRange(ae))this.range=ue.of(ae);else if(ne.isPosition(ae))this.range=new ue(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$jK=T,e.$jK=T=t=Oe([j],T);let q=class{static is(N){return N?typeof N.message=="string"&&N.location&&ue.isRange(N.location.range)&&$.URI.isUri(N.location.uri):!1}constructor(N,ae){this.location=N,this.message=ae}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.location.range.isEqual(ae.location.range)&&N.location.uri.toString()===ae.location.uri.toString()}};e.$kK=q,e.$kK=q=Oe([j],q);let z=class{constructor(N,ae,pe=G.Error){if(!ue.isRange(N))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=N,this.message=ae,this.severity=pe}toJSON(){return{severity:G[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ae){return N===ae?!0:!N||!ae?!1:N.message===ae.message&&N.severity===ae.severity&&N.code===ae.code&&N.severity===ae.severity&&N.source===ae.source&&N.range.isEqual(ae.range)&&(0,D.$sb)(N.tags,ae.tags)&&(0,D.$sb)(N.relatedInformation,ae.relatedInformation,q.isEqual)}};e.$lK=z,e.$lK=z=Oe([j],z);let ie=class{constructor(N,ae){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ae}};e.$mK=ie,e.$mK=ie=Oe([j],ie);var B;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(B||(e.DocumentHighlightKind=B={}));let X=class{constructor(N,ae=B.Text){this.range=N,this.kind=ae}toJSON(){return{range:this.range,kind:B[this.kind]}}};e.$nK=X,e.$nK=X=Oe([j],X);var H;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(H||(e.SymbolKind=H={}));var Q;(function(M){M[M.Deprecated=1]="Deprecated"})(Q||(e.SymbolTag=Q={}));let re=s=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ae,pe,Me,Ge){this.name=N,this.kind=ae,this.containerName=Ge,typeof pe=="string"&&(this.containerName=pe),Me instanceof T?this.location=Me:pe instanceof ue&&(this.location=new T(Me,pe)),s.validate(this)}toJSON(){return{name:this.name,kind:H[this.kind],location:this.location,containerName:this.containerName}}};e.$oK=re,e.$oK=re=s=Oe([j],re);let de=o=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(o.validate)}constructor(N,ae,pe,Me,Ge){this.name=N,this.detail=ae,this.kind=pe,this.range=Me,this.selectionRange=Ge,this.children=[],o.validate(this)}};e.$pK=de,e.$pK=de=o=Oe([j],de);var Ee;(function(M){M[M.Invoke=1]="Invoke",M[M.Automatic=2]="Automatic"})(Ee||(e.CodeActionTriggerKind=Ee={}));let Ce=class{constructor(N,ae){this.title=N,this.kind=ae}};e.$qK=Ce,e.$qK=Ce=Oe([j],Ce);let Le=class{static{i=this}static{this.c="."}constructor(N){this.value=N}append(N){return new i(this.value?this.value+i.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+i.c)}};e.$rK=Le,e.$rK=Le=i=Oe([j],Le),Le.Empty=new Le(""),Le.QuickFix=Le.Empty.append("quickfix"),Le.Refactor=Le.Empty.append("refactor"),Le.RefactorExtract=Le.Refactor.append("extract"),Le.RefactorInline=Le.Refactor.append("inline"),Le.RefactorMove=Le.Refactor.append("move"),Le.RefactorRewrite=Le.Refactor.append("rewrite"),Le.Source=Le.Empty.append("source"),Le.SourceOrganizeImports=Le.Source.append("organizeImports"),Le.SourceFixAll=Le.Source.append("fixAll"),Le.Notebook=Le.Empty.append("notebook");let Ne=class{constructor(N,ae){if(this.range=N,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$sK=Ne,e.$sK=Ne=Oe([j],Ne);class $e{constructor(N,ae,pe,Me,Ge,et){this.kind=N,this.name=ae,this.detail=pe,this.uri=Me,this.range=Ge,this.selectionRange=et}}e.$tK=$e;class ke{constructor(N,ae){this.fromRanges=ae,this.from=N}}e.$uK=ke;class ye{constructor(N,ae){this.fromRanges=ae,this.to=N}}e.$vK=ye;var Te;(function(M){M[M.Information=0]="Information",M[M.Warning=1]="Warning",M[M.Error=2]="Error"})(Te||(e.LanguageStatusSeverity=Te={}));let Ue=class{constructor(N,ae){this.range=N,this.command=ae}get isResolved(){return!!this.command}};e.$wK=Ue,e.$wK=Ue=Oe([j],Ue);let Xe=n=class{#e;static isMarkdownString(N){return N instanceof n?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ae=!1){this.#e=new r.$Yj(N,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(N){this.#e.value=N}get isTrusted(){return this.#e.isTrusted}set isTrusted(N){this.#e.isTrusted=N}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(N){this.#e.supportThemeIcons=N}get supportHtml(){return this.#e.supportHtml}set supportHtml(N){this.#e.supportHtml=N}get baseUri(){return this.#e.baseUri}set baseUri(N){this.#e.baseUri=N}appendText(N){return this.#e.appendText(N),this}appendMarkdown(N){return this.#e.appendMarkdown(N),this}appendCodeblock(N,ae){return this.#e.appendCodeblock(ae??"",N),this}};e.$xK=Xe,e.$xK=Xe=n=Oe([j],Xe);let He=class{constructor(N,ae){this.label=N,this.documentation=ae}};e.$yK=He,e.$yK=He=Oe([j],He);let Ze=class{constructor(N,ae){this.label=N,this.documentation=ae,this.parameters=[]}};e.$zK=Ze,e.$zK=Ze=Oe([j],Ze);let Je=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$AK=Je,e.$AK=Je=Oe([j],Je);var ge;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(ge||(e.SignatureHelpTriggerKind=ge={}));var Se;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(Se||(e.InlayHintKind=Se={}));let Ie=class{constructor(N){this.value=N}};e.$BK=Ie,e.$BK=Ie=Oe([j],Ie);let Fe=class{constructor(N,ae,pe){this.position=N,this.label=ae,this.kind=pe}};e.$CK=Fe,e.$CK=Fe=Oe([j],Fe);var je;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var Ke;(function(M){M[M.Text=0]="Text",M[M.Method=1]="Method",M[M.Function=2]="Function",M[M.Constructor=3]="Constructor",M[M.Field=4]="Field",M[M.Variable=5]="Variable",M[M.Class=6]="Class",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Unit=10]="Unit",M[M.Value=11]="Value",M[M.Enum=12]="Enum",M[M.Keyword=13]="Keyword",M[M.Snippet=14]="Snippet",M[M.Color=15]="Color",M[M.File=16]="File",M[M.Reference=17]="Reference",M[M.Folder=18]="Folder",M[M.EnumMember=19]="EnumMember",M[M.Constant=20]="Constant",M[M.Struct=21]="Struct",M[M.Event=22]="Event",M[M.Operator=23]="Operator",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue"})(Ke||(e.CompletionItemKind=Ke={}));var Be;(function(M){M[M.Deprecated=1]="Deprecated"})(Be||(e.CompletionItemTag=Be={}));let qe=class{constructor(N,ae){this.label=N,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&Ke[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$DK=qe,e.$DK=qe=Oe([j],qe);let Qe=class{constructor(N=[],ae=!1){this.items=N,this.isIncomplete=ae}};e.$EK=Qe,e.$EK=Qe=Oe([j],Qe);let We=class{constructor(N,ae,pe){this.insertText=N,this.range=ae,this.command=pe}};e.$FK=We,e.$FK=We=Oe([j],We);let Ye=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$GK=Ye,e.$GK=Ye=Oe([j],Ye);var it;(function(M){M[M.Active=-1]="Active",M[M.Beside=-2]="Beside",M[M.One=1]="One",M[M.Two=2]="Two",M[M.Three=3]="Three",M[M.Four=4]="Four",M[M.Five=5]="Five",M[M.Six=6]="Six",M[M.Seven=7]="Seven",M[M.Eight=8]="Eight",M[M.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var _e;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(_e||(e.StatusBarAlignment=_e={}));function st(M,N){return`${S.$Wl.toKey(M)}.${N}`}e.$HK=st;var ot;(function(M){M[M.Off=0]="Off",M[M.On=1]="On",M[M.Relative=2]="Relative"})(ot||(e.TextEditorLineNumbersStyle=ot={}));var At;(function(M){M[M.Manual=1]="Manual",M[M.AfterDelay=2]="AfterDelay",M[M.FocusOut=3]="FocusOut"})(At||(e.TextDocumentSaveReason=At={}));var mt;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(mt||(e.TextEditorRevealType=mt={}));var ht;(function(M){M[M.Keyboard=1]="Keyboard",M[M.Mouse=2]="Mouse",M[M.Command=3]="Command"})(ht||(e.TextEditorSelectionChangeKind=ht={}));var jt;(function(M){M[M.Undo=1]="Undo",M[M.Redo=2]="Redo"})(jt||(e.TextDocumentChangeReason=jt={}));var Lt;(function(M){M[M.OpenOpen=0]="OpenOpen",M[M.ClosedClosed=1]="ClosedClosed",M[M.OpenClosed=2]="OpenClosed",M[M.ClosedOpen=3]="ClosedOpen"})(Lt||(e.DecorationRangeBehavior=Lt={})),function(M){function N(ae){switch(ae){case"keyboard":return M.Keyboard;case"mouse":return M.Mouse;case"api":return M.Command}}M.fromValue=N}(ht||(e.TextEditorSelectionChangeKind=ht={}));var wt;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(wt||(e.SyntaxTokenType=wt={})),function(M){function N(ae){switch(ae){case M.Other:return"other";case M.Comment:return"comment";case M.String:return"string";case M.RegEx:return"regex"}return"other"}M.toString=N}(wt||(e.SyntaxTokenType=wt={}));let ct=class{constructor(N,ae){if(ae&&!$.URI.isUri(ae))throw(0,O.$5)("target");if(!ue.isRange(N)||N.isEmpty)throw(0,O.$5)("range");this.range=N,this.target=ae}};e.$IK=ct,e.$IK=ct=Oe([j],ct);let vt=class{constructor(N,ae,pe,Me){this.red=N,this.green=ae,this.blue=pe,this.alpha=Me}};e.$JK=vt,e.$JK=vt=Oe([j],vt);let Rt=class{constructor(N,ae){if(ae&&!(ae instanceof vt))throw(0,O.$5)("color");if(!ue.isRange(N)||N.isEmpty)throw(0,O.$5)("range");this.range=N,this.color=ae}};e.$KK=Rt,e.$KK=Rt=Oe([j],Rt);let ft=class{constructor(N){if(!N||typeof N!="string")throw(0,O.$5)("label");this.label=N}};e.$LK=ft,e.$LK=ft=Oe([j],ft);var Mt;(function(M){M[M.RGB=0]="RGB",M[M.HEX=1]="HEX",M[M.HSL=2]="HSL"})(Mt||(e.ColorFormat=Mt={}));var Ot;(function(M){M[M.Error=0]="Error",M[M.Warning=1]="Warning",M[M.Information=2]="Information"})(Ot||(e.SourceControlInputBoxValidationType=Ot={}));var nt;(function(M){M[M.Unknown=0]="Unknown",M[M.Shutdown=1]="Shutdown",M[M.Process=2]="Process",M[M.User=3]="User",M[M.Extension=4]="Extension"})(nt||(e.TerminalExitReason=nt={}));class lt{constructor(N,ae,pe){if(this.startIndex=N,this.length=ae,this.tooltip=pe,typeof N!="number"||N<0)throw(0,O.$5)("startIndex");if(typeof ae!="number"||ae<1)throw(0,O.$5)("length");if(pe!==void 0&&typeof pe!="string")throw(0,O.$5)("tooltip")}}e.$MK=lt;class gt{constructor(N){this.uri=N}}e.$NK=gt;class Tt{constructor(N){this.terminalCommand=N}}e.$OK=Tt;var Ut;(function(M){M[M.Panel=1]="Panel",M[M.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class Bt{constructor(N){if(this.options=N,typeof N!="object")throw(0,O.$5)("options")}}e.$PK=Bt;var Pt;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(Pt||(e.TaskRevealKind=Pt={}));var Ft;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(Ft||(e.TaskPanelKind=Ft={}));let kt=class{static{a=this}static{this.Clean=new a("clean","Clean")}static{this.Build=new a("build","Build")}static{this.Rebuild=new a("rebuild","Rebuild")}static{this.Test=new a("test","Test")}static from(N){switch(N){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}constructor(N,ae){if(this.label=ae,typeof N!="string"||typeof ae!="string")throw(0,O.$5)("name");this.c=N}get id(){return this.c}};e.$QK=kt,e.$QK=kt=a=Oe([j],kt);function zt(M){let N="";for(let ae=0;ae<M.length;ae++)N+=M[ae].replace(/,/g,",,")+",";return N}let yt=class{constructor(N,ae,pe){if(typeof N!="string")throw(0,O.$5)("process");this.e=[],this.c=N,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=pe):this.f=ae)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,O.$5)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)N.push(ae);return zt(N)}};e.$RK=yt,e.$RK=yt=Oe([j],yt);let ve=class{constructor(N,ae,pe){if(this.f=[],Array.isArray(ae)){if(!N)throw(0,O.$5)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,O.$5)("command");this.e=N,this.f=ae,this.g=pe}else{if(typeof N!="string")throw(0,O.$5)("commandLine");this.c=N,this.g=ae}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,O.$5)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,O.$5)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)N.push(typeof ae=="string"?ae:ae.value);return zt(N)}};e.$SK=ve,e.$SK=ve=Oe([j],ve);var De;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})(De||(e.ShellQuoting=De={}));var fe;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace"})(fe||(e.TaskScope=fe={}));class J{constructor(N){this.c=N}computeId(){return"customExecution"+(0,C.$bg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$TK=J;let Pe=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(N,ae,pe,Me,Ge,et){this.j=!1,this.k=this.definition=N;let tt;typeof ae=="string"?(this.m=this.name=ae,this.t=this.source=pe,this.execution=Me,tt=Ge,this.j=!0):ae===fe.Global||ae===fe.Workspace?(this.target=ae,this.m=this.name=pe,this.t=this.source=Me,this.execution=Ge,tt=et):(this.target=ae,this.m=this.name=pe,this.t=this.source=Me,this.execution=Ge,tt=et),typeof tt=="string"?(this.o=[tt],this.q=!0):Array.isArray(tt)?(this.o=tt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.w=Object.create(null),this.x=Object.create(null)}get _id(){return this.h}set _id(N){this.h=N}get _deprecated(){return this.j}z(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.A())}A(){this.n instanceof yt?this.k={type:b.e,id:this.n.computeId()}:this.n instanceof ve?this.k={type:b.f,id:this.n.computeId()}:this.n instanceof J?this.k={type:b.c,id:this.n.computeId()}:this.k={type:b.g,id:(0,C.$bg)()}}get definition(){return this.k}set definition(N){if(N==null)throw(0,O.$5)("Kind can't be undefined or null");this.z(),this.k=N}get scope(){return this.l}set target(N){this.z(),this.l=N}get name(){return this.m}set name(N){if(typeof N!="string")throw(0,O.$5)("name");this.z(),this.m=N}get execution(){return this.n}set execution(N){N===null&&(N=void 0),this.z(),this.n=N;const ae=this.k.type;(b.g===ae||b.e===ae||b.f===ae||b.c===ae)&&this.A()}get problemMatchers(){return this.o}set problemMatchers(N){if(Array.isArray(N))this.z(),this.o=N,this.q=!0;else{this.z(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.z(),this.r=N}get source(){return this.t}set source(N){if(typeof N!="string"||N.length===0)throw(0,O.$5)("source must be a string of length > 0");this.z(),this.t=N}get group(){return this.u}set group(N){N===null&&(N=void 0),this.z(),this.u=N}get detail(){return this.y}set detail(N){N===null&&(N=void 0),this.y=N}get presentationOptions(){return this.w}set presentationOptions(N){N==null&&(N=Object.create(null)),this.z(),this.w=N}get runOptions(){return this.x}set runOptions(N){N==null&&(N=Object.create(null)),this.z(),this.x=N}};e.$UK=Pe,e.$UK=Pe=b=Oe([j],Pe);var Re;(function(M){M[M.SourceControl=1]="SourceControl",M[M.Window=10]="Window",M[M.Notification=15]="Notification"})(Re||(e.ProgressLocation=Re={}));var Ve;(function(M){function N(ae){const pe=ae;return(0,w.$Af)(pe.value)?pe.tooltip&&!(0,w.$wf)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}M.isViewBadge=N})(Ve||(e.ViewBadge=Ve={}));let ze=p=class{static isTreeItem(N,ae){const pe=N;if(pe.checkboxState!==void 0){const Me=(0,w.$Af)(pe.checkboxState)?pe.checkboxState:(0,w.$yf)(pe.checkboxState)&&(0,w.$Af)(pe.checkboxState.state)?pe.checkboxState.state:void 0,Ge=!(0,w.$Af)(pe.checkboxState)&&(0,w.$yf)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(Me===void 0||Me!==rt.Checked&&Me!==rt.Unchecked||Ge!==void 0&&!(0,w.$wf)(Ge))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}if(N instanceof p)return!0;if(pe.label!==void 0&&!(0,w.$wf)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,w.$wf)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,w.$wf)(pe.iconPath)&&!$.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,w.$wf)(pe.iconPath.id))){const Me=pe.iconPath;if(!Me||!(0,w.$wf)(Me.light)&&!$.URI.isUri(Me.light)&&!(0,w.$wf)(Me.dark)&&!$.URI.isUri(Me.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}return pe.description!==void 0&&!(0,w.$wf)(pe.description)&&typeof pe.description!="boolean"?(console.log("INVALID tree item, invalid description",pe.description),!1):pe.resourceUri!==void 0&&!$.URI.isUri(pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1):pe.tooltip!==void 0&&!(0,w.$wf)(pe.tooltip)&&!(pe.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1):pe.command!==void 0&&!pe.command.command?(console.log("INVALID tree item, invalid command",pe.command),!1):pe.collapsibleState!==void 0&&pe.collapsibleState<xe.None&&pe.collapsibleState>xe.Expanded?(console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1):pe.contextValue!==void 0&&!(0,w.$wf)(pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1):pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1):!0}constructor(N,ae=xe.None){this.collapsibleState=ae,$.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$VK=ze,e.$VK=ze=p=Oe([j],ze);var xe;(function(M){M[M.None=0]="None",M[M.Collapsed=1]="Collapsed",M[M.Expanded=2]="Expanded"})(xe||(e.TreeItemCollapsibleState=xe={}));var rt;(function(M){M[M.Unchecked=0]="Unchecked",M[M.Checked=1]="Checked"})(rt||(e.TreeItemCheckboxState=rt={}));let dt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$WK=dt,e.$WK=dt=Oe([j],dt);class $t extends dt{}e.$XK=$t;class at extends $t{#e;constructor(N){super(""),this.#e=N}asFile(){return this.#e}}e.$YK=at;class pt{constructor(N,ae,pe,Me){this.name=N,this.uri=ae,this._itemId=pe,this.c=Me}data(){return this.c()}}e.$ZK=pt;let Qt=class{#e=new Map;constructor(N){for(const[ae,pe]of N??[]){const Me=this.#e.get(this.#t(ae));Me?Me.push(pe):this.#e.set(this.#t(ae),[pe])}}get(N){return this.#e.get(this.#t(N))?.[0]}set(N,ae){this.#e.set(this.#t(N),[ae])}forEach(N,ae){for(const[pe,Me]of this.#e)for(const Ge of Me)N.call(ae,Ge,pe,this)}*[Symbol.iterator](){for(const[N,ae]of this.#e)for(const pe of ae)yield[N,pe]}#t(N){return N.toLowerCase()}};e.$1K=Qt,e.$1K=Qt=Oe([j],Qt);let Jt=class{constructor(N){this.insertText=N}};e.$2K=Jt,e.$2K=Jt=Oe([j],Jt);let Yt=class{constructor(N,ae){this.label=ae,this.insertText=N}};e.$3K=Yt,e.$3K=Yt=Oe([j],Yt);let Ct=class{constructor(N,ae){this.id=N,this.color=ae}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$4K=Ct,e.$4K=Ct=Oe([j],Ct),Ct.File=new Ct("file"),Ct.Folder=new Ct("folder");let Zt=class{constructor(N){this.id=N}};e.$5K=Zt,e.$5K=Zt=Oe([j],Zt);var Cn;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.WorkspaceFolder=3]="WorkspaceFolder"})(Cn||(e.ConfigurationTarget=Cn={}));let Xt=class{get base(){return this.c}set base(N){this.c=N,this.e=$.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ae){if(typeof N!="string"&&(!N||!$.URI.isUri(N)&&!$.URI.isUri(N.uri)))throw(0,O.$5)("base");if(typeof ae!="string")throw(0,O.$5)("pattern");typeof N=="string"?this.baseUri=$.URI.file(N):$.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$6K=Xt,e.$6K=Xt=Oe([j],Xt);const In=new WeakMap;function ci(M,N){In.set(M,N)}e.$7K=ci;let qt=class{constructor(N,ae,pe,Me){this.enabled=typeof N=="boolean"?N:!0,typeof ae=="string"&&(this.condition=ae),typeof pe=="string"&&(this.hitCondition=pe),typeof Me=="string"&&(this.logMessage=Me)}get id(){return this.c||(this.c=In.get(this)??(0,C.$bg)()),this.c}};e.$8K=qt,e.$8K=qt=Oe([j],qt);let xt=class extends qt{constructor(N,ae,pe,Me,Ge){if(super(ae,pe,Me,Ge),N===null)throw(0,O.$5)("location");this.location=N}};e.$9K=xt,e.$9K=xt=Oe([j],xt);let _t=class extends qt{constructor(N,ae,pe,Me,Ge){super(ae,pe,Me,Ge),this.functionName=N}};e.$0K=_t,e.$0K=_t=Oe([j],_t);let en=class extends qt{constructor(N,ae,pe,Me,Ge,et,tt){if(super(Me,Ge,et,tt),!ae)throw(0,O.$5)("dataId");this.label=N,this.dataId=ae,this.canPersist=pe}};e.$$K=en,e.$$K=en=Oe([j],en);let tn=class{constructor(N,ae,pe){this.command=N,this.args=ae||[],this.options=pe}};e.$_K=tn,e.$_K=tn=Oe([j],tn);let nn=class{constructor(N,ae){this.port=N,this.host=ae}};e.$aL=nn,e.$aL=nn=Oe([j],nn);let sn=class{constructor(N){this.path=N}};e.$bL=sn,e.$bL=sn=Oe([j],sn);let rn=class{constructor(N){this.implementation=N}};e.$cL=rn,e.$cL=rn=Oe([j],rn);let on=class{constructor(N,ae,pe){this.session=N,this.threadId=ae,this.frameId=pe}};e.$dL=on,e.$dL=on=Oe([j],on);let an=class{constructor(N,ae){this.session=N,this.threadId=ae}};e.$eL=an,e.$eL=an=Oe([j],an);let cn=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$fL=cn,e.$fL=cn=Oe([j],cn);var An;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(An||(e.InlineCompletionTriggerKind=An={}));let ln=class{constructor(N,ae){this.range=N,this.text=ae}};e.$gL=ln,e.$gL=ln=Oe([j],ln);let un=class{constructor(N,ae,pe=!0){this.range=N,this.variableName=ae,this.caseSensitiveLookup=pe}};e.$hL=un,e.$hL=un=Oe([j],un);let hn=class{constructor(N,ae){this.range=N,this.expression=ae}};e.$iL=hn,e.$iL=hn=Oe([j],hn);let fn=class{constructor(N,ae){this.frameId=N,this.stoppedLocation=ae}};e.$jL=fn,e.$jL=fn=Oe([j],fn);var Ln;(function(M){M[M.Changed=1]="Changed",M[M.Created=2]="Created",M[M.Deleted=3]="Deleted"})(Ln||(e.FileChangeType=Ln={}));let dn=E=class extends Error{static FileExists(N){return new E(N,v.FileSystemProviderErrorCode.FileExists,E.FileExists)}static FileNotFound(N){return new E(N,v.FileSystemProviderErrorCode.FileNotFound,E.FileNotFound)}static FileNotADirectory(N){return new E(N,v.FileSystemProviderErrorCode.FileNotADirectory,E.FileNotADirectory)}static FileIsADirectory(N){return new E(N,v.FileSystemProviderErrorCode.FileIsADirectory,E.FileIsADirectory)}static NoPermissions(N){return new E(N,v.FileSystemProviderErrorCode.NoPermissions,E.NoPermissions)}static Unavailable(N){return new E(N,v.FileSystemProviderErrorCode.Unavailable,E.Unavailable)}constructor(N,ae=v.FileSystemProviderErrorCode.Unknown,pe){super($.URI.isUri(N)?N.toString(!0):N),this.code=pe?.name??"Unknown",(0,v.$ik)(this,ae),Object.setPrototypeOf(this,E.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};e.$kL=dn,e.$kL=dn=E=Oe([j],dn);let mn=class{constructor(N,ae,pe){this.start=N,this.end=ae,this.kind=pe}};e.$lL=mn,e.$lL=mn=Oe([j],mn);var Rn;(function(M){M[M.Comment=1]="Comment",M[M.Imports=2]="Imports",M[M.Region=3]="Region"})(Rn||(e.FoldingRangeKind=Rn={}));var On;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(On||(e.CommentThreadCollapsibleState=On={}));var Fn;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(Fn||(e.CommentMode=Fn={}));var Nn;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(Nn||(e.CommentState=Nn={}));var jn;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(jn||(e.CommentThreadState=jn={}));class li{constructor(N,ae=[]){this.tokenTypes=N,this.tokenModifiers=ae}}e.$mL=li;function ui(M){return typeof M>"u"||(0,w.$xf)(M)}class gn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,N){this.l=!0;for(let ae=0,pe=N.tokenTypes.length;ae<pe;ae++)this.j.set(N.tokenTypes[ae],ae);for(let ae=0,pe=N.tokenModifiers.length;ae<pe;ae++)this.k.set(N.tokenModifiers[ae],ae)}}push(N,ae,pe,Me,Ge){if(typeof N=="number"&&typeof ae=="number"&&typeof pe=="number"&&typeof Me=="number"&&(typeof Ge=="number"||typeof Ge>"u"))return typeof Ge>"u"&&(Ge=0),this.n(N,ae,pe,Me,Ge);if(ue.isRange(N)&&typeof ae=="string"&&ui(pe))return this.m(N,ae,pe);throw(0,O.$5)()}m(N,ae,pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(ae))throw new Error("`tokenType` is not in the provided legend");const Me=N.start.line,Ge=N.start.character,et=N.end.character-N.start.character,tt=this.j.get(ae);let ut=0;if(pe)for(const bt of pe){if(!this.k.has(bt))throw new Error("`tokenModifier` is not in the provided legend");const Et=this.k.get(bt);ut|=1<<Et>>>0}this.n(Me,Ge,et,tt,ut)}n(N,ae,pe,Me,Ge){if(this.f&&(N<this.c||N===this.c&&ae<this.e)){this.f=!1;const ut=this.g.length/5|0;let bt=0,Et=0;for(let St=0;St<ut;St++){let It=this.g[5*St],Vt=this.g[5*St+1];It===0?(It=bt,Vt+=Et):It+=bt,this.g[5*St]=It,this.g[5*St+1]=Vt,bt=It,Et=Vt}}let et=N,tt=ae;this.f&&this.h>0&&(et-=this.c,et===0&&(tt-=this.e)),this.g[this.h++]=et,this.g[this.h++]=tt,this.g[this.h++]=pe,this.g[this.h++]=Me,this.g[this.h++]=Ge,this.c=N,this.e=ae}static o(N){const ae=[],pe=N.length/5|0;for(let tt=0;tt<pe;tt++)ae[tt]=tt;ae.sort((tt,ut)=>{const bt=N[5*tt],Et=N[5*ut];if(bt===Et){const St=N[5*tt+1],It=N[5*ut+1];return St-It}return bt-Et});const Me=new Uint32Array(N.length);let Ge=0,et=0;for(let tt=0;tt<pe;tt++){const ut=5*ae[tt],bt=N[ut+0],Et=N[ut+1],St=N[ut+2],It=N[ut+3],Vt=N[ut+4],ai=bt-Ge,Ri=ai===0?Et-et:Et,Wt=5*tt;Me[Wt+0]=ai,Me[Wt+1]=Ri,Me[Wt+2]=St,Me[Wt+3]=It,Me[Wt+4]=Vt,Ge=bt,et=Et}return Me}build(N){return this.f?new $n(new Uint32Array(this.g),N):new $n(gn.o(this.g),N)}}e.$nL=gn;class $n{constructor(N,ae){this.resultId=ae,this.data=N}}e.$oL=$n;class hi{constructor(N,ae,pe){this.start=N,this.deleteCount=ae,this.data=pe}}e.$pL=hi;class fi{constructor(N,ae){this.resultId=ae,this.edits=N}}e.$qL=fi;var Mn;(function(M){M[M.Separate=0]="Separate",M[M.MergeWithParent=1]="MergeWithParent"})(Mn||(e.DebugConsoleMode=Mn={}));let pn=class{static{this.Back={iconPath:new Ct("arrow-left")}}constructor(){}};e.$rL=pn,e.$rL=pn=Oe([j],pn);var Tn;(function(M){M[M.Separator=-1]="Separator",M[M.Default=0]="Default"})(Tn||(e.QuickPickItemKind=Tn={}));var Un;(function(M){M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(Un||(e.InputBoxValidationSeverity=Un={}));var zn;(function(M){M[M.UI=1]="UI",M[M.Workspace=2]="Workspace"})(zn||(e.ExtensionKind=zn={}));class di{static validate(N){if(typeof N.badge=="string"){let ae=(0,I.$0e)(N.badge,0);if(ae<N.badge.length&&(ae+=(0,I.$0e)(N.badge,ae)),N.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Ct.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ae,pe){this.badge=N,this.tooltip=ae,this.color=pe}}e.$sL=di;let bn=class{constructor(N){this.kind=N}};e.$tL=bn,e.$tL=bn=Oe([j],bn);var Bn;(function(M){M[M.Light=1]="Light",M[M.Dark=2]="Dark",M[M.HighContrast=3]="HighContrast",M[M.HighContrastLight=4]="HighContrastLight"})(Bn||(e.ColorThemeKind=Bn={}));class Nt{static isNotebookRange(N){return N instanceof Nt?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ae){if(N<0)throw(0,O.$5)("start must be positive");if(ae<0)throw(0,O.$5)("end must be positive");N<=ae?(this.c=N,this.e=ae):(this.c=ae,this.e=N)}with(N){let ae=this.c,pe=this.e;return N.start!==void 0&&(ae=N.start),N.end!==void 0&&(pe=N.end),ae===this.c&&pe===this.e?this:new Nt(ae,pe)}}e.$uL=Nt;class Gt{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ae=>Gt.isNotebookCellData(ae))}static isNotebookCellData(N){return!0}constructor(N,ae,pe,Me,Ge,et,tt){this.kind=N,this.value=ae,this.languageId=pe,this.mime=Me,this.outputs=Ge??[],this.metadata=et,this.executionSummary=tt,Gt.validate(this)}}e.$vL=Gt;class mi{constructor(N){this.cells=N}}e.$wL=mi;class Dt{static isNotebookCellOutputItem(N){return N instanceof Dt?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ae={name:N.name,message:N.message,stack:N.stack};return Dt.json(ae,"application/vnd.code.notebook.error")}static stdout(N){return Dt.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return Dt.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ae="application/octet-stream"){return new Dt(N,ae)}static#e=new TextEncoder;static text(N,ae=A.$Ir.text){const pe=Dt.#e.encode(String(N));return new Dt(pe,ae)}static json(N,ae="text/x-json"){const pe=JSON.stringify(N,void 0,"	");return Dt.text(pe,ae)}constructor(N,ae){this.data=N,this.mime=ae;const pe=(0,A.$Mr)(ae,!0);if(!pe)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}e.$xL=Dt;class Kt{static isNotebookCellOutput(N){return N instanceof Kt?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ae=!1){const pe=new Set,Me=new Set;for(let Ge=0;Ge<N.length;Ge++){const et=N[Ge],tt=(0,A.$Mr)(et.mime);if(!pe.has(tt)||(0,g.$hI)(tt)){pe.add(tt);continue}Me.add(Ge),ae&&console.warn(`DUPLICATED mime type '${et.mime}' will be dropped`)}return Me.size===0?N:N.filter((Ge,et)=>!Me.has(et))}constructor(N,ae,pe){this.items=Kt.ensureUniqueMimeTypes(N,!0),typeof ae=="string"?(this.id=ae,this.metadata=pe):(this.id=(0,C.$bg)(),this.metadata=ae??pe)}}e.$yL=Kt;var qn;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(qn||(e.NotebookCellKind=qn={}));var Hn;(function(M){M[M.Idle=1]="Idle",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(Hn||(e.NotebookCellExecutionState=Hn={}));var Vn;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(Vn||(e.NotebookCellStatusBarAlignment=Vn={}));var Wn;(function(M){M[M.Default=0]="Default",M[M.InCenter=1]="InCenter",M[M.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",M[M.AtTop=3]="AtTop"})(Wn||(e.NotebookEditorRevealType=Wn={}));class gi{constructor(N,ae){this.text=N,this.alignment=ae}}e.$zL=gi;var Gn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred"})(Gn||(e.NotebookControllerAffinity=Gn={}));var Kn;(function(M){M[M.Default=1]="Default",M[M.Preferred=2]="Preferred",M[M.Hidden=-1]="Hidden"})(Kn||(e.NotebookControllerAffinity2=Kn={}));class $i{constructor(N,ae=[]){this.uri=N,this.provides=(0,D.$1b)(ae)}}e.$AL=$i;class pi{constructor(N){this.label=N}}e.$BL=pi;let wn=class{constructor(N,ae){this.label=N,this.timestamp=ae}};e.$CL=wn,e.$CL=wn=Oe([j],wn);var Qn;(function(M){M[M.Production=1]="Production",M[M.Development=2]="Development",M[M.Test=3]="Test"})(Qn||(e.ExtensionMode=Qn={}));var Jn;(function(M){M[M.Node=1]="Node",M[M.Webworker=2]="Webworker"})(Jn||(e.ExtensionRuntime=Jn={}));var Yn;(function(M){M[M.Other=0]="Other",M[M.Comment=1]="Comment",M[M.String=2]="String",M[M.RegEx=3]="RegEx"})(Yn||(e.StandardTokenType=Yn={}));class bi{constructor(N,ae){this.ranges=N,this.wordPattern=ae}}e.$DL=bi;class wi{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$EL=wi;var Zn;(function(M){M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(Zn||(e.TestResultState=Zn={}));var Xn;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(Xn||(e.TestRunProfileKind=Xn={}));let vn=class{constructor(N=void 0,ae=void 0,pe=void 0,Me=!1){this.include=N,this.exclude=ae,this.profile=pe,this.continuous=Me}};e.$FL=vn,e.$FL=vn=Oe([j],vn);let yn=k=class{static diff(N,ae,pe){const Me=new k(N);return Me.expectedOutput=ae,Me.actualOutput=pe,Me}constructor(N){this.message=N}};e.$GL=yn,e.$GL=yn=k=Oe([j],yn);let En=class{constructor(N){this.id=N}};e.$HL=En,e.$HL=En=Oe([j],En);let Ht=class{constructor(N,ae){this.covered=N,this.total=ae}};e.$IL=Ht,e.$IL=Ht=Oe([j],Ht);let kn=L=class{static fromDetails(N,ae){const pe=new Ht(0,0),Me=new Ht(0,0),Ge=new Ht(0,0);for(const tt of ae)if("branches"in tt){pe.total+=1,pe.covered+=tt.executionCount>0?1:0;for(const ut of tt.branches)Me.total+=1,Me.covered+=ut.executionCount>0?1:0}else Ge.total+=1,Ge.covered+=tt.executionCount>0?1:0;const et=new L(N,pe,Me.total>0?Me:void 0,Ge.total>0?Ge:void 0);return et.detailedCoverage=ae,et}constructor(N,ae,pe,Me){this.uri=N,this.statementCoverage=ae,this.branchCoverage=pe,this.functionCoverage=Me}};e.$JL=kn,e.$JL=kn=L=Oe([j],kn);let Dn=class{constructor(N,ae,pe=[]){this.executionCount=N,this.location=ae,this.branches=pe}};e.$KL=Dn,e.$KL=Dn=Oe([j],Dn);let Sn=class{constructor(N,ae){this.executionCount=N,this.location=ae}};e.$LL=Sn,e.$LL=Sn=Oe([j],Sn);let Pn=class{constructor(N,ae){this.executionCount=N,this.location=ae}};e.$ML=Pn,e.$ML=Pn=Oe([j],Pn);var xn;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(xn||(e.ExternalUriOpenerPriority=xn={}));var _n;(function(M){M[M.Untrusted=0]="Untrusted",M[M.Trusted=1]="Trusted",M[M.Unspecified=2]="Unspecified"})(_n||(e.WorkspaceTrustState=_n={}));var ei;(function(M){M[M.Notify=1]="Notify",M[M.OpenBrowser=2]="OpenBrowser",M[M.OpenPreview=3]="OpenPreview",M[M.Silent=4]="Silent",M[M.Ignore=5]="Ignore",M[M.OpenBrowserOnce=6]="OpenBrowserOnce"})(ei||(e.PortAutoForwardAction=ei={}));class vi{constructor(N,ae,pe,Me,Ge,et){this.kind=N,this.name=ae,this.detail=pe,this.uri=Me,this.range=Ge,this.selectionRange=et}}e.$NL=vi;class yi{constructor(N){this.uri=N}}e.$OL=yi;class Ei{constructor(N,ae){this.original=N,this.modified=ae}}e.$PL=Ei;class ki{constructor(N,ae,pe,Me){this.base=N,this.input1=ae,this.input2=pe,this.result=Me}}e.$QL=ki;class Di{constructor(N,ae){this.uri=N,this.viewType=ae}}e.$RL=Di;class Si{constructor(N){this.viewType=N}}e.$SL=Si;class Pi{constructor(N,ae){this.uri=N,this.notebookType=ae}}e.$TL=Pi;class Ci{constructor(N,ae,pe){this.original=N,this.modified=ae,this.notebookType=pe}}e.$UL=Ci;class Ii{constructor(){}}e.$VL=Ii;class Ai{constructor(N,ae){this.uri=N,this.inputBoxUri=ae}}e.$WL=Ai;var ti;(function(M){M[M.Up=1]="Up",M[M.Down=2]="Down"})(ti||(e.InteractiveSessionVoteDirection=ti={}));var ni;(function(M){M[M.Action=1]="Action",M[M.Toolbar=2]="Toolbar"})(ni||(e.InteractiveSessionCopyKind=ni={}));var ii;(function(M){M[M.Unhelpful=0]="Unhelpful",M[M.Helpful=1]="Helpful",M[M.Undone=2]="Undone",M[M.Accepted=3]="Accepted"})(ii||(e.InteractiveEditorResponseFeedbackKind=ii={}));var si;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.Assistant=2]="Assistant",M[M.Function=3]="Function"})(si||(e.ChatMessageRole=si={}));var ri;(function(M){M[M.Short=1]="Short",M[M.Medium=2]="Medium",M[M.Full=3]="Full"})(ri||(e.ChatVariableLevel=ri={}));class Li{constructor(N,ae){this.role=N,this.content=ae}}e.$XL=Li;var oi;(function(M){M[M.SymbolInformation=1]="SymbolInformation",M[M.CommandInformation=2]="CommandInformation",M[M.SearchInformation=3]="SearchInformation",M[M.SettingInformation=4]="SettingInformation"})(oi||(e.RelatedInformationType=oi={}))}),define(be[267],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zM=void 0,e.$zM=(0,D.$Lh)("environmentVariableService")}),define(be[268],we([1,0,7,4,63,3,248,10]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9M=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=void 0;function w(h,t){if(t)if(P.$i)for(const s in t){let o=s;for(const n in h)if(s.toLowerCase()===n.toLowerCase()){o=n;break}const i=t[s];i!==void 0&&$(h,o,i)}else Object.keys(t).forEach(s=>{const o=t[s];o!==void 0&&$(h,s,o)})}e.$1M=w;function $(h,t,s){typeof s=="string"?h[t]=s:delete h[t]}function C(h,t,s,o){h.TERM_PROGRAM="vscode",t&&(h.TERM_PROGRAM_VERSION=t),d(h,o)&&(h.LANG=g(s)),h.COLORTERM="truecolor"}e.$2M=C;function S(h,t){if(t)for(const s of Object.keys(t)){const o=t[s];o!=null&&(h[s]=o)}}async function v(h,t){return await Promise.all(Object.entries(t).map(async([s,o])=>{if(typeof o=="string")try{t[s]=await h(o)}catch{t[s]=o}})),t}function d(h,t){if(t==="on")return!0;if(t==="auto"){const s=h.LANG;return!s||s.search(/\.UTF\-8$/)===-1&&s.search(/\.utf8$/)===-1&&s.search(/\.euc.+/)===-1}return!1}e.$3M=d;function g(h){const t=h?h.split("-"):[],s=t.length;if(s===0)return"en_US.UTF-8";if(s===1){const o={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in o&&t.push(o[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}e.$4M=g;async function m(h,t,s,o,i,n){if(h.cwd){const b=typeof h.cwd=="object"?h.cwd.fsPath:h.cwd,p=await l(b,s);return(0,A.$YM)(p||b)}let a;return!h.ignoreConfigurationCwd&&i&&(s&&(i=await l(i,s,n)),i&&(D.$gc(i)?a=i:o&&(a=D.$hc(o.fsPath,i)))),a||(a=o?o.fsPath:t||""),(0,A.$YM)(a)}e.$5M=m;async function l(h,t,s){if(t)try{return await t(h)}catch(o){s?.error("Could not resolve terminal cwd",o);return}return h}function f(h,t,s){if(s)return o=>s.resolveWithEnvironment(t,h,o)}e.$6M=f;async function u(h,t,s,o,i,n){const a={};if(h.strictEnv)S(a,h.env);else{S(a,n);const b={...t};s&&(b&&await v(s,b),h.env&&await v(s,h.env)),(0,r.$tl)(a,"VSCODE_IPC_HOOK_CLI"),w(a,b),w(a,h.env),C(a,o,P.$v,i)}return a}e.$7M=u;async function c(h,t,s,o,i,n,a=P.$i){let b;if((0,I.$wf)(h)?b=h:(b=h.fsPath,a&&n!==1?b=b.replace(/\\/g,"/"):!a&&n===1&&(b=b.replace(/\//g,"\\"))),!t)return b;const p=b.includes(" "),E=b.includes("(")||b.includes(")"),k=D.$lc(t,".exe"),L=k==="pwsh"||s==="pwsh"||k==="powershell"||s==="powershell";if(L&&(p||b.includes("'")))return`& '${b.replace(/'/g,"''")}'`;if(E&&L)return`& '${b}'`;if(n===1){if(o!==void 0)return o==="gitbash"?(0,A.$WM)(b.replace(/\\/g,"/")):o==="wsl"?i?.getWslPath(b,"win-to-unix")||b:p?`"${b}"`:b;const j=t.toLowerCase();return j.includes("wsl")||j.includes("bash.exe")&&!j.toLowerCase().includes("git")?i?.getWslPath(b,"win-to-unix")||b:p?`"${b}"`:b}return(0,A.$WM)(b)}e.$8M=c;function y(h,t,s){const o=typeof h=="string"?O.URI.parse(h):h;let i=o?t.getWorkspaceFolder(o)??void 0:void 0;if(!i){const n=s.getLastActiveWorkspaceRoot();i=n?t.getWorkspaceFolder(n)??void 0:void 0}return i}e.$9M=y}),define(be[71],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(P){P.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var O;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(O||(e.TestPosition=O={}));class r{static fromExtHostTestItem(A,I,w=A.parent){if(A._isRoot)return new r([I]);const $=[A.id];for(let C=w;C&&C.id!==I;C=C.parent)$.push(C.id);return $.push(I),new r($.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const I=A.indexOf("\0");return I===-1?A:A.slice(0,I)}static fromString(A){return new r(A.split("\0"))}static join(A,I){return new r([...A.path,I])}static joinToString(A,I){return A.toString()+"\0"+I}static parentId(A){const I=A.lastIndexOf("\0");return I===-1?void 0:A.slice(0,I)}static localId(A){const I=A.lastIndexOf("\0");return I===-1?A:A.slice(I+1)}static isChild(A,I){return I.startsWith(A)&&I[A.length]==="\0"}static compare(A,I){return A===I?0:r.isChild(A,I)?2:r.isChild(I,A)?3:1}constructor(A,I=A.length){if(this.path=A,this.d=I,A.length===0||I<1)throw new Error("cannot create test with empty path")}get rootId(){return new r(this.path,1)}get parentId(){return this.d>1?new r(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new r(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new r(this.path,A)}compare(A){if(typeof A=="string")return r.compare(this.toString(),A);for(let I=0;I<A.d&&I<this.d;I++)if(A.path[I]!==this.path[I])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$1I=r}),define(be[91],we([1,0,4,42,71]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8I=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$7I=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$6I=e.$5I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$4I=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$3I=e.$2I=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var P;(function(p){p[p.Unset=0]="Unset",p[p.Queued=1]="Queued",p[p.Running=2]="Running",p[p.Passed=3]="Passed",p[p.Failed=4]="Failed",p[p.Skipped=5]="Skipped",p[p.Errored=6]="Errored"})(P||(e.TestResultState=P={}));var A;(function(p){p[p.Run=1]="Run",p[p.Debug=2]="Debug",p[p.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var I;(function(p){p[p.Run=2]="Run",p[p.Debug=4]="Debug",p[p.Coverage=8]="Coverage",p[p.HasNonDefaultProfile=16]="HasNonDefaultProfile",p[p.HasConfigurable=32]="HasConfigurable",p[p.SupportsContinuousRun=64]="SupportsContinuousRun"})(I||(e.TestRunProfileBitset=I={})),e.$2I=[2,4,8,16,32,64];const w=p=>"runId"in p;e.$3I=w;var $;(function(p){p.serialize=E=>({range:E.range.toJSON(),uri:E.uri.toJSON()}),p.deserialize=E=>({range:O.$ls.lift(E.range),uri:D.URI.revive(E.uri)})})($||(e.IRichLocation=$={}));var C;(function(p){p[p.Error=0]="Error",p[p.Output=1]="Output"})(C||(e.TestMessageType=C={}));var S;(function(p){p.serialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,contextValue:E.contextValue,location:E.location&&$.serialize(E.location)}),p.deserialize=E=>({message:E.message,type:0,expected:E.expected,actual:E.actual,contextValue:E.contextValue,location:E.location&&$.deserialize(E.location)})})(S||(e.ITestErrorMessage=S={}));const v=(p,E)=>`${E?"s":"e"}${p}`;e.$4I=v;var d;(function(p){p.serialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&$.serialize(E.location)}),p.deserialize=E=>({message:E.message,type:1,offset:E.offset,length:E.length,location:E.location&&$.deserialize(E.location)})})(d||(e.ITestOutputMessage=d={}));var g;(function(p){p.serialize=E=>E.type===0?S.serialize(E):d.serialize(E),p.deserialize=E=>E.type===0?S.deserialize(E):d.deserialize(E)})(g||(e.ITestMessage=g={}));var m;(function(p){p.serializeWithoutMessages=E=>({state:E.state,duration:E.duration,messages:[]}),p.serialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(g.serialize)}),p.deserialize=E=>({state:E.state,duration:E.duration,messages:E.messages.map(g.deserialize)})})(m||(e.ITestTaskState=m={}));const l="\0",f=(p,E)=>p+l+E;e.$5I=f;const u=p=>{const E=p.indexOf(l);return{ctrlId:p.slice(0,E),tagId:p.slice(E+1)}};e.$6I=u;var c;(function(p){p.serialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?.toJSON(),range:E.range?.toJSON()||null,description:E.description,error:E.error,sortText:E.sortText}),p.deserialize=E=>({extId:E.extId,label:E.label,tags:E.tags,busy:E.busy,children:void 0,uri:E.uri?D.URI.revive(E.uri):void 0,range:E.range?O.$ls.lift(E.range):null,description:E.description,error:E.error,sortText:E.sortText})})(c||(e.ITestItem=c={}));var y;(function(p){p[p.NotExpandable=0]="NotExpandable",p[p.Expandable=1]="Expandable",p[p.BusyExpanding=2]="BusyExpanding",p[p.Expanded=3]="Expanded"})(y||(e.TestItemExpandState=y={}));var h;(function(p){p.serialize=E=>({expand:E.expand,item:c.serialize(E.item)}),p.deserialize=E=>({controllerId:r.$1I.root(E.item.extId),expand:E.expand,item:c.deserialize(E.item)})})(h||(e.InternalTestItem=h={}));var t;(function(p){p.serialize=E=>{let k;return E.item&&(k={},E.item.label!==void 0&&(k.label=E.item.label),E.item.tags!==void 0&&(k.tags=E.item.tags),E.item.busy!==void 0&&(k.busy=E.item.busy),E.item.uri!==void 0&&(k.uri=E.item.uri?.toJSON()),E.item.range!==void 0&&(k.range=E.item.range?.toJSON()),E.item.description!==void 0&&(k.description=E.item.description),E.item.error!==void 0&&(k.error=E.item.error),E.item.sortText!==void 0&&(k.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:k}},p.deserialize=E=>{let k;return E.item&&(k={},E.item.label!==void 0&&(k.label=E.item.label),E.item.tags!==void 0&&(k.tags=E.item.tags),E.item.busy!==void 0&&(k.busy=E.item.busy),E.item.range!==void 0&&(k.range=E.item.range?O.$ls.lift(E.item.range):null),E.item.description!==void 0&&(k.description=E.item.description),E.item.error!==void 0&&(k.error=E.item.error),E.item.sortText!==void 0&&(k.sortText=E.item.sortText)),{extId:E.extId,expand:E.expand,item:k}}})(t||(e.ITestItemUpdate=t={}));const s=(p,E)=>{E.expand!==void 0&&(p.expand=E.expand),E.item!==void 0&&(p.item=p.item?Object.assign(p.item,E.item):E.item)};e.$7I=s;var o;(function(p){p.serializeWithoutMessages=E=>({...h.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(m.serializeWithoutMessages)}),p.serialize=E=>({...h.serialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(m.serialize)}),p.deserialize=E=>({...h.deserialize(E),ownComputedState:E.ownComputedState,computedState:E.computedState,tasks:E.tasks.map(m.deserialize),retired:!0})})(o||(e.TestResultItem=o={}));var i;(function(p){p[p.Function=0]="Function",p[p.Statement=1]="Statement"})(i||(e.DetailType=i={}));var n;(function(p){p[p.Add=0]="Add",p[p.Update=1]="Update",p[p.DocumentSynced=2]="DocumentSynced",p[p.Remove=3]="Remove",p[p.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",p[p.Retire=5]="Retire",p[p.AddTag=6]="AddTag",p[p.RemoveTag=7]="RemoveTag"})(n||(e.TestDiffOpType=n={}));var a;(function(p){p.deserialize=E=>E.op===0?{op:E.op,item:h.deserialize(E.item)}:E.op===1?{op:E.op,item:t.deserialize(E.item)}:E.op===2?{op:E.op,uri:D.URI.revive(E.uri),docv:E.docv}:E,p.serialize=E=>E.op===0?{op:E.op,item:h.serialize(E.item)}:E.op===1?{op:E.op,item:t.serialize(E.item)}:E})(a||(e.TestsDiffOp=a={}));class b{constructor(){this.d=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.d}apply(E){const k=this.p();for(const L of E)switch(L.op){case 0:this.k(h.deserialize(L.item),k);break;case 1:this.l(t.deserialize(L.item),k);break;case 3:this.m(L.itemId,k);break;case 5:this.o(L.itemId);break;case 4:this.updatePendingRoots(L.amount);break;case 6:this.d.set(L.tag.id,L.tag);break;case 7:this.d.delete(L.id);break}k.complete?.()}k(E,k){const L=r.$1I.parentId(E.item.extId)?.toString();let j;if(!L)j=this.q(E),this.g.add(j),this.f.set(E.item.extId,j);else if(this.f.has(L)){const Y=this.f.get(L);Y.children.add(E.item.extId),j=this.q(E,Y),this.f.set(E.item.extId,j)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(E)}`);return}return k.add?.(j),E.expand===2&&this.h++,j}l(E,k){const L=this.f.get(E.extId);if(L)return E.expand!==void 0&&(L.expand===2&&this.h--,E.expand===2&&this.h++),(0,e.$7I)(L,E),k.update?.(L),L}m(E,k){const L=this.f.get(E);if(!L)return;const j=r.$1I.parentId(L.item.extId)?.toString();j?this.f.get(j).children.delete(L.item.extId):this.g.delete(L);const Y=[[E]];for(;Y.length;)for(const ce of Y.pop()){const x=this.f.get(ce);x&&(Y.push(x.children),this.f.delete(ce),k.remove?.(x,x!==L),x.expand===2&&this.h--)}}o(E){}updatePendingRoots(E){this.j+=E}p(){return{}}}e.$8I=b}),define(be[132],we([1,0,14,5,2,94,91,71]),function(le,e,D,O,r,P,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=e.$1L=e.$ZL=e.$YL=e.TestItemEventOp=void 0;var w;(function(u){u[u.Upsert=0]="Upsert",u[u.SetTags=1]="SetTags",u[u.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",u[u.RemoveChild=3]="RemoveChild",u[u.SetProp=4]="SetProp",u[u.Bulk=5]="Bulk",u[u.DocumentSynced=6]="DocumentSynced"})(w||(e.TestItemEventOp=w={}));const $=(u,c)=>u===c,S=Object.entries({range:(u,c)=>u===c?!0:!u||!c?!1:u.equalsRange(c),busy:$,label:$,description:$,error:$,sortText:$,tags:(u,c)=>!(u.length!==c.length||u.some(y=>!c.includes(y)))}),v=(u,c)=>{let y;for(const[h,t]of S)t(u[h],c[h])||(y?y[h]=c[h]:y={[h]:c[h]});return y};class d extends r.$Qc{get root(){return this.s.root}constructor(c){super(),this.s=c,this.f=this.B(new D.$3g(()=>this.flushDiff(),200)),this.g=this.B(new O.$Ld),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(c){this.h=c;for(const y of this.tree.values())this.I(y)}get resolveHandler(){return this.h}collectDiff(){const c=this.m;return this.m=[],c}pushDiff(c){switch(c.op){case 2:{for(const y of this.m)if(y.op===2&&y.uri===c.uri){y.docv=c.docv;return}break}case 1:{const y=this.m[this.m.length-1];if(y){if(y.op===1&&y.item.extId===c.item.extId){(0,A.$7I)(y.item,c.item);return}if(y.op===0&&y.item.item.extId===c.item.extId){(0,A.$7I)(y.item,c.item);return}}break}}this.m.push(c),this.f.isScheduled()||this.f.schedule()}expand(c,y){const h=this.tree.get(c);if(h){if((h.expandLevels===void 0||y>h.expandLevels)&&(h.expandLevels=y),h.expand===1){const t=this.L(h);return t.isOpen()?this.J(h,y-1):t.wait().then(()=>this.J(h,y-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,y-1)):this.J(h,y-1)}}dispose(){for(const c of this.tree.values())this.s.getApiFor(c.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(c,y){switch(y.op){case 3:this.N(I.$1I.joinToString(c.fullId,y.id));break;case 0:this.y(y.item,c);break;case 5:for(const h of y.ops)this.u(c,h);break;case 1:this.z(y.new,y.old,c.fullId.toString());break;case 2:this.I(c);break;case 4:this.pushDiff({op:1,item:{extId:c.fullId.toString(),item:y.update}});break;case 6:this.w(c.actual.uri);break;default:(0,P.$2c)(y)}}w(c){c&&this.pushDiff({op:2,uri:c,docv:this.s.getDocumentVersion(c)})}y(c,y){const h=I.$1I.fromExtHostTestItem(c,this.root.id,y?.actual),t=this.s.getApiFor(c);t.parent&&t.parent!==y?.actual&&this.s.getChildren(t.parent).delete(c.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:c,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},c.tags.forEach(this.C,this),this.tree.set(s.fullId.toString(),s),this.F(c,y),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(c)}}),this.H(c,s,y);return}if(s.actual===c){this.G(c,s,y);return}if(s.actual.uri?.toString()!==c.uri?.toString())return this.N(h.toString()),this.y(c,y);const o=this.s.getChildren(s.actual),i=s.actual,n=v(this.s.toITestItem(i),this.s.toITestItem(c));this.s.getApiFor(i).listener=void 0,s.actual=c,s.expand=0,n&&(n.hasOwnProperty("tags")&&(this.z(c.tags,i.tags,h.toString()),delete n.tags),this.u(s,{op:4,update:n})),this.H(c,s,y);for(const[a,b]of o)this.s.getChildren(c).get(b.id)||this.N(I.$1I.joinToString(h,b.id));this.w(s.actual.uri)}z(c,y,h){const t=new Set(y.map(s=>s.id));for(const s of c)t.delete(s.id)||this.C(s);this.pushDiff({op:1,item:{extId:h,item:{tags:c.map(s=>(0,A.$5I)(this.s.controllerId,s.id))}}}),t.forEach(this.D,this)}C(c){const y=this.j.get(c.id);y?y.refCount++:(this.j.set(c.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$5I)(this.s.controllerId,c.id)}}))}D(c){const y=this.j.get(c);y&&!--y.refCount&&(this.j.delete(c),this.pushDiff({op:7,id:(0,A.$5I)(this.s.controllerId,c)}))}F(c,y){this.s.getApiFor(c).parent=y&&y.actual!==this.root?y.actual:void 0}G(c,y,h){this.F(c,h);const t=this.s.getApiFor(c);t.parent=h?.actual,t.listener=s=>this.u(y,s),this.I(y)}H(c,y,h){this.G(c,y,h);for(const[t,s]of this.s.getChildren(c))this.y(s,y)}I(c){let y;this.h?c.resolveBarrier?y=c.resolveBarrier.isOpen()?3:2:y=c.actual.canResolveChildren?1:0:y=0,y!==c.expand&&(c.expand=y,this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:y}}),y===1&&c.expandLevels!==void 0&&this.L(c))}J(c,y){if(y<0)return;const h=[];for(const[t,s]of this.s.getChildren(c.actual)){const o=this.expand(I.$1I.joinToString(c.fullId,s.id),y);(0,D.$Dg)(o)&&h.push(o)}if(h.length)return Promise.all(h).then(()=>{})}L(c){if(c.resolveBarrier)return c.resolveBarrier;if(!this.h){const s=new D.$Pg;return s.open(),s}c.expand=2,this.M(c);const y=c.resolveBarrier=new D.$Pg,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(c.actual===this.root?void 0:c.actual)}catch(s){h(s)}return(0,D.$Dg)(t)?t.catch(h).then(()=>{y.open(),this.I(c)}):(y.open(),this.I(c)),c.resolveBarrier}M(c){this.pushDiff({op:1,item:{extId:c.fullId.toString(),expand:c.expand}})}N(c){const y=this.tree.get(c);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:c});const h=[y];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.D(s.id);this.tree.delete(t.fullId.toString());for(const[s,o]of this.s.getChildren(t.actual))h.push(this.tree.get(I.$1I.joinToString(t.fullId,o.id)))}}}flushDiff(){const c=this.collectDiff();c.length&&this.g.fire(c)}}e.$YL=d;class g extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.$ZL=g;class m extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$1L=m;class l extends Error{constructor(c,y,h){super(`TestItem with ID "${c}" is from controller "${y}" and cannot be added as a child of an item from controller "${h}".`)}}e.$2L=l;const f=(u,c,y)=>{let h=new Map;return{get size(){return h.size},forEach(t,s){for(const o of h.values())t.call(s,o,this)},[Symbol.iterator](){return h.entries()},replace(t){const s=new Map,o=new Set(h.keys()),i={op:5,ops:[]};for(const n of t){if(!(n instanceof y))throw new m(n.id);const a=c(n).controllerId;if(a!==u.controllerId)throw new l(n.id,a,u.controllerId);if(s.has(n.id))throw new g(n.id);s.set(n.id,n),o.delete(n.id),i.ops.push({op:0,item:n})}for(const n of o.keys())i.ops.push({op:3,id:n});u.listener?.(i),h=s},add(t){if(!(t instanceof y))throw new m(t.id);h.set(t.id,t),u.listener?.({op:0,item:t})},delete(t){h.delete(t)&&u.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$3L=f}),define(be[133],we([1,0,132]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=e.$4L=void 0;const O=new WeakMap,r=(A,I)=>{const w={controllerId:I};return O.set(A,w),w};e.$4L=r;const P=A=>{const I=O.get(A);if(!I)throw new D.$1L(A?.id||"<unknown>");return I};e.$5L=P}),define(be[269],we([1,0,24,6]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$qD=e.$pD=e.$oD=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=void 0,e.$6C=".vscode",e.$7C="settings",e.$8C=`${e.$6C}/${e.$7C}.json`,e.$9C="vscode://schemas/settings/default",e.$0C="vscode://schemas/settings/user",e.$$C="vscode://schemas/settings/profile",e.$_C="vscode://schemas/settings/machine",e.$aD="vscode://schemas/settings/workspace",e.$bD="vscode://schemas/settings/folder",e.$cD="vscode://schemas/launch",e.$dD="vscode://schemas/tasks",e.$eD=[1],e.$fD=[2,3,4,5,6],e.$gD=[3,4,5],e.$hD=[1,...e.$gD],e.$iD=[2,3,4,5,6],e.$jD=[3,4,5,6],e.$kD=[4,5,6],e.$lD="tasks",e.$mD="launch",e.$nD=Object.create(null),e.$nD[e.$lD]=`${e.$6C}/${e.$lD}.json`,e.$nD[e.$mD]=`${e.$6C}/${e.$mD}.json`,e.$oD=Object.create(null),e.$oD[e.$lD]=`${e.$lD}.json`,e.$pD=(0,O.$Mh)(D.$fi),e.$qD=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$rD="workbench.settings.applyToAllProfiles"}),define(be[134],we([1,0,6]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=e.VariableKind=e.$UM=void 0,e.$UM=(0,D.$Lh)("configurationResolverService");var O;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator"})(O||(e.VariableKind=O={}));class r extends Error{constructor(A,I){super(I),this.variable=A}}e.$VM=r}),define(be[270],we([1,0,7,29,10,22,3,166,204,134,17]),function(le,e,D,O,r,P,A,I,w,$,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(d,g,m,l){this.h=new Map,this.a=d,this.b=g,this.g=m,l&&(this.c=l.then(f=>this.i(f)))}i(d){if(A.$i){const g=Object.create(null);return Object.keys(d).forEach(m=>{g[m.toLowerCase()]=d[m]}),g}return d}resolveWithEnvironment(d,g,m){return this.l({env:this.i(d),userHome:void 0},g?g.uri:void 0,m)}async resolveAsync(d,g){const m={env:await this.c,userHome:await this.g};return this.l(m,d?d.uri:void 0,g)}async j(d,g,m,l){const f=P.$Wm(g);A.$i&&f.windows?Object.keys(f.windows).forEach(c=>f[c]=f.windows[c]):A.$j&&f.osx?Object.keys(f.osx).forEach(c=>f[c]=f.osx[c]):A.$k&&f.linux&&Object.keys(f.linux).forEach(c=>f[c]=f.linux[c]),delete f.windows,delete f.osx,delete f.linux;const u={env:await this.c,userHome:await this.g};return this.l(u,d?d.uri:void 0,f,m,l)}async resolveAnyAsync(d,g,m){return this.j(d,g,m)}async resolveAnyMap(d,g,m){const l=new Map;return{newConfig:await this.j(d,g,m,l),resolvedVariables:l}}resolveWithInteractionReplace(d,g,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(d,g,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(d,g){if(this.h.has(d))throw new Error("Variable "+d+" is contributed twice.");this.h.set(d,g)}async l(d,g,m,l,f){if(r.$wf(m))return this.m(d,g,m,l,f);if(Array.isArray(m))return Promise.all(m.map(u=>this.l(d,g,u,l,f)));if(r.$yf(m)){const u=Object.create(null),c=await Promise.all(Object.keys(m).map(async y=>[await this.m(d,g,y,l,f),await this.l(d,g,m[y],l,f)]));for(const[y,h]of c)u[y]=h;return u}return m}m(d,g,m,l,f){return(0,C.$Re)(m,S.VARIABLE_REGEXP,async(u,c)=>{if(c.includes(S.VARIABLE_LHS))return u;let y=await this.o(d,u,c,g,l);return f?.set(c,y),y!==u&&r.$wf(y)&&y.match(S.VARIABLE_REGEXP)&&(y=await this.m(d,g,y,l,f)),y})}n(d){return this.b?this.b.getUriLabel(d,{noPrefix:!0}):d.fsPath}async o(d,g,m,l,f){let u;const c=m.split(":");c.length>1&&(m=c[0],u=c[1]);const y=s=>{const o=this.a.getFilePath();if(o)return(0,I.$jv)(o);throw new $.$VM(s,(0,w.localize)(0,null,g))},h=s=>{const o=y(s);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,I.$jv)(i)}throw new $.$VM(s,(0,w.localize)(1,null,g,D.$lc(o)))},t=s=>{if(u){const o=this.a.getFolderUri(u);if(o)return o;throw new $.$VM(s,(0,w.localize)(2,null,g,u))}if(l)return l;throw this.a.getWorkspaceFolderCount()>1?new $.$VM(s,(0,w.localize)(3,null,g)):new $.$VM(s,(0,w.localize)(4,null,g))};switch(m){case"env":if(u){if(d.env){const s=d.env[A.$i?u.toLowerCase():u];if(r.$wf(s))return s}return""}throw new $.$VM($.VariableKind.Env,(0,w.localize)(5,null,g));case"config":if(u){const s=this.a.getConfigurationValue(l,u);if(r.$Ff(s))throw new $.$VM($.VariableKind.Config,(0,w.localize)(6,null,g,u));if(r.$yf(s))throw new $.$VM($.VariableKind.Config,(0,w.localize)(7,null,g,u));return s}throw new $.$VM($.VariableKind.Config,(0,w.localize)(8,null,g));case"command":return this.p($.VariableKind.Command,g,u,f,"command");case"input":return this.p($.VariableKind.Input,g,u,f,"input");case"extensionInstallFolder":if(u){const s=await this.a.getExtension(u);if(!s)throw new $.$VM($.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,g,u));return this.n(s.extensionLocation)}throw new $.$VM($.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,g));default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,I.$jv)(this.n(t($.VariableKind.WorkspaceFolder)));case"cwd":return l||u?(0,I.$jv)(this.n(t($.VariableKind.Cwd))):O.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,I.$jv)(D.$lc(this.n(t($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(d.userHome)return d.userHome;throw new $.$VM($.VariableKind.UserHome,(0,w.localize)(11,null,g))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new $.$VM($.VariableKind.LineNumber,(0,w.localize)(12,null,g))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new $.$VM($.VariableKind.SelectedText,(0,w.localize)(13,null,g))}case"file":return y($.VariableKind.File);case"fileWorkspaceFolder":return h($.VariableKind.FileWorkspaceFolder);case"relativeFile":return l||u?D.$jc(this.n(t($.VariableKind.RelativeFile)),y($.VariableKind.RelativeFile)):y($.VariableKind.RelativeFile);case"relativeFileDirname":{const s=D.$kc(y($.VariableKind.RelativeFileDirname));if(l||u){const o=D.$jc(this.n(t($.VariableKind.RelativeFileDirname)),s);return o.length===0?".":o}return s}case"fileDirname":return D.$kc(y($.VariableKind.FileDirname));case"fileExtname":return D.$mc(y($.VariableKind.FileExtname));case"fileBasename":return D.$lc(y($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=D.$lc(y($.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-D.$mc(s).length)}case"fileDirnameBasename":return D.$lc(D.$kc(y($.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||g}case"execInstallFolder":{const s=this.a.getAppRoot();return s||g}case"pathSeparator":return D.sep;default:try{const s=u?`${m}:${u}`:m;return this.p($.VariableKind.Unknown,g,s,f,void 0)}catch{return g}}}}p(d,g,m,l,f){if(m&&l){const u=f===void 0?l[m]:l[f+":"+m];if(typeof u=="string")return u;throw new $.$VM(d,(0,w.localize)(14,null,g))}return g}}e.$0M=S}),define(be[271],we([1,0,6,90]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$B=e.$0B=e.OpenEditorContext=e.GroupsOrder=e.$9B=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$8B=void 0,e.$8B=(0,D.$Lh)("editorGroupsService");var r;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(r||(e.GroupDirection=r={}));var P;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var A;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var I;(function(g){g[g.MAXIMIZE=0]="MAXIMIZE",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(I||(e.GroupsArrangement=I={}));var w;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(w||(e.MergeGroupMode=w={}));function $(g){const m=g;return(0,O.$XD)(m?.editor)&&(0,O.$XD)(m?.replacement)}e.$9B=$;var C;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(C||(e.GroupsOrder=C={}));var S;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function v(g){const m=g;return!!m&&typeof m.id=="number"&&Array.isArray(m.editors)}e.$0B=v;function d(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$$B=d}),define(be[135],we([1,0,6,271]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=void 0,e.$_B=(0,D.$Lh)("editorService"),e.$aC=-1,e.$bC=-2;function r(P){const A=P;return typeof P=="number"||(0,O.$0B)(A)}e.$cC=r}),define(be[136],we([1,0,18,15,150,74,101,26,143,50,62,22,10,4,42,172,227,133,90,130,71,91,135,131]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$8L=e.$7L=e.MarkdownString=e.$6L=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var o;(function(ve){function De(J){const{selectionStartLineNumber:Pe,selectionStartColumn:Re,positionLineNumber:Ve,positionColumn:ze}=J,xe=new s.$$J(Pe-1,Re-1),rt=new s.$$J(Ve-1,ze-1);return new s.$aK(xe,rt)}ve.to=De;function fe(J){const{anchor:Pe,active:Re}=J;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Re.line+1,positionColumn:Re.character+1}}ve.from=fe})(o||(e.Selection=o={}));var i;(function(ve){function De(J){if(!J)return;const{start:Pe,end:Re}=J;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Re.line+1,endColumn:Re.character+1}}ve.from=De;function fe(J){if(!J)return;const{startLineNumber:Pe,startColumn:Re,endLineNumber:Ve,endColumn:ze}=J;return new s.$_J(Pe-1,Re-1,Ve-1,ze-1)}ve.to=fe})(i||(e.Range=i={}));var n;(function(ve){function De(fe){switch(fe){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}ve.to=De})(n||(e.TokenType=n={}));var a;(function(ve){function De(J){return new s.$$J(J.lineNumber-1,J.column-1)}ve.to=De;function fe(J){return{lineNumber:J.line+1,column:J.character+1}}ve.from=fe})(a||(e.Position=a={}));var b;(function(ve){function De(Pe,Re,Ve){return(0,D.$Fb)((0,D.$1b)(Pe).map(ze=>fe(ze,Re,Ve)))}ve.from=De;function fe(Pe,Re,Ve){if(typeof Pe=="string")return{$serialized:!0,language:Pe,isBuiltin:Ve?.isBuiltin};if(Pe)return{$serialized:!0,language:Pe.language,scheme:J(Pe.scheme,Re),pattern:je.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType,isBuiltin:Ve?.isBuiltin}}function J(Pe,Re){return Re&&typeof Pe=="string"?Re.transformOutgoingScheme(Pe):Pe}})(b||(e.DocumentSelector=b={}));var p;(function(ve){function De(J){switch(J){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}ve.from=De;function fe(J){switch(J){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}ve.to=fe})(p||(e.DiagnosticTag=p={}));var E;(function(ve){function De(J){let Pe;return J.code&&((0,v.$wf)(J.code)||(0,v.$Af)(J.code)?Pe=String(J.code):Pe={value:String(J.code.value),target:J.code.target}),{...i.from(J.range),message:J.message,source:J.source,code:Pe,severity:L.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(k.from),tags:Array.isArray(J.tags)?(0,D.$Fb)(J.tags.map(p.from)):void 0}}ve.from=De;function fe(J){const Pe=new s.$lK(i.to(J),J.message,L.to(J.severity));return Pe.source=J.source,Pe.code=(0,v.$wf)(J.code)?J.code:J.code?.value,Pe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(k.to),Pe.tags=J.tags&&(0,D.$Fb)(J.tags.map(p.to)),Pe}ve.to=fe})(E||(e.Diagnostic=E={}));var k;(function(ve){function De(J){return{...i.from(J.location.range),message:J.message,resource:J.location.uri}}ve.from=De;function fe(J){return new s.$kK(new s.$jK(J.resource,i.to(J)),J.message)}ve.to=fe})(k||(e.DiagnosticRelatedInformation=k={}));var L;(function(ve){function De(J){switch(J){case s.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}ve.from=De;function fe(J){switch(J){case l.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}ve.to=fe})(L||(e.DiagnosticSeverity=L={}));var j;(function(ve){function De(J){return typeof J=="number"&&J>=s.ViewColumn.One?J-1:J===s.ViewColumn.Beside?t.$bC:t.$aC}ve.from=De;function fe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=fe})(j||(e.ViewColumn=j={}));function Y(ve){return typeof ve.range<"u"}function ce(ve){return ve.length===0?!0:!!Y(ve[0])}e.$6L=ce;var x;(function(ve){function De(ze){return ze.map(ve.from)}ve.fromMany=De;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function J(ze){let xe;if(fe(ze)){const{language:at,value:pt}=ze;xe={value:"```"+at+`
`+pt+"\n```\n"}}else s.$xK.isMarkdownString(ze)?xe={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?xe={value:ze}:xe={value:""};const rt=Object.create(null);xe.uris=rt;const dt=at=>{try{let pt=d.URI.parse(at,!0);pt=pt.with({query:Pe(pt.query,rt)}),rt[at]=pt}catch{}return""},$t=new w.marked.Renderer;return $t.link=dt,$t.image=at=>typeof at=="string"?dt(A.$6j(at).href):"",(0,w.marked)(xe.value,{renderer:$t}),xe}ve.from=J;function Pe(ze,xe){if(!ze)return ze;let rt;try{rt=(0,$.$hh)(ze)}catch{}if(!rt)return ze;let dt=!1;return rt=(0,S.$Ym)(rt,$t=>{if(d.URI.isUri($t)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return xe[at]=$t,dt=!0,at}else return}),dt?JSON.stringify(rt):ze}function Re(ze){const xe=new s.$xK(ze.value,ze.supportThemeIcons);return xe.isTrusted=ze.isTrusted,xe.supportHtml=ze.supportHtml,xe.baseUri=ze.baseUri?d.URI.from(ze.baseUri):void 0,xe}ve.to=Re;function Ve(ze){if(ze)return typeof ze=="string"?ze:ve.from(ze)}ve.fromStrict=Ve})(x||(e.MarkdownString=x={}));function ne(ve){return ce(ve)?ve.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?x.fromMany(De.hoverMessage):De.hoverMessage?x.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):ve.map(De=>({range:i.from(De)}))}e.$7L=ne;function ue(ve){return typeof ve>"u"?ve:typeof ve=="string"?d.URI.file(ve):ve}e.$8L=ue;var _;(function(ve){function De(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?ue(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}ve.from=De})(_||(e.ThemableDecorationAttachmentRenderOptions=_={}));var he;(function(ve){function De(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?_.from(fe.before):void 0,after:fe.after?_.from(fe.after):void 0}}ve.from=De})(he||(e.ThemableDecorationRenderOptions=he={}));var ee;(function(ve){function De(fe){if(typeof fe>"u")return fe;switch(fe){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=De})(ee||(e.DecorationRangeBehavior=ee={}));var te;(function(ve){function De(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ee.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?he.from(fe.light):void 0,dark:fe.dark?he.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?ue(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?_.from(fe.before):void 0,after:fe.after?_.from(fe.after):void 0}}ve.from=De})(te||(e.DecorationRenderOptions=te={}));var W;(function(ve){function De(J){return{text:J.newText,eol:J.newEol&&Je.from(J.newEol),range:i.from(J.range)}}ve.from=De;function fe(J){const Pe=new s.$eK(i.to(J.range),J.text);return Pe.newEol=typeof J.eol>"u"?void 0:Je.to(J.eol),Pe}ve.to=fe})(W||(e.TextEdit=W={}));var K;(function(ve){function De(J,Pe){const Re={edits:[]};if(J instanceof s.$hK){const Ve=new I.$zc;for(const ze of J._allEntries())ze._type===1&&d.URI.isUri(ze.to)&&ze.from===void 0&&Ve.add(ze.to);for(const ze of J._allEntries())if(ze._type===1){let xe;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?xe={type:"base64",value:(0,O.$te)(O.$_d.wrap(ze.options.contents))}:xe={type:"dataTransferItem",id:ze.options.contents._itemId}),Re.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:xe},metadata:ze.metadata})}else ze._type===2?Re.edits.push({resource:ze.uri,textEdit:W.from(ze.edit),versionId:Ve.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Re.edits.push({resource:ze.uri,textEdit:{range:i.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ve.has(ze.uri)?void 0:Pe?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Re.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Re.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(_e.from)}})}return Re}ve.from=De;function fe(J){const Pe=new s.$hK,Re=new I.$yc;for(const Ve of J.edits)if(Ve.textEdit){const ze=Ve,xe=d.URI.revive(ze.resource),rt=i.to(ze.textEdit.range),dt=ze.textEdit.text,$t=ze.textEdit.insertAsSnippet;let at;$t?at=s.$gK.replace(rt,new s.$iK(dt)):at=s.$eK.replace(rt,dt);const pt=Re.get(xe);pt?pt.push(at):Re.set(xe,[at])}else Pe.renameFile(d.URI.revive(Ve.oldResource),d.URI.revive(Ve.newResource),Ve.options);for(const[Ve,ze]of Re)Pe.set(Ve,ze);return Pe}ve.to=fe})(K||(e.WorkspaceEdit=K={}));var V;(function(ve){const De=Object.create(null);De[s.SymbolKind.File]=0,De[s.SymbolKind.Module]=1,De[s.SymbolKind.Namespace]=2,De[s.SymbolKind.Package]=3,De[s.SymbolKind.Class]=4,De[s.SymbolKind.Method]=5,De[s.SymbolKind.Property]=6,De[s.SymbolKind.Field]=7,De[s.SymbolKind.Constructor]=8,De[s.SymbolKind.Enum]=9,De[s.SymbolKind.Interface]=10,De[s.SymbolKind.Function]=11,De[s.SymbolKind.Variable]=12,De[s.SymbolKind.Constant]=13,De[s.SymbolKind.String]=14,De[s.SymbolKind.Number]=15,De[s.SymbolKind.Boolean]=16,De[s.SymbolKind.Array]=17,De[s.SymbolKind.Object]=18,De[s.SymbolKind.Key]=19,De[s.SymbolKind.Null]=20,De[s.SymbolKind.EnumMember]=21,De[s.SymbolKind.Struct]=22,De[s.SymbolKind.Event]=23,De[s.SymbolKind.Operator]=24,De[s.SymbolKind.TypeParameter]=25;function fe(Pe){return typeof De[Pe]=="number"?De[Pe]:6}ve.from=fe;function J(Pe){for(const Re in De)if(De[Re]===Pe)return Number(Re);return s.SymbolKind.Property}ve.to=J})(V||(e.SymbolKind=V={}));var oe;(function(ve){function De(J){switch(J){case s.SymbolTag.Deprecated:return 1}}ve.from=De;function fe(J){switch(J){case 1:return s.SymbolTag.Deprecated}}ve.to=fe})(oe||(e.SymbolTag=oe={}));var me;(function(ve){function De(J){return{name:J.name,kind:V.from(J.kind),tags:J.tags&&J.tags.map(oe.from),containerName:J.containerName,location:F.from(J.location)}}ve.from=De;function fe(J){const Pe=new s.$oK(J.name,V.to(J.kind),J.containerName,F.to(J.location));return Pe.tags=J.tags&&J.tags.map(oe.to),Pe}ve.to=fe})(me||(e.WorkspaceSymbol=me={}));var se;(function(ve){function De(J){const Pe={name:J.name||"!!MISSING: name!!",detail:J.detail,range:i.from(J.range),selectionRange:i.from(J.selectionRange),kind:V.from(J.kind),tags:J.tags?.map(oe.from)??[]};return J.children&&(Pe.children=J.children.map(De)),Pe}ve.from=De;function fe(J){const Pe=new s.$pK(J.name,J.detail,V.to(J.kind),i.to(J.range),i.to(J.selectionRange));return(0,D.$Jb)(J.tags)&&(Pe.tags=J.tags.map(oe.to)),J.children&&(Pe.children=J.children.map(fe)),Pe}ve.to=fe})(se||(e.DocumentSymbol=se={}));var U;(function(ve){function De(J){const Pe=new s.$tK(V.to(J.kind),J.name,J.detail||"",d.URI.revive(J.uri),i.to(J.range),i.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ve.to=De;function fe(J,Pe,Re){if(Pe=Pe??J._sessionId,Re=Re??J._itemId,Pe===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Re,name:J.name,detail:J.detail,kind:V.from(J.kind),uri:J.uri,range:i.from(J.range),selectionRange:i.from(J.selectionRange),tags:J.tags?.map(oe.from)}}ve.from=fe})(U||(e.CallHierarchyItem=U={}));var Z;(function(ve){function De(fe){return new s.$uK(U.to(fe.from),fe.fromRanges.map(J=>i.to(J)))}ve.to=De})(Z||(e.CallHierarchyIncomingCall=Z={}));var R;(function(ve){function De(fe){return new s.$vK(U.to(fe.to),fe.fromRanges.map(J=>i.to(J)))}ve.to=De})(R||(e.CallHierarchyOutgoingCall=R={}));var F;(function(ve){function De(J){return{range:J.range&&i.from(J.range),uri:J.uri}}ve.from=De;function fe(J){return new s.$jK(d.URI.revive(J.uri),i.to(J.range))}ve.to=fe})(F||(e.location=F={}));var G;(function(ve){function De(J){const Pe=J,Re=J;return{originSelectionRange:Pe.originSelectionRange?i.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Re.uri,range:i.from(Pe.targetRange?Pe.targetRange:Re.range),targetSelectionRange:Pe.targetSelectionRange?i.from(Pe.targetSelectionRange):void 0}}ve.from=De;function fe(J){return{targetUri:d.URI.revive(J.uri),targetRange:i.to(J.range),targetSelectionRange:J.targetSelectionRange?i.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?i.to(J.originSelectionRange):void 0}}ve.to=fe})(G||(e.DefinitionLink=G={}));var T;(function(ve){function De(J){return{range:i.from(J.range),contents:x.fromMany(J.contents)}}ve.from=De;function fe(J){return new s.$mK(J.contents.map(x.to),i.to(J.range))}ve.to=fe})(T||(e.Hover=T={}));var q;(function(ve){function De(J){return{range:i.from(J.range),expression:J.expression}}ve.from=De;function fe(J){return new s.$fL(i.to(J.range),J.expression)}ve.to=fe})(q||(e.EvaluatableExpression=q={}));var z;(function(ve){function De(J){if(J instanceof s.$gL)return{type:"text",range:i.from(J.range),text:J.text};if(J instanceof s.$hL)return{type:"variable",range:i.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof s.$iL)return{type:"expression",range:i.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=De;function fe(J){switch(J.type){case"text":return{range:i.to(J.range),text:J.text};case"variable":return{range:i.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:i.to(J.range),expression:J.expression}}}ve.to=fe})(z||(e.InlineValue=z={}));var ie;(function(ve){function De(J){return{frameId:J.frameId,stoppedLocation:i.from(J.stoppedLocation)}}ve.from=De;function fe(J){return new s.$jL(J.frameId,i.to(J.stoppedLocation))}ve.to=fe})(ie||(e.InlineValueContext=ie={}));var B;(function(ve){function De(J){return{range:i.from(J.range),kind:J.kind}}ve.from=De;function fe(J){return new s.$nK(i.to(J.range),J.kind)}ve.to=fe})(B||(e.DocumentHighlight=B={}));var X;(function(ve){function De(fe){switch(fe){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}ve.to=De})(X||(e.CompletionTriggerKind=X={}));var H;(function(ve){function De(fe){return{triggerKind:X.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}ve.to=De})(H||(e.CompletionContext=H={}));var Q;(function(ve){function De(J){switch(J){case s.CompletionItemTag.Deprecated:return 1}}ve.from=De;function fe(J){switch(J){case 1:return s.CompletionItemTag.Deprecated}}ve.to=fe})(Q||(e.CompletionItemTag=Q={}));var re;(function(ve){const De=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function fe(Re){return De.get(Re)??9}ve.from=fe;const J=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Pe(Re){return J.get(Re)??s.CompletionItemKind.Property}ve.to=Pe})(re||(e.CompletionItemKind=re={}));var de;(function(ve){function De(fe,J){const Pe=new s.$DK(fe.label);return Pe.insertText=fe.insertText,Pe.kind=re.to(fe.kind),Pe.tags=fe.tags?.map(Q.to),Pe.detail=fe.detail,Pe.documentation=A.$1j(fe.documentation)?x.to(fe.documentation):fe.documentation,Pe.sortText=fe.sortText,Pe.filterText=fe.filterText,Pe.preselect=fe.preselect,Pe.commitCharacters=fe.commitCharacters,g.$ls.isIRange(fe.range)?Pe.range=i.to(fe.range):typeof fe.range=="object"&&(Pe.range={inserting:i.to(fe.range.insert),replacing:i.to(fe.range.replace)}),Pe.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?Pe.insertText=new s.$iK(fe.insertText):(Pe.insertText=fe.insertText,Pe.textEdit=Pe.range instanceof s.$_J?new s.$eK(Pe.range,Pe.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(Pe.additionalTextEdits=fe.additionalTextEdits.map(Re=>W.to(Re))),Pe.command=J&&fe.command?J.fromInternal(fe.command):void 0,Pe}ve.to=De})(de||(e.CompletionItem=de={}));var Ee;(function(ve){function De(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:x.fromStrict(J.documentation)}}ve.from=De;function fe(J){return{label:J.label,documentation:A.$1j(J.documentation)?x.to(J.documentation):J.documentation}}ve.to=fe})(Ee||(e.ParameterInformation=Ee={}));var Ce;(function(ve){function De(J){return{label:J.label,documentation:x.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(Ee.from):[],activeParameter:J.activeParameter}}ve.from=De;function fe(J){return{label:J.label,documentation:A.$1j(J.documentation)?x.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(Ee.to):[],activeParameter:J.activeParameter}}ve.to=fe})(Ce||(e.SignatureInformation=Ce={}));var Le;(function(ve){function De(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(Ce.from):[]}}ve.from=De;function fe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(Ce.to):[]}}ve.to=fe})(Le||(e.SignatureHelp=Le={}));var Ne;(function(ve){function De(fe,J){const Pe=new s.$CK(a.to(J.position),typeof J.label=="string"?J.label:J.label.map($e.to.bind(void 0,fe)),J.kind&&ke.to(J.kind));return Pe.textEdits=J.textEdits&&J.textEdits.map(W.to),Pe.tooltip=A.$1j(J.tooltip)?x.to(J.tooltip):J.tooltip,Pe.paddingLeft=J.paddingLeft,Pe.paddingRight=J.paddingRight,Pe}ve.to=De})(Ne||(e.InlayHint=Ne={}));var $e;(function(ve){function De(fe,J){const Pe=new s.$BK(J.label);return Pe.tooltip=A.$1j(J.tooltip)?x.to(J.tooltip):J.tooltip,m.Command.is(J.command)&&(Pe.command=fe.fromInternal(J.command)),J.location&&(Pe.location=F.to(J.location)),Pe}ve.to=De})($e||(e.InlayHintLabelPart=$e={}));var ke;(function(ve){function De(J){return J}ve.from=De;function fe(J){return J}ve.to=fe})(ke||(e.InlayHintKind=ke={}));var ye;(function(ve){function De(J){return{range:i.from(J.range),url:J.target,tooltip:J.tooltip}}ve.from=De;function fe(J){let Pe;if(J.url)try{Pe=typeof J.url=="string"?d.URI.parse(J.url,!0):d.URI.revive(J.url)}catch{}return new s.$IK(i.to(J.range),Pe)}ve.to=fe})(ye||(e.DocumentLink=ye={}));var Te;(function(ve){function De(J){const Pe=new s.$LK(J.label);return J.textEdit&&(Pe.textEdit=W.to(J.textEdit)),J.additionalTextEdits&&(Pe.additionalTextEdits=J.additionalTextEdits.map(Re=>W.to(Re))),Pe}ve.to=De;function fe(J){return{label:J.label,textEdit:J.textEdit?W.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Pe=>W.from(Pe)):void 0}}ve.from=fe})(Te||(e.ColorPresentation=Te={}));var Ue;(function(ve){function De(J){return new s.$JK(J[0],J[1],J[2],J[3])}ve.to=De;function fe(J){return[J.red,J.green,J.blue,J.alpha]}ve.from=fe})(Ue||(e.Color=Ue={}));var Xe;(function(ve){function De(J){return{range:i.from(J.range)}}ve.from=De;function fe(J){return new s.$sK(i.to(J.range))}ve.to=fe})(Xe||(e.SelectionRange=Xe={}));var He;(function(ve){function De(fe){switch(fe){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}ve.to=De})(He||(e.TextDocumentSaveReason=He={}));var Ze;(function(ve){function De(J){switch(J){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=De;function fe(J){switch(J){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}ve.to=fe})(Ze||(e.TextEditorLineNumbersStyle=Ze={}));var Je;(function(ve){function De(J){if(J===s.EndOfLine.CRLF)return 1;if(J===s.EndOfLine.LF)return 0}ve.from=De;function fe(J){if(J===1)return s.EndOfLine.CRLF;if(J===0)return s.EndOfLine.LF}ve.to=fe})(Je||(e.EndOfLine=Je={}));var ge;(function(ve){function De(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=De})(ge||(e.ProgressLocation=ge={}));var Se;(function(ve){function De(J){const Pe={start:J.start+1,end:J.end+1};return J.kind&&(Pe.kind=Ie.from(J.kind)),Pe}ve.from=De;function fe(J){const Pe={start:J.start-1,end:J.end-1};return J.kind&&(Pe.kind=Ie.to(J.kind)),Pe}ve.to=fe})(Se||(e.FoldingRange=Se={}));var Ie;(function(ve){function De(J){if(J)switch(J){case s.FoldingRangeKind.Comment:return m.$at.Comment;case s.FoldingRangeKind.Imports:return m.$at.Imports;case s.FoldingRangeKind.Region:return m.$at.Region}}ve.from=De;function fe(J){if(J)switch(J.value){case m.$at.Comment.value:return s.FoldingRangeKind.Comment;case m.$at.Imports.value:return s.FoldingRangeKind.Imports;case m.$at.Region.value:return s.FoldingRangeKind.Region}}ve.to=fe})(Ie||(e.FoldingRangeKind=Ie={}));var Fe;(function(ve){function De(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?i.from(fe.selection):void 0,override:typeof fe.override=="boolean"?u.$KD.id:void 0}}ve.from=De})(Fe||(e.TextEditorOpenOptions=Fe={}));var je;(function(ve){function De(Re){return Re instanceof s.$6K?Re.toJSON():typeof Re=="string"?Re:fe(Re)||J(Re)?new s.$6K(Re.baseUri??Re.base,Re.pattern).toJSON():Re}ve.from=De;function fe(Re){const Ve=Re;return Ve?d.URI.isUri(Ve.baseUri)&&typeof Ve.pattern=="string":!1}function J(Re){const Ve=Re;return Ve?typeof Ve.base=="string"&&typeof Ve.pattern=="string":!1}function Pe(Re){return typeof Re=="string"?Re:new s.$6K(d.URI.revive(Re.baseUri),Re.pattern)}ve.to=Pe})(je||(e.GlobPattern=je={}));var Ke;(function(ve){function De(fe){if(fe){if(Array.isArray(fe))return fe.map(De);if(typeof fe=="string")return fe;{const J=fe;return{language:J.language,scheme:J.scheme,pattern:je.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ve.from=De})(Ke||(e.LanguageSelector=Ke={}));var Be;(function(ve){function De(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Pe=>Array.isArray(Pe)&&Pe.every(Re=>Re&&typeof Re=="object"&&"uri"in Re&&d.URI.isUri(Re.uri)&&"version"in Re&&typeof Re.version=="number"&&"ranges"in Re&&Array.isArray(Re.ranges)&&Re.ranges.every(Ve=>Ve instanceof s.$_J)))}ve.is=De;function fe(J){return{documents:J.documents.map(Pe=>Pe.map(Re=>({uri:d.URI.from(Re.uri),version:Re.version,ranges:Re.ranges.map(Ve=>i.from(Ve))})))}}ve.from=fe})(Be||(e.MappedEditsContext=Be={}));var qe;(function(ve){function De(J){return{start:J.start,end:J.end}}ve.from=De;function fe(J){return new s.$uL(J.start,J.end)}ve.to=fe})(qe||(e.NotebookRange=qe={}));var Qe;(function(ve){function De(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ve.to=De;function fe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ve.from=fe})(Qe||(e.NotebookCellExecutionSummary=Qe={}));var We;(function(ve){function De(fe){if(fe===c.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(fe===c.NotebookCellExecutionState.Pending)return;if(fe===c.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}ve.to=De})(We||(e.NotebookCellExecutionState=We={}));var Ye;(function(ve){function De(J){switch(J){case s.NotebookCellKind.Markup:return c.CellKind.Markup;case s.NotebookCellKind.Code:default:return c.CellKind.Code}}ve.from=De;function fe(J){switch(J){case c.CellKind.Markup:return s.NotebookCellKind.Markup;case c.CellKind.Code:default:return s.NotebookCellKind.Code}}ve.to=fe})(Ye||(e.NotebookCellKind=Ye={}));var it;(function(ve){function De(J){const Pe={metadata:J.metadata??Object.create(null),cells:[]};for(const Re of J.cells)s.$vL.validate(Re),Pe.cells.push(_e.from(Re));return Pe}ve.from=De;function fe(J){const Pe=new s.$wL(J.cells.map(_e.to));return(0,v.$Jf)(J.metadata)||(Pe.metadata=J.metadata),Pe}ve.to=fe})(it||(e.NotebookData=it={}));var _e;(function(ve){function De(J){return{cellKind:Ye.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Qe.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(ot.from):[]}}ve.from=De;function fe(J){return new s.$vL(Ye.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(ot.to):void 0,J.metadata,J.internalMetadata?Qe.to(J.internalMetadata):void 0)}ve.to=fe})(_e||(e.NotebookCellData=_e={}));var st;(function(ve){function De(J){return{mime:J.mime,valueBytes:O.$_d.wrap(J.data)}}ve.from=De;function fe(J){return new s.$xL(J.valueBytes.buffer,J.mime)}ve.to=fe})(st||(e.NotebookCellOutputItem=st={}));var ot;(function(ve){function De(J){return{outputId:J.id,items:J.items.map(st.from),metadata:J.metadata}}ve.from=De;function fe(J){const Pe=J.items.map(st.to);return new s.$yL(Pe,J.outputId,J.metadata)}ve.to=fe})(ot||(e.NotebookCellOutput=ot={}));var At;(function(ve){function De(Pe){return J(Pe)?{include:je.from(Pe.include)??void 0,exclude:je.from(Pe.exclude)??void 0}:je.from(Pe)??void 0}ve.from=De;function fe(Pe){return J(Pe)?{include:je.to(Pe.include),exclude:je.to(Pe.exclude)}:je.to(Pe)}ve.to=fe;function J(Pe){const Re=Pe;return Re?!(0,v.$Ff)(Re.include)&&!(0,v.$Ff)(Re.exclude):!1}})(At||(e.NotebookExclusiveDocumentPattern=At={}));var mt;(function(ve){function De(fe,J,Pe){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Re,Pe),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}ve.from=De})(mt||(e.NotebookStatusBarItem=mt={}));var ht;(function(ve){function De(fe,J,Pe){const Re=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:J.toInternal(Re,Pe),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}ve.from=De})(ht||(e.NotebookKernelSourceAction=ht={}));var jt;(function(ve){function De(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}ve.from=De})(jt||(e.NotebookDocumentContentOptions=jt={}));var Lt;(function(ve){function De(J){return{uri:J.uri,provides:J.provides}}ve.from=De;function fe(J){return new s.$AL(d.URI.revive(J.uri),J.provides)}ve.to=fe})(Lt||(e.NotebookRendererScript=Lt={}));var wt;(function(ve){function De(J){return{message:x.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:i.from(J.location.range),uri:J.location.uri}}}ve.from=De;function fe(J){const Pe=new s.$GL(typeof J.message=="string"?J.message:x.to(J.message));return Pe.actualOutput=J.actual,Pe.expectedOutput=J.expected,Pe.contextValue=J.contextValue,Pe.location=J.location?F.to(J.location):void 0,Pe}ve.to=fe})(wt||(e.TestMessage=wt={}));var ct;(function(ve){ve.namespace=h.$5I,ve.denamespace=h.$6I})(ct||(e.TestTag=ct={}));var vt;(function(ve){function De(J){const Pe=(0,f.$5L)(J).controllerId;return{extId:y.$1I.fromExtHostTestItem(J,Pe).toString(),label:J.label,uri:d.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Re=>ct.namespace(Pe,Re.id)),range:g.$ls.lift(i.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&x.fromStrict(J.error)||null}}ve.from=De;function fe(J){return{parent:void 0,error:void 0,id:y.$1I.fromString(J.extId).localId,label:J.label,uri:d.URI.revive(J.uri),tags:(J.tags||[]).map(Pe=>{const{tagId:Re}=ct.denamespace(Pe);return new s.$HL(Re)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ve.toPlain=fe})(vt||(e.TestItem=vt={})),function(ve){function De(J){return{id:J.id}}ve.from=De;function fe(J){return new s.$HL(J.id)}ve.to=fe}(ct||(e.TestTag=ct={}));var Rt;(function(ve){const De=(J,Pe)=>{const Re=[];for(const[ze,xe]of Pe)y.$1I.compare(xe.item.extId,ze)===2&&(Pe.delete(ze),Re.push(xe));const Ve={...vt.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(xe=>xe.type===0).map(wt.to)})),children:Re.map(ze=>De(ze,Pe))};for(const ze of Ve.children)ze.parent=Ve;return Ve};function fe(J){const Pe=[],Re=new Map;for(const Ve of J.items){Re.set(Ve.item.extId,Ve);const ze=y.$1I.root(Ve.item.extId);J.request.targets.some(xe=>xe.controllerId===ze&&xe.testIds.includes(Ve.item.extId))&&Pe.push(Ve)}return{completedAt:J.completedAt,results:Pe.map(Ve=>De(Ve,Re))}}ve.to=fe})(Rt||(e.TestResults=Rt={}));var ft;(function(ve){function De(Re){return{covered:Re.covered,total:Re.covered}}function fe(Re){return"line"in Re?a.from(Re):i.from(Re)}function J(Re){return"branches"in Re?{count:Re.executionCount,location:fe(Re.location),type:1,branches:Re.branches.length?Re.branches.map(Ve=>({count:Ve.executionCount,location:Ve.location&&fe(Ve.location)})):void 0}:{type:0,count:Re.executionCount,location:fe(Re.location)}}ve.fromDetailed=J;function Pe(Re){return{uri:Re.uri,statement:De(Re.statementCoverage),branch:Re.branchCoverage&&De(Re.branchCoverage),function:Re.functionCoverage&&De(Re.functionCoverage),details:Re.detailedCoverage?.map(J)}}ve.fromFile=Pe})(ft||(e.TestCoverage=ft={}));var Mt;(function(ve){function De(fe){switch(fe){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}ve.to=De})(Mt||(e.CodeActionTriggerKind=Mt={}));var Ot;(function(ve){function De(J){const Pe=new s.$NL(V.to(J.kind),J.name,J.detail||"",d.URI.revive(J.uri),i.to(J.range),i.to(J.selectionRange));return Pe._sessionId=J._sessionId,Pe._itemId=J._itemId,Pe}ve.to=De;function fe(J,Pe,Re){if(Pe=Pe??J._sessionId,Re=Re??J._itemId,Pe===void 0||Re===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Re,kind:V.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:i.from(J.range),selectionRange:i.from(J.selectionRange),tags:J.tags?.map(oe.from)}}ve.from=fe})(Ot||(e.TypeHierarchyItem=Ot={}));var nt;(function(ve){function De(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}ve.from=De})(nt||(e.ViewBadge=nt={}));var lt;(function(ve){function De(Re,Ve,ze){const xe=Ve.fileData;return xe?new s.$YK(new s.$ZK(xe.name,d.URI.revive(xe.uri),xe.id,(0,P.$bb)(()=>ze(xe.id)))):Re===C.$Ir.uriList&&Ve.uriListData?new s.$XK(Pe(Ve.uriListData)):new s.$XK(Ve.asString)}ve.to=De;async function fe(Re,Ve){const ze=await Ve.asString();if(Re===C.$Ir.uriList)return{asString:ze,fileData:void 0,uriListData:J(ze)};const xe=Ve.asFile();return{asString:ze,fileData:xe?{name:xe.name,uri:xe.uri,id:xe._itemId??xe.id}:void 0}}ve.from=fe;function J(Re){return r.$Us.split(Re).map(Ve=>{if(Ve.startsWith("#"))return Ve;try{return d.URI.parse(Ve)}catch{}return Ve})}function Pe(Re){return r.$Us.create(Re.map(Ve=>typeof Ve=="string"?Ve:d.URI.revive(Ve)))}})(lt||(e.DataTransferItem=lt={}));var gt;(function(ve){function De(J,Pe){const Re=J.items.map(([Ve,ze])=>[Ve,lt.to(Ve,ze,Pe)]);return new s.$1K(Re)}ve.toDataTransfer=De;async function fe(J){const Pe={items:[]},Re=[];for(const[Ve,ze]of J)Re.push((async()=>{Pe.items.push([Ve,await lt.from(Ve,ze)])})());return await Promise.all(Re),Pe}ve.from=fe})(gt||(e.DataTransfer=gt={}));var Tt;(function(ve){function De(J){return{message:J.message,metadata:J.metadata,title:J.title,tooltip:J.tooltip}}ve.to=De;function fe(J){return{kind:"reply",message:J.message,metadata:J.metadata,title:J.title,tooltip:J.tooltip}}ve.from=fe})(Tt||(e.ChatReplyFollowup=Tt={}));var Ut;(function(ve){function De(fe){return typeof fe=="string"?{title:fe,message:fe,kind:"reply"}:"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:Tt.from(fe)}ve.from=De})(Ut||(e.ChatFollowup=Ut={}));var Bt;(function(ve){function De(J){const Pe=new s.$XL(Pt.to(J.role),J.content);return Pe.name=J.name,Pe}ve.to=De;function fe(J){return{role:Pt.from(J.role),content:J.content,name:J.name}}ve.from=fe})(Bt||(e.ChatMessage=Bt={}));var Pt;(function(ve){function De(J){switch(J){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}ve.to=De;function fe(J){switch(J){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}ve.from=fe})(Pt||(e.ChatMessageRole=Pt={}));var Ft;(function(ve){function De(J){return{level:kt.to(J.level),value:J.value,description:J.description}}ve.to=De;function fe(J){return{level:kt.from(J.level),value:J.value,description:J.description}}ve.from=fe})(Ft||(e.ChatVariable=Ft={}));var kt;(function(ve){function De(J){switch(J){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}ve.to=De;function fe(J){switch(J){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}ve.from=fe})(kt||(e.ChatVariableLevel=kt={}));var zt;(function(ve){function De(fe){switch(fe){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted}}ve.to=De})(zt||(e.InteractiveEditorResponseFeedbackKind=zt={}));var yt;(function(ve){function De(fe,J,Pe){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand}:"uri"in fe?{uri:fe.uri}:J.toInternal(fe,Pe)}ve.from=De})(yt||(e.TerminalQuickFix=yt={}))}),define(be[272],we([1,0,42,133,71,132,91,136,4]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lM=e.$kM=e.$jM=e.$iM=void 0;const $=(c,y,h,t)=>{let s=y;return{enumerable:!0,configurable:!1,get(){return s},set(o){if(!h(s,o)){const i=s;s=o,c.listener?.(t(o,i))}}}},C=(c,y)=>c===y,S={range:(c,y)=>c===y?!0:!c||!y?!1:c.isEqual(y),label:C,description:C,sortText:C,busy:C,error:C,canResolveChildren:C,tags:(c,y)=>!(c.length!==y.length||c.some(h=>!y.find(t=>h.id===t.id)))},v=c=>y=>({op:4,update:c(y)}),d=(c,y)=>({range:(()=>{let h;const t=v(s=>({range:D.$ls.lift(I.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){c.listener?.({op:6}),S.range(h,s)||(h=s,c.listener?.(t(s)))}}})(),label:$(c,y,S.label,v(h=>({label:h}))),description:$(c,void 0,S.description,v(h=>({description:h}))),sortText:$(c,void 0,S.sortText,v(h=>({sortText:h}))),canResolveChildren:$(c,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:$(c,!1,S.busy,v(h=>({busy:h}))),error:$(c,void 0,S.error,v(h=>({error:I.MarkdownString.fromStrict(h)||null}))),tags:$(c,[],S.tags,(h,t)=>({op:1,new:h.map(I.TestTag.from),old:t.map(I.TestTag.from)}))}),g=c=>{const y=r.$1I.fromString(c.extId),h=new l(y.controllerId,y.localId,c.label,w.URI.revive(c.uri)||void 0);return h.range=I.Range.to(c.range||void 0),h.description=c.description||void 0,h.sortText=c.sortText||void 0,h.tags=c.tags.map(t=>I.TestTag.to({id:(0,A.$6I)(t).tagId})),h},m=c=>{let y;for(const h of c.tests){const t=g(h.item);(0,O.$5L)(t).parent=y,y=t}return y};e.$iM=m;class l{constructor(y,h,t,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const o=(0,O.$4L)(this,y);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return o.parent instanceof f?void 0:o.parent}},children:{value:(0,P.$3L)(o,O.$5L,l),enumerable:!0,writable:!1},...d(o,t)})}}e.$jM=l;class f extends l{constructor(y,h){super(y,y,h,void 0),this._isRoot=!0}}e.$kM=f;class u extends P.$YL{constructor(y,h,t){super({controllerId:y,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:O.$5L,getChildren:s=>s.children,root:new f(y,h),toITestItem:I.TestItem.from})}}e.$lM=u}),define(be[273],we([1,0,269,117,89,87,134,90,135,12,223,267,88]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aN=e.$_M=void 0,e.$_M="remoteterminal";let d=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(m,l,f,u,c,y,h,t,s,o){this.a=m,this.b=l,this.c=f,this.d=u,this.e=c,this.f=y,this.g=h,this.h=t,this.i=s,this.j=o}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(m,l,f,u,c,y,h,t){await this.c.whenRemoteConfigurationLoaded();const s=Object.create(null),o=f?this.d.getWorkspaceFolder(f)??void 0:void 0;let i;try{i=(await this.e.resolveAnyMap(o,{shellLaunchConfig:m,configuration:l})).resolvedVariables}catch(Y){this.h.error(Y)}if(i)for(const[Y,ce]of i.entries())(/^config:/.test(Y)||Y==="selectedText"||Y==="lineNumber")&&(s[Y]=ce);const n=[];for(const[Y,ce]of this.f.collections.entries())n.push([Y,(0,P.$br)(ce.map),(0,P.$cr)(ce.descriptionMap)]);const a=await this.g.resolveAuthority(this.a),b=a.options&&a.options.extensionHostEnv,p=this.d.getWorkspace(),E=p.folders,k=f?this.d.getWorkspaceFolder(f):null,L=I.$6D.getOriginalUri(this.i.activeEditor,{supportSideBySide:I.SideBySideEditor.PRIMARY,filterByScheme:[$.Schemas.file,$.Schemas.vscodeUserData,$.Schemas.vscodeRemote]}),j={configuration:l,resolvedVariables:s,envVariableCollections:n,shellLaunchConfig:m,workspaceId:p.id,workspaceName:this.j.getWorkspaceLabel(p),workspaceFolders:E,activeWorkspaceFolder:k,activeFileResource:L,shouldPersistTerminal:c,options:u,cols:y,rows:h,unicodeVersion:t,resolverEnv:b};return await this.b.call("$createProcess",j)}requestDetachInstance(m,l){return this.b.call("$requestDetachInstance",[m,l])}acceptDetachInstanceReply(m,l){return this.b.call("$acceptDetachInstanceReply",[m,l])}attachToProcess(m){return this.b.call("$attachToProcess",[m])}detachFromProcess(m,l){return this.b.call("$detachFromProcess",[m,l])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(m,l){return this.b.call("$processBinary",[m,l])}start(m){return this.b.call("$start",[m])}input(m,l){return this.b.call("$input",[m,l])}acknowledgeDataEvent(m,l){return this.b.call("$acknowledgeDataEvent",[m,l])}setUnicodeVersion(m,l){return this.b.call("$setUnicodeVersion",[m,l])}shutdown(m,l){return this.b.call("$shutdown",[m,l])}resize(m,l,f){return this.b.call("$resize",[m,l,f])}clearBuffer(m){return this.b.call("$clearBuffer",[m])}getInitialCwd(m){return this.b.call("$getInitialCwd",[m])}getCwd(m){return this.b.call("$getCwd",[m])}orphanQuestionReply(m){return this.b.call("$orphanQuestionReply",[m])}sendCommandResult(m,l,f){return this.b.call("$sendCommandResult",[m,l,f])}freePortKillProcess(m){return this.b.call("$freePortKillProcess",[m])}installAutoReply(m,l){return this.b.call("$installAutoReply",[m,l])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(m){return this.b.call("$getDefaultSystemShell",[m])}getProfiles(m,l,f){return this.b.call("$getProfiles",[this.d.getWorkspace().id,m,l,f])}acceptPtyHostResolvedVariables(m,l){return this.b.call("$acceptPtyHostResolvedVariables",[m,l])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(m,l){return this.b.call("$getWslPath",[m,l])}setTerminalLayoutInfo(m){const f={workspaceId:this.d.getWorkspace().id,tabs:m?m.tabs:[]};return this.b.call("$setTerminalLayoutInfo",f)}updateTitle(m,l,f){return this.b.call("$updateTitle",[m,l,f])}updateIcon(m,l,f,u){return this.b.call("$updateIcon",[m,l,f,u])}refreshProperty(m,l){return this.b.call("$refreshProperty",[m,l])}updateProperty(m,l,f){return this.b.call("$updateProperty",[m,l,f])}getTerminalLayoutInfo(){const l={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",l)}reviveTerminalProcesses(m,l,f){return this.b.call("$reviveTerminalProcesses",[m,l,f])}getRevivedPtyNewId(m){return this.b.call("$getRevivedPtyNewId",[m])}serializeTerminalState(m){return this.b.call("$serializeTerminalState",[m])}};e.$aN=d,e.$aN=d=Oe([Ae(2,D.$pD),Ae(3,r.$Uh),Ae(4,A.$UM),Ae(5,S.$zM),Ae(6,O.$Kk),Ae(7,v.$1q),Ae(8,w.$_B),Ae(9,C.$Qu)],d)}),define(be[274],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.ExtHostConnectionType=void 0;var D;(function(C){C[C.IPC=1]="IPC",C[C.Socket=2]="Socket",C[C.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class O{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(S){this.pipeName=S,this.type=1}serialize(S){S[O.ENV_KEY]=this.pipeName}}e.$om=O;class r{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(S){S[r.ENV_KEY]="1"}}e.$pm=r;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(S){S[P.ENV_KEY]="1"}}e.$qm=P;function A(C){delete C[O.ENV_KEY],delete C[r.ENV_KEY],delete C[P.ENV_KEY]}function I(C,S){A(S),C.serialize(S)}e.$rm=I;function w(C){if(C[O.ENV_KEY])return $(C,new O(C[O.ENV_KEY]));if(C[r.ENV_KEY])return $(C,new r);if(C[P.ENV_KEY])return $(C,new P);throw new Error("No connection information defined in environment!")}e.$sm=w;function $(C,S){return A(C),S}}),define(be[275],we([1,0,15]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$6l=e.$5l=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var O;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(O||(e.UIKind=O={}));var r;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(r||(e.ExtensionHostExitCode=r={}));var P;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function A($){const C=D.$_d.alloc(1);switch($){case 0:C.writeUInt8(1,0);break;case 1:C.writeUInt8(2,0);break;case 2:C.writeUInt8(3,0);break}return C}e.$5l=A;function I($,C){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return C===0;case 2:return C===1;case 3:return C===2;default:return!1}}e.$6l=I;var w;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(w||(e.NativeLogMarkers=w={}))}),define(be[276],we([1,0,6,5,13,263,275,56,36,22,4,2,202]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qM=e.$pM=e.$oM=e.$nM=void 0;let d=class extends S.$Qc{constructor(f,u){super(),this.s=f,this.t=u,this.a=this.B(new O.$Ld),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new O.$Ld),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=C.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=u.createLogger(this.m,{id:w.$fo,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(u.onDidChangeLogLevel(c=>{(0,r.$8i)(c)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===r.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(f,u,c){const y=this.getTelemetryDetails(),h=new g(u,c,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled}),t=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(f,u,c){this.f=f,this.g=u,this.c=c??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const u=Object.create(null);switch(u["common.extname"]=`${f.publisher}.${f.name}`,u["common.extversion"]=f.version,u["common.vscodemachineid"]=this.s.telemetryInfo.machineId,u["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,u["common.vscodeversion"]=this.s.version,u["common.isnewappinstall"]=m(this.s.telemetryInfo.firstSessionDate),u["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:u["common.uikind"]="web";break;case A.UIKind.Desktop:u["common.uikind"]="desktop";break;default:u["common.uikind"]="unknown"}return u["common.remotename"]=(0,I.$Qk)((0,w.$mo)(this.s.remote.authority)),u}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const u=this.getTelemetryDetails();this.r.forEach((c,y)=>{const h=c.filter(t=>!t.isDisposed);h.length===0?this.r.delete(y):this.r.set(y,h)}),this.r.forEach(c=>{for(const y of c)y.updateTelemetryEnablements(u.isUsageEnabled,u.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,u){const y=this.r.get(f.value)?.filter(t=>!t.isDisposed);if(!y)return this.r.delete(f.value),!1;let h=!1;for(const t of y)t.ignoreUnhandledExtHostErrors||(t.logError(u),h=!0);return h}};e.$nM=d,e.$nM=d=Oe([Ae(0,P.$mM),Ae(1,r.$7i)],d);class g{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,u,c,y,h,t,s){this.g=c,this.h=y,this.i=h,this.j=t,this.a=new O.$Ld,this.ignoreUnhandledExtHostErrors=u?.ignoreUnhandledErrors??!1,this.b=u?.ignoreBuiltInCommonProperties??!1,this.c=u?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(f,u){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:u},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let u="properties"in f?f.properties??{}:f;return u=(0,w.$po)(u,[]),this.c&&(u=(0,$.$Zm)(u,this.c)),this.b||(u=(0,$.$Zm)(u,this.j)),"properties"in f?f.properties=u:f=u,f}k(f,u){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f?.sendEventData(f,u),this.h.trace(f,u))}logUsage(f,u){this.d.isUsageEnabled&&this.k(f,u)}logError(f,u){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,u);else{const c={name:f.name,message:f.message,stack:f.stack,cause:f.cause},y=(0,w.$po)(c,[]),h=new Error(y.message,{cause:y.cause});h.stack=y.stack,h.name=y.name,u=this.mixInCommonPropsAndCleanData(u||{}),this.i||this.f.sendErrorData(h,u),this.h.trace("exception",u)}}get apiTelemetryLogger(){if(!this.e){const f=this,u={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(u)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$oM=g;function m(l){const f=Date.now()-new Date(l).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$pM=m,e.$qM=(0,D.$Lh)("IExtHostTelemetry")}),define(be[277],we([1,0,40,205,53]),function(le,e,D,O,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=void 0;function P(A,I,w,$){const C=new D.$Yl;return A.forEach(S=>{const v=C.get(S.identifier);v&&$.warn((0,O.localize)(0,null,v.extensionLocation.fsPath,S.extensionLocation.fsPath)),C.set(S.identifier,S)}),I.forEach(S=>{const v=C.get(S.identifier);if(v)if(v.isBuiltin){if(r.gte(v.version,S.version)){$.warn(`Skipping extension ${S.extensionLocation.path} in favour of the builtin extension ${v.extensionLocation.path}.`);return}S.isBuiltin=!0}else $.warn((0,O.localize)(1,null,v.extensionLocation.fsPath,S.extensionLocation.fsPath));else if(S.isBuiltin){$.warn(`Skipping obsolete builtin extension ${S.extensionLocation.path}`);return}C.set(S.identifier,S)}),w.forEach(S=>{$.info((0,O.localize)(2,null,S.extensionLocation.fsPath));const v=C.get(S.identifier);v&&v.isBuiltin&&(S.isBuiltin=!0),C.set(S.identifier,S)}),Array.from(C.values())}e.$uN=P}),define(be[278],we([1,0,7,3,29,4,41,51,66,57,277,12]),function(le,e,D,O,r,P,A,I,w,$,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yN=e.$xN=void 0;class v{constructor(m,l,f,u,c,y,h){this.c=m,this.d=f,this.f=u,this.g=c,this.h=y,this.i=h,this.a=Promise.resolve(),this.b=Promise.resolve();const t=l.args["install-builtin-extension"];if(t){c.trace("Installing builtin extensions passed via args...");const o={isMachineScoped:!!l.args["do-not-sync"],installPreReleaseVersion:!!l.args["pre-release"]};A.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=m.installExtensions([],this.j(t),o,!!l.args.force).then(()=>{A.mark("code/server/didInstallBuiltinExtensions"),c.trace("Finished installing builtin extensions")},i=>{c.error(i)})}const s=l.args["install-extension"];s&&(c.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>m.installExtensions(this.j(s),[],{isMachineScoped:!!l.args["do-not-sync"],installPreReleaseVersion:!!l.args["pre-release"],isApplicationScoped:!0},!!l.args.force)).then(()=>{c.trace("Finished installing extensions")},o=>{c.error(o)}))}j(m){return m.map(l=>/\.vsix$/i.test(l)?P.URI.file((0,D.$gc)(l)?l:(0,D.$hc)((0,r.cwd)(),l)):l)}whenExtensionsReady(){return this.b}async scanExtensions(m,l,f,u){A.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${m}`),await this.a;const c=f?f.filter(h=>h.scheme===S.Schemas.file).map(h=>h.fsPath):void 0;l=l??this.d.defaultProfile.extensionsResource;const y=await this.k(l,m??O.$v,c,u);return this.g.trace("Scanned Extensions",y),this.r(y),A.mark("code/server/didScanExtensions"),y}async scanSingleExtension(m,l,f){await this.a;const u=m.scheme===S.Schemas.file?m.fsPath:null;if(!u)return null;const c=await this.o(u,l,f??O.$v);return c?(this.r([c]),c):null}async k(m,l,f,u){await this.q(l,u);const[c,y,h]=await Promise.all([this.m(l),this.n(m,l),this.l(l,f)]);return(0,C.$uN)(c,y,h,this.g)}async l(m,l){return l?(await Promise.all(l.map(f=>this.f.scanOneOrMultipleExtensions(P.URI.file((0,D.$ic)(f)),1,{language:m})))).flat().map(f=>(0,$.$sp)(f,!0)):[]}async m(m){return(await this.f.scanSystemExtensions({language:m,useCache:!0})).map(f=>(0,$.$sp)(f,!1))}async n(m,l){return(await this.f.scanUserExtensions({profileLocation:m,language:l,useCache:!0})).map(u=>(0,$.$sp)(u,!1))}async o(m,l,f){const u=P.URI.file((0,D.$ic)(m)),c=l?0:1,y=await this.f.scanExistingExtension(u,c,{language:f});return y?(0,$.$sp)(y,!1):null}async q(m,l){if(!(m===O.$f||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(u=>u.id===m)){this.g.trace(`Language Pack ${m} is already installed. Skipping language pack installation.`);return}}catch(f){this.g.error(f)}if(!l){this.g.trace(`No language pack id provided for language ${m}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${l} for language ${m} is not installed. It will be installed now.`);try{await this.c.installExtensions([l],[],{isMachineScoped:!0},!0)}catch(f){this.g.error(f)}}}r(m){const l=(t,s)=>t.replace(/file/g,"vscode-remote"),f=t=>{let s="";return s+=t.global?"g":"",s+=t.ignoreCase?"i":"",s+=t.multiline?"m":"",new RegExp(l(t.source,!0),s)},u=new class{mapDefined(t){return w.$Oi.create(t)}mapNot(t){return w.$Ti.create(t)}mapEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?w.$Pi.create(t,l(s,!1)):w.$Pi.create(t,s)}mapNotEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?w.$Si.create(t,l(s,!1)):w.$Si.create(t,s)}mapGreater(t,s){return w.$Ui.create(t,s)}mapGreaterEquals(t,s){return w.$Vi.create(t,s)}mapSmaller(t,s){return w.$Wi.create(t,s)}mapSmallerEquals(t,s){return w.$Xi.create(t,s)}mapRegex(t,s){return t==="resourceScheme"&&s?w.$Yi.create(t,f(s)):w.$Yi.create(t,s)}mapIn(t,s){return w.$Qi.create(t,s)}mapNotIn(t,s){return w.$Ri.create(t,s)}},c=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const s=w.$Ji.deserialize(t.when);if(!s)return;const o=s.map(u);t.when=o.serialize()},y=t=>{if(Array.isArray(t))for(const s of t)c(s);else c(t)},h=t=>{for(const s in t)y(t[s])};m.forEach(t=>{t.contributes&&(t.contributes.menus&&h(t.contributes.menus),t.contributes.keybindings&&y(t.contributes.keybindings),t.contributes.views&&h(t.contributes.views))})}}e.$xN=v;class d{constructor(m,l){this.a=m,this.b=l}listen(m,l){throw new Error("Invalid listen")}async call(m,l,f){const u=this.b(m);switch(l){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const c=f[0],y=f[1]?P.URI.revive(u.transformIncoming(f[1])):void 0,h=Array.isArray(f[2])?f[2].map(o=>P.URI.revive(u.transformIncoming(o))):void 0,t=f[3];return(await this.a.scanExtensions(c,y,h,t)).map(o=>(0,I.$Em)(o,u))}case"scanSingleExtension":{const c=await this.a.scanSingleExtension(P.URI.revive(u.transformIncoming(f[0])),f[1],f[2]);return c?(0,I.$Em)(c,u):null}}throw new Error("Invalid call")}}e.$yN=d}),define(be[137],we([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=void 0;class D{static{this.count=0}constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++D.count}}e.$ev=D;const O=[];function r(I){const w=new D(I);return O[w.nid]=w,w}e.$fv=r;function P(I){return O[I].sid}e.$gv=P;class A{constructor(w){this.value=w}}e.$hv=A}),define(be[279],we([1,0,137]),function(le,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9J=e.$8J=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$7J=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var O;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})(O||(e.TextEditorRevealType=O={}));var r;(function(m){m[m.UnknownInput=0]="UnknownInput",m[m.TextInput=1]="TextInput",m[m.TextDiffInput=2]="TextDiffInput",m[m.TextMergeInput=3]="TextMergeInput",m[m.NotebookInput=4]="NotebookInput",m[m.NotebookDiffInput=5]="NotebookDiffInput",m[m.CustomEditorInput=6]="CustomEditorInput",m[m.WebviewEditorInput=7]="WebviewEditorInput",m[m.TerminalEditorInput=8]="TerminalEditorInput",m[m.InteractiveEditorInput=9]="InteractiveEditorInput"})(r||(e.TabInputKind=r={}));var P;(function(m){m[m.TAB_OPEN=0]="TAB_OPEN",m[m.TAB_CLOSE=1]="TAB_CLOSE",m[m.TAB_UPDATE=2]="TAB_UPDATE",m[m.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var A;(function(m){m[m.Editable=0]="Editable",m[m.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var I;(function(m){m[m.Int8Array=1]="Int8Array",m[m.Uint8Array=2]="Uint8Array",m[m.Uint8ClampedArray=3]="Uint8ClampedArray",m[m.Int16Array=4]="Int16Array",m[m.Uint16Array=5]="Uint16Array",m[m.Int32Array=6]="Int32Array",m[m.Uint32Array=7]="Uint32Array",m[m.Float32Array=8]="Float32Array",m[m.Float64Array=9]="Float64Array",m[m.BigInt64Array=10]="BigInt64Array",m[m.BigUint64Array=11]="BigUint64Array"})(I||(e.WebviewMessageArrayBufferViewType=I={}));var w;(function(m){m[m.Text=1]="Text",m[m.Error=2]="Error",m[m.Rich=3]="Rich"})(w||(e.CellOutputKind=w={}));var $;(function(m){m[m.Default=0]="Default",m[m.InCenter=1]="InCenter",m[m.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",m[m.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var C;(function(m){m[m.None=0]="None",m[m.Process=1]="Process",m[m.Output=2]="Output"})(C||(e.CandidatePortSource=C={}));class S{static{this.a=0}static mixin(l){return l._id=S.a++,l}}e.$7J=S;var v;(function(m){m.label="a",m.kind="b",m.detail="c",m.documentation="d",m.sortText="e",m.filterText="f",m.preselect="g",m.insertText="h",m.insertTextRules="i",m.range="j",m.commitCharacters="k",m.additionalTextEdits="l",m.kindModifier="m",m.commandIdent="n",m.commandId="o",m.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var d;(function(m){m.defaultRanges="a",m.completions="b",m.isIncomplete="c",m.duration="d"})(d||(e.ISuggestResultDtoField=d={}));var g;(function(m){m[m.Workspace=0]="Workspace",m[m.TextDocument=1]="TextDocument"})(g||(e.ExtHostTestingResource=g={})),e.$8J={MainThreadAuthentication:(0,D.$fv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$fv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$fv)("MainThreadChatProvider"),MainThreadChatSlashCommands:(0,D.$fv)("MainThreadChatSlashCommands"),MainThreadChatAgents:(0,D.$fv)("MainThreadChatAgents"),MainThreadChatVariables:(0,D.$fv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$fv)("MainThreadClipboard"),MainThreadCommands:(0,D.$fv)("MainThreadCommands"),MainThreadComments:(0,D.$fv)("MainThreadComments"),MainThreadConfiguration:(0,D.$fv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$fv)("MainThreadConsole"),MainThreadDebugService:(0,D.$fv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$fv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$fv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$fv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$fv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$fv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$fv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$fv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$fv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$fv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$fv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$fv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$fv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$fv)("MainThreadLanguages"),MainThreadLogger:(0,D.$fv)("MainThreadLogger"),MainThreadMessageService:(0,D.$fv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$fv)("MainThreadOutputService"),MainThreadProgress:(0,D.$fv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$fv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$fv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$fv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$fv)("MainThreadSecretState"),MainThreadStorage:(0,D.$fv)("MainThreadStorage"),MainThreadTelemetry:(0,D.$fv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$fv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$fv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$fv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$fv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$fv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$fv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$fv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$fv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$fv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$fv)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.$fv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$fv)("MainThreadSCM"),MainThreadSearch:(0,D.$fv)("MainThreadSearch"),MainThreadShare:(0,D.$fv)("MainThreadShare"),MainThreadTask:(0,D.$fv)("MainThreadTask"),MainThreadWindow:(0,D.$fv)("MainThreadWindow"),MainThreadLabelService:(0,D.$fv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$fv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$fv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$fv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$fv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$fv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$fv)("MainThreadInteractive"),MainThreadChat:(0,D.$fv)("MainThreadChat"),MainThreadInlineChat:(0,D.$fv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$fv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$fv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$fv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$fv)("MainThreadTimeline"),MainThreadTesting:(0,D.$fv)("MainThreadTesting"),MainThreadLocalization:(0,D.$fv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$fv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$fv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$fv)("MainThreadIssueReporter")},e.$9J={ExtHostCommands:(0,D.$fv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$fv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$fv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$fv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$fv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$fv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$fv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$fv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$fv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$fv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$fv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$fv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$fv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$fv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$fv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$fv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$fv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$fv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$fv)("ExtHostStatusBar"),ExtHostShare:(0,D.$fv)("ExtHostShare"),ExtHostExtensionService:(0,D.$fv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$fv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$fv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$fv)("ExtHostSCM"),ExtHostSearch:(0,D.$fv)("ExtHostSearch"),ExtHostTask:(0,D.$fv)("ExtHostTask"),ExtHostWorkspace:(0,D.$fv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$fv)("ExtHostWindow"),ExtHostWebviews:(0,D.$fv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$fv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$fv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$fv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$fv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$fv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$fv)("ExtHostProgress"),ExtHostComments:(0,D.$fv)("ExtHostComments"),ExtHostSecretState:(0,D.$fv)("ExtHostSecretState"),ExtHostStorage:(0,D.$fv)("ExtHostStorage"),ExtHostUrls:(0,D.$fv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$fv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$fv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$fv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$fv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$fv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$fv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$fv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$fv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$fv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$fv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$fv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$fv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$fv)("ExtHostChat"),ExtHostChatSlashCommands:(0,D.$fv)("ExtHostChatSlashCommands"),ExtHostChatAgents:(0,D.$fv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$fv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$fv)("ExtHostChatProvider"),ExtHostAiRelatedInformation:(0,D.$fv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$fv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$fv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$fv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$fv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$fv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$fv)("ExtHostTimeline"),ExtHostTesting:(0,D.$fv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$fv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$fv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$fv)("ExtHostIssueReporter")}}),define(be[280],we([1,0,10,131,136,22,279,18,13,50,42,100,4,2,6,264,272,15,137,38,58,36,276]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=void 0;let s=class{#e;#t;#n;constructor(p,E,k){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$8J.MainThreadCommands),this.d=E,this.#n=k,this.#t=p.getProxy(A.$8J.MainThreadTelemetry),this.converter=new o(this,L=>{const j=this.c.get(L);return j?.result===n.Void?j:void 0},E),this.f=[{processArgument(L){return(0,$.$ih)(L)}},{processArgument(L){return(0,P.$Ym)(L,function(j){if(C.$ls.isIRange(j))return r.Range.to(j);if(S.$ks.isIPosition(j))return r.Position.to(j);if(C.$ls.isIRange(j.range)&&v.URI.isUri(j.uri))return r.location.to(j);if(j instanceof f.$_d)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const E=this.registerCommand(!1,p.id,async(...k)=>{const L=p.args.map((Y,ce)=>{if(!Y.validate(k[ce]))throw new Error(`Invalid argument '${Y.name}' when running '${p.id}', received: ${typeof k[ce]=="object"?JSON.stringify(k[ce],null,"	"):k[ce]} `);return Y.convert(k[ce])}),j=await this.executeCommand(p.internalId,...L);return p.result.convert(j,k,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new O.$0J(()=>{E.dispose(),this.c.delete(p.id)})}registerCommand(p,E,k,L,j,Y){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:L,description:j,extension:Y}),p&&this.#e.$registerCommand(E),new O.$0J(()=>{this.b.delete(E)&&p&&this.#e.$unregisterCommand(E)})}executeCommand(p,...E){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,E,!0)}async g(p,E,k){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,E,!1);{let L=!1;const j=(0,P.$Ym)(E,function(Y){if(Y instanceof O.$$J)return r.Position.from(Y);if(Y instanceof O.$_J)return r.Range.from(Y);if(Y instanceof O.$jK)return r.location.from(Y);if(O.$uL.isNotebookRange(Y))return r.NotebookRange.from(Y);if(Y instanceof ArrayBuffer)return L=!0,f.$_d.wrap(new Uint8Array(Y));if(Y instanceof Uint8Array)return L=!0,f.$_d.wrap(Y);if(Y instanceof f.$_d)return L=!0,Y;if(!Array.isArray(Y))return Y});try{const Y=await this.#e.$executeCommand(p,L?new u.$hv(j):j,k);return(0,$.$ih)(Y)}catch(Y){if(Y instanceof Error&&Y.message==="$executeCommand:retry")return this.g(p,E,!1);throw Y}}}async h(p,E,k){const L=this.b.get(p);if(!L)throw new Error("Unknown command");const{callback:j,thisArg:Y,description:ce}=L;if(ce)for(let ne=0;ne<ce.args.length;ne++)try{(0,D.$Nf)(E[ne],ce.args[ne].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed.Illegal argument '${ce.args[ne].name}' - ${ce.args[ne].description} `)}const x=y.$Hd.create();try{return await j.apply(Y,E)}catch(ne){if(p===this.converter.delegatingCommandId){const ue=this.converter.getActualCommand(...E);ue&&(p=ue.command)}if(this.d.error(ne,p,L.extension?.identifier),!k)throw ne;if(L.extension?.identifier){const ue=this.#n.onExtensionError(L.extension.identifier,ne);this.d.trace("forwarded error to extension?",ue,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,c.$wi)(ne)),this.id=p,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,p,x.elapsed())}}j(p,E,k){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new h.$ao(E),duration:k})}$executeContributedCommand(p,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const k=this.b.get(p);return k?(E=E.map(L=>this.f.reduce((j,Y)=>Y.processArgument(j,k.extension?.identifier),L)),this.h(p,E,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(E=>(p&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandHandlerDescriptions(){const p=Object.create(null);for(const[E,k]of this.b){const{description:L}=k;L&&(p[E]=L)}return Promise.resolve(p)}};e.$rM=s,e.$rM=s=Oe([Ae(0,m.$9L),Ae(1,w.$6i),Ae(2,t.$qM)],s),e.$sM=(0,g.$Lh)("IExtHostCommands");class o{constructor(p,E,k){this.d=p,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${Date.now().toString(36)} `,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,E){if(!p)return;const k={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return k;const L=this.f(p.command);if(L)k.id=L.internalId,k.arguments=L.args.map((j,Y)=>j.convert(p.arguments&&p.arguments[Y]));else if((0,I.$Jb)(p.arguments)){const j=`${p.command} /${++this.c}`;this.b.set(j,p),E.add((0,d.$Oc)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),k.$ident=j,k.id=this.delegatingCommandId,k.arguments=[j],this.g.trace("CommandsConverter#CREATE",p.command,j)}return k}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const E=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$tM=o;class i{static{this.Uri=new i("uri","Uri of a text document",p=>v.URI.isUri(p),p=>p)}static{this.Position=new i("position","A position in a text document",p=>O.$$J.isPosition(p),r.Position.from)}static{this.Range=new i("range","A range in a text document",p=>O.$_J.isRange(p),r.Range.from)}static{this.Selection=new i("selection","A selection in a text document",p=>O.$aK.isSelection(p),r.Selection.from)}static{this.Number=new i("number","",p=>typeof p=="number",p=>p)}static{this.String=new i("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=i.Arr(i.String)}static Arr(p){return new i(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,E=>Array.isArray(E)&&E.every(k=>p.validate(k)),E=>E.map(k=>p.convert(k)))}static{this.CallHierarchyItem=new i("item","A call hierarchy item",p=>p instanceof O.$tK,r.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new i("item","A type hierarchy item",p=>p instanceof O.$NL,r.TypeHierarchyItem.from)}static{this.TestItem=new i("testItem","A VS Code TestItem",p=>p instanceof l.$jM,r.TestItem.from)}constructor(p,E,k,L){this.name=p,this.description=E,this.validate=k,this.convert=L}optional(){return new i(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,E){return new i(p??this.name,E??this.description,this.validate,this.convert)}}e.$uM=i;class n{static{this.Void=new n("no result",p=>p)}constructor(p,E){this.description=p,this.convert=E}}e.$vM=n;class a{constructor(p,E,k,L,j){this.id=p,this.internalId=E,this.description=k,this.args=L,this.result=j}}e.$wM=a}),define(be[281],we([1,0,11,2,12,218]),function(le,e,D,O,r,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0,e.$dN="remoteFilesystem";class A extends P.$cN{static register(w,$,C){const S=w.getConnection();if(!S)return O.$Qc.None;const v=new O.$Pc,d=(async()=>{try{const g=await w.getRawEnvironment();g?$.registerProvider(r.Schemas.vscodeRemote,v.add(new A(g,S))):C.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(g){C.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,D.$8)(g))}})();return v.add($.onWillActivateFileSystemProvider(g=>{g.scheme===r.Schemas.vscodeRemote&&g.join(d)})),v}constructor(w,$){super($.getChannel(e.$dN),{pathCaseSensitive:w.os===3})}}e.$eN=A}),define(be[92],we([1,0,27,14,7,10,21,170,299,300]),function(le,e,D,O,r,P,A,I,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.zip=e.$cp=e.$bp=void 0,e.$bp="end of central directory record signature not found";const C=new RegExp(e.$bp);class S extends Error{constructor(s,o){let i=o.message;switch(s){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=s,this.cause=o}}e.$cp=S;function v(t){const s=t.externalFileAttributes>>16||33188;return[448,56,7].map(o=>s&o).reduce((o,i)=>o+i,s&61440)}function d(t){if(t instanceof S)return t;let s;return C.test(t.message)&&(s="CorruptZip"),new S(s,t)}function g(t,s,o,i,n,a){const b=r.$kc(s),p=r.$hc(i,b);if(!p.startsWith(i))return Promise.reject(new Error(I.localize(0,null,s)));const E=r.$hc(i,s);let k;return a.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(A.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((L,j)=>{if(!a.isCancellationRequested)try{k=(0,D.createWriteStream)(E,{mode:o}),k.once("close",()=>L()),k.once("error",j),t.once("error",j),t.pipe(k)}catch(Y){j(Y)}}))}function m(t,s,o,i){let n=(0,O.$Eg)(()=>Promise.resolve()),a=0;const b=i.onCancellationRequested(()=>{n.cancel(),t.close()});return new Promise((p,E)=>{const k=new O.$Lg,L=j=>{j.isCancellationRequested||(a++,t.readEntry())};t.once("error",E),t.once("close",()=>n.then(()=>{i.isCancellationRequested||t.entryCount===a?p():E(new S("Incomplete",new Error(I.localize(1,null,a,t.entryCount))))},E)),t.readEntry(),t.on("entry",j=>{if(i.isCancellationRequested)return;if(!o.sourcePathRegex.test(j.fileName)){L(i);return}const Y=j.fileName.replace(o.sourcePathRegex,"");if(/\/$/.test(Y)){const ne=r.$hc(s,Y);n=(0,O.$Eg)(ue=>A.Promises.mkdir(ne,{recursive:!0}).then(()=>L(ue)).then(void 0,E));return}const ce=f(t,j),x=v(j);n=(0,O.$Eg)(ne=>k.queue(()=>ce.then(ue=>g(ue,Y,x,s,o,ne).then(()=>L(ne)))).then(null,E))})}).finally(()=>b.dispose())}function l(t,s=!1){return new Promise((o,i)=>{(0,w.open)(t,s?{lazyEntries:!0}:void 0,(n,a)=>{n?i(d(n)):o((0,P.$Hf)(a))})})}function f(t,s){return new Promise((o,i)=>{t.openReadStream(s,(n,a)=>{n?i(d(n)):o((0,P.$Hf)(a))})})}function u(t,s){return new Promise((o,i)=>{const n=new $.ZipFile;s.forEach(b=>{b.contents?n.addBuffer(typeof b.contents=="string"?Buffer.from(b.contents,"utf8"):b.contents,b.path):b.localPath&&n.addFile(b.localPath,b.path)}),n.end();const a=(0,D.createWriteStream)(t);n.outputStream.pipe(a),n.outputStream.once("error",i),a.once("error",i),a.once("finish",()=>o(t))})}e.zip=u;function c(t,s,o={},i){const n=new RegExp(o.sourcePath?`^${o.sourcePath}`:"");let a=l(t,!0);return o.overwrite&&(a=a.then(b=>A.Promises.rm(s).then(()=>b))),a.then(b=>m(b,s,{sourcePathRegex:n},i))}e.$ep=c;function y(t,s){return l(t).then(o=>new Promise((i,n)=>{o.on("entry",a=>{a.fileName===s&&f(o,a).then(b=>i(b),b=>n(b))}),o.once("close",()=>n(new Error(I.localize(2,null,s))))}))}function h(t,s){return y(t,s).then(o=>new Promise((i,n)=>{const a=[];o.once("error",n),o.on("data",b=>a.push(b)),o.on("end",()=>i(Buffer.concat(a)))}))}e.$fp=h}),define(be[282],we([1,0,14,11,2,12,19,53,10,23,21,92,24,25,30,37,81,16,13]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$up=void 0;let y=class extends r.$Qc{static{c=this}static{this.c=".sigzip"}constructor(t,s,o,i,n,a){super(),this.h=s,this.j=o,this.m=i,this.n=n,this.r=a,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,s,o){await this.g;const i=(0,A.$sg)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,i,a=>this.j.download(t,a,s))}catch(a){throw new g.$2n(a.message,g.ExtensionManagementErrorCode.Download)}let n=!1;if(o&&this.t(t)){const a=await this.u(t);try{n=await this.n.verify(i.fsPath,a.fsPath,this.r.getLevel()===u.LogLevel.Trace)}catch(b){const p=b;if(n=p.code,p.output&&this.r.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${p.output}`),n===g.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===g.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new g.$2n(S.$bp,g.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(a)}catch(b){this.r.error(b)}}}return n===!0?this.r.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${t.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:i,verificationStatus:n}}t(t){if(!t.isSigned)return!1;const s=this.m.getValue("extensions.verifySignature");return(0,w.$Cf)(s)?s:!0}async u(t){await this.g;const s=(0,A.$sg)(this.extensionsDownloadDir,`${this.z(t)}${c.c}`);return await this.w(t,s,o=>this.j.downloadSignatureArchive(t,o)),s}async w(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==P.Schemas.file){await o(s);return}const i=(0,A.$sg)(this.extensionsDownloadDir,`.${(0,$.$bg)()}`);await this.h.exists(i)||await o(i);try{await C.Promises.rename(i.fsPath,s.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.r.info(`Rename failed because of ${(0,O.$8)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],i=[];for(const b of t.children)if(b.name.endsWith(c.c))i.push(b.resource);else{const p=m.$ro.parse(b.name);p&&o.push([p,b])}const n=(0,m.$wo)(o,([b])=>b),a=[];for(const b of n)b.sort((p,E)=>I.rcompare(p[0].version,E[0].version)),s.push(...b.slice(1).map(p=>p[1].resource)),a.push(b[0][1]);a.sort((b,p)=>b.mtime-p.mtime),s.push(...a.slice(0,Math.max(0,a.length-this.f)).map(b=>b.resource)),s.push(...i),await D.Promises.settled(s.map(b=>(this.r.trace("Deleting from cache",b.path),this.h.del(b))))}}catch(t){this.r.error(t)}}z(t){return this.f?m.$ro.create(t).toString().toLowerCase():(0,$.$bg)()}};e.$up=y,e.$up=y=c=Oe([Ae(0,d.$Th),Ae(1,f.$7j),Ae(2,g.$1n),Ae(3,v.$fi),Ae(4,l.$8o),Ae(5,u.$6i)],y)}),define(be[283],we([1,0,92,184]),function(le,e,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;function r(P){return(0,D.$fp)(P,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,O.localize)(0,null))}})}e.$wp=r}),define(be[138],we([1,0,14,15,20,38,11,5,59,2,26,12,7,19,53,10,4,23,21,92,183,80,25,255,30,37,45,57,282,256,283,231,240,79,16,6,13,31,32,34,33]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t,s,o,i,n,a,b,p,E,k,L,j,Y,ce,x,ne,ue,_,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=void 0,e.$zp=(0,ce.$Mh)(o.$3n);const ee=".vsctmp";let te=class extends s.$gp{constructor(U,Z,R,F,G,T,q,z,ie,B,X,H){super(U,Z,X,R,B,H),this.fb=G,this.gb=T,this.hb=q,this.ib=ie,this.eb=new Map,this.rb=new C.$zc;const Q=this.B(z.createInstance(p.$vp));this.bb=this.B(z.createInstance(W,de=>Q.postUninstall(de))),this.cb=this.B(new k.$xp(H,ie,X,this,this.F)),this.db=this.B(z.createInstance(b.$up));const re=this.B(new L.$yp(this,this.fb,H,T,X,ie,R));this.B(re.onDidChangeExtensionsByAnotherSource(de=>this.qb(de))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Bo)(this.ib,this.F)),this.jb}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const Z=await this.pb(U),R=await(0,c.zip)((0,d.$sg)(this.db.extensionsDownloadDir,(0,f.$bg)()).fsPath,Z);return l.URI.file(R)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:Z,cleanup:R}=await this.lb(U),F=v.$ic(Z.fsPath);try{return await(0,E.$wp)(F)}finally{await R()}}getInstalled(U,Z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(U??null,Z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.bb.scanUserExtensionAtLocation(U)}async install(U,Z={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:R,cleanup:F}=await this.lb(U);try{const G=await(0,E.$wp)(v.$ic(R.fsPath)),T=(0,i.$vo)(G.publisher,G.name);if(G.engines&&G.engines.vscode&&!(0,j.$Io)(G.engines.vscode,this.G.version,this.G.date))throw new Error(y.localize(0,null,T,this.G.version));const z=(await this.I([{manifest:G,extension:R,options:Z}])).find(({identifier:ie})=>(0,i.$qo)(ie,{id:T}));if(z?.local)return z.local;throw z?.error?z.error:(0,s.$ip)(new Error(`Unknown error while installing extension ${T}`))}finally{await F()}}async installFromLocation(U,Z){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const R=await this.bb.scanUserExtensionAtLocation(U);if(!R)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.ub([[R,void 0]],Z),this.F.info("Successfully installed extension",R.identifier.id,Z.toString()),R}async installExtensionsFromProfile(U,Z,R){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,Z.toString(),R.toString());const F=(await this.bb.scanExtensions(1,Z)).filter(G=>U.some(T=>(0,i.$qo)(T,G.identifier)));if(F.length){const G=await Promise.all(F.map(T=>this.bb.scanMetadata(T,Z)));await this.ub(F.map((T,q)=>[T,G[q]]),R),this.F.info("Successfully installed extensions",F.map(T=>T.identifier.id),R.toString())}return F}async updateMetadata(U,Z,R=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),Z.isPreReleaseVersion&&(Z.preRelease=!0),Z.isMachineScoped=Z.isMachineScoped||void 0,Z.isBuiltin=Z.isBuiltin||void 0,Z.pinned=Z.pinned||void 0,U=await this.bb.updateMetadata(U,Z,R),this.cb.invalidate(R),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(y.localize(1,null));const Z=await this.getTargetPlatform(),[R]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:Z,compatible:!0},r.CancellationToken.None);if(!R)throw new Error(y.localize(2,null));await this.bb.setUninstalled(U);try{await this.bb.removeUninstalledExtension(U)}catch(F){throw new Error(y.localize(3,null,(0,P.$wi)(F)))}return this.installFromGallery(R)}ab(U,Z,R,F){return this.bb.copyExtension(U,Z,R,F)}copyExtensions(U,Z){return this.bb.copyExtensions(U,Z)}markAsUninstalled(...U){return this.bb.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(U){this.F.error(U)}}async download(U,Z,R){const{location:F}=await this.db.download(U,Z,!R);return F}async lb(U){if(U.scheme===S.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const Z=(0,d.$sg)(this.db.extensionsDownloadDir,(0,f.$bg)());return await this.hb.download(U,Z),this.F.info("Downloaded extension to",Z.toString()),{location:Z,cleanup:async()=>{try{await this.ib.del(Z)}catch(F){this.F.error(F)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(U,Z,R){if(l.URI.isUri(Z))return new oe(U,Z,R,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const F=i.$ro.create(Z).toString();let G=this.eb.get(F);return G||(this.eb.set(F,G=new V(U,Z,R,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),G.waitUntilTaskIsFinished().finally(()=>this.eb.delete(F))),G}$(U,Z){return new me(U,Z.profileLocation,this.gb)}async pb(U){const Z=async F=>{let G=await u.Promises.readdir(F);G=G.map(z=>v.$hc(F,z));const T=await Promise.all(G.map(z=>u.Promises.stat(z)));let q=Promise.resolve([]);return T.forEach((z,ie)=>{const B=G[ie];z.isFile()&&(q=q.then(X=>[...X,B])),z.isDirectory()&&(q=q.then(X=>Z(B).then(H=>[...X,...H])))}),q};return(await Z(U.location.fsPath)).map(F=>({path:`extension/${v.$jc(U.location.fsPath,F)}`,localPath:F}))}async qb({added:U,removed:Z}){if(Z){const R=U&&this.D.extUri.isEqual(Z.profileLocation,U.profileLocation)?Z.extensions.filter(F=>U.extensions.every(G=>!(0,i.$qo)(G,F))):Z.extensions;for(const F of R)this.F.info("Extensions removed from another source",F.id,Z.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:Z.profileLocation})}if(U){const F=(await this.bb.scanExtensions(1,U.profileLocation)).filter(G=>U.extensions.some(T=>(0,i.$qo)(T,G.identifier)));this.s.fire(F.map(G=>(this.F.info("Extensions added from another source",G.identifier.id,U.profileLocation.toString()),{identifier:G.identifier,local:G,profileLocation:U.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(Z=>this.rb.add(Z)));const U=await this.ib.resolve(this.fb.userExtensionsLocation);for(const Z of U.children??[])Z.isDirectory&&this.rb.add(Z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(Z=>this.tb(Z)))}async tb(U){if(!U.affects(this.fb.userExtensionsLocation,1))return;const Z=[];for(const R of U.rawAdded){if(this.rb.has(R)||!this.D.extUri.isEqual(this.D.extUri.dirname(R),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(R,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(R).startsWith(".")||!(await this.ib.stat(R)).isDirectory)continue;const F=await this.bb.scanUserExtensionAtLocation(R);F&&F.installedTimestamp===void 0&&(this.rb.add(R),Z.push(F))}Z.length&&(await this.ub(Z.map(R=>[R,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",Z.map(R=>R.identifier.id)))}async ub(U,Z){const R=U.map(F=>F[0]);await this.vb(R),await this.gb.addExtensionsToProfile(U,Z),this.s.fire(R.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:Z})))}async vb(U){const Z=await this.bb.getUninstalledExtensions();for(const R of U){const F=i.$ro.create(R);Z[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.bb.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$Ap=te,e.$Ap=te=Oe([Ae(0,o.$1n),Ae(1,ue.$0k),Ae(2,x.$6i),Ae(3,t.$Th),Ae(4,a.$pp),Ae(5,n.$lp),Ae(6,h.$En),Ae(7,ce.$Kh),Ae(8,Y.$7j),Ae(9,ne.$lj),Ae(10,_.$Dk),Ae(11,he.$Fk)],te);let W=class extends $.$Qc{constructor(U,Z,R,F,G,T){super(),this.j=U,this.m=Z,this.n=R,this.s=F,this.t=G,this.u=T,this.h=this.B(new I.$Ld),this.onExtract=this.h.event,this.c=(0,d.$sg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Xg}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,Z){const R={includeInvalid:!0,profileLocation:Z};let F=[];return U===null||U===0?F.push(...await this.n.scanAllExtensions({includeInvalid:!0},R,!1)):U===1&&F.push(...await this.n.scanUserExtensions(R)),F=U!==null?F.filter(G=>G.type===U):F,Promise.all(F.map(G=>this.F(G)))}async scanAllUserExtensions(U){const Z=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return Promise.all(Z.map(R=>this.F(R)))}async scanUserExtensionAtLocation(U){try{const Z=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(Z)return await this.F(Z)}catch(Z){this.u.error(Z)}return null}async extractUserExtension(U,Z,R,F,G){const T=U.toString(),q=l.URI.file(v.$hc(this.n.userExtensionsLocation.fsPath,`.${(0,f.$bg)()}`)),z=l.URI.file(v.$hc(this.n.userExtensionsLocation.fsPath,T));let ie=await this.m.exists(z);if(ie&&F){try{await this.y(U.id,z,"removeExisting")}catch{throw new o.$2n(y.localize(4,null,z.fsPath,U.id),o.ExtensionManagementErrorCode.Delete)}ie=!1}if(!ie)try{try{this.u.trace(`Started extracting the extension from ${Z} to ${z.fsPath}`),await(0,c.$ep)(Z,q.fsPath,{sourcePath:"extension",overwrite:!0},G),this.u.info(`Extracted extension to ${z}:`,U.id)}catch(B){let X=o.ExtensionManagementErrorCode.Extract;throw B instanceof c.$cp&&(B.type==="CorruptZip"?X=o.ExtensionManagementErrorCode.CorruptZip:B.type==="Incomplete"&&(X=o.ExtensionManagementErrorCode.IncompleteZip)),new o.$2n(B.message,X)}await this.n.updateMetadata(q,R);try{this.u.trace(`Started renaming the extension from ${q.fsPath} to ${z.fsPath}`),await this.C(q.fsPath,z.fsPath),this.u.info("Renamed to",z.fsPath)}catch(B){if(B.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,A.$8)(B)}. Deleted from extracted location`,q),B}this.h.fire(z)}catch(B){try{await this.m.del(q,{recursive:!0})}catch{}throw B}return this.D(z,1)}async scanMetadata(U,Z){return Z?(await this.w(U,Z))?.metadata:this.n.scanMetadata(U.location)}async w(U,Z){return(await this.s.scanProfileExtensions(Z)).find(F=>(0,i.$qo)(F.identifier,U.identifier))}async updateMetadata(U,Z,R){return R?await this.s.updateMetadata([[U,Z]],R):await this.n.updateMetadata(U.location,Z),this.D(U.location,U.type,R)}getUninstalledExtensions(){return this.z()}async setUninstalled(...U){const Z=U.map(R=>i.$ro.create(R));await this.z(R=>Z.forEach(F=>{R[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(U){await this.z(Z=>delete Z[U.toString()])}async removeExtension(U,Z){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,Z)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(Z=>delete Z[i.$ro.create(U).toString()])}async copyExtension(U,Z,R,F){const G=await this.w(U,Z),T=await this.w(U,R);return F={...G?.metadata,...F},T?await this.s.updateMetadata([[U,{...T.metadata,...F}]],R):await this.s.addExtensionsToProfile([[U,F]],R),this.D(U.location,U.type,R)}async copyExtensions(U,Z){const R=await this.scanExtensions(1,U),F=await Promise.all(R.filter(G=>!G.isApplicationScoped).map(async G=>[G,await this.scanMetadata(G,U)]));await this.s.addExtensionsToProfile(F,Z)}async y(U,Z,R){this.u.trace(`Deleting ${R} extension from disk`,U,Z.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(Z),`${this.t.extUri.basename(Z)}.${(0,w.$zi)((0,f.$bg)()).toString(16)}${ee}`);await this.C(Z.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${R} extension from disk`,U,Z.fsPath)}async z(U){return this.g.queue(async()=>{let Z;try{Z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,Y.$kk)(F)!==1)throw F}let R={};if(Z)try{R=JSON.parse(Z)}catch{}return U&&(U(R),Object.keys(R).length?await this.m.writeFile(this.c,O.$_d.fromString(JSON.stringify(R))):await this.m.del(this.c)),R})}async C(U,Z){try{await u.Promises.rename(U,Z,2*60*1e3)}catch(R){throw new o.$2n(R.message||y.localize(5,null,U,Z),R.code||o.ExtensionManagementErrorCode.Rename)}}async D(U,Z,R){if(R){const G=(await this.n.scanUserExtensions({profileLocation:R})).find(T=>this.t.extUri.isEqual(T.location,U));if(G)return this.F(G)}else{const F=await this.n.scanExistingExtension(U,Z,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(y.localize(6,null,U.path))}async F(U){const Z=await this.m.resolve(U.location);let R,F;return Z.children&&(R=Z.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,F=Z.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:R,changelogUrl:F,publisherDisplayName:U.metadata?.publisherDisplayName||null,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const Z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const G of Z)U[i.$ro.create(G).toString()]||R.add(G.identifier.id.toLowerCase());try{const G=(0,i.$wo)(Z,T=>T.identifier);await D.Promises.settled(G.map(async T=>{const q=T.sort((z,ie)=>g.rcompare(z.manifest.version,ie.manifest.version))[0];R.has(q.identifier.id.toLowerCase())||await this.j(await this.F(q))}))}catch(G){this.u.error(G)}const F=Z.filter(G=>G.metadata&&U[i.$ro.create(G).toString()]);await Promise.allSettled(F.map(G=>this.removeUninstalledExtension(G)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(Z){(0,Y.$kk)(Z)!==1&&this.u.error(Z);return}if(U?.children)try{await Promise.allSettled(U.children.map(async Z=>{if(!(!Z.isDirectory||!Z.name.endsWith(ee))){this.u.trace("Deleting the temporarily deleted folder",Z.resource.toString());try{await this.m.del(Z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",Z.resource.toString())}catch(R){(0,Y.$kk)(R)!==1&&this.u.error(R)}}}))}catch{}}};e.$Bp=W,e.$Bp=W=Oe([Ae(1,Y.$7j),Ae(2,a.$pp),Ae(3,n.$lp),Ae(4,_.$Dk),Ae(5,x.$6i)],W);class K extends s.$jp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,m.$Df)(this.options.operation)?this.l:this.options.operation}constructor(U,Z,R,F,G,T,q,z,ie){super(),this.identifier=U,this.source=Z,this.options=R,this.m=F,this.n=G,this.o=T,this.p=q,this.q=z,this.s=ie,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[Z,R]=await this.x(U);return this.j=Z.isBuiltin||Z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[Z,R]],this.j),Z}async u({zipPath:U,key:Z,metadata:R},F,G){let T=await this.v(Z);return T||(this.s.trace("Extracting extension...",Z.id),T=await this.m.extractUserExtension(Z,U,R,F,G),this.s.info("Extracting extension completed.",Z.id)),T}async v(U){return await this.w(U)?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(F=>i.$ro.create(F).equals(U))):void 0}async w(U){return!!(await this.m.getUninstalledExtensions())[U.toString()]}}class V extends K{constructor(U,Z,R,F,G,T,q,z,ie,B){super(Z.identifier,Z,R,G,T,q,z,ie,B),this.y=Z,this.z=F}async x(U){const R=(await this.m.scanExtensions(null,this.options.profileLocation)).find(q=>(0,i.$qo)(q.identifier,this.y.identifier));R&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||R?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0,preRelease:this.y.properties.isPreReleaseVersion||((0,m.$Cf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.y.version)return[await this.m.updateMetadata(R,F),F];const{location:G,verificationStatus:T}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=T,this.B(G.fsPath),[await this.u({zipPath:G.fsPath,key:i.$ro.create(this.y),metadata:F},!1,U),F]}catch(q){try{await this.z.delete(G)}catch(z){this.s.warn("Error while deleting the downloaded file",G.toString(),(0,A.$8)(z))}throw q}}async B(U){try{await(0,E.$wp)(U)}catch(Z){throw new o.$2n((0,s.$hp)(Z).message,o.ExtensionManagementErrorCode.Invalid)}}}e.$Cp=V;class oe extends K{constructor(U,Z,R,F,G,T,q,z,ie,B){super({id:(0,i.$vo)(U.publisher,U.name)},Z,R,G,T,q,z,ie,B),this.y=U,this.z=Z,this.A=F}async h(U){const Z=await super.h(U);return this.D(Z,U),Z}async x(U){const Z=new i.$ro(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation)).find(q=>(0,i.$qo)(this.identifier,q.identifier)),G={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:void 0};if(F)if(this.l=3,Z.equals(new i.$ro(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(y.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&g.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const q=await this.v(Z);if(q)try{await this.m.removeExtension(q,"existing")}catch{throw new Error(y.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:v.$ic(this.z.fsPath),key:Z,metadata:G},!0,U),G]}async D(U,Z){try{let[R]=await this.A.getExtensions([{id:U.identifier.id,version:U.manifest.version}],Z);if(R||([R]=await this.A.getExtensions([{id:U.identifier.id}],Z)),R){const F={id:R.identifier.uuid,publisherDisplayName:R.publisherDisplayName,publisherId:R.publisherId,isPreReleaseVersion:R.properties.isPreReleaseVersion,preRelease:R.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,F,this.options.profileLocation)}}catch{}}}class me extends s.$jp{constructor(U,Z,R){super(),this.extension=U,this.j=Z,this.k=R}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[72],we([1,0,86,77,28,284,15,11,5,2,7,3,23,43,106]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=void 0;class m{traceSocketEvent(k,L){g.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,k,L)}constructor(k,L=""){this.f=!0,this.debugLabel=L,this.socket=k,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,I.$Y)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(k){const L=j=>{this.traceSocketEvent("read",j),k(A.$_d.wrap(j))};return this.socket.on("data",L),{dispose:()=>this.socket.off("data",L)}}onClose(k){const L=j=>{k({type:0,hadError:j,error:void 0})};return this.socket.on("close",L),{dispose:()=>this.socket.off("close",L)}}onEnd(k){const L=()=>{k()};return this.socket.on("end",L),{dispose:()=>this.socket.off("end",L)}}write(k){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",k),this.socket.write(k.buffer,L=>{if(L){if(L.code==="EPIPE")return;(0,I.$Y)(L)}})}catch(L){if(L.code==="EPIPE")return;(0,I.$Y)(L)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((k,L)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),k();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),k()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Ah=m;var l;(function(E){E[E.MinHeaderByteSize=2]="MinHeaderByteSize",E[E.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(l||(l={}));var f;(function(E){E[E.PeekHeader=1]="PeekHeader",E[E.ReadHeader=2]="ReadHeader",E[E.ReadBody=3]="ReadBody",E[E.Fin=4]="Fin"})(f||(f={}));class u extends $.$Qc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(k,L){this.socket.traceSocketEvent(k,L)}constructor(k,L,j,Y){super(),this.f=this.B(new w.$Ld),this.g=this.B(new w.$Ld),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=k,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:L,inflateBytesLength:j?.byteLength||0,recordInflateBytes:Y}),this.a=this.B(new c(this,L,j,Y,this.f,(ce,x)=>this.m(ce,x))),this.B(this.a.onError(ce=>{console.error(ce),(0,I.$Y)(ce),this.g.fire({type:0,hadError:!0,error:ce})})),this.b=new g.$vh,this.B(this.socket.onData(ce=>this.n(ce))),this.B(this.socket.onClose(async ce=>{this.a.isProcessingReadQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(ce)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(k){return this.f.event(k)}onClose(k){return this.g.event(k)}onEnd(k){return this.socket.onEnd(k)}write(k){let L=0;for(;L<k.byteLength;)this.a.writeMessage(k.slice(L,Math.min(L+262144,k.byteLength))),L+=262144}m(k,L){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",k);let j=2;k.byteLength<126?j+=0:k.byteLength<2**16?j+=2:j+=8;const Y=A.$_d.alloc(j);if(L?Y.writeUInt8(194,0):Y.writeUInt8(130,0),k.byteLength<126)Y.writeUInt8(k.byteLength,1);else if(k.byteLength<2**16){Y.writeUInt8(126,1);let ce=1;Y.writeUInt8(k.byteLength>>>8&255,++ce),Y.writeUInt8(k.byteLength>>>0&255,++ce)}else{Y.writeUInt8(127,1);let ce=1;Y.writeUInt8(0,++ce),Y.writeUInt8(0,++ce),Y.writeUInt8(0,++ce),Y.writeUInt8(0,++ce),Y.writeUInt8(k.byteLength>>>24&255,++ce),Y.writeUInt8(k.byteLength>>>16&255,++ce),Y.writeUInt8(k.byteLength>>>8&255,++ce),Y.writeUInt8(k.byteLength>>>0&255,++ce)}this.socket.write(A.$_d.concat([Y,k]))}end(){this.h=!0,this.socket.end()}n(k){if(k.byteLength!==0){for(this.b.acceptChunk(k);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const L=this.b.peek(this.j.readLen),j=L.readUInt8(0),Y=(j&128)>>>7,ce=(j&64)>>>6,x=L.readUInt8(1),ne=(x&128)>>>7,ue=x&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(ue===126?2:0)+(ue===127?8:0),this.j.fin=Y,this.j.firstFrameOfMessage&&(this.j.compressed=!!ce),this.j.firstFrameOfMessage=!!Y,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const L=this.b.read(this.j.readLen),j=L.readUInt8(1),Y=(j&128)>>>7;let ce=j&127,x=1;ce===126?ce=L.readUInt8(++x)*2**8+L.readUInt8(++x):ce===127&&(ce=L.readUInt8(++x)*0+L.readUInt8(++x)*0+L.readUInt8(++x)*0+L.readUInt8(++x)*0+L.readUInt8(++x)*2**24+L.readUInt8(++x)*2**16+L.readUInt8(++x)*2**8+L.readUInt8(++x));let ne=0;Y&&(ne=L.readUInt8(++x)*2**24+L.readUInt8(++x)*2**16+L.readUInt8(++x)*2**8+L.readUInt8(++x)),this.j.state=3,this.j.readLen=ce,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const L=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",L),t(L,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",L),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(L,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await w.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Bh=u;class c extends $.$Qc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$_d.alloc(0)}constructor(k,L,j,Y,ce,x){super(),this.n=k,this.r=ce,this.s=x,this.a=this.B(new w.$Ld),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new w.$Ld),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new w.$Ld),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,L?(this.b=this.B(new y(this.n,Y,j,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(k){this.g.push(k),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const k=this.g.shift();if(this.f){const L=await this.w(this.f,k);this.s(L,!0)}else this.s(k,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(k,L){return new Promise((j,Y)=>{k.write(L),k.flush(ce=>j(ce))})}acceptFrame(k,L,j){this.h.push({data:k,isCompressed:L,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const k=this.h.shift();if(this.b&&k.isCompressed){const L=await this.C(this.b,k.data,k.isLastFrameOfMessage);this.r.fire(L)}else this.r.fire(k.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(k,L,j){return new Promise((Y,ce)=>{k.write(L),j&&k.write(A.$_d.fromByteArray([0,0,255,255])),k.flush(x=>Y(x))})}}class y extends $.$Qc{get recordedInflateBytes(){return this.j?A.$_d.concat(this.f):A.$_d.alloc(0)}constructor(k,L,j,Y){super(),this.h=k,this.j=L,this.a=this.B(new w.$Ld),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(Y),this.b.on("error",ce=>{this.h.traceSocketEvent("zlibInflateError",{message:ce?.message,code:ce?.code}),this.a.fire(ce)}),this.b.on("data",ce=>{this.h.traceSocketEvent("zlibInflateData",ce),this.g.push(A.$_d.wrap(ce))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(k){this.j&&this.f.push(k.clone()),this.h.traceSocketEvent("zlibInflateWrite",k),this.b.write(k.buffer)}flush(k){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const L=A.$_d.concat(this.g);this.g.length=0,k(L)})}}class h extends $.$Qc{constructor(k,L){super(),this.g=k,this.a=this.B(new w.$Ld),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(A.$_d.wrap(j))})}write(k){this.g.traceSocketEvent("zlibDeflateWrite",k.buffer),this.b.write(k.buffer)}flush(k){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let L=A.$_d.concat(this.f);this.f.length=0,L=L.slice(0,L.byteLength-4),k(L)})}}function t(E,k){if(k===0)return;const L=E.byteLength>>>2;for(let ue=0;ue<L;ue++){const _=E.readUInt32BE(ue*4);E.writeUInt32BE(_^k,ue*4)}const j=L*4,Y=E.byteLength-j,ce=k>>>24&255,x=k>>>16&255,ne=k>>>8&255;Y>=1&&E.writeUInt8(E.readUInt8(j)^ce,j),Y>=2&&E.writeUInt8(E.readUInt8(j+1)^x,j+1),Y>=3&&E.writeUInt8(E.readUInt8(j+2)^ne,j+2)}e.$Ch=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function o(){const E=(0,v.$bg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${E}-sock`;const k=process.platform!=="darwin"&&e.$Ch?e.$Ch:(0,r.tmpdir)(),L=(0,C.$hc)(k,`vscode-ipc-${E}.sock`);return n(L),L}e.$Dh=o;function i(E,k,L){const j=(0,D.createHash)("md5").update(E).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${j}-${L}-${k}-sock`;const Y=L.substr(0,4),ce=k.substr(0,6),x=j.substr(0,8);let ne;return process.platform!=="darwin"&&e.$Ch&&!process.env.VSCODE_PORTABLE?ne=(0,C.$hc)(e.$Ch,`vscode-${x}-${Y}-${ce}.sock`):ne=(0,C.$hc)(E,`${Y}-${ce}.sock`),n(ne),ne}e.$Eh=i;function n(E){const k=s[S.$t];typeof k=="number"&&E.length>=k&&console.warn(`WARNING: IPC handle "${E}" is longer than ${k} chars, try a shorter --user-data-dir`)}class a extends d.$ph{static b(k){const L=w.Event.fromNodeEventEmitter(k,"connection");return w.Event.map(L,j=>({protocol:new g.$wh(new m(j,"ipc-server-connection")),onDidClientDisconnect:w.Event.once(w.Event.fromNodeEventEmitter(j,"close"))}))}constructor(k){super(a.b(k)),this.d=k}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Fh=a;function b(E){return new Promise((k,L)=>{const j=(0,O.createServer)();j.on("error",L),j.listen(E,()=>{j.removeListener("error",L),k(new a(j))})})}e.$Gh=b;function p(E,k){return new Promise((L,j)=>{const Y=(0,O.createConnection)(E,()=>{Y.removeListener("error",j),L(g.$xh.fromSocket(new m(Y,`ipc-client${k}`),k))});Y.once("error",j)})}e.$Hh=p}),define(be[139],we([1,0,84,14,15,11,10,24,25,85,13,44,234,284]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Pq=void 0;let g=class extends S.$Ko{constructor(u,c,y,h){super(h),this.m=u,this.n=c,this.r=y,this.s(),this.B(u.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const u=this.m.getValue("http");this.f=u?.proxy,this.g=!!u?.proxyStrictSSL,this.h=u?.proxyAuthorization}async request(u,c){const{f:y,g:h}=this;let t;try{t=await(0,$.$Nl)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,P.$8)(i)))}const s={...process.env,...t},o=u.agent?u.agent:await(0,v.$Oq)(u.url||"",s,{proxyUrl:y,strictSSL:h});return u.agent=o,u.strictSSL=h,this.h&&(u.headers={...u.headers||{},"Proxy-Authorization":this.h}),this.c(u.isChromiumNetwork?"electron":"node",u,()=>l(u,c))}async resolveProxy(u){}};e.$Pq=g,e.$Pq=g=Oe([Ae(0,I.$fi),Ae(1,w.$Th),Ae(2,C.$6i),Ae(3,C.$7i)],g);async function m(f){return((0,D.parse)(f.url).protocol==="https:"?await new Promise((y,h)=>{le(["https"],y,h)}):await new Promise((y,h)=>{le(["http"],y,h)})).request}async function l(f,u){return O.Promises.withAsyncBody(async(c,y)=>{const h=(0,D.parse)(f.url),t=f.getRawRequest?f.getRawRequest(f):await m(f),s={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:f.type||"GET",headers:f.headers,agent:f.agent,rejectUnauthorized:(0,A.$Cf)(f.strictSSL)?f.strictSSL:!0};f.user&&f.password&&(s.auth=f.user+":"+f.password);const o=t(s,i=>{const n=(0,A.$Af)(f.followRedirects)?f.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)l({...f,url:i.headers.location,followRedirects:n-1},u).then(c,y);else{let a=i;!f.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,d.createGunzip)())),c({res:i,stream:(0,r.$oe)(a)})}});o.on("error",y),f.timeout&&o.setTimeout(f.timeout),f.isChromiumNetwork&&o.removeHeader("Content-Length"),f.data&&typeof f.data=="string"&&o.write(f.data),o.end(),u.onCancellationRequested(()=>{o.abort(),y(new P.$3)})})}e.$Qq=l}),define(be[140],we([1,0,52,77,128,12,7,15,5,72,85,13,46,3,63,127,2,274,24]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0;async function c(i={},n,a,b,p,E){const k=await(0,r.$hl)(a,b.userDataPath);let L={};if(n)try{L=await(0,C.$Nl)(E,p,b.args,process.env)}catch(ue){p.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",ue)}const Y={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(k,void 0,0),...i},ce=b.isBuilt?(0,A.$hc)(b.appRoot,"bin"):(0,A.$hc)(b.appRoot,"resources","server","bin-dev"),x=(0,A.$hc)(ce,"remote-cli");let ne=t(Y,"PATH");return ne?ne=x+A.$rc+ne:ne=x,s(Y,"PATH",ne),b.args["without-browser-env-var"]||(Y.BROWSER=(0,A.$hc)(ce,"helpers",d.$i?"browser.cmd":"browser.sh")),o(Y),Y}e.$tm=c;class y{constructor(n,a){this.socket=n,this.initialDataChunk=a}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let n,a,b;return this.socket instanceof $.$Ah?(n=!0,a=!1,b=I.$_d.alloc(0)):(n=!1,a=this.socket.permessageDeflate,b=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:n,permessageDeflate:a,inflateBytes:b.buffer.toString("base64")}}}let h=class{constructor(n,a,b,p,E,k,L,j){this.i=n,this.j=E,this.l=k,this.m=L,this.n=j,this.b=new w.$Ld,this.onClose=this.b.event,this.c=!d.$i||!this.j.args["socket-path"],this.d=!1,this.f=a,this.g=null,this.h=new y(b,p),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(n){this.l.info(`${this.o}${n}`)}q(n){this.l.error(`${this.o}${n}`)}async r(n,a){const b=new l.$Pc;b.add(a.socket),b.add((0,l.$Oc)(()=>{n.destroy()}));const p=()=>{b.dispose()};b.add(a.socket.onEnd(p)),b.add(a.socket.onClose(p)),b.add(w.Event.fromNodeEventEmitter(n,"end")(p)),b.add(w.Event.fromNodeEventEmitter(n,"close")(p)),b.add(w.Event.fromNodeEventEmitter(n,"error")(p)),b.add(a.socket.onData(E=>n.write(E.buffer))),b.add(w.Event.fromNodeEventEmitter(n,"data")(E=>{a.socket.write(I.$_d.wrap(E))})),a.initialDataChunk.byteLength>0&&n.write(a.initialDataChunk.buffer)}async s(n,a){await a.socketDrain();const b=a.toIExtHostSocketMessage();let p;a.socket instanceof $.$Ah?p=a.socket.socket:p=a.socket.socket.socket,n.send(b,p)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const n={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(n)}acceptReconnection(n,a,b){this.f=n,this.p("The client has reconnected.");const p=new y(a,b);if(!this.g){this.h=p;return}this.s(this.g,p)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(n){try{let a=process.execArgv?process.execArgv.filter(x=>!/^--inspect(-brk)?=/.test(x)):[];n.port&&!process.pkg&&(a=[`--inspect${n.break?"-brk":""}=${n.port}`]);const b=await c(n.env,!0,n.language,this.j,this.l,this.n);(0,g.$ul)(b);let p;if(this.c)(0,f.$rm)(new f.$pm,b),p=null;else{const{namedPipeServer:x,pipeName:ne}=await this.u();(0,f.$rm)(new f.$om(ne),b),p=x}const E={env:b,execArgv:a,silent:!0};E.execArgv.unshift("--dns-result-order=ipv4first");const k=["--type=extensionHost","--transformURIs"],L=this.j.args["use-host-proxy"];k.push(`--useHostProxy=${L?"true":"false"}`),this.g=D.fork(P.$_f.asFileUri("bootstrap-fork").fsPath,k,E);const j=this.g.pid;this.p(`<${j}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const Y=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),ce=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(Y(x=>this.p(`<${j}> ${x}`)),ce(x=>this.p(`<${j}><stderr> ${x}`)),this.g.on("error",x=>{this.q(`<${j}> Extension Host Process had an error`),this.l.error(x),this.t()}),this.g.on("exit",(x,ne)=>{this.m.setExitInfo(this.i,{code:x,signal:ne}),this.p(`<${j}> Extension Host Process exited with code: ${x}, signal: ${ne}.`),this.t()}),p)p.on("connection",x=>{p.close(),this.r(x,this.h)});else{const x=ne=>{ne.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",x),this.s(this.g,this.h),this.h=null)};this.g.on("message",x)}}catch(a){console.error("ExtensionHostConnection errored"),a&&console.error(a)}}u(){return new Promise((n,a)=>{const b=(0,$.$Dh)(),p=O.createServer();p.on("error",a),p.listen(b,()=>{p?.removeListener("error",a),n({pipeName:b,namedPipeServer:p})})})}};e.$um=h,e.$um=h=Oe([Ae(4,v.$em),Ae(5,S.$6i),Ae(6,m.$mm),Ae(7,u.$fi)],h);function t(i,n){const a=Object.keys(i).filter(p=>p.toLowerCase()===n.toLowerCase()),b=a.length>0?a[0]:n;return i[b]}function s(i,n,a){const b=Object.keys(i).filter(E=>E.toLowerCase()===n.toLowerCase()),p=b.length>0?b[0]:n;i[p]=a}function o(i){for(const n of Object.keys(i))i[n]===null&&delete i[n]}}),define(be[285],we([1,0,82,13,65,116,24,44,139,36,32,30,125,138,81,110,54,2,111,68,12,16,31,46,119,83,120,11,4,7,29,232,80,34,123,64,3,57,129,33,45,69,126,124,113,114,199,286]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t,s,o,i,n,a,b,p,E,k,L,j,Y,ce,x,ne,ue,_,he,ee,te,W,K,V,oe,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class se extends f.$Qc{constructor(F,G){super(),this.a=F,this.b=G,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const F=await this.f();await F.invokeFunction(async G=>{const T=G.get(A.$fi),q=G.get(O.$6i);x.$i&&(T.getValue("security.restrictUNCAccess")===!1?(0,me.disableUNCAccessRestrictions)():(0,me.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")));try{await this.g(F.createInstance(o.$0o,new O.$bj(q.getLevel(),!1)))}catch(z){throw q.error(z),console.error((0,a.$8)(z)),z}})}async f(){const F=new D.$Jh,G={_serviceBrand:void 0,...l.default};F.set(t.$lj,G);const T=new s.$fm(this.a,G);F.set(s.$em,T);const q=new V.$jN((0,O.$hj)(T),T.logsHome);F.set(O.$7i,q);const z=new K.$tN(this.B(q.createLogger("remoteCLI",{name:(0,oe.localize)(0,null)})));F.set(O.$6i,z),z.trace(`Remote configuration data at ${this.b}`),z.trace("process arguments:",this.a);const ie=this.B(new u.$Ep(z));F.set(h.$7j,ie),ie.registerProvider(y.Schemas.file,this.B(new c.$4p(z)));const B=new Y.$qr(ie);F.set(j.$Dk,B);const X=this.B(new te.$rN(B,T,ie,z));F.set(_.$Fk,X);const H=this.B(new P.$An(X.defaultProfile.settingsResource,ie,new ee.$an,z));return F.set(A.$fi,H),await Promise.all([H.initialize(),X.init()]),F.set(I.$Jo,new r.$Ih(w.$Pq)),F.set(L.$En,new r.$Ih(k.$IN)),F.set(C.$0k,$.$co),F.set(S.$1n,new r.$Ih(v.$7o)),F.set(he.$lp,new r.$Ih(W.$sN)),F.set(ne.$pp,new r.$Ih(ue.$fN)),F.set(g.$8o,new r.$Ih(g.$9o)),F.set(d.$zp,new r.$Ih(d.$Ap)),F.set(i.$Jq,new r.$Ih(n.$Lq)),new m.$7p(F)}async g(F){if(this.a["list-extensions"])return F.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const G={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return F.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),G,!!this.a.force)}else{if(this.a["uninstall-extension"])return F.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return F.locateExtension(this.a["locate-extension"])}}h(F){return F.map(G=>/\.vsix$/i.test(G)?b.URI.file((0,p.$gc)(G)?G:(0,p.$hc)((0,E.cwd)(),G)):G)}}function U(R){setTimeout(()=>process.exit(R),0)}async function Z(R,F,G){if(R.help){const q=l.default.serverApplicationName+(x.$i?".cmd":"");console.log((0,ce.$Cl)(l.default.nameLong,q,l.default.version,G,{noInputFiles:!0,noPipe:!0}));return}if(R.version){console.log((0,ce.$Dl)(l.default.version,l.default.commit));return}const T=new se(R,F);try{await T.run(),U(0)}catch{U(1)}finally{T.dispose()}}e.run=Z}),define(be[287],we([1,0,72,301,27,280,4,13,89]),function(le,e,D,O,r,P,A,I,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yM=e.$xM=void 0;class ${constructor(v,d,g){this.b=v,this.c=d,this.f=g,this.a=O.createServer((m,l)=>this.h(m,l)),this.g().catch(m=>(d.error(m),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,d){const g=(l,f)=>{d.writeHead(l,{"content-type":"application/json"}),d.end(JSON.stringify(f||null),u=>u&&this.c.error(u))},m=[];v.setEncoding("utf8"),v.on("data",l=>m.push(l)),v.on("end",async()=>{try{const l=JSON.parse(m.join(""));let f;switch(l.type){case"open":f=await this.i(l);break;case"openExternal":f=await this.j(l);break;case"status":f=await this.l(l);break;case"extensionManagement":f=await this.k(l);break;default:g(404,`Unknown message type: ${l.type}`);break}g(200,f)}catch(l){const f=l instanceof Error?l.message:JSON.stringify(l);g(500,f),this.c.error("Error while processing pipe request",l)}})}async i(v){const{fileURIs:d,folderURIs:g,forceNewWindow:m,diffMode:l,mergeMode:f,addMode:u,forceReuseWindow:c,gotoLineMode:y,waitMarkerFilePath:h,remoteAuthority:t}=v,s=[];if(Array.isArray(g))for(const a of g)try{s.push({folderUri:A.URI.parse(a)})}catch{}if(Array.isArray(d))for(const a of d)try{(0,w.$ei)(a)?s.push({workspaceUri:A.URI.parse(a)}):s.push({fileUri:A.URI.parse(a)})}catch{}const o=h?A.URI.file(h):void 0,n={forceNewWindow:m,diffMode:l,mergeMode:f,addMode:u,gotoLineMode:y,forceReuseWindow:c,preferNewWindow:!c&&!o&&!u,waitMarkerFileURI:o,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,n)}async j(v){for(const d of v.uris){const g=A.URI.parse(d),m=g.scheme==="file"?g:d;await this.b.executeCommand("_remoteCLI.openExternal",m)}}async k(v){const d=m=>m?.map(l=>/\.vsix$/i.test(l)?A.URI.parse(l):l),g={list:v.list,install:d(v.install),uninstall:d(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",g)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&r.existsSync(this.f)&&r.unlinkSync(this.f)}}e.$xM=$;let C=class extends ${constructor(v,d){super(v,d,(0,D.$Dh)())}};e.$yM=C,e.$yM=C=Oe([Ae(0,P.$sM),Ae(1,I.$6i)],C)}),define(be[288],we([1,0,28,5,22,2,7,3,4,72,70,287,122,87,268,270,140]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$M=void 0;class f extends m.$0M{constructor(y,h,t,s,o){super({getFolderUri:i=>{const n=h.filter(a=>a.name===i);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(i,n)=>s[`config:${n}`],getExecPath:()=>y.VSCODE_EXEC_PATH,getAppRoot:()=>y.VSCODE_CWD,getFilePath:()=>{if(t)return A.$fc(t.fsPath)},getSelectedText:()=>s.selectedText,getLineNumber:()=>s.lineNumber,getExtension:async i=>{const a=(await o.getInstalled()).find(b=>b.identifier.id===i);return a&&{extensionLocation:a.location}}},void 0,Promise.resolve(D.homedir()),Promise.resolve(y))}}class u extends P.$Qc{constructor(y,h,t,s,o,i){super(),this.g=y,this.h=h,this.j=t,this.m=s,this.n=o,this.r=i,this.a=0,this.b=new Map,this.c=this.B(new O.$Ld),this.onExecuteCommand=this.c.event}async call(y,h,t){switch(h){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,t);case"$createProcess":{const s=(0,C.$rr)(y.remoteAuthority);return this.s(s,t)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,t);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,t);case"$listProcesses":return this.j.listProcesses.apply(this.j,t);case"$getLatency":return this.j.getLatency.apply(this.j,t);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,t);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,t);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,t);case"$start":return this.j.start.apply(this.j,t);case"$input":return this.j.input.apply(this.j,t);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,t);case"$shutdown":return this.j.shutdown.apply(this.j,t);case"$resize":return this.j.resize.apply(this.j,t);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,t);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,t);case"$getCwd":return this.j.getCwd.apply(this.j,t);case"$processBinary":return this.j.processBinary.apply(this.j,t);case"$sendCommandResult":return this.u(t[0],t[1],t[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,t);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,t);case"$getDefaultSystemShell":return this.w.apply(this,t);case"$getProfiles":return this.y.apply(this,t);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(t[0],t[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,t);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,t);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,t);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,t);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,t);case"$updateTitle":return this.j.updateTitle.apply(this.j,t);case"$updateProperty":return this.j.updateProperty.apply(this.j,t);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,t);case"$requestDetachInstance":return this.j.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,t);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,t)}throw new Error(`IPC Command ${h} not found`)}listen(y,h,t){switch(h){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||O.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||O.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||O.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||O.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||O.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||O.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${h} not found`)}async s(y,h){const t={name:h.shellLaunchConfig.name,executable:h.shellLaunchConfig.executable,args:h.shellLaunchConfig.args,cwd:typeof h.shellLaunchConfig.cwd=="string"||typeof h.shellLaunchConfig.cwd>"u"?h.shellLaunchConfig.cwd:w.URI.revive(y.transformIncoming(h.shellLaunchConfig.cwd)),env:h.shellLaunchConfig.env,useShellEnvironment:h.shellLaunchConfig.useShellEnvironment,reconnectionProperties:h.shellLaunchConfig.reconnectionProperties,type:h.shellLaunchConfig.type,isFeatureTerminal:h.shellLaunchConfig.isFeatureTerminal},s=await(0,l.$tm)(h.resolverEnv,!!h.shellLaunchConfig.useShellEnvironment,I.$v,this.g,this.h,this.r);this.h.trace("baseEnv",s);const o=ue=>({uri:w.URI.revive(y.transformIncoming(ue.uri)),name:ue.name,index:ue.index,toResource:()=>{throw new Error("Not implemented")}}),i=h.workspaceFolders.map(o),n=h.activeWorkspaceFolder?o(h.activeWorkspaceFolder):void 0,a=h.activeFileResource?w.URI.revive(y.transformIncoming(h.activeFileResource)):void 0,b=new f(s,i,a,h.resolvedVariables,this.n),p=g.$6M(n,process.env,b),E=await g.$5M(t,D.homedir(),p,n?.uri,h.configuration["terminal.integrated.cwd"],this.h);t.cwd=E;const k=I.$i?"terminal.integrated.env.windows":I.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",L=h.configuration[k],j=await g.$7M(t,L,p,this.m.version,h.configuration["terminal.integrated.detectLocale"],s);if(!t.strictEnv){const ue=[];for(const[te,W,K]of h.envVariableCollections)ue.push([te,{map:(0,d.$dr)(W),descriptionMap:(0,d.$er)(K)}]);const _=new Map(ue),he=new v.$hr(_),ee=n?n??void 0:void 0;await he.applyToProcessEnvironment(j,{workspaceFolder:ee},p)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:E,cols:h.cols,rows:h.rows,env:j});const Y=(0,$.$Dh)();j.VSCODE_IPC_HOOK_CLI=Y;const ce=await this.j.createProcess(t,E,h.cols,h.rows,h.unicodeVersion,j,s,h.options,h.shouldPersistTerminal,h.workspaceId,h.workspaceName),x={executeCommand:(ue,..._)=>this.t(ce,ue,_,y)},ne=new S.$xM(x,this.h,Y);return this.j.onProcessExit(ue=>ue.id===ce&&ne.dispose()),{persistentTerminalId:ce,resolvedShellLaunchConfig:t}}t(y,h,t,s){let o,i;const n=new Promise((p,E)=>{o=p,i=E}),a=++this.a;this.b.set(a,{resolve:o,reject:i,uriTransformer:s});const b=(0,r.$Ym)(t,p=>{if(p&&p.$mid===1)return s.transformOutgoing(p);if(p&&p instanceof w.URI)return s.transformOutgoingURI(p)});return this.c.fire({reqId:a,persistentProcessId:y,commandId:h,commandArgs:b}),n}u(y,h,t){const s=this.b.get(y);if(!s)return;this.b.delete(y);const o=(0,r.$Ym)(t,i=>{if(i&&i.$mid===1)return s.uriTransformer.transformIncoming(i)});h?s.reject(o):s.resolve(o)}w(y){return this.j.getDefaultSystemShell(y)}async y(y,h,t,s){return this.j.getProfiles(y,h,t,s)||[]}z(){return{...process.env}}C(y,h){return this.j.getWslPath(y,h)}D(){return this.j.reduceConnectionGraceTime()}}e.$$M=u}),define(be[289],we([1,0,28,5,2,12,7,99,21,43,24,116,207,80,208,25,125,30,81,119,217,138,16,111,68,65,110,82,83,120,13,54,31,44,233,139,118,32,36,246,88,254,34,123,265,266,238,244,288,70,46,273,281,127,57,129,45,33,69,245,114,126,124,113,112,201,278,230,258,251]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t,s,o,i,n,a,b,p,E,k,L,j,Y,ce,x,ne,ue,_,he,ee,te,W,K,V,oe,me,se,U,Z,R,F,G,T,q,z,ie,B,X,H,Q,re,de,Ee,Ce,Le,Ne,$e,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DN=e.$CN=void 0;const ye="monacoworkbench";async function Te(Ie,Fe,je,Ke){const Be=new a.$Jh,qe=new He,Qe={_serviceBrand:void 0,...k.default};Be.set(L.$lj,Qe);const We=new Z.$fm(Fe,Qe);Be.set(m.$Sh,We),Be.set(m.$Th,We);const Ye=new H.$jN((0,E.$hj)(We),We.logsHome);Be.set(E.$7i,Ye),qe.registerChannel("logger",new Ee.$3q(Ye,nt=>Xe(nt.remoteAuthority)));const it=Ye.createLogger("remoteagent",{name:(0,Ce.localize)(0,null)}),_e=new de.$tN(it,[new Ze((0,E.$hj)(We))]);Be.set(E.$6i,_e),setTimeout(()=>Se(We.logsHome.with({scheme:P.Schemas.file}).fsPath).then(null,nt=>_e.error(nt)),1e4),_e.onDidChangeLogLevel(nt=>(0,E.log)(_e,nt,`Log level changed to ${(0,E.$ij)(_e.getLevel())}`)),_e.trace(`Remote configuration data at ${je}`),_e.trace("process arguments:",We.args),Array.isArray(Qe.serverGreeting)&&_e.info(`

${Qe.serverGreeting.join(`
`)}

`),qe.registerChannel(v.$Cn.ChannelName,new v.$Cn);const st=new $.$th(nt=>nt.clientId==="renderer"),ot=Ke.add(new s.$Ep(_e));Be.set(t.$7j,ot),ot.registerProvider(P.Schemas.file,Ke.add(new o.$4p(_e)));const At=new W.$qr(ot);Be.set(te.$Dk,At);const mt=new S.$An(We.machineSettingsResource,ot,new B.$an,_e);Be.set(C.$fi,mt);const ht=new Q.$rN(At,We,ot,_e);Be.set(ie.$Fk,ht),qe.registerChannel("userDataProfiles",new $e.$zN(ht,nt=>Xe(nt.remoteAuthority)));const[,,jt]=await Promise.all([mt.initialize(),ht.init(),(0,I.$Jm)(_e.error.bind(_e))]),Lt=new G.$nm;Be.set(G.$mm,Lt);const wt=new ce.$Pq(mt,We,_e,Ye);Be.set(j.$Jo,wt);let ct=ue.$go;const vt=(0,ue.$no)(Qe,mt);if((0,ue.$io)(Qe,We)){!(0,ue.$jo)(Qe,We)&&Qe.aiConfig?.ariaKey&&(ct=new X.$hN(wt,vt,ye,null,Qe.aiConfig.ariaKey),Ke.add((0,r.$Oc)(()=>ct?.flush())));const nt={appenders:[ct],commonProperties:(0,x.$$n)((0,D.release)(),(0,D.hostname)(),process.arch,Qe.commit,Qe.version+"-remote",jt,vt,"remoteAgent"),piiPaths:(0,ue.$oo)(We)},lt=We.args["telemetry-level"];let gt=3;lt==="all"?gt=3:lt==="error"?gt=2:lt==="crash"?gt=1:lt!==void 0&&(gt=0),Be.set(me.$Er,new i.$Ih(me.$Cr,[nt,gt]))}else Be.set(me.$Er,me.$Dr);Be.set(f.$1n,new i.$Ih(l.$7o));const Rt=qe.getChannel("download",st);Be.set(d.$En,new g.$Gn(Rt,()=>Xe("renderer"))),Be.set(z.$lp,new i.$Ih(re.$sN)),Be.set(T.$pp,new i.$Ih(q.$fN)),Be.set(u.$8o,new i.$Ih(u.$9o)),Be.set(h.$zp,new i.$Ih(h.$Ap));const ft=new n.$7p(Be);Be.set(b.$Jq,ft.createInstance(p.$Lq));const Mt=ft.createInstance(ke.$BN,{graceTime:108e5,shortGraceTime:3e5,scrollback:mt.getValue("terminal.integrated.persistentSessionScrollback")??100}),Ot=ft.createInstance(ee.$mr,Mt);return Be.set(he.$Xq,Ot),ft.invokeFunction(nt=>{const lt=nt.get(h.$zp),gt=nt.get(T.$pp),Tt=nt.get(f.$1n),Ut=nt.get(b.$Jq),Bt=new K.$yr(Ie,We,ht,Lt);qe.registerChannel("remoteextensionsenvironment",Bt);const Pt=new oe.$Fr(nt.get(me.$Er),ct);qe.registerChannel("telemetry",Pt),qe.registerChannel(R.$_M,new se.$$M(We,_e,Ot,Qe,lt,mt));const Ft=new Le.$xN(ft.createInstance(c.$0o,_e),We,ht,gt,_e,Tt,Ut);qe.registerChannel(Ne.$wN,new Le.$yN(Ft,yt=>Xe(yt.remoteAuthority)));const kt=new V.$Br(_e,We);qe.registerChannel(F.$dN,kt),qe.registerChannel("request",new Y.$Mq(nt.get(j.$Jo)));const zt=new y.$$o(lt,yt=>Xe(yt.remoteAuthority));return qe.registerChannel("extensions",zt),Ft.whenExtensionsReady().then(()=>lt.cleanUp()),Ke.add(new _.default(nt.get(ne.$0k))),{telemetryService:nt.get(ne.$0k)}}),{socketServer:qe,instantiationService:ft}}e.$CN=Te;const Ue=Object.create(null);function Xe(Ie){return Ue[Ie]||(Ue[Ie]=(0,U.$rr)(Ie)),Ue[Ie]}class He extends $.$ph{constructor(){const Fe=new O.$Ld;super(Fe.event),this.b=Fe}acceptConnection(Fe,je){this.b.fire({protocol:Fe,onDidClientDisconnect:je})}}e.$DN=He;class Ze extends E.$$i{constructor(Fe=E.$9i){super(),this.setLevel(Fe),this.g=!!process.stdout.isTTY}trace(Fe,...je){this.f(E.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Je()}]\x1B[0m`,Fe,...je):console.log(`[${Je()}]`,Fe,...je))}debug(Fe,...je){this.f(E.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Je()}]\x1B[0m`,Fe,...je):console.log(`[${Je()}]`,Fe,...je))}info(Fe,...je){this.f(E.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Je()}]\x1B[0m`,Fe,...je):console.log(`[${Je()}]`,Fe,...je))}warn(Fe,...je){this.f(E.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Je()}]\x1B[0m`,Fe,...je):console.warn(`[${Je()}]`,Fe,...je))}error(Fe,...je){this.f(E.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Je()}]\x1B[0m`,Fe,...je):console.error(`[${Je()}]`,Fe,...je))}dispose(){}flush(){}}function Je(){const Ie=new Date;return`${ge(Ie.getHours())}:${ge(Ie.getMinutes())}:${ge(Ie.getSeconds())}`}function ge(Ie){return Ie<10?`0${Ie}`:String(Ie)}async function Se(Ie){const Fe=A.$lc(Ie),je=A.$kc(Ie),qe=(await w.Promises.readdir(je)).filter(We=>/^\d{8}T\d{6}$/.test(We)).sort().filter(We=>We!==Fe),Qe=qe.slice(0,Math.max(0,qe.length-9));await Promise.all(Qe.map(We=>w.Promises.rm(A.$hc(je,We))))}}),define(be[290],we([1,0,86,27,77,291,84,93,15,11,39,2,12,7,41,3,17,4,23,167,153,286,106,72,24,6,13,31,56,32,140,259,260,46,289,262]),function(le,e,D,O,r,P,A,I,w,$,C,S,v,d,g,m,l,f,u,c,y,h,t,s,o,i,n,a,b,p,E,k,L,j,Y,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=void 0;const x=5*60*1e3;let ne=class extends S.$Qc{constructor(ee,te,W,K,V,oe,me,se){super(),this.n=ee,this.r=te,this.s=W,this.t=V,this.u=oe,this.w=me,this.y=se,this.h=_.create(this.u),this.j=(0,b.$Rk)(oe),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=K?this.y.createInstance(ce.$GN,this.r):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(ee,te){if(ee.method!=="GET")return(0,ce.$EN)(ee,te,405,`Unsupported method ${ee.method}`);if(!ee.url)return(0,ce.$EN)(ee,te,400,"Bad request.");const W=A.parse(ee.url,!0);let K=W.pathname;if(!K)return(0,ce.$EN)(ee,te,400,"Bad request.");if(K.startsWith(this.j)&&K.charCodeAt(this.j.length)===47&&(K=K.substring(this.j.length)),K==="/version")return te.writeHead(200,{"Content-Type":"text/plain"}),void te.end(this.u.commit||"");if(K==="/delay-shutdown")return this.N(),te.writeHead(200),void te.end("OK");if(!(0,L.$Bm)(this.r,ee,W))return(0,ce.$EN)(ee,te,403,"Forbidden.");if(K==="/vscode-remote-resource"){const V=W.query.path;if(typeof V!="string")return(0,ce.$EN)(ee,te,400,"Bad request.");let oe;try{oe=f.URI.from({scheme:v.Schemas.file,path:V}).fsPath}catch{return(0,ce.$EN)(ee,te,400,"Bad request.")}const me=Object.create(null);this.t.isBuilt&&((0,C.$Vf)(oe,this.t.builtinExtensionsPath,!m.$k)||(0,C.$Vf)(oe,this.t.extensionsPath,!m.$k))&&(me["Cache-Control"]="public, max-age=31536000"),me.Vary="Origin";const se=ee.headers.origin;return se&&this.h.matches(se)&&(me["Access-Control-Allow-Origin"]=se),(0,ce.$FN)(oe,1,this.w,ee,te,me)}if(this.g){this.g.handle(ee,te,W);return}return te.writeHead(404,{"Content-Type":"text/plain"}),void te.end("Not found")}handleUpgrade(ee,te){let W=(0,u.$bg)(),K=!1,V=!1;if(ee.url){const R=A.parse(ee.url,!0).query;typeof R.reconnectionToken=="string"&&(W=R.reconnectionToken),R.reconnection==="true"&&(K=!0),R.skipWebSocketFrames==="true"&&(V=!0)}if(ee.headers.upgrade===void 0||ee.headers.upgrade.toLowerCase()!=="websocket"){te.end("HTTP/1.1 400 Bad Request");return}const oe=ee.headers["sec-websocket-key"],me=D.createHash("sha1");me.update(oe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const U=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${me.digest("base64")}`];let Z=!1;if(!V&&!this.t.args["disable-websocket-compression"]&&ee.headers["sec-websocket-extensions"]){const R=Array.isArray(ee.headers["sec-websocket-extensions"])?ee.headers["sec-websocket-extensions"]:[ee.headers["sec-websocket-extensions"]];for(const F of R)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(F)){if(/\b(permessage-deflate)\b/.test(F)){Z=!0,U.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(F)){Z=!0,U.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}te.write(U.join(`\r
`)+`\r
\r
`),te.setTimeout(0),te.setNoDelay(!0),V?this.D(new s.$Ah(te,`server-connection-${W}`),K,W):this.D(new s.$Bh(new s.$Ah(te,`server-connection-${W}`),Z,null,!0),K,W)}handleServerError(ee){this.w.error("Error occurred in server"),this.w.error(ee)}z(ee){let te;return ee instanceof s.$Ah?te=ee.socket:te=ee.socket.socket,te.remoteAddress||"<unknown>"}async C(ee,te,W){const K=te.getSocket();this.w.error(`${ee} ${W}.`);const V={type:"error",reason:W};te.sendControl(w.$_d.fromString(JSON.stringify(V))),te.dispose(),await K.drain(),K.dispose()}D(ee,te,W){const K=this.z(ee),V=`[${K}][${W.substr(0,8)}]`,oe=new t.$zh({socket:ee}),me=this.s?new this.s.validator:null,se=this.s?new this.s.signer:null;let U;(function(G){G[G.WaitingForAuth=0]="WaitingForAuth",G[G.WaitingForConnectionType=1]="WaitingForConnectionType",G[G.Done=2]="Done",G[G.Error=3]="Error"})(U||(U={}));let Z=0;const R=G=>{Z=3,F.dispose(),this.C(V,oe,G)},F=oe.onControlMessage(G=>{if(Z===0){let T;try{T=JSON.parse(G.toString())}catch{return R("Malformed first message")}if(T.type!=="auth")return R("Invalid first message");if(this.r.type===2&&!this.r.validate(T.auth))return R("Unauthorized client refused: auth mismatch");let q=(0,u.$bg)();if(se)try{q=se.sign(T.data)}catch{}let z=(0,u.$bg)();if(me)try{z=me.createNewMessage(z)}catch{}const ie={type:"sign",data:z,signedData:q};oe.sendControl(w.$_d.fromString(JSON.stringify(ie))),Z=1}else if(Z===1){let T;try{T=JSON.parse(G.toString())}catch{return R("Malformed second message")}if(T.type!=="connectionType")return R("Invalid second message");if(typeof T.signedData!="string")return R("Invalid second message field type");const q=T.commit,z=this.u.commit;if(q&&z&&q!==z)return R("Client refused: version mismatch");let ie=!1;if(!me)ie=!0;else if(this.r.validate(T.signedData))ie=!0;else try{ie=me.validate(T.signedData)==="ok"}catch{}if(!ie){if(this.t.isBuilt)return R("Unauthorized client refused");this.w.error(`${V} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const B in this.b)this.b[B].shortenReconnectionGraceTimeIfNecessary();for(const B in this.a)this.a[B].shortenReconnectionGraceTimeIfNecessary();Z=2,F.dispose(),this.F(K,V,oe,ee,te,W,T)}})}async F(ee,te,W,K,V,oe,me){const se=me.desiredConnectionType===1?`${te}[ManagementConnection]`:me.desiredConnectionType===2?`${te}[ExtensionHostConnection]`:te;if(me.desiredConnectionType===1)if(V){if(!this.b[oe])return this.f.has(oe)?this.C(se,W,"Unknown reconnection token (seen before)"):this.C(se,W,"Unknown reconnection token (never seen)");W.sendControl(w.$_d.fromString(JSON.stringify({type:"ok"})));const U=W.readEntireBuffer();W.dispose(),this.b[oe].acceptReconnection(ee,K,U)}else{if(this.b[oe])return this.C(se,W,"Duplicate reconnection token");W.sendControl(w.$_d.fromString(JSON.stringify({type:"ok"})));const U=new k.$vm(this.w,oe,ee,W);this.n.acceptConnection(U.protocol,U.onClose),this.b[oe]=U,this.f.add(oe),U.onClose(()=>{delete this.b[oe]})}else if(me.desiredConnectionType===2){const U=me.args||{language:"en"},Z=await this.I(U);if(Z.port&&this.w.trace(`${se} - startParams debug port ${Z.port}`),this.w.trace(`${se} - startParams language: ${Z.language}`),this.w.trace(`${se} - startParams env: ${JSON.stringify(Z.env)}`),V){if(!this.a[oe])return this.f.has(oe)?this.C(se,W,"Unknown reconnection token (seen before)"):this.C(se,W,"Unknown reconnection token (never seen)");W.sendPause(),W.sendControl(w.$_d.fromString(JSON.stringify(Z.port?{debugPort:Z.port}:{})));const R=W.readEntireBuffer();W.dispose(),this.a[oe].acceptReconnection(ee,K,R)}else{if(this.a[oe])return this.C(se,W,"Duplicate reconnection token");W.sendPause(),W.sendControl(w.$_d.fromString(JSON.stringify(Z.port?{debugPort:Z.port}:{})));const R=W.readEntireBuffer();W.dispose();const F=this.y.createInstance(E.$um,oe,ee,K,R);this.a[oe]=F,this.f.add(oe),F.onClose(()=>{delete this.a[oe],this.J()}),F.start(Z)}}else if(me.desiredConnectionType===3){const U=me.args;this.G(W,U)}else return this.C(se,W,"Unknown initial data received")}async G(ee,te){const W=ee.getSocket().socket,K=ee.readEntireBuffer();ee.dispose(),W.pause();const V=await this.H(te.host,te.port);K.byteLength>0&&V.write(K.buffer),V.on("end",()=>W.end()),V.on("close",()=>W.end()),V.on("error",()=>W.destroy()),W.on("end",()=>V.end()),W.on("close",()=>V.end()),W.on("error",()=>V.destroy()),V.pipe(W),W.pipe(V)}H(ee,te){return new Promise((W,K)=>{const V=r.createConnection({host:ee,port:te,autoSelectFamily:!0},()=>{V.removeListener("error",K),V.pause(),W(V)});V.once("error",K)})}I(ee){return typeof ee.port=="number"?(0,y.$dg)(ee.port,10,5e3).then(te=>(ee.port=te,ee)):(ee.debugId=void 0,ee.port=void 0,ee.break=void 0,Promise.resolve(ee))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(ee=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!ee?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},x))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};ne=Oe([Ae(4,j.$em),Ae(5,a.$lj),Ae(6,n.$6i),Ae(7,i.$Kh)],ne);async function ue(he,ee,te){const W=await(0,L.$Am)(ee);W instanceof L.$ym&&(console.warn(W.message),process.exit(1));function K(ie){(0,$.setUnexpectedErrorHandler)(B=>{(0,$.$X)(B)&&B.stack&&/unexpectedErrorHandler/.test(B.stack)||ie(B)})}const V=[];K(ie=>{V.push(ie),console.error(ie)});let oe=!1;process.on("SIGPIPE",()=>{oe||(oe=!0,(0,$.$Y)(new Error("Unexpected SIGPIPE")))});const me=new S.$Pc,{socketServer:se,instantiationService:U}=await(0,Y.$CN)(W,ee,te,me);U.invokeFunction(ie=>{const B=ie.get(n.$6i);V.forEach(X=>B.error(X)),V.length=0,K(X=>B.error(X))}),U.invokeFunction(ie=>{const B=ie.get(o.$fi);m.$i&&(B.getValue("security.restrictUNCAccess")===!1?(0,h.disableUNCAccessRestrictions)():(0,h.addUNCHostToAllowlist)(B.getValue("security.allowedUNCHosts")))}),U.invokeFunction(ie=>{const B=ie.get(n.$6i);if(m.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const X=(0,d.$hc)(process.env.HOMEDRIVE,"node_modules"),H=(0,d.$kc)((0,d.$hc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Q=(0,d.$hc)(H,"node_modules");if(O.existsSync(X)||O.existsSync(Q)){const re=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${X}
* ${Q}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;B.warn(re),console.warn(re),process.exit(0)}}});const Z=U.invokeFunction(ie=>{const B=ie.get(n.$6i);if(O.existsSync((0,d.$hc)(v.$_f.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(H){B.error(H)}return null}),R=O.existsSync(v.$_f.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(R&&he&&typeof he!="string"){const ie=W.type!==0?`?${v.$6f}=${W.value}`:"";console.log(`Web UI available at http://localhost${he.port===80?"":`:${he.port}`}/${ie}`)}const F=U.createInstance(ne,se,W,Z,R);g.mark("code/server/ready");const G=P.performance.now(),T=global.vscodeServerStartTime,q=global.vscodeServerListenTime,z=global.vscodeServerCodeLoadedTime;if(U.invokeFunction(async ie=>{const B=ie.get(p.$0k);if(B.publicLog2("serverStart",{startTime:T,startedTime:q,codeLoadedTime:z,readyTime:G}),m.$k){const X=ie.get(n.$6i),H=await(0,c.$cg)(X.error.bind(X));H&&B.publicLog2("serverPlatformInfo",{platformId:H.id,platformVersionId:H.version_id,platformIdLike:H.id_like})}}),ee["print-startup-performance"]){const ie=I.$S.get();let B="";B+=`

### Load AMD-module
`,B+=I.$S.toMarkdownTable(["Module","Duration"],ie.amdLoad),B+=`

### Load commonjs-module
`,B+=I.$S.toMarkdownTable(["Module","Duration"],ie.nodeRequire),B+=`

### Invoke AMD-module factory
`,B+=I.$S.toMarkdownTable(["Module","Duration"],ie.amdInvoke),B+=`

### Invoke commonjs-module
`,B+=I.$S.toMarkdownTable(["Module","Duration"],ie.nodeEval),B+=`Start-up time: ${q-T}
`,B+=`Code loading time: ${z-T}
`,B+=`Initialized time: ${G-T}
`,B+=`
`,console.log(B)}return F}e.$HN=ue;class _{static create(ee){const te=ee.webEndpointUrlTemplate,W=ee.commit,K=ee.quality;if(!te||!W||!K)return new _(null);const V=(0,u.$bg)(),me=new URL(te.replace("{{uuid}}",V).replace("{{commit}}",W).replace("{{quality}}",K)).origin,se=(0,l.$De)(me).replace(V,"[a-zA-Z0-9\\-]+");try{const U=(0,l.$Le)(`^${se}$`,!0,{matchCase:!1});return new _(U)}catch{return new _(null)}}constructor(ee){this.a=ee}matches(ee){return this.a?this.a.test(ee):!1}}}),define(be[302],we([1,0,28,27,12,285,290,64,7,291,46,54,41]),function(le,e,D,O,r,P,A,I,w,$,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=$.performance.now();const d={onMultipleValues:(i,n)=>{console.error(`Option '${i}' can only be defined once. Using value ${n}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,n)=>{console.warn(`Option '${i}' is deprecated: ${n}`)}},g=(0,I.$Al)(process.argv.slice(2),C.$dm,d),m=g["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.$hc)(D.homedir(),S.default.serverDataFolderName||".vscode-remote"),l=(0,w.$hc)(m,"data"),f=(0,w.$hc)(l,"User"),u=(0,w.$hc)(f,"globalStorage"),c=(0,w.$hc)(f,"History"),y=(0,w.$hc)(l,"Machine");g["user-data-dir"]=l;const h=(0,w.$kc)(r.$_f.asFileUri("").fsPath),t=(0,w.$hc)(h,"extensions");g["builtin-extensions-dir"]=t,g["extensions-dir"]=g["extensions-dir"]||(0,w.$hc)(m,"extensions"),[m,g["extensions-dir"],l,f,y,u,c].forEach(i=>{try{O.existsSync(i)||O.mkdirSync(i,{mode:448})}catch(n){console.error(n)}});function s(){(0,P.run)(g,m,C.$dm)}e.spawnCli=s;function o(i){return(0,A.$HN)(i,g,m)}e.createServer=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/f1b07bd25dfad64b0167beb15359ae573aecd2cc/core/vs/server/node/server.main.js.map
